#include "controller.h"
# 23 "/h/27/yijun/software/vim62/src/proto/eval.pro"
void del_menutrans_vars (void);
# 6 "/h/27/yijun/software/vim62/src/proto/menu.pro"
char_u *menu_name_skip (char_u *name);
# 3 "/h/27/yijun/software/vim62/src/proto/gui_gtk.pro"
void gui_mch_add_menu (vimmenu_T *menu, int idx);
# 4 "/h/27/yijun/software/vim62/src/proto/gui_gtk.pro"
void gui_mch_add_menu_item (vimmenu_T *menu, int idx);
# 8 "/h/27/yijun/software/vim62/src/proto/gui_gtk.pro"
void gui_mch_menu_set_tip (vimmenu_T *menu);
# 9 "/h/27/yijun/software/vim62/src/proto/gui_gtk.pro"
void gui_mch_destroy_menu (vimmenu_T *menu);
# 16 "/h/27/yijun/software/vim62/src/proto/gui_gtk.pro"
void gui_mch_show_popupmenu (vimmenu_T *menu);
# 54 "/h/27/yijun/software/vim62/src/proto/gui_gtk_x11.pro"
void gui_mch_menu_grey (vimmenu_T *menu, int grey);
# 56 "/h/27/yijun/software/vim62/src/proto/gui_gtk_x11.pro"
void gui_mch_draw_menubar (void);
# 398 "/h/27/yijun/software/vim62/src/globals.h"
extern int force_menu_update ;
# 2221 "/h/27/yijun/software/vim62/src/menu.cpp.c"
typedef struct
{
    char_u *from;
    char_u *to;
} menutrans_T;
# 24 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int add_menu_path (char_u *, vimmenu_T *, int *, char_u *);
# 26 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int menu_nable_recurse (vimmenu_T *menu, char_u *name, int modes, int enable);
# 27 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int remove_menu (vimmenu_T **, char_u *, int, int silent);
# 28 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static void free_menu (vimmenu_T **menup);
# 29 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static void free_menu_string (vimmenu_T *, int);
# 30 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int show_menus (char_u *, int);
# 31 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static void show_menus_recursive (vimmenu_T *, int, int);
# 32 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int menu_name_equal (char_u *name, vimmenu_T *menu);
# 33 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int menu_namecmp (char_u *name, char_u *mname);
# 34 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int get_menu_cmd_modes (char_u *, int, int *, int *);
# 35 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static char_u *popup_mode_name (char_u *name, int idx);
# 36 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static char_u *menu_text (char_u *text, int *mnemonic, char_u **actext);
# 38 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int get_menu_mode (void);
# 39 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static void gui_update_menus_recurse (vimmenu_T *, int);
# 49 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int menu_is_hidden (char_u *name);
# 51 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int menu_is_tearoff (char_u *name);
# 55 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static char_u *menu_skip_part (char_u *p);
# 58 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static char_u *menutrans_lookup (char_u *name, int len);
# 62 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static char_u menu_mode_chars[] = {'n', 'v', 'o', 'i', 'c', 't'};
# 64 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static char_u e_notsubmenu[] = "E327: Part of menu-item path is not sub-menu";
# 65 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static char_u e_othermode[] = "E328: Menu only exists in another mode";
# 66 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static char_u e_nomenu[] = "E329: No menu of that name";
# 69 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static const char *toolbar_names[] =
{
             "New", "Open", "Save", "Undo", "Redo",
             "Cut", "Copy", "Paste", "Print", "Help",
             "Find", "SaveAll", "SaveSesn", "NewSesn", "LoadSesn",
             "RunScript", "Replace", "WinClose", "WinMax", "WinMin",
             "WinSplit", "Shell", "FindPrev", "FindNext", "FindHelp",
             "Make", "TagJump", "RunCtags", "WinVSplit", "WinMaxWidth",
             "WinMinWidth", "Exit"
};
# 86 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    void ex_menu(eap)
    exarg_T *eap;
{
    char_u *menu_path;
    int modes;
    char_u *map_to;
    int noremap;
    int silent = 0;
    int unmenu;
    char_u *map_buf;
    char_u *arg;
    char_u *p;
    int i;






    int pri_tab[10 + 1];
    int enable = 2;


    char_u *tofree = ((void *)0);
    char_u *new_cmd;


    char_u *icon = ((void *)0);

    vimmenu_T menuarg;

    modes = get_menu_cmd_modes(eap->cmd, eap->forceit, &noremap, &unmenu);
    arg = eap->arg;

    for (;;)
    {
        if (strncmp((char *)(arg), (char *)("<script>"), (size_t)(8)) == 0)
        {
            noremap = -2;
            arg = skipwhite(arg + 8);
            continue;
        }
        if (strncmp((char *)(arg), (char *)("<silent>"), (size_t)(8)) == 0)
        {
            silent = 1;
            arg = skipwhite(arg + 8);
            continue;
        }
        break;
    }



    if (strncmp((char *)(arg), (char *)("icon="), (size_t)(5)) == 0)
    {
        arg += 5;

        icon = arg;

        while (*arg != '\000' && *arg != ' ')
        {
            if (*arg == '\\')
                memmove((char *)(arg), (char *)(arg + 1), strlen((char *)(arg)));





                ++arg;
        }
        if (*arg != '\000')
        {
            *arg++ = '\000';
            arg = skipwhite(arg);
        }
    }




    for (p = arg; *p; ++p)
        if (!(__ctype_b[(int) ((*p))] & (unsigned short int) _ISdigit) && *p != '.')
            break;
    if (((*p) == ' ' || (*p) == '\t'))
    {
        for (i = 0; i < 10 && !((*arg) == ' ' || (*arg) == '\t'); ++i)
        {
            pri_tab[i] = getdigits(&arg);
            if (pri_tab[i] == 0)
                pri_tab[i] = 500;
            if (*arg == '.')
                ++arg;
        }
        arg = skipwhite(arg);
    }
    else if (eap->addr_count && eap->line2 != 0)
    {
        pri_tab[0] = eap->line2;
        i = 1;
    }
    else
        i = 0;
    while (i < 10)
        pri_tab[i++] = 500;
    pri_tab[10] = -1;




    if (strncmp((char *)(arg), (char *)("enable"), (size_t)(6)) == 0 && ((arg[6]) == ' ' || (arg[6]) == '\t'))
    {
        enable = 1;
        arg = skipwhite(arg + 6);
    }
    else if (strncmp((char *)(arg), (char *)("disable"), (size_t)(7)) == 0 && ((arg[7]) == ' ' || (arg[7]) == '\t'))
    {
        enable = 0;
        arg = skipwhite(arg + 7);
    }




    if (*arg == '\000')
    {
        show_menus(arg, modes);
        return;
    }





    menuarg.iconidx = -1;
    menuarg.icon_builtin = 0;
    if (menu_is_toolbar(arg))
    {
        menu_path = menu_skip_part(arg);
        if (*menu_path == '.')
        {
            p = menu_skip_part(++menu_path);
            if (strncmp((char *)(menu_path), (char *)("BuiltIn"), (size_t)(7)) == 0)
            {
                if (skipdigits(menu_path + 7) == p)
                {
                    menuarg.iconidx = atoi((char *)menu_path + 7);
                    if (menuarg.iconidx >= (sizeof(toolbar_names) / sizeof(char *)))
                        menuarg.iconidx = -1;
                    else
                        menuarg.icon_builtin = 1;
                }
            }
            else
            {
                for (i = 0; i < (sizeof(toolbar_names) / sizeof(char *)); ++i)
                    if (strncmp((char *)(toolbar_names[i]), (char *)(menu_path), (size_t)(p - menu_path))
                                                                         == 0)
                    {
                        menuarg.iconidx = i;
                        break;
                    }
            }
        }
    }






    menu_path = arg;
    while (*menu_path)
    {

        p = menu_skip_part(menu_path);
        map_to = menutrans_lookup(menu_path, (int)(p - menu_path));
        if (map_to != ((void *)0))
        {

            i = (int)strlen((char *)(map_to));
            new_cmd = alloc((unsigned)strlen((char *)(arg)) + i + 1);
            if (new_cmd == ((void *)0))
                break;
            memmove((char *)(new_cmd), (char *)(arg), menu_path - arg);
            memmove((char *)(new_cmd + (menu_path - arg)), (char *)(map_to), (size_t)i);
            strcpy((char *)(new_cmd + (menu_path - arg) + i), (char *)(p));
            p = new_cmd + (menu_path - arg) + i;
            vim_free(tofree);
            tofree = new_cmd;
            arg = new_cmd;
        }
        if (*p != '.')
            break;
        menu_path = p + 1;
    }






    menu_path = arg;
    if (*menu_path == '.')
    {
        emsg2((char_u *)(((char *)(e_invarg2))), (char_u *)(menu_path));
        goto theend;
    }

    while (*arg && !((*arg) == ' ' || (*arg) == '\t'))
    {
        if ((*arg == '\\' || *arg == 22) && arg[1] != '\000')
            arg++;
        else if (strncasecmp((char *)(arg), (char *)("<TAB>"), (size_t)(5)) == 0)
        {
            *arg = '\011';
            memmove((char *)(arg + 1), (char *)(arg + 5), strlen((char *)(arg + 4)));
        }
        arg++;
    }
    if (*arg != '\000')
        *arg++ = '\000';
    arg = skipwhite(arg);
    map_to = arg;




    if (*map_to == '\000' && !unmenu && enable == 2)
    {
        show_menus(menu_path, modes);
        goto theend;
    }
    else if (*map_to != '\000' && (unmenu || enable != 2))
    {
        emsg((char_u *)(((char *)(e_trailing))));
        goto theend;
    }







    if (enable != 2)
    {




        if (strcmp((char *)(menu_path), (char *)("*")) == 0)
            menu_path = (char_u *)"";
        menu_nable_recurse(root_menu, menu_path, modes, enable);
    }
    else if (unmenu)
    {



        if (strcmp((char *)(menu_path), (char *)("*")) == 0)
            menu_path = (char_u *)"";




        if (menu_is_popup(menu_path))
        {
            for (i = 0; i < 5; ++i)
                if (modes & (1 << i))
                {
                    p = popup_mode_name(menu_path, i);
                    if (p != ((void *)0))
                    {
                        remove_menu(&root_menu, p, ((1 << 5) - 1), 1);
                        vim_free(p);
                    }
                }
        }


        remove_menu(&root_menu, menu_path, modes, 0);
    }
    else
    {




        if (strcasecmp((char *)(map_to), (char *)("<nop>")) == 0)
        {
            map_to = (char_u *)"";
            map_buf = ((void *)0);
        }
        else
            map_to = replace_termcodes(map_to, &map_buf, 0, 1);
        menuarg.modes = modes;

        menuarg.iconfile = icon;

        menuarg.noremap[0] = noremap;
        menuarg.silent[0] = silent;
        add_menu_path(menu_path, &menuarg, pri_tab, map_to



                );




        if (menu_is_popup(menu_path))
        {
            for (i = 0; i < 5; ++i)
                if (modes & (1 << i))
                {
                    p = popup_mode_name(menu_path, i);
                    if (p != ((void *)0))
                    {

                        menuarg.modes = modes;

                        menuarg.iconfile = ((void *)0);
                        menuarg.iconidx = -1;
                        menuarg.icon_builtin = 0;

                        add_menu_path(p, &menuarg, pri_tab, map_to



                                         );
                        vim_free(p);
                    }
                }
        }

        vim_free(map_buf);
    }
theend:

    vim_free(tofree);



}
# 447 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int add_menu_path(menu_path, menuarg, pri_tab, call_data



        )
    char_u *menu_path;
    vimmenu_T *menuarg;

    int *pri_tab;
    char_u *call_data;



{
    char_u *path_name;
    int modes = menuarg->modes;
    vimmenu_T **menup;
    vimmenu_T *menu = ((void *)0);
    vimmenu_T *parent;
    vimmenu_T **lower_pri;
    char_u *p;
    char_u *name;
    char_u *dname;
    char_u *next_name;
    int i;
    int c;

    int idx;
    int new_idx;

    int pri_idx = 0;
    int old_modes = 0;
    int amenu;


    path_name = vim_strsave(menu_path);
    if (path_name == ((void *)0))
        return 0;
    menup = &root_menu;
    parent = ((void *)0);
    name = path_name;
    while (*name)
    {


        next_name = menu_name_skip(name);
        dname = menu_text(name, ((void *)0), ((void *)0));


        lower_pri = menup;

        idx = 0;
        new_idx = 0;

        menu = *menup;
        while (menu != ((void *)0))
        {
            if (menu_name_equal(name, menu) || menu_name_equal(dname, menu))
            {
                if (*next_name == '\000' && menu->children != ((void *)0))
                {
                    if (!sys_menu)
                        emsg((char_u *)(((char *)("E330: Menu path must not lead to a sub-menu"))));
                    goto erret;
                }
                if (*next_name != '\000' && menu->children == ((void *)0)



                        )
                {
                    if (!sys_menu)
                        emsg((char_u *)(((char *)(e_notsubmenu))));
                    goto erret;
                }
                break;
            }
            menup = &menu->next;



            if (parent != ((void *)0) || menu_is_menubar(menu->name))
            {

                ++idx;

                if (menu->priority <= pri_tab[pri_idx])
                {
                    lower_pri = menup;

                    new_idx = idx;

                }
            }
            menu = menu->next;
        }

        if (menu == ((void *)0))
        {
            if (*next_name == '\000' && parent == ((void *)0))
            {
                emsg((char_u *)(((char *)("E331: Must not add menu items directly to menu bar"))));
                goto erret;
            }

            if (menu_is_separator(dname) && *next_name != '\000')
            {
                emsg((char_u *)(((char *)("E332: Separator cannot be part of a menu path"))));
                goto erret;
            }


            menu = (vimmenu_T *)alloc_clear((unsigned)sizeof(vimmenu_T));
            if (menu == ((void *)0))
                goto erret;

            menu->modes = modes;
            menu->enabled = ((1 << 5) - 1);
            menu->name = vim_strsave(name);

            menu->dname = menu_text(name, &menu->mnemonic, &menu->actext);
            menu->priority = pri_tab[pri_idx];
            menu->parent = parent;
            menu->next = *lower_pri;
            *lower_pri = menu;

            old_modes = 0;


            menu->iconidx = menuarg->iconidx;
            menu->icon_builtin = menuarg->icon_builtin;
            if (*next_name == '\000' && menuarg->iconfile != ((void *)0))
                menu->iconfile = vim_strsave(menuarg->iconfile);






        }
        else
        {
            old_modes = menu->modes;
            {
                menu->modes |= modes;
                menu->enabled |= modes;
            }
        }






        if ((old_modes & ((1 << 5) - 1)) == 0
                && (menu->modes & ((1 << 5) - 1)) != 0)
        {
            if (gui.in_use)
            {
                if (*next_name == '\000')
                {

                    gui_mch_add_menu_item(menu, new_idx);


                    force_menu_update = 1;
                }
                else
                {

                    gui_mch_add_menu(menu, new_idx);
                }
            }
        }


        menup = &menu->children;
        parent = menu;
        name = next_name;
        vim_free(dname);
        if (pri_tab[pri_idx + 1] != -1)
            ++pri_idx;
    }
    vim_free(path_name);





    amenu = ((modes & ((1 << 0) | (1 << 3))) ==
                                       ((1 << 0) | (1 << 3)));
    if (sys_menu)
        modes &= ~old_modes;

    if (menu != ((void *)0) && modes)
    {

        menu->cb = gui_menu_cb;

        p = (call_data == ((void *)0)) ? ((void *)0) : vim_strsave(call_data);


        for (i = 0; i < 6; ++i)
        {
            if (modes & (1 << i))
            {

                free_menu_string(menu, i);




                c = 0;
                if (amenu && call_data != ((void *)0) && *call_data != '\000'



                                       )
                {
                    switch (1 << i)
                    {
                        case (1 << 1):
                        case (1 << 2):
                        case (1 << 4):
                            c = 3;
                            break;
                        case (1 << 3):
                            c = 15;
                            break;
                    }
                }

                if (c)
                {
                    menu->strings[i] = alloc((unsigned)(strlen((char *)(call_data)) + 4));
                    if (menu->strings[i] != ((void *)0))
                    {
                        menu->strings[i][0] = c;
                        strcpy((char *)(menu->strings[i] + 1), (char *)(call_data));
                        if (c == 3)
                        {
                            int len = strlen((char *)(menu->strings[i]));


                            menu->strings[i][len] = 28;
                            menu->strings[i][len + 1] = 7;
                            menu->strings[i][len + 2] = '\000';
                        }
                    }
                }
                else
                    menu->strings[i] = p;
                menu->noremap[i] = menuarg->noremap[0];
                menu->silent[i] = menuarg->silent[0];
            }
        }


        if (modes & (1 << 5))
            gui_mch_menu_set_tip(menu);

    }
    return 1;

erret:
    vim_free(path_name);
    vim_free(dname);
    return 0;
}
# 786 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int menu_nable_recurse(menu, name, modes, enable)
    vimmenu_T *menu;
    char_u *name;
    int modes;
    int enable;
{
    char_u *p;

    if (menu == ((void *)0))
        return 1;


    p = menu_name_skip(name);


    while (menu != ((void *)0))
    {
        if (*name == '\000' || *name == '*' || menu_name_equal(name, menu))
        {
            if (*p != '\000')
            {
                if (menu->children == ((void *)0))
                {
                    emsg((char_u *)(((char *)(e_notsubmenu))));
                    return 0;
                }
                if (menu_nable_recurse(menu->children, p, modes, enable)
                                                                      == 0)
                    return 0;
            }
            else
                if (enable)
                    menu->enabled |= modes;
                else
                    menu->enabled &= ~modes;






            if (*name != '\000' && *name != '*')
                break;
        }
        menu = menu->next;
    }
    if (*name != '\000' && *name != '*' && menu == ((void *)0))
    {
        emsg((char_u *)(((char *)(e_nomenu))));
        return 0;
    }



    force_menu_update = 1;


    return 1;
}
# 851 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int remove_menu(menup, name, modes, silent)
    vimmenu_T **menup;
    char_u *name;
    int modes;
    int silent;
{
    vimmenu_T *menu;
    vimmenu_T *child;
    char_u *p;

    if (*menup == ((void *)0))
        return 1;


    p = menu_name_skip(name);


    while ((menu = *menup) != ((void *)0))
    {
        if (*name == '\000' || menu_name_equal(name, menu))
        {
            if (*p != '\000' && menu->children == ((void *)0))
            {
                if (!silent)
                    emsg((char_u *)(((char *)(e_notsubmenu))));
                return 0;
            }
            if ((menu->modes & modes) != 0x0)
            {
                if (remove_menu(&menu->children, p, modes, silent) == 0)
                    return 0;
            }
            else if (*name != '\000')
            {
                if (!silent)
                    emsg((char_u *)(((char *)(e_othermode))));
                return 0;
            }






            if (*name != '\000')
                break;



            menu->modes &= ~modes;
            if (modes & (1 << 5))
                free_menu_string(menu, 5);
            if ((menu->modes & ((1 << 5) - 1)) == 0)
                free_menu(menup);
            else
                menup = &menu->next;
        }
        else
            menup = &menu->next;
    }
    if (*name != '\000')
    {
        if (menu == ((void *)0))
        {
            if (!silent)
                emsg((char_u *)(((char *)(e_nomenu))));
            return 0;
        }



        menu->modes &= ~modes;





            child = menu->children;
        for ( ; child != ((void *)0); child = child->next)
            menu->modes |= child->modes;
        if (modes & (1 << 5))
        {
            free_menu_string(menu, 5);


            if (gui.in_use)
                gui_mch_menu_set_tip(menu);

        }
        if ((menu->modes & ((1 << 5) - 1)) == 0)
        {





            *menup = menu;
            free_menu(menup);
        }
    }

    return 1;
}
# 970 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static void free_menu(menup)
    vimmenu_T **menup;
{
    int i;
    vimmenu_T *menu;

    menu = *menup;




    if (gui.in_use)
        gui_mch_destroy_menu(menu);




    *menup = menu->next;
    vim_free(menu->name);
    vim_free(menu->dname);
    vim_free(menu->actext);

    vim_free(menu->iconfile);

    for (i = 0; i < 6; i++)
        free_menu_string(menu, i);
    vim_free(menu);



    force_menu_update = 1;

}
# 1008 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static void free_menu_string(menu, idx)
    vimmenu_T *menu;
    int idx;
{
    int count = 0;
    int i;

    for (i = 0; i < 6; i++)
        if (menu->strings[i] == menu->strings[idx])
            count++;
    if (count == 1)
        vim_free(menu->strings[idx]);
    menu->strings[idx] = ((void *)0);
}
# 1027 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int show_menus(path_name, modes)
    char_u *path_name;
    int modes;
{
    char_u *p;
    char_u *name;
    vimmenu_T *menu;
    vimmenu_T *parent = ((void *)0);

    menu = root_menu;
    name = path_name = vim_strsave(path_name);
    if (path_name == ((void *)0))
        return 0;


    while (*name)
    {
        p = menu_name_skip(name);
        while (menu != ((void *)0))
        {
            if (menu_name_equal(name, menu))
            {

                if (*p != '\000' && menu->children == ((void *)0))
                {
                    emsg((char_u *)(((char *)(e_notsubmenu))));
                    vim_free(path_name);
                    return 0;
                }
                else if ((menu->modes & modes) == 0x0)
                {
                    emsg((char_u *)(((char *)(e_othermode))));
                    vim_free(path_name);
                    return 0;
                }
                break;
            }
            menu = menu->next;
        }
        if (menu == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_nomenu))));
            vim_free(path_name);
            return 0;
        }
        name = p;
        parent = menu;
        menu = menu->children;
    }



    msg_puts_title((char_u *)(((char *)("\n--- Menus ---"))));

    show_menus_recursive(parent, modes, 0);
    return 1;
}
# 1089 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static void show_menus_recursive(menu, modes, depth)
    vimmenu_T *menu;
    int modes;
    int depth;
{
    int i;
    int bit;

    if (menu != ((void *)0) && (menu->modes & modes) == 0x0)
        return;

    if (menu != ((void *)0))
    {
        msg_putchar('\n');
        if (got_int)
            return;
        for (i = 0; i < depth; i++)
            msg_puts((char_u *)("  "));
        if (menu->priority)
        {
            msg_outnum((long)menu->priority);
            msg_puts((char_u *)(" "));
        }

        msg_outtrans_attr(menu->name, highlight_attr[(int)(HLF_D)]);
    }

    if (menu != ((void *)0) && menu->children == ((void *)0))
    {
        for (bit = 0; bit < 6; bit++)
            if ((menu->modes & modes & (1 << bit)) != 0)
            {
                msg_putchar('\n');
                if (got_int)
                    return;
                for (i = 0; i < depth + 2; i++)
                    msg_puts((char_u *)("  "));
                msg_putchar(menu_mode_chars[bit]);
                if (menu->noremap[bit] == -1)
                    msg_putchar('*');
                else if (menu->noremap[bit] == -2)
                    msg_putchar('&');
                else
                    msg_putchar(' ');
                if (menu->silent[bit])
                    msg_putchar('s');
                else
                    msg_putchar(' ');
                if ((menu->modes & menu->enabled & (1 << bit)) == 0)
                    msg_putchar('-');
                else
                    msg_putchar(' ');
                msg_puts((char_u *)(" "));
                if (*menu->strings[bit] == '\000')
                    msg_puts_attr((char_u *)"<Nop>", highlight_attr[(int)(HLF_8)]);
                else
                    msg_outtrans_special(menu->strings[bit], 0);
            }
    }
    else
    {
        if (menu == ((void *)0))
        {
            menu = root_menu;
            depth--;
        }
        else
            menu = menu->children;


        for (; menu != ((void *)0) && !got_int; menu = menu->next)
            if (!menu_is_hidden(menu->dname))
                show_menus_recursive(menu, modes, depth + 1);
    }
}
# 1170 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static vimmenu_T *expand_menu = ((void *)0);
# 1171 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int expand_modes = 0x0;
# 1172 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static int expand_emenu;
# 1178 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    char_u * set_context_in_menu_cmd(xp, cmd, arg, forceit)
    expand_T *xp;
    char_u *cmd;
    char_u *arg;
    int forceit;
{
    char_u *after_dot;
    char_u *p;
    char_u *path_name = ((void *)0);
    char_u *name;
    int unmenu;
    vimmenu_T *menu;
    int expand_menus;

    xp->xp_context = (-2);



    for (p = arg; *p; ++p)
        if (!(__ctype_b[(int) ((*p))] & (unsigned short int) _ISdigit) && *p != '.')
            break;

    if (!((*p) == ' ' || (*p) == '\t'))
    {
        if (strncmp((char *)(arg), (char *)("enable"), (size_t)(6)) == 0
                && (arg[6] == '\000' || ((arg[6]) == ' ' || (arg[6]) == '\t')))
            p = arg + 6;
        else if (strncmp((char *)(arg), (char *)("disable"), (size_t)(7)) == 0
                && (arg[7] == '\000' || ((arg[7]) == ' ' || (arg[7]) == '\t')))
            p = arg + 7;
        else
            p = arg;
    }

    while (*p != '\000' && ((*p) == ' ' || (*p) == '\t'))
        ++p;

    arg = after_dot = p;

    for (; *p && !((*p) == ' ' || (*p) == '\t'); ++p)
    {
        if ((*p == '\\' || *p == 22) && p[1] != '\000')
            p++;
        else if (*p == '.')
            after_dot = p + 1;
    }


    expand_menus = !((*cmd == 't' && cmd[1] == 'e') || *cmd == 'p');
    expand_emenu = (*cmd == 'e');
    if (expand_menus && ((*p) == ' ' || (*p) == '\t'))
        return ((void *)0);
    if (*p == '\000')
    {





        expand_modes = get_menu_cmd_modes(cmd, forceit, ((void *)0), &unmenu);
        if (!unmenu)
            expand_modes = ((1 << 5) - 1);

        menu = root_menu;
        if (after_dot != arg)
        {
            path_name = alloc((unsigned)(after_dot - arg));
            if (path_name == ((void *)0))
                return ((void *)0);
            strncpy((char *)(path_name), (char *)(arg), (size_t)(after_dot - arg - 1));
            path_name[after_dot - arg - 1] = '\000';
        }
        name = path_name;
        while (name != ((void *)0) && *name)
        {
            p = menu_name_skip(name);
            while (menu != ((void *)0))
            {
                if (menu_name_equal(name, menu))
                {

                    if ((*p != '\000' && menu->children == ((void *)0))
                        || ((menu->modes & expand_modes) == 0x0))
                    {




                        vim_free(path_name);
                        return ((void *)0);
                    }
                    break;
                }
                menu = menu->next;
            }
            if (menu == ((void *)0))
            {

                vim_free(path_name);
                return ((void *)0);
            }
            name = p;
            menu = menu->children;
        }

        xp->xp_context = expand_menus ? 21 : 11;
        xp->xp_pattern = after_dot;
        expand_menu = menu;
    }
    else
        xp->xp_context = 0;
    return ((void *)0);
}
# 1298 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    char_u * get_menu_name(xp, idx)
    expand_T *xp;
    int idx;
{
    static vimmenu_T *menu = ((void *)0);
    char_u *str;

    if (idx == 0)
        menu = expand_menu;


    while (menu != ((void *)0) && (menu_is_hidden(menu->dname)
            || menu_is_separator(menu->dname)
            || menu_is_tearoff(menu->dname)
            || menu->children == ((void *)0)))
        menu = menu->next;

    if (menu == ((void *)0))
        return ((void *)0);

    if (menu->modes & expand_modes)
        str = menu->dname;
    else
        str = (char_u *)"";


    menu = menu->next;

    return str;
}
# 1335 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    char_u * get_menu_names(xp, idx)
    expand_T *xp;
    int idx;
{
    static vimmenu_T *menu = ((void *)0);
    static char_u tbuffer[256];
    char_u *str;

    if (idx == 0)
        menu = expand_menu;


    while (menu != ((void *)0)
            && ( menu_is_hidden(menu->dname)
                || (expand_emenu && menu_is_separator(menu->dname))
                || menu_is_tearoff(menu->dname)



               ))
        menu = menu->next;

    if (menu == ((void *)0))
        return ((void *)0);

    if (menu->modes & expand_modes)
    {
        if (menu->children != ((void *)0))
        {
            strcpy((char *)(tbuffer), (char *)(menu->dname));


            strcat((char *)(tbuffer), (char *)("\001"));
            str = tbuffer;
        }
        else
            str = menu->dname;
    }
    else
        str = (char_u *)"";


    menu = menu->next;

    return str;
}
# 1388 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    char_u * menu_name_skip(name)
    char_u *name;
{
    char_u *p;

    for (p = name; *p && *p != '.'; p++)
    {
        if (*p == '\\' || *p == 22)
        {
            memmove((char *)(p), (char *)(p + 1), strlen((char *)(p)));
            if (*p == '\000')
                break;
        }




    }
    if (*p)
        *p++ = '\000';
    return p;
}
# 1416 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int menu_name_equal(name, menu)
    char_u *name;
    vimmenu_T *menu;
{
    return (menu_namecmp(name, menu->name) || menu_namecmp(name, menu->dname));
}
# 1424 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int menu_namecmp(name, mname)
    char_u *name;
    char_u *mname;
{
    int i;

    for (i = 0; name[i] != '\000' && name[i] != '\011'; ++i)
        if (name[i] != mname[i])
            break;
    return ((name[i] == '\000' || name[i] == '\011')
            && (mname[i] == '\000' || mname[i] == '\011'));
}
# 1446 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int get_menu_cmd_modes(cmd, forceit, noremap, unmenu)
    char_u *cmd;
    int forceit;
    int *noremap;
    int *unmenu;
{
    int modes;

    switch (*cmd++)
    {
        case 'v':
            modes = (1 << 1);
            break;
        case 'o':
            modes = (1 << 2);
            break;
        case 'i':
            modes = (1 << 3);
            break;
        case 't':
            modes = (1 << 5);
            break;
        case 'c':
            modes = (1 << 4);
            break;
        case 'a':
            modes = (1 << 3) | (1 << 4) | (1 << 0)
                                    | (1 << 1) | (1 << 2);
            break;
        case 'n':
            if (cmd[1] != 'o')
            {
                modes = (1 << 0);
                break;
            }

        default:
            --cmd;
            if (forceit)
                modes = (1 << 3) | (1 << 4);
            else
                modes = (1 << 0) | (1 << 1)
                                                       | (1 << 2);
    }

    if (noremap != ((void *)0))
        *noremap = (*cmd == 'n' ? -1 : 0);
    if (unmenu != ((void *)0))
        *unmenu = (*cmd == 'u');
    return modes;
}
# 1503 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static char_u * popup_mode_name(name, idx)
    char_u *name;
    int idx;
{
    char_u *p;
    int len = (int)strlen((char *)(name));

    p = vim_strnsave(name, len + 1);
    if (p != ((void *)0))
    {
        memmove((char *)(p + 6), (char *)(p + 5), (size_t)(len - 4));
        p[5] = menu_mode_chars[idx];
    }
    return p;
}
# 1526 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    int get_menu_index(menu, state)
    vimmenu_T *menu;
    int state;
{
    int idx;

    if ((state & 0x10))
        idx = 3;
    else if (state & 0x08)
        idx = 4;

    else if (VIsual_active)
        idx = 1;

    else if (state == (0x200 + 0x01) || state == 0x300)
        idx = 4;
    else if (finish_op)
        idx = 2;
    else if ((state & 0x01))
        idx = 0;
    else
        idx = -1;

    if (idx != -1 && menu->strings[idx] == ((void *)0))
        idx = -1;
    return idx;
}
# 1563 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static char_u * menu_text(str, mnemonic, actext)
    char_u *str;
    int *mnemonic;
    char_u **actext;
{
    char_u *p;
    char_u *text;


    p = vim_strchr(str, '\011');
    if (p != ((void *)0))
    {
        if (actext != ((void *)0))
            *actext = vim_strsave(p + 1);
        text = vim_strnsave(str, (int)(p - str));
    }
    else
        text = vim_strsave(str);
    if (text != ((void *)0))
    {
        p = vim_strchr(text, '&');
        if (p != ((void *)0))
        {
            if (mnemonic != ((void *)0))

                *mnemonic = p[1];
            memmove((char *)(p), (char *)(p + 1), strlen((char *)(p)));
        }
    }
    return text;
}
# 1612 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    int menu_is_menubar(name)
    char_u *name;
{
    return (!menu_is_popup(name)
            && !menu_is_toolbar(name)
            && *name != ']');
}
# 1624 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    int menu_is_popup(name)
    char_u *name;
{
    return (strncmp((char *)(name), (char *)("PopUp"), (size_t)(5)) == 0);
}
# 1648 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    int menu_is_toolbar(name)
    char_u *name;
{
    return (strncmp((char *)(name), (char *)("ToolBar"), (size_t)(7)) == 0);
}
# 1659 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    int menu_is_separator(name)
    char_u *name;
{
    return (name[0] == '-' && name[strlen((char *)(name)) - 1] == '-');
}
# 1669 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int menu_is_hidden(name)
    char_u *name;
{
    return (name[0] == ']') || (menu_is_popup(name) && name[5] != '\000');
}
# 1682 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int menu_is_tearoff(name)
    char_u *name;
{

    return (strcmp((char *)(name), (char *)("-->Detach")) == 0);



}
# 1696 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static int get_menu_mode()
{

    if (VIsual_active)
        return 1;

    if (State & 0x10)
        return 3;
    if ((State & 0x08) || State == 0x300 || State == (0x200 + 0x01))
        return 4;
    if (finish_op)
        return 2;
    if (State & 0x01)
        return 0;
    if (State & 0x20)
        return 3;
    return -1;
}
# 1723 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    void gui_create_initial_menus(menu)
    vimmenu_T *menu;
{
    int idx = 0;

    while (menu != ((void *)0))
    {

        if (menu->modes & ((1 << 5) - 1))
        {
            if (menu->children != ((void *)0))
            {
                gui_mch_add_menu(menu, idx);
                gui_create_initial_menus(menu->children);
            }
            else
                gui_mch_add_menu_item(menu, idx);
        }
        menu = menu->next;
        ++idx;
    }
}
# 1750 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static void gui_update_menus_recurse(menu, mode)
    vimmenu_T *menu;
    int mode;
{
    int grey;

    while (menu)
    {
        if ((menu->modes & menu->enabled & mode)



           )
            grey = 0;
        else
            grey = 1;






        if (vim_strchr(p_go, 'g') != ((void *)0) || menu->parent == ((void *)0)

                || menu_is_toolbar(menu->parent->name)

                   )
            gui_mch_menu_grey(menu, grey);
        else
            gui_mch_menu_hidden(menu, grey);

        gui_update_menus_recurse(menu->children, mode);
        menu = menu->next;
    }
}
# 1792 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    void gui_update_menus(modes)
    int modes;
{
    static int prev_mode = -1;
    int mode = 0;

    if (modes != 0x0)
        mode = modes;
    else
    {
        mode = get_menu_mode();
        if (mode == -1)
            mode = 0;
        else
            mode = (1 << mode);
    }

    if (force_menu_update || mode != prev_mode)
    {
        gui_update_menus_recurse(root_menu, mode);
        gui_mch_draw_menubar();
        prev_mode = mode;
        force_menu_update = 0;





    }
}
# 1830 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    int gui_is_menu_shortcut(key)
    int key;
{
    vimmenu_T *menu;

    if (key < 256)
        key = tolower(key);
    for (menu = root_menu; menu != ((void *)0); menu = menu->next)
        if (menu->mnemonic == key
                || (menu->mnemonic < 256 && tolower(menu->mnemonic) == key))
            return 1;
    return 0;
}
# 1851 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    void gui_show_popupmenu()
{
    vimmenu_T *menu;
    int mode;

    mode = get_menu_mode();
    if (mode == -1)
        return;
    mode = menu_mode_chars[mode];

    for (menu = root_menu; menu != ((void *)0); menu = menu->next)
        if (strncmp((char *)("PopUp"), (char *)(menu->name), (size_t)(5)) == 0 && menu->name[5] == mode)
            break;


    if (menu != ((void *)0) && menu->children != ((void *)0))
        gui_mch_show_popupmenu(menu);
}
# 2034 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    void ex_emenu(eap)
    exarg_T *eap;
{
    vimmenu_T *menu;
    char_u *name;
    char_u *saved_name;
    char_u *p;
    int idx;
    char_u *mode;

    saved_name = vim_strsave(eap->arg);
    if (saved_name == ((void *)0))
        return;

    menu = root_menu;
    name = saved_name;
    while (*name)
    {

        p = menu_name_skip(name);

        while (menu != ((void *)0))
        {
            if (menu_name_equal(name, menu))
            {
                if (*p == '\000' && menu->children != ((void *)0))
                {
                    emsg((char_u *)(((char *)("E333: Menu path must lead to a menu item"))));
                    menu = ((void *)0);
                }
                else if (*p != '\000' && menu->children == ((void *)0))
                {
                    emsg((char_u *)(((char *)(e_notsubmenu))));
                    menu = ((void *)0);
                }
                break;
            }
            menu = menu->next;
        }
        if (menu == ((void *)0) || *p == '\000')
            break;
        menu = menu->children;
        name = p;
    }
    vim_free(saved_name);
    if (menu == ((void *)0))
    {
        emsg2((char_u *)(((char *)("E334: Menu not found: %s"))), (char_u *)(eap->arg));
        return;
    }


    if (restart_edit)
    {
        mode = (char_u *)"Insert";
        idx = 3;
    }
    else if (eap->addr_count)
    {
        pos_T tpos;

        mode = (char_u *)"Visual";
        idx = 1;






        if ((curbuf->b_visual_start.lnum == eap->line1)
                && (curbuf->b_visual_end.lnum) == eap->line2)
        {

            VIsual_mode = curbuf->b_visual_mode;
            tpos = curbuf->b_visual_end;
            curwin->w_cursor = curbuf->b_visual_start;
            curwin->w_curswant = curbuf->b_visual_curswant;
        }
        else
        {

            VIsual_mode = 'V';
            curwin->w_cursor.lnum = eap->line1;
            curwin->w_cursor.col = 1;
            tpos.lnum = eap->line2;
            tpos.col = (0x7fffffffL);
        }



        VIsual_active = 1;
        VIsual_reselect = 1;
        check_cursor();
        VIsual = curwin->w_cursor;
        curwin->w_cursor = tpos;

        check_cursor();




        if (*p_sel == 'e' && gchar_cursor() != '\000')
            ++curwin->w_cursor.col;
    }
    else
    {
        mode = (char_u *)"Normal";
        idx = 0;
    }

    if (idx != -1 && menu->strings[idx] != ((void *)0))
    {
        ins_typebuf(menu->strings[idx], menu->noremap[idx], 0,
                                                     1, menu->silent[idx]);
    }
    else
        emsg2((char_u *)(((char *)("E335: Menu not defined for %s mode"))), (char_u *)(mode));
}
# 2160 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    vimmenu_T * gui_find_menu(path_name)
    char_u *path_name;
{
    vimmenu_T *menu = ((void *)0);
    char_u *name;
    char_u *saved_name;
    char_u *p;

    menu = root_menu;

    saved_name = vim_strsave(path_name);
    if (saved_name == ((void *)0))
        return ((void *)0);

    name = saved_name;
    while (*name)
    {

        p = menu_name_skip(name);

        while (menu != ((void *)0))
        {
            if (strcmp((char *)(name), (char *)(menu->name)) == 0 || strcmp((char *)(name), (char *)(menu->dname)) == 0)
            {
                if (menu->children == ((void *)0))
                {

                    if (*p == '\000')
                        emsg((char_u *)(((char *)("E336: Menu path must lead to a sub-menu"))));
                    else
                        emsg((char_u *)(((char *)(e_notsubmenu))));
                    menu = ((void *)0);
                    goto theend;
                }
                if (*p == '\000')
                    goto theend;
                break;
            }
            menu = menu->next;
        }
        if (menu == ((void *)0))
            break;


        menu = menu->children;
        name = p;
    }

    if (menu == ((void *)0))
        emsg((char_u *)(((char *)("E337: Menu not found - check menu names"))));
theend:
    vim_free(saved_name);
    return menu;
}
# 2227 "/h/27/yijun/software/vim62/src/menu.cpp.c"
static garray_T menutrans_ga = {0, 0, 0, 0, ((void *)0)};
# 2237 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    void ex_menutranslate(eap)
    exarg_T *eap;
{

    char_u *arg = eap->arg;
    menutrans_T *tp;
    int i;
    char_u *from, *to;

    if (menutrans_ga.ga_itemsize == 0)
        ga_init2(&menutrans_ga, (int)sizeof(menutrans_T), 5);




    if (strncmp((char *)(arg), (char *)("clear"), (size_t)(5)) == 0 && ends_excmd(*skipwhite(arg + 5)))
    {
        tp = (menutrans_T *)menutrans_ga.ga_data;
        for (i = 0; i < menutrans_ga.ga_len; ++i)
        {
            vim_free(tp[i].from);
            vim_free(tp[i].to);
        }
        ga_clear(&menutrans_ga);


        del_menutrans_vars();

    }
    else
    {

        from = arg;
        arg = menu_skip_part(arg);
        to = skipwhite(arg);
        *arg = '\000';
        arg = menu_skip_part(to);
        if (arg == to)
            emsg((char_u *)(((char *)(e_invarg))));
        else
        {
            if (ga_grow(&menutrans_ga, 1) == 1)
            {
                tp = (menutrans_T *)menutrans_ga.ga_data;
                from = vim_strsave(from);
                to = vim_strnsave(to, (int)(arg - to));
                if (from != ((void *)0) && to != ((void *)0))
                {
                    tp[menutrans_ga.ga_len].from = from;
                    tp[menutrans_ga.ga_len].to = to;
                    ++menutrans_ga.ga_len;
                    --menutrans_ga.ga_room;
                }
            }
        }
    }

}
# 2301 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static char_u * menu_skip_part(p)
    char_u *p;
{
    while (*p != '\000' && *p != '.' && !((*p) == ' ' || (*p) == '\t'))
    {
        if ((*p == '\\' || *p == 22) && p[1] != '\000')
            ++p;
        ++p;
    }
    return p;
}
# 2320 "/h/27/yijun/software/vim62/src/menu.cpp.c"
    static char_u * menutrans_lookup(name, len)
    char_u *name;
    int len;
{
    menutrans_T *tp = (menutrans_T *)menutrans_ga.ga_data;
    int i;

    for (i = 0; i < menutrans_ga.ga_len; ++i)
        if (strncmp((char *)(name), (char *)(tp[i].from), (size_t)(len)) == 0 && tp[i].from[len] == '\000')
            return tp[i].to;
    return ((void *)0);
}
