#ifndef HEADER_801
#define HEADER_801
#include "728.h"
#include "804.h"
#include "811.h"
#include "837.h"
# 475 "/usr/include/glib-1.2/glib.h"
typedef long glong;
# 479 "/usr/include/glib-1.2/glib.h"
typedef unsigned char guchar;
# 484 "/usr/include/glib-1.2/glib.h"
typedef float gfloat;
# 741 "/usr/include/glib-1.2/glib.h"
typedef enum
{

  G_LOG_FLAG_RECURSION = 1 << 0,
  G_LOG_FLAG_FATAL = 1 << 1,


  G_LOG_LEVEL_ERROR = 1 << 2,
  G_LOG_LEVEL_CRITICAL = 1 << 3,
  G_LOG_LEVEL_WARNING = 1 << 4,
  G_LOG_LEVEL_MESSAGE = 1 << 5,
  G_LOG_LEVEL_INFO = 1 << 6,
  G_LOG_LEVEL_DEBUG = 1 << 7,

  G_LOG_LEVEL_MASK = ~(G_LOG_FLAG_RECURSION | G_LOG_FLAG_FATAL)
} GLogLevelFlags;
# 1388 "/usr/include/glib-1.2/glib.h"
void g_free (gpointer mem);
# 41 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
typedef enum
{
  GTK_TYPE_INVALID,
  GTK_TYPE_NONE,


  GTK_TYPE_CHAR,
  GTK_TYPE_UCHAR,
  GTK_TYPE_BOOL,
  GTK_TYPE_INT,
  GTK_TYPE_UINT,
  GTK_TYPE_LONG,
  GTK_TYPE_ULONG,
  GTK_TYPE_FLOAT,
  GTK_TYPE_DOUBLE,
  GTK_TYPE_STRING,
  GTK_TYPE_ENUM,
  GTK_TYPE_FLAGS,
  GTK_TYPE_BOXED,
  GTK_TYPE_POINTER,


  GTK_TYPE_SIGNAL,
  GTK_TYPE_ARGS,
  GTK_TYPE_CALLBACK,
  GTK_TYPE_C_CALLBACK,
  GTK_TYPE_FOREIGN,


  GTK_TYPE_OBJECT
} GtkFundamentalType;
# 123 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
typedef guint GtkType;
# 125 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
typedef struct _GtkTypeObject GtkTypeObject;
# 126 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
typedef struct _GtkTypeClass GtkTypeClass;
# 150 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
typedef struct _GtkArg GtkArg;
# 45 "/usr/include/gtk-1.2/gtk/gtkwidget.h"
typedef enum
{
  GTK_TOPLEVEL = 1 << 4,
  GTK_NO_WINDOW = 1 << 5,
  GTK_REALIZED = 1 << 6,
  GTK_MAPPED = 1 << 7,
  GTK_VISIBLE = 1 << 8,
  GTK_SENSITIVE = 1 << 9,
  GTK_PARENT_SENSITIVE = 1 << 10,
  GTK_CAN_FOCUS = 1 << 11,
  GTK_HAS_FOCUS = 1 << 12,



  GTK_CAN_DEFAULT = 1 << 13,



  GTK_HAS_DEFAULT = 1 << 14,

  GTK_HAS_GRAB = 1 << 15,
  GTK_RC_STYLE = 1 << 16,
  GTK_COMPOSITE_CHILD = 1 << 17,
  GTK_NO_REPARENT = 1 << 18,
  GTK_APP_PAINTABLE = 1 << 19,



  GTK_RECEIVES_DEFAULT = 1 << 20
} GtkWidgetFlags;
# 51 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"
typedef struct _GtkContainer GtkContainer;
# 31 "/h/27/yijun/software/vim62/src/gui_gtk_f.h"
typedef struct _GtkForm GtkForm;
# 84 "/usr/include/gtk-1.2/gtk/gtksignal.h"
guint gtk_signal_connect (GtkObject *object,
                                           const gchar *name,
                                           GtkSignalFunc func,
                                           gpointer func_data);
# 1280 "/usr/include/glib-1.2/glib.h"
void g_log (const gchar *log_domain,
                                         GLogLevelFlags log_level,
                                         const gchar *format,
                                         ...) __attribute__((format (printf, 3, 4)));
# 166 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
typedef void (*GtkCallbackMarshal) (GtkObject *object,
                                    gpointer data,
                                    guint n_args,
                                    GtkArg *args);
# 185 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
struct _GtkTypeObject
{




  GtkTypeClass *klass;
};
# 54 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"
struct _GtkContainer
{
  GtkWidget widget;

  GtkWidget *focus_child;

  guint border_width : 16;
  guint need_resize : 1;
  guint resize_mode : 2;
  guint reallocate_redraws : 1;



  GSList *resize_widgets;
};
# 108 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"
GtkType gtk_container_get_type (void);
# 56 "/h/27/yijun/software/vim62/src/gui_gtk_f.h"
GtkType gtk_form_get_type(void);
# 369 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
GtkTypeObject* gtk_type_check_object_cast (GtkTypeObject *type_object,
                                                 GtkType cast_type);
# 34 "/h/27/yijun/software/vim62/src/gui_gtk_f.h"
struct _GtkForm
{
    GtkContainer container;

    GList *children;

    guint width;
    guint height;

    GdkWindow *bin_window;

    GdkVisibilityState visibility;
    gulong configure_serial;

    gint freeze_count;
};
# 219 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"
struct _GtkArg
{
  GtkType type;
  gchar *name;







  union {

    gchar char_data;
    guchar uchar_data;
    gboolean bool_data;
    gint int_data;
    guint uint_data;
    glong long_data;
    gulong ulong_data;
    gfloat float_data;
    gdouble double_data;
    gchar *string_data;
    gpointer pointer_data;
    GtkObject *object_data;


    struct {
      GtkSignalFunc f;
      gpointer d;
    } signal_data;
    struct {
      gint n_args;
      GtkArg *args;
    } args_data;
    struct {
      GtkCallbackMarshal marshal;
      gpointer data;
      GtkDestroyNotify notify;
    } callback_data;
    struct {
      GtkFunction func;
      gpointer func_data;
    } c_callback_data;
    struct {
      gpointer data;
      GtkDestroyNotify notify;
    } foreign_data;
  } d;
};
# 156 "/usr/include/gtk-1.2/gtk/gtkobject.h"
struct _GtkObjectClass
{

  GtkType type;





  guint *signals;



  guint nsignals;



  guint n_args;
  GSList *construct_args;


  void (*set_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (*get_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (* shutdown) (GtkObject *object);
  void (* destroy) (GtkObject *object);

  void (* finalize) (GtkObject *object);
};
#endif
