enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
extern __const unsigned short int *__ctype_b;
typedef unsigned char char_u;
char_u *alloc (unsigned size);
extern int atoi (__const char *__nptr) __attribute__ ((__pure__));
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
void cloneFoldGrowArray (garray_T *from, garray_T *to);
void deleteFoldRecurse (garray_T *gap);
int emsg (char_u *s);
typedef long int __off_t;
__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _blksize;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
extern int fprintf (FILE *__restrict __stream,
                    __const char *__restrict __format, ...) ;
typedef unsigned int size_t;
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
char_u *ml_get (linenr_T lnum);
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
char_u *ml_get_buf (buf_T *buf, linenr_T lnum, int will_change);
void redraw_later (int type);
void setpcmark (void);
char_u *skipwhite (char_u *p);
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
extern char *strncpy (char *__restrict __dest,
                      __const char *__restrict __src, size_t __n) ;
void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
extern int State ;
extern buf_T *curbuf ;
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
extern win_T *curwin;
extern int got_int ;
int ga_grow (garray_T *gap, int n);
void ga_init2 (garray_T *gap, int itemsize, int growsize);
extern int VIsual_active ;
extern char_u *p_sel;
void changed_lines (linenr_T lnum, colnr_T col, linenr_T lnume, long xtra);
void changed_window_setting (void);
void foldUpdate (win_T *wp, linenr_T top, linenr_T bot);
int foldmethodIsDiff (win_T *wp);
extern int diff_context ;
int u_save (linenr_T top, linenr_T bot);int hasAnyFolding (win_T *win);
int hasFolding (linenr_T lnum, linenr_T *firstp, linenr_T *lastp);
void line_breakcheck (void);
int ml_replace (linenr_T lnum, char_u *line, int copy);
void redraw_curbuf_later (int type);
extern pos_T VIsual;
void ga_clear (garray_T *gap);
int put_eol (FILE *fd);
extern char *strstr (__const char *__haystack, __const char *__needle)
             __attribute__ ((__pure__));
int put_line (FILE *fd, char *s);
extern char_u e_modifiable[] ;
int foldmethodIsManual (win_T *wp);
int foldmethodIsMarker (win_T *wp);
void closeFold (linenr_T lnum, long count);
extern char_u *p_fcl;
int diff_infold (win_T *wp, linenr_T lnum);int eval_foldexpr (char_u *arg, int *cp);
int foldmethodIsIndent (win_T *wp);
int foldmethodIsExpr (win_T *wp);
int get_indent_buf (buf_T *buf, linenr_T lnum);
int syn_get_foldlevel (win_T *wp, long lnum);
typedef struct
{
    linenr_T fd_top;
    linenr_T fd_len;
    garray_T fd_nested;
    char fd_flags;
    char fd_small;
} fold_T;
typedef struct
{
    win_T *wp;
    linenr_T lnum;
    linenr_T off;
    linenr_T lnum_save;
    int lvl;
    int lvl_next;
    int start;
    int end;
    int had_end;
} fline_T;
int find_wl_entry (win_T *win, linenr_T lnum);
typedef struct foldinfo
{
    int fi_level;
    int fi_lnum;
    int fi_low_level;
} foldinfo_T;
int hasFoldingWin (win_T *win, linenr_T lnum, linenr_T *firstp, linenr_T *lastp, int cache, foldinfo_T *infop);
long foldedCount (win_T *win, linenr_T lnum, foldinfo_T *infop);
int foldmethodIsSyntax (win_T *wp);int plines_win_nofold (win_T *wp, linenr_T lnum);
void set_vim_var_nr (int idx, long val);
static int checkCloseRec (garray_T *gap, linenr_T lnum, int level);
static int foldFind (garray_T *gap, linenr_T lnum, fold_T **fpp);
static int foldLevelWin (win_T *wp, linenr_T lnum);
static void checkupdate (win_T *wp);
static void setFoldRepeat (linenr_T lnum, long count, int open);
static linenr_T setManualFold (linenr_T lnum, int opening, int recurse, int *donep);
static void foldOpenNested (fold_T *fpr);
static void deleteFoldEntry (garray_T *gap, int idx, int recursive);
static void foldMarkAdjustRecurse (garray_T *gap, linenr_T line1, linenr_T line2, long amount, long amount_after);
static int getDeepestNestingRecurse (garray_T *gap);
static int check_closed (win_T *win, fold_T *fp, int *use_levelp, int level, int *maybe_smallp, linenr_T lnum_off);
static void checkSmall (win_T *wp, fold_T *fp, linenr_T lnum_off);
static void setSmallMaybe (garray_T *gap);
static void foldCreateMarkers (linenr_T start, linenr_T end);
static void foldAddMarker (linenr_T lnum, char_u *marker, int markerlen);
static void deleteFoldMarkers (fold_T *fp, int recursive, linenr_T lnum_off);
static void foldDelMarker (linenr_T lnum, char_u *marker, int markerlen);
static void foldUpdateIEMS (win_T *wp, linenr_T top, linenr_T bot);
static void parseMarker (win_T *wp);
static char *e_nofold = "E490: No fold found";
static linenr_T invalid_top = (linenr_T)0;
static linenr_T invalid_bot = (linenr_T)0;
static int foldstartmarkerlen;
static char_u *foldendmarker;
static int foldendmarkerlen;
    void copyFoldingState(wp_from, wp_to)
    win_T *wp_from;
    win_T *wp_to;
{
    wp_to->w_fold_manual = wp_from->w_fold_manual;
    wp_to->w_foldinvalid = wp_from->w_foldinvalid;
    cloneFoldGrowArray(&wp_from->w_folds, &wp_to->w_folds);
}
    int hasAnyFolding(win)
    win_T *win;
{
    return (win->w_onebuf_opt.wo_fen
            && (!foldmethodIsManual(win) || win->w_folds.ga_len > 0));
}
    int hasFolding(lnum, firstp, lastp)
    linenr_T lnum;
    linenr_T *firstp;
    linenr_T *lastp;
{
    return hasFoldingWin(curwin, lnum, firstp, lastp, 1, ((void *)0));
}
    int hasFoldingWin(win, lnum, firstp, lastp, cache, infop)
    win_T *win;
    linenr_T lnum;
    linenr_T *firstp;
    linenr_T *lastp;
    int cache;
    foldinfo_T *infop;
{
    int had_folded = 0;
    linenr_T first = 0;
    linenr_T last = 0;
    linenr_T lnum_rel = lnum;
    int x;
    fold_T *fp;
    int level = 0;
    int use_level = 0;
    int maybe_small = 0;
    garray_T *gap;
    int low_level = 0;;
    checkupdate(win);
    if (!hasAnyFolding(win))
    {
        if (infop != ((void *)0))
            infop->fi_level = 0;
        return 0;
    }
    if (cache)
    {
        x = find_wl_entry(win, lnum);
        if (x >= 0)
        {
            first = win->w_lines[x].wl_lnum;
            last = win->w_lines[x].wl_lastlnum;
            had_folded = win->w_lines[x].wl_folded;
        }
    }
    if (first == 0)
    {
        gap = &win->w_folds;
        for (;;)
        {
            if (!foldFind(gap, lnum_rel, &fp))
                break;
            if (lnum_rel == fp->fd_top && low_level == 0)
                low_level = level + 1;
            first += fp->fd_top;
            last += fp->fd_top;
            had_folded = check_closed(win, fp, &use_level, level,
                                               &maybe_small, lnum - lnum_rel);
            if (had_folded)
            {
                last += fp->fd_len - 1;
                break;
            }
            gap = &fp->fd_nested;
            lnum_rel -= fp->fd_top;
            ++level;
        }
    }
    if (!had_folded)
    {
        if (infop != ((void *)0))
        {
            infop->fi_level = level;
            infop->fi_lnum = lnum - lnum_rel;
            infop->fi_low_level = low_level == 0 ? level : low_level;
        }
        return 0;
    }
    if (lastp != ((void *)0))
        *lastp = last;
    if (firstp != ((void *)0))
        *firstp = first;
    if (infop != ((void *)0))
    {
        infop->fi_level = level + 1;
        infop->fi_lnum = first;
        infop->fi_low_level = low_level == 0 ? level + 1 : low_level;
    }
    return 1;
}
    int foldLevel(lnum)
    linenr_T lnum;
{
    if (invalid_top == (linenr_T)0)
        checkupdate(curwin);
    else if (lnum >= invalid_top && lnum <= invalid_bot)
        return -1;
    if (!hasAnyFolding(curwin))
        return 0;
    return foldLevelWin(curwin, lnum);
}
    int lineFolded(win, lnum)
    win_T *win;
    linenr_T lnum;
{
    return foldedCount(win, lnum, ((void *)0)) != 0;
}
    long foldedCount(win, lnum, infop)
    win_T *win;
    linenr_T lnum;
    foldinfo_T *infop;
{
    linenr_T last;
    if (hasFoldingWin(win, lnum, ((void *)0), &last, 0, infop))
        return (long)(last - lnum + 1);
    return 0;
}
    int foldmethodIsManual(wp)
    win_T *wp;
{
    return (wp->w_onebuf_opt.wo_fdm[3] == 'u');
}
    int foldmethodIsIndent(wp)
    win_T *wp;
{
    return (wp->w_onebuf_opt.wo_fdm[0] == 'i');
}
    int foldmethodIsExpr(wp)
    win_T *wp;
{
    return (wp->w_onebuf_opt.wo_fdm[1] == 'x');
}
    int foldmethodIsMarker(wp)
    win_T *wp;
{
    return (wp->w_onebuf_opt.wo_fdm[2] == 'r');
}
    int foldmethodIsSyntax(wp)
    win_T *wp;
{
    return (wp->w_onebuf_opt.wo_fdm[0] == 's');
}
    int foldmethodIsDiff(wp)
    win_T *wp;
{
    return (wp->w_onebuf_opt.wo_fdm[0] == 'd');
}
    void closeFold(lnum, count)
    linenr_T lnum;
    long count;
{
    setFoldRepeat(lnum, count, 0);
}
    void closeFoldRecurse(lnum)
    linenr_T lnum;
{
    (void)setManualFold(lnum, 0, 1, ((void *)0));
}
    void opFoldRange(first, last, opening, recurse, had_visual)
    linenr_T first;
    linenr_T last;
    int opening;
    int recurse;
    int had_visual;
{
    int done = 0;
    linenr_T lnum;
    linenr_T lnum_next;
    for (lnum = first; lnum <= last; lnum = lnum_next + 1)
    {
        lnum_next = lnum;
        if (opening && !recurse)
            (void)hasFolding(lnum, ((void *)0), &lnum_next);
        (void)setManualFold(lnum, opening, recurse, &done);
        if (!opening && !recurse)
            (void)hasFolding(lnum, ((void *)0), &lnum_next);
    }
    if (done == 0)
        emsg((char_u *)(((char *)(e_nofold))));
    if (had_visual)
        redraw_curbuf_later(20);
}
    void openFold(lnum, count)
    linenr_T lnum;
    long count;
{
    setFoldRepeat(lnum, count, 1);
}
    void openFoldRecurse(lnum)
    linenr_T lnum;
{
    (void)setManualFold(lnum, 1, 1, ((void *)0));
}
    void foldOpenCursor()
{
    int done;
    checkupdate(curwin);
    if (hasAnyFolding(curwin))
        for (;;)
        {
            done = 0;
            (void)setManualFold(curwin->w_cursor.lnum, 1, 0, &done);
            if (!(done & 1))
                break;
        }
}
    void newFoldLevel()
{
    fold_T *fp;
    int i;
    checkupdate(curwin);
    if (curwin->w_fold_manual)
    {
        fp = (fold_T *)curwin->w_folds.ga_data;
        for (i = 0; i < curwin->w_folds.ga_len; ++i)
            fp[i].fd_flags = 2;
        curwin->w_fold_manual = 0;
    }
    changed_window_setting();
}
    void foldCheckClose()
{
    if (*p_fcl != '\000')
    {
        checkupdate(curwin);
        if (checkCloseRec(&curwin->w_folds, curwin->w_cursor.lnum,
                                                        (int)curwin->w_onebuf_opt.wo_fdl))
            changed_window_setting();
    }
}
    static int checkCloseRec(gap, lnum, level)
    garray_T *gap;
    linenr_T lnum;
    int level;
{
    fold_T *fp;
    int retval = 0;
    int i;
    fp = (fold_T *)gap->ga_data;
    for (i = 0; i < gap->ga_len; ++i)
    {
        if (fp[i].fd_flags == 0)
        {
            if (level <= 0 && (lnum < fp[i].fd_top
                                      || lnum >= fp[i].fd_top + fp[i].fd_len))
            {
                fp[i].fd_flags = 2;
                retval = 1;
            }
            else
                retval |= checkCloseRec(&fp[i].fd_nested, lnum - fp[i].fd_top,
                                                                   level - 1);
        }
    }
    return retval;
}
    int foldManualAllowed(create)
    int create;
{
    if (foldmethodIsManual(curwin) || foldmethodIsMarker(curwin))
        return 1;
    if (create)
        emsg((char_u *)(((char *)("E350: Cannot create fold with current 'foldmethod'"))));
    else
        emsg((char_u *)(((char *)("E351: Cannot delete fold with current 'foldmethod'"))));
    return 0;
}
    void foldCreate(start, end)
    linenr_T start;
    linenr_T end;
{
    fold_T *fp;
    garray_T *gap;
    garray_T fold_ga;
    int i, j;
    int cont;
    int use_level = 0;
    int closed = 0;
    int level = 0;
    linenr_T start_rel = start;
    linenr_T end_rel = end;
    if (start > end)
    {
        end = start_rel;
        start = end_rel;
        start_rel = start;
        end_rel = end;
    }
    if (foldmethodIsMarker(curwin))
    {
        foldCreateMarkers(start, end);
        return;
    }
    checkupdate(curwin);
    gap = &curwin->w_folds;
    for (;;)
    {
        if (!foldFind(gap, start_rel, &fp))
            break;
        if (fp->fd_top + fp->fd_len > end_rel)
        {
            gap = &fp->fd_nested;
            start_rel -= fp->fd_top;
            end_rel -= fp->fd_top;
            if (use_level || fp->fd_flags == 2)
            {
                use_level = 1;
                if (level >= curwin->w_onebuf_opt.wo_fdl)
                    closed = 1;
            }
            else if (fp->fd_flags == 1)
                closed = 1;
            ++level;
        }
        else
        {
            break;
        }
    }
    i = (int)(fp - (fold_T *)gap->ga_data);
    if (ga_grow(gap, 1) == 1)
    {
        fp = (fold_T *)gap->ga_data + i;
        ga_init2(&fold_ga, (int)sizeof(fold_T), 10);
        for (cont = 0; i + cont < gap->ga_len; ++cont)
            if (fp[cont].fd_top > end_rel)
                break;
        if (cont > 0 && ga_grow(&fold_ga, cont) == 1)
        {
            if (start_rel > fp->fd_top)
                start_rel = fp->fd_top;
            if (end_rel < fp[cont - 1].fd_top + fp[cont - 1].fd_len - 1)
                end_rel = fp[cont - 1].fd_top + fp[cont - 1].fd_len - 1;
            memmove((char *)(fold_ga.ga_data), (char *)(fp), sizeof(fold_T) * cont);
            fold_ga.ga_len += cont;
            fold_ga.ga_room -= cont;
            i += cont;
            for (j = 0; j < cont; ++j)
                ((fold_T *)fold_ga.ga_data)[j].fd_top -= start_rel;
        }
        if (i < gap->ga_len)
            memmove((char *)(fp + 1), (char *)((fold_T *)gap->ga_data + i), sizeof(fold_T) * (gap->ga_len - i));
        gap->ga_len = gap->ga_len + 1 - cont;
        gap->ga_room = gap->ga_room - 1 + cont;
        fp->fd_nested = fold_ga;
        fp->fd_top = start_rel;
        fp->fd_len = end_rel - start_rel + 1;
        if (use_level && !closed && level < curwin->w_onebuf_opt.wo_fdl)
            closeFold(start, 1L);
        if (!use_level)
            curwin->w_fold_manual = 1;
        fp->fd_flags = 1;
        fp->fd_small = 2;
        changed_window_setting();
    }
}
    void deleteFold(start, end, recursive, had_visual)
    linenr_T start;
    linenr_T end;
    int recursive;
    int had_visual;
{
    garray_T *gap;
    fold_T *fp;
    garray_T *found_ga;
    fold_T *found_fp = ((void *)0);
    linenr_T found_off = 0;
    int use_level = 0;
    int maybe_small = 0;
    int level = 0;
    linenr_T lnum = start;
    linenr_T lnum_off;
    int did_one = 0;
    linenr_T first_lnum = (0x7fffffffL);
    linenr_T last_lnum = 0;
    checkupdate(curwin);
    while (lnum <= end)
    {
        gap = &curwin->w_folds;
        found_ga = ((void *)0);
        lnum_off = 0;
        for (;;)
        {
            if (!foldFind(gap, lnum - lnum_off, &fp))
                break;
            found_ga = gap;
            found_fp = fp;
            found_off = lnum_off;
            if (check_closed(curwin, fp, &use_level, level,
                                                      &maybe_small, lnum_off))
                break;
            gap = &fp->fd_nested;
            lnum_off += fp->fd_top;
            ++level;
        }
        if (found_ga == ((void *)0))
        {
            ++lnum;
        }
        else
        {
            lnum = found_fp->fd_top + found_fp->fd_len + found_off;
            did_one = 1;
            if (foldmethodIsManual(curwin))
                deleteFoldEntry(found_ga,
                    (int)(found_fp - (fold_T *)found_ga->ga_data), recursive);
            else
            {
                if (found_fp->fd_top + found_off < first_lnum)
                    first_lnum = found_fp->fd_top;
                if (lnum > last_lnum)
                    last_lnum = lnum;
                parseMarker(curwin);
                deleteFoldMarkers(found_fp, recursive, found_off);
            }
            changed_window_setting();
        }
    }
    if (!did_one)
    {
        emsg((char_u *)(((char *)(e_nofold))));
        if (had_visual)
            redraw_curbuf_later(20);
    }
    if (last_lnum > 0)
        changed_lines(first_lnum, (colnr_T)0, last_lnum, 0L);
}
    void clearFolding(win)
    win_T *win;
{
    deleteFoldRecurse(&win->w_folds);
    win->w_foldinvalid = 0;
}
    void foldUpdate(wp, top, bot)
    win_T *wp;
    linenr_T top;
    linenr_T bot;
{
    fold_T *fp;
    (void)foldFind(&curwin->w_folds, curwin->w_cursor.lnum, &fp);
    while (fp < (fold_T *)curwin->w_folds.ga_data + curwin->w_folds.ga_len
            && fp->fd_top < bot)
    {
        fp->fd_small = 2;
        ++fp;
    }
    if (foldmethodIsIndent(wp)
            || foldmethodIsExpr(wp)
            || foldmethodIsMarker(wp)
            || foldmethodIsDiff(wp)
            || foldmethodIsSyntax(wp))
        foldUpdateIEMS(wp, top, bot);
}
    void foldUpdateAll(win)
    win_T *win;
{
    win->w_foldinvalid = 1;
    redraw_later(40);
}
    int foldMoveTo(updown, dir, count)
    int updown;
    int dir;
    long count;
{
    long n;
    int retval = 0;
    linenr_T lnum_off;
    linenr_T lnum_found;
    linenr_T lnum;
    int use_level;
    int maybe_small;
    garray_T *gap;
    fold_T *fp;
    int level;
    int last;
    for (n = 0; n < count; ++n)
    {
        lnum_off = 0;
        gap = &curwin->w_folds;
        use_level = 0;
        maybe_small = 0;
        lnum_found = curwin->w_cursor.lnum;
        level = 0;
        last = 0;
        for (;;)
        {
            if (!foldFind(gap, curwin->w_cursor.lnum - lnum_off, &fp))
            {
                if (!updown)
                    break;
                if (dir == 1)
                {
                    if (fp - (fold_T *)gap->ga_data >= gap->ga_len)
                        break;
                    --fp;
                }
                else
                {
                    if (fp == (fold_T *)gap->ga_data)
                        break;
                }
                last = 1;
            }
            if (!last)
            {
                if (check_closed(curwin, fp, &use_level, level,
                                                      &maybe_small, lnum_off))
                    last = 1;
                if (last && !updown)
                    break;
            }
            if (updown)
            {
                if (dir == 1)
                {
                    if (fp + 1 - (fold_T *)gap->ga_data < gap->ga_len)
                    {
                        lnum = fp[1].fd_top + lnum_off;
                        if (lnum > curwin->w_cursor.lnum)
                            lnum_found = lnum;
                    }
                }
                else
                {
                    if (fp > (fold_T *)gap->ga_data)
                    {
                        lnum = fp[-1].fd_top + lnum_off + fp[-1].fd_len - 1;
                        if (lnum < curwin->w_cursor.lnum)
                            lnum_found = lnum;
                    }
                }
            }
            else
            {
                if (dir == 1)
                {
                    lnum = fp->fd_top + lnum_off + fp->fd_len - 1;
                    if (lnum > curwin->w_cursor.lnum)
                        lnum_found = lnum;
                }
                else
                {
                    lnum = fp->fd_top + lnum_off;
                    if (lnum < curwin->w_cursor.lnum)
                        lnum_found = lnum;
                }
            }
            if (last)
                break;
            gap = &fp->fd_nested;
            lnum_off += fp->fd_top;
            ++level;
        }
        if (lnum_found != curwin->w_cursor.lnum)
        {
            if (retval == 0)
                setpcmark();
            curwin->w_cursor.lnum = lnum_found;
            curwin->w_cursor.col = 0;
            retval = 1;
        }
        else
            break;
    }
    return retval;
}
    void foldInitWin(newwin)
    win_T *newwin;
{
    ga_init2(&newwin->w_folds, (int)sizeof(fold_T), 10);
}
    int find_wl_entry(win, lnum)
    win_T *win;
    linenr_T lnum;
{
    int i;
    if (win->w_lines_valid > 0)
        for (i = 0; i < win->w_lines_valid; ++i)
            if (win->w_lines[i].wl_valid)
            {
                if (lnum < win->w_lines[i].wl_lnum)
                    return -1;
                if (lnum <= win->w_lines[i].wl_lastlnum)
                    return i;
            }
    return -1;
}
    void foldAdjustVisual()
{
    pos_T *start, *end;
    char_u *ptr;
    if (!VIsual_active || !hasAnyFolding(curwin))
        return;
    if (((((VIsual).lnum != (curwin->w_cursor).lnum) ? (VIsual).lnum < (curwin->w_cursor).lnum : (VIsual).col != (curwin->w_cursor).col ? (VIsual).col < (curwin->w_cursor).col : (VIsual).coladd < (curwin->w_cursor).coladd) || (((VIsual).lnum == (curwin->w_cursor).lnum) && ((VIsual).col == (curwin->w_cursor).col) && ((VIsual).coladd == (curwin->w_cursor).coladd))))
    {
        start = &VIsual;
        end = &curwin->w_cursor;
    }
    else
    {
        start = &curwin->w_cursor;
        end = &VIsual;
    }
    if (hasFolding(start->lnum, &start->lnum, ((void *)0)))
        start->col = 0;
    if (hasFolding(end->lnum, ((void *)0), &end->lnum))
    {
        ptr = ml_get(end->lnum);
        end->col = (colnr_T)strlen((char *)(ptr));
        if (end->col > 0 && *p_sel == 'o')
            --end->col;
    }
}
    void foldAdjustCursor()
{
    (void)hasFolding(curwin->w_cursor.lnum, &curwin->w_cursor.lnum, ((void *)0));
}
    void cloneFoldGrowArray(from, to)
    garray_T *from;
    garray_T *to;
{
    int i;
    fold_T *from_p;
    fold_T *to_p;
    ga_init2(to, from->ga_itemsize, from->ga_growsize);
    if (from->ga_len == 0 || ga_grow(to, from->ga_len) == 0)
        return;
    from_p = (fold_T *)from->ga_data;
    to_p = (fold_T *)to->ga_data;
    for (i = 0; i < from->ga_len; i++)
    {
        to_p->fd_top = from_p->fd_top;
        to_p->fd_len = from_p->fd_len;
        to_p->fd_flags = from_p->fd_flags;
        to_p->fd_small = from_p->fd_small;
        cloneFoldGrowArray(&from_p->fd_nested, &to_p->fd_nested);
        ++to->ga_len;
        --to->ga_room;
        ++from_p;
        ++to_p;
    }
}
    static int foldFind(gap, lnum, fpp)
    garray_T *gap;
    linenr_T lnum;
    fold_T **fpp;
{
    linenr_T low, high;
    fold_T *fp;
    int i;
    fp = (fold_T *)gap->ga_data;
    low = 0;
    high = gap->ga_len - 1;
    while (low <= high)
    {
        i = (low + high) / 2;
        if (fp[i].fd_top > lnum)
            high = i - 1;
        else if (fp[i].fd_top + fp[i].fd_len <= lnum)
            low = i + 1;
        else
        {
            *fpp = fp + i;
            return 1;
        }
    }
    *fpp = fp + low;
    return 0;
}
    static int foldLevelWin(wp, lnum)
    win_T *wp;
    linenr_T lnum;
{
    fold_T *fp;
    linenr_T lnum_rel = lnum;
    int level = 0;
    garray_T *gap;
    gap = &wp->w_folds;
    for (;;)
    {
        if (!foldFind(gap, lnum_rel, &fp))
            break;
        gap = &fp->fd_nested;
        lnum_rel -= fp->fd_top;
        ++level;
    }
    return level;
}
    static void checkupdate(wp)
    win_T *wp;
{
    if (wp->w_foldinvalid)
    {
        foldUpdate(wp, (linenr_T)1, (linenr_T)(0x7fffffffL));
        wp->w_foldinvalid = 0;
    }
}
    static void setFoldRepeat(lnum, count, open)
    linenr_T lnum;
    long count;
    int open;
{
    int done;
    long n;
    for (n = 0; n < count; ++n)
    {
        done = 0;
        (void)setManualFold(lnum, open, 0, &done);
        if (!(done & 1))
        {
            if (n == 0 && !(done & 2))
                emsg((char_u *)(((char *)(e_nofold))));
            break;
        }
    }
}
    static linenr_T setManualFold(lnum, opening, recurse, donep)
    linenr_T lnum;
    int opening;
    int recurse;
    int *donep;
{
    fold_T *fp;
    fold_T *fp2;
    fold_T *found = ((void *)0);
    int j;
    int level = 0;
    int use_level = 0;
    int found_fold = 0;
    garray_T *gap;
    linenr_T next = (0x7fffffffL);
    linenr_T off = 0;
    int done = 0;
    checkupdate(curwin);
    gap = &curwin->w_folds;
    for (;;)
    {
        if (!foldFind(gap, lnum, &fp))
        {
            if (fp < (fold_T *)gap->ga_data + gap->ga_len)
                next = fp->fd_top + off;
            break;
        }
        found_fold = 1;
        if (fp + 1 < (fold_T *)gap->ga_data + gap->ga_len)
            next = fp[1].fd_top + off;
        if (use_level || fp->fd_flags == 2)
        {
            use_level = 1;
            if (level >= curwin->w_onebuf_opt.wo_fdl)
                fp->fd_flags = 1;
            else
                fp->fd_flags = 0;
            fp2 = (fold_T *)fp->fd_nested.ga_data;
            for (j = 0; j < fp->fd_nested.ga_len; ++j)
                fp2[j].fd_flags = 2;
        }
        if (!opening && recurse)
        {
            if (fp->fd_flags != 1)
            {
                done |= 1;
                fp->fd_flags = 1;
            }
        }
        else if (fp->fd_flags == 1)
        {
            if (opening)
            {
                fp->fd_flags = 0;
                done |= 1;
                if (recurse)
                    foldOpenNested(fp);
            }
            break;
        }
        found = fp;
        gap = &fp->fd_nested;
        lnum -= fp->fd_top;
        off += fp->fd_top;
        ++level;
    }
    if (found_fold)
    {
        if (!opening && found != ((void *)0))
        {
            found->fd_flags = 1;
            done |= 1;
        }
        curwin->w_fold_manual = 1;
        if (done & 1)
            changed_window_setting();
        done |= 2;
    }
    else if (donep == ((void *)0))
        emsg((char_u *)(((char *)(e_nofold))));
    if (donep != ((void *)0))
        *donep |= done;
    return next;
}
    static void foldOpenNested(fpr)
    fold_T *fpr;
{
    int i;
    fold_T *fp;
    fp = (fold_T *)fpr->fd_nested.ga_data;
    for (i = 0; i < fpr->fd_nested.ga_len; ++i)
    {
        foldOpenNested(&fp[i]);
        fp[i].fd_flags = 0;
    }
}
    static void deleteFoldEntry(gap, idx, recursive)
    garray_T *gap;
    int idx;
    int recursive;
{
    fold_T *fp;
    int i;
    long moved;
    fold_T *nfp;
    fp = (fold_T *)gap->ga_data + idx;
    if (recursive || fp->fd_nested.ga_len == 0)
    {
        deleteFoldRecurse(&fp->fd_nested);
        --gap->ga_len;
        ++gap->ga_room;
        if (idx < gap->ga_len)
            memmove((char *)(fp), (char *)(fp + 1), sizeof(fold_T) * (gap->ga_len - idx));
    }
    else
    {
        moved = fp->fd_nested.ga_len;
        if (ga_grow(gap, (int)(moved - 1)) == 1)
        {
            nfp = (fold_T *)fp->fd_nested.ga_data;
            for (i = 0; i < moved; ++i)
            {
                nfp[i].fd_top += fp->fd_top;
                if (fp->fd_flags == 2)
                    nfp[i].fd_flags = 2;
                if (fp->fd_small == 2)
                    nfp[i].fd_small = 2;
            }
            if (idx < gap->ga_len)
                memmove((char *)(fp + moved), (char *)(fp + 1), sizeof(fold_T) * (gap->ga_len - idx));
            memmove((char *)(fp), (char *)(nfp), (size_t)(sizeof(fold_T) * moved));
            vim_free(nfp);
            gap->ga_len += moved - 1;
            gap->ga_room -= moved - 1;
        }
    }
}
    void deleteFoldRecurse(gap)
    garray_T *gap;
{
    int i;
    for (i = 0; i < gap->ga_len; ++i)
        deleteFoldRecurse(&(((fold_T *)(gap->ga_data))[i].fd_nested));
    ga_clear(gap);
}
    void foldMarkAdjust(wp, line1, line2, amount, amount_after)
    win_T *wp;
    linenr_T line1;
    linenr_T line2;
    long amount;
    long amount_after;
{
    if (amount == (0x7fffffffL) && line2 >= line1 && line2 - line1 >= -amount_after)
        line2 = line1 - amount_after - 1;
    if ((State & 0x10) && amount == (linenr_T)1 && line2 == (0x7fffffffL))
        --line1;
    foldMarkAdjustRecurse(&wp->w_folds, line1, line2, amount, amount_after);
}
    static void foldMarkAdjustRecurse(gap, line1, line2, amount, amount_after)
    garray_T *gap;
    linenr_T line1;
    linenr_T line2;
    long amount;
    long amount_after;
{
    fold_T *fp;
    int i;
    linenr_T last;
    linenr_T top;
    if ((State & 0x10) && amount == (linenr_T)1 && line2 == (0x7fffffffL))
        top = line1 + 1;
    else
        top = line1;
    (void)foldFind(gap, line1, &fp);
    for (i = (int)(fp - (fold_T *)gap->ga_data); i < gap->ga_len; ++i, ++fp)
    {
        last = fp->fd_top + fp->fd_len - 1;
        if (last < line1)
            continue;
        if (fp->fd_top > line2)
        {
            if (amount_after == 0)
                break;
            fp->fd_top += amount_after;
        }
        else
        {
            if (fp->fd_top >= top && last <= line2)
            {
                if (amount == (0x7fffffffL))
                {
                    deleteFoldEntry(gap, i, 1);
                    --i;
                    --fp;
                }
                else
                    fp->fd_top += amount;
            }
            else
            {
                foldMarkAdjustRecurse(&fp->fd_nested, line1 - fp->fd_top,
                                  line2 - fp->fd_top, amount, amount_after);
                if (fp->fd_top < top)
                {
                    if (last <= line2)
                    {
                        if (amount == (0x7fffffffL))
                            fp->fd_len = line1 - fp->fd_top;
                        else
                            fp->fd_len += amount;
                    }
                    else
                    {
                        fp->fd_len += amount_after;
                    }
                }
                else
                {
                    if (amount == (0x7fffffffL))
                    {
                        fp->fd_len -= line2 - fp->fd_top + 1;
                        fp->fd_top = line1;
                    }
                    else
                    {
                        fp->fd_len += amount_after - amount;
                        fp->fd_top += amount;
                    }
                }
            }
        }
    }
}
    int getDeepestNesting()
{
    checkupdate(curwin);
    return getDeepestNestingRecurse(&curwin->w_folds);
}
    static int getDeepestNestingRecurse(gap)
    garray_T *gap;
{
    int i;
    int level;
    int maxlevel = 0;
    fold_T *fp;
    fp = (fold_T *)gap->ga_data;
    for (i = 0; i < gap->ga_len; ++i)
    {
        level = getDeepestNestingRecurse(&fp[i].fd_nested) + 1;
        if (level > maxlevel)
            maxlevel = level;
    }
    return maxlevel;
}
    static int check_closed(win, fp, use_levelp, level, maybe_smallp, lnum_off)
    win_T *win;
    fold_T *fp;
    int *use_levelp;
    int level;
    int *maybe_smallp;
    linenr_T lnum_off;
{
    int closed = 0;
    if (*use_levelp || fp->fd_flags == 2)
    {
        *use_levelp = 1;
        if (level >= win->w_onebuf_opt.wo_fdl)
            closed = 1;
    }
    else if (fp->fd_flags == 1)
        closed = 1;
    if (fp->fd_small == 2)
        *maybe_smallp = 1;
    if (closed)
    {
        if (*maybe_smallp)
            fp->fd_small = 2;
        checkSmall(win, fp, lnum_off);
        if (fp->fd_small == 1)
            closed = 0;
    }
    return closed;
}
    static void checkSmall(wp, fp, lnum_off)
    win_T *wp;
    fold_T *fp;
    linenr_T lnum_off;
{
    int count;
    int n;
    if (fp->fd_small == 2)
    {
        setSmallMaybe(&fp->fd_nested);
        if (fp->fd_len > curwin->w_onebuf_opt.wo_fml)
            fp->fd_small = 0;
        else
        {
            count = 0;
            for (n = 0; n < fp->fd_len; ++n)
            {
                count += plines_win_nofold(wp, fp->fd_top + lnum_off + n);
                if (count > curwin->w_onebuf_opt.wo_fml)
                {
                    fp->fd_small = 0;
                    return;
                }
            }
            fp->fd_small = 1;
        }
    }
}
    static void setSmallMaybe(gap)
    garray_T *gap;
{
    int i;
    fold_T *fp;
    fp = (fold_T *)gap->ga_data;
    for (i = 0; i < gap->ga_len; ++i)
        fp[i].fd_small = 2;
}
    static void foldCreateMarkers(start, end)
    linenr_T start;
    linenr_T end;
{
    if (!curbuf->b_p_ma)
    {
        emsg((char_u *)(((char *)(e_modifiable))));
        return;
    }
    parseMarker(curwin);
    foldAddMarker(start, curwin->w_onebuf_opt.wo_fmr, foldstartmarkerlen);
    foldAddMarker(end, foldendmarker, foldendmarkerlen);
    changed_lines(start, (colnr_T)0, end, 0L);
}
    static void foldAddMarker(lnum, marker, markerlen)
    linenr_T lnum;
    char_u *marker;
    int markerlen;
{
    char_u *cms = curbuf->b_p_cms;
    char_u *line;
    int line_len;
    char_u *newline;
    char_u *p = (char_u *)strstr((char *)curbuf->b_p_cms, "%s");
    line = ml_get(lnum);
    line_len = (int)strlen((char *)(line));
    if (u_save(lnum - 1, lnum + 1) == 1)
    {
        newline = alloc((unsigned)(line_len + markerlen + strlen((char *)(cms)) + 1));
        if (newline == ((void *)0))
            return;
        strcpy((char *)(newline), (char *)(line));
        if (p == ((void *)0))
        {
            strncpy((char *)(newline + line_len), (char *)(marker), (size_t)(markerlen));
            newline[line_len + markerlen] = '\000';
        }
        else
        {
            strcpy((char *)(newline + line_len), (char *)(cms));
            strncpy((char *)(newline + line_len + (p - cms)), (char *)(marker), (size_t)(markerlen));
            strcpy((char *)(newline + line_len + (p - cms) + markerlen), (char *)(p + 2));
        }
        ml_replace(lnum, newline, 0);
    }
}
    static void deleteFoldMarkers(fp, recursive, lnum_off)
    fold_T *fp;
    int recursive;
    linenr_T lnum_off;
{
    int i;
    if (recursive)
        for (i = 0; i < fp->fd_nested.ga_len; ++i)
            deleteFoldMarkers((fold_T *)fp->fd_nested.ga_data + i, 1,
                                                       lnum_off + fp->fd_top);
    foldDelMarker(fp->fd_top + lnum_off, curwin->w_onebuf_opt.wo_fmr, foldstartmarkerlen);
    foldDelMarker(fp->fd_top + lnum_off + fp->fd_len - 1,
                                             foldendmarker, foldendmarkerlen);
}
    static void foldDelMarker(lnum, marker, markerlen)
    linenr_T lnum;
    char_u *marker;
    int markerlen;
{
    char_u *line;
    char_u *newline;
    char_u *p;
    int len;
    char_u *cms = curbuf->b_p_cms;
    char_u *cms2;
    line = ml_get(lnum);
    for (p = line; *p != '\000'; ++p)
        if (strncmp((char *)(p), (char *)(marker), (size_t)(markerlen)) == 0)
        {
            len = markerlen;
            if ((__ctype_b[(int) ((p[len]))] & (unsigned short int) _ISdigit))
                ++len;
            if (*cms != '\000')
            {
                cms2 = (char_u *)strstr((char *)cms, "%s");
                if (p - line >= cms2 - cms
                        && strncmp((char *)(p - (cms2 - cms)), (char *)(cms), (size_t)(cms2 - cms)) == 0
                        && strncmp((char *)(p + len), (char *)(cms2 + 2), (size_t)(strlen((char *)(cms2 + 2)))) == 0)
                {
                    p -= cms2 - cms;
                    len += (int)strlen((char *)(cms)) - 2;
                }
            }
            if (u_save(lnum - 1, lnum + 1) == 1)
            {
                newline = alloc((unsigned)(strlen((char *)(line)) - len + 1));
                if (newline != ((void *)0))
                {
                    strncpy((char *)(newline), (char *)(line), (size_t)(p - line));
                    strcpy((char *)(newline + (p - line)), (char *)(p + len));
                    ml_replace(lnum, newline, 0);
                }
            }
            break;
        }
}
    void foldtext_cleanup(str)
    char_u *str;
{
    char_u *cms_start;
    int cms_slen = 0;
    char_u *cms_end;
    int cms_elen = 0;
    char_u *s;
    int len;
    int did1 = 0;
    int did2 = 0;
    cms_start = skipwhite(curbuf->b_p_cms);
    cms_slen = strlen((char *)(cms_start));
    while (cms_slen > 0 && ((cms_start[cms_slen - 1]) == ' ' || (cms_start[cms_slen - 1]) == '\t'))
        --cms_slen;
    cms_end = (char_u *)strstr((char *)cms_start, "%s");
    if (cms_end != ((void *)0))
    {
        cms_elen = cms_slen - (cms_end - cms_start);
        cms_slen = cms_end - cms_start;
        while (cms_slen > 0 && ((cms_start[cms_slen - 1]) == ' ' || (cms_start[cms_slen - 1]) == '\t'))
            --cms_slen;
        s = skipwhite(cms_end + 2);
        cms_elen -= s - cms_end;
        cms_end = s;
    }
    parseMarker(curwin);
    for (s = str; *s != '\000'; )
    {
        len = 0;
        if (strncmp((char *)(s), (char *)(curwin->w_onebuf_opt.wo_fmr), (size_t)(foldstartmarkerlen)) == 0)
        {
            len = foldstartmarkerlen;
            if ((__ctype_b[(int) ((s[len]))] & (unsigned short int) _ISdigit))
                ++len;
        }
        else if (strncmp((char *)(s), (char *)(foldendmarker), (size_t)(foldendmarkerlen)) == 0)
        {
            len = foldendmarkerlen;
            if ((__ctype_b[(int) ((s[len]))] & (unsigned short int) _ISdigit))
                ++len;
        }
        else if (cms_end != ((void *)0))
        {
            if (!did1 && strncmp((char *)(s), (char *)(cms_start), (size_t)(cms_slen)) == 0)
            {
                len = cms_slen;
                did1 = 1;
            }
            else if (!did2 && strncmp((char *)(s), (char *)(cms_end), (size_t)(cms_elen)) == 0)
            {
                len = cms_elen;
                did2 = 1;
            }
        }
        if (len != 0)
        {
            while (((s[len]) == ' ' || (s[len]) == '\t'))
                ++len;
            memmove((char *)(s), (char *)(s + len), strlen((char *)(s + len)) + 1);
        }
        else
        {
                ++s;
        }
    }
}
static int fold_changed;
static linenr_T foldUpdateIEMSRecurse (garray_T *gap, int level, linenr_T startlnum, fline_T *flp, void (*getlevel)(fline_T *), linenr_T bot, int topflags);
static int foldInsert (garray_T *gap, int i);
static void foldSplit (garray_T *gap, int i, linenr_T top, linenr_T bot);
static void foldRemove (garray_T *gap, linenr_T top, linenr_T bot);
static void foldMerge (fold_T *fp1, garray_T *gap, fold_T *fp2);
static void foldlevelIndent (fline_T *flp);
static void foldlevelDiff (fline_T *flp);
static void foldlevelExpr (fline_T *flp);
static void foldlevelMarker (fline_T *flp);
static void foldlevelSyntax (fline_T *flp);
    static void foldUpdateIEMS(wp, top, bot)
    win_T *wp;
    linenr_T top;
    linenr_T bot;
{
    linenr_T start;
    linenr_T end;
    fline_T fline;
    void (*getlevel)(fline_T *);
    int level;
    fold_T *fp;
    if (invalid_top != (linenr_T)0)
        return;
    if (wp->w_foldinvalid)
    {
        top = 1;
        bot = wp->w_buffer->b_ml.ml_line_count;
        wp->w_foldinvalid = 0;
        setSmallMaybe(&wp->w_folds);
    }
    if (foldmethodIsDiff(wp))
    {
        if (top > diff_context)
            top -= diff_context;
        else
            top = 1;
        bot += diff_context;
    }
    if (top > wp->w_buffer->b_ml.ml_line_count)
        top = wp->w_buffer->b_ml.ml_line_count;
    fold_changed = 0;
    fline.wp = wp;
    fline.off = 0;
    fline.lvl = 0;
    fline.lvl_next = -1;
    fline.start = 0;
    fline.end = 20 + 1;
    fline.had_end = 20 + 1;
    invalid_top = top;
    invalid_bot = bot;
    if (foldmethodIsMarker(wp))
    {
        getlevel = foldlevelMarker;
        parseMarker(wp);
        if (top > 1)
        {
            level = foldLevelWin(wp, top - 1);
            fline.lnum = top - 1;
            fline.lvl = level;
            getlevel(&fline);
            if (fline.lvl > level)
                fline.lvl = level - (fline.lvl - fline.lvl_next);
            else
                fline.lvl = fline.lvl_next;
        }
        fline.lnum = top;
        getlevel(&fline);
    }
    else
    {
        fline.lnum = top;
        if (foldmethodIsExpr(wp))
        {
            getlevel = foldlevelExpr;
            if (top > 1)
                --fline.lnum;
        }
        else if (foldmethodIsSyntax(wp))
            getlevel = foldlevelSyntax;
        else if (foldmethodIsDiff(wp))
            getlevel = foldlevelDiff;
        else
            getlevel = foldlevelIndent;
        fline.lvl = -1;
        for ( ; !got_int; --fline.lnum)
        {
            fline.lvl_next = -1;
            getlevel(&fline);
            if (fline.lvl >= 0)
                break;
        }
    }
    start = fline.lnum;
    end = bot;
    if (start > end && end < wp->w_buffer->b_ml.ml_line_count)
        end = start;
    while (!got_int)
    {
        if (fline.lnum > wp->w_buffer->b_ml.ml_line_count)
            break;
        if (fline.lnum > end)
        {
            if (getlevel != foldlevelMarker
                    && getlevel != foldlevelSyntax
                    && getlevel != foldlevelExpr)
                break;
            if ((start <= end
                        && foldFind(&wp->w_folds, end, &fp)
                        && fp->fd_top + fp->fd_len - 1 > end)
                    || (fline.lvl == 0
                        && foldFind(&wp->w_folds, fline.lnum, &fp)
                        && fp->fd_top < fline.lnum))
                end = fp->fd_top + fp->fd_len - 1;
            else if (getlevel == foldlevelSyntax
                    && foldLevelWin(wp, fline.lnum) != fline.lvl)
                end = fline.lnum;
            else
                break;
        }
        if (fline.lvl > 0)
        {
            invalid_top = fline.lnum;
            invalid_bot = end;
            end = foldUpdateIEMSRecurse(&wp->w_folds,
                                   1, start, &fline, getlevel, end, 2);
            start = fline.lnum;
        }
        else
        {
            if (fline.lnum == wp->w_buffer->b_ml.ml_line_count)
                break;
            ++fline.lnum;
            fline.lvl = fline.lvl_next;
            getlevel(&fline);
        }
    }
    foldRemove(&wp->w_folds, start, end);
    if (fold_changed && wp->w_onebuf_opt.wo_fen)
        changed_window_setting();
    if (end != bot)
    {
        if (wp->w_redraw_top == 0 || wp->w_redraw_top > top)
            wp->w_redraw_top = top;
        if (wp->w_redraw_bot < end)
            wp->w_redraw_bot = end;
    }
    invalid_top = (linenr_T)0;
}
    static linenr_T foldUpdateIEMSRecurse(gap, level, startlnum, flp, getlevel, bot, topflags)
    garray_T *gap;
    int level;
    linenr_T startlnum;
    fline_T *flp;
    void (*getlevel)(fline_T *);
    linenr_T bot;
    int topflags;
{
    linenr_T ll;
    fold_T *fp = ((void *)0);
    fold_T *fp2;
    int lvl = level;
    linenr_T startlnum2 = startlnum;
    linenr_T firstlnum = flp->lnum;
    int i;
    int finish = 0;
    linenr_T linecount = flp->wp->w_buffer->b_ml.ml_line_count - flp->off;
    int concat;
    if (getlevel == foldlevelMarker && flp->start <= flp->lvl - level
                                                              && flp->lvl > 0)
    {
        foldFind(gap, startlnum - 1, &fp);
        if (fp >= ((fold_T *)gap->ga_data) + gap->ga_len
                                                   || fp->fd_top >= startlnum)
            fp = ((void *)0);
    }
    flp->lnum_save = flp->lnum;
    while (!got_int)
    {
        line_breakcheck();
        lvl = flp->lvl;
        if (lvl > 20)
            lvl = 20;
        if (flp->lnum > firstlnum
                && (level > lvl - flp->start || level >= flp->had_end))
            lvl = 0;
        if (flp->lnum > bot && !finish && fp != ((void *)0))
        {
            if (getlevel != foldlevelMarker
                    && getlevel != foldlevelExpr
                    && getlevel != foldlevelSyntax)
                break;
            if (lvl == level
                    && foldFind(&fp->fd_nested, flp->lnum - fp->fd_top, &fp2))
                bot = fp2->fd_top + fp2->fd_len - 1 + fp->fd_top;
            else if (fp->fd_top + fp->fd_len <= flp->lnum && lvl >= level)
                finish = 1;
            else
                break;
        }
        if (fp == ((void *)0)
                && (lvl != level
                    || flp->lnum_save >= bot
                    || flp->start != 0
                    || flp->had_end <= 20
                    || flp->lnum == linecount))
        {
            while (!got_int)
            {
                if (flp->start != 0 || flp->had_end <= 20)
                    concat = 0;
                else
                    concat = 1;
                if (foldFind(gap, startlnum, &fp)
                        || (fp < ((fold_T *)gap->ga_data) + gap->ga_len
                            && fp->fd_top <= firstlnum)
                        || foldFind(gap, firstlnum - concat, &fp)
                        || (fp < ((fold_T *)gap->ga_data) + gap->ga_len
                            && ((lvl < level && fp->fd_top < flp->lnum)
                                || (lvl >= level
                                           && fp->fd_top <= flp->lnum_save))))
                {
                    if (fp->fd_top + fp->fd_len + concat > firstlnum)
                    {
                        if (fp->fd_top >= startlnum && fp->fd_top != firstlnum)
                        {
                            if (fp->fd_top > firstlnum)
                                foldMarkAdjustRecurse(&fp->fd_nested,
                                        (linenr_T)0, (linenr_T)(0x7fffffffL),
                                        (long)(fp->fd_top - firstlnum), 0L);
                            else
                                foldMarkAdjustRecurse(&fp->fd_nested,
                                        (linenr_T)0,
                                        (long)(firstlnum - fp->fd_top - 1),
                                        (linenr_T)(0x7fffffffL),
                                        (long)(fp->fd_top - firstlnum));
                            fp->fd_len += fp->fd_top - firstlnum;
                            fp->fd_top = firstlnum;
                            fold_changed = 1;
                        }
                        else if (flp->start != 0 && lvl == level
                                                   && fp->fd_top != firstlnum)
                        {
                            foldRemove(&fp->fd_nested, flp->lnum - fp->fd_top,
                                                      flp->lnum - fp->fd_top);
                            i = (int)(fp - (fold_T *)gap->ga_data);
                            foldSplit(gap, i, flp->lnum, flp->lnum - 1);
                            fp = (fold_T *)gap->ga_data + i + 1;
                            if (getlevel == foldlevelMarker
                                    || getlevel == foldlevelExpr
                                    || getlevel == foldlevelSyntax)
                                finish = 1;
                        }
                        break;
                    }
                    if (fp->fd_top >= startlnum)
                    {
                        deleteFoldEntry(gap,
                                     (int)(fp - (fold_T *)gap->ga_data), 1);
                    }
                    else
                    {
                        fp->fd_len = startlnum - fp->fd_top;
                        foldMarkAdjustRecurse(&fp->fd_nested,
                                (linenr_T)fp->fd_len, (linenr_T)(0x7fffffffL),
                                                       (linenr_T)(0x7fffffffL), 0L);
                        fold_changed = 1;
                    }
                }
                else
                {
                    i = (int)(fp - (fold_T *)gap->ga_data);
                    if (foldInsert(gap, i) != 1)
                        return bot;
                    fp = (fold_T *)gap->ga_data + i;
                    fp->fd_top = firstlnum;
                    fp->fd_len = bot - firstlnum + 1;
                    if (topflags == 0)
                    {
                        flp->wp->w_fold_manual = 1;
                        fp->fd_flags = 0;
                    }
                    else if (i <= 0)
                    {
                        fp->fd_flags = topflags;
                        if (topflags != 2)
                            flp->wp->w_fold_manual = 1;
                    }
                    else
                        fp->fd_flags = (fp - 1)->fd_flags;
                    fp->fd_small = 2;
                    if (getlevel == foldlevelMarker
                            || getlevel == foldlevelExpr
                            || getlevel == foldlevelSyntax)
                        finish = 1;
                    fold_changed = 1;
                    break;
                }
            }
        }
        if (lvl < level || flp->lnum > linecount)
        {
            break;
        }
        if (lvl > level)
        {
            if (bot < flp->lnum)
                bot = flp->lnum;
            flp->lnum = flp->lnum_save - fp->fd_top;
            flp->off += fp->fd_top;
            i = (int)(fp - (fold_T *)gap->ga_data);
            bot = foldUpdateIEMSRecurse(&fp->fd_nested, level + 1,
                                       startlnum2 - fp->fd_top, flp, getlevel,
                                              bot - fp->fd_top, fp->fd_flags);
            fp = (fold_T *)gap->ga_data + i;
            flp->lnum += fp->fd_top;
            flp->lnum_save += fp->fd_top;
            flp->off -= fp->fd_top;
            bot += fp->fd_top;
            startlnum2 = flp->lnum;
        }
        else
        {
            flp->lnum = flp->lnum_save;
            ll = flp->lnum + 1;
            while (!got_int)
            {
                if (++flp->lnum > linecount)
                    break;
                flp->lvl = flp->lvl_next;
                getlevel(flp);
                if (flp->lvl >= 0 || flp->had_end <= 20)
                    break;
            }
            if (flp->lnum > linecount)
                break;
            flp->lnum_save = flp->lnum;
            flp->lnum = ll;
        }
    }
    if (fp == ((void *)0))
        return bot;
    if (fp->fd_len < flp->lnum - fp->fd_top)
    {
        fp->fd_len = flp->lnum - fp->fd_top;
        fold_changed = 1;
    }
    foldRemove(&fp->fd_nested, startlnum2 - fp->fd_top,
                                                  flp->lnum - 1 - fp->fd_top);
    if (lvl < level)
    {
        if (fp->fd_len != flp->lnum - fp->fd_top)
        {
            if (fp->fd_top + fp->fd_len > bot + 1)
            {
                if (getlevel == foldlevelMarker
                        || getlevel == foldlevelExpr
                        || getlevel == foldlevelSyntax)
                {
                    bot = fp->fd_top + fp->fd_len - 1;
                    fp->fd_len = flp->lnum - fp->fd_top;
                }
                else
                {
                    i = (int)(fp - (fold_T *)gap->ga_data);
                    foldSplit(gap, i, flp->lnum, bot);
                    fp = (fold_T *)gap->ga_data + i;
                }
            }
            else
                fp->fd_len = flp->lnum - fp->fd_top;
            fold_changed = 1;
        }
    }
    for (;;)
    {
        fp2 = fp + 1;
        if (fp2 >= (fold_T *)gap->ga_data + gap->ga_len
                                                  || fp2->fd_top > flp->lnum)
            break;
        if (fp2->fd_top + fp2->fd_len > flp->lnum)
        {
            if (fp2->fd_top < flp->lnum)
            {
                foldMarkAdjustRecurse(&fp2->fd_nested,
                        (linenr_T)0, (long)(flp->lnum - fp2->fd_top - 1),
                        (linenr_T)(0x7fffffffL), (long)(fp2->fd_top - flp->lnum));
                fp2->fd_len -= flp->lnum - fp2->fd_top;
                fp2->fd_top = flp->lnum;
                fold_changed = 1;
            }
            if (lvl >= level)
            {
                foldMerge(fp, gap, fp2);
            }
            break;
        }
        fold_changed = 1;
        deleteFoldEntry(gap, (int)(fp2 - (fold_T *)gap->ga_data), 1);
    }
    if (bot < flp->lnum - 1)
        bot = flp->lnum - 1;
    return bot;
}
    static int foldInsert(gap, i)
    garray_T *gap;
    int i;
{
    fold_T *fp;
    if (ga_grow(gap, 1) != 1)
        return 0;
    fp = (fold_T *)gap->ga_data + i;
    if (i < gap->ga_len)
        memmove((char *)(fp + 1), (char *)(fp), sizeof(fold_T) * (gap->ga_len - i));
    ++gap->ga_len;
    --gap->ga_room;
    ga_init2(&fp->fd_nested, (int)sizeof(fold_T), 10);
    return 1;
}
    static void foldSplit(gap, i, top, bot)
    garray_T *gap;
    int i;
    linenr_T top;
    linenr_T bot;
{
    fold_T *fp;
    fold_T *fp2;
    garray_T *gap1;
    garray_T *gap2;
    int idx;
    int len;
    if (foldInsert(gap, i + 1) == 0)
        return;
    fp = (fold_T *)gap->ga_data + i;
    fp[1].fd_top = bot + 1;
    fp[1].fd_len = fp->fd_len - (fp[1].fd_top - fp->fd_top);
    fp[1].fd_flags = fp->fd_flags;
    gap1 = &fp->fd_nested;
    gap2 = &fp[1].fd_nested;
    (void)(foldFind(gap1, bot + 1 - fp->fd_top, &fp2));
    len = (int)((fold_T *)gap1->ga_data + gap1->ga_len - fp2);
    if (len > 0 && ga_grow(gap2, len) == 1)
    {
        for (idx = 0; idx < len; ++idx)
        {
            ((fold_T *)gap2->ga_data)[idx] = fp2[idx];
            ((fold_T *)gap2->ga_data)[idx].fd_top
                                                 -= fp[1].fd_top - fp->fd_top;
        }
        gap2->ga_len = len;
        gap2->ga_room -= len;
        gap1->ga_len -= len;
        gap1->ga_room += len;
    }
    fp->fd_len = top - fp->fd_top;
    fold_changed = 1;
}
    static void foldRemove(gap, top, bot)
    garray_T *gap;
    linenr_T top;
    linenr_T bot;
{
    fold_T *fp = ((void *)0);
    if (bot < top)
        return;
    for (;;)
    {
        if (foldFind(gap, top, &fp) && fp->fd_top < top)
        {
            foldRemove(&fp->fd_nested, top - fp->fd_top, bot - fp->fd_top);
            if (fp->fd_top + fp->fd_len > bot + 1)
            {
                foldSplit(gap, (int)(fp - (fold_T *)gap->ga_data), top, bot);
            }
            else
            {
                fp->fd_len = top - fp->fd_top;
            }
            fold_changed = 1;
            continue;
        }
        if (fp >= (fold_T *)(gap->ga_data) + gap->ga_len
                || fp->fd_top > bot)
        {
            break;
        }
        if (fp->fd_top >= top)
        {
            fold_changed = 1;
            if (fp->fd_top + fp->fd_len > bot)
            {
                foldMarkAdjustRecurse(&fp->fd_nested,
                        (linenr_T)0, (long)(bot - fp->fd_top),
                        (linenr_T)(0x7fffffffL), (long)(fp->fd_top - bot - 1));
                fp->fd_len -= bot - fp->fd_top + 1;
                fp->fd_top = bot + 1;
                break;
            }
            deleteFoldEntry(gap, (int)(fp - (fold_T *)gap->ga_data), 1);
        }
    }
}
    static void foldMerge(fp1, gap, fp2)
    fold_T *fp1;
    garray_T *gap;
    fold_T *fp2;
{
    fold_T *fp3;
    fold_T *fp4;
    int idx;
    garray_T *gap1 = &fp1->fd_nested;
    garray_T *gap2 = &fp2->fd_nested;
    if (foldFind(gap1, fp1->fd_len - 1L, &fp3) && foldFind(gap2, 0L, &fp4))
        foldMerge(fp3, gap2, fp4);
    if (gap2->ga_len > 0 && ga_grow(gap1, gap2->ga_len) == 1)
    {
        for (idx = 0; idx < gap2->ga_len; ++idx)
        {
            ((fold_T *)gap1->ga_data)[gap1->ga_len]
                                        = ((fold_T *)gap2->ga_data)[idx];
            ((fold_T *)gap1->ga_data)[gap1->ga_len].fd_top += fp1->fd_len;
            ++gap1->ga_len;
            --gap1->ga_room;
        }
        gap2->ga_len = 0;
    }
    fp1->fd_len += fp2->fd_len;
    deleteFoldEntry(gap, (int)(fp2 - (fold_T *)gap->ga_data), 1);
    fold_changed = 1;
}
    static void foldlevelIndent(flp)
    fline_T *flp;
{
    char_u *s;
    buf_T *buf;
    linenr_T lnum = flp->lnum + flp->off;
    buf = flp->wp->w_buffer;
    s = skipwhite(ml_get_buf(buf, lnum, 0));
    if (*s == '\000' || vim_strchr(flp->wp->w_onebuf_opt.wo_fdi, *s) != ((void *)0))
    {
        if (lnum == 1 || lnum == buf->b_ml.ml_line_count)
            flp->lvl = 0;
        else
            flp->lvl = -1;
    }
    else
        flp->lvl = get_indent_buf(buf, lnum) / buf->b_p_sw;
    if (flp->lvl > flp->wp->w_onebuf_opt.wo_fdn)
        flp->lvl = flp->wp->w_onebuf_opt.wo_fdn;
}
    static void foldlevelDiff(flp)
    fline_T *flp;
{
    if (diff_infold(flp->wp, flp->lnum + flp->off))
        flp->lvl = 1;
    else
        flp->lvl = 0;
}
    static void foldlevelExpr(flp)
    fline_T *flp;
{
    win_T *win;
    int n;
    int c;
    linenr_T lnum = flp->lnum + flp->off;
    win = curwin;
    curwin = flp->wp;
    curbuf = flp->wp->w_buffer;
    set_vim_var_nr(9, lnum);
    flp->start = 0;
    flp->had_end = flp->end;
    flp->end = 20 + 1;
    if (lnum <= 1)
        flp->lvl = 0;
    n = eval_foldexpr(flp->wp->w_onebuf_opt.wo_fde, &c);
    switch (c)
    {
        case 'a': if (flp->lvl >= 0)
                  {
                      flp->lvl += n;
                      flp->lvl_next = flp->lvl;
                  }
                  flp->start = n;
                  break;
        case 's': if (flp->lvl >= 0)
                  {
                      if (n > flp->lvl)
                          flp->lvl_next = 0;
                      else
                          flp->lvl_next = flp->lvl - n;
                      flp->end = flp->lvl_next + 1;
                  }
                  break;
        case '>': flp->lvl = n;
                  flp->lvl_next = n;
                  flp->start = 1;
                  break;
        case '<': flp->lvl_next = n - 1;
                  flp->end = n;
                  break;
        case '=': flp->lvl_next = flp->lvl;
                  break;
        default: if (n < 0)
                      flp->lvl_next = flp->lvl;
                  else
                      flp->lvl_next = n;
                  flp->lvl = n;
                  break;
    }
    if (flp->lvl < 0)
    {
        if (lnum <= 1)
        {
            flp->lvl = 0;
            flp->lvl_next = 0;
        }
        if (lnum == curbuf->b_ml.ml_line_count)
            flp->lvl_next = 0;
    }
    curwin = win;
    curbuf = curwin->w_buffer;
}
    static void parseMarker(wp)
    win_T *wp;
{
    foldendmarker = vim_strchr(wp->w_onebuf_opt.wo_fmr, ',');
    foldstartmarkerlen = (int)(foldendmarker++ - wp->w_onebuf_opt.wo_fmr);
    foldendmarkerlen = (int)strlen((char *)(foldendmarker));
}
    static void foldlevelMarker(flp)
    fline_T *flp;
{
    char_u *startmarker;
    int cstart;
    int cend;
    char_u *s;
    int n;
    startmarker = flp->wp->w_onebuf_opt.wo_fmr;
    cstart = *startmarker;
    ++startmarker;
    cend = *foldendmarker;
    flp->start = 0;
    flp->lvl_next = flp->lvl;
    s = ml_get_buf(flp->wp->w_buffer, flp->lnum + flp->off, 0);
    while (*s)
    {
        if (*s == cstart
                  && strncmp((char *)(s + 1), (char *)(startmarker), (size_t)(foldstartmarkerlen - 1)) == 0)
        {
            s += foldstartmarkerlen;
            if ((__ctype_b[(int) ((*s))] & (unsigned short int) _ISdigit))
            {
                n = atoi((char *)s);
                if (n > 0)
                {
                    flp->lvl = n;
                    flp->lvl_next = n;
                    ++flp->start;
                }
            }
            else
            {
                ++flp->lvl;
                ++flp->lvl_next;
                ++flp->start;
            }
        }
        else if (*s == cend
              && strncmp((char *)(s + 1), (char *)(foldendmarker + 1), (size_t)(foldendmarkerlen - 1)) == 0)
        {
            s += foldendmarkerlen;
            if ((__ctype_b[(int) ((*s))] & (unsigned short int) _ISdigit))
            {
                n = atoi((char *)s);
                if (n > 0)
                {
                    flp->lvl = n;
                    flp->lvl_next = n - 1;
                    if (flp->lvl_next > flp->lvl)
                        flp->lvl_next = flp->lvl;
                }
            }
            else
                --flp->lvl_next;
        }
        else
            ++s;
    }
    if (flp->lvl_next < 0)
        flp->lvl_next = 0;
}
    static void foldlevelSyntax(flp)
    fline_T *flp;
{
    linenr_T lnum = flp->lnum + flp->off;
    int n;
    flp->lvl = syn_get_foldlevel(flp->wp, lnum);
    flp->start = 0;
    if (lnum < flp->wp->w_buffer->b_ml.ml_line_count)
    {
        n = syn_get_foldlevel(flp->wp, lnum + 1);
        if (n > flp->lvl)
        {
            flp->start = n - flp->lvl;
            flp->lvl = n;
        }
    }
}
static int put_folds_recurse (FILE *fd, garray_T *gap, linenr_T off);
static int put_foldopen_recurse (FILE *fd, garray_T *gap, linenr_T off);
    int put_folds(fd, wp)
    FILE *fd;
    win_T *wp;
{
    if (foldmethodIsManual(wp))
    {
        if (put_line(fd, "silent! normal! zE") == 0
                || put_folds_recurse(fd, &wp->w_folds, (linenr_T)0) == 0)
            return 0;
    }
    if (wp->w_fold_manual)
        return put_foldopen_recurse(fd, &wp->w_folds, (linenr_T)0);
    return 1;
}
    static int put_folds_recurse(fd, gap, off)
    FILE *fd;
    garray_T *gap;
    linenr_T off;
{
    int i;
    fold_T *fp;
    fp = (fold_T *)gap->ga_data;
    for (i = 0; i < gap->ga_len; i++)
    {
        if (put_folds_recurse(fd, &fp->fd_nested, off + fp->fd_top) == 0)
            return 0;
        if (fprintf(fd, "%ld,%ldfold", fp->fd_top + off,
                                        fp->fd_top + off + fp->fd_len - 1) < 0
                || put_eol(fd) == 0)
            return 0;
        ++fp;
    }
    return 1;
}
    static int put_foldopen_recurse(fd, gap, off)
    FILE *fd;
    garray_T *gap;
    linenr_T off;
{
    int i;
    fold_T *fp;
    fp = (fold_T *)gap->ga_data;
    for (i = 0; i < gap->ga_len; i++)
    {
        if (fp->fd_flags != 2)
        {
            if (fp->fd_nested.ga_len > 0)
            {
                if (fprintf(fd, "%ld", fp->fd_top + off) < 0
                        || put_eol(fd) == 0
                        || put_line(fd, "normal zo") == 0)
                    return 0;
                if (put_foldopen_recurse(fd, &fp->fd_nested, off + fp->fd_top)
                        == 0)
                    return 0;
            }
            if (fprintf(fd, "%ld", fp->fd_top + off) < 0
                    || put_eol(fd) == 0
                    || fprintf(fd, "normal z%c",
                                    fp->fd_flags == 1 ? 'c' : 'o') < 0
                    || put_eol(fd) == 0)
                return 0;
        }
        ++fp;
    }
    return 1;
}
