enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
extern __const unsigned short int *__ctype_b;
typedef unsigned char char_u;
char_u *alloc (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
char_u *skipwhite (char_u *p);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
void ui_breakcheck (void);
void ui_delay (long msec, int ignoreinput);
void vim_free (void *x);
char_u *vim_strsave (char_u *string);
typedef unsigned int int_u;
extern buf_T *curbuf ;
extern int got_int ;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
extern int highlight_attr[HLF_COUNT];
extern int need_maketitle ;
extern char_u *serverName ;
int ga_grow (garray_T *gap, int n);
void ga_init2 (garray_T *gap, int itemsize, int growsize);
int hex2nr (int c);
extern int strcasecmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
int msg_attr (char_u *s, int attr);
extern int strncasecmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
char_u *eval_to_string (char_u *arg, char_u **nextcmd);
void ga_append (garray_T *gap, int c);
void ga_clear (garray_T *gap);
void ga_concat (garray_T *gap, char_u *s);
typedef struct _XDisplay Display;
Display *gui_mch_get_display (void);
typedef unsigned long XID;
typedef XID Window;
Window serverStrToWin (char_u *str);
void set_vim_var_string (int idx, char_u *val, int len);
typedef long int __time_t;
typedef __time_t time_t;
extern time_t time (time_t *__timer) ;
extern int emsg_skip ;
extern Display *xterm_dpy ;
extern Window clientWindow ;
extern int XFree(
    void*
);
extern void *memcpy (void *__restrict __dest,
                     __const void *__restrict __src, size_t __n) ;
typedef unsigned long Atom;
typedef unsigned long Time;
typedef XID Drawable;
typedef XID Colormap;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int mode;
        int detail;
} XFocusChangeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        char key_vector[32];
} XKeymapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int x, y;
        int width, height;
        int count;
} XExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int state;
} XVisibilityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        int override_redirect;
} XCreateWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
} XDestroyWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int from_configure;
} XUnmapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int override_redirect;
} XMapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
} XMapRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        Window parent;
        int x, y;
        int override_redirect;
} XReparentEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int override_redirect;
} XConfigureEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
} XGravityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int width, height;
} XResizeRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int detail;
        unsigned long value_mask;
} XConfigureRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int place;
} XCirculateEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int place;
} XCirculateRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int request;
        int first_keycode;
        int count;
} XMappingEvent;
typedef struct {
        int type;
        Display *display;
        XID resourceid;
        unsigned long serial;
        unsigned char error_code;
        unsigned char request_code;
        unsigned char minor_code;
} XErrorEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
} XAnyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int keycode;
        int same_screen;
} XKeyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int button;
        int same_screen;
} XButtonEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        char is_hint;
        int same_screen;
} XMotionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        int mode;
        int detail;
        int same_screen;
        int focus;
        unsigned int state;
} XCrossingEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int x, y;
        int width, height;
        int count;
        int major_code;
        int minor_code;
} XGraphicsExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int major_code;
        int minor_code;
} XNoExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom atom;
        Time time;
        int state;
} XPropertyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom selection;
        Time time;
} XSelectionClearEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window owner;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Colormap colormap;
        int new;
        int state;
} XColormapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom message_type;
        int format;
        union {
                char b[20];
                short s[10];
                long l[5];
                } data;
} XClientMessageEvent;
typedef union _XEvent {
        int type;
        XAnyEvent xany;
        XKeyEvent xkey;
        XButtonEvent xbutton;
        XMotionEvent xmotion;
        XCrossingEvent xcrossing;
        XFocusChangeEvent xfocus;
        XExposeEvent xexpose;
        XGraphicsExposeEvent xgraphicsexpose;
        XNoExposeEvent xnoexpose;
        XVisibilityEvent xvisibility;
        XCreateWindowEvent xcreatewindow;
        XDestroyWindowEvent xdestroywindow;
        XUnmapEvent xunmap;
        XMapEvent xmap;
        XMapRequestEvent xmaprequest;
        XReparentEvent xreparent;
        XConfigureEvent xconfigure;
        XGravityEvent xgravity;
        XResizeRequestEvent xresizerequest;
        XConfigureRequestEvent xconfigurerequest;
        XCirculateEvent xcirculate;
        XCirculateRequestEvent xcirculaterequest;
        XPropertyEvent xproperty;
        XSelectionClearEvent xselectionclear;
        XSelectionRequestEvent xselectionrequest;
        XSelectionEvent xselection;
        XColormapEvent xcolormap;
        XClientMessageEvent xclient;
        XMappingEvent xmapping;
        XErrorEvent xerror;
        XKeymapEvent xkeymap;
        long pad[24];
} XEvent;
void serverEventProc (Display *dpy, XEvent *eventPtr);
extern Window commWindow ;
extern Atom commProperty ;
typedef unsigned long VisualID;
typedef char *XPointer;
typedef struct _XGC *GC;
typedef struct _XExtData {
        int number;
        struct _XExtData *next;
        int (*free_private)(
        struct _XExtData *extension
        );
        XPointer private_data;
} XExtData;
typedef struct {
        XExtData *ext_data;
        VisualID visualid;
        int class;
        unsigned long red_mask, green_mask, blue_mask;
        int bits_per_rgb;
        int map_entries;
} Visual;
typedef struct {
        XExtData *ext_data;
        int depth;
        int bits_per_pixel;
        int scanline_pad;
} ScreenFormat;
typedef struct {
        int depth;
        int nvisuals;
        Visual *visuals;
} Depth;
typedef struct {
        XExtData *ext_data;
        struct _XDisplay *display;
        Window root;
        int width, height;
        int mwidth, mheight;
        int ndepths;
        Depth *depths;
        int root_depth;
        Visual *root_visual;
        GC default_gc;
        Colormap cmap;
        unsigned long white_pixel;
        unsigned long black_pixel;
        int max_maps, min_maps;
        int backing_store;
        int save_unders;
        long root_input_mask;
} Screen;
typedef struct
{
        XExtData *ext_data;
        struct _XPrivate *private1;
        int fd;
        int private2;
        int proto_major_version;
        int proto_minor_version;
        char *vendor;
        XID private3;
        XID private4;
        XID private5;
        int private6;
        XID (*resource_alloc)(
                struct _XDisplay*
        );
        int byte_order;
        int bitmap_unit;
        int bitmap_pad;
        int bitmap_bit_order;
        int nformats;
        ScreenFormat *pixmap_format;
        int private8;
        int release;
        struct _XPrivate *private9, *private10;
        int qlen;
        unsigned long last_request_read;
        unsigned long request;
        XPointer private11;
        XPointer private12;
        XPointer private13;
        XPointer private14;
        unsigned max_request_size;
        struct _XrmHashBucketRec *db;
        int (*private15)(
                struct _XDisplay*
                );
        char *display_name;
        int default_screen;
        int nscreens;
        Screen *screens;
        unsigned long motion_buffer;
        unsigned long private16;
        int min_keycode;
        int max_keycode;
        XPointer private17;
        XPointer private18;
        int private19;
        char *xdefaults;
}
*_XPrivDisplay;
typedef char Boolean;
typedef gint gboolean;
typedef const void *gconstpointer;
typedef void (*__gconv_trans_end_fct) (void *);
typedef int __io_close_fn (void *__cookie);
typedef gpointer (*GCacheNewFunc) (gpointer key);
typedef gpointer (*GCacheDupFunc) (gpointer value);
typedef void (*GCacheDestroyFunc) (gpointer value);
typedef gchar* (*GCompletionFunc) (gpointer);
typedef void (*GDestroyNotify) (gpointer data);
typedef guint (*GHashFunc) (gconstpointer key);
typedef void (*GFreeFunc) (gpointer data);
typedef void (*GHookFunc) (gpointer data);
typedef gboolean (*GHookCheckFunc) (gpointer data);
typedef gboolean (*GSourceFunc) (gpointer data);
typedef void (*GdkDestroyNotify) (gpointer data);
typedef void (*GtkClassInitFunc) (gpointer klass);
typedef gint (*GtkFunction) (gpointer data);
typedef void (*GtkDestroyNotify) (gpointer data);
extern Atom XInternAtom(
    Display* ,
    const char* ,
    int
);
typedef void* XtPointer;
extern Window XCreateSimpleWindow(
    Display* ,
    Window ,
    int ,
    int ,
    unsigned int ,
    unsigned int ,
    unsigned int ,
    unsigned long ,
    unsigned long
);
extern Atom *XListProperties(
    Display* ,
    Window ,
    int*
);
extern Window XDefaultRootWindow(
    Display*
);
extern int XChangeProperty(
    Display* ,
    Window ,
    Atom ,
    Atom ,
    int ,
    int ,
    const unsigned char* ,
    int
);
extern int XDeleteProperty(
    Display* ,
    Window ,
    Atom
);
extern int XEventsQueued(
    Display* ,
    int
);
extern int XGetGeometry(
    Display* ,
    Drawable ,
    Window* ,
    int* ,
    int* ,
    unsigned int* ,
    unsigned int* ,
    unsigned int* ,
    unsigned int*
);
extern int XGetWindowProperty(
    Display* ,
    Window ,
    Atom ,
    long ,
    long ,
    int ,
    Atom ,
    Atom* ,
    int* ,
    unsigned long* ,
    unsigned long* ,
    unsigned char**
);
extern int XGrabServer(
    Display*
);
extern int XNextEvent(
    Display* ,
    XEvent*
);
extern int XSelectInput(
    Display* ,
    Window ,
    long
);
extern int XUngrabServer(
    Display*
);
typedef void (*XtBlockHookProc)(
    XtPointer
);
extern char_u e_noserver[] ;
extern char_u e_invexprmsg[] ;
typedef struct PendingCommand
{
    int serial;
    int code;
    char_u *result;
    struct PendingCommand *nextPtr;
} PendingCommand;
struct ServerReply
{
    Window id;
    garray_T strings;
};
enum ServerReplyOp { SROP_Find, SROP_Add, SROP_Delete };
typedef Boolean (*XtWorkProc)(
    XtPointer
);
typedef void (*GtkSignalDestroy) (gpointer data);
typedef int (*EndCond) (void *);
extern int XFlush(
    Display*
);
typedef long int __suseconds_t;
struct timeval
  {
    __time_t tv_sec;
    __suseconds_t tv_usec;
  };
typedef long int __fd_mask;
extern __pid_t getpid (void) ;
typedef int (*XErrorHandler) (
    Display* ,
    XErrorEvent*
);
typedef struct
  {
    __fd_mask __fds_bits[1024 / (8 * sizeof (__fd_mask))];
  } fd_set;
extern XErrorHandler XSetErrorHandler (
    XErrorHandler
);
extern int select (int __nfds, fd_set *__restrict __readfds,
                   fd_set *__restrict __writefds,
                   fd_set *__restrict __exceptfds,
                   struct timeval *__restrict __timeout) ;
extern int XSync(
    Display* ,
    int
);
void server_to_input_buf (char_u *str);
extern int sscanf (__const char *__restrict __s,
                   __const char *__restrict __format, ...) ;
static PendingCommand *pendingCommands = ((void *)0);
static garray_T serverReply = { 0, 0, 0, 0, 0 };
static Window LookupName (Display *dpy, char_u *name, int delete, char_u **loose);
static int SendInit (Display *dpy);
static int DoRegisterName (Display *dpy, char_u *name);
static void DeleteAnyLingerer (Display *dpy, Window w);
static int GetRegProp (Display *dpy, char_u **regPropp, long_u *numItemsp, int domsg);
static int WaitForPend (void *p);
static int WaitForReply (void *p);
static int WindowValid (Display *dpy, Window w);
static void ServerWait (Display *dpy, Window w, EndCond endCond, void *endData, int localLoop, int seconds);
static struct ServerReply *ServerReplyFind (Window w, enum ServerReplyOp op);
static int AppendPropCarefully (Display *display, Window window, Atom property, char_u *value, int length);
static int x_error_check (Display *dpy, XErrorEvent *error_event);
static int IsSerialName (char_u *name);
static Atom registryProperty = 0L;
static Atom vimProperty = 0L;
static int got_x_error = 0;
static char_u *empty_prop = (char_u *)"";
    int serverRegisterName(dpy, name)
    Display *dpy;
    char_u *name;
{
    int i;
    int res;
    char_u *p = ((void *)0);
    res = DoRegisterName(dpy, name);
    if (res < 0)
    {
        i = 1;
        do
        {
            if (res < -1 || i >= 1000)
            {
                msg_attr((char_u *)(((char *)("Unable to register a command server name"))), (highlight_attr[(int)(HLF_W)]));
                return 0;
            }
            if (p == ((void *)0))
                p = alloc(strlen((char *)(name)) + 10);
            if (p == ((void *)0))
            {
                res = -10;
                continue;
            }
            sprintf((char *)p, "%s%d", name, i++);
            res = DoRegisterName(dpy, p);
        }
        while (res < 0)
            ;
        vim_free(p);
    }
    return 1;
}
    static int DoRegisterName(dpy, name)
    Display *dpy;
    char_u *name;
{
    Window w;
    XErrorHandler old_handler;
    char_u propInfo[100 + 20];
    if (commProperty == 0L)
    {
        if (SendInit(dpy) < 0)
            return -2;
    }
    XGrabServer(dpy);
    w = LookupName(dpy, name, 0, ((void *)0));
    if (w != (Window)0)
    {
        int status;
        int dummyInt;
        unsigned int dummyUns;
        Window dummyWin;
        old_handler = XSetErrorHandler(x_error_check);
        status = XGetGeometry(dpy, w, &dummyWin, &dummyInt, &dummyInt,
                                  &dummyUns, &dummyUns, &dummyUns, &dummyUns);
        (void)XSetErrorHandler(old_handler);
        if (status != 0 && w != commWindow)
        {
            XUngrabServer(dpy);
            XFlush(dpy);
            return -1;
        }
        (void)LookupName(dpy, name, 1, ((void *)0));
    }
    sprintf((char *)propInfo, "%x %.*s", (int_u)commWindow,
                                                       100, name);
    old_handler = XSetErrorHandler(x_error_check);
    got_x_error = 0;
    XChangeProperty(dpy, ((&((_XPrivDisplay)dpy)->screens[0])->root), registryProperty, ((Atom) 31), 8,
                    2, propInfo, strlen((char *)(propInfo)) + 1);
    XUngrabServer(dpy);
    XSync(dpy, 0);
    (void)XSetErrorHandler(old_handler);
    if (!got_x_error)
    {
        set_vim_var_string(27, name, -1);
        serverName = vim_strsave(name);
        need_maketitle = 1;
        return 0;
    }
    return -2;
}
    void serverChangeRegisteredWindow(dpy, newwin)
    Display *dpy;
    Window newwin;
{
    char_u propInfo[100 + 20];
    commWindow = newwin;
    if (SendInit(dpy) < 0)
        return;
    XGrabServer(dpy);
    DeleteAnyLingerer(dpy, newwin);
    if (serverName != ((void *)0))
    {
        (void)LookupName(dpy, serverName, 1, ((void *)0));
        sprintf((char *)propInfo, "%x %.*s",
                (int_u)newwin, 100, serverName);
        XChangeProperty(dpy, ((&((_XPrivDisplay)dpy)->screens[0])->root), registryProperty, ((Atom) 31), 8,
                        2, (char_u *)propInfo,
                        strlen((char *)(propInfo)) + 1);
    }
    XUngrabServer(dpy);
}
    int serverSendToVim(dpy, name, cmd, result, server, asExpr, localLoop, silent)
    Display *dpy;
    char_u *name;
    char_u *cmd;
    char_u **result;
    Window *server;
    int asExpr;
    int localLoop;
    int silent;
{
    Window w;
    char_u *property;
    int length;
    int res;
    static int serial = 0;
    PendingCommand pending;
    char_u *loosename = ((void *)0);
    if (result != ((void *)0))
        *result = ((void *)0);
    if (name == ((void *)0) || *name == '\000')
        name = (char_u *)"GVIM";
    if (commProperty == 0L && dpy != ((void *)0))
    {
        if (SendInit(dpy) < 0)
            return -1;
    }
    if (dpy == ((void *)0) || (serverName != ((void *)0) && strcasecmp((char *)(name), (char *)(serverName)) == 0))
    {
        if (asExpr)
        {
            char_u *ret;
            ++emsg_skip;
            ret = eval_to_string(cmd, ((void *)0));
            --emsg_skip;
            if (result != ((void *)0))
            {
                if (ret == ((void *)0))
                    *result = vim_strsave((char_u *)((char *)(e_invexprmsg)));
                else
                    *result = ret;
            }
            else
                vim_free(ret);
            return ret == ((void *)0) ? -1 : 0;
        }
        else
            server_to_input_buf(cmd);
        return 0;
    }
    while (1)
    {
        w = LookupName(dpy, name, 0, &loosename);
        if (w != 0L)
        {
            if (!WindowValid(dpy, w))
            {
                LookupName(dpy, loosename ? loosename : name,
                                      1, ((void *)0));
                continue;
            }
        }
        break;
    }
    if (w == 0L)
    {
        if (!silent)
            emsg2((char_u *)(((char *)(e_noserver))), (char_u *)(name));
        return -1;
    }
    else if (loosename != ((void *)0))
        name = loosename;
    if (server != ((void *)0))
        *server = w;
    length = strlen((char *)(name)) + strlen((char *)(cmd)) + 10;
    property = (char_u *)alloc((unsigned) length + 30);
    sprintf((char *)property, "%c%c%c-n %s%c-s %s",
                      0, asExpr ? 'c' : 'k', 0, name, 0, cmd);
    if (name == loosename)
        vim_free(loosename);
    serial++;
    sprintf((char *)property + length, "%c-r %x %d",
                                                0, (int_u)commWindow, serial);
    length += strlen((char *)(property + length + 1)) + 1;
    res = AppendPropCarefully(dpy, w, commProperty, property, length + 1);
    vim_free(property);
    if (res < 0)
    {
        emsg((char_u *)(((char *)("E248: Failed to send command to the destination program"))));
        return -1;
    }
    if (!asExpr)
        return 0;
    pending.serial = serial;
    pending.code = 0;
    pending.result = ((void *)0);
    pending.nextPtr = pendingCommands;
    pendingCommands = &pending;
    ServerWait(dpy, w, WaitForPend, &pending, localLoop, 600);
    if (pendingCommands == &pending)
        pendingCommands = pending.nextPtr;
    else
    {
        PendingCommand *pcPtr;
        for (pcPtr = pendingCommands; pcPtr != ((void *)0); pcPtr = pcPtr->nextPtr)
            if (pcPtr->nextPtr == &pending)
            {
                pcPtr->nextPtr = pending.nextPtr;
                break;
            }
    }
    if (result != ((void *)0))
        *result = pending.result;
    else
        vim_free(pending.result);
    return pending.code == 0 ? 0 : -1;
}
    static int WaitForPend(p)
    void *p;
{
    PendingCommand *pending = (PendingCommand *) p;
    return pending->result != ((void *)0);
}
    static int WindowValid(dpy, w)
    Display *dpy;
    Window w;
{
    XErrorHandler old_handler;
    Atom *plist;
    int numProp;
    int i;
    old_handler = XSetErrorHandler(x_error_check);
    got_x_error = 0;
    plist = XListProperties(dpy, w, &numProp);
    XSync(dpy, 0);
    XSetErrorHandler(old_handler);
    if (plist == ((void *)0) || got_x_error)
        return 0;
    for (i = 0; i < numProp; i++)
        if (plist[i] == vimProperty)
            return 1;
    return 0;
}
    static void ServerWait(dpy, w, endCond, endData, localLoop, seconds)
    Display *dpy;
    Window w;
    EndCond endCond;
    void *endData;
    int localLoop;
    int seconds;
{
    time_t start;
    time_t now;
    time_t lastChk = 0;
    XEvent event;
    XPropertyEvent *e = (XPropertyEvent *)&event;
    time(&start);
    while (endCond(endData) == 0)
    {
        time(&now);
        if (seconds >= 0 && (now - start) >= seconds)
            break;
        if (now != lastChk)
        {
            lastChk = now;
            if (!WindowValid(dpy, w))
                break;
            serverEventProc(dpy, ((void *)0));
        }
        if (localLoop)
        {
            fd_set fds;
            struct timeval tv;
            tv.tv_sec = 0;
            tv.tv_usec = 50 * 1000;
            do { int __d0, __d1; __asm__ __volatile__ ("cld; rep; stosl" : "=c" (__d0), "=D" (__d1) : "a" (0), "0" (sizeof (fd_set) / sizeof (__fd_mask)), "1" (&((&fds)->__fds_bits)[0]) : "memory"); } while (0);
            __asm__ __volatile__ ("btsl %1,%0" : "=m" (((&fds)->__fds_bits)[(((((_XPrivDisplay)dpy)->fd)) / (8 * sizeof (__fd_mask)))]) : "r" (((int) ((((_XPrivDisplay)dpy)->fd))) % (8 * sizeof (__fd_mask))) : "cc","memory");
            if (select((((_XPrivDisplay)dpy)->fd) + 1, &fds, ((void *)0), ((void *)0), &tv) < 0)
                break;
            while (XEventsQueued(dpy, 1) > 0)
            {
                XNextEvent(dpy, &event);
                if (event.type == 28 && e->window == commWindow)
                    serverEventProc(dpy, &event);
            }
        }
        else
        {
            if (got_int)
                break;
            ui_delay((long)50, 1);
            ui_breakcheck();
        }
    }
}
    char_u * serverGetVimNames(dpy)
    Display *dpy;
{
    char_u *regProp;
    char_u *entry;
    char_u *p;
    long_u numItems;
    int_u w;
    garray_T ga;
    if (registryProperty == 0L)
    {
        if (SendInit(dpy) < 0)
            return ((void *)0);
    }
    ga_init2(&ga, 1, 100);
    if (GetRegProp(dpy, &regProp, &numItems, 1) == 0)
        return ((void *)0);
    ga_init2(&ga, 1, 100);
    for (p = regProp; (p - regProp) < numItems; p++)
    {
        entry = p;
        while (*p != 0 && !(__ctype_b[(int) ((*p))] & (unsigned short int) _ISspace))
            p++;
        if (*p != 0)
        {
            w = 0L;
            sscanf((char *)entry, "%x", &w);
            if (WindowValid(dpy, (Window)w))
            {
                ga_concat(&ga, p + 1);
                ga_concat(&ga, (char_u *)"\n");
            }
            while (*p != 0)
                p++;
        }
    }
    if (regProp != empty_prop)
        XFree(regProp);
    return ga.ga_data;
}
    static struct ServerReply * ServerReplyFind(w, op)
    Window w;
    enum ServerReplyOp op;
{
    struct ServerReply *p;
    struct ServerReply e;
    int i;
    p = (struct ServerReply *) serverReply.ga_data;
    for (i = 0; i < serverReply.ga_len; i++, p++)
        if (p->id == w)
            break;
    if (i >= serverReply.ga_len)
        p = ((void *)0);
    if (p == ((void *)0) && op == SROP_Add)
    {
        if (serverReply.ga_growsize == 0)
            ga_init2(&serverReply, sizeof(struct ServerReply), 1);
        if (ga_grow(&serverReply, 1) == 1)
        {
            p = ((struct ServerReply *) serverReply.ga_data)
                + serverReply.ga_len;
            e.id = w;
            ga_init2(&e.strings, 1, 100);
            memcpy(p, &e, sizeof(e));
            serverReply.ga_len++;
            serverReply.ga_room--;
        }
    }
    else if (p != ((void *)0) && op == SROP_Delete)
    {
        ga_clear(&p->strings);
        memmove((char *)(p), (char *)(p + 1), (serverReply.ga_len - i - 1) * sizeof(*p));
        serverReply.ga_len--;
        serverReply.ga_room++;
    }
    return p;
}
    Window serverStrToWin(str)
    char_u *str;
{
    unsigned id = 0L;
    sscanf((char *)str, "0x%x", &id);
    if (id == 0L)
        emsg2((char_u *)(((char *)("E573: Invalid server id used: %s"))), (char_u *)(str));
    return (Window)id;
}
    int serverSendReply(name, str)
    char_u *name;
    char_u *str;
{
    char_u *property;
    int length;
    int res;
    Display *dpy = ((gui.in_use) ? gui_mch_get_display() : xterm_dpy);
    Window win = serverStrToWin(name);
    if (commProperty == 0L)
    {
        if (SendInit(dpy) < 0)
            return -2;
    }
    if (!WindowValid(dpy, win))
        return -1;
    length = strlen((char *)(str)) + 7;
    if ((property = (char_u *)alloc((unsigned) length + 30)) != ((void *)0))
    {
        sprintf((char *)property, "%c%c%c-n %s%c-w %x",
                          0, 'n', 0, str, 0, (unsigned int)commWindow);
        length += strlen((char *)(property + length));
        res = AppendPropCarefully(dpy, win, commProperty, property, length + 1);
        vim_free(property);
        return res;
    }
    return -1;
}
    static int WaitForReply(p)
    void *p;
{
    Window *w = (Window *) p;
    return ServerReplyFind(*w, SROP_Find) != ((void *)0);
}
    int serverReadReply(dpy, win, str, localLoop)
    Display *dpy;
    Window win;
    char_u **str;
    int localLoop;
{
    int len;
    char_u *s;
    struct ServerReply *p;
    ServerWait(dpy, win, WaitForReply, &win, localLoop, -1);
    if ((p = ServerReplyFind(win, SROP_Find)) != ((void *)0) && p->strings.ga_len > 0)
    {
        *str = vim_strsave(p->strings.ga_data);
        len = strlen((char *)(*str)) + 1;
        if (len < p->strings.ga_len)
        {
            s = (char_u *) p->strings.ga_data;
            memmove((char *)(s), (char *)(s + len), p->strings.ga_len - len);
            p->strings.ga_room += len;
            p->strings.ga_len -= len;
        }
        else
        {
            ga_clear(&p->strings);
            ServerReplyFind(win, SROP_Delete);
        }
        return 0;
    }
    return -1;
}
    int serverPeekReply(dpy, win, str)
    Display *dpy;
    Window win;
    char_u **str;
{
    struct ServerReply *p;
    if ((p = ServerReplyFind(win, SROP_Find)) != ((void *)0) && p->strings.ga_len > 0)
    {
        if (str != ((void *)0))
            *str = p->strings.ga_data;
        return 1;
    }
    if (!WindowValid(dpy, win))
        return -1;
    return 0;
}
    static int SendInit(dpy)
    Display *dpy;
{
    XErrorHandler old_handler;
    old_handler = XSetErrorHandler(x_error_check);
    got_x_error = 0;
    if (commProperty == 0L)
        commProperty = XInternAtom(dpy, "Comm", 0);
    if (vimProperty == 0L)
        vimProperty = XInternAtom(dpy, "Vim", 0);
    if (registryProperty == 0L)
        registryProperty = XInternAtom(dpy, "VimRegistry", 0);
    if (commWindow == 0L)
    {
        commWindow = XCreateSimpleWindow(dpy, XDefaultRootWindow(dpy),
                                getpid(), 0, 10, 10, 0,
                                ((&((_XPrivDisplay)dpy)->screens[(((_XPrivDisplay)dpy)->default_screen)])->white_pixel),
                                ((&((_XPrivDisplay)dpy)->screens[(((_XPrivDisplay)dpy)->default_screen)])->white_pixel));
        XSelectInput(dpy, commWindow, (1L<<22));
        XGrabServer(dpy);
        DeleteAnyLingerer(dpy, commWindow);
        XUngrabServer(dpy);
    }
    XChangeProperty(dpy, commWindow, vimProperty, ((Atom) 31),
                    8, 0, (char_u *)"6.2",
                        (int)strlen((char *)("6.2")) + 1);
    XSync(dpy, 0);
    (void)XSetErrorHandler(old_handler);
    return got_x_error ? -1 : 0;
}
    static Window LookupName(dpy, name, delete, loose)
    Display *dpy;
    char_u *name;
    int delete;
    char_u **loose;
{
    char_u *regProp, *entry;
    char_u *p;
    long_u numItems;
    int_u returnValue;
    if (GetRegProp(dpy, &regProp, &numItems, 0) == 0)
        return 0;
    returnValue = (int_u)0L;
    entry = ((void *)0);
    for (p = regProp; (p - regProp) < numItems; )
    {
        entry = p;
        while (*p != 0 && !(__ctype_b[(int) ((*p))] & (unsigned short int) _ISspace))
            p++;
        if (*p != 0 && strcasecmp((char *)(name), (char *)(p + 1)) == 0)
        {
            sscanf((char *)entry, "%x", &returnValue);
            break;
        }
        while (*p != 0)
            p++;
        p++;
    }
    if (loose != ((void *)0) && returnValue == (int_u)0L && !IsSerialName(name))
    {
        for (p = regProp; (p - regProp) < numItems; )
        {
            entry = p;
            while (*p != 0 && !(__ctype_b[(int) ((*p))] & (unsigned short int) _ISspace))
                p++;
            if (*p != 0 && IsSerialName(p + 1)
                    && strncasecmp((char *)(name), (char *)(p + 1), (size_t)(strlen((char *)(name)))) == 0)
            {
                sscanf((char *)entry, "%x", &returnValue);
                *loose = vim_strsave(p + 1);
                break;
            }
            while (*p != 0)
                p++;
            p++;
        }
    }
    if (delete && returnValue != (int_u)0L)
    {
        int count;
        while (*p != 0)
            p++;
        p++;
        count = numItems - (p - regProp);
        if (count > 0)
            memcpy(entry, p, count);
        XChangeProperty(dpy, ((&((_XPrivDisplay)dpy)->screens[0])->root), registryProperty, ((Atom) 31),
                        8, 0, regProp,
                        (int)(numItems - (p - entry)));
        XSync(dpy, 0);
    }
    if (regProp != empty_prop)
        XFree(regProp);
    return (Window)returnValue;
}
    static void DeleteAnyLingerer(dpy, win)
    Display *dpy;
    Window win;
{
    char_u *regProp, *entry = ((void *)0);
    char_u *p;
    long_u numItems;
    Window wwin;
    if (GetRegProp(dpy, &regProp, &numItems, 0) == 0)
        return;
    for (p = regProp; (p - regProp) < numItems; )
    {
        if (*p != 0)
        {
            sscanf((char *)p, "%x", (int_u *)&wwin);
            if (wwin == win)
            {
                int lastHalf;
                entry = p;
                while (*p != 0)
                    p++;
                p++;
                lastHalf = numItems - (p - regProp);
                if (lastHalf > 0)
                    memcpy(entry, p, lastHalf);
                numItems = (entry - regProp) + lastHalf;
                p = entry;
                continue;
            }
        }
        while (*p != 0)
            p++;
        p++;
    }
    if (entry != ((void *)0))
    {
        XChangeProperty(dpy, ((&((_XPrivDisplay)dpy)->screens[0])->root), registryProperty,
                        ((Atom) 31), 8, 0, regProp,
                        (int)(p - regProp));
        XSync(dpy, 0);
    }
    if (regProp != empty_prop)
        XFree(regProp);
}
    static int GetRegProp(dpy, regPropp, numItemsp, domsg)
    Display *dpy;
    char_u **regPropp;
    long_u *numItemsp;
    int domsg;
{
    int result, actualFormat;
    long_u bytesAfter;
    Atom actualType;
    *regPropp = ((void *)0);
    result = XGetWindowProperty(dpy, ((&((_XPrivDisplay)dpy)->screens[0])->root), registryProperty, 0L,
                                (long)100000, 0,
                                ((Atom) 31), &actualType,
                                &actualFormat, numItemsp, &bytesAfter,
                                regPropp);
    if (actualType == 0L)
    {
        *numItemsp = 0;
        *regPropp = empty_prop;
        return 1;
    }
    if (result != 0 || actualFormat != 8 || actualType != ((Atom) 31))
    {
        if (*regPropp != ((void *)0))
            XFree(*regPropp);
        XDeleteProperty(dpy, ((&((_XPrivDisplay)dpy)->screens[0])->root), registryProperty);
        if (domsg)
            emsg((char_u *)(((char *)("E251: VIM instance registry property is badly formed.  Deleted!"))));
        return 0;
    }
    return 1;
}
    void serverEventProc(dpy, eventPtr)
    Display *dpy;
    XEvent *eventPtr;
{
    char_u *propInfo;
    char_u *p;
    int result, actualFormat, code;
    long_u numItems, bytesAfter;
    Atom actualType;
    if (eventPtr != ((void *)0))
    {
        if (eventPtr->xproperty.atom != commProperty
                || eventPtr->xproperty.state != 0)
            return;
    }
    propInfo = ((void *)0);
    result = XGetWindowProperty(dpy, commWindow, commProperty, 0L,
                                (long)100000, 1,
                                ((Atom) 31), &actualType,
                                &actualFormat, &numItems, &bytesAfter,
                                &propInfo);
    if (result != 0 || actualType != ((Atom) 31) || actualFormat != 8)
    {
        if (propInfo != ((void *)0))
            XFree(propInfo);
        return;
    }
    for (p = propInfo; (p - propInfo) < numItems; )
    {
        if (*p == 0)
        {
            p++;
            continue;
        }
        if ((*p == 'c' || *p == 'k') && (p[1] == 0))
        {
            Window resWindow;
            char_u *name, *script, *serial, *end, *res;
            int asKeys = *p == 'k';
            garray_T reply;
            p += 2;
            name = ((void *)0);
            resWindow = 0L;
            serial = (char_u *)"";
            script = ((void *)0);
            while (p - propInfo < numItems && *p == '-')
            {
                switch (p[1])
                {
                    case 'r':
                        end = skipwhite(p + 2);
                        resWindow = 0;
                        while ((__ctype_b[(int) ((*end))] & (unsigned short int) _ISxdigit))
                        {
                            resWindow = 16 * resWindow + (long_u)hex2nr(*end);
                            ++end;
                        }
                        if (end == p + 2 || *end != ' ')
                            resWindow = 0L;
                        else
                        {
                            p = serial = end + 1;
                            clientWindow = resWindow;
                        }
                        break;
                    case 'n':
                        if (p[2] == ' ')
                            name = p + 3;
                        break;
                    case 's':
                        if (p[2] == ' ')
                            script = p + 3;
                        break;
                }
                while (*p != 0)
                    p++;
                p++;
            }
            if (script == ((void *)0) || name == ((void *)0))
                continue;
            if (resWindow != 0L)
            {
                ga_init2(&reply, 1, 100);
                ga_grow(&reply, 50);
                sprintf(reply.ga_data, "%cr%c-s %s%c-r ", 0, 0, serial, 0);
                reply.ga_len = 10 + strlen((char *)(serial));
                reply.ga_room -= reply.ga_len;
            }
            res = ((void *)0);
            if (serverName != ((void *)0) && strcasecmp((char *)(name), (char *)(serverName)) == 0)
            {
                if (asKeys)
                    server_to_input_buf(script);
                else
                {
                    ++emsg_skip;
                    res = eval_to_string(script, ((void *)0));
                    --emsg_skip;
                }
            }
            if (resWindow != 0L)
            {
                if (res != ((void *)0))
                    ga_concat(&reply, res);
                else if (asKeys == 0)
                {
                    ga_concat(&reply, (char_u *)((char *)(e_invexprmsg)));
                    ga_append(&reply, 0);
                    ga_concat(&reply, (char_u *)"-c 1");
                }
                ga_append(&reply, 0);
                (void)AppendPropCarefully(dpy, resWindow, commProperty,
                                           reply.ga_data, reply.ga_len);
            }
            vim_free(res);
        }
        else if (*p == 'r' && p[1] == 0)
        {
            int serial, gotSerial;
            char_u *res;
            PendingCommand *pcPtr;
            p += 2;
            gotSerial = 0;
            res = (char_u *)"";
            code = 0;
            while ((p-propInfo) < numItems && *p == '-')
            {
                switch (p[1])
                {
                    case 'r':
                        if (p[2] == ' ')
                            res = p + 3;
                        break;
                    case 's':
                        if (sscanf((char *)p + 2, " %d", &serial) == 1)
                            gotSerial = 1;
                        break;
                    case 'c':
                        if (sscanf((char *)p + 2, " %d", &code) != 1)
                            code = 0;
                        break;
                }
                while (*p != 0)
                    p++;
                p++;
            }
            if (!gotSerial)
                continue;
            for (pcPtr = pendingCommands; pcPtr != ((void *)0); pcPtr = pcPtr->nextPtr)
            {
                if (serial != pcPtr->serial || pcPtr->result != ((void *)0))
                    continue;
                pcPtr->code = code;
                if (res != ((void *)0))
                    pcPtr->result = vim_strsave(res);
                else
                    pcPtr->result = vim_strsave((char_u *)"");
                break;
            }
        }
        else if (*p == 'n' && p[1] == 0)
        {
            Window win = 0;
            unsigned int u;
            int gotWindow;
            char_u *str;
            char_u winstr[30];
            struct ServerReply *r;
            p += 2;
            gotWindow = 0;
            str = (char_u *)"";
            while ((p-propInfo) < numItems && *p == '-')
            {
                switch (p[1])
                {
                    case 'n':
                        if (p[2] == ' ')
                            str = p + 3;
                        break;
                    case 'w':
                        if (sscanf((char *)p + 2, " %x", &u) == 1)
                        {
                            win = u;
                            gotWindow = 1;
                        }
                        break;
                }
                while (*p != 0)
                    p++;
                p++;
            }
            if (!gotWindow)
                continue;
            if ((r = ServerReplyFind(win, SROP_Add)) != ((void *)0))
            {
                ga_concat(&(r->strings), str);
                ga_append(&(r->strings), 0);
            }
            sprintf((char *)winstr, "0x%x", (unsigned int)win);
            apply_autocmds(EVENT_REMOTEREPLY, winstr, str, 1, curbuf);
        }
        else
        {
            while (*p != 0)
                p++;
            p++;
        }
    }
    XFree(propInfo);
}
    static int AppendPropCarefully(dpy, window, property, value, length)
    Display *dpy;
    Window window;
    Atom property;
    char_u *value;
    int length;
{
    XErrorHandler old_handler;
    old_handler = XSetErrorHandler(x_error_check);
    got_x_error = 0;
    XChangeProperty(dpy, window, property, ((Atom) 31), 8,
                                               2, value, length);
    XSync(dpy, 0);
    (void) XSetErrorHandler(old_handler);
    return got_x_error ? -1 : 0;
}
    static int x_error_check(dpy, error_event)
    Display *dpy;
    XErrorEvent *error_event;
{
    got_x_error = 1;
    return 0;
}
    static int IsSerialName(str)
    char_u *str;
{
    int len = strlen((char *)(str));
    return (len > 1 && (__ctype_b[(int) ((str[len - 1]))] & (unsigned short int) _ISdigit));
}
