typedef unsigned int size_t;
typedef unsigned long __u_long;
typedef __u_long __ino_t;
typedef long int __time_t;
typedef long int my_wchar_t;
typedef void (*__gconv_trans_end_fct) (void *);
typedef int __io_close_fn (void *__cookie);
typedef __ino_t ino_t;
typedef __time_t time_t;
extern time_t time (time_t *__timer) ;
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
typedef unsigned char char_u;
typedef unsigned short short_u;
typedef unsigned long long_u;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
typedef long linenr_T;
typedef unsigned colnr_T;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct window win_T;
typedef struct wininfo wininfo_T;
typedef struct frame frame_T;
typedef signed char gint8;
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef short gshort;
typedef long glong;
typedef int gint;
typedef gint gboolean;
typedef unsigned char guchar;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef float gfloat;
typedef double gdouble;
typedef void* gpointer;
typedef const void *gconstpointer;
typedef struct _GData GData;
typedef struct _GHashTable GHashTable;
typedef struct _GList GList;
typedef struct _GScanner GScanner;
typedef struct _GScannerConfig GScannerConfig;
typedef struct _GSList GSList;
typedef union _GTokenValue GTokenValue;
typedef gpointer (*GCacheNewFunc) (gpointer key);
typedef gpointer (*GCacheDupFunc) (gpointer value);
typedef void (*GCacheDestroyFunc) (gpointer value);
typedef gchar* (*GCompletionFunc) (gpointer);
typedef void (*GDestroyNotify) (gpointer data);
typedef guint (*GHashFunc) (gconstpointer key);
typedef void (*GFreeFunc) (gpointer data);
typedef void (*GHookFunc) (gpointer data);
typedef gboolean (*GHookCheckFunc) (gpointer data);
typedef void (*GScannerMsgFunc) (GScanner *scanner,
                                                 gchar *message,
                                                 gint error);
typedef void (*GVoidFunc) (void);
struct _GList
{
  gpointer data;
  GList *next;
  GList *prev;
};
struct _GSList
{
  gpointer data;
  GSList *next;
};
void g_slist_free (GSList *list);
GSList* g_slist_append (GSList *list,
                                 gpointer data);
typedef enum
{
  G_TOKEN_EOF = 0,
  G_TOKEN_LEFT_PAREN = '(',
  G_TOKEN_RIGHT_PAREN = ')',
  G_TOKEN_LEFT_CURLY = '{',
  G_TOKEN_RIGHT_CURLY = '}',
  G_TOKEN_LEFT_BRACE = '[',
  G_TOKEN_RIGHT_BRACE = ']',
  G_TOKEN_EQUAL_SIGN = '=',
  G_TOKEN_COMMA = ',',
  G_TOKEN_NONE = 256,
  G_TOKEN_ERROR,
  G_TOKEN_CHAR,
  G_TOKEN_BINARY,
  G_TOKEN_OCTAL,
  G_TOKEN_INT,
  G_TOKEN_HEX,
  G_TOKEN_FLOAT,
  G_TOKEN_STRING,
  G_TOKEN_SYMBOL,
  G_TOKEN_IDENTIFIER,
  G_TOKEN_IDENTIFIER_NULL,
  G_TOKEN_COMMENT_SINGLE,
  G_TOKEN_COMMENT_MULTI,
  G_TOKEN_LAST
} GTokenType;
union _GTokenValue
{
  gpointer v_symbol;
  gchar *v_identifier;
  gulong v_binary;
  gulong v_octal;
  gulong v_int;
  gdouble v_float;
  gulong v_hex;
  gchar *v_string;
  gchar *v_comment;
  guchar v_char;
  guint v_error;
};
struct _GScannerConfig
{
  gchar *cset_skip_characters;
  gchar *cset_identifier_first;
  gchar *cset_identifier_nth;
  gchar *cpair_comment_single;
  guint case_sensitive : 1;
  guint skip_comment_multi : 1;
  guint skip_comment_single : 1;
  guint scan_comment_multi : 1;
  guint scan_identifier : 1;
  guint scan_identifier_1char : 1;
  guint scan_identifier_NULL : 1;
  guint scan_symbols : 1;
  guint scan_binary : 1;
  guint scan_octal : 1;
  guint scan_float : 1;
  guint scan_hex : 1;
  guint scan_hex_dollar : 1;
  guint scan_string_sq : 1;
  guint scan_string_dq : 1;
  guint numbers_2_int : 1;
  guint int_2_float : 1;
  guint identifier_2_string : 1;
  guint char_2_token : 1;
  guint symbol_2_token : 1;
  guint scope_0_fallback : 1;
};
struct _GScanner
{
  gpointer user_data;
  guint max_parse_errors;
  guint parse_errors;
  const gchar *input_name;
  gpointer derived_data;
  GScannerConfig *config;
  GTokenType token;
  GTokenValue value;
  guint line;
  guint position;
  GTokenType next_token;
  GTokenValue next_value;
  guint next_line;
  guint next_position;
  GHashTable *symbol_table;
  gint input_fd;
  const gchar *text;
  const gchar *text_end;
  gchar *buffer;
  guint scope_id;
  GScannerMsgFunc msg_handler;
};
typedef gboolean (*GSourceFunc) (gpointer data);
typedef gulong GdkAtom;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkPoint GdkPoint;
typedef struct _GdkRectangle GdkRectangle;
typedef struct _GdkFont GdkFont;
typedef struct _GdkCursor GdkCursor;
typedef struct _GdkDragContext GdkDragContext;
typedef struct _GdkEventAny GdkEventAny;
typedef struct _GdkEventExpose GdkEventExpose;
typedef struct _GdkEventNoExpose GdkEventNoExpose;
typedef struct _GdkEventVisibility GdkEventVisibility;
typedef struct _GdkEventMotion GdkEventMotion;
typedef struct _GdkEventButton GdkEventButton;
typedef struct _GdkEventKey GdkEventKey;
typedef struct _GdkEventFocus GdkEventFocus;
typedef struct _GdkEventCrossing GdkEventCrossing;
typedef struct _GdkEventConfigure GdkEventConfigure;
typedef struct _GdkEventProperty GdkEventProperty;
typedef struct _GdkEventSelection GdkEventSelection;
typedef struct _GdkEventProximity GdkEventProximity;
typedef struct _GdkEventClient GdkEventClient;
typedef struct _GdkEventDND GdkEventDND;
typedef union _GdkEvent GdkEvent;
typedef struct _GdkIC GdkIC;
typedef struct _GdkICAttr GdkICAttr;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef enum {
  GDK_VISIBILITY_UNOBSCURED,
  GDK_VISIBILITY_PARTIAL,
  GDK_VISIBILITY_FULLY_OBSCURED
} GdkVisibilityState;
typedef enum
{
  GDK_NOTHING = -1,
  GDK_DELETE = 0,
  GDK_DESTROY = 1,
  GDK_EXPOSE = 2,
  GDK_MOTION_NOTIFY = 3,
  GDK_BUTTON_PRESS = 4,
  GDK_2BUTTON_PRESS = 5,
  GDK_3BUTTON_PRESS = 6,
  GDK_BUTTON_RELEASE = 7,
  GDK_KEY_PRESS = 8,
  GDK_KEY_RELEASE = 9,
  GDK_ENTER_NOTIFY = 10,
  GDK_LEAVE_NOTIFY = 11,
  GDK_FOCUS_CHANGE = 12,
  GDK_CONFIGURE = 13,
  GDK_MAP = 14,
  GDK_UNMAP = 15,
  GDK_PROPERTY_NOTIFY = 16,
  GDK_SELECTION_CLEAR = 17,
  GDK_SELECTION_REQUEST = 18,
  GDK_SELECTION_NOTIFY = 19,
  GDK_PROXIMITY_IN = 20,
  GDK_PROXIMITY_OUT = 21,
  GDK_DRAG_ENTER = 22,
  GDK_DRAG_LEAVE = 23,
  GDK_DRAG_MOTION = 24,
  GDK_DRAG_STATUS = 25,
  GDK_DROP_START = 26,
  GDK_DROP_FINISHED = 27,
  GDK_CLIENT_EVENT = 28,
  GDK_VISIBILITY_NOTIFY = 29,
  GDK_NO_EXPOSE = 30
} GdkEventType;
typedef enum
{
  GDK_EXPOSURE_MASK = 1 << 1,
  GDK_POINTER_MOTION_MASK = 1 << 2,
  GDK_POINTER_MOTION_HINT_MASK = 1 << 3,
  GDK_BUTTON_MOTION_MASK = 1 << 4,
  GDK_BUTTON1_MOTION_MASK = 1 << 5,
  GDK_BUTTON2_MOTION_MASK = 1 << 6,
  GDK_BUTTON3_MOTION_MASK = 1 << 7,
  GDK_BUTTON_PRESS_MASK = 1 << 8,
  GDK_BUTTON_RELEASE_MASK = 1 << 9,
  GDK_KEY_PRESS_MASK = 1 << 10,
  GDK_KEY_RELEASE_MASK = 1 << 11,
  GDK_ENTER_NOTIFY_MASK = 1 << 12,
  GDK_LEAVE_NOTIFY_MASK = 1 << 13,
  GDK_FOCUS_CHANGE_MASK = 1 << 14,
  GDK_STRUCTURE_MASK = 1 << 15,
  GDK_PROPERTY_CHANGE_MASK = 1 << 16,
  GDK_VISIBILITY_NOTIFY_MASK = 1 << 17,
  GDK_PROXIMITY_IN_MASK = 1 << 18,
  GDK_PROXIMITY_OUT_MASK = 1 << 19,
  GDK_SUBSTRUCTURE_MASK = 1 << 20,
  GDK_ALL_EVENTS_MASK = 0x0FFFFF
} GdkEventMask;
typedef enum
{
  GDK_NOTIFY_ANCESTOR = 0,
  GDK_NOTIFY_VIRTUAL = 1,
  GDK_NOTIFY_INFERIOR = 2,
  GDK_NOTIFY_NONLINEAR = 3,
  GDK_NOTIFY_NONLINEAR_VIRTUAL = 4,
  GDK_NOTIFY_UNKNOWN = 5
} GdkNotifyType;
typedef enum
{
  GDK_CROSSING_NORMAL,
  GDK_CROSSING_GRAB,
  GDK_CROSSING_UNGRAB
} GdkCrossingMode;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef enum
{
  GDK_SOURCE_MOUSE,
  GDK_SOURCE_PEN,
  GDK_SOURCE_ERASER,
  GDK_SOURCE_CURSOR
} GdkInputSource;
typedef enum
{
  GDK_IM_PREEDIT_AREA = 0x0001,
  GDK_IM_PREEDIT_CALLBACKS = 0x0002,
  GDK_IM_PREEDIT_POSITION = 0x0004,
  GDK_IM_PREEDIT_NOTHING = 0x0008,
  GDK_IM_PREEDIT_NONE = 0x0010,
  GDK_IM_PREEDIT_MASK = 0x001f,
  GDK_IM_STATUS_AREA = 0x0100,
  GDK_IM_STATUS_CALLBACKS = 0x0200,
  GDK_IM_STATUS_NOTHING = 0x0400,
  GDK_IM_STATUS_NONE = 0x0800,
  GDK_IM_STATUS_MASK = 0x0f00
} GdkIMStyle;
typedef enum
{
  GDK_IC_STYLE = 1 << 0,
  GDK_IC_CLIENT_WINDOW = 1 << 1,
  GDK_IC_FOCUS_WINDOW = 1 << 2,
  GDK_IC_FILTER_EVENTS = 1 << 3,
  GDK_IC_SPOT_LOCATION = 1 << 4,
  GDK_IC_LINE_SPACING = 1 << 5,
  GDK_IC_CURSOR = 1 << 6,
  GDK_IC_PREEDIT_FONTSET = 1 << 10,
  GDK_IC_PREEDIT_AREA = 1 << 11,
  GDK_IC_PREEDIT_AREA_NEEDED = 1 << 12,
  GDK_IC_PREEDIT_FOREGROUND = 1 << 13,
  GDK_IC_PREEDIT_BACKGROUND = 1 << 14,
  GDK_IC_PREEDIT_PIXMAP = 1 << 15,
  GDK_IC_PREEDIT_COLORMAP = 1 << 16,
  GDK_IC_STATUS_FONTSET = 1 << 21,
  GDK_IC_STATUS_AREA = 1 << 22,
  GDK_IC_STATUS_AREA_NEEDED = 1 << 23,
  GDK_IC_STATUS_FOREGROUND = 1 << 24,
  GDK_IC_STATUS_BACKGROUND = 1 << 25,
  GDK_IC_STATUS_PIXMAP = 1 << 26,
  GDK_IC_STATUS_COLORMAP = 1 << 27,
  GDK_IC_ALL_REQ = GDK_IC_STYLE |
                                  GDK_IC_CLIENT_WINDOW,
  GDK_IC_PREEDIT_AREA_REQ = GDK_IC_PREEDIT_AREA |
                                  GDK_IC_PREEDIT_FONTSET,
  GDK_IC_PREEDIT_POSITION_REQ = GDK_IC_PREEDIT_AREA | GDK_IC_SPOT_LOCATION |
                                  GDK_IC_PREEDIT_FONTSET,
  GDK_IC_STATUS_AREA_REQ = GDK_IC_STATUS_AREA |
                                  GDK_IC_STATUS_FONTSET
} GdkICAttributesType;
typedef void (*GdkDestroyNotify) (gpointer data);
typedef enum {
  GDK_ACTION_DEFAULT = 1 << 0,
  GDK_ACTION_COPY = 1 << 1,
  GDK_ACTION_MOVE = 1 << 2,
  GDK_ACTION_LINK = 1 << 3,
  GDK_ACTION_PRIVATE = 1 << 4,
  GDK_ACTION_ASK = 1 << 5
} GdkDragAction;
typedef enum {
  GDK_DRAG_PROTO_MOTIF,
  GDK_DRAG_PROTO_XDND,
  GDK_DRAG_PROTO_ROOTWIN,
  GDK_DRAG_PROTO_NONE
} GdkDragProtocol;
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkPoint
{
  gint16 x;
  gint16 y;
};
struct _GdkRectangle
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GdkCursor
{
  GdkCursorType type;
};
struct _GdkDragContext {
  GdkDragProtocol protocol;
  gboolean is_source;
  GdkWindow *source_window;
  GdkWindow *dest_window;
  GList *targets;
  GdkDragAction actions;
  GdkDragAction suggested_action;
  GdkDragAction action;
  guint32 start_time;
};
struct _GdkEventAny
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
};
struct _GdkEventExpose
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkRectangle area;
  gint count;
};
struct _GdkEventNoExpose
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
};
struct _GdkEventVisibility
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkVisibilityState state;
};
struct _GdkEventMotion
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble pressure;
  gdouble xtilt;
  gdouble ytilt;
  guint state;
  gint16 is_hint;
  GdkInputSource source;
  guint32 deviceid;
  gdouble x_root, y_root;
};
struct _GdkEventButton
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble pressure;
  gdouble xtilt;
  gdouble ytilt;
  guint state;
  guint button;
  GdkInputSource source;
  guint32 deviceid;
  gdouble x_root, y_root;
};
struct _GdkEventKey
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  guint state;
  guint keyval;
  gint length;
  gchar *string;
};
struct _GdkEventCrossing
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkWindow *subwindow;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble x_root;
  gdouble y_root;
  GdkCrossingMode mode;
  GdkNotifyType detail;
  gboolean focus;
  guint state;
};
struct _GdkEventFocus
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  gint16 in;
};
struct _GdkEventConfigure
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  gint16 x, y;
  gint16 width;
  gint16 height;
};
struct _GdkEventProperty
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom atom;
  guint32 time;
  guint state;
};
struct _GdkEventSelection
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom selection;
  GdkAtom target;
  GdkAtom property;
  guint32 requestor;
  guint32 time;
};
struct _GdkEventProximity
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  GdkInputSource source;
  guint32 deviceid;
};
struct _GdkEventClient
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom message_type;
  gushort data_format;
  union {
    char b[20];
    short s[10];
    long l[5];
  } data;
};
struct _GdkEventDND {
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkDragContext *context;
  guint32 time;
  gshort x_root, y_root;
};
union _GdkEvent
{
  GdkEventType type;
  GdkEventAny any;
  GdkEventExpose expose;
  GdkEventNoExpose no_expose;
  GdkEventVisibility visibility;
  GdkEventMotion motion;
  GdkEventButton button;
  GdkEventKey key;
  GdkEventCrossing crossing;
  GdkEventFocus focus_change;
  GdkEventConfigure configure;
  GdkEventProperty property;
  GdkEventSelection selection;
  GdkEventProximity proximity;
  GdkEventClient client;
  GdkEventDND dnd;
};
struct _GdkICAttr
{
  GdkIMStyle style;
  GdkWindow *client_window;
  GdkWindow *focus_window;
  GdkEventMask filter_events;
  GdkPoint spot_location;
  gint line_spacing;
  GdkCursor *cursor;
  GdkFont *preedit_fontset;
  GdkRectangle preedit_area;
  GdkRectangle preedit_area_needed;
  GdkColor preedit_foreground;
  GdkColor preedit_background;
  GdkPixmap *preedit_pixmap;
  GdkColormap *preedit_colormap;
  GdkFont *status_fontset;
  GdkRectangle status_area;
  GdkRectangle status_area_needed;
  GdkColor status_foreground;
  GdkColor status_background;
  GdkPixmap *status_pixmap;
  GdkColormap *status_colormap;
};
GdkEvent* gdk_event_copy (GdkEvent *event);
void gdk_event_free (GdkEvent *event);
GdkEventMask gdk_window_get_events (GdkWindow *window);
void gdk_window_set_events (GdkWindow *window,
                                          GdkEventMask event_mask);
gboolean gdk_im_ready (void);
void gdk_im_begin (GdkIC *ic,
                                    GdkWindow *window);
void gdk_im_end (void);
GdkIMStyle gdk_im_decide_style (GdkIMStyle supported_style);
GdkIC* gdk_ic_new (GdkICAttr *attr,
                                    GdkICAttributesType mask);
void gdk_ic_destroy (GdkIC *ic);
GdkEventMask gdk_ic_get_events (GdkIC *ic);
GdkICAttr* gdk_ic_attr_new (void);
GdkICAttributesType gdk_ic_set_attr (GdkIC *ic,
                                      GdkICAttr *attr,
                                      GdkICAttributesType mask);
typedef guint GtkType;
typedef struct _GtkArg GtkArg;
typedef struct _GtkObject GtkObject;
typedef void (*GtkClassInitFunc) (gpointer klass);
typedef void (*GtkSignalFunc) ();
typedef gint (*GtkFunction) (gpointer data);
typedef void (*GtkDestroyNotify) (gpointer data);
typedef void (*GtkCallbackMarshal) (GtkObject *object,
                                    gpointer data,
                                    guint n_args,
                                    GtkArg *args);
struct _GtkArg
{
  GtkType type;
  gchar *name;
  union {
    gchar char_data;
    guchar uchar_data;
    gboolean bool_data;
    gint int_data;
    guint uint_data;
    glong long_data;
    gulong ulong_data;
    gfloat float_data;
    gdouble double_data;
    gchar *string_data;
    gpointer pointer_data;
    GtkObject *object_data;
    struct {
      GtkSignalFunc f;
      gpointer d;
    } signal_data;
    struct {
      gint n_args;
      GtkArg *args;
    } args_data;
    struct {
      GtkCallbackMarshal marshal;
      gpointer data;
      GtkDestroyNotify notify;
    } callback_data;
    struct {
      GtkFunction func;
      gpointer func_data;
    } c_callback_data;
    struct {
      gpointer data;
      GtkDestroyNotify notify;
    } foreign_data;
  } d;
};
typedef enum
{
  GTK_ARROW_UP,
  GTK_ARROW_DOWN,
  GTK_ARROW_LEFT,
  GTK_ARROW_RIGHT
} GtkArrowType;
typedef enum
{
  GTK_ORIENTATION_HORIZONTAL,
  GTK_ORIENTATION_VERTICAL
} GtkOrientation;
typedef enum
{
  GTK_POS_LEFT,
  GTK_POS_RIGHT,
  GTK_POS_TOP,
  GTK_POS_BOTTOM
} GtkPositionType;
typedef enum
{
  GTK_SHADOW_NONE,
  GTK_SHADOW_IN,
  GTK_SHADOW_OUT,
  GTK_SHADOW_ETCHED_IN,
  GTK_SHADOW_ETCHED_OUT
} GtkShadowType;
typedef enum
{
  GTK_STATE_NORMAL,
  GTK_STATE_ACTIVE,
  GTK_STATE_PRELIGHT,
  GTK_STATE_SELECTED,
  GTK_STATE_INSENSITIVE
} GtkStateType;
typedef struct _GtkObjectClass GtkObjectClass;
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkObjectClass
{
  GtkType type;
  guint *signals;
  guint nsignals;
  guint n_args;
  GSList *construct_args;
  void (*set_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (*get_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (* shutdown) (GtkObject *object);
  void (* destroy) (GtkObject *object);
  void (* finalize) (GtkObject *object);
};
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkStyleClass
{
  gint xthickness;
  gint ythickness;
  void (*draw_hline) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x1,
                                 gint x2,
                                 gint y);
  void (*draw_vline) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint y1,
                                 gint y2,
                                 gint x);
  void (*draw_shadow) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_polygon) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 GdkPoint *point,
                                 gint npoints,
                                 gboolean fill);
  void (*draw_arrow) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 GtkArrowType arrow_type,
                                 gboolean fill,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_diamond) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_oval) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_string) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 const gchar *string);
  void (*draw_box) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_flat_box) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_check) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_option) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_cross) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_ramp) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 GtkArrowType arrow_type,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_tab) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_shadow_gap) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkPositionType gap_side,
                                 gint gap_x,
                                 gint gap_width);
  void (*draw_box_gap) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkPositionType gap_side,
                                 gint gap_x,
                                 gint gap_width);
  void (*draw_extension) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkPositionType gap_side);
  void (*draw_focus) (GtkStyle *style,
                                 GdkWindow *window,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_slider) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkOrientation orientation);
  void (*draw_handle) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkOrientation orientation);
};
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
GdkColormap* gtk_widget_get_colormap (GtkWidget *widget);
GdkColormap* gtk_widget_get_default_colormap (void);
typedef unsigned long XID;
typedef unsigned long Atom;
typedef unsigned long VisualID;
typedef unsigned long Time;
typedef XID Window;
typedef XID Drawable;
typedef XID Colormap;
typedef XID KeySym;
typedef unsigned char KeyCode;
typedef char *XPointer;
typedef struct _XExtData {
        int number;
        struct _XExtData *next;
        int (*free_private)(
        struct _XExtData *extension
        );
        XPointer private_data;
} XExtData;
typedef struct _XGC *GC;
typedef struct {
        XExtData *ext_data;
        VisualID visualid;
        int class;
        unsigned long red_mask, green_mask, blue_mask;
        int bits_per_rgb;
        int map_entries;
} Visual;
typedef struct {
        int depth;
        int nvisuals;
        Visual *visuals;
} Depth;
typedef struct {
        XExtData *ext_data;
        struct _XDisplay *display;
        Window root;
        int width, height;
        int mwidth, mheight;
        int ndepths;
        Depth *depths;
        int root_depth;
        Visual *root_visual;
        GC default_gc;
        Colormap cmap;
        unsigned long white_pixel;
        unsigned long black_pixel;
        int max_maps, min_maps;
        int backing_store;
        int save_unders;
        long root_input_mask;
} Screen;
typedef struct {
        XExtData *ext_data;
        int depth;
        int bits_per_pixel;
        int scanline_pad;
} ScreenFormat;
typedef struct _XDisplay Display;
typedef struct
{
        XExtData *ext_data;
        struct _XPrivate *private1;
        int fd;
        int private2;
        int proto_major_version;
        int proto_minor_version;
        char *vendor;
        XID private3;
        XID private4;
        XID private5;
        int private6;
        XID (*resource_alloc)(
                struct _XDisplay*
        );
        int byte_order;
        int bitmap_unit;
        int bitmap_pad;
        int bitmap_bit_order;
        int nformats;
        ScreenFormat *pixmap_format;
        int private8;
        int release;
        struct _XPrivate *private9, *private10;
        int qlen;
        unsigned long last_request_read;
        unsigned long request;
        XPointer private11;
        XPointer private12;
        XPointer private13;
        XPointer private14;
        unsigned max_request_size;
        struct _XrmHashBucketRec *db;
        int (*private15)(
                struct _XDisplay*
                );
        char *display_name;
        int default_screen;
        int nscreens;
        Screen *screens;
        unsigned long motion_buffer;
        unsigned long private16;
        int min_keycode;
        int max_keycode;
        XPointer private17;
        XPointer private18;
        int private19;
        char *xdefaults;
}
*_XPrivDisplay;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int keycode;
        int same_screen;
} XKeyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int button;
        int same_screen;
} XButtonEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        char is_hint;
        int same_screen;
} XMotionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        int mode;
        int detail;
        int same_screen;
        int focus;
        unsigned int state;
} XCrossingEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int mode;
        int detail;
} XFocusChangeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        char key_vector[32];
} XKeymapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int x, y;
        int width, height;
        int count;
} XExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int x, y;
        int width, height;
        int count;
        int major_code;
        int minor_code;
} XGraphicsExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int major_code;
        int minor_code;
} XNoExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int state;
} XVisibilityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        int override_redirect;
} XCreateWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
} XDestroyWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int from_configure;
} XUnmapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int override_redirect;
} XMapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
} XMapRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        Window parent;
        int x, y;
        int override_redirect;
} XReparentEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int override_redirect;
} XConfigureEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
} XGravityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int width, height;
} XResizeRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int detail;
        unsigned long value_mask;
} XConfigureRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int place;
} XCirculateEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int place;
} XCirculateRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom atom;
        Time time;
        int state;
} XPropertyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom selection;
        Time time;
} XSelectionClearEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window owner;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Colormap colormap;
        int new;
        int state;
} XColormapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom message_type;
        int format;
        union {
                char b[20];
                short s[10];
                long l[5];
                } data;
} XClientMessageEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int request;
        int first_keycode;
        int count;
} XMappingEvent;
typedef struct {
        int type;
        Display *display;
        XID resourceid;
        unsigned long serial;
        unsigned char error_code;
        unsigned char request_code;
        unsigned char minor_code;
} XErrorEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
} XAnyEvent;
typedef union _XEvent {
        int type;
        XAnyEvent xany;
        XKeyEvent xkey;
        XButtonEvent xbutton;
        XMotionEvent xmotion;
        XCrossingEvent xcrossing;
        XFocusChangeEvent xfocus;
        XExposeEvent xexpose;
        XGraphicsExposeEvent xgraphicsexpose;
        XNoExposeEvent xnoexpose;
        XVisibilityEvent xvisibility;
        XCreateWindowEvent xcreatewindow;
        XDestroyWindowEvent xdestroywindow;
        XUnmapEvent xunmap;
        XMapEvent xmap;
        XMapRequestEvent xmaprequest;
        XReparentEvent xreparent;
        XConfigureEvent xconfigure;
        XGravityEvent xgravity;
        XResizeRequestEvent xresizerequest;
        XConfigureRequestEvent xconfigurerequest;
        XCirculateEvent xcirculate;
        XCirculateRequestEvent xcirculaterequest;
        XPropertyEvent xproperty;
        XSelectionClearEvent xselectionclear;
        XSelectionRequestEvent xselectionrequest;
        XSelectionEvent xselection;
        XColormapEvent xcolormap;
        XClientMessageEvent xclient;
        XMappingEvent xmapping;
        XErrorEvent xerror;
        XKeymapEvent xkeymap;
        long pad[24];
} XEvent;
typedef struct _XIM *XIM;
typedef struct _XIC *XIC;
typedef void (*XIMProc)(
    XIM,
    XPointer,
    XPointer
);
typedef void *XVaNestedList;
typedef struct {
    XPointer client_data;
    XIMProc callback;
} XIMCallback;
typedef unsigned long XIMFeedback;
typedef struct _XIMText {
    unsigned short length;
    XIMFeedback *feedback;
    int encoding_is_wchar;
    union {
        char *multi_byte;
        my_wchar_t *wide_char;
    } string;
} XIMText;
typedef unsigned long XIMPreeditState;
typedef struct _XIMPreeditDrawCallbackStruct {
    int caret;
    int chg_first;
    int chg_length;
    XIMText *text;
} XIMPreeditDrawCallbackStruct;
extern KeySym XStringToKeysym(
    const char*
);
extern int XFree(
    void*
);
extern KeyCode XKeysymToKeycode(
    Display* ,
    KeySym
);
extern int XSendEvent(
    Display* ,
    Window ,
    int ,
    long ,
    XEvent*
);
extern char *XmbResetIC(
    XIC
);
extern char *XSetICValues(
    XIC , ...
);
extern char *XGetICValues(
    XIC , ...
);
extern XVaNestedList XVaCreateNestedList(
    int , ...
);
typedef struct _XrmHashBucketRec *XrmHashBucket;
typedef struct _XrmHashBucketRec *XrmDatabase;
typedef char Boolean;
typedef void* XtPointer;
typedef void (*XtBlockHookProc)(
    XtPointer
);
typedef Boolean (*XtWorkProc)(
    XtPointer
);
typedef void (*GtkSignalDestroy) (gpointer data);
void gtk_signal_emit_by_name (GtkObject *object,
                                           const gchar *name,
                                           ...);
extern const guint gtk_major_version;
extern const guint gtk_minor_version;
extern const guint gtk_micro_version;
guint gtk_main_level (void);
void gtk_main_quit (void);
typedef void (*GtkItemFactoryCallback) ();
typedef enum {
  GTK_RC_FG = 1 << 0,
  GTK_RC_BG = 1 << 1,
  GTK_RC_TEXT = 1 << 2,
  GTK_RC_BASE = 1 << 3
} GtkRcFlags;
struct _GtkRcStyle
{
  gchar *name;
  gchar *font_name;
  gchar *fontset_name;
  gchar *bg_pixmap_name[5];
  GtkRcFlags color_flags[5];
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor text[5];
  GdkColor base[5];
  GtkThemeEngine *engine;
  gpointer engine_data;
};
struct _GtkThemeEngine {
  guint (*parse_rc_style) (GScanner *scanner, GtkRcStyle *rc_style);
  void (*merge_rc_style) (GtkRcStyle *dest, GtkRcStyle *src);
  void (*rc_style_to_style) (GtkStyle *style, GtkRcStyle *rc_style);
  void (*duplicate_style) (GtkStyle *dest, GtkStyle *src);
  void (*realize_style) (GtkStyle *new_style);
  void (*unrealize_style) (GtkStyle *new_style);
  void (*destroy_rc_style) (GtkRcStyle *rc_style);
  void (*destroy_style) (GtkStyle *style);
  void (*set_background) (GtkStyle *style,
                          GdkWindow *window,
                          GtkStateType state_type);
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
typedef struct m_info minfo_T;
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
typedef struct m_block mblock_T;
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
typedef struct nr_trans NR_TRANS;
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
typedef struct signlist signlist_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct syn_state synstate_T;
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
typedef struct mapblock mapblock_T;
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef struct file_buffer buf_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
extern char_u *p_imak;
extern int p_imdisable;
extern long p_verbose;
void getvcol (win_T *wp, pos_T *pos, colnr_T *start, colnr_T *cursor, colnr_T *end);
colnr_T cmdline_getvcol_cursor (void);
int emsg (char_u *s);
char_u *alloc (unsigned size);
char_u *vim_strsave (char_u *string);
void vim_free (void *x);
char_u *enc_skip (char_u *p);
void xim_set_focus (int focus);
void xim_set_preedit (void);
void xim_reset (void);
void xim_init (void);
void setcursor (void);
int showmode (void);
void out_flush (void);
void add_to_input_buf (char_u *s, int len);
void add_to_input_buf_csi (char_u *str, int len);
void gui_update_cursor (int force, int clear_selection);
int gui_get_x11_windis (Window *win, Display **dis);
extern int highlight_attr[HLF_COUNT];
extern win_T *curwin;
extern GdkICAttr *xic_attr ;
extern GdkIC *xic ;
extern char *draw_feedback ;
extern colnr_T preedit_start_col ;
extern guicolor_T xim_fg_color ;
extern guicolor_T xim_bg_color ;
extern int State ;
static struct
{ char *name; int prop; int codepage;}
enc_canon_table[] =
{
    {"latin1", 0x01 + 0x200, 1252},
    {"iso-8859-2", 0x01, 0},
    {"iso-8859-3", 0x01, 0},
    {"iso-8859-4", 0x01, 0},
    {"iso-8859-5", 0x01, 0},
    {"iso-8859-6", 0x01, 0},
    {"iso-8859-7", 0x01, 0},
    {"cp1255", 0x01, 1255},
    {"iso-8859-8", 0x01, 0},
    {"iso-8859-9", 0x01, 0},
    {"iso-8859-10", 0x01, 0},
    {"iso-8859-11", 0x01, 0},
    {"iso-8859-13", 0x01, 0},
    {"iso-8859-14", 0x01, 0},
    {"iso-8859-15", 0x01, 0},
    {"koi8-r", 0x01, 0},
    {"koi8-u", 0x01, 0},
    {"utf-8", 0x04, 0},
    {"ucs-2", 0x04 + 0x10 + 0x40, 0},
    {"ucs-2le", 0x04 + 0x20 + 0x40, 0},
    {"utf-16", 0x04 + 0x10 + 0x100, 0},
    {"utf-16le", 0x04 + 0x20 + 0x100, 0},
    {"ucs-4", 0x04 + 0x10 + 0x80, 0},
    {"ucs-4le", 0x04 + 0x20 + 0x80, 0},
    {"debug", 0x02, -1},
    {"cp932", 0x02, 932},
    {"cp949", 0x02, 949},
    {"cp936", 0x02, 936},
    {"cp950", 0x02, 950},
    {"euc-jp", 0x02, 9932},
    {"sjis", 0x02, 932},
    {"euc-kr", 0x02, 9949},
    {"euc-cn", 0x02, 9936},
    {"euc-tw", 0x02, 9950},
    {"big5", 0x02, 950},
};
static struct
{ char *name; int canon;}
enc_alias_table[] =
{
    {"ansi", 0},
    {"iso-8859-1", 0},
    {"latin2", 1},
    {"latin3", 2},
    {"latin4", 3},
    {"cyrillic", 4},
    {"arabic", 5},
    {"greek", 6},
    {"hebrew", 8},
    {"latin5", 9},
    {"turkish", 9},
    {"latin6", 10},
    {"nordic", 10},
    {"thai", 11},
    {"latin7", 12},
    {"latin8", 13},
    {"latin9", 14},
    {"utf8", 17},
    {"unicode", 18},
    {"ucs2", 18},
    {"ucs2be", 18},
    {"ucs-2be", 18},
    {"ucs2le", 19},
    {"utf16", 20},
    {"utf16be", 20},
    {"utf-16be", 20},
    {"utf16le", 21},
    {"ucs4", 22},
    {"ucs4be", 22},
    {"ucs-4be", 22},
    {"ucs4le", 23},
    {"932", 25},
    {"949", 26},
    {"936", 27},
    {"950", 28},
    {"eucjp", 29},
    {"unix-jis", 29},
    {"ujis", 29},
    {"shift-jis", 30},
    {"euckr", 31},
    {"5601", 31},
    {"euccn", 32},
    {"gb2312", 32},
    {"euctw", 33},
    {"japan", 29},
    {"korea", 31},
    {"prc", 32},
    {"chinese", 32},
    {"taiwan", 33},
    {"cp950", 34},
    {"950", 34},
    {((void *)0), 0}
};
    static int enc_canon_search(name)
    char_u *name;
{
    int i;
    for (i = 0; i < 35; ++i)
        if (strcmp((char *)(name), (char *)(enc_canon_table[i].name)) == 0)
            return i;
    return -1;
}
static int enc_alias_search (char_u *name);
    char_u * enc_skip(p)
    char_u *p;
{
    if (strncmp((char *)(p), (char *)("2byte-"), (size_t)(6)) == 0)
        return p + 6;
    if (strncmp((char *)(p), (char *)("8bit-"), (size_t)(5)) == 0)
        return p + 5;
    return p;
}
    char_u * enc_canonize(enc)
    char_u *enc;
{
    char_u *r;
    char_u *p, *s;
    int i;
    r = alloc((unsigned)(strlen((char *)(enc)) + 3));
    if (r != ((void *)0))
    {
        p = r;
        for (s = enc; *s != '\000'; ++s)
        {
            if (*s == '_')
                *p++ = '-';
            else
                *p++ = (((*s) < 'A' || (*s) > 'Z') ? (*s) : (*s) + ('a' - 'A'));
        }
        *p = '\000';
        p = enc_skip(r);
        if (strncmp((char *)(p), (char *)("iso8859"), (size_t)(7)) == 0)
        {
            memmove((char *)(p + 4), (char *)(p + 3), strlen((char *)(p + 2)));
            p[3] = '-';
        }
        if (strncmp((char *)(p), (char *)("iso-8859"), (size_t)(8)) == 0 && p[8] != '-')
        {
            memmove((char *)(p + 9), (char *)(p + 8), strlen((char *)(p + 7)));
            p[8] = '-';
        }
        if (strncmp((char *)(p), (char *)("latin-"), (size_t)(6)) == 0)
            memmove((char *)(p + 5), (char *)(p + 6), strlen((char *)(p + 5)));
        if (enc_canon_search(p) >= 0)
        {
            if (p != r)
                memmove((char *)(r), (char *)(p), strlen((char *)(p)) + 1);
        }
        else if ((i = enc_alias_search(p)) >= 0)
        {
            vim_free(r);
            r = vim_strsave((char_u *)enc_canon_table[i].name);
        }
    }
    return r;
}
    static int enc_alias_search(name)
    char_u *name;
{
    int i;
    for (i = 0; enc_alias_table[i].name != ((void *)0); ++i)
        if (strcmp((char *)(name), (char *)(enc_alias_table[i].name)) == 0)
            return enc_alias_table[i].canon;
    return -1;
}
static int xim_is_active = 0;
static int xim_has_focus = 0;
typedef struct _GdkICPrivate GdkICPrivate;
struct _GdkICPrivate
{
  XIC xic;
  GdkICAttr *attr;
  GdkICAttributesType mask;
};
static int preedit_buf_len = 0;
static int xim_preediting ;
static int xim_input_style;
static gboolean use_status_area = 0;
static int im_xim_str2keycode (unsigned int *code, unsigned int *state);
static void im_xim_send_event_imactivate (void);
    static int im_xim_str2keycode(code, state)
    unsigned int *code;
    unsigned int *state;
{
    int retval = 1;
    int len;
    unsigned keycode = 0, keystate = 0;
    Window window;
    Display *display;
    char_u *flag_end;
    char_u *str;
    if (*p_imak != '\000')
    {
        len = strlen((char *)(p_imak));
        for (flag_end = p_imak + len - 1;
                            flag_end > p_imak && *flag_end != '-'; --flag_end)
            ;
        for (str = p_imak; str < flag_end; ++str)
        {
            switch (*str)
            {
                case 's': case 'S':
                    keystate |= (1<<0);
                    break;
                case 'l': case 'L':
                    keystate |= (1<<1);
                    break;
                case 'c': case 'C':
                    keystate |= (1<<2);
                    break;
                case '1':
                    keystate |= (1<<3);
                    break;
                case '2':
                    keystate |= (1<<4);
                    break;
                case '3':
                    keystate |= (1<<5);
                    break;
                case '4':
                    keystate |= (1<<6);
                    break;
                case '5':
                    keystate |= (1<<7);
                    break;
                case '-':
                    break;
                default:
                    retval = 0;
            }
        }
        if (*str == '-')
            ++str;
        gui_get_x11_windis(&window, &display);
        if (display)
            keycode = XKeysymToKeycode(display, XStringToKeysym((char *)str));
        if (keycode == 0)
            retval = 0;
        if (code != ((void *)0))
            *code = keycode;
        if (state != ((void *)0))
            *state = keystate;
    }
    return retval;
}
    static void im_xim_send_event_imactivate()
{
    XKeyEvent ev;
    gui_get_x11_windis(&ev.window, &ev.display);
    ev.root = ((&((_XPrivDisplay)ev.display)->screens[(((_XPrivDisplay)ev.display)->default_screen)])->root);
    ev.subwindow = 0L;
    ev.time = 0L;
    ev.x = 1;
    ev.y = 1;
    ev.x_root = 1;
    ev.y_root = 1;
    ev.same_screen = 1;
    ev.type = 2;
    if (im_xim_str2keycode(&ev.keycode, &ev.state) == 1)
        XSendEvent(ev.display, ev.window, 1, (1L<<0), (XEvent*)&ev);
}
    int im_xim_isvalid_imactivate()
{
    return im_xim_str2keycode(((void *)0), ((void *)0)) == 1;
}
    void im_set_active(active)
    int active;
{
    if (xic == ((void *)0))
        return;
    if (p_imdisable)
        active = 0;
    xim_is_active = active;
    if (*p_imak != '\000')
    {
        xim_is_active = 1;
        if (xim_input_style & (int)GDK_IM_PREEDIT_CALLBACKS)
        {
            if (xim_preediting && !active)
            {
                xim_reset();
                xim_set_focus(0);
                gdk_ic_destroy(xic);
                xim_init();
                xim_preediting = 0;
            }
            else if (!xim_preediting && active)
                im_xim_send_event_imactivate();
        }
        else
        {
            xim_set_focus(0);
            gdk_ic_destroy(xic);
            xim_init();
            xim_preediting = 0;
            if (active)
            {
                im_xim_send_event_imactivate();
                xim_preediting = 1;
            }
        }
    }
    else
    {
        XIMPreeditState preedit_state = 0L;
        XVaNestedList preedit_attr;
        XIC pxic;
        preedit_attr = XVaCreateNestedList(0,
                                "preeditState", &preedit_state,
                                ((void *)0));
        pxic = ((GdkICPrivate *)xic)->xic;
        if (!XGetICValues(pxic, "preeditAttributes", preedit_attr, ((void *)0)))
        {
            XFree(preedit_attr);
            preedit_attr = XVaCreateNestedList(0,
                                "preeditState",
                                active ? 1L : (1L<<1),
                                ((void *)0));
            XSetICValues(pxic, "preeditAttributes", preedit_attr, ((void *)0));
            xim_preediting = active;
            xim_is_active = active;
        }
        XFree(preedit_attr);
    }
    if (xim_input_style & 0x0002L)
    {
        preedit_buf_len = 0;
        if (State & 0x08)
            preedit_start_col = cmdline_getvcol_cursor();
        else
            getvcol(curwin, &curwin->w_cursor, &preedit_start_col, ((void *)0), ((void *)0));
    }
    xim_set_preedit();
}
    void xim_set_focus(focus)
    int focus;
{
    if (xic == ((void *)0))
        return;
    if (focus && xim_is_active)
    {
        if (!xim_has_focus)
        {
            xim_has_focus = 1;
            gdk_im_begin(xic, gui.drawarea->window);
        }
    }
    else
    {
        if (xim_has_focus)
        {
            xim_has_focus = 0;
            gdk_im_end();
        }
    }
}
    void im_set_position(row, col)
    int row;
    int col;
{
    xim_set_preedit();
}
    void xim_set_preedit()
{
    if (xic == ((void *)0))
        return;
    xim_set_focus(1);
    if (gdk_im_ready())
    {
        int attrmask;
        GdkICAttr *attr;
        if (!xic_attr)
            return;
        attr = xic_attr;
        attrmask = 0;
        if (xim_fg_color == (guicolor_T)-11111)
        {
            xim_fg_color = gui.def_norm_pixel;
            xim_bg_color = gui.def_back_pixel;
        }
        if (attr->preedit_foreground.pixel != xim_fg_color)
        {
            attr->preedit_foreground.pixel = xim_fg_color;
            attrmask |= (int)GDK_IC_PREEDIT_FOREGROUND;
        }
        if (attr->preedit_background.pixel != xim_bg_color)
        {
            attr->preedit_background.pixel = xim_bg_color;
            attrmask |= (int)GDK_IC_PREEDIT_BACKGROUND;
        }
        if (attrmask != 0)
            gdk_ic_set_attr(xic, attr, (GdkICAttributesType)attrmask);
    }
}
    void xim_set_status_area()
{
    if (xic == ((void *)0))
        return;
}
static char e_xim[] = "E285: Failed to create input context";
    void xim_decide_input_style()
{
    int supported_style = (int)GDK_IM_PREEDIT_NONE |
                                 (int)GDK_IM_PREEDIT_NOTHING |
                                 (int)GDK_IM_PREEDIT_POSITION |
                                 (int)GDK_IM_PREEDIT_CALLBACKS |
                                 (int)GDK_IM_STATUS_CALLBACKS |
                                 (int)GDK_IM_STATUS_AREA |
                                 (int)GDK_IM_STATUS_NONE |
                                 (int)GDK_IM_STATUS_NOTHING;
    if (!gdk_im_ready())
        xim_input_style = 0;
    else
    {
        if (gtk_major_version > 1
                || (gtk_major_version == 1
                    && (gtk_minor_version > 2
                        || (gtk_minor_version == 2 && gtk_micro_version >= 3))))
            use_status_area = 1;
        else
        {
            emsg((char_u *)(((char *)("E291: Your GTK+ is older than 1.2.3. Status area disabled"))));
            use_status_area = 0;
        }
            supported_style &= ~((int)GDK_IM_PREEDIT_POSITION
                                                   | (int)GDK_IM_STATUS_AREA);
        if (!use_status_area)
            supported_style &= ~(int)GDK_IM_STATUS_AREA;
        xim_input_style = (int)gdk_im_decide_style((GdkIMStyle)supported_style);
    }
}
    static void preedit_start_cbproc(XIC xic, XPointer client_data, XPointer call_data)
{
    draw_feedback = ((void *)0);
    xim_preediting = 1;
    gui_update_cursor(1, 0);
    if (showmode() > 0)
    {
        setcursor();
        out_flush();
    }
}
    static void xim_back_delete(int n)
{
    char_u str[3];
    str[0] = 0x9b;
    str[1] = 'k';
    str[2] = 'b';
    while (n-- > 0)
        add_to_input_buf(str, 3);
}
static GSList *key_press_event_queue = ((void *)0);
static gboolean processing_queued_event = 0;
    static void preedit_draw_cbproc(XIC xic, XPointer client_data, XPointer call_data)
{
    XIMPreeditDrawCallbackStruct *draw_data;
    XIMText *text;
    char *src;
    GSList *event_queue;
    draw_data = (XIMPreeditDrawCallbackStruct *) call_data;
    text = (XIMText *) draw_data->text;
    if ((text == ((void *)0) && draw_data->chg_length == preedit_buf_len)
            || preedit_buf_len == 0)
    {
        if (State & 0x08)
            preedit_start_col = cmdline_getvcol_cursor();
        else
            getvcol(curwin, &curwin->w_cursor, &preedit_start_col, ((void *)0), ((void *)0));
        vim_free(draw_feedback);
        draw_feedback = ((void *)0);
    }
    if (draw_data->chg_length > 0)
    {
        int bs_cnt;
        if (draw_data->chg_length > preedit_buf_len)
            bs_cnt = preedit_buf_len;
        else
            bs_cnt = draw_data->chg_length;
        xim_back_delete(bs_cnt);
        preedit_buf_len -= bs_cnt;
    }
    if (text != ((void *)0))
    {
        int len;
        char_u *ptr;
        src = text->string.multi_byte;
        if (src != ((void *)0) && !text->encoding_is_wchar)
        {
            len = strlen(src);
            ptr = (char_u *)src;
            if (*ptr == '\n')
                return;
                add_to_input_buf_csi((char_u *)src, len);
            while (*ptr != '\000')
            {
                    ptr++;
                preedit_buf_len++;
            }
        }
    }
    if (text != ((void *)0) || draw_data->chg_length > 0)
    {
        event_queue = key_press_event_queue;
        processing_queued_event = 1;
        while (event_queue != ((void *)0) && processing_queued_event)
        {
            GdkEvent *ev = event_queue->data;
            gboolean *ret;
            gtk_signal_emit_by_name((GtkObject*)gui.mainwin, "key_press_event",
                                                                    ev, &ret);
            gdk_event_free(ev);
            event_queue = event_queue->next;
        }
        processing_queued_event = 0;
        if (key_press_event_queue)
        {
            g_slist_free(key_press_event_queue);
            key_press_event_queue = ((void *)0);
        }
    }
    if (gtk_main_level() > 0)
        gtk_main_quit();
}
    int im_get_feedback_attr(int col)
{
    if (draw_feedback != ((void *)0) && col < preedit_buf_len)
    {
        if (draw_feedback[col] & 1L)
            return 0x01;
        else if (draw_feedback[col] & (1L<<1))
            return 0x08;
        else
            return highlight_attr[(int)(HLF_V)];
    }
    return -1;
}
    static void preedit_caret_cbproc(XIC xic, XPointer client_data, XPointer call_data)
{
}
    static void preedit_done_cbproc(XIC xic, XPointer client_data, XPointer call_data)
{
    vim_free(draw_feedback);
    draw_feedback = ((void *)0);
    xim_preediting = 0;
    gui_update_cursor(1, 0);
    if (showmode() > 0)
    {
        setcursor();
        out_flush();
    }
}
    void xim_reset(void)
{
    char *text;
    if (xic != ((void *)0))
    {
        text = XmbResetIC(((GdkICPrivate *)xic)->xic);
        if (text != ((void *)0) && !(xim_input_style & (int)GDK_IM_PREEDIT_CALLBACKS))
            add_to_input_buf_csi((char_u *)text, strlen(text));
        else
            preedit_buf_len = 0;
        if (text != ((void *)0))
            XFree(text);
    }
}
    int xim_queue_key_press_event(GdkEventKey *event)
{
    if (preedit_buf_len <= 0)
        return 0;
    if (processing_queued_event)
        processing_queued_event = 0;
    key_press_event_queue = g_slist_append(key_press_event_queue,
                                           gdk_event_copy((GdkEvent *)event));
    return 1;
}
    static void preedit_callback_setup(GdkIC *ic)
{
    XIC xxic;
    XVaNestedList preedit_attr;
    XIMCallback preedit_start_cb;
    XIMCallback preedit_draw_cb;
    XIMCallback preedit_caret_cb;
    XIMCallback preedit_done_cb;
    xxic = ((GdkICPrivate*)xic)->xic;
    preedit_start_cb.callback = (XIMProc)preedit_start_cbproc;
    preedit_draw_cb.callback = (XIMProc)preedit_draw_cbproc;
    preedit_caret_cb.callback = (XIMProc)preedit_caret_cbproc;
    preedit_done_cb.callback = (XIMProc)preedit_done_cbproc;
    preedit_attr
        = XVaCreateNestedList (0,
                               "preeditStartCallback", &preedit_start_cb,
                               "preeditDrawCallback", &preedit_draw_cb,
                               "preeditCaretCallback", &preedit_caret_cb,
                               "preeditDoneCallback", &preedit_done_cb,
                               0);
    XSetICValues (xxic, "preeditAttributes", preedit_attr, 0);
    XFree(preedit_attr);
}
    static void reset_state_setup(GdkIC *ic)
{
}
    void xim_init(void)
{
    xic = ((void *)0);
    xic_attr = ((void *)0);
    if (!gdk_im_ready())
    {
        if (p_verbose > 0)
            emsg((char_u *)(((char *)("E292: Input Method Server is not running"))));
        return;
    }
    if ((xic_attr = gdk_ic_attr_new()) != ((void *)0))
    {
        int mask;
        GdkColormap *colormap;
        GdkICAttr *attr = xic_attr;
        int attrmask = (int)GDK_IC_ALL_REQ;
        GtkWidget *widget = gui.drawarea;
        attr->style = (GdkIMStyle)xim_input_style;
        attr->client_window = gui.mainwin->window;
        if ((colormap = gtk_widget_get_colormap(widget)) !=
            gtk_widget_get_default_colormap())
        {
            attrmask |= (int)GDK_IC_PREEDIT_COLORMAP;
            attr->preedit_colormap = colormap;
        }
        attrmask |= (int)GDK_IC_PREEDIT_FOREGROUND;
        attrmask |= (int)GDK_IC_PREEDIT_BACKGROUND;
        attr->preedit_foreground = widget->style->fg[GTK_STATE_NORMAL];
        attr->preedit_background = widget->style->base[GTK_STATE_NORMAL];
        xic = gdk_ic_new(attr, (GdkICAttributesType)attrmask);
        if (xic == ((void *)0))
            emsg((char_u *)(((char *)(e_xim))));
        else
        {
            mask = (int)gdk_window_get_events(widget->window);
            mask |= (int)gdk_ic_get_events(xic);
            gdk_window_set_events(widget->window, (GdkEventMask)mask);
            if (xim_input_style & (int)GDK_IM_PREEDIT_CALLBACKS)
                preedit_callback_setup(xic);
            reset_state_setup(xic);
        }
    }
}
    void im_shutdown(void)
{
    if (xic != ((void *)0))
    {
        gdk_im_end();
        gdk_ic_destroy(xic);
        xic = ((void *)0);
    }
    xim_is_active = 0;
    xim_preediting = 0;
    preedit_start_col = (0x7fffffffL);
}
    int xim_get_status_area_height()
{
    if (xim_input_style & (int)GDK_IM_STATUS_AREA)
        return gui.char_height;
    return 0;
}
    int im_get_status()
{
    if (xim_input_style & (int)GDK_IM_PREEDIT_CALLBACKS)
        return xim_preediting;
    return xim_has_focus;
}
