enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
extern __const unsigned short int *__ctype_b;
typedef unsigned char char_u;
char_u *alloc (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
extern int atoi (__const char *__nptr) __attribute__ ((__pure__));
int buf_valid (buf_T *buf);
void changed_line_abv_curs (void);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
void maketitle (void);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
int msg_outtrans (char_u *str);
void msg_putchar (int c);
void msg_puts (char_u *s);
void msg_puts_title (char_u *s);
void out_flush (void);
void redraw_later (int type);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
void ui_breakcheck (void);
void ui_delay (long msec, int ignoreinput);
int vgetc (void);
void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
int vim_strsize (char_u *s);
extern long Columns ;
extern char_u *IObuff;
extern long Rows
                            ;
extern int State ;
extern buf_T *curbuf ;
typedef int scid_T;
extern scid_T current_SID ;
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
extern win_T *curwin;
extern int emsg_silent ;
extern buf_T *firstbuf ;
extern int got_int ;
extern char_u *p_cpo;
extern char_u *sourcing_name ;
extern int VIsual_active ;
void set_string_option_direct (char_u *name, int opt_idx, char_u *val, int opt_flags);
extern int no_mapping ;
extern int allow_keys ;
extern int msg_col;
enum key_extra
{
    KE_NAME = 3
    , KE_S_UP
    , KE_S_DOWN
    , KE_S_F1
    , KE_S_F2
    , KE_S_F3
    , KE_S_F4
    , KE_S_F5
    , KE_S_F6
    , KE_S_F7
    , KE_S_F8
    , KE_S_F9
    , KE_S_F10
    , KE_S_F11
    , KE_S_F12
    , KE_S_F13
    , KE_S_F14
    , KE_S_F15
    , KE_S_F16
    , KE_S_F17
    , KE_S_F18
    , KE_S_F19
    , KE_S_F20
    , KE_S_F21
    , KE_S_F22
    , KE_S_F23
    , KE_S_F24
    , KE_S_F25
    , KE_S_F26
    , KE_S_F27
    , KE_S_F28
    , KE_S_F29
    , KE_S_F30
    , KE_S_F31
    , KE_S_F32
    , KE_S_F33
    , KE_S_F34
    , KE_S_F35
    , KE_S_F36
    , KE_S_F37
    , KE_MOUSE
    , KE_LEFTMOUSE
    , KE_LEFTDRAG
    , KE_LEFTRELEASE
    , KE_MIDDLEMOUSE
    , KE_MIDDLEDRAG
    , KE_MIDDLERELEASE
    , KE_RIGHTMOUSE
    , KE_RIGHTDRAG
    , KE_RIGHTRELEASE
    , KE_IGNORE
    , KE_TAB
    , KE_S_TAB_OLD
    , KE_SNIFF
    , KE_XF1
    , KE_XF2
    , KE_XF3
    , KE_XF4
    , KE_XEND
    , KE_XHOME
    , KE_LEFTMOUSE_NM
    , KE_LEFTRELEASE_NM
    , KE_S_XF1
    , KE_S_XF2
    , KE_S_XF3
    , KE_S_XF4
    , KE_MOUSEDOWN
    , KE_MOUSEUP
    , KE_KINS
    , KE_KDEL
    , KE_CSI
    , KE_SNR
    , KE_PLUG
    , KE_CMDWIN
    , KE_C_LEFT
    , KE_C_RIGHT
    , KE_C_HOME
    , KE_C_END
    , KE_X1MOUSE
    , KE_X1DRAG
    , KE_X1RELEASE
    , KE_X2MOUSE
    , KE_X2DRAG
    , KE_X2RELEASE
    , KE_DROP
};
char_u *get_special_key_name (int c, int modifiers);
int mouse_has (int c);
int redrawing (void);
void setcursor (void);void setmouse (void);
extern int strncasecmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
void update_screen (int type);
void update_topline (void);
int vpeekc (void);
void vungetc (int c);
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
extern int mouse_col;
extern int mouse_row;
void ga_append (garray_T *gap, int c);
void ga_clear (garray_T *gap);
void ga_concat (garray_T *gap, char_u *s);
void ga_init (garray_T *gap);
extern char *getenv (__const char *__name) ;
void set_option_value (char_u *name, long number, char_u *string, int opt_flags);
void set_vim_var_string (int idx, char_u *val, int len);
extern char *strstr (__const char *__haystack, __const char *__needle)
             __attribute__ ((__pure__));
int trans_special (char_u **srcp, char_u *dst, int keycode);
extern char_u e_usingsid[] ;
extern int starting ;
extern int t_colors ;
void add_termcode (char_u *name, char_u *string, int use_8bit);
char_u *find_termcode (char_u *name);
void cursor_on (void);
void display_errors (void);
void invalidate_botline (void);
void starttermcap (void);
void wait_return (int redraw);
extern int exiting ;
extern int exmode_active ;
int ins_typebuf (char_u *str, int noremap, int offset, int nottyped, int silent);
void set_shellsize (int width, int height, int mustset);
void shell_resized (void);
typedef struct
{
    char_u *tb_buf;
    char_u *tb_noremap;
    int tb_buflen;
    int tb_off;
    int tb_len;
    int tb_maplen;
    int tb_silent;
    int tb_no_abbr_cnt;
} typebuf_T;
extern typebuf_T typebuf
                    ;
void redrawcmdline (void);
void screenclear (void);
void del_typebuf (int len, int offset);
void update_mouseshape (int shape_idx);
typedef struct VimMenu vimmenu_T;
struct VimMenu
{
    int modes;
    int enabled;
    char_u *name;
    char_u *dname;
    int mnemonic;
    char_u *actext;
    int priority;
    void (*cb)();
    char_u *iconfile;
    int iconidx;
    int icon_builtin;
    char_u *strings[6];
    int noremap[6];
    char silent[6];
    vimmenu_T *children;
    vimmenu_T *parent;
    vimmenu_T *next;
    GtkWidget *id;
    GtkWidget *submenu_id;
    GtkWidget *tearoff_handle;
    GtkWidget *label;
};
extern vimmenu_T *current_menu;
void check_shellsize (void);
void clip_init (int can_use);
extern int isatty (int __fd) ;
void mch_errmsg (char *str);
void out_str (char_u *s);
extern int current_scrollbar;
extern long_u scrollbar_value;
extern int full_screen ;
extern long p_mouset;
int hexhex2nr (char_u *p);
void init_highlight (int both, int reset);
void screen_start (void);
void screenalloc (int clear);
void scroll_region_reset (void);
int term_is_gui (char_u *name);
int ui_get_shellsize (void);
char_u *get_var_value (char_u *name);
extern int termcap_active ;
extern char_u *p_mousem;
extern long p_wd;
extern int cur_tmode ;
extern char_u *empty_option ;
extern int p_tf;
extern int p_wiv;
void screen_stop_highlight (void);
extern int scroll_region ;
extern int term_is_xterm ;
enum SpecialKey
{
    KS_NAME = 0,
    KS_CE,
    KS_AL,
    KS_CAL,
    KS_DL,
    KS_CDL,
    KS_CS,
    KS_CL,
    KS_CD,
    KS_UT,
    KS_DA,
    KS_DB,
    KS_VI,
    KS_VE,
    KS_VS,
    KS_ME,
    KS_MR,
    KS_MD,
    KS_SE,
    KS_SO,
    KS_CZH,
    KS_CZR,
    KS_UE,
    KS_US,
    KS_MS,
    KS_CM,
    KS_SR,
    KS_CRI,
    KS_VB,
    KS_KS,
    KS_KE,
    KS_TI,
    KS_TE,
    KS_BC,
    KS_CCS,
    KS_CCO,
    KS_CSF,
    KS_CSB,
    KS_XS,
    KS_MB,
    KS_CAF,
    KS_CAB,
    KS_LE,
    KS_ND,
    KS_CIS,
    KS_CIE,
    KS_TS,
    KS_FS,
    KS_CWP,
    KS_CWS,
    KS_CRV,
    KS_CSV,
    KS_OP
};
extern char_u *(term_strings[]);
typedef long int __time_t;
typedef long int __suseconds_t;
struct timeval
  {
    __time_t tv_sec;
    __suseconds_t tv_usec;
  };
struct timezone
  {
    int tz_minuteswest;
    int tz_dsttime;
  };
typedef struct timezone *__restrict __timezone_ptr_t;
extern char_u *p_mouse;
int vim_is_xterm (char_u *name);
int use_xterm_mouse (void);
int vim_is_iris (char_u *name);
void mch_setmouse (int on);
int term_is_8bit (char_u *name);
void out_str_nf (char_u *s);
typedef unsigned int speed_t;
extern int gettimeofday (struct timeval *__restrict __tv,
                         __timezone_ptr_t __tz) ;
typedef void (*__sighandler_t) (int);
extern int p_ek;
extern int p_tbi;
int vim_is_fastterm (char_u *name);
void mch_settmode (int tmode);
void get_stty (void);
void check_mouse_termcode (void);
void start_xterm_trace (int button);
void stop_xterm_trace (void);
int vpeekc_nomap (void);
void check_map_keycodes (void);
int get_pseudo_mouse_code (int button, int is_click, int is_drag);
void set_string_default (char *name, char_u *val);
void check_options (void);
void set_term_option_alloced (char_u **p);
void clear_termoptions (void);
void set_term_defaults (void);
void reset_cterm_colors (void);
int set_termname (char_u *term);
void ttest (int pairs);
void win_new_shellsize (void);
void del_termcode (char_u *name);
int find_term_bykeys (char_u *src);
int show_one_termcode (char_u *name, char_u *code, int printit);
void ui_write (char_u *s, int len);
void ui_set_shellsize (int mustset);
void ui_new_shellsize (void);
void shell_new_rows (void);
void shell_new_columns (void);
int min_rows (void);
void gui_init (void);
int gui_mch_haskey (char_u *name);
extern char PC;
extern char *UP;
extern char *BC;
extern speed_t ospeed;
typedef int (*outfuntype) (int);
extern int tgetent (void *__buffer, __const char *__termtype) ;
extern int tgetflag (__const char *__name) ;
extern int tgetnum (__const char *__name) ;
extern char *tgoto (__const char *__cstring, int __hpos, int __vpos) ;
struct builtin_term
{
    int bt_entry;
    char *bt_string;
};
char *tgetstr (char *, char **);
extern void tputs (__const char *__string, int __nlines, int (*) (int)) ;
void repeat_message (void);
static struct builtin_term *find_builtin_term (char_u *name);
static void parse_builtin_tcap (char_u *s);
static void term_color (char_u *s, int n);
static void gather_termleader (void);
static void req_codes_from_term (void);
static void req_more_codes_from_term (void);
static void got_code_from_term (char_u *code, int len);
static void check_for_codes_from_term (void);
static int get_bytes_from_buf (char_u *, char_u *, int);
static void may_req_termresponse (void);
static void del_termcode_idx (int idx);
static int term_is_builtin (char_u *name);
static int term_7to8bit (char_u *p);
static void switch_to_8bit (void);
static char_u *tgetent_error (char_u *, char_u *);
static int crv_status = 1;
static char_u *vim_tgetstr (char *s, char_u **pp);
static int detected_8bit = 0;
struct builtin_term builtin_termcaps[] =
{
    {(int)KS_NAME, "gui"},
    {(int)KS_CE, "\033|$"},
    {(int)KS_AL, "\033|i"},
    {(int)KS_CAL, "\033|%p1%dI"},
    {(int)KS_DL, "\033|d"},
    {(int)KS_CDL, "\033|%p1%dD"},
    {(int)KS_CS, "\033|%p1%d;%p2%dR"},
    {(int)KS_CSV, "\033|%p1%d;%p2%dV"},
    {(int)KS_CL, "\033|C"},
    {(int)KS_ME, "\033|31H"},
    {(int)KS_MR, "\033|1h"},
    {(int)KS_MD, "\033|2h"},
    {(int)KS_SE, "\033|16H"},
    {(int)KS_SO, "\033|16h"},
    {(int)KS_UE, "\033|8H"},
    {(int)KS_US, "\033|8h"},
    {(int)KS_CZR, "\033|4H"},
    {(int)KS_CZH, "\033|4h"},
    {(int)KS_VB, "\033|f"},
    {(int)KS_MS, "y"},
    {(int)KS_UT, "y"},
    {(int)KS_LE, "\b"},
    {(int)KS_ND, "\014"},
    {(int)KS_CM, "\033|%p1%d;%p2%dM"},
    {(int)KS_NAME, "ansi"},
    {(int)KS_CE, "\033[K"},
    {(int)KS_AL, "\033[L"},
    {(int)KS_CAL, "\033[%p1%dL"},
    {(int)KS_DL, "\033[M"},
    {(int)KS_CDL, "\033[%p1%dM"},
    {(int)KS_CL, "\033[H\033[2J"},
    {(int)KS_ME, "\033[0m"},
    {(int)KS_MR, "\033[7m"},
    {(int)KS_MS, "y"},
    {(int)KS_UT, "y"},
    {(int)KS_LE, "\b"},
    {(int)KS_CM, "\033[%i%p1%d;%p2%dH"},
    {(int)KS_CRI, "\033[%p1%dC"},
    {(int)KS_NAME, "xterm"},
    {(int)KS_CE, "\033[K"},
    {(int)KS_AL, "\033[L"},
    {(int)KS_CAL, "\033[%p1%dL"},
    {(int)KS_DL, "\033[M"},
    {(int)KS_CDL, "\033[%p1%dM"},
    {(int)KS_CS, "\033[%i%p1%d;%p2%dr"},
    {(int)KS_CL, "\033[H\033[2J"},
    {(int)KS_CD, "\033[J"},
    {(int)KS_ME, "\033[m"},
    {(int)KS_MR, "\033[7m"},
    {(int)KS_MD, "\033[1m"},
    {(int)KS_UE, "\033[m"},
    {(int)KS_US, "\033[4m"},
    {(int)KS_MS, "y"},
    {(int)KS_UT, "y"},
    {(int)KS_LE, "\b"},
    {(int)KS_CM, "\033[%i%p1%d;%p2%dH"},
    {(int)KS_SR, "\033M"},
    {(int)KS_CRI, "\033[%p1%dC"},
    {(int)KS_KS, "\033[?1h\033="},
    {(int)KS_KE, "\033[?1l\033>"},
    {(int)KS_CIS, "\033]1;"},
    {(int)KS_CIE, "\007"},
    {(int)KS_TS, "\033]2;"},
    {(int)KS_FS, "\007"},
    {(int)KS_CWS, "\033[8;%p1%d;%p2%dt"},
    {(int)KS_CWP, "\033[3;%p1%d;%p2%dt"},
    {(int)KS_CRV, "\033[>c"},
    {(-(('k') + ((int)('u') << 8))), "\033OA"},
    {(-(('k') + ((int)('d') << 8))), "\033OB"},
    {(-(('k') + ((int)('r') << 8))), "\033OC"},
    {(-(('k') + ((int)('l') << 8))), "\033OD"},
    {(-((253) + ((int)(KE_S_UP) << 8))), "\033O2A"},
    {(-((253) + ((int)(KE_S_DOWN) << 8))), "\033O2B"},
    {(-(('%') + ((int)('i') << 8))), "\033O2C"},
    {(-((253) + ((int)(KE_C_RIGHT) << 8))), "\033O5C"},
    {(-(('#') + ((int)('4') << 8))), "\033O2D"},
    {(-((253) + ((int)(KE_C_LEFT) << 8))), "\033O5D"},
    {(-((253) + ((int)(KE_XF1) << 8))), "\033OP"},
    {(-((253) + ((int)(KE_XF2) << 8))), "\033OQ"},
    {(-((253) + ((int)(KE_XF3) << 8))), "\033OR"},
    {(-((253) + ((int)(KE_XF4) << 8))), "\033OS"},
    {(-(('k') + ((int)('1') << 8))), "\033[11~"},
    {(-(('k') + ((int)('2') << 8))), "\033[12~"},
    {(-(('k') + ((int)('3') << 8))), "\033[13~"},
    {(-(('k') + ((int)('4') << 8))), "\033[14~"},
    {(-(('k') + ((int)('5') << 8))), "\033[15~"},
    {(-(('k') + ((int)('6') << 8))), "\033[17~"},
    {(-(('k') + ((int)('7') << 8))), "\033[18~"},
    {(-(('k') + ((int)('8') << 8))), "\033[19~"},
    {(-(('k') + ((int)('9') << 8))), "\033[20~"},
    {(-(('k') + ((int)(';') << 8))), "\033[21~"},
    {(-(('F') + ((int)('1') << 8))), "\033[23~"},
    {(-(('F') + ((int)('2') << 8))), "\033[24~"},
    {(-((253) + ((int)(KE_S_XF1) << 8))), "\033O2P"},
    {(-((253) + ((int)(KE_S_XF2) << 8))), "\033O2Q"},
    {(-((253) + ((int)(KE_S_XF3) << 8))), "\033O2R"},
    {(-((253) + ((int)(KE_S_XF4) << 8))), "\033O2S"},
    {(-((253) + ((int)(KE_S_F1) << 8))), "\033[11;2~"},
    {(-((253) + ((int)(KE_S_F2) << 8))), "\033[12;2~"},
    {(-((253) + ((int)(KE_S_F3) << 8))), "\033[13;2~"},
    {(-((253) + ((int)(KE_S_F4) << 8))), "\033[14;2~"},
    {(-((253) + ((int)(KE_S_F5) << 8))), "\033[15;2~"},
    {(-((253) + ((int)(KE_S_F6) << 8))), "\033[17;2~"},
    {(-((253) + ((int)(KE_S_F7) << 8))), "\033[18;2~"},
    {(-((253) + ((int)(KE_S_F8) << 8))), "\033[19;2~"},
    {(-((253) + ((int)(KE_S_F9) << 8))), "\033[20;2~"},
    {(-((253) + ((int)(KE_S_F10) << 8))), "\033[21;2~"},
    {(-((253) + ((int)(KE_S_F11) << 8))), "\033[23;2~"},
    {(-((253) + ((int)(KE_S_F12) << 8))), "\033[24;2~"},
    {(-(('k') + ((int)('B') << 8))), "\033[Z"},
    {(-(('%') + ((int)('1') << 8))), "\033[28~"},
    {(-(('&') + ((int)('8') << 8))), "\033[26~"},
    {(-(('k') + ((int)('I') << 8))), "\033[2~"},
    {(-(('k') + ((int)('h') << 8))), "\033[7~"},
    {(-(('#') + ((int)('2') << 8))), "\033O2H"},
    {(-((253) + ((int)(KE_C_HOME) << 8))), "\033O5H"},
    {(-(('K') + ((int)('1') << 8))), "\033[1~"},
    {(-((253) + ((int)(KE_XHOME) << 8))), "\033OH"},
    {(-(('@') + ((int)('7') << 8))), "\033[8~"},
    {(-(('*') + ((int)('7') << 8))), "\033O2F"},
    {(-((253) + ((int)(KE_C_END) << 8))), "\033O5F"},
    {(-(('K') + ((int)('4') << 8))), "\033[4~"},
    {(-((253) + ((int)(KE_XEND) << 8))), "\033OF"},
    {(-(('k') + ((int)('P') << 8))), "\033[5~"},
    {(-(('k') + ((int)('N') << 8))), "\033[6~"},
    {(-(('K') + ((int)('6') << 8))), "\033Ok"},
    {(-(('K') + ((int)('7') << 8))), "\033Om"},
    {(-(('K') + ((int)('8') << 8))), "\033Oo"},
    {(-(('K') + ((int)('9') << 8))), "\033Oj"},
    {(-(('K') + ((int)('A') << 8))), "\033OM"},
    {(-((253) + ((int)(KE_KDEL) << 8))), "\033[3~"},
    {0x101, ""},
    {(-(('k') + ((int)('0') << 8))), "\033[10~"},
    {(-(('F') + ((int)('3') << 8))), "\033[25~"},
    {(-(('F') + ((int)('6') << 8))), "\033[29~"},
    {(-(('F') + ((int)('7') << 8))), "\033[31~"},
    {(-(('F') + ((int)('8') << 8))), "\033[32~"},
    {(-(('F') + ((int)('9') << 8))), "\033[33~"},
    {(-(('F') + ((int)('A') << 8))), "\033[34~"},
    {(int)KS_NAME, "iris-ansi"},
    {(int)KS_CE, "\033[K"},
    {(int)KS_CD, "\033[J"},
    {(int)KS_AL, "\033[L"},
    {(int)KS_CAL, "\033[%p1%dL"},
    {(int)KS_DL, "\033[M"},
    {(int)KS_CDL, "\033[%p1%dM"},
    {(int)KS_CL, "\033[H\033[2J"},
    {(int)KS_VE, "\033[9/y\033[12/y"},
    {(int)KS_VS, "\033[10/y\033[=1h\033[=2l"},
    {(int)KS_TI, "\033[=6h"},
    {(int)KS_TE, "\033[=6l"},
    {(int)KS_SE, "\033[21;27m"},
    {(int)KS_SO, "\033[1;7m"},
    {(int)KS_ME, "\033[m"},
    {(int)KS_MR, "\033[7m"},
    {(int)KS_MD, "\033[1m"},
    {(int)KS_CCO, "8"},
    {(int)KS_CZH, "\033[3m"},
    {(int)KS_CZR, "\033[23m"},
    {(int)KS_US, "\033[4m"},
    {(int)KS_UE, "\033[24m"},
    {(int)KS_CAB, "\033[4%p1%dm"},
    {(int)KS_CAF, "\033[3%p1%dm"},
    {(int)KS_CSB, "\033[102;%p1%dm"},
    {(int)KS_CSF, "\033[101;%p1%dm"},
    {(int)KS_MS, "y"},
    {(int)KS_UT, "y"},
    {(int)KS_LE, "\b"},
    {(int)KS_CM, "\033[%i%p1%d;%p2%dH"},
    {(int)KS_SR, "\033M"},
    {(int)KS_CRI, "\033[%p1%dC"},
    {(int)KS_CIS, "\033P3.y"},
    {(int)KS_CIE, "\234"},
    {(int)KS_TS, "\033P1.y"},
    {(int)KS_FS, "\234"},
    {(int)KS_CWS, "\033[203;%p1%d;%p2%d/y"},
    {(int)KS_CWP, "\033[205;%p1%d;%p2%d/y"},
    {(-(('k') + ((int)('u') << 8))), "\033[A"},
    {(-(('k') + ((int)('d') << 8))), "\033[B"},
    {(-(('k') + ((int)('l') << 8))), "\033[D"},
    {(-(('k') + ((int)('r') << 8))), "\033[C"},
    {(-((253) + ((int)(KE_S_UP) << 8))), "\033[161q"},
    {(-((253) + ((int)(KE_S_DOWN) << 8))), "\033[164q"},
    {(-(('#') + ((int)('4') << 8))), "\033[158q"},
    {(-(('%') + ((int)('i') << 8))), "\033[167q"},
    {(-(('k') + ((int)('1') << 8))), "\033[001q"},
    {(-(('k') + ((int)('2') << 8))), "\033[002q"},
    {(-(('k') + ((int)('3') << 8))), "\033[003q"},
    {(-(('k') + ((int)('4') << 8))), "\033[004q"},
    {(-(('k') + ((int)('5') << 8))), "\033[005q"},
    {(-(('k') + ((int)('6') << 8))), "\033[006q"},
    {(-(('k') + ((int)('7') << 8))), "\033[007q"},
    {(-(('k') + ((int)('8') << 8))), "\033[008q"},
    {(-(('k') + ((int)('9') << 8))), "\033[009q"},
    {(-(('k') + ((int)(';') << 8))), "\033[010q"},
    {(-(('F') + ((int)('1') << 8))), "\033[011q"},
    {(-(('F') + ((int)('2') << 8))), "\033[012q"},
    {(-((253) + ((int)(KE_S_F1) << 8))), "\033[013q"},
    {(-((253) + ((int)(KE_S_F2) << 8))), "\033[014q"},
    {(-((253) + ((int)(KE_S_F3) << 8))), "\033[015q"},
    {(-((253) + ((int)(KE_S_F4) << 8))), "\033[016q"},
    {(-((253) + ((int)(KE_S_F5) << 8))), "\033[017q"},
    {(-((253) + ((int)(KE_S_F6) << 8))), "\033[018q"},
    {(-((253) + ((int)(KE_S_F7) << 8))), "\033[019q"},
    {(-((253) + ((int)(KE_S_F8) << 8))), "\033[020q"},
    {(-((253) + ((int)(KE_S_F9) << 8))), "\033[021q"},
    {(-((253) + ((int)(KE_S_F10) << 8))), "\033[022q"},
    {(-((253) + ((int)(KE_S_F11) << 8))), "\033[023q"},
    {(-((253) + ((int)(KE_S_F12) << 8))), "\033[024q"},
    {(-(('k') + ((int)('I') << 8))), "\033[139q"},
    {(-(('k') + ((int)('h') << 8))), "\033[H"},
    {(-(('@') + ((int)('7') << 8))), "\033[146q"},
    {(-(('k') + ((int)('P') << 8))), "\033[150q"},
    {(-(('k') + ((int)('N') << 8))), "\033[154q"},
    {(int)KS_NAME, "dumb"},
    {(int)KS_CL, "\014"},
    {(int)KS_CM, "\033[%i%p1%d;%p2%dH"},
    {(int)KS_NAME, ((void *)0)}
};
char_u *(term_strings[(int)KS_OP + 1]);
static int need_gather = 0;
static char_u termleader[256 + 1];
static int check_for_codes = 0;
    static struct builtin_term * find_builtin_term(term)
    char_u *term;
{
    struct builtin_term *p;
    p = builtin_termcaps;
    while (p->bt_string != ((void *)0))
    {
        if (p->bt_entry == (int)KS_NAME)
        {
            if (strcmp((char *)(p->bt_string), (char *)("iris-ansi")) == 0 && vim_is_iris(term))
                return p;
            else if (strcmp((char *)(p->bt_string), (char *)("xterm")) == 0 && vim_is_xterm(term))
                return p;
            else
                  if (strcmp((char *)(term), (char *)(p->bt_string)) == 0)
                    return p;
        }
        ++p;
    }
    return p;
}
    static void parse_builtin_tcap(term)
    char_u *term;
{
    struct builtin_term *p;
    char_u name[2];
    int term_8bit;
    p = find_builtin_term(term);
    term_8bit = term_is_8bit(term);
    if (p->bt_string == ((void *)0))
        return;
    for (++p; p->bt_entry != (int)KS_NAME && p->bt_entry != 0x101; ++p)
    {
        if ((int)p->bt_entry >= 0)
        {
            if (term_strings[p->bt_entry] == ((void *)0)
                                 || term_strings[p->bt_entry] == empty_option)
            {
                if (term_8bit && term_7to8bit((char_u *)p->bt_string) != 0)
                {
                    char_u *s, *t;
                    s = vim_strsave((char_u *)p->bt_string);
                    if (s != ((void *)0))
                    {
                        for (t = s; *t; ++t)
                            if (term_7to8bit(t))
                            {
                                *t = term_7to8bit(t);
                                strcpy((char *)(t + 1), (char *)(t + 2));
                            }
                        term_strings[p->bt_entry] = s;
                        set_term_option_alloced(&term_strings[p->bt_entry]);
                    }
                }
                else
                    term_strings[p->bt_entry] = (char_u *)p->bt_string;
            }
        }
        else
        {
            name[0] = ((-((int)p->bt_entry)) & 0xff);
            name[1] = (((unsigned)(-((int)p->bt_entry)) >> 8) & 0xff);
            if (find_termcode(name) == ((void *)0))
                add_termcode(name, (char_u *)p->bt_string, term_8bit);
        }
    }
}
static void set_color_count (int nr);
    static void set_color_count(nr)
    int nr;
{
    char_u nr_colors[20];
    t_colors = nr;
    if (t_colors > 1)
        sprintf((char *)nr_colors, "%d", t_colors);
    else
        *nr_colors = '\000';
    set_string_option_direct((char_u *)"t_Co", -1, nr_colors, 1);
}
static char *(key_names[]) =
{
    "Co",
    "ku", "kd", "kr", "kl",
    "#2", "#4", "%i", "*7",
    "k1", "k2", "k3", "k4", "k5", "k6",
    "k7", "k8", "k9", "k;", "F1", "F2",
    "%1", "&8", "kb", "kI", "kD", "kh",
    "@7", "kP", "kN", "K1", "K3", "K4", "K5", "kB",
    ((void *)0)
};
    int set_termname(term)
    char_u *term;
{
    struct builtin_term *termp;
    int builtin_first = p_tbi;
    int try;
    int termcap_cleared = 0;
    int width = 0, height = 0;
    char_u *error_msg = ((void *)0);
    char_u *bs_p, *del_p;
    detected_8bit = 0;
    if (term_is_builtin(term))
    {
        term += 8;
        builtin_first = 1;
    }
    for (try = builtin_first ? 0 : 1; try < 3; ++try)
    {
        if (try == 1)
        {
            char_u *p;
            static char_u tstrbuf[2048];
            int i;
            char_u tbuf[2048];
            char_u *tp;
            static struct {
                            enum SpecialKey dest;
                            char *name;
                          } string_names[] =
                            { {KS_CE, "ce"}, {KS_AL, "al"}, {KS_CAL,"AL"},
                                {KS_DL, "dl"}, {KS_CDL,"DL"}, {KS_CS, "cs"},
                                {KS_CL, "cl"}, {KS_CD, "cd"},
                                {KS_VI, "vi"}, {KS_VE, "ve"}, {KS_MB, "mb"},
                                {KS_VS, "vs"}, {KS_ME, "me"}, {KS_MR, "mr"},
                                {KS_MD, "md"}, {KS_SE, "se"}, {KS_SO, "so"},
                                {KS_CZH,"ZH"}, {KS_CZR,"ZR"}, {KS_UE, "ue"},
                                {KS_US, "us"}, {KS_CM, "cm"}, {KS_SR, "sr"},
                                {KS_CRI,"RI"}, {KS_VB, "vb"}, {KS_KS, "ks"},
                                {KS_KE, "ke"}, {KS_TI, "ti"}, {KS_TE, "te"},
                                {KS_BC, "bc"}, {KS_CSB,"Sb"}, {KS_CSF,"Sf"},
                                {KS_CAB,"AB"}, {KS_CAF,"AF"}, {KS_LE, "le"},
                                {KS_ND, "nd"}, {KS_OP, "op"}, {KS_CRV, "RV"},
                                {KS_CIS, "IS"}, {KS_CIE, "IE"},
                                {KS_TS, "ts"}, {KS_FS, "fs"},
                                {KS_CWP, "WP"}, {KS_CWS, "WS"},
                                {(enum SpecialKey)0, ((void *)0)}
                            };
            if ((error_msg = tgetent_error(tbuf, term)) == ((void *)0))
            {
                tp = tstrbuf;
                if (!termcap_cleared)
                {
                    clear_termoptions();
                    termcap_cleared = 1;
                }
                for (i = 0; string_names[i].name != ((void *)0); ++i)
                {
                    if (term_strings[(int)(string_names[i].dest)] == ((void *)0)
                            || term_strings[(int)(string_names[i].dest)] == empty_option)
                        term_strings[(int)(string_names[i].dest)] =
                                           vim_tgetstr((string_names[i].name), (&tp));
                }
                if (((term_strings[(int)(KS_MS)]) == ((void *)0) || (term_strings[(int)(KS_MS)]) == empty_option)
                                                        && tgetflag("ms") > 0)
                    (term_strings[(int)(KS_MS)]) = (char_u *)"y";
                if (((term_strings[(int)(KS_XS)]) == ((void *)0) || (term_strings[(int)(KS_XS)]) == empty_option)
                                                        && tgetflag("xs") > 0)
                    (term_strings[(int)(KS_XS)]) = (char_u *)"y";
                if (((term_strings[(int)(KS_DB)]) == ((void *)0) || (term_strings[(int)(KS_DB)]) == empty_option)
                                                        && tgetflag("db") > 0)
                    (term_strings[(int)(KS_DB)]) = (char_u *)"y";
                if (((term_strings[(int)(KS_DA)]) == ((void *)0) || (term_strings[(int)(KS_DA)]) == empty_option)
                                                        && tgetflag("da") > 0)
                    (term_strings[(int)(KS_DA)]) = (char_u *)"y";
                if (((term_strings[(int)(KS_UT)]) == ((void *)0) || (term_strings[(int)(KS_UT)]) == empty_option)
                                                        && tgetflag("ut") > 0)
                    (term_strings[(int)(KS_UT)]) = (char_u *)"y";
                for (i = 0; key_names[i] != ((void *)0); ++i)
                {
                    if (find_termcode((char_u *)key_names[i]) == ((void *)0))
                    {
                        p = vim_tgetstr((key_names[i]), (&tp));
                        if (p != ((void *)0)
                                && (*p != 8
                                    || key_names[i][0] != 'k'
                                    || key_names[i][1] != 'l'))
                            add_termcode((char_u *)key_names[i], p, 0);
                    }
                }
                if (height == 0)
                    height = tgetnum("li");
                if (width == 0)
                    width = tgetnum("co");
                if (term_strings[(int)(KS_CCO)] == ((void *)0)
                        || term_strings[(int)(KS_CCO)] == empty_option)
                    set_color_count(tgetnum("Co"));
                BC = (char *)vim_tgetstr(("bc"), (&tp));
                UP = (char *)vim_tgetstr(("up"), (&tp));
                p = vim_tgetstr(("pc"), (&tp));
                if (p)
                    PC = *p;
            }
        }
        else
        {
            if (try == 2 && builtin_first && termcap_cleared)
                break;
            termp = find_builtin_term(term);
            if (termp->bt_string == ((void *)0))
            {
                if (try == 0)
                    continue;
                if (termcap_cleared)
                    break;
                mch_errmsg("\r\n");
                if (error_msg != ((void *)0))
                {
                    mch_errmsg((char *)error_msg);
                    mch_errmsg("\r\n");
                }
                mch_errmsg("'");
                mch_errmsg((char *)term);
                mch_errmsg(((char *)("' not known. Available builtin terminals are:")));
                mch_errmsg("\r\n");
                for (termp = &(builtin_termcaps[0]); termp->bt_string != ((void *)0);
                                                                      ++termp)
                {
                    if (termp->bt_entry == (int)KS_NAME)
                    {
                        mch_errmsg("    builtin_");
                        mch_errmsg(termp->bt_string);
                        mch_errmsg("\r\n");
                    }
                }
                if (starting != 2)
                {
                    screen_start();
                    wait_return(1);
                    return 0;
                }
                term = (char_u *)"ansi";
                mch_errmsg(((char *)("defaulting to '")));
                mch_errmsg((char *)term);
                mch_errmsg("'\r\n");
                if (emsg_silent == 0)
                {
                    screen_start();
                    out_flush();
                    ui_delay(2000L, 1);
                }
                set_string_option_direct((char_u *)"term", -1, term, 1);
                display_errors();
            }
            out_flush();
            if (!termcap_cleared)
            {
                clear_termoptions();
                termcap_cleared = 1;
            }
            parse_builtin_tcap(term);
            if (term_is_gui(term))
            {
                out_flush();
                gui_init();
                if (!gui.in_use)
                    return 0;
                break;
            }
        }
    }
    if (strcmp((char *)(term), (char *)("pcterm")) == 0)
        (term_strings[(int)(KS_CCS)]) = (char_u *)"yes";
    else
        (term_strings[(int)(KS_CCS)]) = empty_option;
    if (!gui.in_use)
        get_stty();
    if (!gui.in_use)
    {
        bs_p = find_termcode((char_u *)"kb");
        del_p = find_termcode((char_u *)"kD");
        if (bs_p == ((void *)0) || *bs_p == '\000')
            add_termcode((char_u *)"kb", (bs_p = (char_u *)"\010"), 0);
        if ((del_p == ((void *)0) || *del_p == '\000') &&
                                            (bs_p == ((void *)0) || *bs_p != 0x7f))
            add_termcode((char_u *)"kD", (char_u *)(char_u *)"\177", 0);
    }
    term_is_xterm = vim_is_xterm(term);
    {
        char_u *p;
        p = (char_u *)"";
        if (!gui.in_use)
            clip_init(0);
        if (term_is_xterm)
        {
            if (use_xterm_mouse())
                p = ((void *)0);
            else
                p = (char_u *)"xterm";
        }
        if (p != ((void *)0))
            set_option_value((char_u *)"ttym", 0L, p, 0);
        if (p == ((void *)0)
                || gui.in_use
                )
            check_mouse_termcode();
    }
    if (vim_is_fastterm(term))
        p_tf = 1;
    ttest(1);
    full_screen = 1;
    set_term_defaults();
    crv_status = 1;
    if (starting != 2)
    {
        starttermcap();
        setmouse();
        maketitle();
    }
    if (width <= 0 || height <= 0)
    {
        width = 80;
        height = 24;
    }
    set_shellsize(width, height, 0);
    if (starting != 2)
    {
        if (scroll_region)
            scroll_region_reset();
        check_map_keycodes();
        {
            buf_T *old_curbuf;
            old_curbuf = curbuf;
            for (curbuf = firstbuf; curbuf != ((void *)0); curbuf = curbuf->b_next)
            {
                if (curbuf->b_ml.ml_mfp != ((void *)0))
                    apply_autocmds(EVENT_TERMCHANGED, ((void *)0), ((void *)0), 0,
                                                                      curbuf);
            }
            if (buf_valid(old_curbuf))
                curbuf = old_curbuf;
        }
    }
    may_req_termresponse();
    return 1;
}
static int has_mouse_termcode = 0;
    void set_mouse_termcode(n, s)
    int n;
    char_u *s;
{
    char_u name[2];
    name[0] = n;
    name[1] = ('X');
    add_termcode(name, s, 0);
        has_mouse_termcode |= 1;
}
    void del_mouse_termcode(n)
    int n;
{
    char_u name[2];
    name[0] = n;
    name[1] = ('X');
    del_termcode(name);
        has_mouse_termcode &= ~1;
}
    static char_u * tgetent_error(tbuf, term)
    char_u *tbuf;
    char_u *term;
{
    int i;
    i = tgetent((char *)(tbuf), (char *)(term));
    if (i < 0
            || i == 0
       )
    {
        (void)tgetent((char *)(tbuf), (char *)("dumb"));
        if (i < 0)
            return (char_u *)((char *)("E557: Cannot open termcap file"));
        if (i == 0)
            return (char_u *)((char *)("E558: Terminal entry not found in terminfo"));
    }
    return ((void *)0);
}
    static char_u * vim_tgetstr(s, pp)
    char *s;
    char_u **pp;
{
    char *p;
    p = tgetstr(s, (char **)pp);
    if (p == (char *)-1)
        p = ((void *)0);
    return (char_u *)p;
}
    void getlinecol(cp, rp)
    long *cp;
    long *rp;
{
    char_u tbuf[2048];
    if ((term_strings[(int)(KS_NAME)]) != ((void *)0) && *(term_strings[(int)(KS_NAME)]) != '\000' && tgetent_error(tbuf, (term_strings[(int)(KS_NAME)])) == ((void *)0))
    {
        if (*cp == 0)
            *cp = tgetnum("co");
        if (*rp == 0)
            *rp = tgetnum("li");
    }
}
    int add_termcap_entry(name, force)
    char_u *name;
    int force;
{
    char_u *term;
    int key;
    struct builtin_term *termp;
    char_u *string;
    int i;
    int builtin_first;
    char_u tbuf[2048];
    char_u tstrbuf[2048];
    char_u *tp = tstrbuf;
    char_u *error_msg = ((void *)0);
    if (gui.in_use || gui.starting)
        return gui_mch_haskey(name);
    if (!force && find_termcode(name) != ((void *)0))
        return 1;
    term = (term_strings[(int)(KS_NAME)]);
    if (term == ((void *)0) || *term == '\000')
        return 0;
    if (term_is_builtin(term))
    {
        term += 8;
        builtin_first = 1;
    }
    else
        builtin_first = p_tbi;
    for (i = 0; i < 2; ++i)
    {
        if (!builtin_first == i)
        {
            termp = find_builtin_term(term);
            if (termp->bt_string != ((void *)0))
            {
                key = (-((name[0]) + ((int)(name[1]) << 8)));
                while (termp->bt_entry != (int)KS_NAME)
                {
                    if ((int)termp->bt_entry == key)
                    {
                        add_termcode(name, (char_u *)termp->bt_string,
                                                          term_is_8bit(term));
                        return 1;
                    }
                    ++termp;
                }
            }
        }
        else
        {
            error_msg = tgetent_error(tbuf, term);
            if (error_msg == ((void *)0))
            {
                string = vim_tgetstr(((char *)name), (&tp));
                if (string != ((void *)0) && *string != '\000')
                {
                    add_termcode(name, string, 0);
                    return 1;
                }
            }
        }
    }
    if (sourcing_name == ((void *)0))
    {
        if (error_msg != ((void *)0))
            emsg((char_u *)(error_msg));
        else
            emsg2((char_u *)(((char *)("E436: No \"%s\" entry in termcap"))), (char_u *)(name));
    }
    return 0;
}
    static int term_is_builtin(name)
    char_u *name;
{
    return (strncmp((char *)(name), (char *)("builtin_"), (size_t)((size_t)8)) == 0);
}
    int term_is_8bit(name)
    char_u *name;
{
    return (detected_8bit || strstr((char *)name, "8bit") != ((void *)0));
}
    static int term_7to8bit(p)
    char_u *p;
{
    if (*p == '\033')
    {
        if (p[1] == '[')
            return 0x9b;
        if (p[1] == ']')
            return 0x9d;
        if (p[1] == 'O')
            return 0x8f;
    }
    return 0;
}
    int term_is_gui(name)
    char_u *name;
{
    return (strcmp((char *)(name), (char *)("builtin_gui")) == 0 || strcmp((char *)(name), (char *)("gui")) == 0);
}
    void termcapinit(name)
    char_u *name;
{
    char_u *term;
    if (name != ((void *)0) && *name == '\000')
        name = ((void *)0);
    term = name;
    if (term == ((void *)0))
        term = (char_u *)getenv((char *)((char_u *)"TERM"));
    if (term == ((void *)0) || *term == '\000')
        term = (char_u *)"ansi";
    set_string_option_direct((char_u *)"term", -1, term, 1);
    set_string_default("term", term);
    set_string_default("ttytype", term);
    set_termname((term_strings[(int)(KS_NAME)]) != ((void *)0) ? (term_strings[(int)(KS_NAME)]) : term);
}
static char_u out_buf[2047 + 1];
static int out_pos = 0;
    void out_flush()
{
    int len;
    if (out_pos != 0)
    {
        len = out_pos;
        out_pos = 0;
        ui_write(out_buf, len);
    }
}
    void out_trash()
{
    out_pos = 0;
}
    void out_char(c)
    unsigned c;
{
    if (c == '\n')
        out_char('\r');
    out_buf[out_pos++] = c;
    if (out_pos >= 2047 || p_wd)
        out_flush();
}
static void out_char_nf (unsigned);
    static void out_char_nf(c)
    unsigned c;
{
    if (c == '\n')
        out_char_nf('\r');
    out_buf[out_pos++] = c;
    if (out_pos >= 2047)
        out_flush();
}
    void out_str_nf(s)
    char_u *s;
{
    if (out_pos > 2047 - 20)
        out_flush();
    while (*s)
        out_char_nf(*s++);
    if (p_wd)
        out_flush();
}
    void out_str(s)
    char_u *s;
{
    if (s != ((void *)0) && *s)
    {
        if (gui.in_use)
        {
            out_str_nf(s);
            return;
        }
        if (out_pos > 2047 - 20)
            out_flush();
        tputs((char *)s, 1, (outfuntype) out_char_nf);
        if (p_wd)
            out_flush();
    }
}
    void term_windgoto(row, col)
    int row;
    int col;
{
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CM)]), col, row)));
}
    void term_cursor_right(i)
    int i;
{
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CRI)]), 0, i)));
}
    void term_append_lines(line_count)
    int line_count;
{
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CAL)]), 0, line_count)));
}
    void term_delete_lines(line_count)
    int line_count;
{
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CDL)]), 0, line_count)));
}
    void term_set_winpos(x, y)
    int x;
    int y;
{
    if (x < 0)
        x = 0;
    if (y < 0)
        y = 0;
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CWP)]), y, x)));
}
    void term_set_winsize(width, height)
    int width;
    int height;
{
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CWS)]), height, width)));
}
    void term_fg_color(n)
    int n;
{
    if (*(term_strings[(int)(KS_CAF)]))
        term_color((term_strings[(int)(KS_CAF)]), n);
    else if (*(term_strings[(int)(KS_CSF)]))
        term_color((term_strings[(int)(KS_CSF)]), n);
}
    void term_bg_color(n)
    int n;
{
    if (*(term_strings[(int)(KS_CAB)]))
        term_color((term_strings[(int)(KS_CAB)]), n);
    else if (*(term_strings[(int)(KS_CSB)]))
        term_color((term_strings[(int)(KS_CSB)]), n);
}
    static void term_color(s, n)
    char_u *s;
    int n;
{
    char buf[20];
    int i = 2;
    if (n >= 8 && t_colors >= 16
              && ((s[0] == '\033' && s[1] == '[') || (s[0] == 0x9b && (i = 1) == 1))
              && s[i] != '\000'
              && (strcmp((char *)(s + i + 1), (char *)("%p1%dm")) == 0
                  || strcmp((char *)(s + i + 1), (char *)("%dm")) == 0)
              && (s[i] == '3' || s[i] == '4'))
    {
        sprintf(buf,
                "%s%s%%p1%%dm",
                i == 2 ? "\033[" : "\233",
                s[i] == '3' ? (n >= 16 ? "38;5;" : "9")
                            : (n >= 16 ? "48;5;" : "10"));
        out_str((char_u *)(tgoto(buf, 0, n >= 16 ? n : n - 8)));
    }
    else
        out_str((char_u *)(tgoto((char *)s, 0, n)));
}
    void term_settitle(title)
    char_u *title;
{
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_TS)]), 0, 0)));
    out_str_nf(title);
    out_str((term_strings[(int)(KS_FS)]));
    out_flush();
}
    void ttest(pairs)
    int pairs;
{
    check_options();
    if (*(term_strings[(int)(KS_CM)]) == '\000')
        emsg((char_u *)(((char *)("E437: terminal capability \"cm\" required"))));
    if (*(term_strings[(int)(KS_CS)]) != '\000')
        scroll_region = 1;
    else
        scroll_region = 0;
    if (pairs)
    {
        if (*(term_strings[(int)(KS_ME)]) == '\000')
            (term_strings[(int)(KS_ME)]) = (term_strings[(int)(KS_MR)]) = (term_strings[(int)(KS_MD)]) = (term_strings[(int)(KS_MB)]) = empty_option;
        if (*(term_strings[(int)(KS_SO)]) == '\000' || *(term_strings[(int)(KS_SE)]) == '\000')
            (term_strings[(int)(KS_SO)]) = (term_strings[(int)(KS_SE)]) = empty_option;
        if (*(term_strings[(int)(KS_US)]) == '\000' || *(term_strings[(int)(KS_UE)]) == '\000')
            (term_strings[(int)(KS_US)]) = (term_strings[(int)(KS_UE)]) = empty_option;
        if (*(term_strings[(int)(KS_CZH)]) == '\000' || *(term_strings[(int)(KS_CZR)]) == '\000')
            (term_strings[(int)(KS_CZH)]) = (term_strings[(int)(KS_CZR)]) = empty_option;
        if (*(term_strings[(int)(KS_VE)]) == '\000')
            (term_strings[(int)(KS_VI)]) = empty_option;
        if (*(term_strings[(int)(KS_ME)]) == '\000')
        {
            (term_strings[(int)(KS_ME)]) = (term_strings[(int)(KS_SE)]);
            (term_strings[(int)(KS_MR)]) = (term_strings[(int)(KS_SO)]);
            (term_strings[(int)(KS_MD)]) = (term_strings[(int)(KS_SO)]);
        }
        if (*(term_strings[(int)(KS_SO)]) == '\000')
        {
            (term_strings[(int)(KS_SE)]) = (term_strings[(int)(KS_ME)]);
            if (*(term_strings[(int)(KS_MR)]) == '\000')
                (term_strings[(int)(KS_SO)]) = (term_strings[(int)(KS_MD)]);
            else
                (term_strings[(int)(KS_SO)]) = (term_strings[(int)(KS_MR)]);
        }
        if (*(term_strings[(int)(KS_CZH)]) == '\000')
        {
            (term_strings[(int)(KS_CZR)]) = (term_strings[(int)(KS_ME)]);
            if (*(term_strings[(int)(KS_MR)]) == '\000')
                (term_strings[(int)(KS_CZH)]) = (term_strings[(int)(KS_MD)]);
            else
                (term_strings[(int)(KS_CZH)]) = (term_strings[(int)(KS_MR)]);
        }
        if (*(term_strings[(int)(KS_CSB)]) == '\000' || *(term_strings[(int)(KS_CSF)]) == '\000')
        {
            (term_strings[(int)(KS_CSB)]) = empty_option;
            (term_strings[(int)(KS_CSF)]) = empty_option;
        }
        if (*(term_strings[(int)(KS_CAB)]) == '\000' || *(term_strings[(int)(KS_CAF)]) == '\000')
        {
            (term_strings[(int)(KS_CAB)]) = empty_option;
            (term_strings[(int)(KS_CAF)]) = empty_option;
        }
        if (*(term_strings[(int)(KS_CSB)]) == '\000' && *(term_strings[(int)(KS_CAB)]) == '\000')
            (term_strings[(int)(KS_CCO)]) = empty_option;
        p_wiv = (*(term_strings[(int)(KS_XS)]) != '\000');
    }
    need_gather = 1;
    t_colors = atoi((char *)(term_strings[(int)(KS_CCO)]));
}
    void add_long_to_buf(val, dst)
    long_u val;
    char_u *dst;
{
    int i;
    int shift;
    for (i = 1; i <= sizeof(long_u); i++)
    {
        shift = 8 * (sizeof(long_u) - i);
        dst[i - 1] = (char_u) ((val >> shift) & 0xff);
    }
}
static int get_long_from_buf (char_u *buf, long_u *val);
    static int get_long_from_buf(buf, val)
    char_u *buf;
    long_u *val;
{
    int len;
    char_u bytes[sizeof(long_u)];
    int i;
    int shift;
    *val = 0;
    len = get_bytes_from_buf(buf, bytes, (int)sizeof(long_u));
    if (len != -1)
    {
        for (i = 0; i < sizeof(long_u); i++)
        {
            shift = 8 * (sizeof(long_u) - 1 - i);
            *val += (long_u)bytes[i] << shift;
        }
    }
    return len;
}
    static int get_bytes_from_buf(buf, bytes, num_bytes)
    char_u *buf;
    char_u *bytes;
    int num_bytes;
{
    int len = 0;
    int i;
    char_u c;
    for (i = 0; i < num_bytes; i++)
    {
        if ((c = buf[len++]) == '\000')
            return -1;
        if (c == (0x80))
        {
            if (buf[len] == '\000' || buf[len + 1] == '\000')
                return -1;
            if (buf[len++] == (int)255)
                c = '\000';
            ++len;
        }
        bytes[i] = c;
    }
    return len;
}
    void check_shellsize()
{
    if (Columns < 12)
        Columns = 12;
    if (Rows < min_rows())
        Rows = min_rows();
}
    void win_new_shellsize()
{
    static int old_Rows = 0;
    static int old_Columns = 0;
    if (old_Rows != Rows || old_Columns != Columns)
        ui_new_shellsize();
    if (old_Rows != Rows)
    {
        old_Rows = Rows;
        shell_new_rows();
    }
    if (old_Columns != Columns)
    {
        old_Columns = Columns;
        shell_new_columns();
    }
}
    void shell_resized()
{
    set_shellsize(0, 0, 0);
}
    void shell_resized_check()
{
    int old_Rows = Rows;
    int old_Columns = Columns;
    (void)ui_get_shellsize();
    check_shellsize();
    if (old_Rows != Rows || old_Columns != Columns)
        shell_resized();
}
    void set_shellsize(width, height, mustset)
    int width, height;
    int mustset;
{
    static int busy = 0;
    if (busy)
        return;
    if (width < 0 || height < 0)
        return;
    if (State == (0x200 + 0x01) || State == 0x400)
    {
        State = 0x400;
        return;
    }
    ++busy;
    if (mustset || (ui_get_shellsize() == 0 && height != 0))
    {
        Rows = height;
        Columns = width;
        check_shellsize();
        ui_set_shellsize(mustset);
    }
    else
        check_shellsize();
    win_new_shellsize();
    if (State != 0x300 && State != 0x600 && State != 0x800)
        screenclear();
    else
        screen_start();
    if (starting != 2)
    {
        maketitle();
        changed_line_abv_curs();
        invalidate_botline();
        if (State == 0x300 || State == 0x600 || State == 0x800
                                                             || exmode_active)
        {
            screenalloc(0);
            repeat_message();
        }
        else if (State & 0x08)
        {
            update_screen(40);
            redrawcmdline();
        }
        else
        {
            update_topline();
            update_screen(40);
            if (redrawing())
                setcursor();
        }
        cursor_on();
    }
    out_flush();
    --busy;
}
    void settmode(tmode)
    int tmode;
{
    if (gui.in_use)
        return;
    if (full_screen)
    {
        if (exmode_active == 1)
            tmode = 0;
        if (tmode != 0 || cur_tmode != 0)
        {
            if (tmode != 2 && crv_status == 2)
                (void)vpeekc_nomap();
            check_for_codes_from_term();
            if (tmode != 2)
                mch_setmouse(0);
            out_flush();
            mch_settmode(tmode);
            cur_tmode = tmode;
            if (tmode == 2)
                setmouse();
            out_flush();
        }
        may_req_termresponse();
    }
}
    void starttermcap()
{
    if (full_screen && !termcap_active)
    {
        out_str((term_strings[(int)(KS_TI)]));
        out_str((term_strings[(int)(KS_KS)]));
        out_flush();
        termcap_active = 1;
        screen_start();
        may_req_termresponse();
        check_for_codes_from_term();
    }
}
    void stoptermcap()
{
    screen_stop_highlight();
    reset_cterm_colors();
    if (termcap_active)
    {
        if (crv_status == 2)
            (void)vpeekc_nomap();
        check_for_codes_from_term();
        out_str((term_strings[(int)(KS_KE)]));
        out_flush();
        termcap_active = 0;
        cursor_on();
        out_str((term_strings[(int)(KS_TE)]));
        screen_start();
        out_flush();
    }
}
    static void may_req_termresponse()
{
    if (crv_status == 1
            && cur_tmode == 2
            && termcap_active
            && isatty(1)
            && *(term_strings[(int)(KS_CRV)]) != '\000')
    {
        out_str((term_strings[(int)(KS_CRV)]));
        crv_status = 2;
        out_flush();
        (void)vpeekc_nomap();
    }
}
    int swapping_screen()
{
    return (full_screen && *(term_strings[(int)(KS_TI)]) != '\000');
}
    void setmouse()
{
    int checkfor;
    update_mouseshape(-1);
    if (gui.in_use)
        return;
    if (*p_mouse == '\000' || has_mouse_termcode == 0)
        return;
    if (cur_tmode != 2)
    {
        mch_setmouse(0);
        return;
    }
    if (VIsual_active)
        checkfor = 'v';
    else
        if (State == (0x200 + 0x01) || State == 0x300 || State == 0x400)
        checkfor = 'r';
    else if (State & 0x10)
        checkfor = 'i';
    else if (State & 0x08)
        checkfor = 'c';
    else if (State == 0x800 || State == 0x600)
        checkfor = ' ';
    else
        checkfor = 'n';
    if (mouse_has(checkfor))
        mch_setmouse(1);
    else
        mch_setmouse(0);
}
    int mouse_has(c)
    int c;
{
    char_u *p;
    for (p = p_mouse; *p; ++p)
        switch (*p)
        {
            case 'a': if (vim_strchr((char_u *)"nvich", c) != ((void *)0))
                          return 1;
                      break;
            case 'h': if (c != 'r' && curbuf->b_help)
                                 return 1;
                             break;
            default: if (c == *p) return 1; break;
        }
    return 0;
}
    int mouse_model_popup()
{
    return (p_mousem[0] == 'p');
}
    void scroll_start()
{
    if (*(term_strings[(int)(KS_VS)]) != '\000')
    {
        out_str((term_strings[(int)(KS_VS)]));
        out_str((term_strings[(int)(KS_VE)]));
        screen_start();
    }
}
static int cursor_is_off = 0;
    void cursor_on()
{
    if (cursor_is_off)
    {
        out_str((term_strings[(int)(KS_VE)]));
        cursor_is_off = 0;
    }
}
    void cursor_off()
{
    if (full_screen)
    {
        if (!cursor_is_off)
            out_str((term_strings[(int)(KS_VI)]));
        cursor_is_off = 1;
    }
}
    void scroll_region_set(wp, off)
    win_T *wp;
    int off;
{
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CS)]), (wp->w_winrow) + wp->w_height - 1, (wp->w_winrow) + off)));
    if (*(term_strings[(int)(KS_CSV)]) != '\000' && wp->w_width != Columns)
        out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CSV)]), (wp->w_wincol) + wp->w_width - 1, (wp->w_wincol))));
    screen_start();
}
    void scroll_region_reset()
{
    out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CS)]), (int)Rows - 1, 0)));
    if (*(term_strings[(int)(KS_CSV)]) != '\000')
        out_str((char_u *)(tgoto((char *)(term_strings[(int)(KS_CSV)]), (int)Columns - 1, 0)));
    screen_start();
}
struct termcode
{
    char_u name[2];
    char_u *code;
    int len;
} *termcodes = ((void *)0);
static int tc_max_len = 0;
static int tc_len = 0;
    void clear_termcodes()
{
    while (tc_len > 0)
        vim_free(termcodes[--tc_len].code);
    vim_free(termcodes);
    termcodes = ((void *)0);
    tc_max_len = 0;
    BC = (char *)empty_option;
    UP = (char *)empty_option;
    PC = '\000';
    ospeed = 0;
    need_gather = 1;
}
    void add_termcode(name, string, use_8bit)
    char_u *name;
    char_u *string;
    int use_8bit;
{
    struct termcode *new_tc;
    int i, j;
    char_u *s;
    if (string == ((void *)0) || *string == '\000')
    {
        del_termcode(name);
        return;
    }
    s = vim_strsave(string);
    if (s == ((void *)0))
        return;
    if (use_8bit && term_7to8bit(string) != 0)
    {
        memmove((char *)(s), (char *)(s + 1), strlen((char *)(s)));
        s[0] = term_7to8bit(string);
    }
    need_gather = 1;
    if (tc_len == tc_max_len)
    {
        tc_max_len += 20;
        new_tc = (struct termcode *)alloc(
                            (unsigned)(tc_max_len * sizeof(struct termcode)));
        if (new_tc == ((void *)0))
        {
            tc_max_len -= 20;
            return;
        }
        for (i = 0; i < tc_len; ++i)
            new_tc[i] = termcodes[i];
        vim_free(termcodes);
        termcodes = new_tc;
    }
    for (i = 0; i < tc_len; ++i)
    {
        if (termcodes[i].name[0] < name[0])
            continue;
        if (termcodes[i].name[0] == name[0])
        {
            if (termcodes[i].name[1] < name[1])
                continue;
            if (termcodes[i].name[1] == name[1])
            {
                vim_free(termcodes[i].code);
                --tc_len;
                break;
            }
        }
        for (j = tc_len; j > i; --j)
            termcodes[j] = termcodes[j - 1];
        break;
    }
    termcodes[i].name[0] = name[0];
    termcodes[i].name[1] = name[1];
    termcodes[i].code = s;
    termcodes[i].len = (int)strlen((char *)(s));
    ++tc_len;
}
    char_u * find_termcode(name)
    char_u *name;
{
    int i;
    for (i = 0; i < tc_len; ++i)
        if (termcodes[i].name[0] == name[0] && termcodes[i].name[1] == name[1])
            return termcodes[i].code;
    return ((void *)0);
}
    char_u * get_termcode(i)
    int i;
{
    if (i >= tc_len)
        return ((void *)0);
    return &termcodes[i].name[0];
}
    void del_termcode(name)
    char_u *name;
{
    int i;
    if (termcodes == ((void *)0))
        return;
    need_gather = 1;
    for (i = 0; i < tc_len; ++i)
        if (termcodes[i].name[0] == name[0] && termcodes[i].name[1] == name[1])
        {
            del_termcode_idx(i);
            return;
        }
}
    static void del_termcode_idx(idx)
    int idx;
{
    int i;
    vim_free(termcodes[idx].code);
    --tc_len;
    for (i = idx; i < tc_len; ++i)
        termcodes[i] = termcodes[i + 1];
}
    static void switch_to_8bit()
{
    int i;
    int c;
    if (!term_is_8bit((term_strings[(int)(KS_NAME)])))
    {
        for (i = 0; i < tc_len; ++i)
        {
            c = term_7to8bit(termcodes[i].code);
            if (c != 0)
            {
                memmove((char *)(termcodes[i].code + 1), (char *)(termcodes[i].code + 2), strlen((char *)(termcodes[i].code + 1)));
                termcodes[i].code[0] = c;
            }
        }
        need_gather = 1;
    }
    detected_8bit = 1;
}
static linenr_T orig_topline = 0;
static int orig_topfill = 0;
    void set_mouse_topline(wp)
    win_T *wp;
{
    orig_topline = wp->w_topline;
    orig_topfill = wp->w_topfill;
}
    int check_termcode(max_offset, buf, buflen)
    int max_offset;
    char_u *buf;
    int buflen;
{
    char_u *tp;
    char_u *p;
    int slen = 0;
    int len;
    int offset;
    char_u key_name[2];
    int new_slen;
    int extra;
    char_u string[6 + 1];
    int i, j;
    int idx = 0;
    char_u bytes[6];
    int num_bytes;
    int mouse_code = 0;
    int modifiers;
    int is_click, is_drag;
    int wheel_code = 0;
    int current_button;
    static int held_button = 0x03;
    static int orig_num_clicks = 1;
    static int orig_mouse_code = 0x0;
    static int orig_mouse_col = 0;
    static int orig_mouse_row = 0;
    static struct timeval orig_mouse_time = {0, 0};
    struct timeval mouse_time;
    long timediff;
    int cpo_koffset;
    cpo_koffset = (vim_strchr(p_cpo, 'K') != ((void *)0));
    if (need_gather)
        gather_termleader();
    for (offset = 0; offset < max_offset; ++offset)
    {
        if (buf == ((void *)0))
        {
            if (offset >= typebuf.tb_len)
                break;
            tp = typebuf.tb_buf + typebuf.tb_off + offset;
            len = typebuf.tb_len - offset;
        }
        else
        {
            if (offset >= buflen)
                break;
            tp = buf + offset;
            len = buflen - offset;
        }
        if (*tp == (0x80))
        {
            offset += 2;
            continue;
        }
        i = *tp;
        for (p = termleader; *p && *p != i; ++p)
            ;
        if (*p == '\000')
            continue;
        if (*tp == '\033' && !p_ek && (State & 0x10))
            continue;
        new_slen = 0;
        key_name[0] = '\000';
        if (gui.in_use)
        {
            if (*tp == 0x9b)
            {
                if (len < 3)
                    return -1;
                slen = 3;
                key_name[0] = tp[1];
                key_name[1] = tp[2];
            }
        }
        else
        {
            for (idx = 0; idx < tc_len; ++idx)
            {
                slen = termcodes[idx].len;
                if (cpo_koffset && offset && len < slen)
                    continue;
                if (strncmp((char *)(termcodes[idx].code), (char *)(tp), (size_t)((size_t)(slen > len ? len : slen))) == 0)
                {
                    if (len < slen)
                        return -1;
                    if (termcodes[idx].name[0] == 'K'
                                           && (__ctype_b[(int) ((termcodes[idx].name[1]))] & (unsigned short int) _ISdigit))
                    {
                        for (j = idx + 1; j < tc_len; ++j)
                            if (termcodes[j].len == slen &&
                                    strncmp((char *)(termcodes[idx].code), (char *)(termcodes[j].code), (size_t)(slen)) == 0)
                            {
                                idx = j;
                                break;
                            }
                    }
                    key_name[0] = termcodes[idx].name[0];
                    key_name[1] = termcodes[idx].name[1];
                    break;
                }
            }
        }
        if (key_name[0] == '\000')
        {
            if (*(term_strings[(int)(KS_CRV)]) != '\000' && ((tp[0] == '\033' && tp[1] == '[' && len >= 3)
                                               || (tp[0] == 0x9b && len >= 2)))
            {
                j = 0;
                extra = 0;
                for (i = 2 + (tp[0] != 0x9b);
                        i < len && ((__ctype_b[(int) ((tp[i]))] & (unsigned short int) _ISdigit)
                            || tp[i] == ';' || tp[i] == '.'); ++i)
                    if (tp[i] == ';' && ++j == 1)
                        extra = atoi((char *)tp + i + 1);
                if (i == len)
                    return -1;
                if (i > 2 + (tp[0] != 0x9b) && tp[i] == 'c')
                {
                    crv_status = 3;
                    if (tp[0] == 0x9b)
                        switch_to_8bit();
                    if (extra > 20000)
                        extra = 0;
                    if (tp[1 + (tp[0] != 0x9b)] == '>' && j == 2)
                    {
                        if (extra >= 95)
                            set_option_value((char_u *)"ttym", 0L,
                                                       (char_u *)"xterm2", 0);
                        if (extra >= 141)
                        {
                            check_for_codes = 1;
                            need_gather = 1;
                            req_codes_from_term();
                        }
                    }
                    set_vim_var_string(10, tp, i + 1);
                    apply_autocmds(EVENT_TERMRESPONSE,
                                                   ((void *)0), ((void *)0), 0, curbuf);
                    key_name[0] = (int)253;
                    key_name[1] = (int)KE_IGNORE;
                    slen = i + 1;
                }
            }
            else if (check_for_codes
                    && ((tp[0] == '\033' && tp[1] == 'P' && len >= 2)
                        || tp[0] == 0x90))
            {
                j = 1 + (tp[0] != 0x90);
                for (i = j; i < len; ++i)
                    if ((tp[i] == '\033' && tp[i + 1] == '\\' && i + 1 < len)
                            || tp[i] == 0x9c)
                    {
                        if (i - j >= 3 && tp[j + 1] == '+' && tp[j + 2] == 'r')
                            got_code_from_term(tp + j, i);
                        key_name[0] = (int)253;
                        key_name[1] = (int)KE_IGNORE;
                        slen = i + 1 + (tp[i] == '\033');
                        break;
                    }
                if (i == len)
                    return -1;
            }
        }
        if (key_name[0] == '\000')
            continue;
        if (gui.in_use
                && key_name[0] == (int)253
                && (key_name[1] == (int)KE_X1MOUSE
                    || key_name[1] == (int)KE_X2MOUSE
                    || key_name[1] == (int)KE_MOUSEDOWN
                    || key_name[1] == (int)KE_MOUSEUP))
        {
            num_bytes = get_bytes_from_buf(tp + slen, bytes, 4);
            if (num_bytes == -1)
                return -1;
            mouse_col = 128 * (bytes[0] - ' ' - 1) + bytes[1] - ' ' - 1;
            mouse_row = 128 * (bytes[2] - ' ' - 1) + bytes[3] - ' ' - 1;
            slen += num_bytes;
        }
        else
        if (key_name[0] == (int)251
                )
        {
            is_click = is_drag = 0;
            if (key_name[0] == (int)251)
            {
                for (;;)
                {
                    if (gui.in_use)
                    {
                        num_bytes = get_bytes_from_buf(tp + slen, bytes, 5);
                        if (num_bytes == -1)
                            return -1;
                        mouse_code = bytes[0];
                        mouse_col = 128 * (bytes[1] - ' ' - 1)
                                                         + bytes[2] - ' ' - 1;
                        mouse_row = 128 * (bytes[3] - ' ' - 1)
                                                         + bytes[4] - ' ' - 1;
                    }
                    else
                    {
                        num_bytes = get_bytes_from_buf(tp + slen, bytes, 3);
                        if (num_bytes == -1)
                            return -1;
                        mouse_code = bytes[0];
                        mouse_col = bytes[1] - ' ' - 1;
                        mouse_row = bytes[2] - ' ' - 1;
                    }
                    slen += num_bytes;
                    if (gui.in_use)
                        j = 3;
                    else
                        j = termcodes[idx].len;
                    if (strncmp((char *)(tp), (char *)(tp + slen), (size_t)((size_t)j)) == 0
                            && tp[slen + j] == mouse_code
                            && tp[slen + j + 1] != '\000'
                            && tp[slen + j + 2] != '\000'
                            && (!gui.in_use
                                || (tp[slen + j + 3] != '\000'
                                        && tp[slen + j + 4] != '\000'))
                            )
                        slen += j;
                    else
                        break;
                }
                if (mouse_code >= 0x60
                        && !gui.in_use
                        )
                {
                    wheel_code = mouse_code;
                }
                else if (held_button == 0x03
                        && (mouse_code == 0x23 || mouse_code == 0x24))
                {
                    wheel_code = mouse_code - 0x23 + 0x60;
                }
                else if (use_xterm_mouse() > 1)
                {
                    if (mouse_code & 0x40)
                        mouse_code |= (0x40 | 0x03);
                }
                else if (!(mouse_code & (0x40 | 0x03) & ~0x03))
                {
                    if ((mouse_code & 0x03) == 0x03)
                        stop_xterm_trace();
                    else
                        start_xterm_trace(mouse_code);
                }
            }
            current_button = (mouse_code & 0x03);
            if (current_button == 0x03
                    && wheel_code == 0
                    )
            {
                if ((mouse_code & (0x40 | 0x03)) == (0x40 | 0x03))
                    is_drag = 1;
                current_button = held_button;
            }
            else if (wheel_code == 0)
            {
                if (!gui.in_use)
                {
                    gettimeofday(&mouse_time, ((void *)0));
                    timediff = (mouse_time.tv_usec
                                            - orig_mouse_time.tv_usec) / 1000;
                    if (timediff < 0)
                        --orig_mouse_time.tv_sec;
                    timediff += (mouse_time.tv_sec
                                             - orig_mouse_time.tv_sec) * 1000;
                    orig_mouse_time = mouse_time;
                    if (mouse_code == orig_mouse_code
                            && timediff < p_mouset
                            && orig_num_clicks != 4
                            && orig_mouse_col == mouse_col
                            && orig_mouse_row == mouse_row
                            && orig_topfill == curwin->w_topfill
                            && orig_topline == curwin->w_topline)
                        ++orig_num_clicks;
                    else
                        orig_num_clicks = 1;
                    orig_mouse_col = mouse_col;
                    orig_mouse_row = mouse_row;
                    orig_topline = curwin->w_topline;
                    orig_topfill = curwin->w_topfill;
                }
                else
                    orig_num_clicks = (((unsigned)((mouse_code) & 0xC0) >> 6) + 1);
                is_click = 1;
                orig_mouse_code = mouse_code;
            }
            if (!is_drag)
                held_button = mouse_code & 0x03;
            modifiers = 0x0;
            if (orig_mouse_code & 0x04)
                modifiers |= 0x02;
            if (orig_mouse_code & 0x10)
                modifiers |= 0x04;
            if (orig_mouse_code & 0x08)
                modifiers |= 0x08;
            if (orig_num_clicks == 2)
                modifiers |= 0x10;
            else if (orig_num_clicks == 3)
                modifiers |= 0x20;
            else if (orig_num_clicks == 4)
                modifiers |= 0x30;
            if (modifiers != 0)
            {
                string[new_slen++] = (0x80);
                string[new_slen++] = (int)252;
                string[new_slen++] = modifiers;
            }
            key_name[0] = (int)253;
            if (wheel_code != 0)
                key_name[1] = (wheel_code & 1)
                                        ? (int)KE_MOUSEUP : (int)KE_MOUSEDOWN;
            else
                key_name[1] = get_pseudo_mouse_code(current_button,
                                                           is_click, is_drag);
        }
        else if (key_name[0] == (int)250)
        {
            long_u val;
            num_bytes = get_long_from_buf(tp + slen, &val);
            if (num_bytes == -1)
                return -1;
            current_menu = (vimmenu_T *)val;
            slen += num_bytes;
        }
        else if (key_name[0] == (int)249)
        {
            long_u val;
            j = 0;
            for (i = 0; tp[j] == 0x9b && tp[j + 1] == 249
                                                     && tp[j + 2] != '\000'; ++i)
            {
                j += 3;
                num_bytes = get_bytes_from_buf(tp + j, bytes, 1);
                if (num_bytes == -1)
                    break;
                if (i == 0)
                    current_scrollbar = (int)bytes[0];
                else if (current_scrollbar != (int)bytes[0])
                    break;
                j += num_bytes;
                num_bytes = get_long_from_buf(tp + j, &val);
                if (num_bytes == -1)
                    break;
                scrollbar_value = val;
                j += num_bytes;
                slen = j;
            }
            if (i == 0)
                return -1;
        }
        else if (key_name[0] == (int)248)
        {
            long_u val;
            j = 0;
            for (i = 0; tp[j] == 0x9b && tp[j + 1] == 248
                                                     && tp[j + 2] != '\000'; ++i)
            {
                j += 3;
                num_bytes = get_long_from_buf(tp + j, &val);
                if (num_bytes == -1)
                    break;
                scrollbar_value = val;
                j += num_bytes;
                slen = j;
            }
            if (i == 0)
                return -1;
        }
        if (key_name[0] == 242)
            string[new_slen++] = key_name[1];
        else
        {
            string[new_slen++] = (0x80);
            string[new_slen++] = key_name[0];
            string[new_slen++] = key_name[1];
        }
        string[new_slen] = '\000';
        extra = new_slen - slen;
        if (buf == ((void *)0))
        {
            if (extra < 0)
                del_typebuf(-extra, offset);
            else if (extra > 0)
                ins_typebuf(string + slen, 0, offset, 0, 0);
            memmove((char *)(typebuf.tb_buf + typebuf.tb_off + offset), (char *)(string), (size_t)new_slen);
        }
        else
        {
            if (extra < 0)
                memmove((char *)(buf + offset), (char *)(buf + offset - extra), (size_t)(buflen + offset + extra));
            else if (extra > 0)
                memmove((char *)(buf + offset + extra), (char *)(buf + offset), (size_t)(buflen - offset));
            memmove((char *)(buf + offset), (char *)(string), (size_t)new_slen);
        }
        return (len + extra + offset);
    }
    return 0;
}
    char_u * replace_termcodes(from, bufp, from_part, do_lt)
    char_u *from;
    char_u **bufp;
    int from_part;
    int do_lt;
{
    int i;
    int slen;
    int key;
    int dlen = 0;
    char_u *src;
    int do_backslash;
    int do_special;
    int do_key_code;
    char_u *result;
    do_backslash = (vim_strchr(p_cpo, 'B') == ((void *)0));
    do_special = (vim_strchr(p_cpo, '<') == ((void *)0));
    do_key_code = (vim_strchr(p_cpo, 'k') == ((void *)0));
    result = alloc((unsigned)strlen((char *)(from)) * 6 + 1);
    if (result == ((void *)0))
    {
        *bufp = ((void *)0);
        return from;
    }
    src = from;
    if (from_part && src[0] == '#' && (__ctype_b[(int) ((src[1]))] & (unsigned short int) _ISdigit))
    {
        result[dlen++] = (0x80);
        result[dlen++] = 'k';
        if (src[1] == '0')
            result[dlen++] = ';';
        else
            result[dlen++] = src[1];
        src += 2;
    }
    while (*src != '\000')
    {
        if (do_special && (do_lt || strncmp((char *)(src), (char *)("<lt>"), (size_t)(4)) != 0))
        {
            if (strncasecmp((char *)(src), (char *)("<SID>"), (size_t)(5)) == 0)
            {
                if (current_SID <= 0)
                    emsg((char_u *)(((char *)(e_usingsid))));
                else
                {
                    src += 5;
                    result[dlen++] = (0x80);
                    result[dlen++] = (int)253;
                    result[dlen++] = (int)KE_SNR;
                    sprintf((char *)result + dlen, "%ld", (long)current_SID);
                    dlen += (int)strlen((char *)(result + dlen));
                    result[dlen++] = '_';
                    continue;
                }
            }
            slen = trans_special(&src, result + dlen, 1);
            if (slen)
            {
                dlen += slen;
                continue;
            }
        }
        if (do_key_code)
        {
            i = find_term_bykeys(src);
            if (i >= 0)
            {
                result[dlen++] = (0x80);
                result[dlen++] = termcodes[i].name[0];
                result[dlen++] = termcodes[i].name[1];
                src += termcodes[i].len;
                continue;
            }
        }
        if (do_special)
        {
            char_u *p, *s, len;
            if (strncasecmp((char *)(src), (char *)("<Leader>"), (size_t)(8)) == 0)
            {
                len = 8;
                p = get_var_value((char_u *)"g:mapleader");
            }
            else if (strncasecmp((char *)(src), (char *)("<LocalLeader>"), (size_t)(13)) == 0)
            {
                len = 13;
                p = get_var_value((char_u *)"g:maplocalleader");
            }
            else
            {
                len = 0;
                p = ((void *)0);
            }
            if (len != 0)
            {
                if (p == ((void *)0) || *p == '\000' || strlen((char *)(p)) > 8 * 6)
                    s = (char_u *)"\\";
                else
                    s = p;
                while (*s != '\000')
                    result[dlen++] = *s++;
                src += len;
                continue;
            }
        }
        key = *src;
        if (key == 22 || (do_backslash && key == '\\'))
        {
            ++src;
            if (*src == '\000')
            {
                if (from_part)
                    result[dlen++] = key;
                break;
            }
        }
        {
            if (*src == (0x80))
            {
                result[dlen++] = (0x80);
                result[dlen++] = 254;
                result[dlen++] = ('X');
            }
            else if (*src == 0x9b)
            {
                result[dlen++] = (0x80);
                result[dlen++] = 253;
                result[dlen++] = (int)KE_CSI;
            }
            else
                result[dlen++] = *src;
            ++src;
        }
    }
    result[dlen] = '\000';
    if ((*bufp = vim_strsave(result)) != ((void *)0))
        from = *bufp;
    vim_free(result);
    return from;
}
    int find_term_bykeys(src)
    char_u *src;
{
    int i;
    int slen;
    for (i = 0; i < tc_len; ++i)
    {
        slen = termcodes[i].len;
        if (slen > 1 && strncmp((char *)(termcodes[i].code), (char *)(src), (size_t)((size_t)slen)) == 0)
            return i;
    }
    return -1;
}
    static void gather_termleader()
{
    int i;
    int len = 0;
    if (gui.in_use)
        termleader[len++] = 0x9b;
    if (check_for_codes)
        termleader[len++] = 0x90;
    termleader[len] = '\000';
    for (i = 0; i < tc_len; ++i)
        if (vim_strchr(termleader, termcodes[i].code[0]) == ((void *)0))
        {
            termleader[len++] = termcodes[i].code[0];
            termleader[len] = '\000';
        }
    need_gather = 0;
}
    void show_termcodes()
{
    int col;
    int *items;
    int item_count;
    int run;
    int row, rows;
    int cols;
    int i;
    int len;
    if (tc_len == 0)
        return;
    items = (int *)alloc((unsigned)(sizeof(int) * tc_len));
    if (items == ((void *)0))
        return;
    msg_puts_title((char_u *)(((char *)("\n--- Terminal keys ---"))));
    for (run = 1; run <= 2 && !got_int; ++run)
    {
        item_count = 0;
        for (i = 0; i < tc_len; i++)
        {
            len = show_one_termcode(termcodes[i].name,
                                                    termcodes[i].code, 0);
            if ((len <= 27 - 2 && run == 1) || (len > 27 - 2 && run == 2))
                items[item_count++] = i;
        }
        if (run == 1)
        {
            cols = (Columns + 2) / 27;
            if (cols == 0)
                cols = 1;
            rows = (item_count + cols - 1) / cols;
        }
        else
            rows = item_count;
        for (row = 0; row < rows && !got_int; ++row)
        {
            msg_putchar('\n');
            if (got_int)
                break;
            col = 0;
            for (i = row; i < item_count; i += rows)
            {
                msg_col = col;
                show_one_termcode(termcodes[items[i]].name,
                                              termcodes[items[i]].code, 1);
                col += 27;
            }
            out_flush();
            ui_breakcheck();
        }
    }
    vim_free(items);
}
    int show_one_termcode(name, code, printit)
    char_u *name;
    char_u *code;
    int printit;
{
    char_u *p;
    int len;
    if (name[0] > '~')
    {
        IObuff[0] = ' ';
        IObuff[1] = ' ';
        IObuff[2] = ' ';
        IObuff[3] = ' ';
    }
    else
    {
        IObuff[0] = 't';
        IObuff[1] = '_';
        IObuff[2] = name[0];
        IObuff[3] = name[1];
    }
    IObuff[4] = ' ';
    p = get_special_key_name((-((name[0]) + ((int)(name[1]) << 8))), 0);
    if (p[1] != 't')
        strcpy((char *)(IObuff + 5), (char *)(p));
    else
        IObuff[5] = '\000';
    len = (int)strlen((char *)(IObuff));
    do
        IObuff[len++] = ' ';
    while (len < 17);
    IObuff[len] = '\000';
    if (code == ((void *)0))
        len += 4;
    else
        len += vim_strsize(code);
    if (printit)
    {
        msg_puts(IObuff);
        if (code == ((void *)0))
            msg_puts((char_u *)"NULL");
        else
            msg_outtrans(code);
    }
    return len;
}
static int xt_index_in = 0;
static int xt_index_out = 0;
    static void req_codes_from_term()
{
    xt_index_out = 0;
    xt_index_in = 0;
    req_more_codes_from_term();
}
    static void req_more_codes_from_term()
{
    char buf[11];
    int old_idx = xt_index_out;
    if (exiting)
        return;
    while (xt_index_out < xt_index_in + 10 && key_names[xt_index_out] != ((void *)0))
    {
        sprintf(buf, "\033P+q%02x%02x\033\\",
                      key_names[xt_index_out][0], key_names[xt_index_out][1]);
        out_str_nf((char_u *)buf);
        ++xt_index_out;
    }
    if (xt_index_out != old_idx)
        out_flush();
}
    static void got_code_from_term(code, len)
    char_u *code;
    int len;
{
    char_u name[3];
    char_u str[100];
    int i;
    int j = 0;
    int c;
    if (code[0] == '1' && code[7] == '=' && len / 2 < 100)
    {
        name[0] = hexhex2nr(code + 3);
        name[1] = hexhex2nr(code + 5);
        name[2] = '\000';
        for (i = 0; key_names[i] != ((void *)0); ++i)
        {
            if (strcmp((char *)(key_names[i]), (char *)(name)) == 0)
            {
                xt_index_in = i;
                break;
            }
        }
        if (key_names[i] != ((void *)0))
        {
            for (i = 8; (c = hexhex2nr(code + i)) >= 0; i += 2)
                str[j++] = c;
            str[j] = '\000';
            if (name[0] == 'C' && name[1] == 'o')
            {
                i = atoi((char *)str);
                if (i != t_colors)
                {
                    set_color_count(i);
                    init_highlight(1, 0);
                    redraw_later(50);
                }
            }
            else
            {
                i = find_term_bykeys(str);
                if (i >= 0)
                    del_termcode_idx(i);
                add_termcode(name, str, 0);
            }
        }
    }
    ++xt_index_in;
    req_more_codes_from_term();
}
    static void check_for_codes_from_term()
{
    int c;
    if (xt_index_out == 0 || xt_index_out == xt_index_in)
        return;
    ++no_mapping;
    ++allow_keys;
    for (;;)
    {
        c = vpeekc();
        if (c == '\000')
            break;
        if (c != (0x80) && c != (-((253) + ((int)(KE_IGNORE) << 8))))
            break;
        c = vgetc();
        if (c != (-((253) + ((int)(KE_IGNORE) << 8))))
        {
            vungetc(c);
            break;
        }
    }
    --no_mapping;
    --allow_keys;
}
    char_u * translate_mapping(str, expmap)
    char_u *str;
    int expmap;
{
    garray_T ga;
    int c;
    int modifiers;
    int cpo_bslash;
    int cpo_special;
    int cpo_keycode;
    ga_init(&ga);
    ga.ga_itemsize = 1;
    ga.ga_growsize = 40;
    cpo_bslash = (vim_strchr(p_cpo, 'B') != ((void *)0));
    cpo_special = (vim_strchr(p_cpo, '<') != ((void *)0));
    cpo_keycode = (vim_strchr(p_cpo, 'k') == ((void *)0));
    for (; *str; ++str)
    {
        c = *str;
        if (c == (0x80) && str[1] != '\000' && str[2] != '\000')
        {
            modifiers = 0;
            if (str[1] == 252)
            {
                str++;
                modifiers = *++str;
                c = *++str;
            }
            if (cpo_special && cpo_keycode && c == (0x80) && !modifiers)
            {
                int i;
                for (i = 0; i < tc_len; ++i)
                    if (termcodes[i].name[0] == str[1]
                                            && termcodes[i].name[1] == str[2])
                        break;
                if (i < tc_len)
                {
                    ga_concat(&ga, termcodes[i].code);
                    str += 2;
                    continue;
                }
            }
            if (c == (0x80) && str[1] != '\000' && str[2] != '\000')
            {
                if (expmap && cpo_special)
                {
                    ga_clear(&ga);
                    return ((void *)0);
                }
                c = ((str[1]) == 254 ? (0x80) : (str[1]) == 255 ? (-((255) + ((int)(('X')) << 8))) : (-((str[1]) + ((int)(str[2]) << 8))));
                if (c == (-((255) + ((int)(('X')) << 8))))
                    c = '\000';
                str += 2;
            }
            if (((c) < 0) || modifiers)
            {
                if (expmap && cpo_special)
                {
                    ga_clear(&ga);
                    return ((void *)0);
                }
                ga_concat(&ga, get_special_key_name(c, modifiers));
                continue;
            }
        }
        if (c == ' ' || c == '\t' || c == 10 || c == 22
            || (c == '<' && !cpo_special) || (c == '\\' && !cpo_bslash))
            ga_append(&ga, cpo_bslash ? 22 : '\\');
        if (c)
            ga_append(&ga, c);
    }
    ga_append(&ga, '\000');
    return (char_u *)(ga.ga_data);
}
