enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
extern __const unsigned short int *__ctype_b;
int aborting (void);
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef unsigned char char_u;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
void alist_unlink (alist_T *al);
extern alist_T global_alist;
char_u *alloc (unsigned size);
char_u *alloc_clear (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
int bt_quickfix (buf_T *buf);
int bufIsChanged (buf_T *buf);
extern int p_acd;
void buf_copy_options (buf_T *buf, int flags);
int buf_hide (buf_T *buf);
buf_T *buflist_new (char_u *ffname, char_u *sfname, linenr_T lnum, int flags);
extern long p_ch;
extern int p_ea;
int can_abandon (buf_T *buf, int forceit);
void clear_winopt (winopt_T *wop);
void changed_line_abv_curs (void);
void close_buffer (win_T *win, buf_T *buf, int action);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
int do_ecmd (int fnum, char_u *ffname, char_u *sfname, exarg_T *eap, linenr_T newlnum, int flags);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
char_u *eval_to_string_safe (char_u *arg, char_u **nextcmd);
void maketitle (void);
int mch_dirname (char_u *buf, int len);
int msg (char_u *s);void redraw_later (int type);
void setpcmark (void);
void shorten_fnames (int force);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
extern char *strncpy (char *__restrict __dest,
                      __const char *__restrict __src, size_t __n) ;
void u_sync (void);
void var_init (garray_T *gap);
void var_clear (garray_T *gap);
int vim_chdirfile (char_u *fname);
void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
void win_close (win_T *win, int free_buf);
void win_enter (win_T *wp, int undo_sync);
int win_split (int size, int flags);
int win_valid (win_T *win);
extern long Columns ;
extern int RedrawingDisabled ;
extern long Rows
                            ;
extern int autocmd_block ;
extern int cmdline_row;
typedef struct
{
    int hide;
    int browse;
    int split;
    int confirm;
} cmdmod_T;
extern cmdmod_T cmdmod;
extern int cmdwin_type ;
extern buf_T *curbuf ;
extern win_T *curwin;
extern win_T *firstwin;
extern win_T *lastwin;
extern int msg_row;
extern int msg_scrolled;
extern int need_mouse_correct ;
extern int restart_edit ;
int ga_grow (garray_T *gap, int n);
void ga_init2 (garray_T *gap, int itemsize, int growsize);
int virtual_active (void);
extern int VIsual_active ;
void changed_line_abv_curs_win (win_T *wp);
extern int chdir (__const char *__path) ;
void check_cursor (void);
int do_cmdline_cmd (char_u *cmd);
typedef struct foldinfo
{
    int fi_level;
    int fi_lnum;
    int fi_low_level;
} foldinfo_T;
int hasFoldingWin (win_T *win, linenr_T lnum, linenr_T *firstp, linenr_T *lastp, int cache, foldinfo_T *infop);
void invalidate_botline_win (win_T *wp);
void redraw_win_later (win_T *wp, int type);
char_u *vim_strnsave (char_u *string, int len);
int add_to_showcmd (int c);
int safe_vgetc (void);
extern int no_mapping ;
extern int allow_keys ;
extern int msg_col;
void curs_columns (int scroll);
void find_pattern_in_path (char_u *ptr, int dir, int len, int whole, int skip_comments, int type, long count, int action, linenr_T start_lnum, linenr_T end_lnum);
char_u *ml_get_curline (void);
void set_topline (win_T *wp, linenr_T lnum);
void setmouse (void);
int showmode (void);
void update_topline (void);
int vim_isfilec (int c);
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
extern long p_so;
extern int redraw_cmdline ;
extern int sc_col;
int mch_isFullName (char_u *fname);
void msg_clr_eos (void);
void set_vim_var_string (int idx, char_u *val, int len);
extern int starting ;
void win_init (win_T *wp);
void win_setheight (int height);
extern int autocmd_busy ;
extern int g_do_tagpreview ;
extern int p_confirm;
void dialog_changed (buf_T *buf, int checkall);
void redraw_all_later (int type);
void screen_fill (int start_row, int end_row, int start_col, int end_col, int c1, int c2, int attr);
void win_goto (win_T *wp);
void beep_flush (void);
int find_ident_under_cursor (char_u **string, int find_type);
char_u *file_name_at_cursor (int options, long count);
extern long p_pvh;
extern int p_sb;
extern int p_spr;
extern long p_wh;
extern long p_wiw;
char_u *find_file_in_path (char_u *ptr, int len, int options, int first, char_u *rel_fname);
void win_setwidth (int width);
extern char_u *globaldir ;
extern char_u e_cmdwin[] ;
extern int postponed_split ;
extern frame_T *topframe;
void compute_cmdrow (void);
extern long p_wmh;
void last_status (int morewin);
extern long p_ls;
int path_with_url (char_u *fname);
int win_hasvertsplit (void);
void gui_init_which_components (char_u *oldval);
void gui_create_scrollbar (scrollbar_T *sb, int type, win_T *wp);
void gui_update_scrollbars (int force);
extern int full_screen ;
void mch_exit (int r);
int win_count (void);
void win_equal (win_T *next_curwin, int current, int dir);
int plines_win (win_T *wp, linenr_T lnum, int winheight);
int plines_win_nofill (win_T *wp, linenr_T lnum, int winheight);
char_u *find_file_name_in_path (char_u *ptr, int len, int options, long count, char_u *rel_fname);
void reset_VIsual_and_resel (void);
extern win_T *prevwin ;
void comp_col (void);
int win_alloc_lines (win_T *wp);
void win_free_lsize (win_T *wp);
char_u *file_name_in_line (char_u *line, int col, int options, long count, char_u *rel_fname);
extern char_u *p_ead;
extern long p_wmw;
int mch_FullName (char_u *fname, char_u *buf, int len, int force);
void copyFoldingState (win_T *wp_from, win_T *wp_to);
void foldInitWin (win_T *newwin);
void copy_jumplist (win_T *from, win_T *to);
void free_jumplist (win_T *wp);
int plines_win_col (win_T *wp, linenr_T lnum, long column);
void do_nv_ident (int c1, int c2);
void win_copy_options (win_T *wp_from, win_T *wp_to);
void win_comp_scroll (win_T *wp);
void gui_mch_destroy_scrollbar (scrollbar_T *sb);
extern char_u e_noroom[] ;
static int path_is_url (char_u *p);
static int win_split_ins (int size, int flags, win_T *newwin, int dir);
static int win_comp_pos (void);
static void frame_comp_pos (frame_T *topfrp, int *row, int *col);
static void frame_setheight (frame_T *curfrp, int height);
static void frame_setwidth (frame_T *curfrp, int width);
static void win_exchange (long);
static void win_rotate (int, int);
static void win_totop (int size, int flags);
static void win_equal_rec (win_T *next_curwin, int current, frame_T *topfr, int dir, int col, int row, int width, int height);
static win_T *winframe_remove (win_T *win, int *dirp);
static frame_T *win_altframe (win_T *win);
static win_T *frame2win (frame_T *frp);
static int frame_has_win (frame_T *frp, win_T *wp);
static void frame_new_height (frame_T *topfrp, int height, int topfirst, int wfh);
static int frame_fixed_height (frame_T *frp);
static void frame_add_statusline (frame_T *frp);
static void frame_new_width (frame_T *topfrp, int width, int leftfirst);
static void frame_add_vsep (frame_T *frp);
static int frame_minwidth (frame_T *topfrp, win_T *next_curwin);
static void frame_fix_width (win_T *wp);
static void frame_fix_height (win_T *wp);
static int frame_minheight (frame_T *topfrp, win_T *next_curwin);
static void win_enter_ext (win_T *wp, int undo_sync, int no_curwin);
static void win_free (win_T *wp);
static void win_append (win_T *, win_T *);
static void win_remove (win_T *);
static void frame_append (frame_T *after, frame_T *frp);
static void frame_insert (frame_T *before, frame_T *frp);
static void frame_remove (frame_T *frp);
static void win_new_width (win_T *wp, int width);
static void win_goto_ver (int up, long count);
static void win_goto_hor (int left, long count);
static void frame_add_height (frame_T *frp, int n);
static void last_status_rec (frame_T *fr, int statusline);
static void make_snapshot (void);
static void make_snapshot_rec (frame_T *fr, frame_T **frp);
static void clear_snapshot (void);
static void clear_snapshot_rec (frame_T *fr);
static void restore_snapshot (int close_curwin);
static int check_snapshot_rec (frame_T *sn, frame_T *fr);
static win_T *restore_snapshot_rec (frame_T *sn, frame_T *fr);
static void win_setheight_win (int height, win_T *win);
static win_T *win_alloc (win_T *after);
static void win_new_height (win_T *, int);
    void do_window(nchar, Prenum, xchar)
    int nchar;
    long Prenum;
    int xchar;
{
    long Prenum1;
    win_T *wp;
    char_u *ptr;
    int type = 2;
    int len;
    char_u cbuf[40];
    if (Prenum == 0)
        Prenum1 = 1;
    else
        Prenum1 = Prenum;
    switch (nchar)
    {
    case 'S':
    case 19:
    case 's':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                need_mouse_correct = 1;
                win_split((int)Prenum, 0);
                break;
    case 22:
    case 'v':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                need_mouse_correct = 1;
                win_split((int)Prenum, 2);
                break;
    case 30:
    case '^':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                strcpy((char *)(cbuf), (char *)("split #"));
                if (Prenum)
                    sprintf((char *)cbuf + 7, "%ld", Prenum);
                do_cmdline_cmd(cbuf);
                break;
    case 14:
    case 'n':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                if (Prenum)
                    sprintf((char *)cbuf, "%ld", Prenum);
                else
                    cbuf[0] = '\000';
                strcat((char *)(cbuf), (char *)("new"));
                do_cmdline_cmd(cbuf);
                break;
    case 17:
    case 'q':
                reset_VIsual_and_resel();
                do_cmdline_cmd((char_u *)"quit");
                break;
    case 3:
    case 'c':
                reset_VIsual_and_resel();
                do_cmdline_cmd((char_u *)"close");
                break;
    case 26:
    case 'z':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                do_cmdline_cmd((char_u *)"pclose");
                break;
    case 'P':
                for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
                    if (wp->w_onebuf_opt.wo_pvw)
                        break;
                if (wp == ((void *)0))
                    emsg((char_u *)(((char *)("E441: There is no preview window"))));
                else
                    win_goto(wp);
                break;
    case 15:
    case 'o':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                do_cmdline_cmd((char_u *)"only");
                break;
    case 23:
    case 'w':
    case 'W':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                if (lastwin == firstwin)
                    beep_flush();
                else
                {
                    if (Prenum)
                    {
                        for (wp = firstwin; --Prenum > 0; )
                        {
                            if (wp->w_next == ((void *)0))
                                break;
                            else
                                wp = wp->w_next;
                        }
                    }
                    else
                    {
                        if (nchar == 'W')
                        {
                            wp = curwin->w_prev;
                            if (wp == ((void *)0))
                                wp = lastwin;
                        }
                        else
                        {
                            wp = curwin->w_next;
                            if (wp == ((void *)0))
                                wp = firstwin;
                        }
                    }
                    win_goto(wp);
                }
                break;
    case 'j':
    case (-(('k') + ((int)('d') << 8))):
    case 10:
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                win_goto_ver(0, Prenum1);
                break;
    case 'k':
    case (-(('k') + ((int)('u') << 8))):
    case 11:
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                win_goto_ver(1, Prenum1);
                break;
    case 'h':
    case (-(('k') + ((int)('l') << 8))):
    case 8:
    case (-(('k') + ((int)('b') << 8))):
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                win_goto_hor(1, Prenum1);
                break;
    case 'l':
    case (-(('k') + ((int)('r') << 8))):
    case 12:
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                win_goto_hor(0, Prenum1);
                break;
    case 't':
    case 20:
                win_goto(firstwin);
                break;
    case 'b':
    case 2:
                win_goto(lastwin);
                break;
    case 'p':
    case 16:
                if (prevwin == ((void *)0))
                    beep_flush();
                else
                    win_goto(prevwin);
                break;
    case 'x':
    case 24:
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                win_exchange(Prenum);
                break;
    case 18:
    case 'r':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                win_rotate(0, (int)Prenum1);
                break;
    case 'R':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                win_rotate(1, (int)Prenum1);
                break;
    case 'K':
    case 'J':
    case 'H':
    case 'L':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                win_totop((int)Prenum,
                        ((nchar == 'H' || nchar == 'L') ? 2 : 0)
                        | ((nchar == 'H' || nchar == 'K') ? 4 : 8));
                break;
    case '=':
                need_mouse_correct = 1;
                win_equal(((void *)0), 0, 'b');
                break;
    case '+':
                need_mouse_correct = 1;
                win_setheight(curwin->w_height + (int)Prenum1);
                break;
    case '-':
                need_mouse_correct = 1;
                win_setheight(curwin->w_height - (int)Prenum1);
                break;
    case 31:
    case '_':
                need_mouse_correct = 1;
                win_setheight(Prenum ? (int)Prenum : 9999);
                break;
    case '>':
                need_mouse_correct = 1;
                win_setwidth(curwin->w_width + (int)Prenum1);
                break;
    case '<':
                need_mouse_correct = 1;
                win_setwidth(curwin->w_width - (int)Prenum1);
                break;
    case '|':
                need_mouse_correct = 1;
                win_setwidth(Prenum != 0 ? (int)Prenum : 9999);
                break;
    case '}':
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                if (Prenum)
                    g_do_tagpreview = Prenum;
                else
                    g_do_tagpreview = p_pvh;
    case ']':
    case 29:
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                if (Prenum)
                    postponed_split = Prenum;
                else
                    postponed_split = -1;
                do_nv_ident(29, '\000');
                break;
    case 'f':
    case 6:
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                reset_VIsual_and_resel();
                ptr = file_name_at_cursor(1|4|2,
                                                                     Prenum1);
                if (ptr != ((void *)0))
                {
                    need_mouse_correct = 1;
                    setpcmark();
                    if (win_split(0, 0) == 1)
                    {
                        curwin->w_onebuf_opt.wo_scb = 0;
                        (void)do_ecmd(0, ptr, ((void *)0), ((void *)0), (linenr_T)0,
                                                                   0x01);
                    }
                    vim_free(ptr);
                }
                break;
    case 'i':
    case 9:
                type = 1;
    case 'd':
    case 4:
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                if ((len = find_ident_under_cursor(&ptr, 1)) == 0)
                    break;
                find_pattern_in_path(ptr, 0, len, 1,
                        Prenum == 0 ? 1 : 0, type,
                        Prenum1, 3, (linenr_T)1, (linenr_T)(0x7fffffffL));
                curwin->w_set_curswant = 1;
                break;
    case 'g':
    case 7:
                if (cmdwin_type != 0) { emsg((char_u *)(((char *)(e_cmdwin)))); break; }
                ++no_mapping;
                ++allow_keys;
                if (xchar == '\000')
                    xchar = safe_vgetc();
                --no_mapping;
                --allow_keys;
                (void)add_to_showcmd(xchar);
                switch (xchar)
                {
                    case '}':
                        xchar = 29;
                        if (Prenum)
                            g_do_tagpreview = Prenum;
                        else
                            g_do_tagpreview = p_pvh;
                    case ']':
                    case 29:
                        reset_VIsual_and_resel();
                        if (Prenum)
                            postponed_split = Prenum;
                        else
                            postponed_split = -1;
                        do_nv_ident('g', xchar);
                        break;
                    default:
                        beep_flush();
                        break;
                }
                break;
    default: beep_flush();
                break;
    }
}
    int win_split(size, flags)
    int size;
    int flags;
{
    flags |= cmdmod.split;
    if ((flags & 4) && (flags & 8))
    {
        emsg((char_u *)(((char *)("E442: Can't split topleft and botright at the same time"))));
        return 0;
    }
    if (flags & 16)
        make_snapshot();
    else
        clear_snapshot();
    return win_split_ins(size, flags, ((void *)0), 0);
}
    static int win_split_ins(size, flags, newwin, dir)
    int size;
    int flags;
    win_T *newwin;
    int dir;
{
    win_T *wp = newwin;
    win_T *oldwin;
    int new_size = size;
    int i;
    int need_status = 0;
    int do_equal = 0;
    int needed;
    int available;
    int oldwin_height = 0;
    int layout;
    frame_T *frp, *curfrp;
    int before;
    if (flags & 4)
        oldwin = firstwin;
    else if (flags & 8)
        oldwin = lastwin;
    else
        oldwin = curwin;
    if (lastwin == firstwin && p_ls == 1 && oldwin->w_status_height == 0)
    {
        if (oldwin->w_height <= p_wmh && newwin == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_noroom))));
            return 0;
        }
        need_status = 1;
    }
    if (flags & 2)
    {
        layout = 1;
        do_equal = (p_ea && new_size == 0 && *p_ead != 'v');
        needed = p_wmw + 1;
        if (flags & 1)
            needed += p_wiw - p_wmw;
        if (p_ea || (flags & (8 | 4)))
        {
            available = topframe->fr_width;
            needed += frame_minwidth(topframe, ((void *)0));
        }
        else
            available = oldwin->w_width;
        if (available < needed && newwin == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_noroom))));
            return 0;
        }
        if (new_size == 0)
            new_size = oldwin->w_width / 2;
        if (new_size > oldwin->w_width - p_wmw - 1)
            new_size = oldwin->w_width - p_wmw - 1;
        if (new_size < p_wmw)
            new_size = p_wmw;
        if (oldwin->w_width - new_size - 1 < p_wmw)
            do_equal = 1;
    }
    else
    {
        layout = 2;
        do_equal = (p_ea && new_size == 0
                && *p_ead != 'h'
                );
        needed = p_wmh + 1 + need_status;
        if (flags & 1)
            needed += p_wh - p_wmh;
        if (p_ea || (flags & (8 | 4)))
        {
            available = topframe->fr_height;
            needed += frame_minheight(topframe, ((void *)0));
        }
        else
        {
            available = oldwin->w_height;
            needed += p_wmh;
        }
        if (available < needed && newwin == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_noroom))));
            return 0;
        }
        oldwin_height = oldwin->w_height;
        if (need_status)
        {
            oldwin->w_status_height = 1;
            oldwin_height -= 1;
        }
        if (new_size == 0)
            new_size = oldwin_height / 2;
        if (new_size > oldwin_height - p_wmh - 1)
            new_size = oldwin_height - p_wmh - 1;
        if (new_size < p_wmh)
            new_size = p_wmh;
        if (oldwin_height - new_size - 1 < p_wmh)
            do_equal = 1;
        if (oldwin->w_onebuf_opt.wo_wfh)
        {
            win_setheight_win(oldwin->w_height + new_size + 1,
                                                                      oldwin);
            oldwin_height = oldwin->w_height;
            if (need_status)
                oldwin_height -= 1;
        }
    }
    if ((flags & 4) == 0
            && ((flags & 8)
                || (flags & 32)
                || (!(flags & 64)
                    && (
                        (flags & 2) ? p_spr :
                        p_sb))))
    {
        if (newwin == ((void *)0))
            wp = win_alloc(oldwin);
        else
            win_append(oldwin, wp);
    }
    else
    {
        if (newwin == ((void *)0))
            wp = win_alloc(oldwin->w_prev);
        else
            win_append(oldwin->w_prev, wp);
    }
    if (newwin == ((void *)0))
    {
        if (wp == ((void *)0))
            return 0;
        wp->w_buffer = curbuf;
        curbuf->b_nwindows++;
        wp->w_cursor = curwin->w_cursor;
        wp->w_valid = 0;
        wp->w_curswant = curwin->w_curswant;
        wp->w_set_curswant = curwin->w_set_curswant;
        wp->w_topline = curwin->w_topline;
        wp->w_topfill = curwin->w_topfill;
        wp->w_leftcol = curwin->w_leftcol;
        wp->w_pcmark = curwin->w_pcmark;
        wp->w_prev_pcmark = curwin->w_prev_pcmark;
        wp->w_alt_fnum = curwin->w_alt_fnum;
        wp->w_fraction = curwin->w_fraction;
        wp->w_prev_fraction_row = curwin->w_prev_fraction_row;
        copy_jumplist(curwin, wp);
        if (curwin->w_localdir != ((void *)0))
            wp->w_localdir = vim_strsave(curwin->w_localdir);
        wp->w_alist = curwin->w_alist;
        ++wp->w_alist->al_refcount;
        wp->w_arg_idx = curwin->w_arg_idx;
        for (i = 0; i < curwin->w_tagstacklen; i++)
        {
            wp->w_tagstack[i] = curwin->w_tagstack[i];
            if (wp->w_tagstack[i].tagname != ((void *)0))
                wp->w_tagstack[i].tagname =
                                       vim_strsave(wp->w_tagstack[i].tagname);
        }
        wp->w_tagstackidx = curwin->w_tagstackidx;
        wp->w_tagstacklen = curwin->w_tagstacklen;
        win_copy_options(curwin, wp);
        copyFoldingState(curwin, wp);
    }
    if (flags & (4 | 8))
    {
        if ((topframe->fr_layout == 2 && (flags & 2) == 0)
            || (topframe->fr_layout == 1 && (flags & 2) != 0))
        {
            curfrp = topframe->fr_child;
            if (flags & 8)
                while (curfrp->fr_next != ((void *)0))
                    curfrp = curfrp->fr_next;
        }
        else
            curfrp = topframe;
        before = (flags & 4);
    }
    else
    {
        curfrp = oldwin->w_frame;
        if (flags & 32)
            before = 0;
        else if (flags & 64)
            before = 1;
        else
        if (flags & 2)
            before = !p_spr;
        else
            before = !p_sb;
    }
    if (curfrp->fr_parent == ((void *)0) || curfrp->fr_parent->fr_layout != layout)
    {
        frp = (frame_T *)alloc_clear((unsigned)sizeof(frame_T));
        *frp = *curfrp;
        curfrp->fr_layout = layout;
        frp->fr_parent = curfrp;
        frp->fr_next = ((void *)0);
        frp->fr_prev = ((void *)0);
        curfrp->fr_child = frp;
        curfrp->fr_win = ((void *)0);
        curfrp = frp;
        if (frp->fr_win != ((void *)0))
            oldwin->w_frame = frp;
        else
            for (frp = frp->fr_child; frp != ((void *)0); frp = frp->fr_next)
                frp->fr_parent = curfrp;
    }
    if (newwin == ((void *)0))
    {
        frp = (frame_T *)alloc_clear((unsigned)sizeof(frame_T));
        frp->fr_layout = 0;
        frp->fr_win = wp;
        wp->w_frame = frp;
    }
    else
        frp = newwin->w_frame;
    frp->fr_parent = curfrp->fr_parent;
    if (before)
        frame_insert(curfrp, frp);
    else
        frame_append(curfrp, frp);
    if (flags & 2)
    {
        wp->w_onebuf_opt.wo_scr = curwin->w_onebuf_opt.wo_scr;
        if (need_status)
        {
            --oldwin->w_height;
            oldwin->w_status_height = need_status;
        }
        if (flags & (4 | 8))
        {
            wp->w_winrow = 0;
            wp->w_height = curfrp->fr_height - (p_ls > 0);
            wp->w_status_height = (p_ls > 0);
        }
        else
        {
            wp->w_winrow = oldwin->w_winrow;
            wp->w_height = oldwin->w_height;
            wp->w_status_height = oldwin->w_status_height;
        }
        frp->fr_height = curfrp->fr_height;
        wp->w_width = new_size;
        if (before)
            wp->w_vsep_width = 1;
        else
        {
            wp->w_vsep_width = oldwin->w_vsep_width;
            oldwin->w_vsep_width = 1;
        }
        if (flags & (4 | 8))
        {
            if (flags & 8)
                frame_add_vsep(curfrp);
            frame_new_width(curfrp, curfrp->fr_width
                    - (new_size + ((flags & 4) != 0)), flags & 4);
        }
        else
            oldwin->w_width -= new_size + 1;
        if (before)
        {
            wp->w_wincol = oldwin->w_wincol;
            oldwin->w_wincol += new_size + 1;
        }
        else
            wp->w_wincol = oldwin->w_wincol + oldwin->w_width + 1;
        frame_fix_width(oldwin);
        frame_fix_width(wp);
    }
    else
    {
        if (flags & (4 | 8))
        {
            wp->w_wincol = 0;
            wp->w_width = Columns;
            wp->w_vsep_width = 0;
        }
        else
        {
            wp->w_wincol = oldwin->w_wincol;
            wp->w_width = oldwin->w_width;
            wp->w_vsep_width = oldwin->w_vsep_width;
        }
        frp->fr_width = curfrp->fr_width;
        win_new_height(wp, new_size);
        if (flags & (4 | 8))
            frame_new_height(curfrp, curfrp->fr_height
                        - (new_size + 1), flags & 4, 0);
        else
            win_new_height(oldwin, oldwin_height - (new_size + 1));
        if (before)
        {
            wp->w_winrow = oldwin->w_winrow;
            wp->w_status_height = 1;
            oldwin->w_winrow += wp->w_height + 1;
        }
        else
        {
            wp->w_winrow = oldwin->w_winrow + oldwin->w_height + 1;
            wp->w_status_height = oldwin->w_status_height;
            oldwin->w_status_height = 1;
        }
        if (flags & 8)
            frame_add_statusline(curfrp);
        frame_fix_height(wp);
        frame_fix_height(oldwin);
    }
    if (flags & (4 | 8))
        (void)win_comp_pos();
    redraw_win_later(wp, 40);
    wp->w_redr_status = 1;
    redraw_win_later(oldwin, 40);
    oldwin->w_redr_status = 1;
    if (need_status)
    {
        msg_row = Rows - 1;
        msg_col = sc_col;
        msg_clr_eos();
        comp_col();
        msg_row = Rows - 1;
        msg_col = 0;
    }
    if (do_equal || dir != 0)
        win_equal(wp, 1,
                (flags & 2) ? (dir == 'v' ? 'b' : 'h')
                : dir == 'h' ? 'b' :
                'v');
    if (flags & 2)
    {
        i = p_wiw;
        if (size != 0)
            p_wiw = size;
        if (gui.in_use)
            gui_init_which_components(((void *)0));
    }
    else
    {
        i = p_wh;
        if (size != 0)
            p_wh = size;
    }
    win_enter(wp, 0);
    if (flags & 2)
        p_wiw = i;
    else
        p_wh = i;
    return 1;
}
    static int win_minheight(wp)
    win_T *wp;
{
    int minheight = p_wmh;
    int n;
    win_T *wp1, *wp2;
    wp1 = wp;
    for (;;)
    {
        wp1 = wp1->w_next;
        if (wp1 == ((void *)0))
            break;
        n = p_wmh;
        wp2 = wp1;
        for (;;)
        {
            wp2 = wp2->w_next;
            if (wp2 == ((void *)0))
                break;
            n += win_minheight(wp2);
        }
        if (n > minheight)
            minheight = n;
    }
    return minheight;
}
    int win_valid(win)
    win_T *win;
{
    win_T *wp;
    if (win == ((void *)0))
        return 0;
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        if (wp == win)
            return 1;
    return 0;
}
    int win_count()
{
    win_T *wp;
    int count = 0;
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        ++count;
    return count;
}
    int make_windows(count, vertical)
    int count;
    int vertical;
{
    int maxcount;
    int todo;
    if (vertical)
    {
        maxcount = (curwin->w_width + curwin->w_vsep_width
                                             - (p_wiw - p_wmw)) / (p_wmw + 1);
    }
    else
    {
        maxcount = (curwin->w_height + curwin->w_status_height
                                  - (p_wh - p_wmh)) / (p_wmh + 1);
    }
    if (maxcount < 2)
        maxcount = 2;
    if (count > maxcount)
        count = maxcount;
    if (count > 1)
        last_status(1);
    ++autocmd_block;
    for (todo = count - 1; todo > 0; --todo)
        if (vertical)
        {
            if (win_split(curwin->w_width - (curwin->w_width - todo)
                        / (todo + 1) - 1, 2 | 64) == 0)
                break;
        }
        else
        {
            if (win_split(curwin->w_height - (curwin->w_height - todo
                            * 1) / (todo + 1)
                        - 1, 64) == 0)
                break;
        }
    --autocmd_block;
    return (count - todo);
}
    static void win_exchange(Prenum)
    long Prenum;
{
    frame_T *frp;
    frame_T *frp2;
    win_T *wp;
    win_T *wp2;
    int temp;
    if (lastwin == firstwin)
    {
        beep_flush();
        return;
    }
    need_mouse_correct = 1;
    if (Prenum)
    {
        frp = curwin->w_frame->fr_parent->fr_child;
        while (frp != ((void *)0) && --Prenum > 0)
            frp = frp->fr_next;
    }
    else if (curwin->w_frame->fr_next != ((void *)0))
        frp = curwin->w_frame->fr_next;
    else
        frp = curwin->w_frame->fr_prev;
    if (frp == ((void *)0) || frp->fr_win == ((void *)0) || frp->fr_win == curwin)
        return;
    wp = frp->fr_win;
    wp2 = curwin->w_prev;
    frp2 = curwin->w_frame->fr_prev;
    if (wp->w_prev != curwin)
    {
        win_remove(curwin);
        frame_remove(curwin->w_frame);
        win_append(wp->w_prev, curwin);
        frame_insert(frp, curwin->w_frame);
    }
    if (wp != wp2)
    {
        win_remove(wp);
        frame_remove(wp->w_frame);
        win_append(wp2, wp);
        if (frp2 == ((void *)0))
            frame_insert(wp->w_frame->fr_parent->fr_child, wp->w_frame);
        else
            frame_append(frp2, wp->w_frame);
    }
    temp = curwin->w_status_height;
    curwin->w_status_height = wp->w_status_height;
    wp->w_status_height = temp;
    temp = curwin->w_vsep_width;
    curwin->w_vsep_width = wp->w_vsep_width;
    wp->w_vsep_width = temp;
    if (curwin->w_frame->fr_parent != wp->w_frame->fr_parent)
    {
        temp = curwin->w_height;
        curwin->w_height = wp->w_height;
        wp->w_height = temp;
        temp = curwin->w_width;
        curwin->w_width = wp->w_width;
        wp->w_width = temp;
    }
    else
    {
        frame_fix_height(curwin);
        frame_fix_height(wp);
        frame_fix_width(curwin);
        frame_fix_width(wp);
    }
    (void)win_comp_pos();
    win_enter(wp, 1);
    redraw_later(50);
}
    static void win_rotate(upwards, count)
    int upwards;
    int count;
{
    win_T *wp1;
    win_T *wp2;
    frame_T *frp;
    int n;
    if (firstwin == lastwin)
    {
        beep_flush();
        return;
    }
    need_mouse_correct = 1;
    for (frp = curwin->w_frame->fr_parent->fr_child; frp != ((void *)0);
                                                           frp = frp->fr_next)
        if (frp->fr_win == ((void *)0))
        {
            emsg((char_u *)(((char *)("E443: Cannot rotate when another window is split"))));
            return;
        }
    while (count--)
    {
        if (upwards)
        {
            frp = curwin->w_frame->fr_parent->fr_child;
            wp1 = frp->fr_win;
            win_remove(wp1);
            frame_remove(frp);
            for ( ; frp->fr_next != ((void *)0); frp = frp->fr_next)
                ;
            win_append(frp->fr_win, wp1);
            frame_append(frp, wp1->w_frame);
            wp2 = frp->fr_win;
        }
        else
        {
            for (frp = curwin->w_frame; frp->fr_next != ((void *)0);
                                                           frp = frp->fr_next)
                ;
            wp1 = frp->fr_win;
            wp2 = wp1->w_prev;
            win_remove(wp1);
            frame_remove(frp);
            win_append(frp->fr_parent->fr_child->fr_win->w_prev, wp1);
            frame_insert(frp->fr_parent->fr_child, frp);
        }
        n = wp2->w_status_height;
        wp2->w_status_height = wp1->w_status_height;
        wp1->w_status_height = n;
        frame_fix_height(wp1);
        frame_fix_height(wp2);
        n = wp2->w_vsep_width;
        wp2->w_vsep_width = wp1->w_vsep_width;
        wp1->w_vsep_width = n;
        frame_fix_width(wp1);
        frame_fix_width(wp2);
        (void)win_comp_pos();
    }
    redraw_later(50);
}
    static void win_totop(size, flags)
    int size;
    int flags;
{
    int dir;
    int height = curwin->w_height;
    if (lastwin == firstwin)
    {
        beep_flush();
        return;
    }
    (void)winframe_remove(curwin, &dir);
    win_remove(curwin);
    last_status(0);
    (void)win_comp_pos();
    (void)win_split_ins(size, flags, curwin, dir);
    if (!(flags & 2))
    {
        win_setheight(height);
        if (p_ea)
            win_equal(curwin, 1, 'v');
    }
    if (gui.in_use)
    {
        gui_init_which_components(((void *)0));
        gui_update_scrollbars(1);
    }
    need_mouse_correct = 1;
}
    void win_move_after(win1, win2)
    win_T *win1, *win2;
{
    int height;
    if (win1 == win2)
        return;
    if (win2->w_next != win1)
    {
        if (win1 == lastwin)
        {
            height = win1->w_prev->w_status_height;
            win1->w_prev->w_status_height = win1->w_status_height;
            win1->w_status_height = height;
            win1->w_prev->w_vsep_width = 0;
            win1->w_vsep_width = 1;
        }
        else if (win2 == lastwin)
        {
            height = win1->w_status_height;
            win1->w_status_height = win2->w_status_height;
            win2->w_status_height = height;
            win2->w_vsep_width = 1;
            win1->w_vsep_width = 0;
        }
        win_remove(win1);
        frame_remove(win1->w_frame);
        win_append(win2, win1);
        frame_append(win2->w_frame, win1->w_frame);
        (void)win_comp_pos();
        redraw_later(40);
    }
    win_enter(win1, 0);
}
    void win_equal(next_curwin, current, dir)
    win_T *next_curwin;
    int current;
    int dir;
{
    if (dir == 0)
        dir = *p_ead;
    win_equal_rec(next_curwin == ((void *)0) ? curwin : next_curwin, current,
                      topframe, dir, 0, 0, (int)Columns, topframe->fr_height);
}
    static void win_equal_rec(next_curwin, current, topfr, dir, col, row, width, height)
    win_T *next_curwin;
    int current;
    frame_T *topfr;
    int dir;
    int col;
    int row;
    int width;
    int height;
{
    int n, m;
    int extra_sep = 0;
    int wincount, totwincount = 0;
    frame_T *fr;
    int next_curwin_size = 0;
    int room = 0;
    int new_size;
    int has_next_curwin = 0;
    int hnc;
    if (topfr->fr_layout == 0)
    {
        if (topfr->fr_height != height || topfr->fr_win->w_winrow != row
                || topfr->fr_width != width || topfr->fr_win->w_wincol != col
           )
        {
            topfr->fr_win->w_winrow = row;
            frame_new_height(topfr, height, 0, 0);
            topfr->fr_win->w_wincol = col;
            frame_new_width(topfr, width, 0);
            redraw_all_later(50);
        }
    }
    else if (topfr->fr_layout == 1)
    {
        topfr->fr_width = width;
        topfr->fr_height = height;
        if (dir != 'v')
        {
            n = frame_minwidth(topfr, (win_T *)-1);
            if (col + width == Columns)
                extra_sep = 1;
            else
                extra_sep = 0;
            totwincount = (n + extra_sep) / (p_wmw + 1);
            m = frame_minwidth(topfr, next_curwin);
            room = width - m;
            if (room < 0)
            {
                next_curwin_size = p_wiw + room;
                room = 0;
            }
            else if (n == m)
                next_curwin_size = 0;
            else
            {
                next_curwin_size = (room + p_wiw + (totwincount - 1) * p_wmw
                                           + (totwincount - 1)) / totwincount;
                if (next_curwin_size > p_wiw)
                    room -= next_curwin_size - p_wiw;
                else
                    next_curwin_size = p_wiw;
            }
            if (n != m)
                --totwincount;
        }
        for (fr = topfr->fr_child; fr != ((void *)0); fr = fr->fr_next)
        {
            n = m = 0;
            wincount = 1;
            if (fr->fr_next == ((void *)0))
                new_size = width;
            else if (dir == 'v')
                new_size = fr->fr_width;
            else
            {
                n = frame_minwidth(fr, (win_T *)-1);
                wincount = (n + (fr->fr_next == ((void *)0) ? extra_sep : 0))
                                                                / (p_wmw + 1);
                m = frame_minwidth(fr, next_curwin);
                if (n != m)
                    --wincount;
                new_size = (wincount * room + ((unsigned)totwincount >> 1))
                                                                / totwincount;
                if (n != m)
                {
                    next_curwin_size -= p_wiw - (m - n);
                    new_size += next_curwin_size;
                }
            }
            if (!current || dir != 'v' || topfr->fr_parent != ((void *)0)
                    || (new_size != fr->fr_width)
                    || frame_has_win(fr, next_curwin))
                win_equal_rec(next_curwin, current, fr, dir, col, row,
                                                        new_size + n, height);
            col += new_size + n;
            width -= new_size + n;
            if (n != m)
                room -= new_size - next_curwin_size;
            else
                room -= new_size;
            totwincount -= wincount;
        }
    }
    else
    {
        topfr->fr_width = width;
        topfr->fr_height = height;
        if (dir != 'h')
        {
            n = frame_minheight(topfr, (win_T *)-1);
            if (row + height == cmdline_row && p_ls == 0)
                extra_sep = 1;
            else
                extra_sep = 0;
            totwincount = (n + extra_sep) / (p_wmh + 1);
            has_next_curwin = frame_has_win(topfr, next_curwin);
            m = frame_minheight(topfr, next_curwin);
            room = height - m;
            if (room < 0)
            {
                next_curwin_size = p_wh + room;
                room = 0;
            }
            else
            {
                next_curwin_size = -1;
                for (fr = topfr->fr_child; fr != ((void *)0); fr = fr->fr_next)
                {
                    if (frame_fixed_height(fr))
                    {
                        n = frame_minheight(fr, (win_T *)-1);
                        new_size = fr->fr_height;
                        if (frame_has_win(fr, next_curwin))
                        {
                            room += p_wh - p_wmh;
                            next_curwin_size = 0;
                            if (new_size < p_wh)
                                new_size = p_wh;
                        }
                        else
                            totwincount -= (n + (fr->fr_next == ((void *)0)
                                              ? extra_sep : 0)) / (p_wmh + 1);
                        room -= new_size - n;
                        if (room < 0)
                        {
                            new_size += room;
                            room = 0;
                        }
                        fr->fr_newheight = new_size;
                    }
                }
                if (next_curwin_size == -1)
                {
                    if (!has_next_curwin)
                        next_curwin_size = 0;
                    else if (totwincount > 1
                            && (room + (totwincount - 2))
                                                   / (totwincount - 1) > p_wh)
                    {
                        next_curwin_size = (room + p_wh + totwincount * p_wmh
                                           + (totwincount - 1)) / totwincount;
                        room -= next_curwin_size - p_wh;
                    }
                    else
                        next_curwin_size = p_wh;
                }
            }
            if (has_next_curwin)
                --totwincount;
        }
        for (fr = topfr->fr_child; fr != ((void *)0); fr = fr->fr_next)
        {
            n = m = 0;
            wincount = 1;
            if (fr->fr_next == ((void *)0))
                new_size = height;
            else if (dir == 'h')
                new_size = fr->fr_height;
            else if (frame_fixed_height(fr))
            {
                new_size = fr->fr_newheight;
                wincount = 0;
            }
            else
            {
                n = frame_minheight(fr, (win_T *)-1);
                wincount = (n + (fr->fr_next == ((void *)0) ? extra_sep : 0))
                                                                / (p_wmh + 1);
                m = frame_minheight(fr, next_curwin);
                if (has_next_curwin)
                    hnc = frame_has_win(fr, next_curwin);
                else
                    hnc = 0;
                if (hnc)
                    --wincount;
                if (totwincount == 0)
                    new_size = room;
                else
                    new_size = (wincount * room + ((unsigned)totwincount >> 1))
                                                                / totwincount;
                if (hnc)
                {
                    next_curwin_size -= p_wh - (m - n);
                    new_size += next_curwin_size;
                    room -= new_size - next_curwin_size;
                }
                else
                    room -= new_size;
                new_size += n;
            }
            if (!current || dir != 'h' || topfr->fr_parent != ((void *)0)
                    || (new_size != fr->fr_height)
                    || frame_has_win(fr, next_curwin))
                win_equal_rec(next_curwin, current, fr, dir, col, row,
                                                             width, new_size);
            row += new_size;
            height -= new_size;
            totwincount -= wincount;
        }
    }
}
    void close_windows(buf)
    buf_T *buf;
{
    win_T *win;
    ++RedrawingDisabled;
    for (win = firstwin; win != ((void *)0) && lastwin != firstwin; )
    {
        if (win->w_buffer == buf)
        {
            win_close(win, 0);
            win = firstwin;
        }
        else
            win = win->w_next;
    }
    --RedrawingDisabled;
}
    void win_close(win, free_buf)
    win_T *win;
    int free_buf;
{
    win_T *wp;
    int other_buffer = 0;
    int close_curwin = 0;
    frame_T *frp;
    int dir;
    int help_window = 0;
    if (lastwin == firstwin)
    {
        emsg((char_u *)(((char *)("E444: Cannot close last window"))));
        return;
    }
    if (win->w_buffer->b_help)
        help_window = 1;
    else
        clear_snapshot();
    if (win == curwin)
    {
        wp = frame2win(win_altframe(win));
        if (wp->w_buffer != curbuf)
        {
            other_buffer = 1;
            apply_autocmds(EVENT_BUFLEAVE, ((void *)0), ((void *)0), 0, curbuf);
            if (!win_valid(win) || firstwin == lastwin)
                return;
        }
        apply_autocmds(EVENT_WINLEAVE, ((void *)0), ((void *)0), 0, curbuf);
        if (!win_valid(win) || firstwin == lastwin)
            return;
        if (aborting())
            return;
    }
    close_buffer(win, win->w_buffer, free_buf ? 2 : 0);
    if (!win_valid(win) || firstwin == lastwin)
        return;
    alist_unlink(win->w_alist);
    frp = win->w_frame;
    wp = winframe_remove(win, &dir);
    vim_free(frp);
    win_free(win);
    if (win == curwin)
    {
        curwin = wp;
        if (wp->w_onebuf_opt.wo_pvw || bt_quickfix(wp->w_buffer))
        {
            for (;;)
            {
                if (wp->w_next == ((void *)0))
                    wp = firstwin;
                else
                    wp = wp->w_next;
                if (wp == curwin)
                    break;
                if (!wp->w_onebuf_opt.wo_pvw && !bt_quickfix(wp->w_buffer))
                {
                    curwin = wp;
                    break;
                }
            }
        }
        curbuf = curwin->w_buffer;
        close_curwin = 1;
    }
    if (p_ea)
        win_equal(curwin, 1,
                dir
                );
    else
        win_comp_pos();
    if (close_curwin)
    {
        win_enter_ext(wp, 0, 1);
        if (other_buffer)
            apply_autocmds(EVENT_BUFENTER, ((void *)0), ((void *)0), 0, curbuf);
    }
    last_status(0);
    if (help_window)
        restore_snapshot(close_curwin);
    if (gui.in_use && !win_hasvertsplit())
        gui_init_which_components(((void *)0));
    redraw_all_later(40);
}
    static win_T * winframe_remove(win, dirp)
    win_T *win;
    int *dirp;
{
    frame_T *frp, *frp2, *frp3;
    frame_T *frp_close = win->w_frame;
    win_T *wp;
    int old_height = 0;
    frp2 = win_altframe(win);
    wp = frame2win(frp2);
    frame_remove(frp_close);
    if (frp_close->fr_parent->fr_layout == 2)
    {
        if (frp2->fr_win != ((void *)0)
                && (frp2->fr_next != ((void *)0) || frp2->fr_prev != ((void *)0))
                && frp2->fr_win->w_onebuf_opt.wo_wfh)
            old_height = frp2->fr_win->w_height;
        frame_new_height(frp2, frp2->fr_height + frp_close->fr_height,
                            frp2 == frp_close->fr_next ? 1 : 0, 0);
        if (old_height != 0)
            win_setheight_win(old_height, frp2->fr_win);
        *dirp = 'v';
    }
    else
    {
        frame_new_width(frp2, frp2->fr_width + frp_close->fr_width,
                                   frp2 == frp_close->fr_next ? 1 : 0);
        *dirp = 'h';
    }
    if (frp2 == frp_close->fr_next)
    {
        int row = win->w_winrow;
        int col = (win->w_wincol);
        frame_comp_pos(frp2, &row, &col);
    }
    if (frp2->fr_next == ((void *)0) && frp2->fr_prev == ((void *)0))
    {
        frp2->fr_parent->fr_layout = frp2->fr_layout;
        frp2->fr_parent->fr_child = frp2->fr_child;
        for (frp = frp2->fr_child; frp != ((void *)0); frp = frp->fr_next)
            frp->fr_parent = frp2->fr_parent;
        frp2->fr_parent->fr_win = frp2->fr_win;
        if (frp2->fr_win != ((void *)0))
            frp2->fr_win->w_frame = frp2->fr_parent;
        frp = frp2->fr_parent;
        vim_free(frp2);
        frp2 = frp->fr_parent;
        if (frp2 != ((void *)0) && frp2->fr_layout == frp->fr_layout)
        {
            if (frp2->fr_child == frp)
                frp2->fr_child = frp->fr_child;
            frp->fr_child->fr_prev = frp->fr_prev;
            if (frp->fr_prev != ((void *)0))
                frp->fr_prev->fr_next = frp->fr_child;
            for (frp3 = frp->fr_child; ; frp3 = frp3->fr_next)
            {
                frp3->fr_parent = frp2;
                if (frp3->fr_next == ((void *)0))
                {
                    frp3->fr_next = frp->fr_next;
                    if (frp->fr_next != ((void *)0))
                        frp->fr_next->fr_prev = frp3;
                    break;
                }
            }
            vim_free(frp);
        }
    }
    return wp;
}
    static frame_T * win_altframe(win)
    win_T *win;
{
    frame_T *frp;
    int b;
    frp = win->w_frame;
    if (frp->fr_parent->fr_layout == 1)
        b = p_spr;
    else
        b = p_sb;
    if ((!b && frp->fr_next != ((void *)0)) || frp->fr_prev == ((void *)0))
        return frp->fr_next;
    return frp->fr_prev;
}
    static win_T * frame2win(frp)
    frame_T *frp;
{
    while (frp->fr_win == ((void *)0))
        frp = frp->fr_child;
    return frp->fr_win;
}
    static int frame_has_win(frp, wp)
    frame_T *frp;
    win_T *wp;
{
    frame_T *p;
    if (frp->fr_layout == 0)
        return frp->fr_win == wp;
    for (p = frp->fr_child; p != ((void *)0); p = p->fr_next)
        if (frame_has_win(p, wp))
            return 1;
    return 0;
}
    static void frame_new_height(topfrp, height, topfirst, wfh)
    frame_T *topfrp;
    int height;
    int topfirst;
    int wfh;
{
    frame_T *frp;
    int extra_lines;
    int h;
    if (topfrp->fr_win != ((void *)0))
    {
        win_new_height(topfrp->fr_win,
                                    height - topfrp->fr_win->w_status_height);
    }
    else if (topfrp->fr_layout == 1)
    {
        do
        {
            for (frp = topfrp->fr_child; frp != ((void *)0); frp = frp->fr_next)
            {
                frame_new_height(frp, height, topfirst, wfh);
                if (frp->fr_height > height)
                {
                    height = frp->fr_height;
                    break;
                }
            }
        }
        while (frp != ((void *)0));
    }
    else
    {
        frp = topfrp->fr_child;
        if (wfh)
            while (frame_fixed_height(frp))
            {
                frp = frp->fr_next;
                if (frp == ((void *)0))
                    return;
            }
        if (!topfirst)
        {
            while (frp->fr_next != ((void *)0))
                frp = frp->fr_next;
            if (wfh)
                while (frame_fixed_height(frp))
                    frp = frp->fr_prev;
        }
        extra_lines = height - topfrp->fr_height;
        if (extra_lines < 0)
        {
            while (frp != ((void *)0))
            {
                h = frame_minheight(frp, ((void *)0));
                if (frp->fr_height + extra_lines < h)
                {
                    extra_lines += frp->fr_height - h;
                    frame_new_height(frp, h, topfirst, wfh);
                }
                else
                {
                    frame_new_height(frp, frp->fr_height + extra_lines,
                                                               topfirst, wfh);
                    break;
                }
                if (topfirst)
                {
                    do
                        frp = frp->fr_next;
                    while (wfh && frp != ((void *)0) && frame_fixed_height(frp));
                }
                else
                {
                    do
                        frp = frp->fr_prev;
                    while (wfh && frp != ((void *)0) && frame_fixed_height(frp));
                }
                if (frp == ((void *)0))
                    height -= extra_lines;
            }
        }
        else if (extra_lines > 0)
        {
            frame_new_height(frp, frp->fr_height + extra_lines, topfirst, wfh);
        }
    }
    topfrp->fr_height = height;
}
    static int frame_fixed_height(frp)
    frame_T *frp;
{
    if (frp->fr_win != ((void *)0))
        return frp->fr_win->w_onebuf_opt.wo_wfh;
    if (frp->fr_layout == 1)
    {
        for (frp = frp->fr_child; frp != ((void *)0); frp = frp->fr_next)
            if (frame_fixed_height(frp))
                return 1;
        return 0;
    }
    for (frp = frp->fr_child; frp != ((void *)0); frp = frp->fr_next)
        if (!frame_fixed_height(frp))
            return 0;
    return 1;
}
    static void frame_add_statusline(frp)
    frame_T *frp;
{
    win_T *wp;
    if (frp->fr_layout == 0)
    {
        wp = frp->fr_win;
        if (wp->w_status_height == 0)
        {
            if (wp->w_height > 0)
                --wp->w_height;
            wp->w_status_height = 1;
        }
    }
    else if (frp->fr_layout == 1)
    {
        for (frp = frp->fr_child; frp != ((void *)0); frp = frp->fr_next)
            frame_add_statusline(frp);
    }
    else
    {
        for (frp = frp->fr_child; frp->fr_next != ((void *)0); frp = frp->fr_next)
            ;
        frame_add_statusline(frp);
    }
}
    static void frame_new_width(topfrp, width, leftfirst)
    frame_T *topfrp;
    int width;
    int leftfirst;
{
    frame_T *frp;
    int extra_cols;
    int w;
    win_T *wp;
    if (topfrp->fr_layout == 0)
    {
        wp = topfrp->fr_win;
        for (frp = topfrp; frp->fr_parent != ((void *)0); frp = frp->fr_parent)
            if (frp->fr_parent->fr_layout == 1 && frp->fr_next != ((void *)0))
                break;
        if (frp->fr_parent == ((void *)0))
            wp->w_vsep_width = 0;
        win_new_width(wp, width - wp->w_vsep_width);
    }
    else if (topfrp->fr_layout == 2)
    {
        for (frp = topfrp->fr_child; frp != ((void *)0); frp = frp->fr_next)
            frame_new_width(frp, width, leftfirst);
    }
    else
    {
        frp = topfrp->fr_child;
        if (!leftfirst)
            while (frp->fr_next != ((void *)0))
                frp = frp->fr_next;
        extra_cols = width - topfrp->fr_width;
        if (extra_cols < 0)
        {
            while (frp != ((void *)0))
            {
                w = frame_minwidth(frp, ((void *)0));
                if (frp->fr_width + extra_cols < w)
                {
                    extra_cols += frp->fr_width - w;
                    frame_new_width(frp, w, leftfirst);
                }
                else
                {
                    frame_new_width(frp, frp->fr_width + extra_cols, leftfirst);
                    break;
                }
                if (leftfirst)
                    frp = frp->fr_next;
                else
                    frp = frp->fr_prev;
            }
        }
        else if (extra_cols > 0)
        {
            frame_new_width(frp, frp->fr_width + extra_cols, leftfirst);
        }
    }
    topfrp->fr_width = width;
}
    static void frame_add_vsep(frp)
    frame_T *frp;
{
    win_T *wp;
    if (frp->fr_layout == 0)
    {
        wp = frp->fr_win;
        if (wp->w_vsep_width == 0)
        {
            if (wp->w_width > 0)
                --wp->w_width;
            wp->w_vsep_width = 1;
        }
    }
    else if (frp->fr_layout == 2)
    {
        for (frp = frp->fr_child; frp != ((void *)0); frp = frp->fr_next)
            frame_add_vsep(frp);
    }
    else
    {
        frp = frp->fr_child;
        while (frp->fr_next != ((void *)0))
            frp = frp->fr_next;
        frame_add_vsep(frp);
    }
}
    static void frame_fix_width(wp)
    win_T *wp;
{
    wp->w_frame->fr_width = wp->w_width + wp->w_vsep_width;
}
    static void frame_fix_height(wp)
    win_T *wp;
{
    wp->w_frame->fr_height = wp->w_height + wp->w_status_height;
}
    static int frame_minheight(topfrp, next_curwin)
    frame_T *topfrp;
    win_T *next_curwin;
{
    frame_T *frp;
    int m;
    int n;
    if (topfrp->fr_win != ((void *)0))
    {
        if (topfrp->fr_win == next_curwin)
            m = p_wh + topfrp->fr_win->w_status_height;
        else
        {
            m = p_wmh + topfrp->fr_win->w_status_height;
            if (p_wmh == 0 && topfrp->fr_win == curwin && next_curwin == ((void *)0))
                ++m;
        }
    }
    else if (topfrp->fr_layout == 1)
    {
        m = 0;
        for (frp = topfrp->fr_child; frp != ((void *)0); frp = frp->fr_next)
        {
            n = frame_minheight(frp, next_curwin);
            if (n > m)
                m = n;
        }
    }
    else
    {
        m = 0;
        for (frp = topfrp->fr_child; frp != ((void *)0); frp = frp->fr_next)
            m += frame_minheight(frp, next_curwin);
    }
    return m;
}
    static int frame_minwidth(topfrp, next_curwin)
    frame_T *topfrp;
    win_T *next_curwin;
{
    frame_T *frp;
    int m, n;
    if (topfrp->fr_win != ((void *)0))
    {
        if (topfrp->fr_win == next_curwin)
            m = p_wiw + topfrp->fr_win->w_vsep_width;
        else
        {
            m = p_wmw + topfrp->fr_win->w_vsep_width;
            if (p_wmw == 0 && topfrp->fr_win == curwin && next_curwin == ((void *)0))
                ++m;
        }
    }
    else if (topfrp->fr_layout == 2)
    {
        m = 0;
        for (frp = topfrp->fr_child; frp != ((void *)0); frp = frp->fr_next)
        {
            n = frame_minwidth(frp, next_curwin);
            if (n > m)
                m = n;
        }
    }
    else
    {
        m = 0;
        for (frp = topfrp->fr_child; frp != ((void *)0); frp = frp->fr_next)
            m += frame_minwidth(frp, next_curwin);
    }
    return m;
}
    void close_others(message, forceit)
    int message;
    int forceit;
{
    win_T *wp;
    win_T *nextwp;
    int r;
    if (lastwin == firstwin)
    {
        if (message
                    && !autocmd_busy
                                    )
            msg((char_u *)(((char *)("Already only one window"))));
        return;
    }
    for (wp = firstwin; win_valid(wp); wp = nextwp)
    {
        nextwp = wp->w_next;
        if (wp != curwin)
        {
            r = can_abandon(wp->w_buffer, forceit);
            if (!win_valid(wp))
            {
                nextwp = firstwin;
                continue;
            }
            if (!r)
            {
                if (message && (p_confirm || cmdmod.confirm))
                {
                    dialog_changed(wp->w_buffer, 0);
                    if (!win_valid(wp))
                    {
                        nextwp = firstwin;
                        continue;
                    }
                }
                if (bufIsChanged(wp->w_buffer))
                    continue;
            }
            win_close(wp, !(buf_hide(wp->w_buffer)) && !bufIsChanged(wp->w_buffer));
        }
    }
    if (lastwin != firstwin)
        emsg((char_u *)(((char *)("E445: Other window contains changes"))));
}
    void win_init(wp)
    win_T *wp;
{
    redraw_win_later(wp, 40);
    wp->w_lines_valid = 0;
    wp->w_cursor.lnum = 1;
    wp->w_curswant = wp->w_cursor.col = 0;
    wp->w_cursor.coladd = 0;
    wp->w_pcmark.lnum = 1;
    wp->w_pcmark.col = 0;
    wp->w_prev_pcmark.lnum = 0;
    wp->w_prev_pcmark.col = 0;
    wp->w_topline = 1;
    wp->w_topfill = 0;
    wp->w_botline = 2;
}
    void win_alloc_first()
{
    curwin = win_alloc(((void *)0));
    curbuf = buflist_new(((void *)0), ((void *)0), 1L, 2);
    if (curwin == ((void *)0) || curbuf == ((void *)0))
        mch_exit(0);
    curwin->w_buffer = curbuf;
    curbuf->b_nwindows = 1;
    curwin->w_alist = &global_alist;
    win_init(curwin);
    topframe = (frame_T *)alloc_clear((unsigned)sizeof(frame_T));
    if (topframe == ((void *)0))
        mch_exit(0);
    topframe->fr_layout = 0;
    topframe->fr_width = Columns;
    topframe->fr_height = Rows - p_ch;
    topframe->fr_win = curwin;
    curwin->w_frame = topframe;
}
    void win_goto(wp)
    win_T *wp;
{
    if (cmdwin_type != 0)
    {
        beep_flush();
        return;
    }
    if (wp->w_buffer != curbuf)
        reset_VIsual_and_resel();
    else if (VIsual_active)
        wp->w_cursor = curwin->w_cursor;
    need_mouse_correct = 1;
    win_enter(wp, 1);
}
    static void win_goto_ver(up, count)
    int up;
    long count;
{
    frame_T *fr;
    frame_T *nfr;
    frame_T *foundfr;
    foundfr = curwin->w_frame;
    while (count--)
    {
        fr = foundfr;
        for (;;)
        {
            if (fr == topframe)
                goto end;
            if (up)
                nfr = fr->fr_prev;
            else
                nfr = fr->fr_next;
            if (fr->fr_parent->fr_layout == 2 && nfr != ((void *)0))
                break;
            fr = fr->fr_parent;
        }
        for (;;)
        {
            if (nfr->fr_layout == 0)
            {
                foundfr = nfr;
                break;
            }
            fr = nfr->fr_child;
            if (nfr->fr_layout == 1)
            {
                while (fr->fr_next != ((void *)0)
                        && frame2win(fr)->w_wincol + fr->fr_width
                                         <= curwin->w_wincol + curwin->w_wcol)
                    fr = fr->fr_next;
            }
            if (nfr->fr_layout == 2 && up)
                while (fr->fr_next != ((void *)0))
                    fr = fr->fr_next;
            nfr = fr;
        }
    }
end:
    if (foundfr != ((void *)0))
        win_goto(foundfr->fr_win);
}
    static void win_goto_hor(left, count)
    int left;
    long count;
{
    frame_T *fr;
    frame_T *nfr;
    frame_T *foundfr;
    foundfr = curwin->w_frame;
    while (count--)
    {
        fr = foundfr;
        for (;;)
        {
            if (fr == topframe)
                goto end;
            if (left)
                nfr = fr->fr_prev;
            else
                nfr = fr->fr_next;
            if (fr->fr_parent->fr_layout == 1 && nfr != ((void *)0))
                break;
            fr = fr->fr_parent;
        }
        for (;;)
        {
            if (nfr->fr_layout == 0)
            {
                foundfr = nfr;
                break;
            }
            fr = nfr->fr_child;
            if (nfr->fr_layout == 2)
            {
                while (fr->fr_next != ((void *)0)
                        && frame2win(fr)->w_winrow + fr->fr_height
                                         <= curwin->w_winrow + curwin->w_wrow)
                    fr = fr->fr_next;
            }
            if (nfr->fr_layout == 1 && left)
                while (fr->fr_next != ((void *)0))
                    fr = fr->fr_next;
            nfr = fr;
        }
    }
end:
    if (foundfr != ((void *)0))
        win_goto(foundfr->fr_win);
}
    void win_enter(wp, undo_sync)
    win_T *wp;
    int undo_sync;
{
    win_enter_ext(wp, undo_sync, 0);
    if (p_acd && curbuf->b_ffname != ((void *)0)
            && vim_chdirfile(curbuf->b_ffname) == 1)
        shorten_fnames(1);
}
    static void win_enter_ext(wp, undo_sync, curwin_invalid)
    win_T *wp;
    int undo_sync;
    int curwin_invalid;
{
    int other_buffer = 0;
    if (wp == curwin && !curwin_invalid)
        return;
    if (!curwin_invalid)
    {
        if (wp->w_buffer != curbuf)
        {
            apply_autocmds(EVENT_BUFLEAVE, ((void *)0), ((void *)0), 0, curbuf);
            other_buffer = 1;
            if (!win_valid(wp))
                return;
        }
        apply_autocmds(EVENT_WINLEAVE, ((void *)0), ((void *)0), 0, curbuf);
        if (!win_valid(wp))
            return;
        if (aborting())
            return;
    }
    if (undo_sync && curbuf != wp->w_buffer)
        u_sync();
    if (wp->w_buffer != curbuf)
        buf_copy_options(wp->w_buffer, 1 | 4);
    if (!curwin_invalid)
    {
        prevwin = curwin;
        curwin->w_redr_status = 1;
    }
    curwin = wp;
    curbuf = wp->w_buffer;
    check_cursor();
    if (!virtual_active())
        curwin->w_cursor.coladd = 0;
    changed_line_abv_curs();
    if (curwin->w_localdir != ((void *)0))
    {
        if (globaldir == ((void *)0))
        {
            char_u cwd[1024];
            if (mch_dirname(cwd, 1024) == 1)
                globaldir = vim_strsave(cwd);
        }
        chdir((char *)curwin->w_localdir);
        shorten_fnames(1);
    }
    else if (globaldir != ((void *)0))
    {
        chdir((char *)globaldir);
        vim_free(globaldir);
        globaldir = ((void *)0);
        shorten_fnames(1);
    }
    apply_autocmds(EVENT_WINENTER, ((void *)0), ((void *)0), 0, curbuf);
    if (other_buffer)
        apply_autocmds(EVENT_BUFENTER, ((void *)0), ((void *)0), 0, curbuf);
    maketitle();
    curwin->w_redr_status = 1;
    if (restart_edit)
        redraw_later(10);
    if (curwin->w_height < p_wh && !curwin->w_onebuf_opt.wo_wfh)
        win_setheight((int)p_wh);
    else if (curwin->w_height == 0)
        win_setheight(1);
    if (curwin->w_width < p_wiw)
        win_setwidth((int)p_wiw);
    setmouse();
}
    win_T * buf_jump_open_win(buf)
    buf_T *buf;
{
    win_T *wp;
    for (wp = firstwin; wp; wp = wp->w_next)
        if (wp->w_buffer == buf)
            break;
    if (wp != ((void *)0))
        win_enter(wp, 0);
    return wp;
}
    static win_T * win_alloc(after)
    win_T *after;
{
    win_T *newwin;
    newwin = (win_T *)alloc_clear((unsigned)sizeof(win_T));
    if (newwin != ((void *)0) && win_alloc_lines(newwin) == 0)
    {
        vim_free(newwin);
        newwin = ((void *)0);
    }
    if (newwin != ((void *)0))
    {
        win_append(after, newwin);
        newwin->w_wincol = 0;
        newwin->w_width = Columns;
        newwin->w_topline = 1;
        newwin->w_topfill = 0;
        newwin->w_botline = 2;
        newwin->w_cursor.lnum = 1;
        newwin->w_scbind_pos = 1;
        newwin->w_fraction = 0;
        newwin->w_prev_fraction_row = -1;
        if (gui.in_use)
        {
            gui_create_scrollbar(&newwin->w_scrollbars[0],
                    0, newwin);
            gui_create_scrollbar(&newwin->w_scrollbars[1],
                    1, newwin);
        }
        var_init(&newwin->w_vars);
        foldInitWin(newwin);
    }
    return newwin;
}
    static void win_free(wp)
    win_T *wp;
{
    int i;
    clear_winopt(&wp->w_onebuf_opt);
    clear_winopt(&wp->w_allbuf_opt);
    var_clear(&wp->w_vars);
    if (prevwin == wp)
        prevwin = ((void *)0);
    win_free_lsize(wp);
    for (i = 0; i < wp->w_tagstacklen; ++i)
        vim_free(wp->w_tagstack[i].tagname);
    vim_free(wp->w_localdir);
    vim_free(wp->w_match.regprog);
    free_jumplist(wp);
    if (gui.in_use)
    {
        gui_mch_destroy_scrollbar(&wp->w_scrollbars[0]);
        gui_mch_destroy_scrollbar(&wp->w_scrollbars[1]);
    }
    win_remove(wp);
    vim_free(wp);
}
    static void win_append(after, wp)
    win_T *after, *wp;
{
    win_T *before;
    if (after == ((void *)0))
        before = firstwin;
    else
        before = after->w_next;
    wp->w_next = before;
    wp->w_prev = after;
    if (after == ((void *)0))
        firstwin = wp;
    else
        after->w_next = wp;
    if (before == ((void *)0))
        lastwin = wp;
    else
        before->w_prev = wp;
}
    static void win_remove(wp)
    win_T *wp;
{
    if (wp->w_prev != ((void *)0))
        wp->w_prev->w_next = wp->w_next;
    else
        firstwin = wp->w_next;
    if (wp->w_next != ((void *)0))
        wp->w_next->w_prev = wp->w_prev;
    else
        lastwin = wp->w_prev;
}
    static void frame_append(after, frp)
    frame_T *after, *frp;
{
    frp->fr_next = after->fr_next;
    after->fr_next = frp;
    if (frp->fr_next != ((void *)0))
        frp->fr_next->fr_prev = frp;
    frp->fr_prev = after;
}
    static void frame_insert(before, frp)
    frame_T *before, *frp;
{
    frp->fr_next = before;
    frp->fr_prev = before->fr_prev;
    before->fr_prev = frp;
    if (frp->fr_prev != ((void *)0))
        frp->fr_prev->fr_next = frp;
    else
        frp->fr_parent->fr_child = frp;
}
    static void frame_remove(frp)
    frame_T *frp;
{
    if (frp->fr_prev != ((void *)0))
        frp->fr_prev->fr_next = frp->fr_next;
    else
        frp->fr_parent->fr_child = frp->fr_next;
    if (frp->fr_next != ((void *)0))
        frp->fr_next->fr_prev = frp->fr_prev;
}
    int win_alloc_lines(wp)
    win_T *wp;
{
    wp->w_lines_valid = 0;
    wp->w_lines = (wline_T *)alloc((unsigned)(Rows * sizeof(wline_T)));
    if (wp->w_lines == ((void *)0))
        return 0;
    return 1;
}
    void win_free_lsize(wp)
    win_T *wp;
{
    vim_free(wp->w_lines);
    wp->w_lines = ((void *)0);
}
    void shell_new_rows()
{
    int h = (int)(Rows - p_ch);
    if (firstwin == ((void *)0))
        return;
    if (h < frame_minheight(topframe, ((void *)0)))
        h = frame_minheight(topframe, ((void *)0));
    frame_new_height(topframe, h, 0, 1);
    if (topframe->fr_height != h)
        frame_new_height(topframe, h, 0, 0);
    (void)win_comp_pos();
    compute_cmdrow();
}
    void shell_new_columns()
{
    if (firstwin == ((void *)0))
        return;
    frame_new_width(topframe, (int)Columns, 0);
    (void)win_comp_pos();
}
    void win_size_save(gap)
    garray_T *gap;
{
    win_T *wp;
    ga_init2(gap, (int)sizeof(int), 1);
    if (ga_grow(gap, win_count() * 2) == 1)
        for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        {
            ((int *)gap->ga_data)[gap->ga_len++] =
                                               wp->w_width + wp->w_vsep_width;
            ((int *)gap->ga_data)[gap->ga_len++] = wp->w_height;
        }
}
    void win_size_restore(gap)
    garray_T *gap;
{
    win_T *wp;
    int i;
    if (win_count() * 2 == gap->ga_len)
    {
        i = 0;
        for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        {
            frame_setwidth(wp->w_frame, ((int *)gap->ga_data)[i++]);
            win_setheight_win(((int *)gap->ga_data)[i++], wp);
        }
        (void)win_comp_pos();
    }
}
    static int win_comp_pos()
{
    int row = 0;
    int col = 0;
    frame_comp_pos(topframe, &row, &col);
    return row;
}
    static void frame_comp_pos(topfrp, row, col)
    frame_T *topfrp;
    int *row;
    int *col;
{
    win_T *wp;
    frame_T *frp;
    int startcol;
    int startrow;
    wp = topfrp->fr_win;
    if (wp != ((void *)0))
    {
        if (wp->w_winrow != *row
                || wp->w_wincol != *col
                )
        {
            wp->w_winrow = *row;
            wp->w_wincol = *col;
            redraw_win_later(wp, 40);
            wp->w_redr_status = 1;
        }
        *row += wp->w_height + wp->w_status_height;
        *col += wp->w_width + wp->w_vsep_width;
    }
    else
    {
        startrow = *row;
        startcol = *col;
        for (frp = topfrp->fr_child; frp != ((void *)0); frp = frp->fr_next)
        {
            if (topfrp->fr_layout == 1)
                *row = startrow;
            else
                *col = startcol;
            frame_comp_pos(frp, row, col);
        }
    }
}
    void win_setheight(height)
    int height;
{
    if (height < p_wmh)
        height = p_wmh;
    if (height == 0)
        height = 1;
    win_setheight_win(height, curwin);
}
    static void win_setheight_win(height, win)
    int height;
    win_T *win;
{
    int row;
    frame_setheight(win->w_frame, height + win->w_status_height);
    row = win_comp_pos();
    if (full_screen && msg_scrolled == 0 && row < cmdline_row)
        screen_fill(row, cmdline_row, 0, (int)Columns, ' ', ' ', 0);
    cmdline_row = row;
    msg_row = row;
    msg_col = 0;
    redraw_all_later(40);
}
    static void frame_setheight(curfrp, height)
    frame_T *curfrp;
    int height;
{
    int room;
    int take;
    int room_cmdline;
    int run;
    frame_T *frp;
    int h;
    int room_reserved;
    if (curfrp->fr_height == height)
        return;
    if (curfrp->fr_parent == ((void *)0))
    {
        if (height > Rows - p_ch)
            height = Rows - p_ch;
        if (height > 0)
            frame_new_height(curfrp, height, 0, 0);
    }
    else if (curfrp->fr_parent->fr_layout == 1)
    {
        h = frame_minheight(curfrp->fr_parent, ((void *)0));
        if (height < h)
            height = h;
        frame_setheight(curfrp->fr_parent, height);
    }
    else
    {
        for (run = 1; run <= 2; ++run)
        {
            room = 0;
            room_reserved = 0;
            for (frp = curfrp->fr_parent->fr_child; frp != ((void *)0);
                                                           frp = frp->fr_next)
            {
                if (frp != curfrp
                        && frp->fr_win != ((void *)0)
                        && frp->fr_win->w_onebuf_opt.wo_wfh)
                    room_reserved += frp->fr_height;
                room += frp->fr_height;
                if (frp != curfrp)
                    room -= frame_minheight(frp, ((void *)0));
            }
            if (curfrp->fr_width != Columns)
                room_cmdline = 0;
            else
            {
                room_cmdline = Rows - p_ch - (lastwin->w_winrow
                               + lastwin->w_height + lastwin->w_status_height);
                if (room_cmdline < 0)
                    room_cmdline = 0;
            }
            if (height <= room + room_cmdline)
                break;
            if (run == 2 || curfrp->fr_width == Columns)
            {
                if (height > room + room_cmdline)
                    height = room + room_cmdline;
                break;
            }
            frame_setheight(curfrp->fr_parent, height
                + frame_minheight(curfrp->fr_parent, (win_T *)-1) - (int)p_wmh - 1);
        }
        take = height - curfrp->fr_height;
        if (height > room + room_cmdline - room_reserved)
            room_reserved = room + room_cmdline - height;
        if (take < 0 && room - curfrp->fr_height < room_reserved)
            room_reserved = 0;
        if (take > 0 && room_cmdline > 0)
        {
            if (take < room_cmdline)
                room_cmdline = take;
            take -= room_cmdline;
            topframe->fr_height += room_cmdline;
        }
        frame_new_height(curfrp, height, 0, 0);
        for (run = 0; run < 2; ++run)
        {
            if (run == 0)
                frp = curfrp->fr_next;
            else
                frp = curfrp->fr_prev;
            while (frp != ((void *)0) && take != 0)
            {
                h = frame_minheight(frp, ((void *)0));
                if (room_reserved > 0
                        && frp->fr_win != ((void *)0)
                        && frp->fr_win->w_onebuf_opt.wo_wfh)
                {
                    if (room_reserved >= frp->fr_height)
                        room_reserved -= frp->fr_height;
                    else
                    {
                        if (frp->fr_height - room_reserved > take)
                            room_reserved = frp->fr_height - take;
                        take -= frp->fr_height - room_reserved;
                        frame_new_height(frp, room_reserved, 0, 0);
                        room_reserved = 0;
                    }
                }
                else
                {
                    if (frp->fr_height - take < h)
                    {
                        take -= frp->fr_height - h;
                        frame_new_height(frp, h, 0, 0);
                    }
                    else
                    {
                        frame_new_height(frp, frp->fr_height - take,
                                                                0, 0);
                        take = 0;
                    }
                }
                if (run == 0)
                    frp = frp->fr_next;
                else
                    frp = frp->fr_prev;
            }
        }
    }
}
    void win_setwidth(width)
    int width;
{
    if (width < p_wmw)
        width = p_wmw;
    if (width == 0)
        width = 1;
    frame_setwidth(curwin->w_frame, width + curwin->w_vsep_width);
    (void)win_comp_pos();
    redraw_all_later(40);
}
    static void frame_setwidth(curfrp, width)
    frame_T *curfrp;
    int width;
{
    int room;
    int take;
    int run;
    frame_T *frp;
    int w;
    if (curfrp->fr_width == width)
        return;
    if (curfrp->fr_parent == ((void *)0))
        return;
    if (curfrp->fr_parent->fr_layout == 2)
    {
        w = frame_minwidth(curfrp->fr_parent, ((void *)0));
        if (width < w)
            width = w;
        frame_setwidth(curfrp->fr_parent, width);
    }
    else
    {
        for (run = 1; run <= 2; ++run)
        {
            room = 0;
            for (frp = curfrp->fr_parent->fr_child; frp != ((void *)0);
                                                           frp = frp->fr_next)
            {
                room += frp->fr_width;
                if (frp != curfrp)
                    room -= frame_minwidth(frp, ((void *)0));
            }
            if (width <= room)
                break;
            if (run == 2 || curfrp->fr_height >= Rows - p_ch)
            {
                if (width > room)
                    width = room;
                break;
            }
            frame_setwidth(curfrp->fr_parent, width
                 + frame_minwidth(curfrp->fr_parent, (win_T *)-1) - (int)p_wmw - 1);
        }
        take = width - curfrp->fr_width;
        frame_new_width(curfrp, width, 0);
        for (run = 0; run < 2; ++run)
        {
            if (run == 0)
                frp = curfrp->fr_next;
            else
                frp = curfrp->fr_prev;
            while (frp != ((void *)0) && take != 0)
            {
                w = frame_minwidth(frp, ((void *)0));
                if (frp->fr_width - take < w)
                {
                    take -= frp->fr_width - w;
                    frame_new_width(frp, w, 0);
                }
                else
                {
                    frame_new_width(frp, frp->fr_width - take, 0);
                    take = 0;
                }
                if (run == 0)
                    frp = frp->fr_next;
                else
                    frp = frp->fr_prev;
            }
        }
    }
}
    void win_setminheight()
{
    int room;
    int first = 1;
    win_T *wp;
    while (p_wmh > 0)
    {
        room = -p_wh;
        for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
            room += wp->w_height - p_wmh;
        if (room >= 0)
            break;
        --p_wmh;
        if (first)
        {
            emsg((char_u *)(((char *)(e_noroom))));
            first = 0;
        }
    }
}
    void win_drag_status_line(dragwin, offset)
    win_T *dragwin;
    int offset;
{
    frame_T *curfr;
    frame_T *fr;
    int room;
    int row;
    int up;
    int n;
    fr = dragwin->w_frame;
    curfr = fr;
    if (fr != topframe)
    {
        fr = fr->fr_parent;
        if (fr->fr_layout != 2)
        {
            curfr = fr;
            if (fr != topframe)
                fr = fr->fr_parent;
        }
    }
    while (curfr != topframe && curfr->fr_next == ((void *)0))
    {
        if (fr != topframe)
            fr = fr->fr_parent;
        curfr = fr;
        if (fr != topframe)
            fr = fr->fr_parent;
    }
    if (offset < 0)
    {
        up = 1;
        offset = -offset;
        if (fr == curfr)
        {
            room = fr->fr_height - frame_minheight(fr, ((void *)0));
        }
        else
        {
            room = 0;
            for (fr = fr->fr_child; ; fr = fr->fr_next)
            {
                room += fr->fr_height - frame_minheight(fr, ((void *)0));
                if (fr == curfr)
                    break;
            }
        }
        fr = curfr->fr_next;
    }
    else
    {
        up = 0;
        room = Rows - cmdline_row;
        if (curfr->fr_next == ((void *)0))
            room -= 1;
        else
            room -= p_ch;
        if (room < 0)
            room = 0;
        for (fr = curfr->fr_next; fr != ((void *)0); fr = fr->fr_next)
            room += fr->fr_height - frame_minheight(fr, ((void *)0));
        fr = curfr;
    }
    if (room < offset)
        offset = room;
    if (offset <= 0)
        return;
    if (fr != ((void *)0))
        frame_new_height(fr, fr->fr_height + offset, up, 0);
    if (up)
        fr = curfr;
    else
        fr = curfr->fr_next;
    while (fr != ((void *)0) && offset > 0)
    {
        n = frame_minheight(fr, ((void *)0));
        if (fr->fr_height - offset <= n)
        {
            offset -= fr->fr_height - n;
            frame_new_height(fr, n, !up, 0);
        }
        else
        {
            frame_new_height(fr, fr->fr_height - offset, !up, 0);
            break;
        }
        if (up)
            fr = fr->fr_prev;
        else
            fr = fr->fr_next;
    }
    row = win_comp_pos();
    screen_fill(row, cmdline_row, 0, (int)Columns, ' ', ' ', 0);
    cmdline_row = row;
    p_ch = Rows - cmdline_row;
    if (p_ch < 1)
        p_ch = 1;
    redraw_all_later(40);
    showmode();
}
    void win_drag_vsep_line(dragwin, offset)
    win_T *dragwin;
    int offset;
{
    frame_T *curfr;
    frame_T *fr;
    int room;
    int left;
    int n;
    fr = dragwin->w_frame;
    if (fr == topframe)
        return;
    curfr = fr;
    fr = fr->fr_parent;
    if (fr->fr_layout != 1)
    {
        if (fr == topframe)
            return;
        curfr = fr;
        fr = fr->fr_parent;
    }
    while (curfr->fr_next == ((void *)0))
    {
        if (fr == topframe)
            break;
        curfr = fr;
        fr = fr->fr_parent;
        if (fr != topframe)
        {
            curfr = fr;
            fr = fr->fr_parent;
        }
    }
    if (offset < 0)
    {
        left = 1;
        offset = -offset;
        room = 0;
        for (fr = fr->fr_child; ; fr = fr->fr_next)
        {
            room += fr->fr_width - frame_minwidth(fr, ((void *)0));
            if (fr == curfr)
                break;
        }
        fr = curfr->fr_next;
    }
    else
    {
        left = 0;
        room = 0;
        for (fr = curfr->fr_next; fr != ((void *)0); fr = fr->fr_next)
            room += fr->fr_width - frame_minwidth(fr, ((void *)0));
        fr = curfr;
    }
    if (room < offset)
        offset = room;
    if (offset <= 0)
        return;
    frame_new_width(fr, fr->fr_width + offset, left);
    if (left)
        fr = curfr;
    else
        fr = curfr->fr_next;
    while (fr != ((void *)0) && offset > 0)
    {
        n = frame_minwidth(fr, ((void *)0));
        if (fr->fr_width - offset <= n)
        {
            offset -= fr->fr_width - n;
            frame_new_width(fr, n, !left);
        }
        else
        {
            frame_new_width(fr, fr->fr_width - offset, !left);
            break;
        }
        if (left)
            fr = fr->fr_prev;
        else
            fr = fr->fr_next;
    }
    (void)win_comp_pos();
    redraw_all_later(40);
}
    static void win_new_height(wp, height)
    win_T *wp;
    int height;
{
    linenr_T lnum;
    int sline, line_size;
    if (height < 0)
        height = 0;
    if (wp->w_wrow != wp->w_prev_fraction_row && wp->w_height > 0)
        wp->w_fraction = ((long)wp->w_wrow * 16384L
                                    + 16384L / 2) / (long)wp->w_height;
    wp->w_height = height;
    wp->w_skipcol = 0;
    if (!wp->w_onebuf_opt.wo_scb || wp == curwin)
    {
        lnum = wp->w_cursor.lnum;
        if (lnum < 1)
            lnum = 1;
        wp->w_wrow = ((long)wp->w_fraction * (long)height - 1L) / 16384L;
        line_size = plines_win_col(wp, lnum, (long)(wp->w_cursor.col)) - 1;
        sline = wp->w_wrow - line_size;
        if (sline < 0)
        {
            wp->w_wrow = line_size;
        }
        else
        {
            while (sline > 0 && lnum > 1)
            {
                hasFoldingWin(wp, lnum, &lnum, ((void *)0), 1, ((void *)0));
                if (lnum == 1)
                {
                    line_size = 1;
                    --sline;
                    break;
                }
                --lnum;
                if (lnum == wp->w_topline)
                    line_size = plines_win_nofill(wp, lnum, 1)
                                                              + wp->w_topfill;
                else
                    line_size = plines_win(wp, lnum, 1);
                sline -= line_size;
            }
            if (sline < 0)
            {
                hasFoldingWin(wp, lnum, ((void *)0), &lnum, 1, ((void *)0));
                lnum++;
                wp->w_wrow -= line_size + sline;
            }
            else if (sline > 0)
            {
                lnum = 1;
                wp->w_wrow -= sline;
            }
        }
        set_topline(wp, lnum);
    }
    if (wp == curwin)
    {
        if (p_so)
            update_topline();
        curs_columns(0);
    }
    wp->w_prev_fraction_row = wp->w_wrow;
    win_comp_scroll(wp);
    redraw_win_later(wp, 40);
    wp->w_redr_status = 1;
    invalidate_botline_win(wp);
}
    static void win_new_width(wp, width)
    win_T *wp;
    int width;
{
    wp->w_width = width;
    wp->w_lines_valid = 0;
    changed_line_abv_curs_win(wp);
    invalidate_botline_win(wp);
    if (wp == curwin)
    {
        update_topline();
        curs_columns(1);
    }
    redraw_win_later(wp, 40);
    wp->w_redr_status = 1;
}
    void win_comp_scroll(wp)
    win_T *wp;
{
    wp->w_onebuf_opt.wo_scr = ((unsigned)wp->w_height >> 1);
    if (wp->w_onebuf_opt.wo_scr == 0)
        wp->w_onebuf_opt.wo_scr = 1;
}
    void command_height(old_p_ch)
    long old_p_ch;
{
    int h;
    frame_T *frp;
    frp = lastwin->w_frame;
    while (frp->fr_width != Columns && frp->fr_parent != ((void *)0))
        frp = frp->fr_parent;
    while (frp->fr_prev != ((void *)0) && frp->fr_layout == 0
                                                      && frp->fr_win->w_onebuf_opt.wo_wfh)
        frp = frp->fr_prev;
    if (starting != 2)
    {
        cmdline_row = Rows - p_ch;
        if (p_ch > old_p_ch)
        {
            while (p_ch > old_p_ch)
            {
                if (frp == ((void *)0))
                {
                    emsg((char_u *)(((char *)(e_noroom))));
                    p_ch = old_p_ch;
                    cmdline_row = Rows - p_ch;
                    break;
                }
                h = frp->fr_height - frame_minheight(frp, ((void *)0));
                if (h > p_ch - old_p_ch)
                    h = p_ch - old_p_ch;
                old_p_ch += h;
                frame_add_height(frp, -h);
                frp = frp->fr_prev;
            }
            (void)win_comp_pos();
            if (full_screen)
                screen_fill((int)(cmdline_row), (int)Rows, 0,
                                                   (int)Columns, ' ', ' ', 0);
            msg_row = cmdline_row;
            redraw_cmdline = 1;
            return;
        }
        if (msg_row < cmdline_row)
            msg_row = cmdline_row;
        redraw_cmdline = 1;
    }
    frame_add_height(frp, (int)(old_p_ch - p_ch));
    if (frp != lastwin->w_frame)
        (void)win_comp_pos();
}
    static void frame_add_height(frp, n)
    frame_T *frp;
    int n;
{
    frame_new_height(frp, frp->fr_height + n, 0, 0);
    for (;;)
    {
        frp = frp->fr_parent;
        if (frp == ((void *)0))
            break;
        frp->fr_height += n;
    }
}
    void last_status(morewin)
    int morewin;
{
    last_status_rec(topframe, (p_ls == 2
                          || (p_ls == 1 && (morewin || lastwin != firstwin))));
}
    static void last_status_rec(fr, statusline)
    frame_T *fr;
    int statusline;
{
    frame_T *fp;
    win_T *wp;
    if (fr->fr_layout == 0)
    {
        wp = fr->fr_win;
        if (wp->w_status_height != 0 && !statusline)
        {
            win_new_height(wp, wp->w_height + 1);
            wp->w_status_height = 0;
            comp_col();
        }
        else if (wp->w_status_height == 0 && statusline)
        {
            fp = fr;
            while (fp->fr_height <= frame_minheight(fp, ((void *)0)))
            {
                if (fp == topframe)
                {
                    emsg((char_u *)(((char *)(e_noroom))));
                    return;
                }
                if (fp->fr_parent->fr_layout == 2 && fp->fr_prev != ((void *)0))
                    fp = fp->fr_prev;
                else
                    fp = fp->fr_parent;
            }
            wp->w_status_height = 1;
            if (fp != fr)
            {
                frame_new_height(fp, fp->fr_height - 1, 0, 0);
                frame_fix_height(wp);
                (void)win_comp_pos();
            }
            else
                win_new_height(wp, wp->w_height - 1);
            comp_col();
            redraw_all_later(40);
        }
    }
    else if (fr->fr_layout == 1)
    {
        for (fp = fr->fr_child; fp != ((void *)0); fp = fp->fr_next)
            last_status_rec(fp, statusline);
    }
    else
    {
        for (fp = fr->fr_child; fp->fr_next != ((void *)0); fp = fp->fr_next)
            ;
        last_status_rec(fp, statusline);
    }
}
    char_u * file_name_at_cursor(options, count)
    int options;
    long count;
{
    return file_name_in_line(ml_get_curline(),
                      curwin->w_cursor.col, options, count, curbuf->b_ffname);
}
    char_u * file_name_in_line(line, col, options, count, rel_fname)
    char_u *line;
    int col;
    int options;
    long count;
    char_u *rel_fname;
{
    char_u *ptr;
    int len;
    ptr = line + col;
    while (*ptr != '\000' && !vim_isfilec(*ptr))
        ++ptr;
    if (*ptr == '\000')
    {
        if (options & 1)
            emsg((char_u *)(((char *)("E446: No file name under cursor"))));
        return ((void *)0);
    }
    while (ptr > line)
    {
        if (vim_isfilec(ptr[-1])
                || ((options & 4) && path_is_url(ptr - 1)))
            --ptr;
        else
            break;
    }
    len = 0;
    while (vim_isfilec(ptr[len])
                         || ((options & 4) && path_is_url(ptr + len)))
            ++len;
    if (len > 2 && vim_strchr((char_u *)".,:;!", ptr[len - 1]) != ((void *)0)
                                                       && ptr[len - 2] != '.')
        --len;
    return find_file_name_in_path(ptr, len, options, count, rel_fname);
}
static char_u *eval_includeexpr (char_u *ptr, int len);
    static char_u * eval_includeexpr(ptr, len)
    char_u *ptr;
    int len;
{
    char_u *res;
    set_vim_var_string(11, ptr, len);
    res = eval_to_string_safe(curbuf->b_p_inex, ((void *)0));
    set_vim_var_string(11, ((void *)0), 0);
    return res;
}
    char_u * find_file_name_in_path(ptr, len, options, count, rel_fname)
    char_u *ptr;
    int len;
    int options;
    long count;
    char_u *rel_fname;
{
    char_u *file_name;
    int c;
    char_u *tofree = ((void *)0);
    if ((options & 8) && *curbuf->b_p_inex != '\000')
    {
        tofree = eval_includeexpr(ptr, len);
        if (tofree != ((void *)0))
        {
            ptr = tofree;
            len = (int)strlen((char *)(ptr));
        }
    }
    if (options & 2)
    {
        file_name = find_file_in_path(ptr, len, options & ~1,
                                                             1, rel_fname);
        if (file_name == ((void *)0)
                && !(options & 8) && *curbuf->b_p_inex != '\000')
        {
            tofree = eval_includeexpr(ptr, len);
            if (tofree != ((void *)0))
            {
                ptr = tofree;
                len = (int)strlen((char *)(ptr));
                file_name = find_file_in_path(ptr, len, options & ~1,
                                                             1, rel_fname);
            }
        }
        if (file_name == ((void *)0) && (options & 1))
        {
            c = ptr[len];
            ptr[len] = '\000';
            emsg2((char_u *)(((char *)("E447: Can't find file \"%s\" in path"))), (char_u *)(ptr));
            ptr[len] = c;
        }
        while (file_name != ((void *)0) && --count > 0)
        {
            vim_free(file_name);
            file_name = find_file_in_path(ptr, len, options, 0, rel_fname);
        }
    }
    else
        file_name = vim_strnsave(ptr, len);
    vim_free(tofree);
    return file_name;
}
    static int path_is_url(p)
    char_u *p;
{
    if (strncmp((char *)(p), (char *)("://"), (size_t)((size_t)3)) == 0)
        return 1;
    else if (strncmp((char *)(p), (char *)(":\\\\"), (size_t)((size_t)3)) == 0)
        return 2;
    return 0;
}
    int path_with_url(fname)
    char_u *fname;
{
    char_u *p;
    for (p = fname; (__ctype_b[(int) ((*p))] & (unsigned short int) _ISalpha); ++p)
        ;
    return path_is_url(p);
}
    int vim_isAbsName(name)
    char_u *name;
{
    return (path_with_url(name) != 0 || mch_isFullName(name));
}
    int vim_FullName(fname, buf, len, force)
    char_u *fname, *buf;
    int len;
    int force;
{
    int retval = 1;
    int url;
    *buf = '\000';
    if (fname == ((void *)0))
        return 0;
    url = path_with_url(fname);
    if (!url)
        retval = mch_FullName(fname, buf, len, force);
    if (url || retval == 0)
    {
        strncpy((char *)(buf), (char *)(fname), (size_t)(len));
        buf[len - 1] = '\000';
    }
    return retval;
}
    int min_rows()
{
    win_T *wp;
    int total;
    if (firstwin == ((void *)0))
        return 2;
    total = 1;
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        total += p_wmh + (wp->w_status_height);
    if (p_wmh == 0)
        total += 1;
    return total;
}
    int only_one_window()
{
    int count = 0;
    win_T *wp;
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        if (!(wp->w_buffer->b_help
                    || wp->w_onebuf_opt.wo_pvw
             ) || wp == curwin)
            ++count;
    return (count <= 1);
}
    void check_lnums(do_curwin)
    int do_curwin;
{
    win_T *wp;
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        if ((do_curwin || wp != curwin) && wp->w_buffer == curbuf)
        {
            if (wp->w_cursor.lnum > curbuf->b_ml.ml_line_count)
                wp->w_cursor.lnum = curbuf->b_ml.ml_line_count;
            if (wp->w_topline > curbuf->b_ml.ml_line_count)
                wp->w_topline = curbuf->b_ml.ml_line_count;
        }
}
static frame_T *snapshot = ((void *)0);
    static void make_snapshot()
{
    clear_snapshot();
    make_snapshot_rec(topframe, &snapshot);
}
    static void make_snapshot_rec(fr, frp)
    frame_T *fr;
    frame_T **frp;
{
    *frp = (frame_T *)alloc_clear((unsigned)sizeof(frame_T));
    if (*frp == ((void *)0))
        return;
    (*frp)->fr_layout = fr->fr_layout;
    (*frp)->fr_width = fr->fr_width;
    (*frp)->fr_height = fr->fr_height;
    if (fr->fr_next != ((void *)0))
        make_snapshot_rec(fr->fr_next, &((*frp)->fr_next));
    if (fr->fr_child != ((void *)0))
        make_snapshot_rec(fr->fr_child, &((*frp)->fr_child));
    if (fr->fr_layout == 0 && fr->fr_win == curwin)
        (*frp)->fr_win = curwin;
}
    static void clear_snapshot()
{
    clear_snapshot_rec(snapshot);
    snapshot = ((void *)0);
}
    static void clear_snapshot_rec(fr)
    frame_T *fr;
{
    if (fr != ((void *)0))
    {
        clear_snapshot_rec(fr->fr_next);
        clear_snapshot_rec(fr->fr_child);
        vim_free(fr);
    }
}
    static void restore_snapshot(close_curwin)
    int close_curwin;
{
    win_T *wp;
    if (snapshot != ((void *)0)
            && snapshot->fr_width == topframe->fr_width
            && snapshot->fr_height == topframe->fr_height
            && check_snapshot_rec(snapshot, topframe) == 1)
    {
        wp = restore_snapshot_rec(snapshot, topframe);
        win_comp_pos();
        if (wp != ((void *)0) && close_curwin)
            win_goto(wp);
        redraw_all_later(50);
    }
    clear_snapshot();
}
    static int check_snapshot_rec(sn, fr)
    frame_T *sn;
    frame_T *fr;
{
    if (sn->fr_layout != fr->fr_layout
            || (sn->fr_next == ((void *)0)) != (fr->fr_next == ((void *)0))
            || (sn->fr_child == ((void *)0)) != (fr->fr_child == ((void *)0))
            || (sn->fr_next != ((void *)0)
                && check_snapshot_rec(sn->fr_next, fr->fr_next) == 0)
            || (sn->fr_child != ((void *)0)
                && check_snapshot_rec(sn->fr_child, fr->fr_child) == 0))
        return 0;
    return 1;
}
    static win_T * restore_snapshot_rec(sn, fr)
    frame_T *sn;
    frame_T *fr;
{
    win_T *wp = ((void *)0);
    win_T *wp2;
    fr->fr_height = sn->fr_height;
    fr->fr_width = sn->fr_width;
    if (fr->fr_layout == 0)
    {
        frame_new_height(fr, fr->fr_height, 0, 0);
        frame_new_width(fr, fr->fr_width, 0);
        wp = sn->fr_win;
    }
    if (sn->fr_next != ((void *)0))
    {
        wp2 = restore_snapshot_rec(sn->fr_next, fr->fr_next);
        if (wp2 != ((void *)0))
            wp = wp2;
    }
    if (sn->fr_child != ((void *)0))
    {
        wp2 = restore_snapshot_rec(sn->fr_child, fr->fr_child);
        if (wp2 != ((void *)0))
            wp = wp2;
    }
    return wp;
}
    int win_hasvertsplit()
{
    frame_T *fr;
    if (topframe->fr_layout == 1)
        return 1;
    if (topframe->fr_layout == 2)
        for (fr = topframe->fr_child; fr != ((void *)0); fr = fr->fr_next)
            if (fr->fr_layout == 1)
                return 1;
    return 0;
}
