# 99 "/usr/include/gconv.h"
typedef void (*__gconv_trans_end_fct) (void *);
# 364 "/usr/include/libio.h"

typedef int __io_close_fn (void *__cookie);
# 144 "/usr/include/stdio.h"

extern int remove (__const char *__filename) ;
# 680 "/usr/include/stdlib.h"

typedef int (*__compar_fn_t) (__const void *, __const void *);
# 67 "/usr/X11R6/include/X11/X.h"

typedef unsigned long XID;
# 75 "/usr/X11R6/include/X11/X.h"

typedef unsigned long Atom;
# 78 "/usr/X11R6/include/X11/X.h"

typedef unsigned long Time;
# 97 "/usr/X11R6/include/X11/X.h"

typedef XID Window;
# 98 "/usr/X11R6/include/X11/X.h"

typedef XID Drawable;
# 103 "/usr/X11R6/include/X11/X.h"

typedef XID Pixmap;
# 104 "/usr/X11R6/include/X11/X.h"

typedef XID Cursor;
# 105 "/usr/X11R6/include/X11/X.h"

typedef XID Colormap;
# 306 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
    Pixmap background_pixmap;
    unsigned long background_pixel;
    Pixmap border_pixmap;
    unsigned long border_pixel;
    int bit_gravity;
    int win_gravity;
    int backing_store;
    unsigned long backing_planes;
    unsigned long backing_pixel;
    int save_under;
    long event_mask;
    long do_not_propagate_mask;
    int override_redirect;
    Colormap colormap;
    Cursor cursor;
} XSetWindowAttributes;
# 502 "/usr/X11R6/include/X11/Xlib.h"

typedef struct _XDisplay Display;
# 578 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int keycode;
        int same_screen;
} XKeyEvent;
# 596 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int button;
        int same_screen;
} XButtonEvent;
# 614 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        char is_hint;
        int same_screen;
} XMotionEvent;
# 631 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        int mode;
        int detail;




        int same_screen;
        int focus;
        unsigned int state;
} XCrossingEvent;
# 655 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int mode;
        int detail;





} XFocusChangeEvent;
# 673 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        char key_vector[32];
} XKeymapEvent;
# 682 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int x, y;
        int width, height;
        int count;
} XExposeEvent;
# 693 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int x, y;
        int width, height;
        int count;
        int major_code;
        int minor_code;
} XGraphicsExposeEvent;
# 706 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int major_code;
        int minor_code;
} XNoExposeEvent;
# 716 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int state;
} XVisibilityEvent;
# 725 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        int override_redirect;
} XCreateWindowEvent;
# 738 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
} XDestroyWindowEvent;
# 747 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int from_configure;
} XUnmapEvent;
# 757 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int override_redirect;
} XMapEvent;
# 767 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
} XMapRequestEvent;
# 776 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        Window parent;
        int x, y;
        int override_redirect;
} XReparentEvent;
# 788 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int override_redirect;
} XConfigureEvent;
# 802 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
} XGravityEvent;
# 812 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int width, height;
} XResizeRequestEvent;
# 821 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int detail;
        unsigned long value_mask;
} XConfigureRequestEvent;
# 836 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int place;
} XCirculateEvent;
# 846 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int place;
} XCirculateRequestEvent;
# 856 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom atom;
        Time time;
        int state;
} XPropertyEvent;
# 867 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom selection;
        Time time;
} XSelectionClearEvent;
# 877 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window owner;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionRequestEvent;
# 890 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionEvent;
# 902 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Colormap colormap;



        int new;

        int state;
} XColormapEvent;
# 917 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom message_type;
        int format;
        union {
                char b[20];
                short s[10];
                long l[5];
                } data;
} XClientMessageEvent;
# 932 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int request;

        int first_keycode;
        int count;
} XMappingEvent;
# 944 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        Display *display;
        XID resourceid;
        unsigned long serial;
        unsigned char error_code;
        unsigned char request_code;
        unsigned char minor_code;
} XErrorEvent;
# 954 "/usr/X11R6/include/X11/Xlib.h"

typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
} XAnyEvent;
# 966 "/usr/X11R6/include/X11/Xlib.h"

typedef union _XEvent {
        int type;
        XAnyEvent xany;
        XKeyEvent xkey;
        XButtonEvent xbutton;
        XMotionEvent xmotion;
        XCrossingEvent xcrossing;
        XFocusChangeEvent xfocus;
        XExposeEvent xexpose;
        XGraphicsExposeEvent xgraphicsexpose;
        XNoExposeEvent xnoexpose;
        XVisibilityEvent xvisibility;
        XCreateWindowEvent xcreatewindow;
        XDestroyWindowEvent xdestroywindow;
        XUnmapEvent xunmap;
        XMapEvent xmap;
        XMapRequestEvent xmaprequest;
        XReparentEvent xreparent;
        XConfigureEvent xconfigure;
        XGravityEvent xgravity;
        XResizeRequestEvent xresizerequest;
        XConfigureRequestEvent xconfigurerequest;
        XCirculateEvent xcirculate;
        XCirculateRequestEvent xcirculaterequest;
        XPropertyEvent xproperty;
        XSelectionClearEvent xselectionclear;
        XSelectionRequestEvent xselectionrequest;
        XSelectionEvent xselection;
        XColormapEvent xcolormap;
        XClientMessageEvent xclient;
        XMappingEvent xmapping;
        XErrorEvent xerror;
        XKeymapEvent xkeymap;
        long pad[24];
} XEvent;
# 2343 "/usr/X11R6/include/X11/Xlib.h"

extern int XChangeWindowAttributes(

    Display* ,
    Window ,
    unsigned long ,
    XSetWindowAttributes*

);
# 168 "/usr/X11R6/include/X11/Intrinsic.h"

typedef char Boolean;
# 178 "/usr/X11R6/include/X11/Intrinsic.h"

typedef void* XtPointer;
# 300 "/usr/X11R6/include/X11/Intrinsic.h"

typedef void (*XtBlockHookProc)(

    XtPointer

);
# 454 "/usr/X11R6/include/X11/Intrinsic.h"

typedef Boolean (*XtWorkProc)(

    XtPointer

);
# 28 "/usr/lib/glib/include/glibconfig.h"

typedef signed char gint8;
# 29 "/usr/lib/glib/include/glibconfig.h"

typedef unsigned char guint8;
# 30 "/usr/lib/glib/include/glibconfig.h"

typedef signed short gint16;
# 31 "/usr/lib/glib/include/glibconfig.h"

typedef unsigned short guint16;
# 33 "/usr/lib/glib/include/glibconfig.h"

typedef unsigned int guint32;
# 473 "/usr/include/glib-1.2/glib.h"

typedef char gchar;
# 474 "/usr/include/glib-1.2/glib.h"

typedef short gshort;
# 475 "/usr/include/glib-1.2/glib.h"

typedef long glong;
# 476 "/usr/include/glib-1.2/glib.h"

typedef int gint;
# 477 "/usr/include/glib-1.2/glib.h"

typedef gint gboolean;
# 479 "/usr/include/glib-1.2/glib.h"

typedef unsigned char guchar;
# 480 "/usr/include/glib-1.2/glib.h"

typedef unsigned short gushort;
# 481 "/usr/include/glib-1.2/glib.h"

typedef unsigned long gulong;
# 482 "/usr/include/glib-1.2/glib.h"

typedef unsigned int guint;
# 484 "/usr/include/glib-1.2/glib.h"

typedef float gfloat;
# 485 "/usr/include/glib-1.2/glib.h"

typedef double gdouble;
# 498 "/usr/include/glib-1.2/glib.h"

typedef void* gpointer;
# 499 "/usr/include/glib-1.2/glib.h"

typedef const void *gconstpointer;
# 695 "/usr/include/glib-1.2/glib.h"

typedef struct _GData GData;
# 697 "/usr/include/glib-1.2/glib.h"

typedef struct _GHashTable GHashTable;
# 700 "/usr/include/glib-1.2/glib.h"

typedef struct _GList GList;
# 705 "/usr/include/glib-1.2/glib.h"

typedef struct _GScanner GScanner;
# 706 "/usr/include/glib-1.2/glib.h"

typedef struct _GScannerConfig GScannerConfig;
# 707 "/usr/include/glib-1.2/glib.h"

typedef struct _GSList GSList;
# 713 "/usr/include/glib-1.2/glib.h"

typedef union _GTokenValue GTokenValue;
# 741 "/usr/include/glib-1.2/glib.h"

typedef enum
{

  G_LOG_FLAG_RECURSION = 1 << 0,
  G_LOG_FLAG_FATAL = 1 << 1,


  G_LOG_LEVEL_ERROR = 1 << 2,
  G_LOG_LEVEL_CRITICAL = 1 << 3,
  G_LOG_LEVEL_WARNING = 1 << 4,
  G_LOG_LEVEL_MESSAGE = 1 << 5,
  G_LOG_LEVEL_INFO = 1 << 6,
  G_LOG_LEVEL_DEBUG = 1 << 7,

  G_LOG_LEVEL_MASK = ~(G_LOG_FLAG_RECURSION | G_LOG_FLAG_FATAL)
} GLogLevelFlags;
# 762 "/usr/include/glib-1.2/glib.h"

typedef gpointer (*GCacheNewFunc) (gpointer key);
# 763 "/usr/include/glib-1.2/glib.h"

typedef gpointer (*GCacheDupFunc) (gpointer value);
# 764 "/usr/include/glib-1.2/glib.h"

typedef void (*GCacheDestroyFunc) (gpointer value);
# 765 "/usr/include/glib-1.2/glib.h"

typedef gint (*GCompareFunc) (gconstpointer a,
                                                 gconstpointer b);
# 767 "/usr/include/glib-1.2/glib.h"

typedef gchar* (*GCompletionFunc) (gpointer);
# 768 "/usr/include/glib-1.2/glib.h"

typedef void (*GDestroyNotify) (gpointer data);
# 772 "/usr/include/glib-1.2/glib.h"

typedef void (*GFunc) (gpointer data,
                                                 gpointer user_data);
# 774 "/usr/include/glib-1.2/glib.h"

typedef guint (*GHashFunc) (gconstpointer key);
# 775 "/usr/include/glib-1.2/glib.h"

typedef void (*GFreeFunc) (gpointer data);
# 790 "/usr/include/glib-1.2/glib.h"

typedef void (*GHookFunc) (gpointer data);
# 791 "/usr/include/glib-1.2/glib.h"

typedef gboolean (*GHookCheckFunc) (gpointer data);
# 802 "/usr/include/glib-1.2/glib.h"

typedef gint (*GSearchFunc) (gpointer key,
                                                 gpointer data);
# 804 "/usr/include/glib-1.2/glib.h"

typedef void (*GScannerMsgFunc) (GScanner *scanner,
                                                 gchar *message,
                                                 gint error);
# 810 "/usr/include/glib-1.2/glib.h"

typedef void (*GVoidFunc) (void);
# 813 "/usr/include/glib-1.2/glib.h"

struct _GList
{
  gpointer data;
  GList *next;
  GList *prev;
};
# 820 "/usr/include/glib-1.2/glib.h"

struct _GSList
{
  gpointer data;
  GSList *next;
};
# 868 "/usr/include/glib-1.2/glib.h"

void g_list_free_1 (GList *list);
# 869 "/usr/include/glib-1.2/glib.h"

GList* g_list_append (GList *list,
                                 gpointer data);
# 883 "/usr/include/glib-1.2/glib.h"

GList* g_list_remove_link (GList *list,
                                 GList *llink);
# 1280 "/usr/include/glib-1.2/glib.h"

void g_log (const gchar *log_domain,
                                         GLogLevelFlags log_level,
                                         const gchar *format,
                                         ...) __attribute__((format (printf, 3, 4)));
# 1384 "/usr/include/glib-1.2/glib.h"

gpointer g_malloc (gulong size);
# 1388 "/usr/include/glib-1.2/glib.h"

void g_free (gpointer mem);
# 1878 "/usr/include/glib-1.2/glib.h"

typedef enum
{
  G_TOKEN_EOF = 0,

  G_TOKEN_LEFT_PAREN = '(',
  G_TOKEN_RIGHT_PAREN = ')',
  G_TOKEN_LEFT_CURLY = '{',
  G_TOKEN_RIGHT_CURLY = '}',
  G_TOKEN_LEFT_BRACE = '[',
  G_TOKEN_RIGHT_BRACE = ']',
  G_TOKEN_EQUAL_SIGN = '=',
  G_TOKEN_COMMA = ',',

  G_TOKEN_NONE = 256,

  G_TOKEN_ERROR,

  G_TOKEN_CHAR,
  G_TOKEN_BINARY,
  G_TOKEN_OCTAL,
  G_TOKEN_INT,
  G_TOKEN_HEX,
  G_TOKEN_FLOAT,
  G_TOKEN_STRING,

  G_TOKEN_SYMBOL,
  G_TOKEN_IDENTIFIER,
  G_TOKEN_IDENTIFIER_NULL,

  G_TOKEN_COMMENT_SINGLE,
  G_TOKEN_COMMENT_MULTI,
  G_TOKEN_LAST
} GTokenType;
# 1912 "/usr/include/glib-1.2/glib.h"

union _GTokenValue
{
  gpointer v_symbol;
  gchar *v_identifier;
  gulong v_binary;
  gulong v_octal;
  gulong v_int;
  gdouble v_float;
  gulong v_hex;
  gchar *v_string;
  gchar *v_comment;
  guchar v_char;
  guint v_error;
};
# 1927 "/usr/include/glib-1.2/glib.h"

struct _GScannerConfig
{


  gchar *cset_skip_characters;
  gchar *cset_identifier_first;
  gchar *cset_identifier_nth;
  gchar *cpair_comment_single;



  guint case_sensitive : 1;




  guint skip_comment_multi : 1;
  guint skip_comment_single : 1;
  guint scan_comment_multi : 1;
  guint scan_identifier : 1;
  guint scan_identifier_1char : 1;
  guint scan_identifier_NULL : 1;
  guint scan_symbols : 1;
  guint scan_binary : 1;
  guint scan_octal : 1;
  guint scan_float : 1;
  guint scan_hex : 1;
  guint scan_hex_dollar : 1;
  guint scan_string_sq : 1;
  guint scan_string_dq : 1;
  guint numbers_2_int : 1;
  guint int_2_float : 1;
  guint identifier_2_string : 1;
  guint char_2_token : 1;
  guint symbol_2_token : 1;
  guint scope_0_fallback : 1;
};
# 1965 "/usr/include/glib-1.2/glib.h"

struct _GScanner
{

  gpointer user_data;
  guint max_parse_errors;


  guint parse_errors;


  const gchar *input_name;


  gpointer derived_data;


  GScannerConfig *config;


  GTokenType token;
  GTokenValue value;
  guint line;
  guint position;


  GTokenType next_token;
  GTokenValue next_value;
  guint next_line;
  guint next_position;


  GHashTable *symbol_table;
  gint input_fd;
  const gchar *text;
  const gchar *text_end;
  gchar *buffer;
  guint scope_id;


  GScannerMsgFunc msg_handler;
};
# 2463 "/usr/include/glib-1.2/glib.h"

typedef gboolean (*GSourceFunc) (gpointer data);
# 52 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef gulong GdkAtom;
# 53 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkColor GdkColor;
# 54 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkColormap GdkColormap;
# 55 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkVisual GdkVisual;
# 56 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkWindowAttr GdkWindowAttr;
# 57 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkWindow GdkWindow;
# 58 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkWindow GdkPixmap;
# 59 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkWindow GdkBitmap;
# 60 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkWindow GdkDrawable;
# 64 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkGC GdkGC;
# 65 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkPoint GdkPoint;
# 66 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkRectangle GdkRectangle;
# 68 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkFont GdkFont;
# 69 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkCursor GdkCursor;
# 72 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkDragContext GdkDragContext;
# 74 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventAny GdkEventAny;
# 75 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventExpose GdkEventExpose;
# 76 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventNoExpose GdkEventNoExpose;
# 77 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventVisibility GdkEventVisibility;
# 78 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventMotion GdkEventMotion;
# 79 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventButton GdkEventButton;
# 80 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventKey GdkEventKey;
# 81 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventFocus GdkEventFocus;
# 82 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventCrossing GdkEventCrossing;
# 83 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventConfigure GdkEventConfigure;
# 84 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventProperty GdkEventProperty;
# 85 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventSelection GdkEventSelection;
# 86 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventProximity GdkEventProximity;
# 87 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventClient GdkEventClient;
# 89 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef struct _GdkEventDND GdkEventDND;
# 91 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef union _GdkEvent GdkEvent;
# 126 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_WINDOW_ROOT,
  GDK_WINDOW_TOPLEVEL,
  GDK_WINDOW_CHILD,
  GDK_WINDOW_DIALOG,
  GDK_WINDOW_TEMP,
  GDK_WINDOW_PIXMAP,
  GDK_WINDOW_FOREIGN
} GdkWindowType;
# 146 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_INPUT_OUTPUT,
  GDK_INPUT_ONLY
} GdkWindowClass;
# 177 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_VISUAL_STATIC_GRAY,
  GDK_VISUAL_GRAYSCALE,
  GDK_VISUAL_STATIC_COLOR,
  GDK_VISUAL_PSEUDO_COLOR,
  GDK_VISUAL_TRUE_COLOR,
  GDK_VISUAL_DIRECT_COLOR
} GdkVisualType;
# 191 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
# 205 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_WA_TITLE = 1 << 1,
  GDK_WA_X = 1 << 2,
  GDK_WA_Y = 1 << 3,
  GDK_WA_CURSOR = 1 << 4,
  GDK_WA_COLORMAP = 1 << 5,
  GDK_WA_VISUAL = 1 << 6,
  GDK_WA_WMCLASS = 1 << 7,
  GDK_WA_NOREDIR = 1 << 8
} GdkWindowAttributesType;
# 330 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
# 337 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum {
  GDK_FILTER_CONTINUE,
  GDK_FILTER_TRANSLATE,
  GDK_FILTER_REMOVE
} GdkFilterReturn;
# 343 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum {
  GDK_VISIBILITY_UNOBSCURED,
  GDK_VISIBILITY_PARTIAL,
  GDK_VISIBILITY_FULLY_OBSCURED
} GdkVisibilityState;
# 371 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_NOTHING = -1,
  GDK_DELETE = 0,
  GDK_DESTROY = 1,
  GDK_EXPOSE = 2,
  GDK_MOTION_NOTIFY = 3,
  GDK_BUTTON_PRESS = 4,
  GDK_2BUTTON_PRESS = 5,
  GDK_3BUTTON_PRESS = 6,
  GDK_BUTTON_RELEASE = 7,
  GDK_KEY_PRESS = 8,
  GDK_KEY_RELEASE = 9,
  GDK_ENTER_NOTIFY = 10,
  GDK_LEAVE_NOTIFY = 11,
  GDK_FOCUS_CHANGE = 12,
  GDK_CONFIGURE = 13,
  GDK_MAP = 14,
  GDK_UNMAP = 15,
  GDK_PROPERTY_NOTIFY = 16,
  GDK_SELECTION_CLEAR = 17,
  GDK_SELECTION_REQUEST = 18,
  GDK_SELECTION_NOTIFY = 19,
  GDK_PROXIMITY_IN = 20,
  GDK_PROXIMITY_OUT = 21,
  GDK_DRAG_ENTER = 22,
  GDK_DRAG_LEAVE = 23,
  GDK_DRAG_MOTION = 24,
  GDK_DRAG_STATUS = 25,
  GDK_DROP_START = 26,
  GDK_DROP_FINISHED = 27,
  GDK_CLIENT_EVENT = 28,
  GDK_VISIBILITY_NOTIFY = 29,
  GDK_NO_EXPOSE = 30
} GdkEventType;
# 410 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_EXPOSURE_MASK = 1 << 1,
  GDK_POINTER_MOTION_MASK = 1 << 2,
  GDK_POINTER_MOTION_HINT_MASK = 1 << 3,
  GDK_BUTTON_MOTION_MASK = 1 << 4,
  GDK_BUTTON1_MOTION_MASK = 1 << 5,
  GDK_BUTTON2_MOTION_MASK = 1 << 6,
  GDK_BUTTON3_MOTION_MASK = 1 << 7,
  GDK_BUTTON_PRESS_MASK = 1 << 8,
  GDK_BUTTON_RELEASE_MASK = 1 << 9,
  GDK_KEY_PRESS_MASK = 1 << 10,
  GDK_KEY_RELEASE_MASK = 1 << 11,
  GDK_ENTER_NOTIFY_MASK = 1 << 12,
  GDK_LEAVE_NOTIFY_MASK = 1 << 13,
  GDK_FOCUS_CHANGE_MASK = 1 << 14,
  GDK_STRUCTURE_MASK = 1 << 15,
  GDK_PROPERTY_CHANGE_MASK = 1 << 16,
  GDK_VISIBILITY_NOTIFY_MASK = 1 << 17,
  GDK_PROXIMITY_IN_MASK = 1 << 18,
  GDK_PROXIMITY_OUT_MASK = 1 << 19,
  GDK_SUBSTRUCTURE_MASK = 1 << 20,
  GDK_ALL_EVENTS_MASK = 0x0FFFFF
} GdkEventMask;
# 443 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_NOTIFY_ANCESTOR = 0,
  GDK_NOTIFY_VIRTUAL = 1,
  GDK_NOTIFY_INFERIOR = 2,
  GDK_NOTIFY_NONLINEAR = 3,
  GDK_NOTIFY_NONLINEAR_VIRTUAL = 4,
  GDK_NOTIFY_UNKNOWN = 5
} GdkNotifyType;
# 458 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_CROSSING_NORMAL,
  GDK_CROSSING_GRAB,
  GDK_CROSSING_UNGRAB
} GdkCrossingMode;
# 467 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
# 508 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_LSB_FIRST,
  GDK_MSB_FIRST
} GdkByteOrder;
# 557 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum
{
  GDK_SOURCE_MOUSE,
  GDK_SOURCE_PEN,
  GDK_SOURCE_ERASER,
  GDK_SOURCE_CURSOR
} GdkInputSource;
# 698 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef void (*GdkDestroyNotify) (gpointer data);
# 733 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum {
  GDK_ACTION_DEFAULT = 1 << 0,
  GDK_ACTION_COPY = 1 << 1,
  GDK_ACTION_MOVE = 1 << 2,
  GDK_ACTION_LINK = 1 << 3,
  GDK_ACTION_PRIVATE = 1 << 4,
  GDK_ACTION_ASK = 1 << 5
} GdkDragAction;
# 742 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef enum {
  GDK_DRAG_PROTO_MOTIF,
  GDK_DRAG_PROTO_XDND,
  GDK_DRAG_PROTO_ROOTWIN,

  GDK_DRAG_PROTO_NONE
} GdkDragProtocol;
# 757 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
# 768 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
# 786 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkVisual
{
  GdkVisualType type;
  gint depth;
  GdkByteOrder byte_order;
  gint colormap_size;
  gint bits_per_rgb;

  guint32 red_mask;
  gint red_shift;
  gint red_prec;

  guint32 green_mask;
  gint green_shift;
  gint green_prec;

  guint32 blue_mask;
  gint blue_shift;
  gint blue_prec;
};
# 807 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkWindowAttr
{
  gchar *title;
  gint event_mask;
  gint16 x, y;
  gint16 width;
  gint16 height;
  GdkWindowClass wclass;
  GdkVisual *visual;
  GdkColormap *colormap;
  GdkWindowType window_type;
  GdkCursor *cursor;
  gchar *wmclass_name;
  gchar *wmclass_class;
  gboolean override_redirect;
};
# 824 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkWindow
{
  gpointer user_data;
};
# 878 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkGC
{
  gint dummy_var;
};
# 883 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkPoint
{
  gint16 x;
  gint16 y;
};
# 889 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkRectangle
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
# 905 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
# 912 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkCursor
{
  GdkCursorType type;
};
# 1009 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkDragContext {
  GdkDragProtocol protocol;

  gboolean is_source;

  GdkWindow *source_window;
  GdkWindow *dest_window;

  GList *targets;
  GdkDragAction actions;
  GdkDragAction suggested_action;
  GdkDragAction action;

  guint32 start_time;
};
# 1027 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef void GdkXEvent;
# 1029 "/usr/include/gtk-1.2/gdk/gdktypes.h"

typedef GdkFilterReturn (*GdkFilterFunc) (GdkXEvent *xevent,
                                          GdkEvent *event,
                                          gpointer data);
# 1033 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventAny
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
};
# 1040 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventExpose
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkRectangle area;
  gint count;
};
# 1049 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventNoExpose
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;

};
# 1057 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventVisibility
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkVisibilityState state;
};
# 1065 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventMotion
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble pressure;
  gdouble xtilt;
  gdouble ytilt;
  guint state;
  gint16 is_hint;
  GdkInputSource source;
  guint32 deviceid;
  gdouble x_root, y_root;
};
# 1083 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventButton
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble pressure;
  gdouble xtilt;
  gdouble ytilt;
  guint state;
  guint button;
  GdkInputSource source;
  guint32 deviceid;
  gdouble x_root, y_root;
};
# 1101 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventKey
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  guint state;
  guint keyval;
  gint length;
  gchar *string;
};
# 1113 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventCrossing
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkWindow *subwindow;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble x_root;
  gdouble y_root;
  GdkCrossingMode mode;
  GdkNotifyType detail;
  gboolean focus;
  guint state;
};
# 1130 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventFocus
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  gint16 in;
};
# 1138 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventConfigure
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  gint16 x, y;
  gint16 width;
  gint16 height;
};
# 1148 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventProperty
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom atom;
  guint32 time;
  guint state;
};
# 1158 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventSelection
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom selection;
  GdkAtom target;
  GdkAtom property;
  guint32 requestor;
  guint32 time;
};
# 1173 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventProximity
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  GdkInputSource source;
  guint32 deviceid;
};
# 1183 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventClient
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom message_type;
  gushort data_format;
  union {
    char b[20];
    short s[10];
    long l[5];
  } data;
};
# 1199 "/usr/include/gtk-1.2/gdk/gdktypes.h"

struct _GdkEventDND {
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkDragContext *context;

  guint32 time;
  gshort x_root, y_root;
};
# 1209 "/usr/include/gtk-1.2/gdk/gdktypes.h"

union _GdkEvent
{
  GdkEventType type;
  GdkEventAny any;
  GdkEventExpose expose;
  GdkEventNoExpose no_expose;
  GdkEventVisibility visibility;
  GdkEventMotion motion;
  GdkEventButton button;
  GdkEventKey key;
  GdkEventCrossing crossing;
  GdkEventFocus focus_change;
  GdkEventConfigure configure;
  GdkEventProperty property;
  GdkEventSelection selection;
  GdkEventProximity proximity;
  GdkEventClient client;
  GdkEventDND dnd;
};
# 145 "/usr/include/gtk-1.2/gdk/gdk.h"

GdkWindow* gdk_window_new (GdkWindow *parent,
                                      GdkWindowAttr *attributes,
                                      gint attributes_mask);
# 149 "/usr/include/gtk-1.2/gdk/gdk.h"

void gdk_window_destroy (GdkWindow *window);
# 155 "/usr/include/gtk-1.2/gdk/gdk.h"

void gdk_window_show (GdkWindow *window);
# 156 "/usr/include/gtk-1.2/gdk/gdk.h"

void gdk_window_hide (GdkWindow *window);
# 164 "/usr/include/gtk-1.2/gdk/gdk.h"

void gdk_window_move_resize (GdkWindow *window,
                                      gint x,
                                      gint y,
                                      gint width,
                                      gint height);
# 196 "/usr/include/gtk-1.2/gdk/gdk.h"

void gdk_window_set_user_data (GdkWindow *window,
                                          gpointer user_data);
# 201 "/usr/include/gtk-1.2/gdk/gdk.h"

void gdk_window_add_filter (GdkWindow *window,
                                         GdkFilterFunc function,
                                         gpointer data);
# 41 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef enum
{
  GTK_TYPE_INVALID,
  GTK_TYPE_NONE,


  GTK_TYPE_CHAR,
  GTK_TYPE_UCHAR,
  GTK_TYPE_BOOL,
  GTK_TYPE_INT,
  GTK_TYPE_UINT,
  GTK_TYPE_LONG,
  GTK_TYPE_ULONG,
  GTK_TYPE_FLOAT,
  GTK_TYPE_DOUBLE,
  GTK_TYPE_STRING,
  GTK_TYPE_ENUM,
  GTK_TYPE_FLAGS,
  GTK_TYPE_BOXED,
  GTK_TYPE_POINTER,


  GTK_TYPE_SIGNAL,
  GTK_TYPE_ARGS,
  GTK_TYPE_CALLBACK,
  GTK_TYPE_C_CALLBACK,
  GTK_TYPE_FOREIGN,


  GTK_TYPE_OBJECT
} GtkFundamentalType;
# 123 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef guint GtkType;
# 125 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef struct _GtkTypeObject GtkTypeObject;
# 126 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef struct _GtkTypeClass GtkTypeClass;
# 150 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef struct _GtkArg GtkArg;
# 151 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef struct _GtkObject GtkObject;
# 152 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef struct _GtkTypeInfo GtkTypeInfo;
# 160 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef void (*GtkClassInitFunc) (gpointer klass);
# 161 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef void (*GtkObjectInitFunc) (gpointer object,
                                    gpointer klass);
# 163 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef void (*GtkSignalFunc) ();
# 164 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef gint (*GtkFunction) (gpointer data);
# 165 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef void (*GtkDestroyNotify) (gpointer data);
# 166 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

typedef void (*GtkCallbackMarshal) (GtkObject *object,
                                    gpointer data,
                                    guint n_args,
                                    GtkArg *args);
# 185 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

struct _GtkTypeObject
{




  GtkTypeClass *klass;
};
# 207 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

struct _GtkTypeClass
{



  GtkType type;
}


;
# 219 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

struct _GtkArg
{
  GtkType type;
  gchar *name;







  union {

    gchar char_data;
    guchar uchar_data;
    gboolean bool_data;
    gint int_data;
    guint uint_data;
    glong long_data;
    gulong ulong_data;
    gfloat float_data;
    gdouble double_data;
    gchar *string_data;
    gpointer pointer_data;
    GtkObject *object_data;


    struct {
      GtkSignalFunc f;
      gpointer d;
    } signal_data;
    struct {
      gint n_args;
      GtkArg *args;
    } args_data;
    struct {
      GtkCallbackMarshal marshal;
      gpointer data;
      GtkDestroyNotify notify;
    } callback_data;
    struct {
      GtkFunction func;
      gpointer func_data;
    } c_callback_data;
    struct {
      gpointer data;
      GtkDestroyNotify notify;
    } foreign_data;
  } d;
};
# 322 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

struct _GtkTypeInfo
{
  gchar *type_name;
  guint object_size;
  guint class_size;
  GtkClassInitFunc class_init_func;
  GtkObjectInitFunc object_init_func;
  gpointer reserved_1;
  gpointer reserved_2;
  GtkClassInitFunc base_class_init_func;
};
# 351 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

GtkType gtk_type_unique (GtkType parent_type,
                                                 const GtkTypeInfo *type_info);
# 358 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

gpointer gtk_type_class (GtkType type);
# 361 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

gpointer gtk_type_new (GtkType type);
# 367 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

gboolean gtk_type_is_a (GtkType type,
                                                 GtkType is_a_type);
# 369 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

GtkTypeObject* gtk_type_check_object_cast (GtkTypeObject *type_object,
                                                 GtkType cast_type);
# 371 "/usr/include/gtk-1.2/gtk/gtktypeutils.h"

GtkTypeClass* gtk_type_check_class_cast (GtkTypeClass *klass,
                                                 GtkType cast_type);
# 35 "/usr/include/gtk-1.2/gtk/gtkenums.h"

typedef enum
{
  GTK_ARROW_UP,
  GTK_ARROW_DOWN,
  GTK_ARROW_LEFT,
  GTK_ARROW_RIGHT
} GtkArrowType;
# 70 "/usr/include/gtk-1.2/gtk/gtkenums.h"

typedef enum
{
  GTK_DIR_TAB_FORWARD,
  GTK_DIR_TAB_BACKWARD,
  GTK_DIR_UP,
  GTK_DIR_DOWN,
  GTK_DIR_LEFT,
  GTK_DIR_RIGHT
} GtkDirectionType;
# 124 "/usr/include/gtk-1.2/gtk/gtkenums.h"

typedef enum
{
  GTK_ORIENTATION_HORIZONTAL,
  GTK_ORIENTATION_VERTICAL
} GtkOrientation;
# 173 "/usr/include/gtk-1.2/gtk/gtkenums.h"

typedef enum
{
  GTK_POS_LEFT,
  GTK_POS_RIGHT,
  GTK_POS_TOP,
  GTK_POS_BOTTOM
} GtkPositionType;
# 235 "/usr/include/gtk-1.2/gtk/gtkenums.h"

typedef enum
{
  GTK_SHADOW_NONE,
  GTK_SHADOW_IN,
  GTK_SHADOW_OUT,
  GTK_SHADOW_ETCHED_IN,
  GTK_SHADOW_ETCHED_OUT
} GtkShadowType;
# 245 "/usr/include/gtk-1.2/gtk/gtkenums.h"

typedef enum
{
  GTK_STATE_NORMAL,
  GTK_STATE_ACTIVE,
  GTK_STATE_PRELIGHT,
  GTK_STATE_SELECTED,
  GTK_STATE_INSENSITIVE
} GtkStateType;
# 117 "/usr/include/gtk-1.2/gtk/gtkobject.h"

typedef struct _GtkObjectClass GtkObjectClass;
# 125 "/usr/include/gtk-1.2/gtk/gtkobject.h"

struct _GtkObject
{

  GtkObjectClass *klass;







  guint32 flags;




  guint ref_count;




  GData *object_data;
};
# 156 "/usr/include/gtk-1.2/gtk/gtkobject.h"

struct _GtkObjectClass
{

  GtkType type;





  guint *signals;



  guint nsignals;



  guint n_args;
  GSList *construct_args;


  void (*set_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (*get_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (* shutdown) (GtkObject *object);
  void (* destroy) (GtkObject *object);

  void (* finalize) (GtkObject *object);
};
# 44 "/usr/include/gtk-1.2/gtk/gtkaccelgroup.h"

typedef struct _GtkAccelGroup GtkAccelGroup;
# 47 "/usr/include/gtk-1.2/gtk/gtkaccelgroup.h"

typedef enum
{



  GTK_ACCEL_VISIBLE = 1 << 0,



  GTK_ACCEL_SIGNAL_VISIBLE = 1 << 1,



  GTK_ACCEL_LOCKED = 1 << 2,
  GTK_ACCEL_MASK = 0x07
} GtkAccelFlags;
# 64 "/usr/include/gtk-1.2/gtk/gtkaccelgroup.h"

struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
# 38 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

typedef struct _GtkStyle GtkStyle;
# 39 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

typedef struct _GtkStyleClass GtkStyleClass;
# 44 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

typedef struct _GtkThemeEngine GtkThemeEngine;
# 45 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

typedef struct _GtkRcStyle GtkRcStyle;
# 51 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

typedef struct _GtkWidget GtkWidget;
# 60 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

struct _GtkStyle
{
  GtkStyleClass *klass;

  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];

  GdkColor black;
  GdkColor white;
  GdkFont *font;

  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;

  GdkPixmap *bg_pixmap[5];



  gint ref_count;
  gint attach_count;

  gint depth;
  GdkColormap *colormap;

  GtkThemeEngine *engine;

  gpointer engine_data;

  GtkRcStyle *rc_style;


  GSList *styles;
};
# 106 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

struct _GtkStyleClass
{
  gint xthickness;
  gint ythickness;

  void (*draw_hline) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x1,
                                 gint x2,
                                 gint y);
  void (*draw_vline) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint y1,
                                 gint y2,
                                 gint x);
  void (*draw_shadow) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_polygon) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 GdkPoint *point,
                                 gint npoints,
                                 gboolean fill);
  void (*draw_arrow) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 GtkArrowType arrow_type,
                                 gboolean fill,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_diamond) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_oval) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_string) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 const gchar *string);
  void (*draw_box) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_flat_box) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_check) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_option) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_cross) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_ramp) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 GtkArrowType arrow_type,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_tab) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_shadow_gap) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkPositionType gap_side,
                                 gint gap_x,
                                 gint gap_width);
  void (*draw_box_gap) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkPositionType gap_side,
                                 gint gap_x,
                                 gint gap_width);
  void (*draw_extension) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkPositionType gap_side);
  void (*draw_focus) (GtkStyle *style,
                                 GdkWindow *window,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);
  void (*draw_slider) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkOrientation orientation);
  void (*draw_handle) (GtkStyle *style,
                                 GdkWindow *window,
                                 GtkStateType state_type,
                                 GtkShadowType shadow_type,
                                 GdkRectangle *area,
                                 GtkWidget *widget,
                                 gchar *detail,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height,
                                 GtkOrientation orientation);
};
# 349 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

GtkStyle* gtk_style_attach (GtkStyle *style,
                                              GdkWindow *window);
# 354 "/usr/include/gtk-1.2/gtk/gtkstyle.h"

void gtk_style_set_background (GtkStyle *style,
                                              GdkWindow *window,
                                              GtkStateType state_type);
# 45 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

typedef enum
{
  GTK_TOPLEVEL = 1 << 4,
  GTK_NO_WINDOW = 1 << 5,
  GTK_REALIZED = 1 << 6,
  GTK_MAPPED = 1 << 7,
  GTK_VISIBLE = 1 << 8,
  GTK_SENSITIVE = 1 << 9,
  GTK_PARENT_SENSITIVE = 1 << 10,
  GTK_CAN_FOCUS = 1 << 11,
  GTK_HAS_FOCUS = 1 << 12,



  GTK_CAN_DEFAULT = 1 << 13,



  GTK_HAS_DEFAULT = 1 << 14,

  GTK_HAS_GRAB = 1 << 15,
  GTK_RC_STYLE = 1 << 16,
  GTK_COMPOSITE_CHILD = 1 << 17,
  GTK_NO_REPARENT = 1 << 18,
  GTK_APP_PAINTABLE = 1 << 19,



  GTK_RECEIVES_DEFAULT = 1 << 20
} GtkWidgetFlags;
# 121 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

typedef struct _GtkRequisition GtkRequisition;
# 122 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

typedef struct _GtkAllocation GtkAllocation;
# 123 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

typedef struct _GtkSelectionData GtkSelectionData;
# 124 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

typedef struct _GtkWidgetClass GtkWidgetClass;
# 128 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

typedef void (*GtkCallback) (GtkWidget *widget,
                             gpointer data);
# 134 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
# 144 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
# 161 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

struct _GtkSelectionData
{
  GdkAtom selection;
  GdkAtom target;
  GdkAtom type;
  gint format;
  guchar *data;
  gint length;
};
# 176 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

struct _GtkWidget
{






  GtkObject object;






  guint16 private_flags;




  guint8 state;







  guint8 saved_state;







  gchar *name;






  GtkStyle *style;



  GtkRequisition requisition;



  GtkAllocation allocation;





  GdkWindow *window;



  GtkWidget *parent;
};
# 240 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

struct _GtkWidgetClass
{






  GtkObjectClass parent_class;





  guint activate_signal;






  guint set_scroll_adjustments_signal;


  void (* show) (GtkWidget *widget);
  void (* show_all) (GtkWidget *widget);
  void (* hide) (GtkWidget *widget);
  void (* hide_all) (GtkWidget *widget);
  void (* map) (GtkWidget *widget);
  void (* unmap) (GtkWidget *widget);
  void (* realize) (GtkWidget *widget);
  void (* unrealize) (GtkWidget *widget);
  void (* draw) (GtkWidget *widget,
                                GdkRectangle *area);
  void (* draw_focus) (GtkWidget *widget);
  void (* draw_default) (GtkWidget *widget);
  void (* size_request) (GtkWidget *widget,
                                GtkRequisition *requisition);
  void (* size_allocate) (GtkWidget *widget,
                                GtkAllocation *allocation);
  void (* state_changed) (GtkWidget *widget,
                                GtkStateType previous_state);
  void (* parent_set) (GtkWidget *widget,
                                GtkWidget *previous_parent);
  void (* style_set) (GtkWidget *widget,
                                GtkStyle *previous_style);


  gint (* add_accelerator) (GtkWidget *widget,
                                guint accel_signal_id,
                                GtkAccelGroup *accel_group,
                                guint accel_key,
                                GdkModifierType accel_mods,
                                GtkAccelFlags accel_flags);
  void (* remove_accelerator) (GtkWidget *widget,
                                GtkAccelGroup *accel_group,
                                guint accel_key,
                                GdkModifierType accel_mods);


  void (* grab_focus) (GtkWidget *widget);


  gint (* event) (GtkWidget *widget,
                                    GdkEvent *event);
  gint (* button_press_event) (GtkWidget *widget,
                                    GdkEventButton *event);
  gint (* button_release_event) (GtkWidget *widget,
                                    GdkEventButton *event);
  gint (* motion_notify_event) (GtkWidget *widget,
                                    GdkEventMotion *event);
  gint (* delete_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  gint (* destroy_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  gint (* expose_event) (GtkWidget *widget,
                                    GdkEventExpose *event);
  gint (* key_press_event) (GtkWidget *widget,
                                    GdkEventKey *event);
  gint (* key_release_event) (GtkWidget *widget,
                                    GdkEventKey *event);
  gint (* enter_notify_event) (GtkWidget *widget,
                                    GdkEventCrossing *event);
  gint (* leave_notify_event) (GtkWidget *widget,
                                    GdkEventCrossing *event);
  gint (* configure_event) (GtkWidget *widget,
                                    GdkEventConfigure *event);
  gint (* focus_in_event) (GtkWidget *widget,
                                    GdkEventFocus *event);
  gint (* focus_out_event) (GtkWidget *widget,
                                    GdkEventFocus *event);
  gint (* map_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  gint (* unmap_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  gint (* property_notify_event) (GtkWidget *widget,
                                    GdkEventProperty *event);
  gint (* selection_clear_event) (GtkWidget *widget,
                                    GdkEventSelection *event);
  gint (* selection_request_event) (GtkWidget *widget,
                                    GdkEventSelection *event);
  gint (* selection_notify_event) (GtkWidget *widget,
                                    GdkEventSelection *event);
  gint (* proximity_in_event) (GtkWidget *widget,
                                    GdkEventProximity *event);
  gint (* proximity_out_event) (GtkWidget *widget,
                                    GdkEventProximity *event);
  gint (* visibility_notify_event) (GtkWidget *widget,
                                     GdkEventVisibility *event);
  gint (* client_event) (GtkWidget *widget,
                                    GdkEventClient *event);
  gint (* no_expose_event) (GtkWidget *widget,
                                    GdkEventAny *event);


  void (* selection_get) (GtkWidget *widget,
                                    GtkSelectionData *selection_data,
                                    guint info,
                                    guint time);
  void (* selection_received) (GtkWidget *widget,
                                    GtkSelectionData *selection_data,
                                    guint time);


  void (* drag_begin) (GtkWidget *widget,
                                    GdkDragContext *context);
  void (* drag_end) (GtkWidget *widget,
                                    GdkDragContext *context);
  void (* drag_data_get) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    GtkSelectionData *selection_data,
                                    guint info,
                                    guint time);
  void (* drag_data_delete) (GtkWidget *widget,
                                    GdkDragContext *context);


  void (* drag_leave) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    guint time);
  gboolean (* drag_motion) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    gint x,
                                    gint y,
                                    guint time);
  gboolean (* drag_drop) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    gint x,
                                    gint y,
                                    guint time);
  void (* drag_data_received) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    gint x,
                                    gint y,
                                    GtkSelectionData *selection_data,
                                    guint info,
                                    guint time);


  void (* debug_msg) (GtkWidget *widget,
                                    const gchar *string);


  GtkFunction pad1;
  GtkFunction pad2;
  GtkFunction pad3;
  GtkFunction pad4;
};
# 425 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

GtkType gtk_widget_get_type (void);
# 448 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_unparent (GtkWidget *widget);
# 454 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_map (GtkWidget *widget);
# 455 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_unmap (GtkWidget *widget);
# 456 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_realize (GtkWidget *widget);
# 475 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_draw (GtkWidget *widget,
                                           GdkRectangle *area);
# 479 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_size_request (GtkWidget *widget,
                                           GtkRequisition *requisition);
# 481 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_size_allocate (GtkWidget *widget,
                                           GtkAllocation *allocation);
# 505 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

gint gtk_widget_event (GtkWidget *widget,
                                           GdkEvent *event);
# 518 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

gint gtk_widget_intersect (GtkWidget *widget,
                                           GdkRectangle *area,
                                           GdkRectangle *intersection);
# 534 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_set_parent (GtkWidget *widget,
                                           GtkWidget *parent);
# 536 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

void gtk_widget_set_parent_window (GtkWidget *widget,
                                           GdkWindow *parent_window);
# 538 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

GdkWindow *gtk_widget_get_parent_window (GtkWidget *widget);
# 556 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

GdkColormap* gtk_widget_get_colormap (GtkWidget *widget);
# 557 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

GdkVisual* gtk_widget_get_visual (GtkWidget *widget);
# 571 "/usr/include/gtk-1.2/gtk/gtkwidget.h"

gint gtk_widget_get_events (GtkWidget *widget);
# 51 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"

typedef struct _GtkContainer GtkContainer;
# 52 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"

typedef struct _GtkContainerClass GtkContainerClass;
# 54 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"

struct _GtkContainer
{
  GtkWidget widget;

  GtkWidget *focus_child;

  guint border_width : 16;
  guint need_resize : 1;
  guint resize_mode : 2;
  guint reallocate_redraws : 1;



  GSList *resize_widgets;
};
# 70 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"

struct _GtkContainerClass
{
  GtkWidgetClass parent_class;

  guint n_child_args;

  void (* add) (GtkContainer *container,
                                 GtkWidget *widget);
  void (* remove) (GtkContainer *container,
                                 GtkWidget *widget);
  void (* check_resize) (GtkContainer *container);
  void (* forall) (GtkContainer *container,
                                 gboolean include_internals,
                                 GtkCallback callback,
                                 gpointer callbabck_data);
  gint (* focus) (GtkContainer *container,
                                 GtkDirectionType direction);
  void (* set_focus_child) (GtkContainer *container,
                                 GtkWidget *widget);
  GtkType (*child_type) (GtkContainer *container);
  void (*set_child_arg) (GtkContainer *container,
                                 GtkWidget *child,
                                 GtkArg *arg,
                                 guint arg_id);
  void (*get_child_arg) (GtkContainer *container,
                                 GtkWidget *child,
                                 GtkArg *arg,
                                 guint arg_id);
  gchar* (*composite_name) (GtkContainer *container,
                                 GtkWidget *child);


  GtkFunction pad1;
  GtkFunction pad2;
};
# 108 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"

GtkType gtk_container_get_type (void);
# 205 "/usr/include/gtk-1.2/gtk/gtkcontainer.h"

void gtk_container_queue_resize (GtkContainer *container);
# 50 "/usr/include/gtk-1.2/gtk/gtksignal.h"

typedef void (*GtkSignalDestroy) (gpointer data);
# 43 "/usr/include/gtk-1.2/gtk/gtkmenufactory.h"

typedef void (*GtkMenuCallback) (GtkWidget *widget,
                                 gpointer user_data);
# 48 "/usr/include/gtk-1.2/gtk/gtkitemfactory.h"

typedef void (*GtkItemFactoryCallback) ();
# 39 "/usr/include/gtk-1.2/gtk/gtkrc.h"

typedef enum {
  GTK_RC_FG = 1 << 0,
  GTK_RC_BG = 1 << 1,
  GTK_RC_TEXT = 1 << 2,
  GTK_RC_BASE = 1 << 3
} GtkRcFlags;
# 46 "/usr/include/gtk-1.2/gtk/gtkrc.h"

struct _GtkRcStyle
{
  gchar *name;
  gchar *font_name;
  gchar *fontset_name;
  gchar *bg_pixmap_name[5];

  GtkRcFlags color_flags[5];
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor text[5];
  GdkColor base[5];

  GtkThemeEngine *engine;
  gpointer engine_data;
};
# 41 "/usr/include/gtk-1.2/gtk/gtkthemes.h"

struct _GtkThemeEngine {




  guint (*parse_rc_style) (GScanner *scanner, GtkRcStyle *rc_style);





  void (*merge_rc_style) (GtkRcStyle *dest, GtkRcStyle *src);


  void (*rc_style_to_style) (GtkStyle *style, GtkRcStyle *rc_style);





  void (*duplicate_style) (GtkStyle *dest, GtkStyle *src);






  void (*realize_style) (GtkStyle *new_style);




  void (*unrealize_style) (GtkStyle *new_style);


  void (*destroy_rc_style) (GtkRcStyle *rc_style);


  void (*destroy_style) (GtkStyle *style);

  void (*set_background) (GtkStyle *style,
                          GdkWindow *window,
                          GtkStateType state_type);
};
# 28 "/h/27/yijun/software/vim61/src/gui_gtk_f.h"

typedef struct _GtkForm GtkForm;
# 29 "/h/27/yijun/software/vim61/src/gui_gtk_f.h"

typedef struct _GtkFormClass GtkFormClass;
# 31 "/h/27/yijun/software/vim61/src/gui_gtk_f.h"

struct _GtkForm
{
    GtkContainer container;

    GList *children;

    guint width;
    guint height;

    GdkWindow *bin_window;

    GdkVisibilityState visibility;
    gulong configure_serial;

    gint freeze_count;
};
# 48 "/h/27/yijun/software/vim61/src/gui_gtk_f.h"

struct _GtkFormClass
{
    GtkContainerClass parent_class;
};
# 53 "/h/27/yijun/software/vim61/src/gui_gtk_f.h"

GtkType gtk_form_get_type(void);
# 60 "/h/27/yijun/software/vim61/src/gui_gtk_f.h"

void gtk_form_move(GtkForm *form, GtkWidget * widget,
        gint x, gint y);
# 45 "/usr/include/gtk-1.2/gdk/gdkprivate.h"

typedef struct _GdkWindowPrivate GdkWindowPrivate;
# 46 "/usr/include/gtk-1.2/gdk/gdkprivate.h"

typedef struct _GdkWindowPrivate GdkPixmapPrivate;
# 60 "/usr/include/gtk-1.2/gdk/gdkprivate.h"

struct _GdkWindowPrivate
{
  GdkWindow window;
  GdkWindow *parent;
  Window xwindow;
  Display *xdisplay;
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
  guint8 resize_count;
  guint8 window_type;
  guint ref_count;
  guint destroyed : 2;
  guint mapped : 1;
  guint guffaw_gravity : 1;

  gint extension_events;

  GList *filters;
  GdkColormap *colormap;
  GList *children;
};
# 32 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

typedef struct _GtkFormChild GtkFormChild;
# 34 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

struct _GtkFormChild
{
    GtkWidget *widget;
    GdkWindow *window;
    gint x;
    gint y;
    gint mapped : 1;
};
# 44 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_class_init(GtkFormClass * class);
# 45 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_init(GtkForm * form);
# 47 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_realize(GtkWidget * widget);
# 48 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_unrealize(GtkWidget * widget);
# 49 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_map(GtkWidget * widget);
# 50 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_size_request(GtkWidget * widget,
                                  GtkRequisition * requisition);
# 52 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_size_allocate(GtkWidget * widget,
                                   GtkAllocation * allocation);
# 54 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_draw(GtkWidget * widget,
                          GdkRectangle * area);
# 56 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static gint gtk_form_expose(GtkWidget * widget,
                            GdkEventExpose * event);
# 59 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_remove(GtkContainer * container,
                            GtkWidget * widget);
# 61 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_forall(GtkContainer * container,
                            gboolean include_internals,
                            GtkCallback callback,
                            gpointer callback_data);
# 66 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_realize_child(GtkForm * form,
                                   GtkFormChild * child);
# 68 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_position_child(GtkForm * form,
                                    GtkFormChild * child,
                                    gboolean force_allocate);
# 71 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_position_children(GtkForm * form);
# 73 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static GdkFilterReturn gtk_form_filter(GdkXEvent * gdk_xevent,
                                       GdkEvent * event,
                                       gpointer data);
# 76 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static GdkFilterReturn gtk_form_main_filter(GdkXEvent * gdk_xevent,
                                            GdkEvent * event,
                                            gpointer data);
# 80 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_set_static_gravity(GdkWindow * win,
                                        gboolean op);
# 83 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static void gtk_form_send_configure(GtkForm *form);
# 85 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

static GtkWidgetClass *parent_class = ((void *)0);
# 91 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    GtkWidget * gtk_form_new(void)
{
    GtkForm *form;

    form = gtk_type_new(gtk_form_get_type());

    return (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ())))));
}
# 101 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    void gtk_form_put(GtkForm * form,
             GtkWidget * child_widget,
             gint x, gint y)
{
    GtkFormChild *child;

    (void)({ if (!(form != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 107, __PRETTY_FUNCTION__, "form != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 108, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });

    child = ((GtkFormChild *) g_malloc ((unsigned) sizeof (GtkFormChild) * (1)));

    child->widget = child_widget;
    child->window = ((void *)0);
    child->x = x;
    child->y = y;
    child->widget->requisition.width = 0;
    child->widget->requisition.height = 0;
    child->mapped = 0;

    form->children = g_list_append(form->children, child);

    gtk_widget_set_parent(child_widget, (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ()))))));
    if (((((( ( (form) != ((void *)0) && ( (((GtkObject*) (form))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (form))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (form) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (form), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0))
        gtk_widget_set_parent_window (child->widget, form->bin_window);
    gtk_widget_size_request(child->widget, ((void *)0));

    if (((((( ( (form) != ((void *)0) && ( (((GtkObject*) (form))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (form))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (form) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (form), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0) && !((((( ( (child_widget) != ((void *)0) && ( (((GtkObject*) (child_widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child_widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child_widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child_widget), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0))
        gtk_form_realize_child(form, child);

    gtk_form_position_child(form, child, 1);
}
# 134 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    void gtk_form_move(GtkForm * form,
              GtkWidget * child_widget,
              gint x, gint y)
{
    GList *tmp_list;
    GtkFormChild *child;

    (void)({ if (!(form != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 141, __PRETTY_FUNCTION__, "form != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 142, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });

    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
    {
        child = tmp_list->data;
        if (child->widget == child_widget)
        {
            child->x = x;
            child->y = y;

            gtk_form_position_child(form, child, 1);
            return;
        }
    }
}
# 159 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    void gtk_form_set_size(GtkForm * form, guint width, guint height)
{
    (void)({ if (!(form != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 161, __PRETTY_FUNCTION__, "form != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 162, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });


    if (form->width == width && form->height == height)
        return;
    form->width = width;
    form->height = height;


    gtk_container_queue_resize((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) (((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ())))))->parent)), ((gtk_container_get_type ()))))));
}
# 175 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    void gtk_form_freeze(GtkForm * form)
{
    (void)({ if (!(form != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 177, __PRETTY_FUNCTION__, "form != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 178, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });

    ++form->freeze_count;
}
# 184 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    void gtk_form_thaw(GtkForm * form)
{
    (void)({ if (!(form != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 186, __PRETTY_FUNCTION__, "form != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 187, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });

    if (form->freeze_count)
    {
        if (!(--form->freeze_count))
        {
            gtk_form_position_children(form);
            gtk_widget_draw((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ()))))), ((void *)0));
        }
    }
}
# 202 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    guint gtk_form_get_type(void)
{
    static guint form_type = 0;

    if (!form_type)
    {
        GtkTypeInfo form_info =
        {
            "GtkForm",
            sizeof(GtkForm),
            sizeof(GtkFormClass),
            (GtkClassInitFunc) gtk_form_class_init,
            (GtkObjectInitFunc) gtk_form_init
        };

        form_type = gtk_type_unique((gtk_container_get_type ()), &form_info);
    }
    return form_type;
}
# 223 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_class_init(GtkFormClass * class)
{
    GtkWidgetClass *widget_class;
    GtkContainerClass *container_class;

    widget_class = (GtkWidgetClass *) class;
    container_class = (GtkContainerClass *) class;

    parent_class = gtk_type_class(gtk_container_get_type());

    widget_class->realize = gtk_form_realize;
    widget_class->unrealize = gtk_form_unrealize;
    widget_class->map = gtk_form_map;
    widget_class->size_request = gtk_form_size_request;
    widget_class->size_allocate = gtk_form_size_allocate;
    widget_class->draw = gtk_form_draw;
    widget_class->expose_event = gtk_form_expose;

    container_class->remove = gtk_form_remove;
    container_class->forall = gtk_form_forall;
}
# 246 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_init(GtkForm * form)
{
    form->children = ((void *)0);

    form->width = 1;
    form->height = 1;

    form->bin_window = ((void *)0);

    form->configure_serial = 0;
    form->visibility = GDK_VISIBILITY_PARTIAL;

    form->freeze_count = 0;
}
# 265 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_realize(GtkWidget * widget)
{
    GList *tmp_list;
    GtkForm *form;
    GdkWindowAttr attributes;
    gint attributes_mask;

    (void)({ if (!(widget != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 272, __PRETTY_FUNCTION__, "widget != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 273, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });

    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));
    (void)({ (((( ( (form) != ((void *)0) && ( (((GtkObject*) (form))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (form))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (form) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (form), GTK_TYPE_OBJECT) )->flags)) |= (GTK_REALIZED)); });

    attributes.window_type = GDK_WINDOW_CHILD;
    attributes.x = widget->allocation.x;
    attributes.y = widget->allocation.y;
    attributes.width = widget->allocation.width;
    attributes.height = widget->allocation.height;
    attributes.wclass = GDK_INPUT_OUTPUT;
    attributes.visual = gtk_widget_get_visual(widget);
    attributes.colormap = gtk_widget_get_colormap(widget);
    attributes.event_mask = GDK_VISIBILITY_NOTIFY_MASK;

    attributes_mask = GDK_WA_X | GDK_WA_Y | GDK_WA_VISUAL | GDK_WA_COLORMAP;

    widget->window = gdk_window_new(gtk_widget_get_parent_window(widget),
                                    &attributes, attributes_mask);
    gdk_window_set_user_data(widget->window, widget);

    attributes.x = 0;
    attributes.y = 0;
    attributes.event_mask = gtk_widget_get_events(widget);

    form->bin_window = gdk_window_new(widget->window,
                                      &attributes, attributes_mask);
    gdk_window_set_user_data(form->bin_window, widget);

    gtk_form_set_static_gravity(form->bin_window, 1);

    widget->style = gtk_style_attach(widget->style, widget->window);
    gtk_style_set_background(widget->style, widget->window, GTK_STATE_NORMAL);
    gtk_style_set_background(widget->style, form->bin_window, GTK_STATE_NORMAL);

    gdk_window_add_filter(widget->window, gtk_form_main_filter, form);
    gdk_window_add_filter(form->bin_window, gtk_form_filter, form);

    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
    {
        GtkFormChild *child = tmp_list->data;

        gtk_widget_set_parent_window (child->widget, form->bin_window);
        if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0))
            gtk_form_realize_child(form, child);
    }
}
# 322 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_map(GtkWidget * widget)
{
    GList *tmp_list;
    GtkForm *form;

    (void)({ if (!(widget != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 327, __PRETTY_FUNCTION__, "widget != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 328, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });

    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));

    (void)({ (((( ( (widget) != ((void *)0) && ( (((GtkObject*) (widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (widget), GTK_TYPE_OBJECT) )->flags)) |= (GTK_MAPPED)); });

    gdk_window_show(widget->window);
    gdk_window_show(form->bin_window);

    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
    {
        GtkFormChild *child = tmp_list->data;

        if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0) &&
            !((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0))
            gtk_widget_map(child->widget);

        if (child->window)
            gdk_window_show(child->window);
    }

}
# 352 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_unrealize(GtkWidget * widget)
{
    GList *tmp_list;
    GtkForm *form;

    (void)({ if (!(widget != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 357, __PRETTY_FUNCTION__, "widget != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 358, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });

    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));

    tmp_list = form->children;

    gdk_window_set_user_data(form->bin_window, ((void *)0));
    gdk_window_destroy(form->bin_window);
    form->bin_window = ((void *)0);

    while (tmp_list)
    {
        GtkFormChild *child = tmp_list->data;

        if (child->window)
        {
            gdk_window_set_user_data(child->window, ((void *)0));
            gdk_window_destroy(child->window);
        }
        tmp_list = tmp_list->next;
    }

    if ((((GtkWidgetClass*) gtk_type_check_class_cast ((GtkTypeClass*) ((parent_class)), ((gtk_widget_get_type ())))))->unrealize)
         (* (((GtkWidgetClass*) gtk_type_check_class_cast ((GtkTypeClass*) ((parent_class)), ((gtk_widget_get_type ())))))->unrealize) (widget);
}
# 386 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_draw(GtkWidget * widget, GdkRectangle * area)
{
    GtkForm *form;
    GList *children;
    GtkFormChild *child;
    GdkRectangle child_area;

    (void)({ if (!(widget != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 393, __PRETTY_FUNCTION__, "widget != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 394, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });

    if ((((((( ( (widget) != ((void *)0) && ( (((GtkObject*) (widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0) && ((((( ( (widget) != ((void *)0) && ( (((GtkObject*) (widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0)))
    {
        form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));

        children = form->children;

        while (children)
        {
            child = children->data;

            if ((((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0) && ((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0))
                    && gtk_widget_intersect(child->widget, area, &child_area))
                gtk_widget_draw(child->widget, &child_area);

            children = children->next;
        }
    }
}
# 416 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_size_request(GtkWidget * widget,
                      GtkRequisition * requisition)
{
    GList *tmp_list;
    GtkForm *form;

    (void)({ if (!(widget != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 422, __PRETTY_FUNCTION__, "widget != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 423, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });

    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));

    requisition->width = form->width;
    requisition->height = form->height;

    tmp_list = form->children;

    while (tmp_list)
    {
        GtkFormChild *child = tmp_list->data;
        gtk_widget_size_request(child->widget, ((void *)0));
        tmp_list = tmp_list->next;
    }
}
# 441 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_size_allocate(GtkWidget * widget,
                       GtkAllocation * allocation)
{
    GList *tmp_list;
    GtkForm *form;
    gboolean need_reposition;

    (void)({ if (!(widget != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 448, __PRETTY_FUNCTION__, "widget != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 449, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });

    if (widget->allocation.x == allocation->x
            && widget->allocation.y == allocation->y
            && widget->allocation.width == allocation->width
            && widget->allocation.height == allocation->height)
        return;

    need_reposition = widget->allocation.width != allocation->width
                   || widget->allocation.height != allocation->height;
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));

    if (need_reposition)
    {
        tmp_list = form->children;

        while (tmp_list)
        {
            GtkFormChild *child = tmp_list->data;
            gtk_form_position_child(form, child, 1);

            tmp_list = tmp_list->next;
        }
    }

    if (((((( ( (widget) != ((void *)0) && ( (((GtkObject*) (widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (widget), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0))
    {
        gdk_window_move_resize(widget->window,
                               allocation->x, allocation->y,
                               allocation->width, allocation->height);
        gdk_window_move_resize((((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))))->bin_window,
                               0, 0,
                               allocation->width, allocation->height);
    }
    widget->allocation = *allocation;
    if (need_reposition)
        gtk_form_send_configure(form);
}
# 489 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static gint gtk_form_expose(GtkWidget * widget, GdkEventExpose * event)
{
    GList *tmp_list;
    GtkForm *form;

    (void)({ if (!(widget != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 494, __PRETTY_FUNCTION__, "widget != NULL"); return 0; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 495, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return 0; }; });

    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));

    if (event->window == form->bin_window)
        return 0;

    tmp_list = form->children;
    while (tmp_list)
    {
        GtkFormChild *child = tmp_list->data;

        if (event->window == child->window)
            return gtk_widget_event(child->widget, (GdkEvent *) event);

        tmp_list = tmp_list->next;
    }

    return 0;
}
# 519 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_remove(GtkContainer * container, GtkWidget * widget)
{
    GList *tmp_list;
    GtkForm *form;
    GtkFormChild *child = ((void *)0);

    (void)({ if (!(container != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 525, __PRETTY_FUNCTION__, "container != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((container))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((container)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((container)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 526, __PRETTY_FUNCTION__, "GTK_IS_FORM(container)"); return; }; });

    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((container)), ((gtk_form_get_type ())))));

    tmp_list = form->children;
    while (tmp_list)
    {
        child = tmp_list->data;
        if (child->widget == widget)
            break;
        tmp_list = tmp_list->next;
    }

    if (tmp_list)
    {
        if (child->window)
        {



            gdk_window_set_user_data(child->window, ((void *)0));
            gdk_window_destroy(child->window);
        }
        gtk_widget_unparent(widget);

        form->children = g_list_remove_link(form->children, tmp_list);
        g_list_free_1(tmp_list);
        g_free(child);
    }
}
# 559 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_forall(GtkContainer * container,
                gboolean include_internals,
                GtkCallback callback,
                gpointer callback_data)
{
    GtkForm *form;
    GtkFormChild *child;
    GList *tmp_list;

    (void)({ if (!(container != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 568, __PRETTY_FUNCTION__, "container != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((container))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((container)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((container)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 569, __PRETTY_FUNCTION__, "GTK_IS_FORM(container)"); return; }; });
    (void)({ if (!(callback != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 570, __PRETTY_FUNCTION__, "callback != NULL"); return; }; });

    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((container)), ((gtk_form_get_type ())))));

    tmp_list = form->children;
    while (tmp_list)
    {
        child = tmp_list->data;
        tmp_list = tmp_list->next;

        (*callback) (child->widget, callback_data);
    }
}
# 588 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_realize_child(GtkForm * form,
                       GtkFormChild * child)
{
    GtkWidget *widget;
    gint attributes_mask;

    widget = (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ())))));

    if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_NO_WINDOW) != 0))
    {
        GdkWindowAttr attributes;

        gint x = child->x;
        gint y = child->y;

        attributes.window_type = GDK_WINDOW_CHILD;
        attributes.x = x;
        attributes.y = y;
        attributes.width = child->widget->requisition.width;
        attributes.height = child->widget->requisition.height;
        attributes.wclass = GDK_INPUT_OUTPUT;
        attributes.visual = gtk_widget_get_visual(widget);
        attributes.colormap = gtk_widget_get_colormap(widget);
        attributes.event_mask = GDK_EXPOSURE_MASK;

        attributes_mask = GDK_WA_X | GDK_WA_Y | GDK_WA_VISUAL | GDK_WA_COLORMAP;
        child->window = gdk_window_new(form->bin_window,
                                       &attributes, attributes_mask);
        gdk_window_set_user_data(child->window, widget);

        if (child->window)
            gtk_style_set_background(widget->style,
                                     child->window,
                                     GTK_STATE_NORMAL);
    }
    gtk_widget_set_parent_window(child->widget,
                       child->window ? child->window : form->bin_window);

    gtk_widget_realize(child->widget);

    gtk_form_set_static_gravity(child->window ? child->window : child->widget->window, 1);
}
# 632 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_position_child(GtkForm * form,
                        GtkFormChild * child,
                        gboolean force_allocate)
{
    gint x;
    gint y;

    x = child->x;
    y = child->y;
    if ((x >= (-32767-1)) && (x <= 32767) &&
            (y >= (-32767-1)) && (y <= 32767))
    {
        if (!child->mapped)
        {
            child->mapped = 1;

            if (((((( ( (form) != ((void *)0) && ( (((GtkObject*) (form))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (form))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (form) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (form), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0) && ((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0))
            {
                if (child->window)
                    gdk_window_show(child->window);
                if (!((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0))
                    gtk_widget_map(child->widget);

                child->mapped = 1;
                force_allocate = 1;
            }
        }

        if (force_allocate)
        {
            GtkAllocation allocation;

            if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_NO_WINDOW) != 0))
            {
                if (child->window)
                {
                    gdk_window_move_resize(child->window,
                            x, y,
                            child->widget->requisition.width,
                            child->widget->requisition.height);
                }

                allocation.x = 0;
                allocation.y = 0;
            }
            else
            {
                allocation.x = x;
                allocation.y = y;
            }

            allocation.width = child->widget->requisition.width;
            allocation.height = child->widget->requisition.height;

            gtk_widget_size_allocate(child->widget, &allocation);
        }
    }
    else
    {
        if (child->mapped)
        {
            child->mapped = 0;
            if (child->window)
                gdk_window_hide(child->window);
            else if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0))
                gtk_widget_unmap(child->widget);
        }
    }
}
# 703 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_position_children(GtkForm * form)
{
    GList *tmp_list;

    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
        gtk_form_position_child(form, tmp_list->data, 0);
}
# 724 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static GdkFilterReturn gtk_form_filter(GdkXEvent * gdk_xevent,
                GdkEvent * event,
                gpointer data)
{
    XEvent *xevent;
    GtkForm *form;

    xevent = (XEvent *) gdk_xevent;
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((data)), ((gtk_form_get_type ())))));

    switch (xevent->type)
    {
    case 12:
        if (xevent->xexpose.serial == form->configure_serial)
        {
            if (form->visibility == GDK_VISIBILITY_UNOBSCURED)
                return GDK_FILTER_REMOVE;
            else
                break;
        }
        break;

    case 22:
        if ((xevent->xconfigure.x != 0) || (xevent->xconfigure.y != 0))
            form->configure_serial = xevent->xconfigure.serial;
        break;
    }

    return GDK_FILTER_CONTINUE;
}
# 761 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static GdkFilterReturn gtk_form_main_filter(GdkXEvent * gdk_xevent,
                     GdkEvent * event,
                     gpointer data)
{
    XEvent *xevent;
    GtkForm *form;

    xevent = (XEvent *) gdk_xevent;
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((data)), ((gtk_form_get_type ())))));

    if (xevent->type == 15)
    {
        switch (xevent->xvisibility.state)
        {
        case 2:
            form->visibility = GDK_VISIBILITY_FULLY_OBSCURED;
            break;

        case 1:
            form->visibility = GDK_VISIBILITY_PARTIAL;
            break;

        case 0:
            form->visibility = GDK_VISIBILITY_UNOBSCURED;
            break;
        }

        return GDK_FILTER_REMOVE;
    }
    return GDK_FILTER_CONTINUE;
}
# 798 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_set_static_gravity(GdkWindow * win, gboolean on)
{
    XSetWindowAttributes xattributes;

    xattributes.win_gravity = on ? 10 : 1;
    xattributes.bit_gravity = on ? 10 : 1;

    XChangeWindowAttributes((((GdkWindowPrivate*) win)->xdisplay),
                            (((GdkWindowPrivate*) win)->xwindow),
                            (1L<<4) | (1L<<5),
                            &xattributes);
}
# 812 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    void gtk_form_move_resize(GtkForm * form, GtkWidget * widget,
                     gint x, gint y,
                     gint w, gint h)
{
    widget->requisition.width = w;
    widget->requisition.height = h;
    gtk_form_move(form, widget, x, y);
}
# 822 "/h/27/yijun/software/vim61/src/gui_gtk_f.cpp.c"

    static void gtk_form_send_configure(GtkForm *form)
{
    GtkWidget *widget;
    GdkEventConfigure event;

    widget = (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ())))));

    event.type = GDK_CONFIGURE;
    event.window = widget->window;
    event.x = widget->allocation.x;
    event.y = widget->allocation.y;
    event.width = widget->allocation.width;
    event.height = widget->allocation.height;

    gtk_widget_event (widget, (GdkEvent*) &event);
}
