#include "controller.h"
# 73 "/h/27/yijun/software/vim62/src/stdarg.h"
typedef void *__gnuc_va_list;
# 311 "/h/27/yijun/software/vim62/src/option.h"
extern char_u *p_bsdir;
# 363 "/h/27/yijun/software/vim62/src/option.h"
extern char_u *p_debug;
# 394 "/h/27/yijun/software/vim62/src/option.h"
extern int p_eb;
# 5 "/h/27/yijun/software/vim62/src/proto/ex_eval.pro"
int cause_errthrow (char_u *msg, int severe, int *ignore);
# 6 "/h/27/yijun/software/vim62/src/proto/getchar.pro"
void typeahead_noflush (int c);
# 36 "/h/27/yijun/software/vim62/src/proto/message.pro"
void msg_puts_long_len_attr (char_u *longstr, int len, int attr);
# 41 "/h/27/yijun/software/vim62/src/proto/message.pro"
void msg_moremsg (int full);
# 50 "/h/27/yijun/software/vim62/src/proto/message.pro"
void display_confirm_msg (void);
# 14 "/h/27/yijun/software/vim62/src/proto/gui_gtk.pro"
char_u *gui_mch_browse (int saving, char_u *title, char_u *dflt, char_u *ext, char_u *initdir, char_u *filter);
# 15 "/h/27/yijun/software/vim62/src/proto/gui_gtk.pro"
int gui_mch_dialog (int type, char_u *title, char_u *message, char_u *buttons, int def_but, char_u *textfield);
# 41 "/h/27/yijun/software/vim62/src/message.cpp.c"
struct msg_hist
{
    struct msg_hist *next;
    char_u *msg;
    int attr;
};
# 299 "/usr/include/stdio.h"
extern int vsnprintf (char *__restrict __s, size_t __maxlen,
                      __const char *__restrict __format, __gnuc_va_list __arg)
             __attribute__ ((__format__ (__printf__, 3, 0)));
# 188 "/h/27/yijun/software/vim62/src/stdarg.h"
typedef __gnuc_va_list va_list;
# 22 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void reset_last_sourcing (void);
# 23 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void add_msg_hist (char_u *s, int len, int attr);
# 24 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void hit_return_msg (void);
# 25 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void msg_home_replace_attr (char_u *fname, int attr);
# 29 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void msg_puts_attr_len (char_u *str, int maxlen, int attr);
# 30 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void t_puts (int t_col, char_u *t_s, char_u *s, int attr);
# 31 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void msg_screen_putchar (int c, int attr);
# 32 "/h/27/yijun/software/vim62/src/message.cpp.c"
static int msg_check_screen (void);
# 33 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void redir_write (char_u *s, int maxlen);
# 35 "/h/27/yijun/software/vim62/src/message.cpp.c"
static char_u *msg_show_console_dialog (char_u *message, char_u *buttons, int dfltbutton);
# 36 "/h/27/yijun/software/vim62/src/message.cpp.c"
static int confirm_msg_used = 0;
# 37 "/h/27/yijun/software/vim62/src/message.cpp.c"
static char_u *confirm_msg = ((void *)0);
# 38 "/h/27/yijun/software/vim62/src/message.cpp.c"
static char_u *confirm_msg_tail;
# 48 "/h/27/yijun/software/vim62/src/message.cpp.c"
static struct msg_hist *first_msg_hist = ((void *)0);
# 49 "/h/27/yijun/software/vim62/src/message.cpp.c"
static struct msg_hist *last_msg_hist = ((void *)0);
# 50 "/h/27/yijun/software/vim62/src/message.cpp.c"
static int msg_hist_len = 0;
# 51 "/h/27/yijun/software/vim62/src/message.cpp.c"
static int msg_hist_off = 0;
# 95 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg(s)
    char_u *s;
{
    return msg_attr_keep(s, 0, 0);
}
# 102 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_attr(s, attr)
    char_u *s;
    int attr;
{
    return msg_attr_keep(s, attr, 0);
}
# 110 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_attr_keep(s, attr, keep)
    char_u *s;
    int attr;
    int keep;
{
    static int entered = 0;
    int retval;
    char_u *buf = ((void *)0);


    if (attr == 0)
        set_vim_var_string(5, s, -1);







    if (entered >= 3)
        return 1;
    ++entered;



    if (s != keep_msg
            || (*s != '<'
                && last_msg_hist != ((void *)0)
                && last_msg_hist->msg != ((void *)0)
                && strcmp((char *)(s), (char *)(last_msg_hist->msg))))
        add_msg_hist(s, -1, attr);



    if (s == keep_msg)
        keep_msg = ((void *)0);


    buf = msg_strtrunc(s);
    if (buf != ((void *)0))
        s = buf;

    msg_start();
    msg_outtrans_attr(s, attr);
    if (msg_silent == 0)
        msg_clr_eos();
    retval = msg_end();

    if (keep && retval && vim_strsize(s) < (int)(Rows - cmdline_row - 1)
                                                           * Columns + sc_col)
    {
        set_keep_msg(s);
        keep_msg_attr = 0;
    }

    vim_free(buf);
    --entered;
    return retval;
}
# 175 "/h/27/yijun/software/vim62/src/message.cpp.c"
    char_u * msg_strtrunc(s)
    char_u *s;
{
    char_u *buf = ((void *)0);
    int len;
    int room;


    if (!msg_scroll && !need_wait_return && shortmess('T')
                                                            && !exmode_active)
    {
        len = vim_strsize(s);
        room = (int)(Rows - cmdline_row - 1) * Columns + sc_col - 1;
        if (len > room && room > 0)
        {
                buf = alloc(room + 2);
            if (buf != ((void *)0))
                trunc_string(s, buf, room);
        }
    }
    return buf;
}
# 213 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void trunc_string(s, buf, room)
    char_u *s;
    char_u *buf;
    int room;
{
    int half;
    int len;
    int e;
    int i;
    int n;

    room -= 3;
    half = room / 2;
    len = 0;


    for (e = 0; len < half; ++e)
    {
        if (s[e] == '\000')
        {

            buf[e] = '\000';
            return;
        }
        n = ptr2cells(s + e);
        if (len + n >= half)
            break;
        len += n;
        buf[e] = s[e];
    }


    i = e;
    {
        for (i = (int)strlen((char *)(s)); len + (n = ptr2cells(s + i - 1)) <= room; --i)
            len += n;
    }


    memmove((char *)(buf + e), (char *)("..."), (size_t)3);
    memmove((char *)(buf + e + 3), (char *)(s + i), strlen((char *)(s + i)) + 1);
}
# 346 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int smsg(char_u *s, ...)
{
    va_list arglist;

    (arglist = ((__gnuc_va_list) __builtin_next_arg (s)));

    vsnprintf((char *)IObuff, (1024+1), (char *)s, arglist);



    ((void)0);
    return msg(IObuff);
}
# 364 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int smsg_attr(int attr, char_u *s, ...)
{
    va_list arglist;

    (arglist = ((__gnuc_va_list) __builtin_next_arg (s)));

    vsnprintf((char *)IObuff, (1024+1), (char *)s, arglist);



    ((void)0);
    return msg_attr(IObuff, attr);
}
# 385 "/h/27/yijun/software/vim62/src/message.cpp.c"
static int last_sourcing_lnum = 0;
# 386 "/h/27/yijun/software/vim62/src/message.cpp.c"
static char_u *last_sourcing_name = ((void *)0);
# 393 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void reset_last_sourcing()
{
    vim_free(last_sourcing_name);
    last_sourcing_name = ((void *)0);
    last_sourcing_lnum = 0;
}
# 409 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int emsg(s)
    char_u *s;
{
    char_u *Buf;
    int attr;
    int other_sourcing_name;
    char *p;

    int ignore = 0;
    int severe;


    called_emsg = 1;






    severe = emsg_severe;
    emsg_severe = 0;







    if ((emsg_off > 0 && *p_debug == '\000')

            || emsg_skip > 0

            )
        return 1;

    if (!emsg_off)
    {
        if (cause_errthrow(s, severe, &ignore) == 1)
        {
            if (!ignore)
                did_emsg = 1;
            return 1;
        }


        set_vim_var_string(3, s, -1);






        if (emsg_silent != 0)
        {
            redir_write(s, -1);
            return 1;
        }


        msg_silent = 0;
        cmd_silent = 0;

        if (global_busy)
            ++global_busy;

        if (p_eb)
            beep_flush();
        else
            flush_buffers(0);
        did_emsg = 1;
    }

    emsg_on_display = 1;
    ++msg_scroll;
    attr = highlight_attr[(int)(HLF_E)];
    if (msg_scrolled)
        need_wait_return = 1;







    if (sourcing_name != ((void *)0))
    {
        if (last_sourcing_name != ((void *)0))
            other_sourcing_name = strcmp((char *)(sourcing_name), (char *)(last_sourcing_name));
        else
            other_sourcing_name = 1;
    }
    else
        other_sourcing_name = 0;

    p = ((char *)("Error detected while processing %s:"));
    if (sourcing_name != ((void *)0)
            && (other_sourcing_name || sourcing_lnum != last_sourcing_lnum)
            && (Buf = alloc((unsigned)(strlen((char *)(sourcing_name))
                                                       + strlen((char *)(p))))) != ((void *)0))
    {
        ++no_wait_return;
        if (other_sourcing_name)
        {
            sprintf((char *)Buf, p, sourcing_name);
            msg_attr(Buf, attr);
        }


        if (sourcing_lnum != 0)
        {
            sprintf((char *)Buf, ((char *)("line %4ld:")), (long)sourcing_lnum);
            msg_attr(Buf, highlight_attr[(int)(HLF_N)]);
        }
        --no_wait_return;
        last_sourcing_lnum = sourcing_lnum;
        vim_free(Buf);
    }


    if (sourcing_name == ((void *)0) || other_sourcing_name)
    {
        vim_free(last_sourcing_name);
        if (sourcing_name == ((void *)0))
            last_sourcing_name = ((void *)0);
        else
            last_sourcing_name = vim_strsave(sourcing_name);
    }
    msg_nowait = 0;

    return msg_attr(s, attr);
}
# 558 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int emsg2(s, a1)
    char_u *s, *a1;
{
    if ((emsg_off > 0 && *p_debug == '\000')

            || emsg_skip > 0

            )
        return 1;


    if (a1 == ((void *)0))
        a1 = (char_u *)"[NULL]";


    if (strlen((char *)(s)) + (strstr((char *)s, "%s") != ((void *)0) ? strlen((char *)(a1)) : 20)
                                                            >= (size_t)(1024+1))
        a1 = (char_u *)((char *)("[string too long]"));
    sprintf((char *)IObuff, (char *)s, (char *)a1);
    return emsg(IObuff);
}
# 581 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int emsgn(s, n)
    char_u *s;
    long n;
{
    if ((emsg_off > 0 && *p_debug == '\000')

            || emsg_skip > 0

            )
        return 1;
    sprintf((char *)IObuff, (char *)s, n);
    return emsg(IObuff);
}
# 602 "/h/27/yijun/software/vim62/src/message.cpp.c"
    char_u * msg_trunc_attr(s, force, attr)
    char_u *s;
    int force;
    int attr;
{
    int n;


    add_msg_hist(s, -1, attr);

    s = msg_may_trunc(force, s);

    msg_hist_off = 1;
    n = msg_attr(s, attr);
    msg_hist_off = 0;

    if (n)
        return s;
    return ((void *)0);
}
# 629 "/h/27/yijun/software/vim62/src/message.cpp.c"
    char_u * msg_may_trunc(force, s)
    int force;
    char_u *s;
{
    int n;
    int room;

    room = (int)(Rows - cmdline_row - 1) * Columns + sc_col - 1;
    if ((force || (shortmess('t') && !exmode_active))
            && (n = (int)strlen((char *)(s)) - room) > 0)
    {
        s += n;
        *s = '<';
    }
    return s;
}
# 660 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void add_msg_hist(s, len, attr)
    char_u *s;
    int len;
    int attr;
{
    struct msg_hist *p;

    if (msg_hist_off || msg_silent != 0)
        return;


    while (msg_hist_len > 20)
    {
        p = first_msg_hist;
        first_msg_hist = p->next;
        vim_free(p->msg);
        vim_free(p);
        --msg_hist_len;
    }

    p = (struct msg_hist *)alloc((int)sizeof(struct msg_hist));
    if (p != ((void *)0))
    {
        if (len < 0)
            len = (int)strlen((char *)(s));

        while (len > 0 && *s == '\n')
        {
            ++s;
            --len;
        }
        while (len > 0 && s[len - 1] == '\n')
            --len;
        p->msg = vim_strnsave(s, len);
        p->next = ((void *)0);
        p->attr = attr;
        if (last_msg_hist != ((void *)0))
            last_msg_hist->next = p;
        last_msg_hist = p;
        if (first_msg_hist == ((void *)0))
            first_msg_hist = last_msg_hist;
        ++msg_hist_len;
    }
}
# 710 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void ex_messages(eap)
    exarg_T *eap;
{
    struct msg_hist *p;
    char_u *s;

    msg_hist_off = 1;

    s = (char_u *)getenv((char *)((char_u *)"LANG"));
    if (s != ((void *)0) && *s != '\000')
        msg_attr((char_u *)
                ((char *)("Messages maintainer: Bram Moolenaar <Bram@vim.org>")),
                highlight_attr[(int)(HLF_T)]);

    for (p = first_msg_hist; p != ((void *)0); p = p->next)
        if (p->msg != ((void *)0))
            msg_attr(p->msg, p->attr);

    msg_hist_off = 0;
}
# 732 "/h/27/yijun/software/vim62/src/message.cpp.c"
static void msg_end_prompt (void);
# 739 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void msg_end_prompt()
{
    need_wait_return = 0;
    emsg_on_display = 0;
    cmdline_row = msg_row;
    msg_col = 0;
    msg_clr_eos();
}
# 756 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void wait_return(redraw)
    int redraw;
{
    int c;
    int oldState;
    int tmpState;

    int had_got_int;


    if (redraw == 1)
        must_redraw = 50;



    if (msg_silent != 0)
        return;






    if (vgetc_busy)
        return;
    if (no_wait_return)
    {
        need_wait_return = 1;
        if (!exmode_active)
            cmdline_row = msg_row;
        return;
    }

    redir_off = 1;
    oldState = State;
    if (quit_more)
    {
        c = '\015';
        quit_more = 0;
        got_int = 0;
    }
    else if (exmode_active)
    {
        msg_puts((char_u *)(" "));
        c = '\015';
        got_int = 0;
    }
    else
    {
        State = (0x200 + 0x01);

        setmouse();




        hit_return_msg();
        do
        {


            had_got_int = got_int;
            c = safe_vgetc();
            if (!global_busy)
                got_int = 0;




            if (c == 25 && clip_star.state == 2)
            {
                clip_copy_modeless_selection(1);
                c = (-((253) + ((int)(KE_IGNORE) << 8)));
            }

        } while ((had_got_int && c == 3)
                                || c == (-((253) + ((int)(KE_IGNORE) << 8)))

                                || c == (-((249) + ((int)(('X')) << 8))) || c == (-((248) + ((int)(('X')) << 8)))


                                || c == (-((253) + ((int)(KE_LEFTDRAG) << 8))) || c == (-((253) + ((int)(KE_LEFTRELEASE) << 8)))
                                || c == (-((253) + ((int)(KE_MIDDLEDRAG) << 8))) || c == (-((253) + ((int)(KE_MIDDLERELEASE) << 8)))
                                || c == (-((253) + ((int)(KE_RIGHTDRAG) << 8))) || c == (-((253) + ((int)(KE_RIGHTRELEASE) << 8)))
                                || c == (-((253) + ((int)(KE_MOUSEDOWN) << 8))) || c == (-((253) + ((int)(KE_MOUSEUP) << 8)))
                                || (!mouse_has('r')
                                    && mouse_row != Rows - 1
                                    && (c == (-((253) + ((int)(KE_LEFTMOUSE) << 8)))
                                        || c == (-((253) + ((int)(KE_MIDDLEMOUSE) << 8)))
                                        || c == (-((253) + ((int)(KE_RIGHTMOUSE) << 8)))
                                        || c == (-((253) + ((int)(KE_X1MOUSE) << 8)))
                                        || c == (-((253) + ((int)(KE_X2MOUSE) << 8)))))

                                );
        ui_breakcheck();




        if (c == (-((253) + ((int)(KE_LEFTMOUSE) << 8))) || c == (-((253) + ((int)(KE_MIDDLEMOUSE) << 8))) || c == (-((253) + ((int)(KE_RIGHTMOUSE) << 8)))
                                          || c == (-((253) + ((int)(KE_X1MOUSE) << 8))) || c == (-((253) + ((int)(KE_X2MOUSE) << 8))))
            (void)jump_to_mouse(0x08, ((void *)0), 0);
        else

            if (vim_strchr((char_u *)"\r\n ", c) == ((void *)0) && c != 3)
        {
            stuffcharReadbuff(c);
            do_redraw = 1;

        }

    }
    redir_off = 0;





    if (c == ':' || c == '?' || c == '/')
    {
        if (!exmode_active)
            cmdline_row = msg_row;
        skip_redraw = 1;
        do_redraw = 0;
    }






    tmpState = State;
    State = oldState;

    setmouse();

    msg_check();





    if (swapping_screen() && !termcap_active)
        newline_on_exit = 1;


    need_wait_return = 0;
    did_wait_return = 1;
    emsg_on_display = 0;
    lines_left = -1;
    reset_last_sourcing();
    if (keep_msg != ((void *)0) && vim_strsize(keep_msg) >=
                                  (Rows - cmdline_row - 1) * Columns + sc_col)
    {
        vim_free(keep_msg);
        keep_msg = ((void *)0);
    }

    if (tmpState == 0x400)
    {
        starttermcap();
        shell_resized();
    }
    else if (!skip_redraw
            && (redraw == 1 || (msg_scrolled != 0 && redraw != -1)))
    {
        starttermcap();
        redraw_later(10);
    }
}
# 940 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void hit_return_msg()
{
    if (msg_didout)
        msg_putchar('\n');
    if (got_int)
        msg_puts((char_u *)(((char *)("Interrupt: "))));




    msg_puts_attr((char_u *)(((char *)("Hit ENTER or type command to continue"))), (highlight_attr[(int)(HLF_R)]));

    if (!msg_use_printf())
        msg_clr_eos();
}
# 960 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void set_keep_msg(s)
    char_u *s;
{
    vim_free(keep_msg);
    if (s != ((void *)0) && msg_silent == 0)
        keep_msg = vim_strsave(s);
    else
        keep_msg = ((void *)0);
}
# 974 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_start()
{
    int did_return = 0;

    vim_free(keep_msg);
    keep_msg = ((void *)0);
    if (!msg_scroll && full_screen)
    {
        msg_row = cmdline_row;
        msg_col =



            0;
    }
    else if (msg_didout)
    {
        msg_putchar('\n');
        did_return = 1;
        if (exmode_active != 1)
            cmdline_row = msg_row;
    }
    if (!msg_didany || lines_left < 0)
        msg_starthere();
    msg_didout = 0;
    cursor_off();


    if (!did_return)
        redir_write((char_u *)"\n", -1);
}
# 1010 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_starthere()
{
    lines_left = cmdline_row;
    msg_didany = 0;
}
# 1017 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_putchar(c)
    int c;
{
    msg_putchar_attr(c, 0);
}
# 1024 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_putchar_attr(c, attr)
    int c;
    int attr;
{



    char_u buf[4];


    if (((c) < 0))
    {
        buf[0] = (0x80);
        buf[1] = ((c) == (0x80) ? 254 : (c) == '\000' ? 255 : ((-(c)) & 0xff));
        buf[2] = (((c) == (0x80) || (c) == '\000') ? ('X') : (((unsigned)(-(c)) >> 8) & 0xff));
        buf[3] = '\000';
    }
    else
    {



        buf[0] = c;
        buf[1] = '\000';

    }
    msg_puts_attr(buf, attr);
}
# 1054 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_outnum(n)
    long n;
{
    char_u buf[20];

    sprintf((char *)buf, "%ld", n);
    msg_puts(buf);
}
# 1064 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_home_replace(fname)
    char_u *fname;
{
    msg_home_replace_attr(fname, 0);
}
# 1072 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_home_replace_hl(fname)
    char_u *fname;
{
    msg_home_replace_attr(fname, highlight_attr[(int)(HLF_D)]);
}
# 1080 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void msg_home_replace_attr(fname, attr)
    char_u *fname;
    int attr;
{
    char_u *name;

    name = home_replace_save(((void *)0), fname);
    if (name != ((void *)0))
        msg_outtrans_attr(name, attr);
    vim_free(name);
}
# 1099 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_outtrans(str)
    char_u *str;
{
    return msg_outtrans_attr(str, 0);
}
# 1106 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_outtrans_attr(str, attr)
    char_u *str;
    int attr;
{
    return msg_outtrans_len_attr(str, (int)strlen((char *)(str)), attr);
}
# 1114 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_outtrans_len(str, len)
    char_u *str;
    int len;
{
    return msg_outtrans_len_attr(str, len, 0);
}
# 1126 "/h/27/yijun/software/vim62/src/message.cpp.c"
    char_u * msg_outtrans_one(p, attr)
    char_u *p;
    int attr;
{
    msg_puts_attr(transchar(*p), attr);
    return p + 1;
}
# 1144 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_outtrans_len_attr(msgstr, len, attr)
    char_u *msgstr;
    int len;
    int attr;
{
    int retval = 0;
    char_u *str = msgstr;
    char_u *plain_start = msgstr;
    char_u *s;






    if (attr & 0x1000)
    {
        add_msg_hist(str, len, attr);
        attr &= ~0x1000;
    }
    while (--len >= 0)
    {
        {
            s = transchar(*str);
            if (s[1] != '\000')
            {


                if (str > plain_start)
                    msg_puts_attr_len(plain_start, (int)(str - plain_start),
                                                                        attr);
                plain_start = str + 1;
                msg_puts_attr(s, attr == 0 ? highlight_attr[(int)(HLF_8)] : attr);
            }
            retval += ptr2cells(str);
            ++str;
        }
    }

    if (str > plain_start)

        msg_puts_attr_len(plain_start, (int)(str - plain_start), attr);

    return retval;
}
# 1235 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_make(arg)
    char_u *arg;
{
    int i;
    static char_u *str = (char_u *)"eeffoc", *rs = (char_u *)"Plon#dqg#vxjduB";

    arg = skipwhite(arg);
    for (i = 5; *arg && i >= 0; --i)
        if (*arg++ != str[i])
            break;
    if (i < 0)
    {
        msg_putchar('\n');
        for (i = 0; rs[i]; ++i)
            msg_putchar(rs[i] - 3);
    }
}
# 1269 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_outtrans_special(strstart, from)
    char_u *strstart;
    int from;
{
    char_u *str = strstart;
    int retval = 0;
    char_u *string;
    int attr;
    int len;

    attr = highlight_attr[(int)(HLF_8)];
    while (*str != '\000')
    {

        if ((str == strstart || str[1] == '\000') && *str == ' ')
        {
            string = (char_u *)"<Space>";
            ++str;
        }
        else
            string = str2special(&str, from);
        len = vim_strsize(string);

        msg_puts_attr(string, len > 1



                ? attr : 0);
        retval += len;
    }
    return retval;
}
# 1308 "/h/27/yijun/software/vim62/src/message.cpp.c"
    char_u * str2special(sp, from)
    char_u **sp;
    int from;
{
    int c;
    static char_u buf[7];
    char_u *str = *sp;
    int modifiers = 0;
    int special = 0;
    c = *str;
    if (c == (0x80) && str[1] != '\000' && str[2] != '\000')
    {
        if (str[1] == 252)
        {
            modifiers = str[2];
            str += 3;
            c = *str;
        }
        if (c == (0x80) && str[1] != '\000' && str[2] != '\000')
        {
            c = ((str[1]) == 254 ? (0x80) : (str[1]) == 255 ? (-((255) + ((int)(('X')) << 8))) : (-((str[1]) + ((int)(str[2]) << 8))));
            str += 2;
            if (c == (-((255) + ((int)(('X')) << 8))))
                c = '\000';
        }
        if (((c) < 0) || modifiers)
            special = 1;
    }
    *sp = str + 1;
    if (special || char2cells(c) > 1 || (from && c == ' '))
        return get_special_key_name(c, modifiers);
    buf[0] = c;
    buf[1] = '\000';
    return buf;
}
# 1374 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void str2specialbuf(sp, buf, len)
    char_u *sp;
    char_u *buf;
    int len;
{
    char_u *s;

    *buf = '\000';
    while (*sp)
    {
        s = str2special(&sp, 0);
        if ((int)(strlen((char *)(s)) + strlen((char *)(buf))) < len)
            strcat((char *)(buf), (char *)(s));
    }
}
# 1394 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_prt_line(s)
    char_u *s;
{
    int c;
    int col = 0;
    int n_extra = 0;
    int c_extra = 0;
    char_u *p_extra = ((void *)0);
    int n;
    int attr= 0;
    char_u *trail = ((void *)0);






    if (curwin->w_onebuf_opt.wo_list && lcs_trail)
    {
        trail = s + strlen((char *)(s));
        while (trail > s && ((trail[-1]) == ' ' || (trail[-1]) == '\t'))
            --trail;
    }



    if (*s == '\000' && !curwin->w_onebuf_opt.wo_list)
        msg_putchar(' ');

    for (;;)
    {
        if (n_extra)
        {
            --n_extra;
            if (c_extra)
                c = c_extra;
            else
                c = *p_extra++;
        }
        else
        {
            attr = 0;
            c = *s++;
            if (c == '\011' && (!curwin->w_onebuf_opt.wo_list || lcs_tab1))
            {

                n_extra = curbuf->b_p_ts - col % curbuf->b_p_ts - 1;
                if (!curwin->w_onebuf_opt.wo_list)
                {
                    c = ' ';
                    c_extra = ' ';
                }
                else
                {
                    c = lcs_tab1;
                    c_extra = lcs_tab2;
                    attr = highlight_attr[(int)(HLF_8)];
                }
            }
            else if (c == '\000' && curwin->w_onebuf_opt.wo_list && lcs_eol)
            {
                p_extra = (char_u *)"";
                c_extra = '\000';
                n_extra = 1;
                c = lcs_eol;
                attr = highlight_attr[(int)(HLF_AT)];
                --s;
            }
            else if (c != '\000' && (n = byte2cells(c)) > 1)
            {
                n_extra = n - 1;
                p_extra = transchar(c);
                c_extra = '\000';
                c = *p_extra++;
            }
            else if (c == ' ' && trail != ((void *)0) && s > trail)
            {
                c = lcs_trail;
                attr = highlight_attr[(int)(HLF_8)];
            }
        }

        if (c == '\000')
            break;

        msg_putchar_attr(c, attr);
        col++;
    }
    msg_clr_eos();
}
# 1552 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_puts(s)
    char_u *s;
{
    msg_puts_attr(s, 0);
}
# 1559 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_puts_title(s)
    char_u *s;
{
    msg_puts_attr(s, highlight_attr[(int)(HLF_T)]);
}
# 1584 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_puts_long_attr(longstr, attr)
    char_u *longstr;
    int attr;
{
    msg_puts_long_len_attr(longstr, (int)strlen((char *)longstr), attr);
}
# 1592 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_puts_long_len_attr(longstr, len, attr)
    char_u *longstr;
    int len;
    int attr;
{
    int slen = len;
    int room;

    room = Columns - msg_col;
    if (len > room && room >= 20)
    {
        slen = (room - 3) / 2;
        msg_outtrans_len_attr(longstr, slen, attr);
        msg_puts_attr((char_u *)"...", highlight_attr[(int)(HLF_8)]);
    }
    msg_outtrans_len_attr(longstr + len - slen, slen, attr);
}
# 1614 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_puts_attr(s, attr)
    char_u *s;
    int attr;
{
    msg_puts_attr_len(s, -1, attr);
}
# 1627 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void msg_puts_attr_len(str, maxlen, attr)
    char_u *str;
    int maxlen;
    int attr;
{
    int oldState;
    char_u *s = str;
    char_u *p;
    char_u buf[4];
    char_u *t_s = str;
    int t_col = 0;




    int c;




    redir_write(s, maxlen);




    if (msg_silent != 0)
        return;


    if ((attr & 0x1000) && maxlen < 0)
    {
        add_msg_hist(s, -1, attr);
        attr &= ~0x1000;
    }







    if (msg_scrolled && !msg_scrolled_ign)
        need_wait_return = 1;
    msg_didany = 1;
    if (msg_use_printf())
    {




        while (*s != '\000' && (maxlen < 0 || (int)(s - str) < maxlen))
        {
            if (!silent_mode)
            {
                p = &buf[0];


                if (*s == '\n' && !info_message)
                    *p++ = '\r';



                    *p++ = *s;
                *p = '\0';
                if (info_message)
                    mch_msg((char *)buf);
                else
                    mch_errmsg((char *)buf);
            }
            {
                if (*s == '\r' || *s == '\n')
                    msg_col = 0;
                else
                    ++msg_col;
            }
            ++s;
        }
        msg_didout = 1;





        return;
    }

    did_wait_return = 0;
    while (*s != '\000' && (maxlen < 0 || (int)(s - str) < maxlen))
    {







        if (msg_row >= Rows - 1
                && (*s == '\n'
                    || (
                      (msg_col + t_col >= Columns - 1
                       || (*s == '\011' && msg_col + t_col >= ((Columns - 1) & ~7))




                      ))))
        {
            if (t_col > 0)
            {

                t_puts(t_col, t_s, s, attr);
                t_col = 0;
            }


            if (msg_no_more && lines_left == 0)
                break;



            if (gui.in_use)
                gui_undraw_cursor();


            screen_del_lines(0, 0, 1, (int)Rows, 1, ((void *)0));

            if (!can_clear((char_u *)" "))
            {



                screen_fill((int)Rows - 1, (int)Rows, 0,
                                                   (int)Columns, ' ', ' ', 0);



                if (ScreenAttrs[LineOffset[Rows - 2] + Columns - 1]
                                                               == (char_u)-1)
                    screen_fill((int)Rows - 2, (int)Rows - 1,
                                 (int)Columns - 1, (int)Columns, ' ', ' ', 0);
            }

            msg_row = Rows - 2;
            if (msg_col >= Columns)
                msg_col = Columns - 1;

            ++msg_scrolled;
            need_wait_return = 1;
            if (must_redraw < 10)
                must_redraw = 10;
            redraw_cmdline = 1;
            if (cmdline_row > 0 && !exmode_active)
                --cmdline_row;




            if (p_more && --lines_left == 0 && State != (0x200 + 0x01)
                                            && !msg_no_more && !exmode_active)
            {
                oldState = State;
                State = 0x300;

                setmouse();

                msg_moremsg(0);
                for (;;)
                {



                    c = get_keystroke();


                    if (c == (-((250) + ((int)(('X')) << 8))))
                    {
                        int idx = get_menu_index(current_menu, 0x300);




                        if (idx == -1)
                            continue;
                        c = *current_menu->strings[idx];
                        if (c != '\000' && current_menu->strings[idx][1] != '\000')
                            ins_typebuf(current_menu->strings[idx] + 1,
                                    current_menu->noremap[idx], 0, 1,
                                    current_menu->silent[idx]);
                    }


                    switch (c)
                    {
                    case '\010':
                    case 'k':
                    case (-(('k') + ((int)('u') << 8))):
                        if (!more_back_used)
                        {
                            msg_moremsg(1);
                            continue;
                        }
                        more_back = 1;
                        lines_left = 1;
                        break;
                    case '\015':
                    case '\012':
                    case 'j':
                    case (-(('k') + ((int)('d') << 8))):
                        lines_left = 1;
                        break;
                    case ':':

                        if (!confirm_msg_used)

                        {



                            typeahead_noflush(':');
                            cmdline_row = Rows - 1;
                            skip_redraw = 1;
                            need_wait_return = 0;
                        }

                    case 'q':
                    case 3:
                    case '\033':

                        if (confirm_msg_used)
                        {

                            s = confirm_msg_tail;
                            lines_left = Rows - 1;
                        }
                        else

                        {
                            got_int = 1;
                            quit_more = 1;
                        }
                        break;
                    case 'u':
                    case (-(('k') + ((int)('P') << 8))):
                        if (!more_back_used)
                        {
                            msg_moremsg(1);
                            continue;
                        }
                        more_back = Rows / 2;

                    case 'd':
                        lines_left = Rows / 2;
                        break;
                    case 'b':
                        if (!more_back_used)
                        {
                            msg_moremsg(1);
                            continue;
                        }
                        more_back = Rows - 1;

                    case ' ':
                    case (-(('k') + ((int)('N') << 8))):
                    case (-((253) + ((int)(KE_LEFTMOUSE) << 8))):
                        lines_left = Rows - 1;
                        break;


                    case 25:





                        if (clip_star.state == 2)
                            clip_copy_modeless_selection(1);
                        continue;

                    default:
                        msg_moremsg(1);
                        continue;
                    }
                    break;
                }


                screen_fill((int)Rows - 1, (int)Rows,
                                                0, (int)Columns, ' ', ' ', 0);
                State = oldState;

                setmouse();

                if (quit_more)
                {
                    msg_row = Rows - 1;
                    msg_col = 0;
                    return;
                }




            }
        }

        if (t_col > 0
                && (vim_strchr((char_u *)"\n\r\b\t", *s) != ((void *)0)
                    || *s == '\007'
                    || msg_col + t_col >= Columns




                    ))
        {

            t_puts(t_col, t_s, s, attr);
            t_col = 0;
        }

        if (*s == '\n')
        {
            msg_didout = 0;
            msg_col = 0;
            if (++msg_row >= Rows)
                msg_row = Rows - 1;
        }
        else if (*s == '\r')
        {
            msg_col = 0;
        }
        else if (*s == '\b')
        {
            if (msg_col)
                --msg_col;
        }
        else if (*s == '\011')
        {
            do
                msg_screen_putchar(' ', attr);
            while (msg_col & 7);
        }
        else if (*s == '\007')
            vim_beep();
        else
        {
            {

                if (t_col == 0)
                    t_s = s;




                ++t_col;

            }
        }
        ++s;
    }


    if (t_col > 0)
        t_puts(t_col, t_s, s, attr);

    msg_check();
}
# 2071 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void t_puts(t_col, t_s, s, attr)
    int t_col;
    char_u *t_s;
    char_u *s;
    int attr;
{

    msg_didout = 1;
    screen_puts_len(t_s, (int)(s - t_s), msg_row, msg_col, attr);
    msg_col += t_col;
    if (msg_col >= Columns)
    {
        msg_col = 0;
        ++msg_row;
    }
}
# 2098 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_use_printf()
{
    return (!msg_check_screen()



            || (swapping_screen() && !termcap_active)
               );
}
# 2123 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void mch_errmsg(str)
    char *str;
{
    int len;




    if (

            isatty(2)

            ||



            !(gui.in_use || gui.starting)

            )
    {
        fprintf(stderr, "%s", str);
        return;
    }



    emsg_on_display = 0;

    len = (int)strlen((char *)(str)) + 1;
    if (error_ga.ga_growsize == 0)
    {
        error_ga.ga_growsize = 80;
        error_ga.ga_itemsize = 1;
    }
    if (ga_grow(&error_ga, len) == 1)
    {
        memmove((char *)((char_u *)error_ga.ga_data + error_ga.ga_len), (char *)((char_u *)str), len);



        {
            char_u *p;

            p = (char_u *)error_ga.ga_data + error_ga.ga_len;
            for (;;)
            {
                p = vim_strchr(p, '\r');
                if (p == ((void *)0))
                    break;
                *p = ' ';
            }
        }

        --len;
        error_ga.ga_len += len;
        error_ga.ga_room -= len;
    }
}
# 2188 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void mch_msg(str)
    char *str;
{




    if (

            isatty(2)

            ||



            !(gui.in_use || gui.starting)

            )
    {
        printf("%s", str);
        return;
    }

    mch_errmsg(str);
}
# 2220 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void msg_screen_putchar(c, attr)
    int c;
    int attr;
{
    msg_didout = 1;
    screen_putchar(c, msg_row, msg_col, attr);
    {
        if (++msg_col >= Columns)
        {
            msg_col = 0;
            ++msg_row;
        }
    }
}
# 2247 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_moremsg(full)
    int full;
{
    int attr;

    attr = highlight_attr[(int)(HLF_M)];
    screen_puts((char_u *)((char *)("-- More --")), (int)Rows - 1, 0, attr);
    if (full)
        screen_puts(more_back_used
            ? (char_u *)((char *)(" (RET/BS: line, SPACE/b: page, d/u: half page, q: quit)"))
            : (char_u *)((char *)(" (RET: line, SPACE: page, d: half page, q: quit)")),
            (int)Rows - 1, 10, attr);
}
# 2266 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void repeat_message()
{
    if (State == 0x300)
    {
        msg_moremsg(1);
        msg_row = Rows - 1;
    }

    else if (State == 0x800)
    {
        display_confirm_msg();
        msg_row = Rows - 1;
    }

    else if (State == 0x600)
    {
        windgoto(msg_row, msg_col);
    }
    else if (State == (0x200 + 0x01) || State == 0x400)
    {
        hit_return_msg();
        msg_row = Rows - 1;
    }
}
# 2298 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static int msg_check_screen()
{
    if (!full_screen || !screen_valid(0))
        return 0;

    if (msg_row >= Rows)
        msg_row = Rows - 1;
    if (msg_col >= Columns)
        msg_col = Columns - 1;
    return 1;
}
# 2316 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_clr_eos()
{
    if (msg_use_printf())
    {
        if (full_screen)
        {
            if (*(term_strings[(int)(KS_CD)]))
                out_str((term_strings[(int)(KS_CD)]));
            else if (*(term_strings[(int)(KS_CE)]))
                out_str((term_strings[(int)(KS_CE)]));
        }
    }
    else
    {
        {
            screen_fill(msg_row, msg_row + 1, msg_col, (int)Columns,
                                                                 ' ', ' ', 0);
            screen_fill(msg_row + 1, (int)Rows, 0, (int)Columns, ' ', ' ', 0);
        }
    }
}
# 2350 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_clr_cmdline()
{
    msg_row = cmdline_row;
    msg_col = 0;
    msg_clr_eos();
}
# 2363 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int msg_end()
{






    if (!exiting && need_wait_return && !(State & 0x08))
    {
        wait_return(0);
        return 0;
    }
    out_flush();
    return 1;
}
# 2385 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_check()
{
    if (msg_row == Rows - 1 && msg_col >= sc_col)
    {
        need_wait_return = 1;
        redraw_cmdline = 1;
    }
}
# 2399 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static void redir_write(str, maxlen)
    char_u *str;
    int maxlen;
{
    char_u *s = str;
    static int cur_col = 0;

    if ((redir_fd != ((void *)0)

                          || redir_reg

                                       ) && !redir_off)
    {

        if (*s != '\n' && *s != '\r')
        {
            while (cur_col < msg_col)
            {

                if (redir_reg)
                    write_reg_contents(redir_reg, (char_u *)" ", -1, 1);
                else if (redir_fd)

                    fputs(" ", redir_fd);
                ++cur_col;
            }
        }


        if (redir_reg)
            write_reg_contents(redir_reg, s, maxlen, 1);



        while (*s != '\000' && (maxlen < 0 || (int)(s - str) < maxlen))
        {

            if (!redir_reg && redir_fd != ((void *)0))

                _IO_putc (*s, redir_fd);
            if (*s == '\r' || *s == '\n')
                cur_col = 0;
            else if (*s == '\t')
                cur_col += (8 - cur_col % 8);
            else
                ++cur_col;
            ++s;
        }
    }
}
# 2455 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void give_warning(message, hl)
    char_u *message;
    int hl;
{

    if (msg_silent != 0)
        return;


    set_vim_var_string(4, message, -1);




    vim_free(keep_msg);
    keep_msg = ((void *)0);
    if (hl)
        keep_msg_attr = highlight_attr[(int)(HLF_W)];
    else
        keep_msg_attr = 0;
    if (msg_attr(message, keep_msg_attr) && msg_scrolled == 0)
        set_keep_msg(message);
    msg_didout = 0;
    msg_nowait = 1;
    msg_col = 0;

}
# 2487 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void msg_advance(col)
    int col;
{
    if (msg_silent != 0)
    {
        msg_putchar(' ');
        return;
    }
    if (col >= Columns)
        col = Columns - 1;
    while (msg_col < col)
        msg_putchar(' ');
}
# 2522 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int do_dialog(type, title, message, buttons, dfltbutton, textfield)
    int type;
    char_u *title;
    char_u *message;
    char_u *buttons;
    int dfltbutton;
    char_u *textfield;
{
    int oldState;
    int retval = 0;
    char_u *hotkeys;
    int c;



    if (silent_mode)
        return dfltbutton;




    if (gui.in_use && vim_strchr(p_go, 'c') == ((void *)0))
    {
        c = gui_mch_dialog(type, title, message, buttons, dfltbutton,
                                                                   textfield);
        msg_end_prompt();
        return c;
    }


    oldState = State;
    State = 0x800;

    setmouse();






    ++no_wait_return;
    hotkeys = msg_show_console_dialog(message, buttons, dfltbutton);

    if (hotkeys != ((void *)0))
    {
        for (;;)
        {

            c = get_keystroke();
            switch (c)
            {
            case '\015':
            case '\012':
                retval = dfltbutton;
                break;
            case 3:
            case '\033':
                retval = 0;
                break;
            default:
                if (c > 255)
                    continue;
                for (retval = 0; hotkeys[retval]; retval++)
                {
                    if (hotkeys[retval] == tolower(c))
                        break;
                }
                if (hotkeys[retval])
                {
                    retval++;
                    break;
                }

                continue;
            }
            break;
        }

        vim_free(hotkeys);
    }

    State = oldState;

    setmouse();

    --no_wait_return;
    msg_end_prompt();

    return retval;
}
# 2623 "/h/27/yijun/software/vim62/src/message.cpp.c"
    static char_u * msg_show_console_dialog(message, buttons, dfltbutton)
    char_u *message;
    char_u *buttons;
    int dfltbutton;
{
    int len = 0;
    int lenhotkey = 1;
    char_u *hotk;
    char_u *p;
    char_u *q;
    char_u *r;




    r = buttons;
    while (*r)
    {
        if (*r == '\n')
        {
            len++;
            lenhotkey++;
        }
        else if (*r == '&')
        {
            len++;
        }
        r++;
    }

    len += strlen((char *)(message))
            + 2
            + strlen((char *)(buttons))
            + 3;

    lenhotkey++;




    vim_free(confirm_msg);
    confirm_msg = alloc(len);
    if (confirm_msg == ((void *)0))
        return ((void *)0);
    *confirm_msg = '\000';
    hotk = alloc(lenhotkey);
    if (hotk == ((void *)0))
        return ((void *)0);

    *confirm_msg = '\n';
    strcpy((char *)(confirm_msg + 1), (char *)(message));

    p = confirm_msg + 1 + strlen((char *)(message));
    q = hotk;
    r = buttons;
    *q = (char_u)tolower(*r);



    confirm_msg_tail = p;
    *p++ = '\n';

    while (*r)
    {
        if (*r == '\n')
        {
            *p++ = ',';
            *p++ = ' ';
            *(++q) = (char_u)tolower(*(r + 1));
            if (dfltbutton)
                --dfltbutton;
        }
        else if (*r == '&')
        {
            r++;
            if (*r == '&')
                *p++ = *r;
            else
            {

                *p++ = (dfltbutton == 1) ? '[' : '(';
                *p++ = *r;
                *p++ = (dfltbutton == 1) ? ']' : ')';
                *q = (char_u)tolower(*r);
            }
        }
        else
        {
            *p++ = *r;
        }
        r++;
    }
    *p++ = ':';
    *p++ = ' ';
    *p = '\000';
    *(++q) = '\000';

    display_confirm_msg();
    return hotk;
}
# 2728 "/h/27/yijun/software/vim62/src/message.cpp.c"
    void display_confirm_msg()
{

    ++confirm_msg_used;
    if (confirm_msg != ((void *)0))
        msg_puts_attr(confirm_msg, highlight_attr[(int)(HLF_M)]);
    --confirm_msg_used;
}
# 2742 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int vim_dialog_yesno(type, title, message, dflt)
    int type;
    char_u *title;
    char_u *message;
    int dflt;
{
    if (do_dialog(type,
                title == ((void *)0) ? (char_u *)((char *)("Question")) : title,
                message,
                (char_u *)((char *)("&Yes\n&No")), dflt, ((void *)0)) == 1)
        return 2;
    return 3;
}
# 2757 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int vim_dialog_yesnocancel(type, title, message, dflt)
    int type;
    char_u *title;
    char_u *message;
    int dflt;
{
    switch (do_dialog(type,
                title == ((void *)0) ? (char_u *)((char *)("Question")) : title,
                message,
                (char_u *)((char *)("&Yes\n&No\n&Cancel")), dflt, ((void *)0)))
    {
        case 1: return 2;
        case 2: return 3;
    }
    return 4;
}
# 2775 "/h/27/yijun/software/vim62/src/message.cpp.c"
    int vim_dialog_yesnoallcancel(type, title, message, dflt)
    int type;
    char_u *title;
    char_u *message;
    int dflt;
{
    switch (do_dialog(type,
                title == ((void *)0) ? (char_u *)"Question" : title,
                message,
                (char_u *)((char *)("&Yes\n&No\nSave &All\n&Discard All\n&Cancel")),
                                                                  dflt, ((void *)0)))
    {
        case 1: return 2;
        case 2: return 3;
        case 3: return 5;
        case 4: return 6;
    }
    return 4;
}
# 2803 "/h/27/yijun/software/vim62/src/message.cpp.c"
    char_u * do_browse(saving, title, dflt, ext, initdir, filter, buf)
    int saving;
    char_u *title;
    char_u *dflt;
    char_u *ext;
    char_u *initdir;

    char_u *filter;
    buf_T *buf;
{
    char_u *fname;
    static char_u *last_dir = ((void *)0);
    char_u *tofree = ((void *)0);




    cmdmod.browse = 0;

    if (title == ((void *)0))
    {
        if (saving)
            title = (char_u *)((char *)("Save File dialog"));
        else
            title = (char_u *)((char *)("Open File dialog"));
    }



    if ((initdir == ((void *)0) || *initdir == '\000') && dflt != ((void *)0) && *dflt != '\000')
    {
        if (mch_isdir(dflt))
        {
            initdir = dflt;
            dflt = ((void *)0);
        }
        else if (gettail(dflt) != dflt)
        {
            tofree = vim_strsave(dflt);
            if (tofree != ((void *)0))
            {
                initdir = tofree;
                *gettail(initdir) = '\000';
                dflt = gettail(dflt);
            }
        }
    }

    if (initdir == ((void *)0) || *initdir == '\000')
    {

        if (mch_isdir(p_bsdir))
            initdir = p_bsdir;

        else if ((saving || *p_bsdir == 'b')
                && buf != ((void *)0) && buf->b_ffname != ((void *)0))
        {
            if (dflt == ((void *)0) || *dflt == '\000')
                dflt = gettail(curbuf->b_ffname);
            tofree = vim_strsave(curbuf->b_ffname);
            if (tofree != ((void *)0))
            {
                initdir = tofree;
                *gettail(initdir) = '\000';
            }
        }

        else if (*p_bsdir == 'l')
            initdir = last_dir;


    }


    if (gui.in_use)
    {
        if (filter == ((void *)0)

                && (filter = get_var_value((char_u *)"b:browsefilter")) == ((void *)0)
                && (filter = get_var_value((char_u *)"g:browsefilter")) == ((void *)0)

        )
            filter = (char_u *)"All Files (*)\t*\nC source (*.c, *.h)\t*.c;*.h\nC++ source (*.cpp, *.hpp)\t*.cpp;*.hpp\nVim files (*.vim, _vimrc, _gvimrc)\t*.vim;_vimrc;_gvimrc\n";
        fname = gui_mch_browse(saving, title, dflt, ext, initdir, filter);




        need_check_timestamps = 1;
        did_check_timestamps = 0;
    }
    else

    {

        emsg((char_u *)(((char *)("E338: Sorry, no file browser in console mode"))));
        fname = ((void *)0);
    }


    if (fname != ((void *)0))
    {
        vim_free(last_dir);
        last_dir = vim_strsave(fname);
        if (last_dir != ((void *)0))
        {
            *gettail(last_dir) = '\000';
            if (*last_dir == '\000')
            {

                vim_free(last_dir);
                last_dir = alloc(1024);
                if (last_dir != ((void *)0))
                    mch_dirname(last_dir, 1024);
            }
        }
    }

    vim_free(tofree);

    return fname;
}
