#include "view.h"
# 3 "/h/27/yijun/software/vim62/src/proto/version.pro"
int highest_patch (void);
# 938 "/h/27/yijun/software/vim62/src/globals.h"
extern char *mediumVersion;
# 952 "/h/27/yijun/software/vim62/src/globals.h"
extern char_u *all_cflags;
# 953 "/h/27/yijun/software/vim62/src/globals.h"
extern char_u *all_lflags;
# 957 "/h/27/yijun/software/vim62/src/globals.h"
extern char_u *compiled_user;
# 958 "/h/27/yijun/software/vim62/src/globals.h"
extern char_u *compiled_sys;
# 25 "/h/27/yijun/software/vim62/src/version.cpp.c"
char *Version = "6.2";
# 26 "/h/27/yijun/software/vim62/src/version.cpp.c"
char *mediumVersion = "6.2";
# 46 "/h/27/yijun/software/vim62/src/version.cpp.c"
char *longVersion = "VIM - Vi IMproved 6.2 (2003 Jun 1, compiled " "Jul 18 2003" " " "10:06:39" ")";
# 52 "/h/27/yijun/software/vim62/src/version.cpp.c"
static void version_msg (char *s);
# 54 "/h/27/yijun/software/vim62/src/version.cpp.c"
static char *(features[]) =
{
        "-arabic",


        "+autocmd",




        "+balloon_eval",




        "+browse",







        "+builtin_terms",





        "+byte_offset",




        "+cindent",




        "+clientserver",




        "+clipboard",




        "+cmdline_compl",




        "+cmdline_hist",




        "+cmdline_info",




        "+comments",




        "+cryptv",






        "-cscope",


        "+dialog_con_gui",
        "+diff",




        "+digraphs",




        "+dnd",






        "-ebcdic",




        "-emacs_tags",


        "+eval",




        "+ex_extra",




        "+extra_search",






        "-farsi",


        "+file_in_path",




        "+find_in_path",




        "+folding",






        "-footer",



        "+fork()",
        "-gettext",




        "-hangul_input",
        "-iconv",


        "+insert_expand",




        "+jumplist",






        "-keymap",




        "-langmap",


        "+libcall",




        "+linebreak",




        "+lispindent",




        "+listcmds",




        "+localmap",




        "+menu",




        "+mksession",




        "+modify_fname",




        "+mouse",

        "+mouseshape",
        "-mouse_dec",




        "-mouse_gpm",




        "-mouse_jsbterm",




        "-mouse_netterm",


        "+mouse_xterm",
        "-multi_byte",



        "+multi_lang",




        "+netbeans_intg",
        "-osfiletype",


        "+path_extra",
        "-perl",



        "+postscript",



        "+printer",
        "-python",


        "+quickfix",






        "-rightleft",
        "-ruby",


        "+scrollbind",




        "+signs",




        "+smartindent",






        "-sniff",


        "+statusline",






        "-sun_workshop",


        "+syntax",
        "+tag_binary",




        "+tag_old_static",






        "-tag_any_white",
        "-tcl",




        "+terminfo",
        "+termresponse",




        "+textobjects",




        "+title",




        "+toolbar",




        "+user_commands",




        "+vertsplit",




        "+virtualedit",




        "+visual",

        "+visualextra",







        "+viminfo",




        "+vreplace",




        "+wildignore",




        "+wildmenu",




        "+windows",




        "+writebackup",





        "+X11",







        "-xfontset",


        "+xim",
        "-xsmp",



        "+xterm_clipboard",







        "-xterm_save",

        ((void *)0)
};
# 631 "/h/27/yijun/software/vim62/src/version.cpp.c"
static int included_patches[] =
{

    0
};
# 638 "/h/27/yijun/software/vim62/src/version.cpp.c"
    int highest_patch()
{
    int i;
    int h = 0;

    for (i = 0; included_patches[i] != 0; ++i)
        if (included_patches[i] > h)
            h = included_patches[i];
    return h;
}
# 654 "/h/27/yijun/software/vim62/src/version.cpp.c"
    int has_patch(n)
    int n;
{
    int i;

    for (i = 0; included_patches[i] != 0; ++i)
        if (included_patches[i] == n)
            return 1;
    return 0;
}
# 667 "/h/27/yijun/software/vim62/src/version.cpp.c"
    void ex_version(eap)
    exarg_T *eap;
{



    if (*eap->arg == '\000')
    {
        msg_putchar('\n');
        list_version();
    }
}
# 681 "/h/27/yijun/software/vim62/src/version.cpp.c"
    void list_version()
{
    int i;
    int first;
    char *s = "";





    msg((char_u *)(longVersion));
    if (included_patches[0] != 0)
    {
        msg_puts((char_u *)(((char *)("\nIncluded patches: "))));
        first = -1;

        for (i = 0; included_patches[i] != 0; ++i)
            ;
        while (--i >= 0)
        {
            if (first < 0)
                first = included_patches[i];
            if (i == 0 || included_patches[i - 1] != included_patches[i] + 1)
            {
                msg_puts((char_u *)(s));
                s = ", ";
                msg_outnum((long)first);
                if (first != included_patches[i])
                {
                    msg_puts((char_u *)("-"));
                    msg_outnum((long)included_patches[i]);
                }
                first = -1;
            }
        }
    }
    if (*compiled_user != '\000' || *compiled_sys != '\000')
    {
        msg_puts((char_u *)(((char *)("\nCompiled "))));
        if (*compiled_user != '\000')
        {
            msg_puts((char_u *)(((char *)("by "))));
            msg_puts((char_u *)(compiled_user));
        }
        if (*compiled_sys != '\000')
        {
            msg_puts((char_u *)("@"));
            msg_puts((char_u *)(compiled_sys));
        }
    }
    msg_puts((char_u *)(((char *)("\nNormal version "))));
    msg_puts((char_u *)(((char *)("with GTK GUI."))));
    version_msg(((char *)("  Features included (+) or not (-):\n")));


    for (i = 0; features[i] != ((void *)0); ++i)
    {
        version_msg(features[i]);
        if (msg_col > 0)
            version_msg(" ");
    }

    version_msg("\n");

    version_msg(((char *)("   system vimrc file: \"")));
    version_msg("$VIM/vimrc");
    version_msg("\"\n");


    version_msg(((char *)("     user vimrc file: \"")));
    version_msg("$HOME/.vimrc");
    version_msg("\"\n");
    version_msg(((char *)("      user exrc file: \"")));
    version_msg("$HOME/.exrc");
    version_msg("\"\n");
    version_msg(((char *)("  system gvimrc file: \"")));
    version_msg("$VIM/gvimrc");
    version_msg("\"\n");

    version_msg(((char *)("    user gvimrc file: \"")));
    version_msg("$HOME/.gvimrc");
    version_msg("\"\n");
    version_msg(((char *)("    system menu file: \"")));
    version_msg("$VIMRUNTIME/menu.vim");
    version_msg("\"\n");



    if (*default_vim_dir != '\000')
    {
        version_msg(((char *)("  fall-back for $VIM: \"")));
        version_msg((char *)default_vim_dir);
        version_msg("\"\n");
    }
    if (*default_vimruntime_dir != '\000')
    {
        version_msg(((char *)(" f-b for $VIMRUNTIME: \"")));
        version_msg((char *)default_vimruntime_dir);
        version_msg("\"\n");
    }
    version_msg(((char *)("Compilation: ")));
    version_msg((char *)all_cflags);
    version_msg("\n");
    version_msg(((char *)("Linking: ")));
    version_msg((char *)all_lflags);





}
# 967 "/h/27/yijun/software/vim62/src/version.cpp.c"
    static void version_msg(s)
    char *s;
{
    int len = (int)strlen((char *)(s));

    if (!got_int && len < (int)Columns && msg_col + len >= (int)Columns
                                                                && *s != '\n')
        msg_putchar('\n');
    if (!got_int)
        msg_puts((char_u *)(s));
}
# 979 "/h/27/yijun/software/vim62/src/version.cpp.c"
static void do_intro_line (int row, char_u *mesg, int add_version, int attr);
# 987 "/h/27/yijun/software/vim62/src/version.cpp.c"
    void intro_message(colon)
    int colon;
{
    int i;
    int row;
    int blanklines;
    char *p;
    static char *(lines[]) =
    {
        "VIM - Vi IMproved",
        "",
        "version ",
        "by Bram Moolenaar et al.",



        "Vim is open source and freely distributable",
        "",
        "Help poor children in Uganda!",
        "type  :help iccf<Enter>       for information ",
        "",
        "type  :q<Enter>               to exit         ",
        "type  :help<Enter>  or  <F1>  for on-line help",
        "type  :help version6<Enter>   for version info",
        ((void *)0),
        "",
        "Running in Vi compatible mode",
        "type  :set nocp<Enter>        for Vim defaults",
        "type  :help cp-default<Enter> for info on this",
    };

    static char *(gui_lines[]) =
    {
        ((void *)0),
        ((void *)0),
        ((void *)0),
        ((void *)0),



        ((void *)0),
        ((void *)0),
        ((void *)0),
        "menu  Help->Orphans           for information    ",
        ((void *)0),
        "Running modeless, typed text is inserted",
        "menu  Edit->Global Settings->Toggle Insert Mode  ",
        "                              for two modes      ",
        ((void *)0),
        ((void *)0),
        ((void *)0),
        "menu  Edit->Global Settings->Toggle Vi Compatible",
        "                              for Vim defaults   ",
    };



    blanklines = (int)Rows - ((sizeof(lines) / sizeof(char *)) - 1);
    if (!p_cp)
        blanklines += 4;







    if (p_ls > 1)
        blanklines -= Rows - topframe->fr_height;

    if (blanklines < 0)
        blanklines = 0;


    row = blanklines / 2;
    if ((row >= 2 && Columns >= 50) || colon)
    {
        for (i = 0; i < (int)(sizeof(lines) / sizeof(char *)); ++i)
        {
            p = lines[i];

            if (p_im && gui.in_use && gui_lines[i] != ((void *)0))
                p = gui_lines[i];

            if (p == ((void *)0))
            {
                if (!p_cp)
                    break;
                continue;
            }
            if (*p != '\000')
                do_intro_line(row, (char_u *)((char *)(p)), i == 2, 0);
            ++row;
        }
    }


    if (colon)
        msg_row = row;
}
# 1100 "/h/27/yijun/software/vim62/src/version.cpp.c"
    static void do_intro_line(row, mesg, add_version, attr)
    int row;
    char_u *mesg;
    int add_version;
    int attr;
{
    char_u vers[20];
    int col;
    char_u *p;
    int l;
    int clen;
    col = vim_strsize(mesg);
    if (add_version)
    {
        strcpy((char *)(vers), (char *)(mediumVersion));
        if (highest_patch())
        {

            if ((__ctype_b[(int) (((int)mediumVersion[3]))] & (unsigned short int) _ISalpha))
            {
                if ((__ctype_b[(int) (((int)mediumVersion[4]))] & (unsigned short int) _ISalpha))
                    sprintf((char *)vers + 5, ".%d%s", highest_patch(),
                                                           mediumVersion + 5);
                else
                    sprintf((char *)vers + 4, ".%d%s", highest_patch(),
                                                           mediumVersion + 4);
            }
            else
                sprintf((char *)vers + 3, ".%d", highest_patch());
        }
        col += (int)strlen((char *)(vers));
    }
    col = (Columns - col) / 2;
    if (col < 0)
        col = 0;


    for (p = mesg; *p != '\000'; p += l)
    {
        clen = 0;
        for (l = 0; p[l] != '\000'
                         && (l == 0 || (p[l] != '<' && p[l - 1] != '>')); ++l)
        {
                clen += byte2cells(p[l]);
        }
        screen_puts_len(p, l, row, col, *p == '<' ? highlight_attr[(int)(HLF_8)] : attr);
        col += clen;
    }


    if (add_version)
        screen_puts(vers, row, col, 0);
}
# 1183 "/h/27/yijun/software/vim62/src/version.cpp.c"
    void ex_intro(eap)
    exarg_T *eap;
{
    screenclear();
    intro_message(1);
    wait_return(1);
}
