enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
extern __const unsigned short int *__ctype_b;
typedef long int __off_t;
__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _blksize;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
extern int _IO_putc (int __c, _IO_FILE *__fp) ;
int aborting (void);
typedef unsigned char char_u;
char_u *alloc (unsigned size);
char_u *alloc_clear (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
void buf_clear_file (buf_T *buf);
void buf_freeall (buf_T *buf, int del_buf, int wipe_buf);
void get_winopts (buf_T *buf);
pos_T *buflist_findfpos (buf_T *buf);
void buf_name_changed (void);
void buflist_altfpos (void);
void fname_expand (char_u **ffname, char_u **sfname);
void diff_new_buffer (void);
int apply_autocmds_retval (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf, int *retval);
void fmarks_check_names (buf_T *buf);
win_T *buf_jump_open_win (buf_T *buf);
extern buf_T *au_new_curbuf ;
extern int atoi (__const char *__nptr) __attribute__ ((__pure__));
extern long int atol (__const char *__nptr) __attribute__ ((__pure__));
int autowrite (buf_T *buf, int forceit);
int bufIsChanged (buf_T *buf);
int buf_check_timestamp (buf_T *buf, int focus);
extern int p_acd;
void buf_copy_options (buf_T *buf, int flags);
int buf_hide (buf_T *buf);
int buf_init_chartab (buf_T *buf, int global);int buf_valid (buf_T *buf);
buf_T *buflist_findnr (int nr);
buf_T *buflist_new (char_u *ffname, char_u *sfname, linenr_T lnum, int flags);
void changed_line_abv_curs (void);
void check_arg_idx (win_T *win);
extern char_u e_nowrtmsg[] ;
void check_cursor_col (void);
void check_cursor_lnum (void);
void close_buffer (win_T *win, buf_T *buf, int action);
int curbufIsChanged (void);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
int do_ecmd (int fnum, char_u *ffname, char_u *sfname, exarg_T *eap, linenr_T newlnum, int flags);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
int emsgn (char_u *s, long n);
void expand_env (char_u *src, char_u *dst, int dstlen);
char_u *find_viminfo_parameter (int type);
char_u *fix_fname (char_u *fname);
void foldUpdateAll (win_T *win);
extern int fprintf (FILE *__restrict __stream,
                    __const char *__restrict __format, ...) ;
int fullpathcmp (char_u *s1, char_u *s2, int checkname);
long getdigits (char_u **pp);
void getout (int exitval);
char_u *gettail (char_u *fname);
void handle_swap_exists (buf_T *old_curbuf);
char_u *lalloc (long_u size, int message);
void maketitle (void);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
int ml_delete (linenr_T lnum, int message);
char_u *ml_get (linenr_T lnum);
char_u *ml_get_buf (buf_T *buf, linenr_T lnum, int will_change);
int msg (char_u *s);
int msg_outtrans (char_u *str);
void msg_putchar (int c);
void msg_puts (char_u *s);
void msg_puts_attr (char_u *s, int attr);
void msg_start (void);
int open_buffer (int read_stdin, exarg_T *eap);
void out_flush (void);
int readfile (char_u *fname, char_u *sfname, linenr_T from, linenr_T lines_to_skip, linenr_T lines_to_read, exarg_T *eap, int flags);
void redraw_later (int type);
void set_keep_msg (char_u *s);
void set_last_cursor (win_T *win);
void setpcmark (void);
void shorten_fnames (int force);
int shortmess (int x);
char_u *skiptowhite_esc (char_u *p);
char_u *skipwhite (char_u *p);
int smsg (char_u *, ...);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
typedef __u_int __mode_t;
typedef long int __time_t;
__extension__ typedef unsigned long long int __u_quad_t;
typedef __u_int __gid_t;
typedef __u_int __nlink_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __u_quad_t __dev_t;
struct stat
  {
    __dev_t st_dev;
    unsigned short int __pad1;
    __ino_t st_ino;
    __mode_t st_mode;
    __nlink_t st_nlink;
    __uid_t st_uid;
    __gid_t st_gid;
    __dev_t st_rdev;
    unsigned short int __pad2;
    __off_t st_size;
    __blksize_t st_blksize;
    __blkcnt_t st_blocks;
    __time_t st_atime;
    unsigned long int __unused1;
    __time_t st_mtime;
    unsigned long int __unused2;
    __time_t st_ctime;
    unsigned long int __unused3;
    unsigned long int __unused4;
    unsigned long int __unused5;
  };
extern int stat (__const char *__restrict __file,
                 struct stat *__restrict __buf) ;
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
void ui_breakcheck (void);
int vim_chdirfile (char_u *fname);
void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strrchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
void win_enter (win_T *wp, int undo_sync);
int win_split (int size, int flags);
void wipe_buffer (buf_T *buf, int aucmd);
extern long Columns ;
extern char_u *IObuff;
extern char_u *NameBuff;
extern int RedrawingDisabled ;
extern long Rows
                            ;
extern int State ;
typedef struct
{
    int hide;
    int browse;
    int split;
    int confirm;
} cmdmod_T;
extern cmdmod_T cmdmod;
extern int cmdwin_type ;
extern buf_T *curbuf ;
extern win_T *curwin;
extern char_u e_trailing[] ;
extern buf_T *firstbuf ;
extern win_T *firstwin;
extern int got_int ;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
extern int highlight_attr[HLF_COUNT];
extern int keep_msg_attr ;
extern int msg_row;
extern int msg_scroll ;
extern int msg_scrolled;
extern int need_mouse_correct ;
extern int need_wait_return ;
extern char_u *p_cpo;
extern int p_magic;
extern long p_report;
extern int p_sol;
extern int restart_edit ;
extern int swap_exists_action ;
extern int usingNetbeans ;
void backslash_halve (char_u *p);
int ga_grow (garray_T *gap, int n);
void ga_init2 (garray_T *gap, int itemsize, int growsize);
char_u *transchar (int c);
void transchar_nonprint (char_u *buf, int c);
int vim_isprintc_strict (int c);
void append_redir (char_u *buf, char_u *opt, char_u *fname);
int buf_write (buf_T *buf, char_u *fname, char_u *sfname, linenr_T start, linenr_T end, exarg_T *eap, int append, int forceit, int reset_changed, int filtering);
int call_shell (char_u *cmd, int opt);
void changed_lines (linenr_T lnum, colnr_T col, linenr_T lnume, long xtra);
void check_cursor (void);
char_u *do_browse (int saving, char_u *title, char_u *dflt, char_u *ext, char_u *initdir, char_u *filter, buf_T *buf);
int do_cmdline_cmd (char_u *cmd);
extern int fclose (FILE *__stream) ;
extern FILE *fopen (__const char *__restrict __filename,
                    __const char *__restrict __modes) ;
void mark_adjust (linenr_T line1, linenr_T line2, long amount, long amount_after);
int ml_append (linenr_T lnum, char_u *line, colnr_T len, int newfile);
void set_string_option_direct (char_u *name, int opt_idx, char_u *val, int opt_flags);
int u_save (linenr_T top, linenr_T bot);
extern int unlink (__const char *__name) ;
int vim_fgets (char_u *buf, int size, FILE *fp);
char_u *vim_strnsave (char_u *string, int len);
char_u *vim_tempname (int extra_char);
extern int KeyTyped;
extern char_u *p_srr;
int safe_vgetc (void);
extern int no_mapping ;
extern int allow_keys ;
extern char_u e_invarg[] ;
extern int msg_col;
void AppendToRedobuff (char_u *s);
void AppendToRedobuffLit (char_u *s);
void FreeWild (int count, char_u **files);
void beginline (int flags);
void changed_bytes (linenr_T lnum, colnr_T col);
int chartabsize (char_u *p, colnr_T col);
void check_for_delay (int check_msg_scroll);
int coladvance (colnr_T wcol);
int copy_option_part (char_u **option, char_u *buf, int maxlen, char *sep_chars);
int find_tags (char_u *pat, int *num_matches, char_u ***matchesp, int flags, int mincount);
void foldOpenCursor (void);
int gchar_cursor (void);
int get_indent (void);
int set_indent (int size, int flags);
void line_breakcheck (void);
int linetabsize (char_u *s);
char_u *ml_get_curline (void);
int ml_replace (linenr_T lnum, char_u *line, int copy);
void redraw_curbuf_later (int type);
void scrolldown_clamp (void);
void scrollup_clamp (void);
void setmouse (void);
void showruler (int always);
extern int strncasecmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
void update_screen (int type);
void update_topline (void);
void validate_cursor (void);
int vim_isprintc (int c);
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
extern int need_check_timestamps ;
extern int did_check_timestamps ;
extern char_u e_sandbox[] ;
extern int global_busy ;
extern int intr_char ;
extern int need_start_insertmode ;
extern int no_u_sync ;
extern int p_im;
extern long p_so;
extern int sandbox ;
void add_pathsep (char_u *p);
void appended_lines_mark (linenr_T lnum, long count);
buf_T *buflist_findname (char_u *ffname);
char_u *check_nextcmd (char_u *p);
int check_restricted (void);
int check_secure (void);
int do_cmdline (char_u *cmdline, char_u *(*getline)(int, void *, int), void *cookie, int flags);
void ga_clear (garray_T *gap);
typedef struct expand
{
    int xp_context;
    char_u *xp_pattern;
    char_u *xp_arg;
    int xp_backslash;
} expand_T;
char_u *get_highlight_name (expand_T *xp, int idx);
char_u *getcmdline (int firstc, long count, int indent);
int mch_isdir (char_u *name);
void msg_clr_eos (void);
int msg_end (void);
void msg_prt_line (char_u *s);
void msg_starthere (void);
void msg_str (char_u *s, char_u *arg);
void set_option_value (char_u *name, long number, char_u *string, int opt_flags);
char_u *skiptowhite (char_u *p);
extern char *strstr (__const char *__haystack, __const char *__needle)
             __attribute__ ((__pure__));
int syn_id2attr (int hl_id);
int syntax_present (buf_T *buf);
int u_savesub (linenr_T lnum);
int vim_rename (char_u *from, char_u *to);
extern int did_filetype ;
extern char_u e_invarg2[] ;
extern int emsg_off ;
extern int lines_left ;
extern int msg_didout ;
extern int no_wait_return ;
extern long p_verbose;
void add_termcode (char_u *name, char_u *string, int use_8bit);
char_u *find_termcode (char_u *name);
char_u *alloc_check (unsigned size);
typedef struct
{
    char_u *vir_line;
    FILE *vir_fd;
} vir_T;
void viminfo_writestring (FILE *fd, char_u *p);
int viminfo_readline (vir_T *virp);
char_u *viminfo_readstring (vir_T *virp, int off, int convert);
extern int p_ed;
extern int p_gd;
extern long p_hh;
extern int p_warn;
extern int p_wa;
int read_viminfo_bufferlist (vir_T *virp, int writing);
void write_viminfo_bufferlist (FILE *fp);
void buf_addsign (buf_T *buf, int id, linenr_T lnum, int typenr);
int buf_change_sign_type (buf_T *buf, int markId, int typenr);
linenr_T buf_delsign (buf_T *buf, int id);
int buf_findsign (buf_T *buf, int id);
int buf_findsign_id (buf_T *buf, linenr_T lnum);
void buf_delete_all_signs (void);
void sign_list_placed (buf_T *rbuf);
int read_viminfo_varlist (vir_T *virp, int writing);
void write_viminfo_varlist (FILE *fp);
int not_writing (void);
int read_viminfo_sub_string (vir_T *virp, int force);
void write_viminfo_sub_string (FILE *fp);
void set_arglist (char_u *str);
void prepare_viminfo_history (int asklen);
int read_viminfo_history (vir_T *virp);
void finish_viminfo_history (void);
void write_viminfo_history (FILE *fp);
void write_lnum_adjust (linenr_T offset);
int read_viminfo_filemark (vir_T *virp, int force);
void write_viminfo_filemarks (FILE *fp);
int write_viminfo_marks (FILE *fp_out);
void copy_viminfo_marks (vir_T *virp, FILE *fp_out, int count, int eof);
linenr_T ml_firstmarked (void);
void appended_lines (linenr_T lnum, long count);
void deleted_lines (linenr_T lnum, long count);
void reset_VIsual (void);
int read_viminfo_register (vir_T *virp, int force);
void write_viminfo_registers (FILE *fp);
void check_buf_options (buf_T *buf);int bt_dontwrite_msg (buf_T *buf);
char_u *regtilde (char_u *source, int magic);
int vim_regsub_multi (regmmatch_T *rmp, linenr_T lnum, char_u *source, char_u *dest, int copy, int magic, int backslash);
void update_debug_sign (buf_T *buf, linenr_T lnum);
char_u *get_search_pat (void);
int read_viminfo_search_pattern (vir_T *virp, int force);
void write_viminfo_search_pattern (FILE *fp);
int u_inssub (linenr_T lnum);
void *gui_mch_register_sign (char_u *signfile);
void gui_mch_destroy_sign (void *sign);
void netbeans_file_opened (char *filename);
extern char_u *use_viminfo ;
extern char_u e_exists[] ;
extern char_u e_noprev[] ;
extern char_u e_notcreate[] ;
extern char_u e_positive[] ;
extern char_u e_readonly[] ;
typedef struct sign sign_T;
struct sign
{
    sign_T *sn_next;
    int sn_typenr;
    char_u *sn_name;
    char_u *sn_icon;
    void *sn_image;
    char_u *sn_text;
    int sn_line_hl;
    int sn_text_hl;
};
void do_shell (char_u *cmd, int flags);
void autowrite_all (void);
char_u *buf_modname (int shortname, char_u *fname, char_u *ext, int prepend_dot);
int buf_write_all (buf_T *buf, int forceit);
void dialog_msg (char_u *buff, char *format, char_u *fname);
extern int p_awa;
extern int p_write;
int check_changed (buf_T *buf, int checkaw, int mult_win, int forceit, int allbuf);
void do_argfile (exarg_T *eap, int argn);
int check_fname (void);
void check_lnums (int do_curwin);
extern __mode_t umask (__mode_t __mask) ;
extern int chown (__const char *__file, __uid_t __owner, __gid_t __group)
            ;
extern __gid_t getgid (void) ;
int mch_setperm (char_u *name, long perm);
void diff_invalidate (void);
int should_abort (int retcode);
void set_fileformat (int t, int opt_flags);
int default_fileformat (void);
void cursor_on (void);
void del_lines (long nlines, int undo);
char_u *make_filter_cmd (char_u *cmd, char_u *itmp, char_u *otmp);
int smsg_attr (int, char_u *, ...);
void deleted_lines_mark (linenr_T lnum, long count);
char_u *vim_getenv (char_u *name, int *mustfree);
int u_savedel (linenr_T lnum, long nlines);
void display_errors (void);
buf_T *setaltfname (char_u *ffname, char_u *sfname, linenr_T lnum);
void do_bang (int addr_count, exarg_T *eap, int forceit, int do_in, int do_out);
void print_line_no_prefix (linenr_T lnum, int use_number);
void print_line (linenr_T lnum, int use_number);
int do_write (exarg_T *eap);
void ex_append (exarg_T *eap);
void global_exe (char_u *cmd);
void not_exiting (void);
void ml_setmarked (linenr_T lnum);
void ml_clearmarked (void);
int vim_dialog_yesno (int type, char_u *title, char_u *message, int dflt);
extern int ex_no_reprint ;
extern char_u e_backslash[] ;
extern char_u e_curdir[] ;
extern char_u e_invcmd[] ;
extern char_u e_isadir2[] ;
extern char_u e_zerocount[] ;
int do_tag (char_u *tag, int type, int count, int forceit, int verbose);
void ex_next (exarg_T *eap);
void fileinfo (int fullname, int shorthelp, int dont_truncate);
int find_help_tags (char_u *arg, int *num_matches, char_u ***matches);
int gen_expand_wildcards (int num_pat, char_u **pat, int *num_file, char_u ***file, int flags);
int get_viminfo_parameter (int type);
extern __uid_t getuid (void) ;
void gotocmdline (int clr);
void invalidate_botline (void);
int messaging (void);void msgmore (long n);
int otherfile (char_u *ffname);
typedef int (*__compar_fn_t) (__const void *, __const void *);
extern void qsort (void *__base, size_t __nmemb, size_t __size,
                   __compar_fn_t __compar);
void redraw_later_clear (void);
int search_regcomp (char_u *pat, int pat_save, int pat_use, int options, regmmatch_T *regmatch);
extern char_u e_nopresub[] ;
extern char_u e_patnotf2[] ;
void set_buflisted (int on);
int setfname (char_u *ffname, char_u *sfname, int message);
char_u *skip_regexp (char_u *startp, int dirc, int magic, char_u **newp);
void sort_strings (char_u **files, int count);
void starttermcap (void);
void stoptermcap (void);
extern char *strncat (char *__restrict __dest, __const char *__restrict __src,
                      size_t __n) ;
int swapping_screen (void);
int syn_check_group (char_u *pp, int len);
void u_clearline (void);
int vim_fexists (char_u *fname);
extern char_u e_argreq[] ;
long vim_regexec_multi (regmmatch_T *rmp, win_T *win, buf_T *buf, linenr_T lnum, colnr_T col);
int viminfo_error (char *errnum, char *message, char_u *line);
void wait_return (int redraw);
void win_init (win_T *wp);
void win_setheight (int height);
void windgoto (int row, int col);
typedef __mode_t mode_t;
extern int autocmd_busy ;
extern int bangredo ;
extern char_u e_interr[] ;
extern char_u e_notmp[] ;
extern char_u e_notread[] ;
extern int exiting ;
extern int exmode_active ;
extern int g_do_tagpreview ;
extern int highlight_match ;
extern int keep_help_flag ;
extern char_u *p_hf;
extern char_u msg_buf[80];
extern int msg_didany ;
extern int msg_no_more ;
extern int msg_scrolled_ign ;
extern int msg_silent ;
extern int p_confirm;
extern char_u *p_ffs;
extern char_u *p_rtp;
extern char_u *p_sp;
extern char_u *p_shq;
extern int restricted ;
extern linenr_T search_match_lines;
extern colnr_T search_match_endcol;
extern int secure ;
extern int silent_mode ;
extern int skip_redraw ;
static int linelen (int *has_tab);
static void do_filter (linenr_T line1, linenr_T line2, exarg_T *eap, char_u *cmd, int do_in, int do_out);
static char_u *viminfo_filename (char_u *);
static void do_viminfo (FILE *fp_in, FILE *fp_out, int want_info, int want_marks, int force_read);
static int viminfo_encoding (vir_T *virp);
static int read_viminfo_up_to_marks (vir_T *virp, int forceit, int writing);
static int check_overwrite (exarg_T *eap, buf_T *buf, char_u *fname, char_u *ffname, int other);
static int check_readonly (int *forceit, buf_T *buf);
static void delbuf_msg (char_u *name);
static int do_sub_msg (void);
static int help_compare (const void *s1, const void *s2);
    void do_ascii(eap)
    exarg_T *eap;
{
    int c;
    char buf1[20];
    char buf2[20];
    char_u buf3[7];
        c = gchar_cursor();
    if (c == '\000')
    {
        msg((char_u *)("NUL"));
        return;
    }
    {
        if (c == '\012')
            c = '\000';
        if (vim_isprintc_strict(c) && (c < ' '
                    || c > '~'
                               ))
        {
            transchar_nonprint(buf3, c);
            sprintf(buf1, "  <%s>", (char *)buf3);
        }
        else
            buf1[0] = '\000';
        if (c >= 0x80)
            sprintf(buf2, "  <M-%s>", transchar(c & 0x7f));
        else
            buf2[0] = '\000';
        sprintf((char *)IObuff, ((char *)("<%s>%s%s  %d,  Hex %02x,  Octal %03o")),
                transchar(c), buf1, buf2, c, c, c);
    }
    msg(IObuff);
}
    void ex_align(eap)
    exarg_T *eap;
{
    pos_T save_curpos;
    int len;
    int indent = 0;
    int new_indent;
    int has_tab;
    int width;
    width = atoi((char *)eap->arg);
    save_curpos = curwin->w_cursor;
    if (eap->cmdidx == CMD_left)
    {
        if (width >= 0)
            indent = width;
    }
    else
    {
        if (width <= 0)
            width = curbuf->b_p_tw;
        if (width == 0 && curbuf->b_p_wm > 0)
            width = (curwin->w_width) - curbuf->b_p_wm;
        if (width <= 0)
            width = 80;
    }
    if (u_save((linenr_T)(eap->line1 - 1), (linenr_T)(eap->line2 + 1)) == 0)
        return;
    for (curwin->w_cursor.lnum = eap->line1;
                 curwin->w_cursor.lnum <= eap->line2; ++curwin->w_cursor.lnum)
    {
        if (eap->cmdidx == CMD_left)
            new_indent = indent;
        else
        {
            len = linelen(eap->cmdidx == CMD_right ? &has_tab
                                                   : ((void *)0)) - get_indent();
            if (len <= 0)
                continue;
            if (eap->cmdidx == CMD_center)
                new_indent = (width - len) / 2;
            else
            {
                new_indent = width - len;
                if (has_tab)
                    while (new_indent > 0)
                    {
                        (void)set_indent(new_indent, 0);
                        if (linelen(((void *)0)) <= width)
                        {
                            do
                                (void)set_indent(++new_indent, 0);
                            while (linelen(((void *)0)) <= width);
                            --new_indent;
                            break;
                        }
                        --new_indent;
                    }
            }
        }
        if (new_indent < 0)
            new_indent = 0;
        (void)set_indent(new_indent, 0);
    }
    changed_lines(eap->line1, 0, eap->line2 + 1, 0L);
    curwin->w_cursor = save_curpos;
    beginline(1 | 4);
}
    static int linelen(has_tab)
    int *has_tab;
{
    char_u *line;
    char_u *first;
    char_u *last;
    int save;
    int len;
    line = ml_get_curline();
    first = skipwhite(line);
    for (last = first + strlen((char *)(first));
                                last > first && ((last[-1]) == ' ' || (last[-1]) == '\t'); --last)
        ;
    save = *last;
    *last = '\000';
    len = linetabsize(line);
    if (has_tab != ((void *)0))
        *has_tab = (vim_strrchr(first, '\011') != ((void *)0));
    *last = save;
    return len;
}
    void ex_retab(eap)
    exarg_T *eap;
{
    linenr_T lnum;
    int got_tab = 0;
    long num_spaces = 0;
    long num_tabs;
    long len;
    long col;
    long vcol;
    long start_col = 0;
    long start_vcol = 0;
    int temp;
    long old_len;
    char_u *ptr;
    char_u *new_line = (char_u *)1;
    int did_undo;
    int new_ts;
    int save_list;
    linenr_T first_line = 0;
    linenr_T last_line = 0;
    save_list = curwin->w_onebuf_opt.wo_list;
    curwin->w_onebuf_opt.wo_list = 0;
    new_ts = getdigits(&(eap->arg));
    if (new_ts < 0)
    {
        emsg((char_u *)(((char *)(e_positive))));
        return;
    }
    if (new_ts == 0)
        new_ts = curbuf->b_p_ts;
    for (lnum = eap->line1; !got_int && lnum <= eap->line2; ++lnum)
    {
        ptr = ml_get(lnum);
        col = 0;
        vcol = 0;
        did_undo = 0;
        for (;;)
        {
            if (((ptr[col]) == ' ' || (ptr[col]) == '\t'))
            {
                if (!got_tab && num_spaces == 0)
                {
                    start_vcol = vcol;
                    start_col = col;
                }
                if (ptr[col] == ' ')
                    num_spaces++;
                else
                    got_tab = 1;
            }
            else
            {
                if (got_tab || (eap->forceit && num_spaces > 1))
                {
                    len = num_spaces = vcol - start_vcol;
                    num_tabs = 0;
                    if (!curbuf->b_p_et)
                    {
                        temp = new_ts - (start_vcol % new_ts);
                        if (num_spaces >= temp)
                        {
                            num_spaces -= temp;
                            num_tabs++;
                        }
                        num_tabs += num_spaces / new_ts;
                        num_spaces -= (num_spaces / new_ts) * new_ts;
                    }
                    if (curbuf->b_p_et || got_tab ||
                                        (num_spaces + num_tabs < len))
                    {
                        if (did_undo == 0)
                        {
                            did_undo = 1;
                            if (u_save((linenr_T)(lnum - 1),
                                                (linenr_T)(lnum + 1)) == 0)
                            {
                                new_line = ((void *)0);
                                break;
                            }
                        }
                        len = num_spaces + num_tabs;
                        old_len = (long)strlen((char *)(ptr));
                        new_line = lalloc(old_len - col + start_col + len + 1,
                                                                        1);
                        if (new_line == ((void *)0))
                            break;
                        if (start_col > 0)
                            memmove((char *)(new_line), (char *)(ptr), (size_t)start_col);
                        memmove((char *)(new_line + start_col + len), (char *)(ptr + col), (size_t)(old_len - col + 1));
                        ptr = new_line + start_col;
                        for (col = 0; col < len; col++)
                            ptr[col] = (col < num_tabs) ? '\t' : ' ';
                        ml_replace(lnum, new_line, 0);
                        if (first_line == 0)
                            first_line = lnum;
                        last_line = lnum;
                        ptr = new_line;
                        col = start_col + len;
                    }
                }
                got_tab = 0;
                num_spaces = 0;
            }
            if (ptr[col] == '\000')
                break;
            vcol += chartabsize(ptr + col, (colnr_T)vcol);
                ++col;
        }
        if (new_line == ((void *)0))
            break;
        line_breakcheck();
    }
    if (got_int)
        emsg((char_u *)(((char *)(e_interr))));
    if (curbuf->b_p_ts != new_ts)
        redraw_curbuf_later(40);
    if (first_line != 0)
        changed_lines(first_line, 0, last_line + 1, 0L);
    curwin->w_onebuf_opt.wo_list = save_list;
    curbuf->b_p_ts = new_ts;
    coladvance(curwin->w_curswant);
    u_clearline();
}
    int do_move(line1, line2, dest)
    linenr_T line1;
    linenr_T line2;
    linenr_T dest;
{
    char_u *str;
    linenr_T l;
    linenr_T extra;
    linenr_T num_lines;
    linenr_T last_line;
    if (dest >= line1 && dest < line2)
    {
        emsg((char_u *)(((char *)("E134: Move lines into themselves"))));
        return 0;
    }
    num_lines = line2 - line1 + 1;
    if (u_save(dest, dest + 1) == 0)
        return 0;
    for (extra = 0, l = line1; l <= line2; l++)
    {
        str = vim_strsave(ml_get(l + extra));
        if (str != ((void *)0))
        {
            ml_append(dest + l - line1, str, (colnr_T)0, 0);
            vim_free(str);
            if (dest < line1)
                extra++;
        }
    }
    last_line = curbuf->b_ml.ml_line_count;
    mark_adjust(line1, line2, last_line - line2, 0L);
    if (dest >= line2)
    {
        mark_adjust(line2 + 1, dest, -num_lines, 0L);
        curbuf->b_op_start.lnum = dest - num_lines + 1;
        curbuf->b_op_end.lnum = dest;
    }
    else
    {
        mark_adjust(dest + 1, line1 - 1, num_lines, 0L);
        curbuf->b_op_start.lnum = dest + 1;
        curbuf->b_op_end.lnum = dest + num_lines;
    }
    curbuf->b_op_start.col = curbuf->b_op_end.col = 0;
    mark_adjust(last_line - num_lines + 1, last_line,
                                             -(last_line - dest - extra), 0L);
    if (u_save(line1 + extra - 1, line2 + extra + 1) == 0)
        return 0;
    for (l = line1; l <= line2; l++)
        ml_delete(line1 + extra, 1);
    if (!global_busy && num_lines > p_report)
    {
        if (num_lines == 1)
            msg((char_u *)(((char *)("1 line moved"))));
        else
            smsg((char_u *)((char *)("%ld lines moved")), num_lines);
    }
    if (dest >= line1)
        curwin->w_cursor.lnum = dest;
    else
        curwin->w_cursor.lnum = dest + (line2 - line1) + 1;
    if (line1 < dest)
        changed_lines(line1, 0, dest + num_lines + 1, 0L);
    else
        changed_lines(dest + 1, 0, line1 + num_lines, 0L);
    return 1;
}
    void ex_copy(line1, line2, n)
    linenr_T line1;
    linenr_T line2;
    linenr_T n;
{
    linenr_T count;
    char_u *p;
    count = line2 - line1 + 1;
    curbuf->b_op_start.lnum = n + 1;
    curbuf->b_op_end.lnum = n + count;
    curbuf->b_op_start.col = curbuf->b_op_end.col = 0;
    if (u_save(n, n + 1) == 0)
        return;
    curwin->w_cursor.lnum = n;
    while (line1 <= line2)
    {
        p = vim_strsave(ml_get(line1));
        if (p != ((void *)0))
        {
            ml_append(curwin->w_cursor.lnum, p, (colnr_T)0, 0);
            vim_free(p);
        }
        if (line1 == n)
            line1 = curwin->w_cursor.lnum;
        ++line1;
        if (curwin->w_cursor.lnum < line1)
            ++line1;
        if (curwin->w_cursor.lnum < line2)
            ++line2;
        ++curwin->w_cursor.lnum;
    }
    appended_lines_mark(n, count);
    msgmore((long)count);
}
    void do_bang(addr_count, eap, forceit, do_in, do_out)
    int addr_count;
    exarg_T *eap;
    int forceit;
    int do_in, do_out;
{
    char_u *arg = eap->arg;
    linenr_T line1 = eap->line1;
    linenr_T line2 = eap->line2;
    static char_u *prevcmd = ((void *)0);
    char_u *newcmd = ((void *)0);
    int free_newcmd = 0;
    int ins_prevcmd;
    char_u *t;
    char_u *p;
    char_u *trailarg;
    int len;
    int scroll_save = msg_scroll;
    if (check_restricted() || check_secure())
        return;
    if (addr_count == 0)
    {
        msg_scroll = 0;
        autowrite_all();
        msg_scroll = scroll_save;
    }
    ins_prevcmd = forceit;
    trailarg = arg;
    do
    {
        len = (int)strlen((char *)(trailarg)) + 1;
        if (newcmd != ((void *)0))
            len += (int)strlen((char *)(newcmd));
        if (ins_prevcmd)
        {
            if (prevcmd == ((void *)0))
            {
                emsg((char_u *)(((char *)(e_noprev))));
                vim_free(newcmd);
                return;
            }
            len += (int)strlen((char *)(prevcmd));
        }
        if ((t = alloc(len)) == ((void *)0))
        {
            vim_free(newcmd);
            return;
        }
        *t = '\000';
        if (newcmd != ((void *)0))
            strcat((char *)(t), (char *)(newcmd));
        if (ins_prevcmd)
            strcat((char *)(t), (char *)(prevcmd));
        p = t + strlen((char *)(t));
        strcat((char *)(t), (char *)(trailarg));
        vim_free(newcmd);
        newcmd = t;
        trailarg = ((void *)0);
        while (*p)
        {
            if (*p == '!'
                                        )
            {
                if (p > newcmd && p[-1] == '\\')
                    memmove((char *)(p - 1), (char *)(p), (size_t)(strlen((char *)(p)) + 1));
                else
                {
                    trailarg = p;
                    *trailarg++ = '\000';
                    ins_prevcmd = 1;
                    break;
                }
            }
            ++p;
        }
    } while (trailarg != ((void *)0));
    vim_free(prevcmd);
    prevcmd = newcmd;
    if (bangredo)
    {
        AppendToRedobuffLit(prevcmd);
        AppendToRedobuff((char_u *)"\n");
        bangredo = 0;
    }
    if (*p_shq != '\000')
    {
        newcmd = alloc((unsigned)(strlen((char *)(prevcmd)) + 2 * strlen((char *)(p_shq)) + 1));
        if (newcmd == ((void *)0))
            return;
        strcpy((char *)(newcmd), (char *)(p_shq));
        strcat((char *)(newcmd), (char *)(prevcmd));
        strcat((char *)(newcmd), (char *)(p_shq));
        free_newcmd = 1;
    }
    if (addr_count == 0)
    {
        msg_start();
        msg_putchar(':');
        msg_putchar('!');
        msg_outtrans(newcmd);
        msg_clr_eos();
        windgoto(msg_row, msg_col);
        do_shell(newcmd, 0);
    }
    else
        do_filter(line1, line2, eap, newcmd, do_in, do_out);
    if (free_newcmd)
        vim_free(newcmd);
}
    static void do_filter(line1, line2, eap, cmd, do_in, do_out)
    linenr_T line1, line2;
    exarg_T *eap;
    char_u *cmd;
    int do_in, do_out;
{
    char_u *itmp = ((void *)0);
    char_u *otmp = ((void *)0);
    linenr_T linecount;
    pos_T cursor_save;
    char_u *cmd_buf;
    buf_T *old_curbuf = curbuf;
    if (*cmd == '\000')
        return;
    cursor_save = curwin->w_cursor;
    linecount = line2 - line1 + 1;
    curwin->w_cursor.lnum = line1;
    curwin->w_cursor.col = 0;
    changed_line_abv_curs();
    invalidate_botline();
    if ((do_in && (itmp = vim_tempname('i')) == ((void *)0))
            || (do_out && (otmp = vim_tempname('o')) == ((void *)0)))
    {
        emsg((char_u *)(((char *)(e_notmp))));
        goto filterend;
    }
    ++no_wait_return;
    if (do_in && buf_write(curbuf, itmp, ((void *)0), line1, line2, eap,
                                           0, 0, 0, 1) == 0)
    {
        msg_putchar('\n');
        --no_wait_return;
        if (!aborting())
            (void)emsg2((char_u *)(((char *)(e_notcreate))), (char_u *)(itmp));
        goto filterend;
    }
    if (curbuf != old_curbuf)
        goto filterend;
    if (!do_out)
        msg_putchar('\n');
    cmd_buf = make_filter_cmd(cmd, itmp, otmp);
    if (cmd_buf == ((void *)0))
        goto filterend;
    windgoto((int)Rows - 1, 0);
    cursor_on();
    if (!do_out || strcmp((char *)(p_srr), (char *)(">")) == 0 || !do_in)
        redraw_later_clear();
    if (call_shell(cmd_buf, 1 | 4
                                                | (do_out ? 8 : 0)))
    {
        redraw_later_clear();
        wait_return(0);
    }
    vim_free(cmd_buf);
    did_check_timestamps = 0;
    need_check_timestamps = 1;
    ui_breakcheck();
    got_int = 0;
    if (do_out)
    {
        if (u_save((linenr_T)(line2), (linenr_T)(line2 + 1)) == 0)
            goto error;
        redraw_curbuf_later(10);
        if (readfile(otmp, ((void *)0), line2, (linenr_T)0, (linenr_T)(0x7fffffffL), eap,
                                                         0x02) == 0)
        {
            if (!aborting())
            {
                msg_putchar('\n');
                emsg2((char_u *)(((char *)(e_notread))), (char_u *)(otmp));
            }
            goto error;
        }
        if (curbuf != old_curbuf)
            goto filterend;
        if (do_in)
        {
            curwin->w_cursor.lnum = line1;
            del_lines(linecount, 1);
            curbuf->b_op_start.lnum -= linecount;
            curbuf->b_op_end.lnum -= linecount;
            write_lnum_adjust(-linecount);
        }
        else
        {
            curwin->w_cursor.lnum = curbuf->b_op_end.lnum;
            linecount = curbuf->b_op_end.lnum - curbuf->b_op_start.lnum + 1;
        }
        beginline(1 | 4);
        --no_wait_return;
        if (linecount > p_report)
        {
            if (do_in)
            {
                sprintf((char *)msg_buf, ((char *)("%ld lines filtered")),
                                                             (long)linecount);
                if (msg(msg_buf) && !msg_scroll)
                {
                    set_keep_msg(msg_buf);
                    keep_msg_attr = 0;
                }
            }
            else
                msgmore((long)linecount);
        }
    }
    else
    {
error:
        curwin->w_cursor = cursor_save;
        --no_wait_return;
        wait_return(0);
    }
filterend:
    if (curbuf != old_curbuf)
    {
        --no_wait_return;
        emsg((char_u *)(((char *)("E135: *Filter* Autocommands must not change current buffer"))));
    }
    if (itmp != ((void *)0))
        unlink((char *)(itmp));
    if (otmp != ((void *)0))
        unlink((char *)(otmp));
    vim_free(itmp);
    vim_free(otmp);
}
    void do_shell(cmd, flags)
    char_u *cmd;
    int flags;
{
    buf_T *buf;
    int save_nwr;
    if (check_restricted() || check_secure())
    {
        msg_end();
        return;
    }
    msg_putchar('\r');
    if (!autocmd_busy)
    {
            stoptermcap();
    }
        msg_putchar('\n');
    if (p_warn
                && !autocmd_busy
                && msg_silent == 0)
        for (buf = firstbuf; buf; buf = buf->b_next)
            if (bufIsChanged(buf))
            {
                msg_puts((char_u *)(((char *)("[No write since last change]\n"))));
                break;
            }
    if (!swapping_screen())
        windgoto(msg_row, msg_col);
    cursor_on();
    (void)call_shell(cmd, 4 | flags);
    did_check_timestamps = 0;
    need_check_timestamps = 1;
    if (!swapping_screen())
    {
        msg_row = Rows - 1;
        msg_col = 0;
    }
    if (autocmd_busy)
    {
        if (msg_silent == 0)
            redraw_later_clear();
    }
    else
    {
        if (cmd == ((void *)0)
           )
        {
            if (msg_silent == 0)
                redraw_later_clear();
            need_wait_return = 0;
        }
        else
        {
            save_nwr = no_wait_return;
            if (swapping_screen())
                no_wait_return = 0;
            wait_return(msg_silent == 0);
            no_wait_return = save_nwr;
        }
            starttermcap();
    }
    display_errors();
}
    char_u * make_filter_cmd(cmd, itmp, otmp)
    char_u *cmd;
    char_u *itmp;
    char_u *otmp;
{
    char_u *buf;
    long_u len;
    len = (long_u)strlen((char *)(cmd)) + 3;
    if (itmp != ((void *)0))
        len += (long_u)strlen((char *)(itmp)) + 9;
    if (otmp != ((void *)0))
        len += (long_u)strlen((char *)(otmp)) + (long_u)strlen((char *)(p_srr)) + 2;
    buf = lalloc(len, 1);
    if (buf == ((void *)0))
        return ((void *)0);
    sprintf((char *)buf, "(%s)", (char *)cmd);
    if (itmp != ((void *)0))
    {
        strcat((char *)(buf), (char *)(" < "));
        strcat((char *)(buf), (char *)(itmp));
    }
    if (otmp != ((void *)0))
        append_redir(buf, p_srr, otmp);
    return buf;
}
    void append_redir(buf, opt, fname)
    char_u *buf;
    char_u *opt;
    char_u *fname;
{
    char_u *p;
    buf += strlen((char *)(buf));
    for (p = opt; (p = vim_strchr(p, '%')) != ((void *)0); ++p)
        if (p[1] == 's')
            break;
    if (p != ((void *)0))
    {
        *buf = ' ';
        sprintf((char *)buf + 1, (char *)opt, (char *)fname);
    }
    else
        sprintf((char *)buf,
                opt != p_sp ? " %s%s" :
                " %s %s",
                (char *)opt, (char *)fname);
}
static int no_viminfo (void);
static int viminfo_errcnt;
    static int no_viminfo()
{
    return (use_viminfo != ((void *)0) && strcmp((char *)(use_viminfo), (char *)("NONE")) == 0);
}
    int viminfo_error(errnum, message, line)
    char *errnum;
    char *message;
    char_u *line;
{
    sprintf((char *)IObuff, ((char *)("%sviminfo: %s in line: ")), errnum, message);
    strncat((char *)(IObuff), (char *)(line), (size_t)((1024+1) - strlen((char *)(IObuff))));
    emsg(IObuff);
    if (++viminfo_errcnt >= 10)
    {
        emsg((char_u *)(((char *)("E136: viminfo: Too many errors, skipping rest of file"))));
        return 1;
    }
    return 0;
}
    int read_viminfo(file, want_info, want_marks, forceit)
    char_u *file;
    int want_info;
    int want_marks;
    int forceit;
{
    FILE *fp;
    char_u *fname;
    if (no_viminfo())
        return 0;
    fname = viminfo_filename(file);
    if (fname == ((void *)0))
        return 0;
    fp = fopen(((char *)fname), ("r"));
    if (p_verbose > 0)
    {
        char_u *s;
        s = fname;
        if (strlen((char *)(fname)) > (1024+1) - 100)
            s = fname + strlen((char *)(fname)) - ((1024+1) - 100);
        smsg((char_u *)((char *)("Reading viminfo file \"%s\"%s%s%s")), s,
                    want_info ? ((char *)(" info")) : "",
                    want_marks ? ((char *)(" marks")) : "",
                    fp == ((void *)0) ? ((char *)(" FAILED")) : "");
    }
    vim_free(fname);
    if (fp == ((void *)0))
        return 0;
    viminfo_errcnt = 0;
    do_viminfo(fp, ((void *)0), want_info, want_marks, forceit);
    fclose(fp);
    return 1;
}
    void write_viminfo(file, forceit)
    char_u *file;
    int forceit;
{
    char_u *fname;
    FILE *fp_in = ((void *)0);
    FILE *fp_out = ((void *)0);
    char_u *tempname = ((void *)0);
    struct stat st_new;
    char_u *wp;
    mode_t umask_save;
    int shortname = 0;
    struct stat st_old;
    if (no_viminfo())
        return;
    fname = viminfo_filename(file);
    if (fname == ((void *)0))
        return;
    fp_in = fopen(((char *)fname), ("r"));
    if (fp_in == ((void *)0))
    {
        if (stat(((char *)fname), (&st_new)) == 0)
            goto end;
        umask_save = umask(077);
        fp_out = fopen(((char *)fname), ("w"));
        (void)umask(umask_save);
    }
    else
    {
        st_old.st_dev = st_old.st_ino = 0;
        st_old.st_mode = 0600;
        if (stat(((char *)fname), (&st_old)) == 0 && getuid() &&
                !(st_old.st_uid == getuid()
                        ? (st_old.st_mode & 0200)
                        : (st_old.st_gid == getgid()
                                ? (st_old.st_mode & 0020)
                                : (st_old.st_mode & 0002))))
        {
            int tt;
            tt = msg_didany;
            emsg2((char_u *)(((char *)("E137: Viminfo file is not writable: %s"))), (char_u *)(fname));
            msg_didany = tt;
            goto end;
        }
        for (;;)
        {
            tempname = buf_modname(
                                    shortname,
                                    fname,
                                    (char_u *)".tmp",
                                    0);
            if (tempname == ((void *)0))
                break;
            if (stat(((char *)tempname), (&st_new)) == 0)
            {
                if (!shortname && st_new.st_dev == st_old.st_dev &&
                        st_new.st_ino == st_old.st_ino)
                {
                    vim_free(tempname);
                    tempname = ((void *)0);
                    shortname = 1;
                    continue;
                }
                wp = tempname + strlen((char *)(tempname)) - 5;
                if (wp < gettail(tempname))
                    wp = gettail(tempname);
                for (*wp = 'z'; stat(((char *)tempname), (&st_new)) == 0;
                                                                    --*wp)
                {
                    if (*wp == 'a')
                    {
                        vim_free(tempname);
                        tempname = ((void *)0);
                        break;
                    }
                }
            }
            break;
        }
        if (tempname != ((void *)0))
        {
            fp_out = fopen(((char *)tempname), ("w"));
            if (fp_out == ((void *)0))
            {
                vim_free(tempname);
                if ((tempname = vim_tempname('o')) != ((void *)0))
                    fp_out = fopen(((char *)tempname), ("w"));
            }
            if (fp_out != ((void *)0))
            {
                (void)mch_setperm(tempname,
                                  (long)((st_old.st_mode & 0777) | 0600));
                (void)chown((char *)tempname, st_old.st_uid, st_old.st_gid);
            }
        }
    }
    if (fp_out == ((void *)0))
    {
        emsg2((char_u *)(((char *)("E138: Can't write viminfo file %s!"))), (char_u *)(fp_in == ((void *)0) ? fname : tempname));
        if (fp_in != ((void *)0))
            fclose(fp_in);
        goto end;
    }
    if (p_verbose > 0)
        msg_str((char_u *)((char *)("Writing viminfo file \"%s\"")), fname);
    viminfo_errcnt = 0;
    do_viminfo(fp_in, fp_out, !forceit, !forceit, 0);
    fclose(fp_out);
    if (fp_in != ((void *)0))
    {
        fclose(fp_in);
        if (viminfo_errcnt || vim_rename(tempname, fname) == -1)
            unlink((char *)(tempname));
    }
end:
    vim_free(fname);
    vim_free(tempname);
}
    static char_u * viminfo_filename(file)
    char_u *file;
{
    if (file == ((void *)0) || *file == '\000')
    {
        if (use_viminfo != ((void *)0))
            file = use_viminfo;
        else if ((file = find_viminfo_parameter('n')) == ((void *)0) || *file == '\000')
        {
                file = (char_u *)"$HOME/.viminfo";
        }
        expand_env(file, NameBuff, 1024);
        file = NameBuff;
    }
    return vim_strsave(file);
}
    static void do_viminfo(fp_in, fp_out, want_info, want_marks, force_read)
    FILE *fp_in;
    FILE *fp_out;
    int want_info;
    int want_marks;
    int force_read;
{
    int count = 0;
    int eof = 0;
    vir_T vir;
    if ((vir.vir_line = alloc(512)) == ((void *)0))
        return;
    vir.vir_fd = fp_in;
    if (fp_in != ((void *)0))
    {
        if (want_info)
            eof = read_viminfo_up_to_marks(&vir, force_read, fp_out != ((void *)0));
        else
            while (!(eof = viminfo_readline(&vir))
                    && vir.vir_line[0] != '>')
                ;
    }
    if (fp_out != ((void *)0))
    {
        fprintf(fp_out, ((char *)("# This viminfo file was generated by Vim %s.\n")),
                                                          "6.2");
        fprintf(fp_out, ((char *)("# You may edit it if you're careful!\n\n")));
        write_viminfo_search_pattern(fp_out);
        write_viminfo_sub_string(fp_out);
        write_viminfo_history(fp_out);
        write_viminfo_registers(fp_out);
        write_viminfo_varlist(fp_out);
        write_viminfo_filemarks(fp_out);
        write_viminfo_bufferlist(fp_out);
        count = write_viminfo_marks(fp_out);
    }
    if (fp_in != ((void *)0) && want_marks)
        copy_viminfo_marks(&vir, fp_out, count, eof);
    vim_free(vir.vir_line);
}
    static int read_viminfo_up_to_marks(virp, forceit, writing)
    vir_T *virp;
    int forceit;
    int writing;
{
    int eof;
    buf_T *buf;
    prepare_viminfo_history(forceit ? 9999 : 0);
    eof = viminfo_readline(virp);
    while (!eof && virp->vir_line[0] != '>')
    {
        switch (virp->vir_line[0])
        {
            case '+':
            case '|':
            case '^':
            case '<':
            case '\000':
            case '\r':
            case '\n':
            case '#':
                eof = viminfo_readline(virp);
                break;
            case '*':
                eof = viminfo_encoding(virp);
                break;
            case '!':
                eof = read_viminfo_varlist(virp, writing);
                break;
            case '%':
                eof = read_viminfo_bufferlist(virp, writing);
                break;
            case '"':
                eof = read_viminfo_register(virp, forceit);
                break;
            case '/':
            case '&':
            case '~':
                eof = read_viminfo_search_pattern(virp, forceit);
                break;
            case '$':
                eof = read_viminfo_sub_string(virp, forceit);
                break;
            case ':':
            case '?':
            case '=':
            case '@':
                eof = read_viminfo_history(virp);
                break;
            case '-':
            case '\'':
                eof = read_viminfo_filemark(virp, forceit);
                break;
            default:
                if (viminfo_error("E575: ", ((char *)("Illegal starting char")),
                            virp->vir_line))
                    eof = 1;
                else
                    eof = viminfo_readline(virp);
                break;
        }
    }
    finish_viminfo_history();
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
        fmarks_check_names(buf);
    return eof;
}
    static int viminfo_encoding(virp)
    vir_T *virp;
{
    return viminfo_readline(virp);
}
    int viminfo_readline(virp)
    vir_T *virp;
{
    return vim_fgets(virp->vir_line, 512, virp->vir_fd);
}
    char_u * viminfo_readstring(virp, off, convert)
    vir_T *virp;
    int off;
    int convert;
{
    char_u *retval;
    char_u *s, *d;
    long len;
    if (virp->vir_line[off] == 22 && (__ctype_b[(int) ((virp->vir_line[off + 1]))] & (unsigned short int) _ISdigit))
    {
        len = atol((char *)virp->vir_line + off + 1);
        retval = lalloc(len, 1);
        if (retval == ((void *)0))
        {
            (void)vim_fgets(virp->vir_line, 10, virp->vir_fd);
            return ((void *)0);
        }
        (void)vim_fgets(retval, (int)len, virp->vir_fd);
        s = retval + 1;
    }
    else
    {
        retval = vim_strsave(virp->vir_line + off);
        if (retval == ((void *)0))
            return ((void *)0);
        s = retval;
    }
    d = retval;
    while (*s != '\000' && *s != '\n')
    {
        if (s[0] == 22 && s[1] != '\000')
        {
            if (s[1] == 'n')
                *d++ = '\n';
            else
                *d++ = 22;
            s += 2;
        }
        else
            *d++ = *s++;
    }
    *d = '\000';
    return retval;
}
    void viminfo_writestring(fd, p)
    FILE *fd;
    char_u *p;
{
    int c;
    char_u *s;
    int len = 0;
    for (s = p; *s != '\000'; ++s)
    {
        if (*s == 22 || *s == '\n')
            ++len;
        ++len;
    }
    if (len > 512 / 2)
        fprintf(fd, "\026%d\n<", len + 3);
    while ((c = *p++) != '\000')
    {
        if (c == 22 || c == '\n')
        {
            _IO_putc (22, fd);
            if (c == '\n')
                c = 'n';
        }
        _IO_putc (c, fd);
    }
    _IO_putc ('\n', fd);
}
    void do_fixdel(eap)
    exarg_T *eap;
{
    char_u *p;
    p = find_termcode((char_u *)"kb");
    add_termcode((char_u *)"kD", p != ((void *)0)
            && *p == 0x7f ? (char_u *)"\010" : (char_u *)"\177", 0);
}
    void print_line_no_prefix(lnum, use_number)
    linenr_T lnum;
    int use_number;
{
    char_u numbuf[20];
    if (curwin->w_onebuf_opt.wo_nu || use_number)
    {
        sprintf((char *)numbuf, "%7ld ", (long)lnum);
        msg_puts_attr(numbuf, highlight_attr[(int)(HLF_N)]);
    }
    msg_prt_line(ml_get(lnum));
}
    void print_line(lnum, use_number)
    linenr_T lnum;
    int use_number;
{
    int save_silent = silent_mode;
    silent_mode = 0;
    msg_start();
    print_line_no_prefix(lnum, use_number);
    if (save_silent)
    {
        msg_putchar('\n');
        cursor_on();
        out_flush();
        silent_mode = save_silent;
    }
}
    void ex_file(eap)
    exarg_T *eap;
{
    char_u *fname, *sfname, *xfname;
    buf_T *buf;
    if (*eap->arg != '\000')
    {
        buf = curbuf;
        apply_autocmds(EVENT_BUFFILEPRE, ((void *)0), ((void *)0), 0, curbuf);
        if (buf != curbuf)
            return;
        if (aborting())
            return;
        fname = curbuf->b_ffname;
        sfname = curbuf->b_sfname;
        xfname = curbuf->b_fname;
        curbuf->b_ffname = ((void *)0);
        curbuf->b_sfname = ((void *)0);
        if (setfname(eap->arg, ((void *)0), 1) == 0)
        {
            curbuf->b_ffname = fname;
            curbuf->b_sfname = sfname;
            return;
        }
        curbuf->b_flags |= 0x08;
        buf = buflist_new(fname, xfname, curwin->w_cursor.lnum, 0);
        if (buf != ((void *)0))
            curwin->w_alt_fnum = buf->b_fnum;
        vim_free(fname);
        vim_free(sfname);
        apply_autocmds(EVENT_BUFFILEPOST, ((void *)0), ((void *)0), 0, curbuf);
    }
    fileinfo(0, 0, eap->forceit);
}
    void ex_update(eap)
    exarg_T *eap;
{
    if (curbufIsChanged())
        (void)do_write(eap);
}
    void ex_write(eap)
    exarg_T *eap;
{
    if (eap->usefilter)
        do_bang(1, eap, 0, 1, 0);
    else
        (void)do_write(eap);
}
    int do_write(eap)
    exarg_T *eap;
{
    int other;
    char_u *fname = ((void *)0);
    char_u *ffname;
    int retval = 0;
    char_u *free_fname = ((void *)0);
    char_u *browse_file = ((void *)0);
    buf_T *alt_buf = ((void *)0);
    if (not_writing())
        return 0;
    ffname = eap->arg;
    if (cmdmod.browse)
    {
        browse_file = do_browse(1, (char_u *)((char *)("Save As")), ffname,
                                                    ((void *)0), ((void *)0), ((void *)0), curbuf);
        if (browse_file == ((void *)0))
            goto theend;
        ffname = browse_file;
    }
    if (*ffname == '\000')
    {
        if (eap->cmdidx == CMD_saveas)
        {
            emsg((char_u *)(((char *)(e_argreq))));
            goto theend;
        }
        other = 0;
    }
    else
    {
        fname = ffname;
        free_fname = fix_fname(ffname);
        if (free_fname != ((void *)0))
            ffname = free_fname;
        other = otherfile(ffname);
    }
    if (other)
    {
        if (vim_strchr(p_cpo, 'A') != ((void *)0)
                                                 || eap->cmdidx == CMD_saveas)
            alt_buf = setaltfname(ffname, fname, (linenr_T)1);
        else
            alt_buf = buflist_findname(ffname);
        if (alt_buf != ((void *)0) && alt_buf->b_ml.ml_mfp != ((void *)0))
        {
            emsg((char_u *)(((char *)("E139: File is loaded in another buffer"))));
            goto theend;
        }
    }
    if (!other && (
                bt_dontwrite_msg(curbuf) ||
                check_fname() == 0 || check_readonly(&eap->forceit, curbuf)))
        goto theend;
    if (!other)
    {
        ffname = curbuf->b_ffname;
        fname = curbuf->b_fname;
        if ( (eap->line1 != 1
                    || eap->line2 != curbuf->b_ml.ml_line_count)
                && !eap->forceit
                && !eap->append
                && !p_wa)
        {
            if (p_confirm || cmdmod.confirm)
            {
                if (vim_dialog_yesno(4, ((void *)0),
                               (char_u *)((char *)("Write partial file?")), 2) != 2)
                    goto theend;
                eap->forceit = 1;
            }
            else
            {
                emsg((char_u *)(((char *)("E140: Use ! to write partial buffer"))));
                goto theend;
            }
        }
    }
    if (check_overwrite(eap, curbuf, fname, ffname, other) == 1)
    {
        if (eap->cmdidx == CMD_saveas && alt_buf != ((void *)0))
        {
            buf_T *was_curbuf = curbuf;
            apply_autocmds(EVENT_BUFFILEPRE, ((void *)0), ((void *)0), 0, curbuf);
            if (curbuf != was_curbuf || aborting())
            {
                retval = 0;
                goto theend;
            }
            fname = alt_buf->b_fname;
            alt_buf->b_fname = curbuf->b_fname;
            curbuf->b_fname = fname;
            fname = alt_buf->b_ffname;
            alt_buf->b_ffname = curbuf->b_ffname;
            curbuf->b_ffname = fname;
            fname = alt_buf->b_sfname;
            alt_buf->b_sfname = curbuf->b_sfname;
            curbuf->b_sfname = fname;
            buf_name_changed();
            apply_autocmds(EVENT_BUFFILEPOST, ((void *)0), ((void *)0), 0, curbuf);
            if (!alt_buf->b_p_bl)
            {
                alt_buf->b_p_bl = 1;
                apply_autocmds(EVENT_BUFADD, ((void *)0), ((void *)0), 0, alt_buf);
            }
            if (curbuf != was_curbuf || aborting())
            {
                retval = 0;
                goto theend;
            }
        }
        retval = buf_write(curbuf, ffname, fname, eap->line1, eap->line2,
                                 eap, eap->append, eap->forceit, 1, 0);
    }
theend:
    vim_free(browse_file);
    vim_free(free_fname);
    return retval;
}
    static int check_overwrite(eap, buf, fname, ffname, other)
    exarg_T *eap;
    buf_T *buf;
    char_u *fname;
    char_u *ffname;
    int other;
{
    if ( (other
                || (buf->b_flags & 0x08)
                || ((buf->b_flags & 0x10)
                    && vim_strchr(p_cpo, 'O') == ((void *)0))
                || (buf->b_flags & 0x40))
            && !eap->forceit
            && !eap->append
            && !p_wa
            && vim_fexists(ffname))
    {
        if (mch_isdir(ffname))
        {
            emsg2((char_u *)(((char *)(e_isadir2))), (char_u *)(ffname));
            return 0;
        }
        if (p_confirm || cmdmod.confirm)
        {
            char_u buff[(1024+1)];
            dialog_msg(buff, ((char *)("Overwrite existing file \"%.*s\"?")), fname);
            if (vim_dialog_yesno(4, ((void *)0), buff, 2) != 2)
                return 0;
            eap->forceit = 1;
        }
        else
        {
            emsg((char_u *)(((char *)(e_exists))));
            return 0;
        }
    }
    return 1;
}
    void ex_wnext(eap)
    exarg_T *eap;
{
    int i;
    if (eap->cmd[1] == 'n')
        i = curwin->w_arg_idx + (int)eap->line2;
    else
        i = curwin->w_arg_idx - (int)eap->line2;
    eap->line1 = 1;
    eap->line2 = curbuf->b_ml.ml_line_count;
    if (do_write(eap) != 0)
        do_argfile(eap, i);
}
    void do_wqall(eap)
    exarg_T *eap;
{
    buf_T *buf;
    int error = 0;
    if (eap->cmdidx == CMD_xall || eap->cmdidx == CMD_wqall)
        exiting = 1;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
    {
        if (bufIsChanged(buf))
        {
            if (not_writing())
            {
                ++error;
                break;
            }
            if (buf->b_ffname == ((void *)0) && cmdmod.browse)
                buf->b_ffname = do_browse(1, (char_u *)((char *)("Save As")), ((void *)0),
                                                       ((void *)0), ((void *)0), ((void *)0), buf);
            if (buf->b_ffname == ((void *)0))
            {
                emsgn((char_u *)(((char *)("E141: No file name for buffer %ld"))), (long)((long)buf->b_fnum));
                ++error;
            }
            else if (check_readonly(&eap->forceit, buf)
                    || check_overwrite(eap, buf, buf->b_fname, buf->b_ffname,
                                                               0) == 0)
            {
                ++error;
            }
            else
            {
                if (buf_write_all(buf, eap->forceit) == 0)
                    ++error;
                if (!buf_valid(buf))
                    buf = firstbuf;
            }
        }
    }
    if (exiting)
    {
        if (!error)
            getout(0);
        not_exiting();
    }
}
    int not_writing()
{
    if (p_write)
        return 0;
    emsg((char_u *)(((char *)("E142: File not written: Writing is disabled by 'write' option"))));
    return 1;
}
    static int check_readonly(forceit, buf)
    int *forceit;
    buf_T *buf;
{
    if (!*forceit && buf->b_p_ro)
    {
        if ((p_confirm || cmdmod.confirm) && buf->b_fname != ((void *)0))
        {
            char_u buff[(1024+1)];
            dialog_msg(buff, ((char *)("'readonly' option is set for \"%.*s\".\nDo you wish to write anyway?")),
                    buf->b_fname);
            if (vim_dialog_yesno(4, ((void *)0), buff, 2) == 2)
            {
                *forceit = 1;
                return 0;
            }
            else
                return 1;
        }
        else
            emsg((char_u *)(((char *)(e_readonly))));
        return 1;
    }
    return 0;
}
    int getfile(fnum, ffname, sfname, setpm, lnum, forceit)
    int fnum;
    char_u *ffname;
    char_u *sfname;
    int setpm;
    linenr_T lnum;
    int forceit;
{
    int other;
    int retval;
    char_u *free_me = ((void *)0);
    if (cmdwin_type != 0)
        return 1;
    if (fnum == 0)
    {
        fname_expand(&ffname, &sfname);
        other = otherfile(ffname);
        free_me = ffname;
    }
    else
        other = (fnum != curbuf->b_fnum);
    if (other)
        ++no_wait_return;
    if (other && !forceit && curbuf->b_nwindows == 1 && !(buf_hide(curbuf))
                   && curbufIsChanged() && autowrite(curbuf, forceit) == 0)
    {
        if (other)
            --no_wait_return;
        emsg((char_u *)(((char *)(e_nowrtmsg))));
        retval = 2;
        goto theend;
    }
    if (other)
        --no_wait_return;
    if (setpm)
        setpcmark();
    if (!other)
    {
        if (lnum != 0)
            curwin->w_cursor.lnum = lnum;
        check_cursor_lnum();
        beginline(2 | 4);
        retval = 0;
    }
    else if (do_ecmd(fnum, ffname, sfname, ((void *)0), lnum,
                ((buf_hide(curbuf)) ? 0x01 : 0) + (forceit ? 0x08 : 0)) == 1)
        retval = -1;
    else
        retval = 1;
theend:
    vim_free(free_me);
    return retval;
}
    int do_ecmd(fnum, ffname, sfname, eap, newlnum, flags)
    int fnum;
    char_u *ffname;
    char_u *sfname;
    exarg_T *eap;
    linenr_T newlnum;
    int flags;
{
    int other_file;
    int oldbuf;
    int auto_buf = 0;
    char_u *new_name = ((void *)0);
    buf_T *buf;
    buf_T *old_curbuf = curbuf;
    char_u *free_fname = ((void *)0);
    char_u *browse_file = ((void *)0);
    int retval = 0;
    long n;
    linenr_T lnum;
    linenr_T topline = 0;
    int newcol = -1;
    int solcol = -1;
    pos_T *pos;
    char_u *command = ((void *)0);
    if (eap != ((void *)0))
        command = eap->do_ecmd_cmd;
    if (fnum != 0)
    {
        if (fnum == curbuf->b_fnum)
            return 1;
        other_file = 1;
    }
    else
    {
        if (cmdmod.browse)
        {
            browse_file = do_browse(0, (char_u *)((char *)("Edit File")), ffname,
                                                    ((void *)0), ((void *)0), ((void *)0), curbuf);
            if (browse_file == ((void *)0))
                goto theend;
            ffname = browse_file;
        }
        if (sfname == ((void *)0))
            sfname = ffname;
        if ((flags & 0x10) && (ffname == ((void *)0) || *ffname == '\000'))
            goto theend;
        if (ffname == ((void *)0))
            other_file = 1;
        else if (*ffname == '\000' && curbuf->b_ffname == ((void *)0))
            other_file = 0;
        else
        {
            if (*ffname == '\000')
            {
                ffname = curbuf->b_ffname;
                sfname = curbuf->b_fname;
            }
            free_fname = fix_fname(ffname);
            if (free_fname != ((void *)0))
                ffname = free_fname;
            other_file = otherfile(ffname);
        }
    }
    if ( ((!other_file && !(flags & 0x04))
            || (curbuf->b_nwindows == 1
                && !(flags & (0x01 | 0x10))))
        && check_changed(curbuf, p_awa, !other_file,
                                        (flags & 0x08), 0))
    {
        if (fnum == 0 && other_file && ffname != ((void *)0))
            (void)setaltfname(ffname, sfname, newlnum < 0 ? 0 : newlnum);
        goto theend;
    }
    reset_VIsual();
    if (other_file)
    {
        if (!(flags & 0x10))
        {
            curwin->w_alt_fnum = curbuf->b_fnum;
            buflist_altfpos();
        }
        if (fnum)
            buf = buflist_findnr(fnum);
        else
        {
            if (flags & 0x10)
            {
                linenr_T tlnum = 1L;
                if (command != ((void *)0))
                {
                    tlnum = atol((char *)command);
                    if (tlnum <= 0)
                        tlnum = 1L;
                }
                (void)buflist_new(ffname, sfname, tlnum, 2);
                goto theend;
            }
            buf = buflist_new(ffname, sfname, 0L,
                    1 | ((flags & 0x02) ? 0 : 2));
        }
        if (buf == ((void *)0))
            goto theend;
        if (buf->b_ml.ml_mfp == ((void *)0))
        {
            oldbuf = 0;
            buf->b_nwindows = 0;
        }
        else
        {
            oldbuf = 1;
            (void)buf_check_timestamp(buf, 0);
            if (!buf_valid(buf))
                goto theend;
            if (aborting())
                goto theend;
        }
        if ((oldbuf && newlnum == (linenr_T)0) || newlnum == (linenr_T)-1)
        {
            pos = buflist_findfpos(buf);
            newlnum = pos->lnum;
            solcol = pos->col;
        }
        if (buf != curbuf)
        {
            if (buf->b_fname != ((void *)0))
                new_name = vim_strsave(buf->b_fname);
            au_new_curbuf = buf;
            apply_autocmds(EVENT_BUFLEAVE, ((void *)0), ((void *)0), 0, curbuf);
            if (!buf_valid(buf))
            {
                delbuf_msg(new_name);
                goto theend;
            }
            if (aborting())
            {
                vim_free(new_name);
                goto theend;
            }
            if (buf == curbuf)
                auto_buf = 1;
            else
            {
                if (curbuf == old_curbuf)
                    buf_copy_options(buf, 1);
                close_buffer(curwin, curbuf,
                                      (flags & 0x01) ? 0 : 2);
            if (aborting())
            {
                vim_free(new_name);
                goto theend;
            }
                if (!buf_valid(buf))
                {
                    delbuf_msg(new_name);
                    goto theend;
                }
                if (buf == curbuf)
                    auto_buf = 1;
                else
                {
                    curwin->w_buffer = buf;
                    curbuf = buf;
                    ++curbuf->b_nwindows;
                    if (*p_ffs && !oldbuf)
                        set_fileformat(default_fileformat(), 4);
                }
                get_winopts(buf);
            }
            vim_free(new_name);
            au_new_curbuf = ((void *)0);
        }
        else
            ++curbuf->b_nwindows;
        curwin->w_pcmark.lnum = 1;
        curwin->w_pcmark.col = 0;
    }
    else
    {
        if (
                (flags & 0x10) ||
                check_fname() == 0)
            goto theend;
        oldbuf = (flags & 0x04);
    }
    if ((flags & 0x02) || keep_help_flag)
    {
        curbuf->b_help = 1;
        set_string_option_direct((char_u *)"buftype", -1,
                                       (char_u *)"help", 1 |4);
        curbuf->b_p_ma = 0;
        curbuf->b_p_bin = 0;
        curwin->w_onebuf_opt.wo_nu = 0;
        curwin->w_onebuf_opt.wo_scb = 0;
        curwin->w_onebuf_opt.wo_fen = 0;
        curwin->w_onebuf_opt.wo_diff = 0;
        buf = curbuf;
        set_buflisted(0);
    }
    else
    {
        buf = curbuf;
        set_buflisted(1);
    }
    if (buf != curbuf)
        goto theend;
    if (aborting())
        goto theend;
    did_filetype = 0;
    if (!other_file && !oldbuf)
    {
        set_last_cursor(curwin);
        if (newlnum == (linenr_T)-1 || newlnum == (linenr_T)0)
        {
            newlnum = curwin->w_cursor.lnum;
            solcol = curwin->w_cursor.col;
        }
        buf = curbuf;
        if (buf->b_fname != ((void *)0))
            new_name = vim_strsave(buf->b_fname);
        else
            new_name = ((void *)0);
        buf_freeall(curbuf, 0, 0);
        if (!buf_valid(buf))
        {
            delbuf_msg(new_name);
            goto theend;
        }
        vim_free(new_name);
        if (buf != curbuf)
            goto theend;
        if (aborting())
            goto theend;
        buf_clear_file(curbuf);
        curbuf->b_op_start.lnum = 0;
        curbuf->b_op_end.lnum = 0;
    }
    ++RedrawingDisabled;
    retval = 1;
    check_cursor();
    check_arg_idx(curwin);
    if (!auto_buf)
    {
        win_init(curwin);
        foldUpdateAll(curwin);
        if (p_acd && curbuf->b_ffname != ((void *)0)
                                     && vim_chdirfile(curbuf->b_ffname) == 1)
            shorten_fnames(1);
        lnum = curwin->w_cursor.lnum;
        topline = curwin->w_topline;
        if (!oldbuf)
        {
            swap_exists_action = 1;
            curbuf->b_flags |= 0x02;
            if (should_abort(open_buffer(0, eap)))
                retval = 0;
            if (swap_exists_action == 2)
                retval = 0;
            handle_swap_exists(old_curbuf);
        }
        else
        {
            apply_autocmds_retval(EVENT_BUFENTER, ((void *)0), ((void *)0), 0, curbuf,
                                                                    &retval);
            apply_autocmds_retval(EVENT_BUFWINENTER, ((void *)0), ((void *)0), 0, curbuf,
                                                                    &retval);
        }
        check_arg_idx(curwin);
        if (curwin->w_cursor.lnum != lnum)
        {
            newlnum = curwin->w_cursor.lnum;
            newcol = curwin->w_cursor.col;
        }
        if (curwin->w_topline == topline)
            topline = 0;
        changed_line_abv_curs();
        maketitle();
    }
    diff_new_buffer();
    diff_invalidate();
    if (command == ((void *)0))
    {
        if (newcol >= 0)
        {
            curwin->w_cursor.lnum = newlnum;
            curwin->w_cursor.col = newcol;
            check_cursor();
        }
        else if (newlnum > 0)
        {
            curwin->w_cursor.lnum = newlnum;
            check_cursor_lnum();
            if (solcol >= 0 && !p_sol)
            {
                curwin->w_cursor.col = solcol;
                check_cursor_col();
                curwin->w_cursor.coladd = 0;
                curwin->w_set_curswant = 1;
            }
            else
                beginline(2 | 4);
        }
        else
        {
            if (exmode_active)
                curwin->w_cursor.lnum = curbuf->b_ml.ml_line_count;
            beginline(1 | 4);
        }
    }
    check_lnums(0);
    if (oldbuf
                && !auto_buf
                            )
    {
        int msg_scroll_save = msg_scroll;
        if (shortmess('O') && !exiting && p_verbose == 0)
            msg_scroll = 0;
        if (!msg_scroll)
            check_for_delay(0);
        msg_start();
        msg_scroll = msg_scroll_save;
        msg_scrolled_ign = 1;
        fileinfo(0, 1, 0);
        msg_scrolled_ign = 0;
    }
    if (command != ((void *)0))
        do_cmdline(command, ((void *)0), ((void *)0), 0x01);
    --RedrawingDisabled;
    if (!skip_redraw)
    {
        n = p_so;
        if (topline == 0 && command == ((void *)0))
            p_so = 999;
        update_topline();
        curwin->w_scbind_pos = curwin->w_topline;
        p_so = n;
        redraw_curbuf_later(40);
    }
    if (p_im)
        need_start_insertmode = 1;
    if (p_acd && curbuf->b_ffname != ((void *)0)
                                     && vim_chdirfile(curbuf->b_ffname) == 1)
        shorten_fnames(1);
    if (gui.in_use && curbuf->b_fname != ((void *)0))
    {
        if (usingNetbeans)
            netbeans_file_opened((char *)curbuf->b_ffname);
    }
theend:
    vim_free(browse_file);
    vim_free(free_fname);
    return retval;
}
    static void delbuf_msg(name)
    char_u *name;
{
    emsg2((char_u *)(((char *)("E143: Autocommands unexpectedly deleted new buffer %s"))), (char_u *)(name == ((void *)0) ? (char_u *)"" : name));
    vim_free(name);
    au_new_curbuf = ((void *)0);
}
    void ex_append(eap)
    exarg_T *eap;
{
    char_u *theline;
    int did_undo = 0;
    linenr_T lnum = eap->line2;
    if (eap->cmdidx != CMD_append)
        --lnum;
    State = 0x10;
    if (curbuf->b_p_iminsert == 1)
        State |= 0x20;
    while (1)
    {
        msg_scroll = 1;
        need_wait_return = 0;
        if (eap->getline == ((void *)0))
            theline = getcmdline(
                    eap->cstack->cs_whilelevel > 0 ? -1 :
                    '\000', 0L, 0);
        else
            theline = eap->getline(
                    eap->cstack->cs_whilelevel > 0 ? -1 :
                    '\000', eap->cookie, 0);
        lines_left = Rows - 1;
        if (theline == ((void *)0) || (theline[0] == '.' && theline[1] == '\000'))
            break;
        if (!did_undo && u_save(lnum, lnum + 1) == 0)
            break;
        did_undo = 1;
        ml_append(lnum, theline, (colnr_T)0, 0);
        appended_lines_mark(lnum, 1L);
        vim_free(theline);
        ++lnum;
        msg_didout = 1;
    }
    State = 0x01;
    curbuf->b_op_start.lnum = (eap->line2 < curbuf->b_ml.ml_line_count) ?
        eap->line2 + 1 : curbuf->b_ml.ml_line_count;
    if (eap->cmdidx != CMD_append)
        --curbuf->b_op_start.lnum;
    curbuf->b_op_end.lnum = (eap->line2 < lnum)
                                             ? lnum : curbuf->b_op_start.lnum;
    curbuf->b_op_start.col = curbuf->b_op_end.col = 0;
    curwin->w_cursor.lnum = lnum;
    check_cursor_lnum();
    beginline(2 | 4);
    need_wait_return = 0;
    ex_no_reprint = 1;
}
    void ex_change(eap)
    exarg_T *eap;
{
    linenr_T lnum;
    if (eap->line2 >= eap->line1
            && u_save(eap->line1 - 1, eap->line2 + 1) == 0)
        return;
    for (lnum = eap->line2; lnum >= eap->line1; --lnum)
    {
        if (curbuf->b_ml.ml_flags & 1)
            break;
        ml_delete(eap->line1, 0);
    }
    deleted_lines_mark(eap->line1, (long)(eap->line2 - lnum));
    eap->line2 = eap->line1;
    ex_append(eap);
}
    void ex_z(eap)
    exarg_T *eap;
{
    char_u *x;
    int bigness = curwin->w_height - 3;
    char_u kind;
    int numbered = 0;
    int minus = 0;
    linenr_T start, end, curs, i;
    int j;
    linenr_T lnum = eap->line2;
    if (bigness < 1)
        bigness = 1;
    x = eap->arg;
    if (*x == '#')
    {
        numbered = 1;
        ++x;
    }
    kind = *x;
    if (kind == '-' || kind == '+' || kind == '=' || kind == '^' || kind == '.')
        ++x;
    if (*x != 0)
    {
        if (!(__ctype_b[(int) ((*x))] & (unsigned short int) _ISdigit))
        {
            emsg((char_u *)(((char *)("E144: non-numeric argument to :z"))));
            return;
        }
        else
            bigness = atoi((char *)x);
    }
    switch (kind)
    {
        case '-':
            start = lnum - bigness;
            end = lnum;
            curs = lnum;
            break;
        case '=':
            start = lnum - bigness / 2 + 1;
            end = lnum + bigness / 2 - 1;
            curs = lnum;
            minus = 1;
            break;
        case '^':
            start = lnum - bigness * 2;
            end = lnum - bigness;
            curs = lnum - bigness;
            break;
        case '.':
            start = lnum - bigness / 2;
            end = lnum + bigness / 2;
            curs = end;
            break;
        default:
            start = lnum;
            end = lnum + bigness;
            curs = end;
            break;
    }
    if (start < 1)
        start = 1;
    if (end > curbuf->b_ml.ml_line_count)
        end = curbuf->b_ml.ml_line_count;
    if (curs > curbuf->b_ml.ml_line_count)
        curs = curbuf->b_ml.ml_line_count;
    for (i = start; i <= end; i++)
    {
        if (minus && i == lnum)
        {
            msg_putchar('\n');
            for (j = 1; j < Columns; j++)
                msg_putchar('-');
        }
        print_line(i, numbered);
        if (minus && i == lnum)
        {
            msg_putchar('\n');
            for (j = 1; j < Columns; j++)
                msg_putchar('-');
        }
    }
    curwin->w_cursor.lnum = curs;
    ex_no_reprint = 1;
}
    int check_restricted()
{
    if (restricted)
    {
        emsg((char_u *)(((char *)("E145: Shell commands not allowed in rvim"))));
        return 1;
    }
    return 0;
}
    int check_secure()
{
    if (secure)
    {
        secure = 2;
        emsg((char_u *)(((char *)(e_curdir))));
        return 1;
    }
    if (sandbox != 0)
    {
        emsg((char_u *)(((char *)(e_sandbox))));
        return 1;
    }
    return 0;
}
static char_u *old_sub = ((void *)0);
static int global_need_beginline;
static long sub_nsubs;
static linenr_T sub_nlines;
    void do_sub(eap)
    exarg_T *eap;
{
    linenr_T lnum;
    long i = 0;
    regmmatch_T regmatch;
    static int do_all = 0;
    static int do_ask = 0;
    static int do_error = 1;
    static int do_print = 0;
    static int do_ic = 0;
    char_u *pat = ((void *)0), *sub = ((void *)0);
    int delimiter;
    int sublen;
    int got_quit = 0;
    int got_match = 0;
    int temp;
    int which_pat;
    char_u *cmd;
    int save_State;
    linenr_T first_line = 0;
    linenr_T last_line= 0;
    linenr_T old_line_count = curbuf->b_ml.ml_line_count;
    linenr_T line2;
    long nmatch;
    linenr_T sub_firstlnum;
    char_u *sub_firstline;
    cmd = eap->arg;
    if (!global_busy)
    {
        sub_nsubs = 0;
        sub_nlines = 0;
    }
    if (eap->cmdidx == CMD_tilde)
        which_pat = 2;
    else
        which_pat = 1;
    if (eap->cmd[0] == 's' && *cmd != '\000' && !((*cmd) == ' ' || (*cmd) == '\t')
                && vim_strchr((char_u *)"0123456789cegriIp|\"", *cmd) == ((void *)0))
    {
        if ((__ctype_b[(int) ((*cmd))] & (unsigned short int) _ISalpha))
        {
            emsg((char_u *)(((char *)("E146: Regular expressions can't be delimited by letters"))));
            return;
        }
        if (*cmd == '\\')
        {
            ++cmd;
            if (vim_strchr((char_u *)"/?&", *cmd) == ((void *)0))
            {
                emsg((char_u *)(((char *)(e_backslash))));
                return;
            }
            if (*cmd != '&')
                which_pat = 0;
            pat = (char_u *)"";
            delimiter = *cmd++;
        }
        else
        {
            which_pat = 2;
            delimiter = *cmd++;
            pat = cmd;
            cmd = skip_regexp(cmd, delimiter, p_magic, &eap->arg);
            if (cmd[0] == delimiter)
                *cmd++ = '\000';
        }
        sub = cmd;
        while (cmd[0])
        {
            if (cmd[0] == delimiter)
            {
                *cmd++ = '\000';
                break;
            }
            if (cmd[0] == '\\' && cmd[1] != 0)
                ++cmd;
                ++cmd;
        }
        if (!eap->skip)
        {
            vim_free(old_sub);
            old_sub = vim_strsave(sub);
        }
    }
    else if (!eap->skip)
    {
        if (old_sub == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_nopresub))));
            return;
        }
        pat = ((void *)0);
        sub = old_sub;
    }
    if (*cmd == '&')
        ++cmd;
    else
    {
        if (!p_ed)
        {
            if (p_gd)
                do_all = 1;
            else
                do_all = 0;
            do_ask = 0;
        }
        do_error = 1;
        do_print = 0;
        do_ic = 0;
    }
    while (*cmd)
    {
        if (*cmd == 'g')
            do_all = !do_all;
        else if (*cmd == 'c')
            do_ask = !do_ask;
        else if (*cmd == 'e')
            do_error = !do_error;
        else if (*cmd == 'r')
            which_pat = 2;
        else if (*cmd == 'p')
            do_print = 1;
        else if (*cmd == 'i')
            do_ic = 'i';
        else if (*cmd == 'I')
            do_ic = 'I';
        else
            break;
        ++cmd;
    }
    cmd = skipwhite(cmd);
    if ((__ctype_b[(int) ((*cmd))] & (unsigned short int) _ISdigit))
    {
        i = getdigits(&cmd);
        if (i <= 0 && !eap->skip && do_error)
        {
            emsg((char_u *)(((char *)(e_zerocount))));
            return;
        }
        eap->line1 = eap->line2;
        eap->line2 += i - 1;
        if (eap->line2 > curbuf->b_ml.ml_line_count)
            eap->line2 = curbuf->b_ml.ml_line_count;
    }
    cmd = skipwhite(cmd);
    if (*cmd && *cmd != '"')
    {
        eap->nextcmd = check_nextcmd(cmd);
        if (eap->nextcmd == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_trailing))));
            return;
        }
    }
    if (eap->skip)
        return;
    if (search_regcomp(pat, 1, which_pat, 0x20, &regmatch) == 0)
    {
        if (do_error)
            emsg((char_u *)(((char *)(e_invcmd))));
        return;
    }
    if (do_ic == 'i')
        regmatch.rmm_ic = 1;
    else if (do_ic == 'I')
        regmatch.rmm_ic = 0;
    sub_firstline = ((void *)0);
    if (!(sub[0] == '\\' && sub[1] == '='))
        sub = regtilde(sub, p_magic);
    line2 = eap->line2;
    for (lnum = eap->line1; lnum <= line2 && !(got_quit
                || aborting()
                ); ++lnum)
    {
        sub_firstlnum = lnum;
        nmatch = vim_regexec_multi(&regmatch, curwin, curbuf, lnum, (colnr_T)0);
        if (nmatch)
        {
            colnr_T copycol;
            colnr_T matchcol;
            colnr_T prev_matchcol = (0x7fffffffL);
            char_u *new_end, *new_start = ((void *)0);
            unsigned new_start_len = 0;
            char_u *p1;
            int did_sub = 0;
            int lastone;
            unsigned len, needed_len;
            long nmatch_tl = 0;
            int do_again;
            sub_firstline = vim_strsave(ml_get(sub_firstlnum));
            if (sub_firstline == ((void *)0))
            {
                vim_free(new_start);
                goto outofmem;
            }
            copycol = 0;
            matchcol = 0;
            if (!got_match)
            {
                setpcmark();
                got_match = 1;
            }
            for (;;)
            {
                curwin->w_cursor.lnum = lnum;
                do_again = 0;
                if (matchcol == prev_matchcol
                        && regmatch.endpos[0].lnum == 0
                        && matchcol == regmatch.endpos[0].col)
                {
                    ++matchcol;
                    goto skip;
                }
                matchcol = regmatch.endpos[0].col;
                prev_matchcol = matchcol;
                if (do_ask)
                {
                    save_State = State;
                    State = 0x800;
                    setmouse();
                    curwin->w_cursor.col = regmatch.startpos[0].col;
                    if (vim_strchr(p_cpo, 'u') != ((void *)0))
                        ++no_u_sync;
                    while (do_ask)
                    {
                        int save_p_fen = curwin->w_onebuf_opt.wo_fen;
                        curwin->w_onebuf_opt.wo_fen = 0;
                        temp = RedrawingDisabled;
                        RedrawingDisabled = 0;
                        search_match_lines = regmatch.endpos[0].lnum;
                        search_match_endcol = regmatch.endpos[0].col;
                        highlight_match = 1;
                        update_topline();
                        validate_cursor();
                        update_screen(40);
                        highlight_match = 0;
                        redraw_later(40);
                        curwin->w_onebuf_opt.wo_fen = save_p_fen;
                        if (msg_row == Rows - 1)
                            msg_didout = 0;
                        msg_starthere();
                        i = msg_scroll;
                        msg_scroll = 0;
                        msg_no_more = 1;
                        smsg_attr(highlight_attr[(int)(HLF_R)],
                            (char_u *)((char *)("replace with %s (y/n/a/q/l/^E/^Y)?")),
                                sub);
                        msg_no_more = 0;
                        msg_scroll = i;
                        showruler(1);
                        windgoto(msg_row, msg_col);
                        RedrawingDisabled = temp;
                        ++no_mapping;
                        ++allow_keys;
                        i = safe_vgetc();
                        --allow_keys;
                        --no_mapping;
                        msg_didout = 0;
                        msg_col = 0;
                        gotocmdline(1);
                        need_wait_return = 0;
                        if (i == 'q' || i == '\033' || i == 3
                                || i == intr_char
                                )
                        {
                            got_quit = 1;
                            break;
                        }
                        if (i == 'n')
                            break;
                        if (i == 'y')
                            break;
                        if (i == 'l')
                        {
                            do_all = 0;
                            line2 = lnum;
                            break;
                        }
                        if (i == 'a')
                        {
                            do_ask = 0;
                            break;
                        }
                        if (i == 5)
                            scrollup_clamp();
                        else if (i == 25)
                            scrolldown_clamp();
                    }
                    State = save_State;
                    setmouse();
                    if (vim_strchr(p_cpo, 'u') != ((void *)0))
                        --no_u_sync;
                    if (i == 'n')
                    {
                        if (nmatch > 1)
                        {
                            matchcol = strlen((char *)(sub_firstline));
                            nmatch = 1;
                        }
                        goto skip;
                    }
                    if (got_quit)
                        break;
                }
                curwin->w_cursor.col = 0;
                sublen = vim_regsub_multi(&regmatch, sub_firstlnum,
                                    sub, sub_firstline, 0, p_magic, 1);
                if (nmatch == 1)
                    p1 = sub_firstline;
                else
                {
                    p1 = ml_get(sub_firstlnum + nmatch - 1);
                    nmatch_tl += nmatch - 1;
                }
                i = regmatch.startpos[0].col - copycol;
                needed_len = i + ((unsigned)strlen((char *)(p1)) - regmatch.endpos[0].col)
                                                                 + sublen + 1;
                if (new_start == ((void *)0))
                {
                    new_start_len = needed_len + 50;
                    if ((new_start = alloc_check(new_start_len)) == ((void *)0))
                        goto outofmem;
                    *new_start = '\000';
                    new_end = new_start;
                }
                else
                {
                    len = (unsigned)strlen((char *)(new_start));
                    needed_len += len;
                    if (needed_len > new_start_len)
                    {
                        new_start_len = needed_len + 50;
                        if ((p1 = alloc_check(new_start_len)) == ((void *)0))
                        {
                            vim_free(new_start);
                            goto outofmem;
                        }
                        memmove((char *)(p1), (char *)(new_start), (size_t)(len + 1));
                        vim_free(new_start);
                        new_start = p1;
                    }
                    new_end = new_start + len;
                }
                memmove((char *)(new_end), (char *)(sub_firstline + copycol), (size_t)i);
                new_end += i;
                (void)vim_regsub_multi(&regmatch, sub_firstlnum,
                                           sub, new_end, 1, p_magic, 1);
                sub_nsubs++;
                did_sub = 1;
                if (nmatch > 1)
                {
                    sub_firstlnum += nmatch - 1;
                    vim_free(sub_firstline);
                    sub_firstline = vim_strsave(ml_get(sub_firstlnum));
                    if (sub_firstlnum <= line2)
                        do_again = 1;
                    else
                        do_all = 0;
                }
                copycol = regmatch.endpos[0].col;
                for (p1 = new_end; *p1; ++p1)
                {
                    if (p1[0] == '\\' && p1[1] != '\000')
                        memmove((char *)(p1), (char *)(p1 + 1), strlen((char *)(p1)));
                    else if (*p1 == '\015')
                    {
                        if (u_inssub(lnum) == 1)
                        {
                            *p1 = '\000';
                            ml_append(lnum - 1, new_start,
                                        (colnr_T)(p1 - new_start + 1), 0);
                            mark_adjust(lnum + 1, (linenr_T)(0x7fffffffL), 1L, 0L);
                            if (do_ask)
                                appended_lines(lnum - 1, 1L);
                            else
                            {
                                if (first_line == 0)
                                    first_line = lnum;
                                last_line = lnum + 1;
                            }
                            ++sub_firstlnum;
                            ++lnum;
                            ++line2;
                            ++curwin->w_cursor.lnum;
                            strcpy((char *)(new_start), (char *)(p1 + 1));
                            p1 = new_start - 1;
                        }
                    }
                }
skip:
                lastone = ((sub_firstline[matchcol] == '\000' && nmatch <= 1)
                             || got_int || got_quit || !(do_all || do_again));
                nmatch = -1;
                if (lastone
                        || do_ask
                        || nmatch_tl > 0
                        || (nmatch = vim_regexec_multi(&regmatch, curwin,
                                       curbuf, sub_firstlnum, matchcol)) == 0)
                {
                    if (new_start != ((void *)0))
                    {
                        strcat((char *)(new_start), (char *)(sub_firstline + copycol));
                        matchcol = (colnr_T)strlen((char *)(sub_firstline)) - matchcol;
                        if (u_savesub(lnum) != 1)
                            break;
                        ml_replace(lnum, new_start, 1);
                        if (nmatch_tl > 0)
                        {
                            ++lnum;
                            if (u_savedel(lnum, nmatch_tl) != 1)
                                break;
                            for (i = 0; i < nmatch_tl; ++i)
                                ml_delete(lnum, (int)0);
                            mark_adjust(lnum, lnum + nmatch_tl - 1,
                                                   (long)(0x7fffffffL), -nmatch_tl);
                            if (do_ask)
                                deleted_lines(lnum, nmatch_tl);
                            --lnum;
                            line2 -= nmatch_tl;
                            nmatch_tl = 0;
                        }
                        if (do_ask)
                            changed_bytes(lnum, 0);
                        else
                        {
                            if (first_line == 0)
                                first_line = lnum;
                            last_line = lnum + 1;
                        }
                        sub_firstlnum = lnum;
                        vim_free(sub_firstline);
                        sub_firstline = new_start;
                        new_start = ((void *)0);
                        matchcol = (colnr_T)strlen((char *)(sub_firstline)) - matchcol;
                        copycol = 0;
                    }
                    if (nmatch == -1 && !lastone)
                        nmatch = vim_regexec_multi(&regmatch, curwin, curbuf,
                                                     sub_firstlnum, matchcol);
                    if (nmatch <= 0)
                        break;
                }
                line_breakcheck();
            }
            if (did_sub)
                ++sub_nlines;
            vim_free(sub_firstline);
            sub_firstline = ((void *)0);
        }
        line_breakcheck();
    }
    if (first_line != 0)
    {
        i = curbuf->b_ml.ml_line_count - old_line_count;
        changed_lines(first_line, 0, last_line - i, i);
    }
outofmem:
    vim_free(sub_firstline);
    if (sub_nsubs)
    {
        curbuf->b_op_start.lnum = eap->line1;
        curbuf->b_op_end.lnum = line2;
        curbuf->b_op_start.col = curbuf->b_op_end.col = 0;
        if (!global_busy)
        {
            beginline(1 | 4);
            if (!do_sub_msg() && do_ask)
                msg((char_u *)(""));
        }
        else
            global_need_beginline = 1;
        if (do_print)
            print_line(curwin->w_cursor.lnum, 0);
    }
    else if (!global_busy)
    {
        if (got_int)
            emsg((char_u *)(((char *)(e_interr))));
        else if (got_match)
            msg((char_u *)(""));
        else if (do_error)
            emsg2((char_u *)(((char *)(e_patnotf2))), (char_u *)(get_search_pat()));
    }
    vim_free(regmatch.regprog);
}
    static int do_sub_msg()
{
    if (sub_nsubs > p_report
            && (KeyTyped || sub_nlines > 1 || p_report < 1)
            && messaging())
    {
        if (got_int)
            strcpy((char *)(msg_buf), (char *)(((char *)("(Interrupted) "))));
        else
            msg_buf[0] = '\000';
        if (sub_nsubs == 1)
            strcat((char *)(msg_buf), (char *)(((char *)("1 substitution"))));
        else
            sprintf((char *)msg_buf + strlen((char *)(msg_buf)), ((char *)("%ld substitutions")),
                                                                   sub_nsubs);
        if (sub_nlines == 1)
            strcat((char *)(msg_buf), (char *)(((char *)(" on 1 line"))));
        else
            sprintf((char *)msg_buf + strlen((char *)(msg_buf)), ((char *)(" on %ld lines")),
                                                            (long)sub_nlines);
        if (msg(msg_buf))
        {
            set_keep_msg(msg_buf);
            keep_msg_attr = 0;
        }
        return 1;
    }
    if (got_int)
    {
        emsg((char_u *)(((char *)(e_interr))));
        return 1;
    }
    return 0;
}
    void ex_global(eap)
    exarg_T *eap;
{
    linenr_T lnum;
    int ndone;
    int type;
    char_u *cmd;
    char_u delim;
    char_u *pat;
    regmmatch_T regmatch;
    int match;
    int which_pat;
    if (global_busy)
    {
        emsg((char_u *)(((char *)("E147: Cannot do :global recursive"))));
        return;
    }
    if (eap->forceit)
        type = 'v';
    else
        type = *eap->cmd;
    cmd = eap->arg;
    which_pat = 2;
    sub_nsubs = 0;
    sub_nlines = 0;
    if (*cmd == '\\')
    {
        ++cmd;
        if (vim_strchr((char_u *)"/?&", *cmd) == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_backslash))));
            return;
        }
        if (*cmd == '&')
            which_pat = 1;
        else
            which_pat = 0;
        ++cmd;
        pat = (char_u *)"";
    }
    else if (*cmd == '\000')
    {
        emsg((char_u *)(((char *)("E148: Regular expression missing from global"))));
        return;
    }
    else
    {
        delim = *cmd;
        if (delim)
            ++cmd;
        pat = cmd;
        cmd = skip_regexp(cmd, delim, p_magic, &eap->arg);
        if (cmd[0] == delim)
            *cmd++ = '\000';
    }
    if (search_regcomp(pat, 2, which_pat, 0x20, &regmatch) == 0)
    {
        emsg((char_u *)(((char *)(e_invcmd))));
        return;
    }
    ndone = 0;
    for (lnum = eap->line1; lnum <= eap->line2 && !got_int; ++lnum)
    {
        match = vim_regexec_multi(&regmatch, curwin, curbuf, lnum, (colnr_T)0);
        if ((type == 'g' && match) || (type == 'v' && !match))
        {
            ml_setmarked(lnum);
            ndone++;
        }
        line_breakcheck();
    }
    if (got_int)
        msg((char_u *)(((char *)(e_interr))));
    else if (ndone == 0)
    {
        if (type == 'v')
            msg_str((char_u *)((char *)("Pattern found in every line: %s")), pat);
        else
            msg_str((char_u *)((char *)(e_patnotf2)), pat);
    }
    else
        global_exe(cmd);
    ml_clearmarked();
    vim_free(regmatch.regprog);
}
    void global_exe(cmd)
    char_u *cmd;
{
    linenr_T old_lcount;
    linenr_T lnum;
    setpcmark();
    msg_didout = 1;
    global_need_beginline = 0;
    global_busy = 1;
    old_lcount = curbuf->b_ml.ml_line_count;
    while (!got_int && (lnum = ml_firstmarked()) != 0 && global_busy == 1)
    {
        curwin->w_cursor.lnum = lnum;
        curwin->w_cursor.col = 0;
        if (*cmd == '\000' || *cmd == '\n')
            do_cmdline((char_u *)"p", ((void *)0), ((void *)0), 0x02);
        else
            do_cmdline(cmd, ((void *)0), ((void *)0), 0x02);
        ui_breakcheck();
    }
    global_busy = 0;
    if (global_need_beginline)
        beginline(1 | 4);
    else
        check_cursor();
    if (msg_col == 0 && msg_scrolled == 0)
        msg_didout = 0;
    if (!do_sub_msg())
        msgmore(curbuf->b_ml.ml_line_count - old_lcount);
}
    int read_viminfo_sub_string(virp, force)
    vir_T *virp;
    int force;
{
    if (old_sub != ((void *)0) && force)
        vim_free(old_sub);
    if (force || old_sub == ((void *)0))
        old_sub = viminfo_readstring(virp, 1, 1);
    return viminfo_readline(virp);
}
    void write_viminfo_sub_string(fp)
    FILE *fp;
{
    if (get_viminfo_parameter('/') != 0 && old_sub != ((void *)0))
    {
        fprintf(fp, ((char *)("\n# Last Substitute String:\n$")));
        viminfo_writestring(fp, old_sub);
    }
}
    void prepare_tagpreview()
{
    win_T *wp;
    need_mouse_correct = 1;
    if (!curwin->w_onebuf_opt.wo_pvw)
    {
        for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
            if (wp->w_onebuf_opt.wo_pvw)
                break;
        if (wp != ((void *)0))
            win_enter(wp, 1);
        else
        {
            if (win_split(g_do_tagpreview > 0 ? g_do_tagpreview : 0, 0)
                                                                      == 0)
                return;
            curwin->w_onebuf_opt.wo_pvw = 1;
            curwin->w_onebuf_opt.wo_wfh = 1;
            curwin->w_onebuf_opt.wo_scb = 0;
            curwin->w_onebuf_opt.wo_diff = 0;
            curwin->w_onebuf_opt.wo_fdc = 0;
        }
    }
}
    void ex_help(eap)
    exarg_T *eap;
{
    char_u *arg;
    FILE *helpfd;
    int n;
    win_T *wp;
    int num_matches;
    char_u **matches;
    int need_free = 0;
    char_u *p;
    int empty_fnum = 0;
    int alt_fnum = 0;
    buf_T *buf;
    if (eap != ((void *)0))
    {
        for (arg = eap->arg; *arg; ++arg)
        {
            if (*arg == '\n' || *arg == '\r'
                    || (*arg == '|' && arg[1] != '\000' && arg[1] != '|'))
            {
                *arg++ = '\000';
                eap->nextcmd = arg;
                break;
            }
        }
        arg = eap->arg;
        if (eap->skip)
            return;
    }
    else
        arg = (char_u *)"";
    if (*arg != '\000')
    {
        p = arg + strlen((char *)(arg)) - 1;
        while (p > arg && ((*p) == ' ' || (*p) == '\t') && p[-1] != '\\')
            *p-- = '\000';
        n = find_help_tags(arg, &num_matches, &matches);
        if (num_matches == 0 || n == 0)
        {
            emsg2((char_u *)(((char *)("E149: Sorry, no help for %s"))), (char_u *)(arg));
            return;
        }
        arg = vim_strsave(matches[0]);
        need_free = 1;
        FreeWild(num_matches, matches);
    }
    need_mouse_correct = 1;
    if (!curwin->w_buffer->b_help)
    {
        for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
            if (wp->w_buffer != ((void *)0) && wp->w_buffer->b_help)
                break;
        if (wp != ((void *)0) && wp->w_buffer->b_nwindows > 0)
            win_enter(wp, 1);
        else
        {
            if ((helpfd = fopen(((char *)p_hf), ("r"))) == ((void *)0))
            {
                msg_str((char_u *)((char *)("Sorry, help file \"%s\" not found")),
                                                                        p_hf);
                goto erret;
            }
            fclose(helpfd);
            n = 16;
            if (cmdmod.split == 0 && curwin->w_width != Columns
                                                      && curwin->w_width < 80)
                n |= 4;
            if (win_split(0, n) == 0)
                goto erret;
            if (curwin->w_height < p_hh)
                win_setheight((int)p_hh);
            alt_fnum = curbuf->b_fnum;
            (void)do_ecmd(0, ((void *)0), ((void *)0), ((void *)0), (linenr_T)0,
                                                   0x01 + 0x02);
            curwin->w_alt_fnum = alt_fnum;
            empty_fnum = curbuf->b_fnum;
        }
    }
    if (!p_im)
        restart_edit = 0;
    if (arg == ((void *)0) || *arg == '\000')
    {
        arg = (char_u *)"help.txt";
        need_free = 0;
    }
    do_tag(arg, 8, 1, 0, 1);
    if (empty_fnum != 0 && curbuf->b_fnum != empty_fnum)
    {
        buf = buflist_findnr(empty_fnum);
        if (buf != ((void *)0))
            wipe_buffer(buf, 1);
    }
    if (alt_fnum != 0 && curwin->w_alt_fnum == empty_fnum)
        curwin->w_alt_fnum = alt_fnum;
    p =
            (char_u *)"!-~,^*,^|,^\"";
    if (strcmp((char *)(curbuf->b_p_isk), (char *)(p)) != 0)
    {
        set_string_option_direct((char_u *)"isk", -1, p, 1|4);
        check_buf_options(curbuf);
        (void)buf_init_chartab(curbuf, 0);
    }
    curbuf->b_p_ts = 8;
    curwin->w_onebuf_opt.wo_list = 0;
erret:
    if (need_free)
        vim_free(arg);
}
    int help_heuristic(matched_string, offset, wrong_case)
    char_u *matched_string;
    int offset;
    int wrong_case;
{
    int num_letters;
    char_u *p;
    num_letters = 0;
    for (p = matched_string; *p; p++)
        if (((*p) < 0x7f && (__ctype_b[(int) ((*p))] & (unsigned short int) _ISalnum)))
            num_letters++;
    if (((matched_string[offset]) < 0x7f && (__ctype_b[(int) ((matched_string[offset]))] & (unsigned short int) _ISalnum)) && offset > 0
                                 && ((matched_string[offset - 1]) < 0x7f && (__ctype_b[(int) ((matched_string[offset - 1]))] & (unsigned short int) _ISalnum)))
        offset += 10000;
    else if (offset > 2)
        offset *= 200;
    if (wrong_case)
        offset += 5000;
    if (matched_string[0] == '+' && matched_string[1] != '\000')
        offset += 100;
    return (int)(100 * num_letters + strlen((char *)(matched_string)) + offset);
}
    static int help_compare(s1, s2)
    const void *s1;
    const void *s2;
{
    char *p1;
    char *p2;
    p1 = *(char **)s1 + strlen(*(char **)s1) + 1;
    p2 = *(char **)s2 + strlen(*(char **)s2) + 1;
    return strcmp(p1, p2);
}
    int find_help_tags(arg, num_matches, matches)
    char_u *arg;
    int *num_matches;
    char_u ***matches;
{
    char_u *s, *d;
    int i;
    static char *(mtable[]) = {"*", "g*", "[*", "]*", ":*",
                               "/*", "/\\*", "\"*", "/\\(\\)",
                               "?", ":?", "?<CR>", "g?", "g?g?", "g??",
                               "/\\?", "/\\z(\\)",
                               "[count]", "[quotex]", "[range]",
                               "[pattern]", "\\|", "\\%$"};
    static char *(rtable[]) = {"star", "gstar", "[star", "]star", ":star",
                               "/star", "/\\\\star", "quotestar", "/\\\\(\\\\)",
                               "?", ":?", "?<CR>", "g?", "g?g?", "g??",
                               "/\\\\?", "/\\\\z(\\\\)",
                               "\\[count]", "\\[quotex]", "\\[range]",
                               "\\[pattern]", "\\\\bar", "/\\\\%\\$"};
    d = IObuff;
    for (i = sizeof(mtable) / sizeof(char *); --i >= 0; )
        if (strcmp((char *)(arg), (char *)(mtable[i])) == 0)
        {
            strcpy((char *)(d), (char *)(rtable[i]));
            break;
        }
    if (i < 0)
    {
        if (arg[0] == '\\'
                && ((arg[1] != '\000' && arg[2] == '\000')
                    || ((arg[1] == '%' || arg[1] == '_')
                                          && arg[2] != '\000' && arg[3] == '\000')))
        {
            strcpy((char *)(d), (char *)("/\\\\"));
            strcpy((char *)(d + 3), (char *)(arg + 1));
            if (d[3] == '_' && d[4] == '$')
                strcpy((char *)(d + 4), (char *)("\\$"));
        }
        else
        {
            if (arg[0] == '[' && (arg[1] == ':'
                                         || (arg[1] == '+' && arg[2] == '+')))
              *d++ = '\\';
          for (s = arg; *s; ++s)
          {
            if (d - IObuff > (1024+1) - 10)
                break;
            switch (*s)
            {
                case '|': strcpy((char *)(d), (char *)("bar"));
                            d += 3;
                            continue;
                case '"': strcpy((char *)(d), (char *)("quote"));
                            d += 5;
                            continue;
                case '*': *d++ = '.';
                            break;
                case '?': *d++ = '.';
                            continue;
                case '$':
                case '.':
                case '~': *d++ = '\\';
                            break;
            }
            if (*s < ' ' || (*s == '^' && s[1] && (((s[1]) < 0x7f && (__ctype_b[(int) ((s[1]))] & (unsigned short int) _ISalpha))
                           || vim_strchr((char_u *)"?@[\\]^", s[1]) != ((void *)0))))
            {
                if (d > IObuff && d[-1] != '_')
                    *d++ = '_';
                strcpy((char *)(d), (char *)("CTRL-"));
                d += 5;
                if (*s < ' ')
                {
                    *d++ = *s + '@';
                    if (d[-1] == '\\')
                        *d++ = '\\';
                }
                else
                    *d++ = *++s;
                if (s[1] != '\000' && s[1] != '_')
                    *d++ = '_';
                continue;
            }
            else if (*s == '^')
                *d++ = '\\';
            else if (s[0] == '\\' && s[1] != '\\'
                                               && *arg == '/' && s == arg + 1)
                *d++ = '\\';
            if (strncasecmp((char *)(s), (char *)("CTRL-\\_"), (size_t)(7)) == 0)
            {
                strcpy((char *)(d), (char *)("CTRL-\\\\"));
                d += 7;
                s += 6;
            }
            *d++ = *s;
            if (*s == '\'' && s > arg && *arg == '\'')
                break;
          }
          *d = '\000';
        }
    }
    *matches = (char_u **)"";
    *num_matches = 0;
    if (find_tags(IObuff, num_matches, matches,
        1 | 4 | 2 | 32, (int)(0x7fffffffL)) == 1)
        qsort((void *)*matches, (size_t)*num_matches,
                                              sizeof(char_u *), help_compare)
        ;
    return 1;
}
    void fix_help_buffer()
{
    linenr_T lnum;
    char_u *line;
    int in_example = 0;
    int len;
    char_u *p;
    char_u *rt;
    int mustfree;
    set_option_value((char_u *)"ft", 0L, (char_u *)"help", 4);
    if (!syntax_present(curbuf))
    {
        for (lnum = 1; lnum <= curbuf->b_ml.ml_line_count; ++lnum)
        {
            line = ml_get_buf(curbuf, lnum, 0);
            len = (int)strlen((char *)(line));
            if (in_example && len > 0 && !((line[0]) == ' ' || (line[0]) == '\t'))
            {
                if (line[0] == '<')
                {
                    line = ml_get_buf(curbuf, lnum, 1);
                    line[0] = ' ';
                }
                in_example = 0;
            }
            if (!in_example && len > 0)
            {
                if (line[len - 1] == '>' && (len == 1 || line[len - 2] == ' '))
                {
                    line = ml_get_buf(curbuf, lnum, 1);
                    line[len - 1] = ' ';
                    in_example = 1;
                }
                else if (line[len - 1] == '~')
                {
                    line = ml_get_buf(curbuf, lnum, 1);
                    line[len - 1] = ' ';
                }
            }
        }
    }
    if (strcmp((char *)(gettail(curbuf->b_fname)), (char *)("help.txt")) == 0)
    {
        for (lnum = 1; lnum < curbuf->b_ml.ml_line_count; ++lnum)
        {
            line = ml_get_buf(curbuf, lnum, 0);
            if (strstr((char *)line, "*local-additions*") != ((void *)0))
            {
                p = p_rtp;
                while (*p != '\000')
                {
                    copy_option_part(&p, NameBuff, 1024, ",");
                    mustfree = 0;
                    rt = vim_getenv((char_u *)"VIMRUNTIME", &mustfree);
                    if (strcmp((char *)(NameBuff), (char *)(rt)) != 0)
                    {
                        int fcount;
                        char_u **fnames;
                        FILE *fd;
                        char_u *s;
                        int fi;
                        add_pathsep(NameBuff);
                        strcat((char *)(NameBuff), (char *)("doc/*.txt"));
                        if (gen_expand_wildcards(1, &NameBuff, &fcount,
                                             &fnames, 2|32) == 1
                                && fcount > 0)
                        {
                            for (fi = 0; fi < fcount; ++fi)
                            {
                                fd = fopen((char *)fnames[fi], "r");
                                if (fd != ((void *)0))
                                {
                                    vim_fgets(IObuff, (1024+1), fd);
                                    if (IObuff[0] == '*'
                                            && (s = vim_strchr(IObuff + 1, '*'))
                                                                      != ((void *)0))
                                    {
                                        IObuff[0] = '|';
                                        *s = '|';
                                        while (*s != '\000')
                                        {
                                            if (*s == '\r' || *s == '\n')
                                                *s = '\000';
                                            ++s;
                                        }
                                        ml_append(lnum, IObuff, (colnr_T)0,
                                                                       0);
                                        ++lnum;
                                    }
                                    fclose(fd);
                                }
                            }
                            FreeWild(fcount, fnames);
                        }
                    }
                    if (mustfree)
                        vim_free(rt);
                }
                break;
            }
        }
    }
}
    void ex_helptags(eap)
    exarg_T *eap;
{
    FILE *fd_tags;
    FILE *fd;
    garray_T ga;
    int filecount;
    char_u **files;
    char_u *p1, *p2;
    int fi;
    char_u *s;
    int i;
    char_u *fname;
    if (!mch_isdir(eap->arg))
    {
        emsg2((char_u *)(((char *)("E150: Not a directory: %s"))), (char_u *)(eap->arg));
        return;
    }
    strcpy((char *)(NameBuff), (char *)(eap->arg));
    add_pathsep(NameBuff);
    strcat((char *)(NameBuff), (char *)("*.txt"));
    if (gen_expand_wildcards(1, &NameBuff, &filecount, &files,
                                                    2|32) == 0
            || filecount == 0)
    {
        emsg2((char_u *)("E151: No match: %s"), (char_u *)(NameBuff));
        return;
    }
    strcpy((char *)(NameBuff), (char *)(eap->arg));
    add_pathsep(NameBuff);
    strcat((char *)(NameBuff), (char *)("tags"));
    fd_tags = fopen((char *)NameBuff, "w");
    if (fd_tags == ((void *)0))
    {
        emsg2((char_u *)(((char *)("E152: Cannot open %s for writing"))), (char_u *)(NameBuff));
        FreeWild(filecount, files);
        return;
    }
    ga_init2(&ga, (int)sizeof(char_u *), 100);
    if (fullpathcmp((char_u *)"$VIMRUNTIME/doc", eap->arg, 0) == 1)
    {
        if (ga_grow(&ga, 1) == 0)
            got_int = 1;
        else
        {
            s = vim_strsave((char_u *)"help-tags\ttags\t1\n");
            if (s == ((void *)0))
                got_int = 1;
            else
            {
                ((char_u **)ga.ga_data)[ga.ga_len] = s;
                ++ga.ga_len;
                --ga.ga_room;
            }
        }
    }
    for (fi = 0; fi < filecount && !got_int; ++fi)
    {
        fd = fopen((char *)files[fi], "r");
        if (fd == ((void *)0))
        {
            emsg2((char_u *)(((char *)("E153: Unable to open %s for reading"))), (char_u *)(files[fi]));
            continue;
        }
        fname = gettail(files[fi]);
        while (!vim_fgets(IObuff, (1024+1), fd) && !got_int)
        {
            p1 = vim_strchr(IObuff, '*');
            while (p1 != ((void *)0))
            {
                p2 = vim_strchr(p1 + 1, '*');
                if (p2 != ((void *)0) && p2 > p1 + 1)
                {
                    for (s = p1 + 1; s < p2; ++s)
                        if (*s == ' ' || *s == '\t' || *s == '|')
                            break;
                    if (s == p2
                            && (p1 == IObuff || p1[-1] != '-')
                            && (vim_strchr((char_u *)" \t\n\r", s[1]) != ((void *)0)
                                || s[1] == '\0'))
                    {
                        *p2 = '\0';
                        ++p1;
                        if (ga_grow(&ga, 1) == 0)
                        {
                            got_int = 1;
                            break;
                        }
                        s = alloc((unsigned)(p2 - p1 + strlen((char *)(fname)) + 2));
                        if (s == ((void *)0))
                        {
                            got_int = 1;
                            break;
                        }
                        ((char_u **)ga.ga_data)[ga.ga_len] = s;
                        ++ga.ga_len;
                        --ga.ga_room;
                        sprintf((char *)s, "%s\t%s", p1, fname);
                        p2 = vim_strchr(p2 + 1, '*');
                    }
                }
                p1 = p2;
            }
            line_breakcheck();
        }
        fclose(fd);
    }
    FreeWild(filecount, files);
    if (!got_int)
    {
        sort_strings((char_u **)ga.ga_data, ga.ga_len);
        for (i = 1; i < ga.ga_len; ++i)
        {
            p1 = ((char_u **)ga.ga_data)[i - 1];
            p2 = ((char_u **)ga.ga_data)[i];
            while (*p1 == *p2)
            {
                if (*p2 == '\t')
                {
                    *p2 = '\000';
                    sprintf((char *)NameBuff,
                            ((char *)("E154: Duplicate tag \"%s\" in file %s")),
                            ((char_u **)ga.ga_data)[i], p2 + 1);
                    emsg((char_u *)(NameBuff));
                    *p2 = '\t';
                    break;
                }
                ++p1;
                ++p2;
            }
        }
        for (i = 0; i < ga.ga_len; ++i)
        {
            s = ((char_u **)ga.ga_data)[i];
            if (strncmp((char *)(s), (char *)("help-tags\t"), (size_t)(10)) == 0)
                fprintf(fd_tags, (char *)s);
            else
            {
                fprintf(fd_tags, "%s\t/*", s);
                for (p1 = s; *p1 != '\t'; ++p1)
                {
                    if (*p1 == '\\' || *p1 == '/')
                        _IO_putc ('\\', fd_tags);
                    _IO_putc (*p1, fd_tags);
                }
                fprintf(fd_tags, "*\n");
            }
        }
    }
    for (i = 0; i < ga.ga_len; ++i)
        vim_free(((char_u **)ga.ga_data)[i]);
    ga_clear(&ga);
    fclose(fd_tags);
}
static sign_T *first_sign = ((void *)0);
static int last_sign_typenr = 255;
static void sign_list_defined (sign_T *sp);
    void ex_sign(eap)
    exarg_T *eap;
{
    char_u *arg = eap->arg;
    char_u *p;
    int idx;
    sign_T *sp;
    sign_T *sp_prev;
    buf_T *buf;
    static char *cmds[] = {
                        "define",
                        "undefine",
                        "list",
                        "place",
                        "unplace",
                        "jump",
    };
    p = skiptowhite(arg);
    if (*p != '\000')
        *p++ = '\000';
    for (idx = 0; ; ++idx)
    {
        if (idx == 6)
        {
            emsg2((char_u *)(((char *)("E160: Unknown sign command: %s"))), (char_u *)(arg));
            return;
        }
        if (strcmp((char *)(arg), (char *)(cmds[idx])) == 0)
            break;
    }
    arg = skipwhite(p);
    if (idx <= 2)
    {
        if (idx == 2 && *arg == '\000')
        {
            for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
                sign_list_defined(sp);
        }
        else if (*arg == '\000')
            emsg((char_u *)(((char *)("E156: Missing sign name"))));
        else
        {
            p = skiptowhite(arg);
            if (*p != '\000')
                *p++ = '\000';
            sp_prev = ((void *)0);
            for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
            {
                if (strcmp((char *)(sp->sn_name), (char *)(arg)) == 0)
                    break;
                sp_prev = sp;
            }
            if (idx == 0)
            {
                if (sp == ((void *)0))
                {
                    sp = (sign_T *)alloc_clear((unsigned)sizeof(sign_T));
                    if (sp == ((void *)0))
                        return;
                    if (sp_prev == ((void *)0))
                        first_sign = sp;
                    else
                        sp_prev->sn_next = sp;
                    sp->sn_name = vim_strnsave(arg, (int)(p - arg));
                    if ((__ctype_b[(int) ((*arg))] & (unsigned short int) _ISdigit))
                        sp->sn_typenr = atoi((char *)arg);
                    else
                    {
                        sign_T *lp;
                        int start = last_sign_typenr;
                        for (lp = first_sign; lp != ((void *)0); lp = lp->sn_next)
                        {
                            if (lp->sn_typenr == last_sign_typenr)
                            {
                                --last_sign_typenr;
                                if (last_sign_typenr == 0)
                                    last_sign_typenr = 255;
                                if (last_sign_typenr == start)
                                {
                                    emsg((char_u *)(((char *)("E612: Too many signs defined"))));
                                    return;
                                }
                                lp = first_sign;
                                continue;
                            }
                        }
                        sp->sn_typenr = last_sign_typenr--;
                        if (last_sign_typenr == 0)
                            last_sign_typenr = 255;
                    }
                }
                for (;;)
                {
                    arg = skipwhite(p);
                    if (*arg == '\000')
                        break;
                    p = skiptowhite_esc(arg);
                    if (strncmp((char *)(arg), (char *)("icon="), (size_t)(5)) == 0)
                    {
                        arg += 5;
                        vim_free(sp->sn_icon);
                        sp->sn_icon = vim_strnsave(arg, (int)(p - arg));
                        backslash_halve(sp->sn_icon);
                        if (gui.in_use)
                        {
                            if (sp->sn_image != ((void *)0))
                                gui_mch_destroy_sign(sp->sn_image);
                            sp->sn_image = gui_mch_register_sign(sp->sn_icon);
                        }
                    }
                    else if (strncmp((char *)(arg), (char *)("text="), (size_t)(5)) == 0)
                    {
                        char_u *s;
                        int cells;
                        int len;
                        arg += 5;
                        {
                            for (s = arg; s < p; ++s)
                                if (!vim_isprintc(*s))
                                    break;
                            cells = s - arg;
                        }
                        if (s != p || cells < 1 || cells > 2)
                        {
                            *p = '\000';
                            emsg2((char_u *)(((char *)("E239: Invalid sign text: %s"))), (char_u *)(arg));
                            return;
                        }
                        vim_free(sp->sn_text);
                        len = p - arg + ((cells == 1) ? 1 : 0);
                        sp->sn_text = vim_strnsave(arg, len);
                        if (sp->sn_text != ((void *)0) && cells == 1)
                            strcpy((char *)(sp->sn_text + len - 1), (char *)(" "));
                    }
                    else if (strncmp((char *)(arg), (char *)("linehl="), (size_t)(7)) == 0)
                    {
                        arg += 7;
                        sp->sn_line_hl = syn_check_group(arg, (int)(p - arg));
                    }
                    else if (strncmp((char *)(arg), (char *)("texthl="), (size_t)(7)) == 0)
                    {
                        arg += 7;
                        sp->sn_text_hl = syn_check_group(arg, (int)(p - arg));
                    }
                    else
                    {
                        emsg2((char_u *)(((char *)(e_invarg2))), (char_u *)(arg));
                        return;
                    }
                }
            }
            else if (sp == ((void *)0))
                emsg2((char_u *)(((char *)("E155: Unknown sign: %s"))), (char_u *)(arg));
            else if (idx == 2)
                sign_list_defined(sp);
            else
            {
                vim_free(sp->sn_name);
                vim_free(sp->sn_icon);
                if (sp->sn_image != ((void *)0))
                    gui_mch_destroy_sign(sp->sn_image);
                vim_free(sp->sn_text);
                if (sp_prev == ((void *)0))
                    first_sign = sp->sn_next;
                else
                    sp_prev->sn_next = sp->sn_next;
                vim_free(sp);
            }
        }
    }
    else
    {
        int id = -1;
        linenr_T lnum = -1;
        char_u *sign_name = ((void *)0);
        char_u *arg1;
        if (*arg == '\000')
        {
            if (idx == 3)
            {
                sign_list_placed(((void *)0));
            }
            else if (idx == 4)
            {
                id = buf_findsign_id(curwin->w_buffer, curwin->w_cursor.lnum);
                if (id > 0)
                {
                    buf_delsign(curwin->w_buffer, id);
                    update_debug_sign(curwin->w_buffer, curwin->w_cursor.lnum);
                }
                else
                    emsg((char_u *)(((char *)("E159: Missing sign number"))));
            }
            else
                emsg((char_u *)(((char *)(e_argreq))));
            return;
        }
        if (idx == 4 && arg[0] == '*' && arg[1] == '\000')
        {
            buf_delete_all_signs();
            return;
        }
        arg1 = arg;
        if ((__ctype_b[(int) ((*arg))] & (unsigned short int) _ISdigit))
        {
            id = getdigits(&arg);
            if (!((*arg) == ' ' || (*arg) == '\t') && *arg != '\000')
            {
                id = -1;
                arg = arg1;
            }
            else
            {
                arg = skipwhite(arg);
                if (idx == 4 && *arg == '\000')
                {
                    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
                        if ((lnum = buf_delsign(buf, id)) != 0)
                            update_debug_sign(buf, lnum);
                    return;
                }
            }
        }
        for (;;)
        {
            if (strncmp((char *)(arg), (char *)("line="), (size_t)(5)) == 0)
            {
                arg += 5;
                lnum = atoi((char *)arg);
                arg = skiptowhite(arg);
            }
            else if (strncmp((char *)(arg), (char *)("name="), (size_t)(5)) == 0)
            {
                arg += 5;
                sign_name = arg;
                arg = skiptowhite(arg);
                if (*arg != '\000')
                    *arg++ = '\000';
            }
            else if (strncmp((char *)(arg), (char *)("file="), (size_t)(5)) == 0)
            {
                arg += 5;
                buf = buflist_findname(arg);
                break;
            }
            else if (strncmp((char *)(arg), (char *)("buffer="), (size_t)(7)) == 0)
            {
                arg += 7;
                buf = buflist_findnr(atoi((char *)arg));
                break;
            }
            else
            {
                emsg((char_u *)(((char *)(e_invarg))));
                return;
            }
            arg = skipwhite(arg);
        }
        if (buf == ((void *)0))
        {
            emsg2((char_u *)(((char *)("E158: Invalid buffer name: %s"))), (char_u *)(arg));
        }
        else if (id <= 0)
        {
            if (lnum >= 0 || sign_name != ((void *)0))
                emsg((char_u *)(((char *)(e_invarg))));
            else
                sign_list_placed(buf);
        }
        else if (idx == 5)
        {
            if (lnum >= 0 || sign_name != ((void *)0))
                emsg((char_u *)(((char *)(e_invarg))));
            else if ((lnum = buf_findsign(buf, id)) > 0)
            {
                if (buf_jump_open_win(buf) != ((void *)0))
                {
                    curwin->w_cursor.lnum = lnum;
                    check_cursor_lnum();
                    beginline(1);
                }
                else
                {
                    char_u *cmd;
                    cmd = alloc((unsigned)strlen((char *)(buf->b_fname)) + 25);
                    if (cmd == ((void *)0))
                        return;
                    sprintf((char *)cmd, "e +%ld %s", (long)lnum, buf->b_fname);
                    do_cmdline_cmd(cmd);
                    vim_free(cmd);
                }
                foldOpenCursor();
            }
            else
                emsgn((char_u *)(((char *)("E157: Invalid sign ID: %ld"))), (long)(id));
        }
        else if (idx == 4)
        {
            if (lnum >= 0 || sign_name != ((void *)0))
                emsg((char_u *)(((char *)(e_invarg))));
            else
            {
                lnum = buf_delsign(buf, id);
                update_debug_sign(buf, lnum);
            }
        }
        else if (sign_name != ((void *)0))
        {
            for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
                if (strcmp((char *)(sp->sn_name), (char *)(sign_name)) == 0)
                    break;
            if (sp == ((void *)0))
            {
                emsg2((char_u *)(((char *)("E155: Unknown sign: %s"))), (char_u *)(sign_name));
                return;
            }
            if (lnum > 0)
                buf_addsign(buf, id, lnum, sp->sn_typenr);
            else
                lnum = buf_change_sign_type(buf, id, sp->sn_typenr);
            update_debug_sign(buf, lnum);
        }
        else
            emsg((char_u *)(((char *)(e_invarg))));
    }
}
    void sign_gui_started()
{
    sign_T *sp;
    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_icon != ((void *)0))
            sp->sn_image = gui_mch_register_sign(sp->sn_icon);
}
    static void sign_list_defined(sp)
    sign_T *sp;
{
    char_u *p;
    smsg((char_u *)"sign %s", sp->sn_name);
    if (sp->sn_icon != ((void *)0))
    {
        msg_puts((char_u *)(" icon="));
        msg_outtrans(sp->sn_icon);
        if (sp->sn_image == ((void *)0))
            msg_puts((char_u *)(" (NOT FOUND)"));
    }
    if (sp->sn_text != ((void *)0))
    {
        msg_puts((char_u *)(" text="));
        msg_outtrans(sp->sn_text);
    }
    if (sp->sn_line_hl > 0)
    {
        msg_puts((char_u *)(" linehl="));
        p = get_highlight_name(((void *)0), sp->sn_line_hl - 1);
        if (p == ((void *)0))
            msg_puts((char_u *)("NONE"));
        else
            msg_puts(p);
    }
    if (sp->sn_text_hl > 0)
    {
        msg_puts((char_u *)(" texthl="));
        p = get_highlight_name(((void *)0), sp->sn_text_hl - 1);
        if (p == ((void *)0))
            msg_puts((char_u *)("NONE"));
        else
            msg_puts(p);
    }
}
    int sign_get_attr(typenr, line)
    int typenr;
    int line;
{
    sign_T *sp;
    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_typenr == typenr)
        {
            if (line)
            {
                if (sp->sn_line_hl > 0)
                    return syn_id2attr(sp->sn_line_hl);
            }
            else
            {
                if (sp->sn_text_hl > 0)
                    return syn_id2attr(sp->sn_text_hl);
            }
            break;
        }
    return 0;
}
    char_u * sign_get_text(typenr)
    int typenr;
{
    sign_T *sp;
    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_typenr == typenr)
            return sp->sn_text;
    return ((void *)0);
}
    void * sign_get_image(typenr)
    int typenr;
{
    sign_T *sp;
    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_typenr == typenr)
            return sp->sn_image;
    return ((void *)0);
}
    char_u * sign_typenr2name(typenr)
    int typenr;
{
    sign_T *sp;
    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_typenr == typenr)
            return sp->sn_name;
    return (char_u *)((char *)("[Deleted]"));
}
    void ex_drop(eap)
    exarg_T *eap;
{
    int split = 0;
    int incurwin = 0;
    char_u *arg;
    char_u *first = ((void *)0);
    win_T *wp;
    buf_T *buf;
    arg = vim_strsave(eap->arg);
    if (arg != ((void *)0))
    {
        first = fix_fname(arg);
        if (first != ((void *)0))
        {
            buf = buflist_findname(first);
            for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
            {
                if (wp->w_buffer == buf)
                {
                    incurwin = 1;
                    win_enter(wp, 1);
                    break;
                }
            }
            vim_free(first);
            if (incurwin)
            {
                set_arglist(eap->arg);
                curwin->w_arg_idx = 0;
                vim_free(arg);
                return;
            }
        }
        vim_free(arg);
    }
    if (!(buf_hide(curbuf)))
    {
        ++emsg_off;
        split = check_changed(curbuf, 1, 0, 0, 0);
        --emsg_off;
    }
    if (split)
    {
        eap->cmdidx = CMD_snext;
        eap->cmd[0] = 's';
    }
    else
        eap->cmdidx = CMD_next;
    ex_next(eap);
}
