enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
extern __const unsigned short int *__ctype_b;
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef unsigned char char_u;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
void expand_env (char_u *src, char_u *dst, int dstlen);
int fullpathcmp (char_u *s1, char_u *s2, int checkname);
long getdigits (char_u **pp);
void getout (int exitval);
void maketitle (void);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
void out_flush (void);
void resettitle (void);
char_u *skipwhite (char_u *p);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
typedef __u_int __mode_t;
typedef long int __off_t;
typedef long int __time_t;
__extension__ typedef unsigned long long int __u_quad_t;
typedef __u_int __gid_t;
typedef __u_int __nlink_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __u_quad_t __dev_t;
struct stat
  {
    __dev_t st_dev;
    unsigned short int __pad1;
    __ino_t st_ino;
    __mode_t st_mode;
    __nlink_t st_nlink;
    __uid_t st_uid;
    __gid_t st_gid;
    __dev_t st_rdev;
    unsigned short int __pad2;
    __off_t st_size;
    __blksize_t st_blksize;
    __blkcnt_t st_blocks;
    __time_t st_atime;
    unsigned long int __unused1;
    __time_t st_mtime;
    unsigned long int __unused2;
    __time_t st_ctime;
    unsigned long int __unused3;
    unsigned long int __unused4;
    unsigned long int __unused5;
  };
extern int stat (__const char *__restrict __file,
                 struct stat *__restrict __buf) ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
void u_sync (void);
void ui_delay (long msec, int ignoreinput);
void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
extern long Columns ;
extern long Rows
                            ;
extern int State ;
extern int cmdline_row;
typedef struct
{
    int hide;
    int browse;
    int split;
    int confirm;
} cmdmod_T;
extern cmdmod_T cmdmod;
extern int cmdwin_type ;
extern buf_T *curbuf ;
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
extern win_T *curwin;
extern win_T *firstwin;
extern int msg_row;
extern int msg_scroll ;
extern int msg_scrolled;
extern int need_mouse_correct ;
extern int need_wait_return ;
extern int usingNetbeans ;
void ga_init2 (garray_T *gap, int itemsize, int growsize);
extern int VIsual_active ;
int do_cmdline_cmd (char_u *cmd);void redraw_win_later (win_T *wp, int type);
void set_string_option_direct (char_u *name, int opt_idx, char_u *val, int opt_flags);
extern int msg_col;
enum key_extra
{
    KE_NAME = 3
    , KE_S_UP
    , KE_S_DOWN
    , KE_S_F1
    , KE_S_F2
    , KE_S_F3
    , KE_S_F4
    , KE_S_F5
    , KE_S_F6
    , KE_S_F7
    , KE_S_F8
    , KE_S_F9
    , KE_S_F10
    , KE_S_F11
    , KE_S_F12
    , KE_S_F13
    , KE_S_F14
    , KE_S_F15
    , KE_S_F16
    , KE_S_F17
    , KE_S_F18
    , KE_S_F19
    , KE_S_F20
    , KE_S_F21
    , KE_S_F22
    , KE_S_F23
    , KE_S_F24
    , KE_S_F25
    , KE_S_F26
    , KE_S_F27
    , KE_S_F28
    , KE_S_F29
    , KE_S_F30
    , KE_S_F31
    , KE_S_F32
    , KE_S_F33
    , KE_S_F34
    , KE_S_F35
    , KE_S_F36
    , KE_S_F37
    , KE_MOUSE
    , KE_LEFTMOUSE
    , KE_LEFTDRAG
    , KE_LEFTRELEASE
    , KE_MIDDLEMOUSE
    , KE_MIDDLEDRAG
    , KE_MIDDLERELEASE
    , KE_RIGHTMOUSE
    , KE_RIGHTDRAG
    , KE_RIGHTRELEASE
    , KE_IGNORE
    , KE_TAB
    , KE_S_TAB_OLD
    , KE_SNIFF
    , KE_XF1
    , KE_XF2
    , KE_XF3
    , KE_XF4
    , KE_XEND
    , KE_XHOME
    , KE_LEFTMOUSE_NM
    , KE_LEFTRELEASE_NM
    , KE_S_XF1
    , KE_S_XF2
    , KE_S_XF3
    , KE_S_XF4
    , KE_MOUSEDOWN
    , KE_MOUSEUP
    , KE_KINS
    , KE_KDEL
    , KE_CSI
    , KE_SNR
    , KE_PLUG
    , KE_CMDWIN
    , KE_C_LEFT
    , KE_C_RIGHT
    , KE_C_HOME
    , KE_C_END
    , KE_X1MOUSE
    , KE_X1DRAG
    , KE_X1RELEASE
    , KE_X2MOUSE
    , KE_X2DRAG
    , KE_X2RELEASE
    , KE_DROP
};
int chartabsize (char_u *p, colnr_T col);
int coladvance (colnr_T wcol);
int copy_option_part (char_u **option, char_u *buf, int maxlen, char *sep_chars);
void gui_update_cursor (int force, int clear_selection);
int im_get_status (void);
void ins_str (char_u *s);
char_u *ml_get_curline (void);
char_u *ml_get_cursor (void);
win_T *mouse_find_win (int *rowp, int *colp);
int mouse_has (int c);
void setcursor (void);
void showruler (int always);
extern int strncasecmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
int u_save_cursor (void);
void update_screen (int type);
void update_topline (void);
void validate_cursor (void);
extern char_u *ScreenLines ;
extern int emsg_on_display ;
extern int no_u_sync ;
extern long p_so;
int do_dialog (int type, char_u *title, char_u *message, char_u *buttons, int dfltbutton, char_u *textfield);
int ends_excmd (int c);
void ga_append (garray_T *gap, int c);
void ga_clear (garray_T *gap);
void ga_concat (garray_T *gap, char_u *s);
int mch_isFullName (char_u *fname);
void msg_clr_eos (void);
void set_option_value (char_u *name, long number, char_u *string, int opt_flags);
int syn_name2id (char_u *name);
extern int msg_didout ;
extern char_u *p_go;
extern int starting ;
void cursor_on (void);
void display_errors (void);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
void ex_next (exarg_T *eap);
extern __uid_t getuid (void) ;
void wait_return (int redraw);
extern int exiting ;
extern int exmode_active ;
extern int msg_didany ;
extern int secure ;
typedef char Boolean;
typedef void (*GPrintFunc) (const gchar *string);
typedef char *String;
typedef void (*GErrorFunc) (const gchar *str);
typedef void (*GWarningFunc) (const gchar *str);
typedef void (*XtErrorHandler)(
  String
);
typedef Boolean (*XtFilePredicate)(
   String
);
int do_in_runtimepath (char_u *name, int all, void (*callback)(char_u *fname));
int do_source (char_u *fname, int check_other, int is_vimrc);
void settmode (int tmode);
enum SpecialKey
{
    KS_NAME = 0,
    KS_CE,
    KS_AL,
    KS_CAL,
    KS_DL,
    KS_CDL,
    KS_CS,
    KS_CL,
    KS_CD,
    KS_UT,
    KS_DA,
    KS_DB,
    KS_VI,
    KS_VE,
    KS_VS,
    KS_ME,
    KS_MR,
    KS_MD,
    KS_SE,
    KS_SO,
    KS_CZH,
    KS_CZR,
    KS_UE,
    KS_US,
    KS_MS,
    KS_CM,
    KS_SR,
    KS_CRI,
    KS_VB,
    KS_KS,
    KS_KE,
    KS_TI,
    KS_TE,
    KS_BC,
    KS_CCS,
    KS_CCO,
    KS_CSF,
    KS_CSB,
    KS_XS,
    KS_MB,
    KS_CAF,
    KS_CAB,
    KS_LE,
    KS_ND,
    KS_CIS,
    KS_CIE,
    KS_TS,
    KS_FS,
    KS_CWP,
    KS_CWS,
    KS_CRV,
    KS_CSV,
    KS_OP
};
extern char_u *(term_strings[]);
int check_changed_any (int hidden);
void scrollup (long line_count, int byfold);
void cursor_correct (void);
typedef struct oparg
{
    int op_type;
    int regname;
    int motion_type;
    int motion_force;
    int use_reg_one;
    int inclusive;
    int end_adjusted;
    pos_T start;
    pos_T end;
    long line_count;
    int empty;
    int is_VIsual;
    int block_mode;
    colnr_T start_vcol;
    colnr_T end_vcol;
} oparg_T;
int do_search (oparg_T *oap, int dirc, char_u *pat, long count, int options);
void scrolldown (long line_count, int byfold);
void shell_resized (void);
extern int finish_op ;
extern int hold_gui_events ;
extern frame_T *topframe;
int mouse_model_popup (void);
typedef unsigned long Atom;
typedef gulong GdkAtom;
typedef struct VimClipboard
{
    int available;
    int owned;
    pos_T start;
    pos_T end;
    int vmode;
    short_u origin_row;
    short_u origin_start_col;
    short_u origin_end_col;
    short_u word_start_col;
    short_u word_end_col;
    pos_T prev;
    short_u state;
    short_u mode;
    Atom sel_atom;
    GdkAtom gtk_sel_atom;
} VimClipboard;
extern VimClipboard clip_star;
extern int close (int __fd) ;
typedef int __ssize_t;
typedef __ssize_t ssize_t;
extern ssize_t read (int __fd, void *__buf, size_t __nbytes) ;
int curwin_col_off (void);
int get_real_state (void);
void update_mouseshape (int shape_idx);
void updatescript (int c);
extern int pipe (int __pipedes[2]) ;
extern void _exit (int __status) __attribute__ ((__noreturn__));
extern __pid_t setsid (void) ;
extern __pid_t fork (void) ;
extern long p_ut;
int has_cursorhold (void);
typedef struct VimMenu vimmenu_T;
struct VimMenu
{
    int modes;
    int enabled;
    char_u *name;
    char_u *dname;
    int mnemonic;
    char_u *actext;
    int priority;
    void (*cb)();
    char_u *iconfile;
    int iconidx;
    int icon_builtin;
    char_u *strings[6];
    int noremap[6];
    char silent[6];
    vimmenu_T *children;
    vimmenu_T *parent;
    vimmenu_T *next;
    GtkWidget *id;
    GtkWidget *submenu_id;
    GtkWidget *tearoff_handle;
    GtkWidget *label;
};
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
typedef struct attr_entry
{
    short ae_attr;
    union
    {
        struct
        {
            char_u *start;
            char_u *stop;
        } term;
        struct
        {
            char_u fg_color;
            char_u bg_color;
        } cterm;
        struct
        {
            guicolor_T fg_color;
            guicolor_T bg_color;
            GuiFont font;
        } gui;
    } ae_u;
} attrentry_T;
extern int p_exrc;
extern char_u *p_guifont;
extern int p_mousef;
extern int p_secure;
void sign_gui_started (void);
void gui_create_initial_menus (vimmenu_T *menu);
void gui_mch_toggle_tearoffs (int enable);
void validate_cline_row (void);
void im_set_position (int row, int col);
void xim_set_status_area (void);
void init_gui_options (void);
void set_title_defaults (void);
int option_was_set (char_u *name);
void updateWindow (win_T *wp);
char_u *hl_get_font_name (void);
void hl_set_bg_color_name (char_u *name);
void hl_set_fg_color_name (char_u *name);
attrentry_T *syn_gui_attr2entry (int attr);
int syn_id2colors (int hl_id, guicolor_T *fgp, guicolor_T *bgp);
void free_highlight_fonts (void);
void add_long_to_buf (long_u val, char_u *dst);
void clip_may_redraw_selection (int row, int col, int len);
void ui_focus_change (int in_focus);
void gui_set_cursor (int row, int col);
void gui_position_menu (void);
void gui_reset_scroll_region (void);
void gui_start_highlight (int mask);
void gui_stop_highlight (int mask);
int gui_outstr_nowrap (char_u *s, int len, int flags, guicolor_T fg, guicolor_T bg, int back);
int gui_xy2colrow (int x, int y, int *colp);
void gui_set_fg_color (char_u *name);
void gui_set_bg_color (char_u *name);
void gui_update_screen (void);
void gui_mch_set_text_area_pos (int x, int y, int w, int h);
void gui_mch_set_scrollbar_thumb (scrollbar_T *sb, long val, long size, long max);
void gui_mch_set_scrollbar_pos (scrollbar_T *sb, int x, int y, int w, int h);
void gui_mch_create_scrollbar (scrollbar_T *sb, int orient);
void gui_mch_prepare (int *argc, char **argv);
void gui_mch_set_blinking (long waittime, long on, long off);
int gui_mch_init_check (void);
int gui_mch_init (void);
int gui_mch_open (void);
void gui_mch_exit (int rc);
void gui_mch_set_shellsize (int width, int height, int min_width, int min_height, int base_width, int base_height);
void gui_mch_get_screen_dimensions (int *screen_w, int *screen_h);
void gui_mch_enable_menu (int showit);
void gui_mch_show_toolbar (int showit);
int gui_mch_init_font (char_u *font_name, int fontset);
void gui_mch_set_font (GuiFont font);
guicolor_T gui_mch_get_color (char_u *name);
void gui_mch_set_bg_color (guicolor_T color);
void gui_mch_draw_string (int row, int col, char_u *s, int len, int flags);
void gui_mch_beep (void);
void gui_mch_flash (int msec);
void gui_mch_draw_hollow_cursor (guicolor_T color);
void gui_mch_draw_part_cursor (int w, int h, guicolor_T color);
int gui_mch_wait_for_chars (long wtime);
void gui_mch_clear_block (int row1, int col1, int row2, int col2);
void gui_mch_clear_all (void);
void gui_mch_delete_lines (int row, int num_lines);
void gui_mch_insert_lines (int row, int num_lines);
void gui_mch_enable_scrollbar (scrollbar_T *sb, int flag);
int gui_mch_get_mouse_x (void);
void gui_mch_setmouse (int x, int y);
void gui_mch_drawsign (int row, int col, int typenr);
void netbeans_draw_multisign_indicator (int row);
extern char_u *use_gvimrc ;
extern int new_pixel_width ;
extern int new_pixel_height ;
void add_to_input_buf (char_u *s, int len);
int check_col (int col);
int check_row (int row);
void check_shellsize (void);
int stl_connected (win_T *wp);
void clip_clear_selection (void);
extern int screen_Rows ;
extern int screen_Columns ;
void clip_init (int can_use);
void clip_may_clear_selection (int row1, int row2);
void clip_scroll_selection (int rows);
int gui_redraw_block (int row1, int col1, int row2, int col2, int flags);
extern int screen_cleared ;
extern int updating_screen ;
typedef unsigned int int_u;
void clip_start_selection (int col, int row, int repeated_click);
void clip_process_selection (int button, int col, int row, int_u repeated_click);
void gui_set_shellsize (int mustset, int fit_to_display);
extern linenr_T gui_prev_topline ;
extern int gui_prev_topfill ;
int del_bytes (long count, int fixpos);
__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _blksize;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
extern int fflush (FILE *__stream) ;
void gui_update_menus (int modes);
int xim_get_status_area_height (void);
int gui_get_base_width (void);
int gui_get_base_height (void);
void gui_resize_shell (int pixel_width, int pixel_height);
void gui_clear_block (int row1, int col1, int row2, int col2);
void gui_mch_stop_blink (void);
void gui_mch_start_blink (void);
void gui_mch_set_fg_color (guicolor_T color);
extern char *font_argument ;
typedef struct cursor_entry
{
    int shape;
    int mshape;
    int percentage;
    long blinkwait;
    long blinkon;
    long blinkoff;
    int id;
    int id_lm;
    char *name;
    char used_for;
} cursorentry_T;
int get_shape_idx (int mouse);
int gui_mch_get_mouse_y (void);
extern cursorentry_T shape_table[17];
guint gtk_main_level (void);
void gtk_main_quit (void);
int win_hasvertsplit (void);
void gui_init_which_components (char_u *oldval);
void gui_create_scrollbar (scrollbar_T *sb, int type, win_T *wp);
int gui_find_bitmap (char_u *name, char_u *buffer, char *ext);
guicolor_T gui_get_color (char_u *name);
int process_env (char_u *env, int is_viminit);
void termcapinit (char_u *name);
int gui_init_check (void);
void netbeans_startup_done (void);
int gui_init_font (char_u *font_list, int fontset);
long_u gui_mch_get_rgb (guicolor_T pixel);
void gui_mch_flush (void);
void gui_mch_update (void);
void gui_start (void);
void gui_undraw_cursor (void);
void gui_update_scrollbars (int force);
int input_available (void);
extern int isatty (int __fd) ;
char_u *last_search_pat (void);
int leftcol_changed (void);
void mch_errmsg (char *str);
void out_str (char_u *s);
void xim_set_focus (int focus);
extern guicolor_T xim_fg_color ;
extern guicolor_T xim_bg_color ;
typedef __pid_t pid_t;
extern unsigned *LineOffset ;
extern char_u *ScreenAttrs ;
extern int current_scrollbar;
extern long_u scrollbar_value;
extern int drag_status_line ;
extern int drag_sep_line ;
extern garray_T error_ga
        ;
extern int full_screen ;
extern FILE *stderr;
extern int newline_on_exit ;
extern vimmenu_T *root_menu ;
extern int sys_menu ;
gui_T gui;
static void gui_check_pos (void);
static void gui_position_components (int);
static void gui_outstr (char_u *, int);
static int gui_screenchar (int off, int flags, guicolor_T fg, guicolor_T bg, int back);
static void gui_delete_lines (int row, int count);
static void gui_insert_lines (int row, int count);
static void fill_mouse_coord (char_u *p, int col, int row);
static void gui_do_scrollbar (win_T *wp, int which, int enable);
static void gui_update_horiz_scrollbar (int);
static win_T *xy2win (int x, int y);
static int can_update_cursor = 1;
    void gui_start()
{
    char_u *old_term;
    int dofork = 1;
    static int recursive = 0;
    old_term = vim_strsave((term_strings[(int)(KS_NAME)]));
    settmode(0);
    if (full_screen)
        cursor_on();
    gui.starting = 1;
    full_screen = 0;
    if (!gui.dofork || vim_strchr(p_go, 'f') || recursive)
        dofork = 0;
    ++recursive;
    termcapinit((char_u *)"builtin_gui");
    gui.starting = recursive - 1;
    if (!gui.in_use)
    {
        termcapinit(old_term);
        settmode(2);
        set_title_defaults();
    }
    vim_free(old_term);
    if (gui.in_use)
        display_errors();
    if (gui.in_use && dofork)
    {
        int pipefd[2];
        int pipe_error;
        char dummy;
        pid_t pid = -1;
        pipe_error = (pipe(pipefd) < 0);
        pid = fork();
        if (pid > 0)
        {
            if (pipe_error)
                ui_delay(300L, 1);
            else
            {
                close(pipefd[1]);
                (void)read(pipefd[0], &dummy, (size_t)1);
                close(pipefd[0]);
            }
            if (newline_on_exit)
                mch_errmsg("\r\n");
            _exit(0);
        }
        if (pid == 0)
            (void)setsid();
        if (!pipe_error)
        {
            close(pipefd[0]);
            close(pipefd[1]);
        }
    }
    if (gui.in_use)
        apply_autocmds(EVENT_GUIENTER, ((void *)0), ((void *)0), 0, curbuf);
    --recursive;
}
    void gui_prepare(argc, argv)
    int *argc;
    char **argv;
{
    gui.in_use = 0;
    gui.starting = 0;
    gui_mch_prepare(argc, argv);
}
    int gui_init_check()
{
    static int result = 2;
    if (result != 2)
    {
        if (result == 0)
            emsg((char_u *)(((char *)("E229: Cannot start the GUI"))));
        return result;
    }
    gui.shell_created = 0;
    gui.dying = 0;
    gui.in_focus = 1;
    gui.dragged_sb = -1;
    gui.dragged_wp = ((void *)0);
    gui.pointer_hidden = 0;
    gui.col = 0;
    gui.row = 0;
    gui.num_cols = Columns;
    gui.num_rows = Rows;
    gui.cursor_is_valid = 0;
    gui.scroll_region_top = 0;
    gui.scroll_region_bot = Rows - 1;
    gui.scroll_region_left = 0;
    gui.scroll_region_right = Columns - 1;
    gui.highlight_mask = 0x00;
    gui.char_width = 1;
    gui.char_height = 1;
    gui.char_ascent = 0;
    gui.border_width = 0;
    gui.norm_font = (GuiFont)((void *)0);
    gui.bold_font = (GuiFont)((void *)0);
    gui.ital_font = (GuiFont)((void *)0);
    gui.boldital_font = (GuiFont)((void *)0);
    gui.menu_font = (GuiFont)((void *)0);
    gui.menu_is_active = 1;
    gui.scrollbar_width = gui.scrollbar_height = 16;
    gui.prev_wrap = -1;
    result = gui_mch_init_check();
    return result;
}
    void gui_init()
{
    win_T *wp;
    static int recursive = 0;
    if (!recursive)
    {
        ++recursive;
        clip_init(1);
        if (gui_init_check() == 0)
        {
            --recursive;
            clip_init(0);
            return;
        }
        if (vim_strchr(p_go, 'M') == ((void *)0))
        {
            sys_menu = 1;
            do_source((char_u *)"$VIMRUNTIME/menu.vim", 0, 0);
            sys_menu = 0;
        }
        if (!option_was_set((char_u *)"mouse"))
            set_string_option_direct((char_u *)"mouse", -1,
                                                     (char_u *)"a", 1);
        if (use_gvimrc != ((void *)0))
        {
            if (strcmp((char *)(use_gvimrc), (char *)("NONE")) != 0
                    && strcmp((char *)(use_gvimrc), (char *)("NORC")) != 0
                    && do_source(use_gvimrc, 0, 0) != 1)
                emsg2((char_u *)(((char *)("E230: Cannot read from \"%s\""))), (char_u *)(use_gvimrc));
        }
        else
        {
            do_source((char_u *)"$VIM/gvimrc", 0, 0);
            if (process_env((char_u *)"GVIMINIT", 0) == 0
                 && do_source((char_u *)"$HOME/.gvimrc", 1, 0) == 0
                                )
            {
            }
            if (p_exrc)
            {
                {
                    struct stat s;
                    if (stat((".gvimrc"), (&s)) || s.st_uid != getuid())
                        secure = p_secure;
                }
                if ( fullpathcmp((char_u *)"$HOME/.gvimrc",
                                     (char_u *)".gvimrc", 0) != 1
                        && fullpathcmp((char_u *)"$VIM/gvimrc",
                                     (char_u *)".gvimrc", 0) != 1
                        )
                    do_source((char_u *)".gvimrc", 1, 0);
                if (secure == 2)
                    need_wait_return = 1;
                secure = 0;
            }
        }
        if (need_wait_return || msg_didany)
            wait_return(1);
        --recursive;
    }
    if (gui.in_use)
        return;
    gui.in_use = 1;
    if (gui_mch_init() == 0)
        goto error;
    emsg_on_display = 0;
    msg_scrolled = 0;
    need_wait_return = 0;
    msg_didany = 0;
    if (gui.border_width < 0)
        gui.border_width = 0;
    if (font_argument != ((void *)0))
        set_option_value((char_u *)"gfn", 0L, (char_u *)font_argument, 0);
    if (
            gui_init_font(*p_guifont == '\000' ? hl_get_font_name()
                                                  : p_guifont, 0) == 0)
        goto error2;
    gui.num_cols = Columns;
    gui.num_rows = Rows;
    gui_reset_scroll_region();
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
    {
        gui_create_scrollbar(&wp->w_scrollbars[0], 0, wp);
        gui_create_scrollbar(&wp->w_scrollbars[1], 1, wp);
    }
    gui_create_scrollbar(&gui.bottom_sbar, 2, ((void *)0));
    gui_create_initial_menus(root_menu);
    sign_gui_started();
    gui_init_which_components(((void *)0));
    gui.shell_created = 1;
    if (gui_mch_open() != 0)
    {
        maketitle();
        resettitle();
        init_gui_options();
        gui_mch_update();
        gui_set_shellsize(0, 1);
        if (starting == 0 && usingNetbeans)
            netbeans_startup_done();
        return;
    }
error2:
error:
    gui.in_use = 0;
    clip_init(0);
}
    void gui_exit(rc)
    int rc;
{
    free_highlight_fonts();
    gui.in_use = 0;
    gui_mch_exit(rc);
}
    void gui_shell_closed()
{
    cmdmod_T save_cmdmod;
    save_cmdmod = cmdmod;
    exiting = 1;
    cmdmod.browse = 1;
    cmdmod.confirm = 1;
    if (!check_changed_any(0))
        getout(0);
    exiting = 0;
    cmdmod = save_cmdmod;
    setcursor();
    out_flush();
}
    int gui_init_font(font_list, fontset)
    char_u *font_list;
    int fontset;
{
    char_u font_name[320];
    int font_list_empty = 0;
    int ret = 0;
    if (!gui.in_use)
        return 0;
    font_name[0] = '\000';
    if (*font_list == '\000')
        font_list_empty = 1;
    else
    {
            while (*font_list != '\000')
            {
                (void)copy_option_part(&font_list, font_name, 320, ",");
                if (gui_mch_init_font(font_name, 0) == 1)
                {
                    ret = 1;
                    break;
                }
            }
    }
    if (ret != 1
            && strcmp((char *)(font_list), (char *)("*")) != 0
            && (font_list_empty || gui.norm_font == (GuiFont)((void *)0)))
    {
        ret = gui_mch_init_font(((void *)0), 0);
    }
    if (ret == 1)
    {
            gui_mch_set_font(gui.norm_font);
        gui_set_shellsize(0,
                0
                );
    }
    return ret;
}
    void gui_set_cursor(row, col)
    int row;
    int col;
{
    gui.row = row;
    gui.col = col;
}
    static void gui_check_pos()
{
    if (gui.row >= screen_Rows)
        gui.row = screen_Rows - 1;
    if (gui.col >= screen_Columns)
        gui.col = screen_Columns - 1;
    if (gui.cursor_row >= screen_Rows || gui.cursor_col >= screen_Columns)
        gui.cursor_is_valid = 0;
}
    void gui_update_cursor(force, clear_selection)
    int force;
    int clear_selection;
{
    int cur_width = 0;
    int cur_height = 0;
    int old_hl_mask;
    int idx;
    int id;
    guicolor_T cfg, cbg, cc;
    int cattr;
    int attr;
    attrentry_T *aep = ((void *)0);
    if (!can_update_cursor)
        return;
    gui_check_pos();
    if (!gui.cursor_is_valid || force
                    || gui.row != gui.cursor_row || gui.col != gui.cursor_col)
    {
        gui_undraw_cursor();
        if (gui.row < 0)
            return;
        if (gui.row != gui.cursor_row || gui.col != gui.cursor_col)
            im_set_position(gui.row, gui.col);
        gui.cursor_row = gui.row;
        gui.cursor_col = gui.col;
        if (!screen_cleared || ScreenLines == ((void *)0))
            return;
        if (clear_selection)
            clip_may_clear_selection(gui.row, gui.row);
        if (gui.row >= screen_Rows || gui.col >= screen_Columns)
            return;
        gui.cursor_is_valid = 1;
        idx = get_shape_idx(0);
        if (State & 0x20)
            id = shape_table[idx].id_lm;
        else
            id = shape_table[idx].id;
        cfg = (guicolor_T)-11111;
        cbg = (guicolor_T)-11111;
        cattr = 0x01;
        gui_mch_set_blinking(shape_table[idx].blinkwait,
                             shape_table[idx].blinkon,
                             shape_table[idx].blinkoff);
        if (id > 0)
        {
            cattr = syn_id2colors(id, &cfg, &cbg);
            {
                static int iid;
                guicolor_T fg, bg;
                if (im_get_status())
                {
                    iid = syn_name2id((char_u *)"CursorIM");
                    if (iid > 0)
                    {
                        syn_id2colors(iid, &fg, &bg);
                        if (bg != (guicolor_T)-11111)
                            cbg = bg;
                        if (fg != (guicolor_T)-11111)
                            cfg = fg;
                    }
                }
            }
        }
        attr = ScreenAttrs[LineOffset[gui.row] + gui.col];
        if (attr > 0x1f)
            aep = syn_gui_attr2entry(attr);
        if (aep != ((void *)0))
        {
            attr = aep->ae_attr;
            if (cfg == (guicolor_T)-11111)
                cfg = ((attr & 0x01) ? aep->ae_u.gui.bg_color
                                            : aep->ae_u.gui.fg_color);
            if (cbg == (guicolor_T)-11111)
                cbg = ((attr & 0x01) ? aep->ae_u.gui.fg_color
                                            : aep->ae_u.gui.bg_color);
        }
        if (cfg == (guicolor_T)-11111)
            cfg = (attr & 0x01) ? gui.back_pixel : gui.norm_pixel;
        if (cbg == (guicolor_T)-11111)
            cbg = (attr & 0x01) ? gui.norm_pixel : gui.back_pixel;
        if (aep != ((void *)0))
        {
            xim_bg_color = ((attr & 0x01) ? aep->ae_u.gui.fg_color
                                                : aep->ae_u.gui.bg_color);
            xim_fg_color = ((attr & 0x01) ? aep->ae_u.gui.bg_color
                                                : aep->ae_u.gui.fg_color);
            if (xim_bg_color == (guicolor_T)-11111)
                xim_bg_color = (attr & 0x01) ? gui.norm_pixel
                                                   : gui.back_pixel;
            if (xim_fg_color == (guicolor_T)-11111)
                xim_fg_color = (attr & 0x01) ? gui.back_pixel
                                                   : gui.norm_pixel;
        }
        else
        {
            xim_bg_color = (attr & 0x01) ? gui.norm_pixel
                                               : gui.back_pixel;
            xim_fg_color = (attr & 0x01) ? gui.back_pixel
                                               : gui.norm_pixel;
        }
        attr &= ~0x01;
        if (cattr & 0x01)
        {
            cc = cbg;
            cbg = cfg;
            cfg = cc;
        }
        cattr &= ~0x01;
        if (!gui.in_focus)
        {
            gui_mch_draw_hollow_cursor(cbg);
            return;
        }
        old_hl_mask = gui.highlight_mask;
        if (shape_table[idx].shape == 0
           )
        {
            gui.highlight_mask = (cattr | attr);
                (void)gui_screenchar(LineOffset[gui.row] + gui.col,
                        0x04 | 0x10, cfg, cbg, 0);
        }
        else
        {
            if (shape_table[idx].shape == 2)
            {
                cur_height = gui.char_height;
                cur_width = (gui.char_width * shape_table[idx].percentage
                                                                  + 99) / 100;
            }
            else
            {
                cur_height = (gui.char_height * shape_table[idx].percentage
                                                                  + 99) / 100;
                cur_width = gui.char_width;
            }
            gui_mch_draw_part_cursor(cur_width, cur_height, cbg);
            gui.highlight_mask = ScreenAttrs[LineOffset[gui.row] + gui.col];
            (void)gui_screenchar(LineOffset[gui.row] + gui.col,
                    0x08 | 0x10,
                    (guicolor_T)0, (guicolor_T)0, 0);
        }
        gui.highlight_mask = old_hl_mask;
    }
}
    void gui_position_menu()
{
}
    static void gui_position_components(total_width)
    int total_width;
{
    int text_area_x;
    int text_area_y;
    int text_area_width;
    int text_area_height;
    ++hold_gui_events;
    text_area_x = 0;
    if (gui.which_scrollbars[0])
        text_area_x += gui.scrollbar_width;
    text_area_y = 0;
    text_area_width = gui.num_cols * gui.char_width + gui.border_offset * 2;
    text_area_height = gui.num_rows * gui.char_height + gui.border_offset * 2;
    gui_mch_set_text_area_pos(text_area_x,
                              text_area_y,
                              text_area_width,
                              text_area_height
                                  + xim_get_status_area_height()
                              );
    gui_position_menu();
    if (gui.which_scrollbars[2])
        gui_mch_set_scrollbar_pos(&gui.bottom_sbar,
                                  text_area_x,
                                  text_area_y + text_area_height,
                                  text_area_width,
                                  gui.scrollbar_height);
    gui.left_sbar_x = 0;
    gui.right_sbar_x = text_area_x + text_area_width;
    --hold_gui_events;
}
    int gui_get_base_width()
{
    int base_width;
    base_width = 2 * gui.border_offset;
    if (gui.which_scrollbars[0])
        base_width += gui.scrollbar_width;
    if (gui.which_scrollbars[1])
        base_width += gui.scrollbar_width;
    return base_width;
}
    int gui_get_base_height()
{
    int base_height;
    base_height = 2 * gui.border_offset;
    if (gui.which_scrollbars[2])
        base_height += gui.scrollbar_height;
    return base_height;
}
    void gui_resize_shell(pixel_width, pixel_height)
    int pixel_width;
    int pixel_height;
{
    static int busy = 0;
    if (!gui.shell_created)
        return;
    if (updating_screen || busy)
    {
        new_pixel_width = pixel_width;
        new_pixel_height = pixel_height;
        return;
    }
again:
    busy = 1;
    out_flush();
    gui.num_cols = (pixel_width - gui_get_base_width()) / gui.char_width;
    gui.num_rows = (pixel_height - gui_get_base_height()
                                    + (gui.char_height / 2)
                                        ) / gui.char_height;
    gui_position_components(pixel_width);
    gui_reset_scroll_region();
    if (State == 0x300 || State == 0x800)
        gui.row = gui.num_rows;
    if (gui.num_rows != screen_Rows || gui.num_cols != screen_Columns)
        shell_resized();
    gui_update_scrollbars(1);
    gui_update_cursor(0, 1);
    xim_set_status_area();
    busy = 0;
    if (new_pixel_height)
    {
        pixel_width = new_pixel_width;
        pixel_height = new_pixel_height;
        new_pixel_width = 0;
        new_pixel_height = 0;
        goto again;
    }
}
    void gui_may_resize_shell()
{
    int h, w;
    if (new_pixel_height)
    {
        w = new_pixel_width;
        h = new_pixel_height;
        new_pixel_width = 0;
        new_pixel_height = 0;
        gui_resize_shell(w, h);
    }
}
    int gui_get_shellsize()
{
    Rows = gui.num_rows;
    Columns = gui.num_cols;
    return 1;
}
    void gui_set_shellsize(mustset, fit_to_display)
    int mustset;
    int fit_to_display;
{
    int base_width;
    int base_height;
    int width;
    int height;
    int min_width;
    int min_height;
    int screen_w;
    int screen_h;
    if (!gui.shell_created)
        return;
    base_width = gui_get_base_width();
    base_height = gui_get_base_height();
    {
        width = Columns * gui.char_width + base_width;
        height = Rows * gui.char_height + base_height;
    }
    if (fit_to_display)
    {
        gui_mch_get_screen_dimensions(&screen_w, &screen_h);
        if (width > screen_w)
        {
            Columns = (screen_w - base_width) / gui.char_width;
            if (Columns < 12)
                Columns = 12;
            width = Columns * gui.char_width + base_width;
        }
        if (height > screen_h)
        {
            Rows = (screen_h - base_height) / gui.char_height;
            check_shellsize();
            height = Rows * gui.char_height + base_height;
        }
    }
    gui.num_cols = Columns;
    gui.num_rows = Rows;
    min_width = base_width + 12 * gui.char_width;
    min_height = base_height + 2 * gui.char_height;
    gui_mch_set_shellsize(width, height, min_width, min_height,
                                                     base_width, base_height);
    gui_position_components(width);
    gui_update_scrollbars(1);
    gui_reset_scroll_region();
}
    void gui_new_shellsize()
{
    gui_reset_scroll_region();
}
    void gui_reset_scroll_region()
{
    gui.scroll_region_top = 0;
    gui.scroll_region_bot = gui.num_rows - 1;
    gui.scroll_region_left = 0;
    gui.scroll_region_right = gui.num_cols - 1;
}
    void gui_start_highlight(mask)
    int mask;
{
    if (mask > 0x1f)
        gui.highlight_mask = mask;
    else
        gui.highlight_mask |= mask;
}
    void gui_stop_highlight(mask)
    int mask;
{
    if (mask > 0x1f)
        gui.highlight_mask = 0x00;
    else
        gui.highlight_mask &= ~mask;
}
    void gui_clear_block(row1, col1, row2, col2)
    int row1;
    int col1;
    int row2;
    int col2;
{
    clip_may_clear_selection(row1, row2);
    gui_mch_clear_block(row1, col1, row2, col2);
    if ( gui.cursor_row >= row1 && gui.cursor_row <= row2
            && gui.cursor_col >= col1 && gui.cursor_col <= col2)
        gui.cursor_is_valid = 0;
}
    void gui_update_cursor_later()
{
    out_str((char_u *)("\033|s"));
}
    void gui_write(s, len)
    char_u *s;
    int len;
{
    char_u *p;
    int arg1 = 0, arg2 = 0;
    int force_cursor = 0;
    int force_scrollbar = 0;
    static win_T *old_curwin = ((void *)0);
    while (len)
    {
        if (s[0] == '\033' && s[1] == '|')
        {
            p = s + 2;
            if ((__ctype_b[(int) ((*p))] & (unsigned short int) _ISdigit))
            {
                arg1 = getdigits(&p);
                if (p > s + len)
                    break;
                if (*p == ';')
                {
                    ++p;
                    arg2 = getdigits(&p);
                    if (p > s + len)
                        break;
                }
            }
            switch (*p)
            {
                case 'C':
                    clip_scroll_selection(9999);
                    gui_mch_clear_all();
                    gui.cursor_is_valid = 0;
                    force_scrollbar = 1;
                    break;
                case 'M':
                    gui_set_cursor(arg1, arg2);
                    break;
                case 's':
                    force_cursor = 1;
                    break;
                case 'R':
                    if (arg1 < arg2)
                    {
                        gui.scroll_region_top = arg1;
                        gui.scroll_region_bot = arg2;
                    }
                    else
                    {
                        gui.scroll_region_top = arg2;
                        gui.scroll_region_bot = arg1;
                    }
                    break;
                case 'V':
                    if (arg1 < arg2)
                    {
                        gui.scroll_region_left = arg1;
                        gui.scroll_region_right = arg2;
                    }
                    else
                    {
                        gui.scroll_region_left = arg2;
                        gui.scroll_region_right = arg1;
                    }
                    break;
                case 'd':
                    gui_delete_lines(gui.row, 1);
                    break;
                case 'D':
                    gui_delete_lines(gui.row, arg1);
                    break;
                case 'i':
                    gui_insert_lines(gui.row, 1);
                    break;
                case 'I':
                    gui_insert_lines(gui.row, arg1);
                    break;
                case '$':
                    gui_clear_block(gui.row, gui.col, gui.row,
                                                            (int)Columns - 1);
                    break;
                case 'h':
                    gui_start_highlight(arg1);
                    break;
                case 'H':
                    gui_stop_highlight(arg1);
                    break;
                case 'f':
                    gui_mch_flash(arg1 == 0 ? 20 : arg1);
                    break;
                default:
                    p = s + 1;
                    break;
            }
            len -= (int)(++p - s);
            s = p;
        }
        else if (
                s[0] < 0x20
                && s[0] != 1
                && s[0] != 2
                )
        {
            if (s[0] == '\n')
            {
                gui.col = 0;
                if (gui.row < gui.scroll_region_bot)
                    gui.row++;
                else
                    gui_delete_lines(gui.scroll_region_top, 1);
            }
            else if (s[0] == '\r')
            {
                gui.col = 0;
            }
            else if (s[0] == '\b')
            {
                if (gui.col)
                    --gui.col;
            }
            else if (s[0] == 12)
            {
                ++gui.col;
            }
            else if (s[0] == 7)
            {
                gui_mch_beep();
            }
            --len;
            ++s;
        }
        else
        {
            p = s;
            while (len > 0 && (
                        *p >= 0x20
                        || *p == 1
                        || *p == 2
                        ))
            {
                len--;
                p++;
            }
            gui_outstr(s, (int)(p - s));
            s = p;
        }
    }
    if (can_update_cursor && force_cursor)
        gui_update_cursor(force_cursor, 1);
    if (old_curwin != curwin)
        gui.dragged_sb = -1;
    if (force_scrollbar || old_curwin != curwin)
        gui_update_scrollbars(force_scrollbar);
    else
        gui_update_horiz_scrollbar(0);
    old_curwin = curwin;
    gui.dragged_sb = -1;
    gui_mch_flush();
}
    void gui_dont_update_cursor()
{
    can_update_cursor = 0;
}
    void gui_can_update_cursor()
{
    can_update_cursor = 1;
}
    static void gui_outstr(s, len)
    char_u *s;
    int len;
{
    int this_len;
    if (len == 0)
        return;
    if (len < 0)
        len = (int)strlen((char *)(s));
    while (len > 0)
    {
            if (gui.col + len > Columns)
            this_len = Columns - gui.col;
        else
            this_len = len;
        (void)gui_outstr_nowrap(s, this_len,
                                          0, (guicolor_T)0, (guicolor_T)0, 0);
        s += this_len;
        len -= this_len;
        if (gui.col >= Columns)
        {
            gui.col = 0;
            gui.row++;
        }
    }
}
    static int gui_screenchar(off, flags, fg, bg, back)
    int off;
    int flags;
    guicolor_T fg, bg;
    int back;
{
    return gui_outstr_nowrap(ScreenLines + off, 1, flags, fg, bg, back);
}
    int gui_outstr_nowrap(s, len, flags, fg, bg, back)
    char_u *s;
    int len;
    int flags;
    guicolor_T fg, bg;
    int back;
{
    long_u highlight_mask;
    long_u hl_mask_todo;
    guicolor_T fg_color;
    guicolor_T bg_color;
    GuiFont font = (GuiFont)((void *)0);
    attrentry_T *aep = ((void *)0);
    int draw_flags;
    int col = gui.col;
    int draw_sign = 0;
    int multi_sign = 0;
    if (len < 0)
        len = (int)strlen((char *)(s));
    if (len == 0)
        return 1;
    if (*s == 1
          || *s == 2
    )
    {
        if (*s == 2)
            multi_sign = 1;
        s = (char_u *)"  ";
        if (len == 1 && col > 0)
            --col;
        len = 2;
        draw_sign = 1;
        highlight_mask = 0;
    }
    else
    if (gui.highlight_mask > 0x1f)
    {
        aep = syn_gui_attr2entry(gui.highlight_mask);
        if (aep == ((void *)0))
            highlight_mask = 0;
        else
            highlight_mask = aep->ae_attr;
    }
    else
        highlight_mask = gui.highlight_mask;
    hl_mask_todo = highlight_mask;
    if (aep != ((void *)0) && aep->ae_u.gui.font != (GuiFont)((void *)0))
        font = aep->ae_u.gui.font;
    else
    {
            if (hl_mask_todo & (0x02 | 0x10))
        {
            if ((hl_mask_todo & 0x04) && gui.boldital_font != (GuiFont)((void *)0))
            {
                font = gui.boldital_font;
                hl_mask_todo &= ~(0x02 | 0x10 | 0x04);
            }
            else if (gui.bold_font != (GuiFont)((void *)0))
            {
                font = gui.bold_font;
                hl_mask_todo &= ~(0x02 | 0x10);
            }
            else
                font = gui.norm_font;
        }
        else if ((hl_mask_todo & 0x04) && gui.ital_font != (GuiFont)((void *)0))
        {
            font = gui.ital_font;
            hl_mask_todo &= ~0x04;
        }
        else
            font = gui.norm_font;
    }
        gui_mch_set_font(font);
    draw_flags = 0;
    bg_color = gui.back_pixel;
    if ((flags & 0x04) && gui.in_focus)
    {
        draw_flags |= 0x10;
        fg_color = fg;
        bg_color = bg;
    }
    else if (aep != ((void *)0))
    {
        fg_color = aep->ae_u.gui.fg_color;
        if (fg_color == (guicolor_T)-11111)
            fg_color = gui.norm_pixel;
        bg_color = aep->ae_u.gui.bg_color;
        if (bg_color == (guicolor_T)-11111)
            bg_color = gui.back_pixel;
    }
    else
        fg_color = gui.norm_pixel;
    if (highlight_mask & (0x01 | 0x10))
    {
        gui_mch_set_fg_color(bg_color);
        gui_mch_set_bg_color(fg_color);
    }
    else
    {
        gui_mch_set_fg_color(fg_color);
        gui_mch_set_bg_color(bg_color);
    }
    if (!(flags & 0x10))
        clip_may_clear_selection(gui.row, gui.row);
    if (hl_mask_todo & (0x02 | 0x10))
        draw_flags |= 0x02;
    if (back != 0 && ((draw_flags & 0x02) || (highlight_mask & 0x04)))
        return 0;
    if ((hl_mask_todo & 0x08)
            || (hl_mask_todo & 0x04)
       )
        draw_flags |= 0x04;
    if (flags & 0x08)
        draw_flags |= 0x01;
    {
        gui_mch_draw_string(gui.row, col, s, len, draw_flags);
    }
    if (!(flags & (0x04 | 0x08)))
        gui.col = col + len;
    if (flags & 0x10)
        clip_may_redraw_selection(gui.row, col, len);
    if (!(flags & (0x04 | 0x08)))
    {
        if (gui.cursor_row == gui.row
                && gui.cursor_col >= col
                && gui.cursor_col < col + len)
            gui.cursor_is_valid = 0;
    }
    if (draw_sign)
        gui_mch_drawsign(gui.row, col, gui.highlight_mask);
    if (multi_sign)
        netbeans_draw_multisign_indicator(gui.row);
    return 1;
}
    void gui_undraw_cursor()
{
    if (gui.cursor_is_valid)
    {
        if (gui_redraw_block(gui.cursor_row, gui.cursor_col,
                              gui.cursor_row, gui.cursor_col, 0x10)
                && gui.cursor_col > 0)
            (void)gui_redraw_block(gui.cursor_row, gui.cursor_col - 1,
                         gui.cursor_row, gui.cursor_col - 1, 0x10);
        gui.cursor_is_valid = 0;
    }
}
    void gui_redraw(x, y, w, h)
    int x;
    int y;
    int w;
    int h;
{
    int row1, col1, row2, col2;
    row1 = (((y) - gui.border_offset) / gui.char_height);
    col1 = (((x) - gui.border_offset) / gui.char_width);
    row2 = (((y + h - 1) - gui.border_offset) / gui.char_height);
    col2 = (((x + w - 1) - gui.border_offset) / gui.char_width);
    (void)gui_redraw_block(row1, col1, row2, col2, 0x10);
    if (gui.row == gui.cursor_row)
        gui_update_cursor(1, 1);
}
    int gui_redraw_block(row1, col1, row2, col2, flags)
    int row1;
    int col1;
    int row2;
    int col2;
    int flags;
{
    int old_row, old_col;
    long_u old_hl_mask;
    int off;
    char_u first_attr;
    int idx, len;
    int back, nback;
    int retval = 0;
    if (!screen_cleared || ScreenLines == ((void *)0))
        return retval;
    col1 = check_col(col1);
    col2 = check_col(col2);
    row1 = check_row(row1);
    row2 = check_row(row2);
    old_row = gui.row;
    old_col = gui.col;
    old_hl_mask = gui.highlight_mask;
    for (gui.row = row1; gui.row <= row2; gui.row++)
    {
        gui.col = col1;
        off = LineOffset[gui.row] + gui.col;
        len = col2 - col1 + 1;
        for (back = 0; back < col1; ++back)
            if (ScreenAttrs[off - 1 - back] != ScreenAttrs[off]
                    || ScreenLines[off - 1 - back] == ' ')
                break;
        retval = (col1 > 0 && ScreenAttrs[off - 1] != 0 && back == 0
                                              && ScreenLines[off - 1] != ' ');
        while (len > 0)
        {
            first_attr = ScreenAttrs[off];
            gui.highlight_mask = first_attr;
            {
                for (idx = 0; idx < len && ScreenAttrs[off + idx] == first_attr;
                                                                        idx++)
                {
                }
                nback = gui_outstr_nowrap(ScreenLines + off, idx, flags,
                                          (guicolor_T)0, (guicolor_T)0, back);
            }
            if (nback == 0)
            {
                off -= back;
                len += back;
                gui.col -= back;
            }
            else
            {
                off += idx;
                len -= idx;
            }
            back = 0;
        }
    }
    gui.row = old_row;
    gui.col = old_col;
    gui.highlight_mask = old_hl_mask;
    return retval;
}
    static void gui_delete_lines(row, count)
    int row;
    int count;
{
    if (count <= 0)
        return;
    if (row + count > gui.scroll_region_bot)
        gui_clear_block(row, gui.scroll_region_left,
                              gui.scroll_region_bot, gui.scroll_region_right);
    else
    {
        gui_mch_delete_lines(row, count);
        if (gui.cursor_row >= row
                && gui.cursor_col >= gui.scroll_region_left
                && gui.cursor_col <= gui.scroll_region_right)
        {
            if (gui.cursor_row < row + count)
                gui.cursor_is_valid = 0;
            else if (gui.cursor_row <= gui.scroll_region_bot)
                gui.cursor_row -= count;
        }
    }
}
    static void gui_insert_lines(row, count)
    int row;
    int count;
{
    if (count <= 0)
        return;
    if (row + count > gui.scroll_region_bot)
        gui_clear_block(row, gui.scroll_region_left,
                              gui.scroll_region_bot, gui.scroll_region_right);
    else
    {
        gui_mch_insert_lines(row, count);
        if (gui.cursor_row >= gui.row
                && gui.cursor_col >= gui.scroll_region_left
                && gui.cursor_col <= gui.scroll_region_right)
        {
            if (gui.cursor_row <= gui.scroll_region_bot - count)
                gui.cursor_row += count;
            else if (gui.cursor_row <= gui.scroll_region_bot)
                gui.cursor_is_valid = 0;
        }
    }
}
    int gui_wait_for_chars(wtime)
    long wtime;
{
    int retval;
    static int once_already = 0;
    if (wtime != 0)
    {
        gui_update_menus(0);
    }
    gui_mch_update();
    if (input_available())
    {
        once_already = 0;
        return 1;
    }
    if (wtime == 0)
    {
        once_already = 0;
        return 0;
    }
    gui_mch_flush();
    if (wtime > 0)
    {
        gui_mch_start_blink();
        retval = gui_mch_wait_for_chars(wtime);
        gui_mch_stop_blink();
        once_already = 0;
        return retval;
    }
    gui_mch_start_blink();
    if (once_already == 2)
    {
        updatescript(0);
        retval = gui_mch_wait_for_chars(-1L);
        once_already = 0;
    }
    else if (once_already == 1)
    {
        setcursor();
        once_already = 2;
        retval = 0;
    }
    else
        if (gui_mch_wait_for_chars(p_ut) != 1)
    {
        if (has_cursorhold() && get_real_state() == (0x100 + 0x01))
        {
            apply_autocmds(EVENT_CURSORHOLD, ((void *)0), ((void *)0), 0, curbuf);
            update_screen(10);
            showruler(0);
            setcursor();
            once_already = 1;
            retval = 0;
        }
        else
        {
            updatescript(0);
            retval = gui_mch_wait_for_chars(-1L);
            once_already = 0;
        }
    }
    else
        retval = 1;
    gui_mch_stop_blink();
    return retval;
}
    static void fill_mouse_coord(p, col, row)
    char_u *p;
    int col;
    int row;
{
    p[0] = (char_u)(col / 128 + ' ' + 1);
    p[1] = (char_u)(col % 128 + ' ' + 1);
    p[2] = (char_u)(row / 128 + ' ' + 1);
    p[3] = (char_u)(row % 128 + ' ' + 1);
}
    void gui_send_mouse_event(button, x, y, repeated_click, modifiers)
    int button;
    int x;
    int y;
    int repeated_click;
    int_u modifiers;
{
    static int prev_row = 0, prev_col = 0;
    static int prev_button = -1;
    static int num_clicks = 1;
    char_u string[10];
    enum key_extra button_char;
    int row, col;
    int checkfor;
    int did_clip = 0;
    switch (button)
    {
        case 0x300:
            button_char = KE_X1MOUSE;
            goto button_set;
        case 0x400:
            button_char = KE_X2MOUSE;
            goto button_set;
        case 0x100:
            button_char = KE_MOUSEDOWN;
            goto button_set;
        case 0x200:
            button_char = KE_MOUSEUP;
button_set:
            {
                if (hold_gui_events)
                    return;
                string[3] = 0x9b;
                string[4] = 253;
                string[5] = (int)button_char;
                row = gui_xy2colrow(x, y, &col);
                string[6] = (char_u)(col / 128 + ' ' + 1);
                string[7] = (char_u)(col % 128 + ' ' + 1);
                string[8] = (char_u)(row / 128 + ' ' + 1);
                string[9] = (char_u)(row % 128 + ' ' + 1);
                if (modifiers == 0)
                    add_to_input_buf(string + 3, 7);
                else
                {
                    string[0] = 0x9b;
                    string[1] = 252;
                    string[2] = 0;
                    if (modifiers & 0x04)
                        string[2] |= 0x02;
                    if (modifiers & 0x10)
                        string[2] |= 0x04;
                    if (modifiers & 0x08)
                        string[2] |= 0x08;
                    add_to_input_buf(string, 10);
                }
                return;
            }
    }
    if (clip_star.state == 1)
    {
        clip_process_selection(button, (((x) - gui.border_offset) / gui.char_width), (((y) - gui.border_offset) / gui.char_height), repeated_click);
        return;
    }
    switch (get_real_state())
    {
        case (0x100 + 0x01):
        case 0x04:
        case 0x01: checkfor = 'n'; break;
        case 0x02: checkfor = 'v'; break;
        case (0x40 + 0x10):
        case (0x40 + 0x10)+0x20:
        case (0x40 + 0x80 + 0x10):
        case (0x40 + 0x80 + 0x10)+0x20:
        case 0x10:
        case 0x10 +0x20: checkfor = 'i'; break;
        case 0x300:
        case (0x200 + 0x01):
                                if ((((y) - gui.border_offset) / gui.char_height) == Rows - 1)
                                    checkfor = 'n';
                                else
                                    checkfor = 'r';
                                break;
        case 0x08:
        case 0x08 +0x20:
            if ((((y) - gui.border_offset) / gui.char_height) < cmdline_row && button != 0x01)
                checkfor = ' ';
            else
                checkfor = 'c';
            break;
        default:
            checkfor = ' ';
            break;
    };
    if ((State == 0x01 || State == (0x100 + 0x01) || (State & 0x10))
            && (((y) - gui.border_offset) / gui.char_height) >= topframe->fr_height
            && button != (0x40 | 0x03)
            && !drag_status_line
            && !drag_sep_line
            )
        checkfor = ' ';
    if ((modifiers & 0x10) && (modifiers & 0x04))
        checkfor = 'x';
    if (exmode_active)
        checkfor = ' ';
    if (!mouse_has(checkfor) || checkfor == 'c')
    {
        if (checkfor != 'x' && VIsual_active && (State & 0x01))
            return;
        if (mouse_model_popup() && button == 0x00
                && (modifiers & 0x04) && !(modifiers & 0x10))
        {
            button = 0x02;
            modifiers &= ~ 0x04;
        }
        if (button == 0x02)
        {
            if (clip_star.state == 0)
            {
                if (State & 0x08)
                {
                    col = msg_col;
                    row = msg_row;
                }
                else
                {
                    col = curwin->w_wcol;
                    row = curwin->w_wrow + (curwin->w_winrow);
                }
                clip_start_selection(col, row, 0);
            }
            clip_process_selection(button, (((x) - gui.border_offset) / gui.char_width), (((y) - gui.border_offset) / gui.char_height),
                                                              repeated_click);
            did_clip = 1;
        }
        else if (button ==
                    0x00
                                )
        {
            clip_start_selection((((x) - gui.border_offset) / gui.char_width), (((y) - gui.border_offset) / gui.char_height), repeated_click);
            did_clip = 1;
        }
        if (button != 0x01)
        {
            if (!mouse_has(checkfor) || button == 0x03)
                return;
            if (checkfor != 'c')
                button = 0x00;
        }
        repeated_click = 0;
    }
    if (clip_star.state != 0 && !did_clip)
        clip_clear_selection();
    if (hold_gui_events)
        return;
    row = gui_xy2colrow(x, y, &col);
    if (button == (0x40 | 0x03))
    {
        if (row == prev_row && col == prev_col)
            return;
        if (y < 0)
            row = -1;
    }
    if (curwin->w_topline != gui_prev_topline
            || curwin->w_topfill != gui_prev_topfill
            )
        repeated_click = 0;
    string[0] = 0x9b;
    string[1] = 251;
    string[2] = ('X');
    if (button != (0x40 | 0x03) && button != 0x03)
    {
        if (repeated_click)
        {
            if (button != prev_button || row != prev_row || col != prev_col)
                num_clicks = 1;
            else if (++num_clicks > 4)
                num_clicks = 1;
        }
        else
            num_clicks = 1;
        prev_button = button;
        gui_prev_topline = curwin->w_topline;
        gui_prev_topfill = curwin->w_topfill;
        string[3] = (char_u)(button | 0x20);
        (string[3]) = ((string[3]) & 0x3f) | ((((num_clicks) - 1) & 3) << 6);
    }
    else
        string[3] = (char_u)button;
    string[3] |= modifiers;
    fill_mouse_coord(string + 4, col, row);
    add_to_input_buf(string, 8);
    if (row < 0)
        prev_row = 0;
    else
        prev_row = row;
    prev_col = col;
}
    int gui_xy2colrow(x, y, colp)
    int x;
    int y;
    int *colp;
{
    int col = check_col((((x) - gui.border_offset) / gui.char_width));
    int row = check_row((((y) - gui.border_offset) / gui.char_height));
    *colp = col;
    return row;
}
    void gui_menu_cb(menu)
    vimmenu_T *menu;
{
    char_u bytes[3 + sizeof(long_u)];
    if (hold_gui_events)
        return;
    bytes[0] = 0x9b;
    bytes[1] = 250;
    bytes[2] = ('X');
    add_long_to_buf((long_u)menu, bytes + 3);
    add_to_input_buf(bytes, 3 + sizeof(long_u));
}
    void gui_init_which_components(oldval)
    char_u *oldval;
{
    static int prev_which_scrollbars[3] = {-1, -1, -1};
    static int prev_menu_is_active = -1;
    static int prev_toolbar = -1;
    int using_toolbar = 0;
    static int prev_tearoff = -1;
    int using_tearoff = 0;
    char_u *p;
    int i;
    int grey_old, grey_new;
    char_u *temp;
    win_T *wp;
    int need_set_size;
    if (oldval != ((void *)0) && gui.in_use)
    {
        grey_old = (vim_strchr(oldval, 'g') != ((void *)0));
        grey_new = (vim_strchr(p_go, 'g') != ((void *)0));
        if (grey_old != grey_new)
        {
            temp = p_go;
            p_go = oldval;
            gui_update_menus(((1 << 5) - 1));
            p_go = temp;
        }
    }
    gui.menu_is_active = 0;
    for (i = 0; i < 3; i++)
        gui.which_scrollbars[i] = 0;
    for (p = p_go; *p; p++)
        switch (*p)
        {
            case 'l':
                gui.which_scrollbars[0] = 1;
                break;
            case 'r':
                gui.which_scrollbars[1] = 1;
                break;
            case 'L':
                if (win_hasvertsplit())
                    gui.which_scrollbars[0] = 1;
                break;
            case 'R':
                if (win_hasvertsplit())
                    gui.which_scrollbars[1] = 1;
                break;
            case 'b':
                gui.which_scrollbars[2] = 1;
                break;
            case 'm':
                gui.menu_is_active = 1;
                break;
            case 'g':
                break;
            case 'T':
                using_toolbar = 1;
                break;
            case 't':
                using_tearoff = 1;
                break;
            default:
                break;
        }
    if (gui.in_use)
    {
        need_set_size = 0;
        for (i = 0; i < 3; i++)
        {
            if (gui.which_scrollbars[i] != prev_which_scrollbars[i])
            {
                if (i == 2)
                    gui_mch_enable_scrollbar(&gui.bottom_sbar,
                                                     gui.which_scrollbars[i]);
                else
                {
                    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
                    {
                        gui_do_scrollbar(wp, i, gui.which_scrollbars[i]);
                    }
                }
                need_set_size = 1;
            }
            prev_which_scrollbars[i] = gui.which_scrollbars[i];
        }
        if (gui.menu_is_active != prev_menu_is_active)
        {
            gui_mch_enable_menu(gui.menu_is_active);
            prev_menu_is_active = gui.menu_is_active;
            need_set_size = 1;
        }
        if (using_toolbar != prev_toolbar)
        {
            gui_mch_show_toolbar(using_toolbar);
            prev_toolbar = using_toolbar;
            need_set_size = 1;
        }
        if (using_tearoff != prev_tearoff)
        {
            gui_mch_toggle_tearoffs(using_tearoff);
            prev_tearoff = using_tearoff;
        }
        if (need_set_size)
            gui_set_shellsize(0, 0);
    }
}
    void gui_create_scrollbar(sb, type, wp)
    scrollbar_T *sb;
    int type;
    win_T *wp;
{
    static int sbar_ident = 0;
    sb->ident = sbar_ident++;
    sb->wp = wp;
    sb->type = type;
    sb->value = 0;
    sb->size = 1;
    sb->max = 1;
    sb->top = 0;
    sb->height = 0;
    sb->width = 0;
    sb->status_height = 0;
    gui_mch_create_scrollbar(sb, (wp == ((void *)0)) ? 1 : 0);
}
    scrollbar_T * gui_find_scrollbar(ident)
    long ident;
{
    win_T *wp;
    if (gui.bottom_sbar.ident == ident)
        return &gui.bottom_sbar;
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
    {
        if (wp->w_scrollbars[0].ident == ident)
            return &wp->w_scrollbars[0];
        if (wp->w_scrollbars[1].ident == ident)
            return &wp->w_scrollbars[1];
    }
    return ((void *)0);
}
    void gui_drag_scrollbar(sb, value, still_dragging)
    scrollbar_T *sb;
    long value;
    int still_dragging;
{
    win_T *wp;
    int sb_num;
    char_u bytes[4 + sizeof(long_u)];
    int byte_count;
    if (sb == ((void *)0))
        return;
    if (hold_gui_events)
        return;
    if (cmdwin_type != 0 && sb->wp != curwin)
        return;
    if (still_dragging)
    {
        if (sb->wp == ((void *)0))
            gui.dragged_sb = 2;
        else if (sb == &sb->wp->w_scrollbars[0])
            gui.dragged_sb = 0;
        else
            gui.dragged_sb = 1;
        gui.dragged_wp = sb->wp;
    }
    else
        gui.dragged_sb = -1;
    if (sb->wp != ((void *)0))
        sb = &sb->wp->w_scrollbars[0];
    if (value < 0)
        value = 0;
    if (value > sb->max - sb->size + 1)
        value = sb->max - sb->size + 1;
    sb->value = value;
    if (sb->wp != ((void *)0))
    {
        sb_num = 0;
        for (wp = firstwin; wp != sb->wp && wp != ((void *)0); wp = wp->w_next)
            sb_num++;
        if (wp == ((void *)0))
            return;
        bytes[0] = 0x9b;
        bytes[1] = 249;
        bytes[2] = ('X');
        bytes[3] = (char_u)sb_num;
        byte_count = 4;
    }
    else
    {
        bytes[0] = 0x9b;
        bytes[1] = 248;
        bytes[2] = ('X');
        byte_count = 3;
    }
    add_long_to_buf((long)value, bytes + byte_count);
    add_to_input_buf(bytes, byte_count + sizeof(long_u));
}
    void gui_update_scrollbars(force)
    int force;
{
    win_T *wp;
    scrollbar_T *sb;
    long val, size, max;
    int which_sb;
    int h, y;
    static win_T *prev_curwin = ((void *)0);
    gui_update_horiz_scrollbar(force);
    if (!gui.which_scrollbars[0] && !gui.which_scrollbars[1])
        return;
    if ( (gui.dragged_sb == 0
                || gui.dragged_sb == 1)
            && (!gui.which_scrollbars[0]
                || !gui.which_scrollbars[1])
            && !force)
        return;
    if (!force && (gui.dragged_sb == 0 || gui.dragged_sb == 1))
    {
        which_sb = 0 + 1 - gui.dragged_sb;
        if (gui.dragged_wp != ((void *)0))
            gui_mch_set_scrollbar_thumb(
                    &gui.dragged_wp->w_scrollbars[which_sb],
                    gui.dragged_wp->w_scrollbars[0].value,
                    gui.dragged_wp->w_scrollbars[0].size,
                    gui.dragged_wp->w_scrollbars[0].max);
        return;
    }
    ++hold_gui_events;
    for (wp = firstwin; wp != ((void *)0); wp = ((wp)->w_next))
    {
        if (wp->w_buffer == ((void *)0))
            continue;
        max = wp->w_buffer->b_ml.ml_line_count + wp->w_height - 2;
        if (max < 0)
            max = 0;
        val = wp->w_topline - 1;
        size = wp->w_height;
        if (size > max + 1)
            size = max + 1;
        if (val > max - size + 1)
            val = max - size + 1;
        if (val < 0)
            val = 0;
        sb = &wp->w_scrollbars[0];
        if (size < 1 || wp->w_botline - 2 > max)
        {
            sb->height = 0;
            if (gui.which_scrollbars[0])
                gui_do_scrollbar(wp, 0, 0);
            if (gui.which_scrollbars[1])
                gui_do_scrollbar(wp, 1, 0);
            continue;
        }
        if (force || sb->height != wp->w_height
            || sb->top != wp->w_winrow
            || sb->status_height != wp->w_status_height
            || sb->width != wp->w_width
            || prev_curwin != curwin
            )
        {
            sb->height = wp->w_height;
            sb->top = wp->w_winrow;
            sb->status_height = wp->w_status_height;
            sb->width = wp->w_width;
            h = (sb->height + sb->status_height) * gui.char_height;
            y = sb->top * gui.char_height + gui.border_offset;
            if (wp->w_winrow == 0)
            {
                h += gui.border_offset;
                y -= gui.border_offset;
            }
            if (gui.which_scrollbars[0])
            {
                gui_mch_set_scrollbar_pos(&wp->w_scrollbars[0],
                                          gui.left_sbar_x, y,
                                          gui.scrollbar_width, h);
                gui_do_scrollbar(wp, 0, 1);
            }
            if (gui.which_scrollbars[1])
            {
                gui_mch_set_scrollbar_pos(&wp->w_scrollbars[1],
                                          gui.right_sbar_x, y,
                                          gui.scrollbar_width, h);
                gui_do_scrollbar(wp, 1, 1);
            }
        }
        if (force || sb->value != val || sb->size != size || sb->max != max)
        {
            sb->value = val;
            sb->size = size;
            sb->max = max;
            if (gui.which_scrollbars[0] && gui.dragged_sb != 0)
                gui_mch_set_scrollbar_thumb(&wp->w_scrollbars[0],
                                            val, size, max);
            if (gui.which_scrollbars[1]
                                        && gui.dragged_sb != 1)
                gui_mch_set_scrollbar_thumb(&wp->w_scrollbars[1],
                                            val, size, max);
        }
    }
    prev_curwin = curwin;
    --hold_gui_events;
}
    static void gui_do_scrollbar(wp, which, enable)
    win_T *wp;
    int which;
    int enable;
{
    int midcol = curwin->w_wincol + curwin->w_width / 2;
    int has_midcol = (wp->w_wincol <= midcol
                                     && wp->w_wincol + wp->w_width >= midcol);
    if (gui.which_scrollbars[1] != gui.which_scrollbars[0])
    {
        if (!has_midcol)
            enable = 0;
    }
    else
    {
        if (midcol > Columns / 2)
        {
            if (which == 0 ? wp->w_wincol != 0 : !has_midcol)
                enable = 0;
        }
        else
        {
            if (which == 1 ? wp->w_wincol + wp->w_width != Columns
                                                                : !has_midcol)
                enable = 0;
        }
    }
    gui_mch_enable_scrollbar(&wp->w_scrollbars[which], enable);
}
    int gui_do_scroll()
{
    win_T *wp, *save_wp;
    int i;
    long nlines;
    pos_T old_cursor;
    linenr_T old_topline;
    int old_topfill;
    for (wp = firstwin, i = 0; i < current_scrollbar; wp = ((wp)->w_next), i++)
        if (wp == ((void *)0))
            break;
    if (wp == ((void *)0))
        return 0;
    nlines = (long)scrollbar_value + 1 - (long)wp->w_topline;
    if (nlines == 0)
        return 0;
    save_wp = curwin;
    old_topline = wp->w_topline;
    old_topfill = wp->w_topfill;
    old_cursor = wp->w_cursor;
    curwin = wp;
    curbuf = wp->w_buffer;
    if (nlines < 0)
        scrolldown(-nlines, gui.dragged_wp == ((void *)0));
    else
        scrollup(nlines, gui.dragged_wp == ((void *)0));
    if (gui.dragged_sb == -1)
        gui.dragged_wp = ((void *)0);
    if (old_topline != wp->w_topline
            || old_topfill != wp->w_topfill
            )
    {
        if (p_so != 0)
        {
            cursor_correct();
            update_topline();
        }
        if (old_cursor.lnum != wp->w_cursor.lnum)
            coladvance(wp->w_curswant);
        wp->w_scbind_pos = wp->w_topline;
    }
    curwin = save_wp;
    curbuf = save_wp->w_buffer;
    if (old_topline != wp->w_topline
            || old_topfill != wp->w_topfill
            )
    {
        redraw_win_later(wp, 10);
        updateWindow(wp);
    }
    return (wp == curwin && !(((curwin->w_cursor).lnum == (old_cursor).lnum) && ((curwin->w_cursor).col == (old_cursor).col) && ((curwin->w_cursor).coladd == (old_cursor).coladd)));
}
    static void gui_update_horiz_scrollbar(force)
    int force;
{
    long value, size, max;
    char_u *p;
    if (!gui.which_scrollbars[2])
        return;
    if (!force && gui.dragged_sb == 2)
        return;
    if (!force && curwin->w_onebuf_opt.wo_wrap && gui.prev_wrap)
        return;
    if (curwin->w_cursor.lnum > curbuf->b_ml.ml_line_count)
    {
        gui.bottom_sbar.value = -1;
        return;
    }
    size = (curwin->w_width);
    if (curwin->w_onebuf_opt.wo_wrap)
    {
        value = 0;
        max = (curwin->w_width) - 1;
    }
    else
    {
        value = curwin->w_leftcol;
        p = ml_get_curline();
        max = 0;
        if (p != ((void *)0) && p[0] != '\000')
            for (;;)
            {
                int w = chartabsize(p, (colnr_T)max);
                    ++p;
                if (*p == '\000')
                    break;
                max += w;
            }
        max += (curwin->w_width) - 1;
        size -= curwin_col_off();
        max -= curwin_col_off();
    }
    if (value > max - size + 1)
        value = max - size + 1;
    if (!force && value == gui.bottom_sbar.value && size == gui.bottom_sbar.size
                                                && max == gui.bottom_sbar.max)
        return;
    gui.bottom_sbar.value = value;
    gui.bottom_sbar.size = size;
    gui.bottom_sbar.max = max;
    gui.prev_wrap = curwin->w_onebuf_opt.wo_wrap;
    gui_mch_set_scrollbar_thumb(&gui.bottom_sbar, value, size, max);
}
    int gui_do_horiz_scroll()
{
    if (curwin->w_onebuf_opt.wo_wrap)
        return 0;
    if (curwin->w_leftcol == scrollbar_value)
        return 0;
    curwin->w_leftcol = scrollbar_value;
    return leftcol_changed();
}
    void gui_check_colors()
{
    if (gui.norm_pixel == gui.back_pixel || gui.norm_pixel == (guicolor_T)-11111)
    {
        gui_set_bg_color((char_u *)"White");
        if (gui.norm_pixel == gui.back_pixel || gui.norm_pixel == (guicolor_T)-11111)
            gui_set_fg_color((char_u *)"Black");
    }
}
    void gui_set_fg_color(name)
    char_u *name;
{
    gui.norm_pixel = gui_get_color(name);
    hl_set_fg_color_name(vim_strsave(name));
}
    void gui_set_bg_color(name)
    char_u *name;
{
    gui.back_pixel = gui_get_color(name);
    hl_set_bg_color_name(vim_strsave(name));
}
    guicolor_T gui_get_color(name)
    char_u *name;
{
    guicolor_T t;
    if (*name == '\000')
        return (guicolor_T)-11111;
    t = gui_mch_get_color(name);
    if (t == (guicolor_T)-11111
            && gui.in_use
            )
        emsg2((char_u *)(((char *)("E254: Cannot allocate color %s"))), (char_u *)(name));
    return t;
}
    int gui_get_lightness(pixel)
    guicolor_T pixel;
{
    long_u rgb = gui_mch_get_rgb(pixel);
    return ( (((rgb >> 16) & 0xff) * 299)
            + (((rgb >> 8) & 0xff) * 587)
            + ((rgb & 0xff) * 114)) / 1000;
}
    void gui_focus_change(in_focus)
    int in_focus;
{
    gui.in_focus = in_focus;
    out_flush();
    gui_update_cursor(1, 0);
    xim_set_focus(in_focus);
    ui_focus_change(in_focus);
}
    void gui_mouse_moved(x, y)
    int x;
    int y;
{
    win_T *wp;
    char_u st[6];
    wp = xy2win(x, y);
    if (p_mousef
            && !hold_gui_events
            && (State & (0x01|0x10))
            && State != (0x200 + 0x01)
            && msg_scrolled == 0
            && !need_mouse_correct
            && gui.in_focus)
    {
        if (x < 0 || x > Columns * gui.char_width)
            return;
        if (wp == curwin || wp == ((void *)0))
            return;
        if (finish_op)
        {
            st[0] = '\033';
            add_to_input_buf(st, 1);
        }
        st[0] = 0x9b;
        st[1] = 251;
        st[2] = ('X');
        st[3] = (char_u)0x00;
        fill_mouse_coord(st + 4,
                (wp->w_wincol),
                wp->w_height + (wp->w_winrow));
        add_to_input_buf(st, 8);
        st[3] = (char_u)0x03;
        add_to_input_buf(st, 8);
        if (gtk_main_level() > 0)
            gtk_main_quit();
    }
}
    void gui_mouse_correct()
{
    int x, y;
    win_T *wp = ((void *)0);
    need_mouse_correct = 0;
    if (gui.in_use && p_mousef)
    {
        x = gui_mch_get_mouse_x();
        if (x < 0 || x > Columns * gui.char_width)
            return;
        y = gui_mch_get_mouse_y();
        if (y >= 0)
            wp = xy2win(x, y);
        if (wp != curwin && wp != ((void *)0))
        {
            validate_cline_row();
            gui_mch_setmouse((int)(curwin->w_wincol + curwin->w_width) * gui.char_width - 3,
                         ((curwin->w_winrow) + curwin->w_wrow) * gui.char_height
                                                     + (gui.char_height) / 2);
        }
    }
}
    static win_T * xy2win(x, y)
    int x;
    int y;
{
    int row;
    int col;
    win_T *wp;
    row = (((y) - gui.border_offset) / gui.char_height);
    col = (((x) - gui.border_offset) / gui.char_width);
    if (row < 0 || col < 0)
        return ((void *)0);
    wp = mouse_find_win(&row, &col);
    if (State == (0x200 + 0x01) || State == 0x300)
    {
        if ((((y) - gui.border_offset) / gui.char_height) == Rows - 1)
            update_mouseshape(15);
        else
            update_mouseshape(14);
    }
    else if (row > wp->w_height)
        update_mouseshape(9);
    else if (!(State & 0x08) && (wp->w_vsep_width) > 0 && col == wp->w_width
            && (row != wp->w_height || !stl_connected(wp)))
        update_mouseshape(12);
    else if (!(State & 0x08) && (wp->w_status_height) > 0
                                                       && row == wp->w_height)
        update_mouseshape(10);
    else
        update_mouseshape(-2);
    return wp;
}
    void ex_gui(eap)
    exarg_T *eap;
{
    char_u *arg = eap->arg;
    if (arg[0] == '-'
            && (arg[1] == 'f' || arg[1] == 'b')
            && (arg[2] == '\000' || ((arg[2]) == ' ' || (arg[2]) == '\t')))
    {
        gui.dofork = (arg[1] == 'b');
        eap->arg = skipwhite(eap->arg + 2);
    }
    if (!gui.in_use)
    {
        msg_clr_eos();
        gui_start();
    }
    if (!ends_excmd(*eap->arg))
        ex_next(eap);
}
static char_u *gfp_buffer;
static void gfp_setname (char_u *fname);
    static void gfp_setname(fname)
    char_u *fname;
{
    if (strlen((char *)(fname)) >= 1024)
        *gfp_buffer = '\000';
    else
        strcpy((char *)(gfp_buffer), (char *)(fname));
}
    int gui_find_bitmap(name, buffer, ext)
    char_u *name;
    char_u *buffer;
    char *ext;
{
    if (strlen((char *)(name)) > 1024 - 14)
        return 0;
    sprintf((char *)buffer, "bitmaps/%s.%s", name, ext);
    gfp_buffer = buffer;
    if (do_in_runtimepath(buffer, 0, gfp_setname) == 0 || *buffer == '\000')
        return 0;
    return 1;
}
    void gui_find_iconfile(name, buffer, ext)
    char_u *name;
    char_u *buffer;
    char *ext;
{
    char_u buf[1024 + 1];
    expand_env(name, buffer, 1024);
    if (!mch_isFullName(buffer) && gui_find_bitmap(buffer, buf, ext) == 1)
        strcpy((char *)(buffer), (char *)(buf));
}
    void display_errors()
{
    char_u *p;
    if (isatty(2))
        fflush(stderr);
    else if (error_ga.ga_data != ((void *)0))
    {
        for (p = (char_u *)error_ga.ga_data; *p != '\000'; ++p)
            if (!(__ctype_b[(int) ((*p))] & (unsigned short int) _ISspace))
            {
                if (strlen((char *)(p)) > 2000)
                    strcpy((char *)(p + 2000 - 14), (char *)("...(truncated)"));
                (void)do_dialog(1, (char_u *)((char *)("Error")),
                                              p, (char_u *)((char *)("&Ok")), 1, ((void *)0));
                break;
            }
        ga_clear(&error_ga);
    }
}
    int no_console_input()
{
    return ((!gui.in_use || gui.starting)
            && !isatty(0) && !isatty(2)
            );
}
    void gui_update_screen()
{
    update_topline();
    validate_cursor();
    update_screen(0);
    setcursor();
    out_flush();
    gui_update_cursor(1, 0);
    gui_mch_flush();
}
static void concat_esc (garray_T *gap, char_u *text, int what);
    char_u * get_find_dialog_text(arg, wwordp, mcasep)
    char_u *arg;
    int *wwordp;
    int *mcasep;
{
    char_u *text;
    if (*arg == '\000')
        text = last_search_pat();
    else
        text = arg;
    if (text != ((void *)0))
    {
        text = vim_strsave(text);
        if (text != ((void *)0))
        {
            int len = strlen((char *)(text));
            int i;
            if (len >= 2 && strncmp((char *)(text), (char *)("\\V"), (size_t)(2)) == 0)
            {
                memmove((char *)(text), (char *)(text + 2), (size_t)(len - 1));
                len -= 2;
            }
            if (len >= 2 && *text == '\\' && (text[1] == 'c' || text[1] == 'C'))
            {
                *mcasep = (text[1] == 'C');
                memmove((char *)(text), (char *)(text + 2), (size_t)(len - 1));
                len -= 2;
            }
            if (len >= 4
                    && strncmp((char *)(text), (char *)("\\<"), (size_t)(2)) == 0
                    && strncmp((char *)(text + len - 2), (char *)("\\>"), (size_t)(2)) == 0)
            {
                *wwordp = 1;
                memmove((char *)(text), (char *)(text + 2), (size_t)(len - 4));
                text[len - 4] = '\000';
            }
            for (i = 0; i + 1 < len; ++i)
                if (text[i] == '\\' && (text[i + 1] == '/'
                                                       || text[i + 1] == '?'))
                {
                    memmove((char *)(text + i), (char *)(text + i + 1), (size_t)(len - i));
                    --len;
                }
        }
    }
    return text;
}
    static void concat_esc(gap, text, what)
    garray_T *gap;
    char_u *text;
    int what;
{
    while (*text != '\000')
    {
        if (*text == what)
            ga_append(gap, '\\');
        ga_append(gap, *text);
        ++text;
    }
}
    int gui_do_findrepl(flags, find_text, repl_text, down)
    int flags;
    char_u *find_text;
    char_u *repl_text;
    int down;
{
    garray_T ga;
    int i;
    int type = (flags & 7);
    char_u *p;
    ga_init2(&ga, 1, 100);
    if (type == 3)
    {
        i = strlen((char *)(find_text));
        p = ml_get_cursor();
        if (((flags & 0x10)
                    ? strncmp((char *)(p), (char *)(find_text), (size_t)(i)) == 0
                    : strncasecmp((char *)(p), (char *)(find_text), (size_t)(i)) == 0)
                && u_save_cursor() == 1)
        {
            if (no_u_sync == 0)
                u_sync();
            del_bytes((long)i, 0);
            ins_str(repl_text);
        }
    }
    else if (type == 4)
        ga_concat(&ga, (char_u *)"%s/");
    ga_concat(&ga, (char_u *)"\\V");
    if (flags & 0x10)
        ga_concat(&ga, (char_u *)"\\C");
    else
        ga_concat(&ga, (char_u *)"\\c");
    if (flags & 0x08)
        ga_concat(&ga, (char_u *)"\\<");
    if (type == 4 || down)
        concat_esc(&ga, find_text, '/');
    else
        concat_esc(&ga, find_text, '?');
    if (flags & 0x08)
        ga_concat(&ga, (char_u *)"\\>");
    if (type == 4)
    {
        if (no_u_sync == 0)
            u_sync();
        ga_concat(&ga, (char_u *)"/");
        concat_esc(&ga, repl_text, '/');
        ga_concat(&ga, (char_u *)"/g");
        do_cmdline_cmd(ga.ga_data);
    }
    else
    {
        i = msg_scroll;
        do_search(((void *)0), down ? '/' : '?', ga.ga_data, 1L,
                                                    0x0c + 0x200);
        msg_scroll = i;
    }
    if (State & (0x01 | 0x10))
    {
        gui_update_screen();
        msg_didout = 0;
        need_wait_return = 0;
    }
    vim_free(ga.ga_data);
    return (ga.ga_len > 0);
}
