typedef unsigned char char_u;
char_u *FullName_save (char_u *fname, int force);
char_u *alloc (unsigned size);
int emsg (char_u *s);
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
char_u *ml_get_buf (buf_T *buf, linenr_T lnum, int will_change);
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
void ui_breakcheck (void);
void vim_free (void *x);
extern buf_T *firstbuf ;
extern int got_int ;
extern void *memset (void *__s, int __c, size_t __n) ;
extern int unlink (__const char *__name) ;
typedef __u_int __mode_t;
typedef __mode_t mode_t;
extern int close (int __fd) ;
typedef long int __off_t;
typedef __off_t off_t;
extern __off_t lseek (int __fd, __off_t __offset, int __whence) ;
typedef long int __time_t;
__extension__ typedef unsigned long long int __u_quad_t;
typedef __u_int __gid_t;
typedef __u_int __nlink_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __u_quad_t __dev_t;
struct stat
  {
    __dev_t st_dev;
    unsigned short int __pad1;
    __ino_t st_ino;
    __mode_t st_mode;
    __nlink_t st_nlink;
    __uid_t st_uid;
    __gid_t st_gid;
    __dev_t st_rdev;
    unsigned short int __pad2;
    __off_t st_size;
    __blksize_t st_blksize;
    __blkcnt_t st_blocks;
    __time_t st_atime;
    unsigned long int __unused1;
    __time_t st_mtime;
    unsigned long int __unused2;
    __time_t st_ctime;
    unsigned long int __unused3;
    unsigned long int __unused4;
    unsigned long int __unused5;
  };
extern int lstat (__const char *__restrict __file,
                  struct stat *__restrict __buf) ;
extern int open (__const char *__file, int __oflag, ...) ;
typedef int __ssize_t;
typedef __ssize_t ssize_t;
extern ssize_t read (int __fd, void *__buf, size_t __nbytes) ;
extern ssize_t write (int __fd, __const void *__buf, size_t __n) ;
extern int did_swapwrite_msg ;
extern long p_uc;
extern int fstat (int __fd, struct stat *__buf) ;
void mf_set_ffname (memfile_T *mfp);
int ui_char_avail (void);
extern int fsync (int __fd) ;
extern void sync (void) ;
extern long p_mm;
extern long p_mmt;
extern char_u *p_sws;
void mch_hide (char_u *name);
extern char_u e_swapclose[] ;
void ml_open_file (buf_T *buf);
static long_u total_mem_used = 0;
static int dont_release = 0;
static void mf_ins_hash (memfile_T *, bhdr_T *);
static void mf_rem_hash (memfile_T *, bhdr_T *);
static bhdr_T *mf_find_hash (memfile_T *, blocknr_T);
static void mf_ins_used (memfile_T *, bhdr_T *);
static void mf_rem_used (memfile_T *, bhdr_T *);
static bhdr_T *mf_release (memfile_T *, int);
static bhdr_T *mf_alloc_bhdr (memfile_T *, int);
static void mf_free_bhdr (bhdr_T *);
static void mf_ins_free (memfile_T *, bhdr_T *);
static bhdr_T *mf_rem_free (memfile_T *);
static int mf_read (memfile_T *, bhdr_T *);
static int mf_write (memfile_T *, bhdr_T *);
static int mf_trans_add (memfile_T *, bhdr_T *);
static void mf_do_open (memfile_T *, char_u *, int);
    memfile_T * mf_open(fname, flags)
    char_u *fname;
    int flags;
{
    memfile_T *mfp;
    int i;
    off_t size;
    struct stat stf;
    if ((mfp = (memfile_T *)alloc((unsigned)sizeof(memfile_T))) == ((void *)0))
        return ((void *)0);
    if (fname == ((void *)0))
    {
        mfp->mf_fname = ((void *)0);
        mfp->mf_ffname = ((void *)0);
        mfp->mf_fd = -1;
    }
    else
    {
        mf_do_open(mfp, fname, flags);
        if (mfp->mf_fd < 0)
        {
            vim_free(mfp);
            return ((void *)0);
        }
    }
    mfp->mf_free_first = ((void *)0);
    mfp->mf_used_first = ((void *)0);
    mfp->mf_used_last = ((void *)0);
    mfp->mf_dirty = 0;
    mfp->mf_used_count = 0;
    for (i = 0; i < 64; ++i)
    {
        mfp->mf_hash[i] = ((void *)0);
        mfp->mf_trans[i] = ((void *)0);
    }
    mfp->mf_page_size = 4096;
    if (mfp->mf_fd >= 0
            && fstat(((mfp->mf_fd)), ((&stf))) == 0
            && stf.st_blksize >= 1048
            && stf.st_blksize <= 50000)
        mfp->mf_page_size = stf.st_blksize;
    if (mfp->mf_fd < 0 || (flags & (01000|0200))
                      || (size = lseek(mfp->mf_fd, (off_t)0L, 2)) <= 0)
        mfp->mf_blocknr_max = 0;
    else
        mfp->mf_blocknr_max = (blocknr_T)((size + mfp->mf_page_size - 1)
                                                         / mfp->mf_page_size);
    mfp->mf_blocknr_min = -1;
    mfp->mf_neg_count = 0;
    mfp->mf_infile_count = mfp->mf_blocknr_max;
    mfp->mf_used_count_max = p_mm * 1024 / mfp->mf_page_size;
    return mfp;
}
    int mf_open_file(mfp, fname)
    memfile_T *mfp;
    char_u *fname;
{
    mf_do_open(mfp, fname, 02|0100|0200);
    if (mfp->mf_fd < 0)
        return 0;
    mfp->mf_dirty = 1;
    return 1;
}
    void mf_close(mfp, del_file)
    memfile_T *mfp;
    int del_file;
{
    bhdr_T *hp, *nextp;
    NR_TRANS *tp, *tpnext;
    int i;
    if (mfp == ((void *)0))
        return;
    if (mfp->mf_fd >= 0)
    {
        if (close(mfp->mf_fd) < 0)
            emsg((char_u *)(((char *)(e_swapclose))));
    }
    if (del_file && mfp->mf_fname != ((void *)0))
        unlink((char *)(mfp->mf_fname));
    for (hp = mfp->mf_used_first; hp != ((void *)0); hp = nextp)
    {
        total_mem_used -= hp->bh_page_count * mfp->mf_page_size;
        nextp = hp->bh_next;
        mf_free_bhdr(hp);
    }
    while (mfp->mf_free_first != ((void *)0))
        vim_free(mf_rem_free(mfp));
    for (i = 0; i < 64; ++i)
        for (tp = mfp->mf_trans[i]; tp != ((void *)0); tp = tpnext)
        {
            tpnext = tp->nt_next;
            vim_free(tp);
        }
    vim_free(mfp->mf_fname);
    vim_free(mfp->mf_ffname);
    vim_free(mfp);
}
    void mf_close_file(buf, getlines)
    buf_T *buf;
    int getlines;
{
    memfile_T *mfp;
    linenr_T lnum;
    mfp = buf->b_ml.ml_mfp;
    if (mfp == ((void *)0) || mfp->mf_fd < 0)
        return;
    if (getlines)
    {
        dont_release = 1;
        for (lnum = 1; lnum <= buf->b_ml.ml_line_count; ++lnum)
            (void)ml_get_buf(buf, lnum, 0);
        dont_release = 0;
    }
    if (close(mfp->mf_fd) < 0)
        emsg((char_u *)(((char *)(e_swapclose))));
    mfp->mf_fd = -1;
    if (mfp->mf_fname != ((void *)0))
    {
        unlink((char *)(mfp->mf_fname));
        vim_free(mfp->mf_fname);
        vim_free(mfp->mf_ffname);
        mfp->mf_fname = ((void *)0);
        mfp->mf_ffname = ((void *)0);
    }
}
    void mf_new_page_size(mfp, new_size)
    memfile_T *mfp;
    unsigned new_size;
{
    total_mem_used += new_size - mfp->mf_page_size;
    mfp->mf_page_size = new_size;
}
    bhdr_T * mf_new(mfp, negative, page_count)
    memfile_T *mfp;
    int negative;
    int page_count;
{
    bhdr_T *hp;
    bhdr_T *freep;
    char_u *p;
    hp = mf_release(mfp, page_count);
    freep = mfp->mf_free_first;
    if (!negative && freep != ((void *)0) && freep->bh_page_count >= page_count)
    {
        if (freep->bh_page_count > page_count)
        {
            if (hp == ((void *)0) && (hp = mf_alloc_bhdr(mfp, page_count)) == ((void *)0))
                return ((void *)0);
            hp->bh_bnum = freep->bh_bnum;
            freep->bh_bnum += page_count;
            freep->bh_page_count -= page_count;
        }
        else if (hp == ((void *)0))
        {
            if ((p = (char_u *)alloc(mfp->mf_page_size * page_count)) == ((void *)0))
                return ((void *)0);
            hp = mf_rem_free(mfp);
            hp->bh_data = p;
        }
        else
        {
            freep = mf_rem_free(mfp);
            hp->bh_bnum = freep->bh_bnum;
            vim_free(freep);
        }
    }
    else
    {
        if (hp == ((void *)0) && (hp = mf_alloc_bhdr(mfp, page_count)) == ((void *)0))
            return ((void *)0);
        if (negative)
        {
            hp->bh_bnum = mfp->mf_blocknr_min--;
            mfp->mf_neg_count++;
        }
        else
        {
            hp->bh_bnum = mfp->mf_blocknr_max;
            mfp->mf_blocknr_max += page_count;
        }
    }
    hp->bh_flags = 2 | 1;
    mfp->mf_dirty = 1;
    hp->bh_page_count = page_count;
    mf_ins_used(mfp, hp);
    mf_ins_hash(mfp, hp);
    (void)memset(((char *)(hp->bh_data)), (0), ((size_t)mfp->mf_page_size));
    return hp;
}
    bhdr_T * mf_get(mfp, nr, page_count)
    memfile_T *mfp;
    blocknr_T nr;
    int page_count;
{
    bhdr_T *hp;
    if (nr >= mfp->mf_blocknr_max || nr <= mfp->mf_blocknr_min)
        return ((void *)0);
    hp = mf_find_hash(mfp, nr);
    if (hp == ((void *)0))
    {
        if (nr < 0 || nr >= mfp->mf_infile_count)
            return ((void *)0);
        hp = mf_release(mfp, page_count);
        if (hp == ((void *)0) && (hp = mf_alloc_bhdr(mfp, page_count)) == ((void *)0))
            return ((void *)0);
        hp->bh_bnum = nr;
        hp->bh_flags = 0;
        hp->bh_page_count = page_count;
        if (mf_read(mfp, hp) == 0)
        {
            mf_free_bhdr(hp);
            return ((void *)0);
        }
    }
    else
    {
        mf_rem_used(mfp, hp);
        mf_rem_hash(mfp, hp);
    }
    hp->bh_flags |= 2;
    mf_ins_used(mfp, hp);
    mf_ins_hash(mfp, hp);
    return hp;
}
    void mf_put(mfp, hp, dirty, infile)
    memfile_T *mfp;
    bhdr_T *hp;
    int dirty;
    int infile;
{
    int flags;
    flags = hp->bh_flags;
    if ((flags & 2) == 0)
        emsg((char_u *)(((char *)("E293: block was not locked"))));
    flags &= ~2;
    if (dirty)
    {
        flags |= 1;
        mfp->mf_dirty = 1;
    }
    hp->bh_flags = flags;
    if (infile)
        mf_trans_add(mfp, hp);
}
    void mf_free(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    vim_free(hp->bh_data);
    mf_rem_hash(mfp, hp);
    mf_rem_used(mfp, hp);
    if (hp->bh_bnum < 0)
    {
        vim_free(hp);
        mfp->mf_neg_count--;
    }
    else
        mf_ins_free(mfp, hp);
}
    int mf_sync(mfp, flags)
    memfile_T *mfp;
    int flags;
{
    int status;
    bhdr_T *hp;
    int got_int_save = got_int;
    if (mfp->mf_fd < 0)
    {
        mfp->mf_dirty = 0;
        return 0;
    }
    got_int = 0;
    status = 1;
    for (hp = mfp->mf_used_last; hp != ((void *)0); hp = hp->bh_prev)
        if (((flags & 1) || hp->bh_bnum >= 0)
                && (hp->bh_flags & 1)
                && (status == 1 || (hp->bh_bnum >= 0
                    && hp->bh_bnum < mfp->mf_infile_count)))
        {
            if ((flags & 8) && hp->bh_bnum != 0)
                continue;
            if (mf_write(mfp, hp) == 0)
            {
                if (status == 0)
                    break;
                status = 0;
            }
            if (flags & 2)
            {
                if (ui_char_avail())
                    break;
            }
            else
                ui_breakcheck();
            if (got_int)
                break;
        }
    if (hp == ((void *)0) || status == 0)
        mfp->mf_dirty = 0;
    if ((flags & 4) && *p_sws != '\000')
    {
        if (strcmp((char *)(p_sws), (char *)("fsync")) == 0)
        {
            if (fsync(mfp->mf_fd))
                status = 0;
        }
        else
            sync();
    }
    got_int |= got_int_save;
    return status;
}
    static void mf_ins_hash(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    bhdr_T *hhp;
    int hash;
    hash = ((hp->bh_bnum) & (64 - 1));
    hhp = mfp->mf_hash[hash];
    hp->bh_hash_next = hhp;
    hp->bh_hash_prev = ((void *)0);
    if (hhp != ((void *)0))
        hhp->bh_hash_prev = hp;
    mfp->mf_hash[hash] = hp;
}
    static void mf_rem_hash(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    if (hp->bh_hash_prev == ((void *)0))
        mfp->mf_hash[((hp->bh_bnum) & (64 - 1))] = hp->bh_hash_next;
    else
        hp->bh_hash_prev->bh_hash_next = hp->bh_hash_next;
    if (hp->bh_hash_next)
        hp->bh_hash_next->bh_hash_prev = hp->bh_hash_prev;
}
    static bhdr_T * mf_find_hash(mfp, nr)
    memfile_T *mfp;
    blocknr_T nr;
{
    bhdr_T *hp;
    for (hp = mfp->mf_hash[((nr) & (64 - 1))]; hp != ((void *)0); hp = hp->bh_hash_next)
        if (hp->bh_bnum == nr)
            break;
    return hp;
}
    static void mf_ins_used(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    hp->bh_next = mfp->mf_used_first;
    mfp->mf_used_first = hp;
    hp->bh_prev = ((void *)0);
    if (hp->bh_next == ((void *)0))
        mfp->mf_used_last = hp;
    else
        hp->bh_next->bh_prev = hp;
    mfp->mf_used_count += hp->bh_page_count;
    total_mem_used += hp->bh_page_count * mfp->mf_page_size;
}
    static void mf_rem_used(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    if (hp->bh_next == ((void *)0))
        mfp->mf_used_last = hp->bh_prev;
    else
        hp->bh_next->bh_prev = hp->bh_prev;
    if (hp->bh_prev == ((void *)0))
        mfp->mf_used_first = hp->bh_next;
    else
        hp->bh_prev->bh_next = hp->bh_next;
    mfp->mf_used_count -= hp->bh_page_count;
    total_mem_used -= hp->bh_page_count * mfp->mf_page_size;
}
    static bhdr_T * mf_release(mfp, page_count)
    memfile_T *mfp;
    int page_count;
{
    bhdr_T *hp;
    int need_release;
    buf_T *buf;
    if (dont_release)
        return ((void *)0);
    need_release = ((mfp->mf_used_count >= mfp->mf_used_count_max)
                                  || (total_mem_used >> 10) >= (long_u)p_mmt);
    if (mfp->mf_fd < 0 && need_release && p_uc)
    {
        for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
            if (buf->b_ml.ml_mfp == mfp)
                break;
        if (buf != ((void *)0) && buf->b_may_swap)
            ml_open_file(buf);
    }
    if (mfp->mf_fd < 0 || !need_release)
        return ((void *)0);
    for (hp = mfp->mf_used_last; hp != ((void *)0); hp = hp->bh_prev)
        if (!(hp->bh_flags & 2))
            break;
    if (hp == ((void *)0))
        return ((void *)0);
    if ((hp->bh_flags & 1) && mf_write(mfp, hp) == 0)
        return ((void *)0);
    mf_rem_used(mfp, hp);
    mf_rem_hash(mfp, hp);
    if (hp->bh_page_count != page_count)
    {
        vim_free(hp->bh_data);
        if ((hp->bh_data = alloc(mfp->mf_page_size * page_count)) == ((void *)0))
        {
            vim_free(hp);
            return ((void *)0);
        }
        hp->bh_page_count = page_count;
    }
    return hp;
}
    int mf_release_all()
{
    buf_T *buf;
    memfile_T *mfp;
    bhdr_T *hp;
    int retval = 0;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
    {
        mfp = buf->b_ml.ml_mfp;
        if (mfp != ((void *)0))
        {
            if (mfp->mf_fd < 0 && buf->b_may_swap)
                ml_open_file(buf);
            if (mfp->mf_fd >= 0)
            {
                for (hp = mfp->mf_used_last; hp != ((void *)0); )
                {
                    if (!(hp->bh_flags & 2)
                            && (!(hp->bh_flags & 1)
                                || mf_write(mfp, hp) != 0))
                    {
                        mf_rem_used(mfp, hp);
                        mf_rem_hash(mfp, hp);
                        mf_free_bhdr(hp);
                        hp = mfp->mf_used_last;
                        retval = 1;
                    }
                    else
                        hp = hp->bh_prev;
                }
            }
        }
    }
    return retval;
}
    static bhdr_T * mf_alloc_bhdr(mfp, page_count)
    memfile_T *mfp;
    int page_count;
{
    bhdr_T *hp;
    if ((hp = (bhdr_T *)alloc((unsigned)sizeof(bhdr_T))) != ((void *)0))
    {
        if ((hp->bh_data = (char_u *)alloc(mfp->mf_page_size * page_count))
                                                                      == ((void *)0))
        {
            vim_free(hp);
            return ((void *)0);
        }
        hp->bh_page_count = page_count;
    }
    return hp;
}
    static void mf_free_bhdr(hp)
    bhdr_T *hp;
{
    vim_free(hp->bh_data);
    vim_free(hp);
}
    static void mf_ins_free(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    hp->bh_next = mfp->mf_free_first;
    mfp->mf_free_first = hp;
}
    static bhdr_T * mf_rem_free(mfp)
    memfile_T *mfp;
{
    bhdr_T *hp;
    hp = mfp->mf_free_first;
    mfp->mf_free_first = hp->bh_next;
    return hp;
}
    static int mf_read(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    off_t offset;
    unsigned page_size;
    unsigned size;
    if (mfp->mf_fd < 0)
        return 0;
    page_size = mfp->mf_page_size;
    offset = (off_t)page_size * hp->bh_bnum;
    size = page_size * hp->bh_page_count;
    if (lseek(mfp->mf_fd, offset, 0) != offset)
    {
        emsg((char_u *)(((char *)("E294: Seek error in swap file read"))));
        return 0;
    }
    if ((unsigned)read((mfp->mf_fd), (char *)(hp->bh_data), (size_t) (size)) != size)
    {
        emsg((char_u *)(((char *)("E295: Read error in swap file"))));
        return 0;
    }
    return 1;
}
    static int mf_write(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    off_t offset;
    blocknr_T nr;
    bhdr_T *hp2;
    unsigned page_size;
    unsigned page_count;
    unsigned size;
    if (mfp->mf_fd < 0)
        return 0;
    if (hp->bh_bnum < 0)
        if (mf_trans_add(mfp, hp) == 0)
            return 0;
    page_size = mfp->mf_page_size;
    for (;;)
    {
        nr = hp->bh_bnum;
        if (nr > mfp->mf_infile_count)
        {
            nr = mfp->mf_infile_count;
            hp2 = mf_find_hash(mfp, nr);
        }
        else
            hp2 = hp;
        offset = (off_t)page_size * nr;
        if (lseek(mfp->mf_fd, offset, 0) != offset)
        {
            emsg((char_u *)(((char *)("E296: Seek error in swap file write"))));
            return 0;
        }
        if (hp2 == ((void *)0))
            page_count = 1;
        else
            page_count = hp2->bh_page_count;
        size = page_size * page_count;
        if ((unsigned)write((mfp->mf_fd), (char *)((hp2 == ((void *)0) ? hp : hp2)->bh_data), (size_t) (size)) != size)
        {
            if (!did_swapwrite_msg)
                emsg((char_u *)(((char *)("E297: Write error in swap file"))));
            did_swapwrite_msg = 1;
            return 0;
        }
        did_swapwrite_msg = 0;
        if (hp2 != ((void *)0))
            hp2->bh_flags &= ~1;
        if (nr + (blocknr_T)page_count > mfp->mf_infile_count)
            mfp->mf_infile_count = nr + page_count;
        if (nr == hp->bh_bnum)
            break;
    }
    return 1;
}
    static int mf_trans_add(mfp, hp)
    memfile_T *mfp;
    bhdr_T *hp;
{
    bhdr_T *freep;
    blocknr_T new_bnum;
    int hash;
    NR_TRANS *np;
    int page_count;
    if (hp->bh_bnum >= 0)
        return 1;
    if ((np = (NR_TRANS *)alloc((unsigned)sizeof(NR_TRANS))) == ((void *)0))
        return 0;
    freep = mfp->mf_free_first;
    page_count = hp->bh_page_count;
    if (freep != ((void *)0) && freep->bh_page_count >= page_count)
    {
        new_bnum = freep->bh_bnum;
        if (freep->bh_page_count > page_count)
        {
            freep->bh_bnum += page_count;
            freep->bh_page_count -= page_count;
        }
        else
        {
            freep = mf_rem_free(mfp);
            vim_free(freep);
        }
    }
    else
    {
        new_bnum = mfp->mf_blocknr_max;
        mfp->mf_blocknr_max += page_count;
    }
    np->nt_old_bnum = hp->bh_bnum;
    np->nt_new_bnum = new_bnum;
    mf_rem_hash(mfp, hp);
    hp->bh_bnum = new_bnum;
    mf_ins_hash(mfp, hp);
    hash = ((np->nt_old_bnum) & (64 - 1));
    np->nt_next = mfp->mf_trans[hash];
    mfp->mf_trans[hash] = np;
    if (np->nt_next != ((void *)0))
        np->nt_next->nt_prev = np;
    np->nt_prev = ((void *)0);
    return 1;
}
    blocknr_T mf_trans_del(mfp, old_nr)
    memfile_T *mfp;
    blocknr_T old_nr;
{
    int hash;
    NR_TRANS *np;
    blocknr_T new_bnum;
    hash = ((old_nr) & (64 - 1));
    for (np = mfp->mf_trans[hash]; np != ((void *)0); np = np->nt_next)
        if (np->nt_old_bnum == old_nr)
            break;
    if (np == ((void *)0))
        return old_nr;
    mfp->mf_neg_count--;
    new_bnum = np->nt_new_bnum;
    if (np->nt_prev != ((void *)0))
        np->nt_prev->nt_next = np->nt_next;
    else
        mfp->mf_trans[hash] = np->nt_next;
    if (np->nt_next != ((void *)0))
        np->nt_next->nt_prev = np->nt_prev;
    vim_free(np);
    return new_bnum;
}
    void mf_set_ffname(mfp)
    memfile_T *mfp;
{
    mfp->mf_ffname = FullName_save(mfp->mf_fname, 0);
}
    void mf_fullname(mfp)
    memfile_T *mfp;
{
    if (mfp != ((void *)0) && mfp->mf_fname != ((void *)0) && mfp->mf_ffname != ((void *)0))
    {
        vim_free(mfp->mf_fname);
        mfp->mf_fname = mfp->mf_ffname;
        mfp->mf_ffname = ((void *)0);
    }
}
    int mf_need_trans(mfp)
    memfile_T *mfp;
{
    return (mfp->mf_fname != ((void *)0) && mfp->mf_neg_count > 0);
}
    static void mf_do_open(mfp, fname, flags)
    memfile_T *mfp;
    char_u *fname;
    int flags;
{
    struct stat sb;
    mfp->mf_fname = fname;
    mf_set_ffname(mfp);
    if ((flags & 0100) && lstat(((char *)mfp->mf_fname), (&sb)) >= 0)
    {
        mfp->mf_fd = -1;
        emsg((char_u *)(((char *)("E300: Swap file already exists (symlink attack?)"))));
    }
    else
    mfp->mf_fd = open(
            (char *)mfp->mf_fname,
            flags | 0
                    , (mode_t)0600
                    );
    if (mfp->mf_fd < 0)
    {
        vim_free(mfp->mf_fname);
        vim_free(mfp->mf_ffname);
        mfp->mf_fname = ((void *)0);
        mfp->mf_ffname = ((void *)0);
    }
    else
        mch_hide(mfp->mf_fname);
}
