typedef long int __off_t;
__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _blksize;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
extern int _IO_putc (int __c, _IO_FILE *__fp) ;
typedef unsigned char char_u;
char_u *alloc (unsigned size);
int byte2cells (int b);
int emsg (char_u *s);
extern int fprintf (FILE *__restrict __stream,
                    __const char *__restrict __format, ...) ;
char_u *gettail (char_u *fname);
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
char_u *home_replace_save (buf_T *buf, char_u *src);
int mch_dirname (char_u *buf, int len);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
int msg (char_u *s);
void msg_putchar (int c);
void msg_puts (char_u *s);
void msg_puts_attr (char_u *s, int attr);
void msg_start (void);
void out_flush (void);
void redraw_later (int type);
void set_keep_msg (char_u *s);
int shortmess (int x);
char_u *skipwhite (char_u *p);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
void trunc_string (char_u *s, char_u *buf, int room);
void ui_breakcheck (void);
void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
int vim_strsize (char_u *s);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
extern long Columns ;
extern char_u *IObuff;
extern long Rows
                            ;
extern int State ;
extern int cmdline_row;
typedef struct
{
    int hide;
    int browse;
    int split;
    int confirm;
} cmdmod_T;
extern cmdmod_T cmdmod;
extern buf_T *curbuf ;
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
extern win_T *curwin;
extern int emsg_silent ;
extern int got_int ;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
extern int highlight_attr[HLF_COUNT];
extern int keep_msg_attr ;
extern int lcs_tab1 ;
extern int msg_row;
extern int msg_scroll ;
extern int msg_scrolled;
extern int need_wait_return ;
extern linenr_T sourcing_lnum ;
extern char_u *sourcing_name ;
int ga_grow (garray_T *gap, int n);
int ptr2cells (char_u *p);
extern int tolower (int __c) ;
char_u *transchar (int c);
char_u *vim_strnsave (char_u *string, int len);
int char2cells (int c);
int safe_vgetc (void);
extern int msg_col;
extern int must_redraw ;
enum key_extra
{
    KE_NAME = 3
    , KE_S_UP
    , KE_S_DOWN
    , KE_S_F1
    , KE_S_F2
    , KE_S_F3
    , KE_S_F4
    , KE_S_F5
    , KE_S_F6
    , KE_S_F7
    , KE_S_F8
    , KE_S_F9
    , KE_S_F10
    , KE_S_F11
    , KE_S_F12
    , KE_S_F13
    , KE_S_F14
    , KE_S_F15
    , KE_S_F16
    , KE_S_F17
    , KE_S_F18
    , KE_S_F19
    , KE_S_F20
    , KE_S_F21
    , KE_S_F22
    , KE_S_F23
    , KE_S_F24
    , KE_S_F25
    , KE_S_F26
    , KE_S_F27
    , KE_S_F28
    , KE_S_F29
    , KE_S_F30
    , KE_S_F31
    , KE_S_F32
    , KE_S_F33
    , KE_S_F34
    , KE_S_F35
    , KE_S_F36
    , KE_S_F37
    , KE_MOUSE
    , KE_LEFTMOUSE
    , KE_LEFTDRAG
    , KE_LEFTRELEASE
    , KE_MIDDLEMOUSE
    , KE_MIDDLEDRAG
    , KE_MIDDLERELEASE
    , KE_RIGHTMOUSE
    , KE_RIGHTDRAG
    , KE_RIGHTRELEASE
    , KE_IGNORE
    , KE_TAB
    , KE_S_TAB_OLD
    , KE_SNIFF
    , KE_XF1
    , KE_XF2
    , KE_XF3
    , KE_XF4
    , KE_XEND
    , KE_XHOME
    , KE_LEFTMOUSE_NM
    , KE_LEFTRELEASE_NM
    , KE_S_XF1
    , KE_S_XF2
    , KE_S_XF3
    , KE_S_XF4
    , KE_MOUSEDOWN
    , KE_MOUSEUP
    , KE_KINS
    , KE_KDEL
    , KE_CSI
    , KE_SNR
    , KE_PLUG
    , KE_CMDWIN
    , KE_C_LEFT
    , KE_C_RIGHT
    , KE_C_HOME
    , KE_C_END
    , KE_X1MOUSE
    , KE_X1DRAG
    , KE_X1RELEASE
    , KE_X2MOUSE
    , KE_X2DRAG
    , KE_X2RELEASE
    , KE_DROP
};
void cursor_off (void);
char_u *get_special_key_name (int c, int modifiers);
int mouse_has (int c);
int msg_attr (char_u *s, int attr);
void screen_putchar (int c, int row, int col, int attr);
void screen_puts (char_u *text, int row, int col, int attr);
void setmouse (void);
void stuffcharReadbuff (int c);
void vim_beep (void);
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
extern int need_check_timestamps ;
extern int did_check_timestamps ;
extern int emsg_on_display ;
extern int global_busy ;
extern int mouse_row;
extern int redraw_cmdline ;
extern int sc_col;
int do_dialog (int type, char_u *title, char_u *message, char_u *buttons, int dfltbutton, char_u *textfield);
extern char *getenv (__const char *__name) ;
int mch_isdir (char_u *name);
void msg_clr_eos (void);
int msg_end (void);
int msg_outtrans_len_attr (char_u *msgstr, int len, int attr);
void msg_putchar_attr (int c, int attr);
char_u *str2special (char_u **sp, int from);
extern int emsg_severe ;
void msg_starthere (void);
void set_vim_var_string (int idx, char_u *val, int len);
extern char *strstr (__const char *__haystack, __const char *__needle)
             __attribute__ ((__pure__));
void write_reg_contents (int name, char_u *str, int maxlen, int must_append);
extern int cmd_silent ;
extern int did_emsg;
extern int emsg_off ;
extern int emsg_skip ;
extern int lines_left ;
extern int msg_didout ;
extern int no_wait_return ;
extern char_u *p_go;
extern int starting ;
extern int vgetc_busy ;
void starttermcap (void);
int swapping_screen (void);
void wait_return (int redraw);
void windgoto (int row, int col);
extern int exiting ;
extern int exmode_active ;
extern int msg_didany ;
extern int msg_no_more ;
extern int msg_scrolled_ign ;
extern int msg_silent ;
extern int silent_mode ;
extern int skip_redraw ;
void screen_fill (int start_row, int end_row, int start_col, int end_col, int c1, int c2, int attr);
extern int redir_off ;
enum SpecialKey
{
    KS_NAME = 0,
    KS_CE,
    KS_AL,
    KS_CAL,
    KS_DL,
    KS_CDL,
    KS_CS,
    KS_CL,
    KS_CD,
    KS_UT,
    KS_DA,
    KS_DB,
    KS_VI,
    KS_VE,
    KS_VS,
    KS_ME,
    KS_MR,
    KS_MD,
    KS_SE,
    KS_SO,
    KS_CZH,
    KS_CZR,
    KS_UE,
    KS_US,
    KS_MS,
    KS_CM,
    KS_SR,
    KS_CRI,
    KS_VB,
    KS_KS,
    KS_KE,
    KS_TI,
    KS_TE,
    KS_BC,
    KS_CCS,
    KS_CCO,
    KS_CSF,
    KS_CSB,
    KS_XS,
    KS_MB,
    KS_CAF,
    KS_CAB,
    KS_LE,
    KS_ND,
    KS_CIS,
    KS_CIE,
    KS_TS,
    KS_FS,
    KS_CWP,
    KS_CWS,
    KS_CRV,
    KS_CSV,
    KS_OP
};
extern char_u *(term_strings[]);
void beep_flush (void);
extern int fputs (__const char *__restrict __s, FILE *__restrict __stream)
            ;
int ins_typebuf (char_u *str, int noremap, int offset, int nottyped, int silent);int msg_outtrans_attr (char_u *str, int attr);
void shell_resized (void);
extern FILE *redir_fd ;
extern int redir_reg ;
void clip_copy_modeless_selection (int both);
void msg_check (void);
typedef unsigned long Atom;
typedef gulong GdkAtom;
typedef struct VimClipboard
{
    int available;
    int owned;
    pos_T start;
    pos_T end;
    int vmode;
    short_u origin_row;
    short_u origin_start_col;
    short_u origin_end_col;
    short_u word_start_col;
    short_u word_end_col;
    pos_T prev;
    short_u state;
    short_u mode;
    Atom sel_atom;
    GdkAtom gtk_sel_atom;
} VimClipboard;
extern VimClipboard clip_star;
extern int quit_more ;
void mch_msg (char *str);
char_u *msg_may_trunc (int force, char_u *s);
extern char_u *keep_msg ;
void flush_buffers (int typeahead);
int get_keystroke (void);
typedef struct VimMenu vimmenu_T;
struct VimMenu
{
    int modes;
    int enabled;
    char_u *name;
    char_u *dname;
    int mnemonic;
    char_u *actext;
    int priority;
    void (*cb)();
    char_u *iconfile;
    int iconidx;
    int icon_builtin;
    char_u *strings[6];
    int noremap[6];
    char silent[6];
    vimmenu_T *children;
    vimmenu_T *parent;
    vimmenu_T *next;
    GtkWidget *id;
    GtkWidget *submenu_id;
    GtkWidget *tearoff_handle;
    GtkWidget *label;
};
int get_menu_index (vimmenu_T *menu, int state);
extern vimmenu_T *current_menu;
void gui_undraw_cursor (void);
extern int isatty (int __fd) ;
void mch_errmsg (char *str);
void out_str (char_u *s);
extern unsigned *LineOffset ;
extern char_u *ScreenAttrs ;
extern garray_T error_ga
        ;
extern int full_screen ;
extern FILE *stderr;
extern int newline_on_exit ;
extern int printf (__const char *__restrict __format, ...) ;
int can_clear (char_u *p);
int screen_del_lines (int off, int row, int line_count, int end, int force, win_T *wp);
extern int lcs_tab2 ;
extern int lcs_trail ;
typedef void *__gnuc_va_list;
extern char_u *p_bsdir;
extern char_u *p_debug;
extern int p_eb;
int cause_errthrow (char_u *msg, int severe, int *ignore);
void typeahead_noflush (int c);
void msg_puts_long_len_attr (char_u *longstr, int len, int attr);
void msg_moremsg (int full);
void display_confirm_msg (void);
char_u *gui_mch_browse (int saving, char_u *title, char_u *dflt, char_u *ext, char_u *initdir, char_u *filter);
int gui_mch_dialog (int type, char_u *title, char_u *message, char_u *buttons, int def_but, char_u *textfield);
struct msg_hist
{
    struct msg_hist *next;
    char_u *msg;
    int attr;
};
extern int vsnprintf (char *__restrict __s, size_t __maxlen,
                      __const char *__restrict __format, __gnuc_va_list __arg)
             __attribute__ ((__format__ (__printf__, 3, 0)));
typedef __gnuc_va_list va_list;
char_u *get_var_value (char_u *name);
extern int termcap_active ;
int jump_to_mouse (int flags, int *inclusive, int which_button);
int msg_attr_keep (char_u *s, int attr, int keep);
extern int more_back ;
extern int more_back_used ;
char_u *msg_strtrunc (char_u *s);
extern int p_more;
int msg_use_printf (void);
extern int info_message ;
void screen_puts_len (char_u *text, int len, int row, int col, int attr);
int screen_valid (int clear);
extern int called_emsg;
extern int did_wait_return ;
extern int do_redraw ;
extern int lcs_eol ;
extern int msg_nowait ;
static void reset_last_sourcing (void);
static void add_msg_hist (char_u *s, int len, int attr);
static void hit_return_msg (void);
static void msg_home_replace_attr (char_u *fname, int attr);
static void msg_puts_attr_len (char_u *str, int maxlen, int attr);
static void t_puts (int t_col, char_u *t_s, char_u *s, int attr);
static void msg_screen_putchar (int c, int attr);
static int msg_check_screen (void);
static void redir_write (char_u *s, int maxlen);
static char_u *msg_show_console_dialog (char_u *message, char_u *buttons, int dfltbutton);
static int confirm_msg_used = 0;
static char_u *confirm_msg = ((void *)0);
static char_u *confirm_msg_tail;
static struct msg_hist *first_msg_hist = ((void *)0);
static struct msg_hist *last_msg_hist = ((void *)0);
static int msg_hist_len = 0;
static int msg_hist_off = 0;
    int msg(s)
    char_u *s;
{
    return msg_attr_keep(s, 0, 0);
}
    int msg_attr(s, attr)
    char_u *s;
    int attr;
{
    return msg_attr_keep(s, attr, 0);
}
    int msg_attr_keep(s, attr, keep)
    char_u *s;
    int attr;
    int keep;
{
    static int entered = 0;
    int retval;
    char_u *buf = ((void *)0);
    if (attr == 0)
        set_vim_var_string(5, s, -1);
    if (entered >= 3)
        return 1;
    ++entered;
    if (s != keep_msg
            || (*s != '<'
                && last_msg_hist != ((void *)0)
                && last_msg_hist->msg != ((void *)0)
                && strcmp((char *)(s), (char *)(last_msg_hist->msg))))
        add_msg_hist(s, -1, attr);
    if (s == keep_msg)
        keep_msg = ((void *)0);
    buf = msg_strtrunc(s);
    if (buf != ((void *)0))
        s = buf;
    msg_start();
    msg_outtrans_attr(s, attr);
    if (msg_silent == 0)
        msg_clr_eos();
    retval = msg_end();
    if (keep && retval && vim_strsize(s) < (int)(Rows - cmdline_row - 1)
                                                           * Columns + sc_col)
    {
        set_keep_msg(s);
        keep_msg_attr = 0;
    }
    vim_free(buf);
    --entered;
    return retval;
}
    char_u * msg_strtrunc(s)
    char_u *s;
{
    char_u *buf = ((void *)0);
    int len;
    int room;
    if (!msg_scroll && !need_wait_return && shortmess('T')
                                                            && !exmode_active)
    {
        len = vim_strsize(s);
        room = (int)(Rows - cmdline_row - 1) * Columns + sc_col - 1;
        if (len > room && room > 0)
        {
                buf = alloc(room + 2);
            if (buf != ((void *)0))
                trunc_string(s, buf, room);
        }
    }
    return buf;
}
    void trunc_string(s, buf, room)
    char_u *s;
    char_u *buf;
    int room;
{
    int half;
    int len;
    int e;
    int i;
    int n;
    room -= 3;
    half = room / 2;
    len = 0;
    for (e = 0; len < half; ++e)
    {
        if (s[e] == '\000')
        {
            buf[e] = '\000';
            return;
        }
        n = ptr2cells(s + e);
        if (len + n >= half)
            break;
        len += n;
        buf[e] = s[e];
    }
    i = e;
    {
        for (i = (int)strlen((char *)(s)); len + (n = ptr2cells(s + i - 1)) <= room; --i)
            len += n;
    }
    memmove((char *)(buf + e), (char *)("..."), (size_t)3);
    memmove((char *)(buf + e + 3), (char *)(s + i), strlen((char *)(s + i)) + 1);
}
    int smsg(char_u *s, ...)
{
    va_list arglist;
    (arglist = ((__gnuc_va_list) __builtin_next_arg (s)));
    vsnprintf((char *)IObuff, (1024+1), (char *)s, arglist);
    ((void)0);
    return msg(IObuff);
}
    int smsg_attr(int attr, char_u *s, ...)
{
    va_list arglist;
    (arglist = ((__gnuc_va_list) __builtin_next_arg (s)));
    vsnprintf((char *)IObuff, (1024+1), (char *)s, arglist);
    ((void)0);
    return msg_attr(IObuff, attr);
}
static int last_sourcing_lnum = 0;
static char_u *last_sourcing_name = ((void *)0);
    static void reset_last_sourcing()
{
    vim_free(last_sourcing_name);
    last_sourcing_name = ((void *)0);
    last_sourcing_lnum = 0;
}
    int emsg(s)
    char_u *s;
{
    char_u *Buf;
    int attr;
    int other_sourcing_name;
    char *p;
    int ignore = 0;
    int severe;
    called_emsg = 1;
    severe = emsg_severe;
    emsg_severe = 0;
    if ((emsg_off > 0 && *p_debug == '\000')
            || emsg_skip > 0
            )
        return 1;
    if (!emsg_off)
    {
        if (cause_errthrow(s, severe, &ignore) == 1)
        {
            if (!ignore)
                did_emsg = 1;
            return 1;
        }
        set_vim_var_string(3, s, -1);
        if (emsg_silent != 0)
        {
            redir_write(s, -1);
            return 1;
        }
        msg_silent = 0;
        cmd_silent = 0;
        if (global_busy)
            ++global_busy;
        if (p_eb)
            beep_flush();
        else
            flush_buffers(0);
        did_emsg = 1;
    }
    emsg_on_display = 1;
    ++msg_scroll;
    attr = highlight_attr[(int)(HLF_E)];
    if (msg_scrolled)
        need_wait_return = 1;
    if (sourcing_name != ((void *)0))
    {
        if (last_sourcing_name != ((void *)0))
            other_sourcing_name = strcmp((char *)(sourcing_name), (char *)(last_sourcing_name));
        else
            other_sourcing_name = 1;
    }
    else
        other_sourcing_name = 0;
    p = ((char *)("Error detected while processing %s:"));
    if (sourcing_name != ((void *)0)
            && (other_sourcing_name || sourcing_lnum != last_sourcing_lnum)
            && (Buf = alloc((unsigned)(strlen((char *)(sourcing_name))
                                                       + strlen((char *)(p))))) != ((void *)0))
    {
        ++no_wait_return;
        if (other_sourcing_name)
        {
            sprintf((char *)Buf, p, sourcing_name);
            msg_attr(Buf, attr);
        }
        if (sourcing_lnum != 0)
        {
            sprintf((char *)Buf, ((char *)("line %4ld:")), (long)sourcing_lnum);
            msg_attr(Buf, highlight_attr[(int)(HLF_N)]);
        }
        --no_wait_return;
        last_sourcing_lnum = sourcing_lnum;
        vim_free(Buf);
    }
    if (sourcing_name == ((void *)0) || other_sourcing_name)
    {
        vim_free(last_sourcing_name);
        if (sourcing_name == ((void *)0))
            last_sourcing_name = ((void *)0);
        else
            last_sourcing_name = vim_strsave(sourcing_name);
    }
    msg_nowait = 0;
    return msg_attr(s, attr);
}
    int emsg2(s, a1)
    char_u *s, *a1;
{
    if ((emsg_off > 0 && *p_debug == '\000')
            || emsg_skip > 0
            )
        return 1;
    if (a1 == ((void *)0))
        a1 = (char_u *)"[NULL]";
    if (strlen((char *)(s)) + (strstr((char *)s, "%s") != ((void *)0) ? strlen((char *)(a1)) : 20)
                                                            >= (size_t)(1024+1))
        a1 = (char_u *)((char *)("[string too long]"));
    sprintf((char *)IObuff, (char *)s, (char *)a1);
    return emsg(IObuff);
}
    int emsgn(s, n)
    char_u *s;
    long n;
{
    if ((emsg_off > 0 && *p_debug == '\000')
            || emsg_skip > 0
            )
        return 1;
    sprintf((char *)IObuff, (char *)s, n);
    return emsg(IObuff);
}
    char_u * msg_trunc_attr(s, force, attr)
    char_u *s;
    int force;
    int attr;
{
    int n;
    add_msg_hist(s, -1, attr);
    s = msg_may_trunc(force, s);
    msg_hist_off = 1;
    n = msg_attr(s, attr);
    msg_hist_off = 0;
    if (n)
        return s;
    return ((void *)0);
}
    char_u * msg_may_trunc(force, s)
    int force;
    char_u *s;
{
    int n;
    int room;
    room = (int)(Rows - cmdline_row - 1) * Columns + sc_col - 1;
    if ((force || (shortmess('t') && !exmode_active))
            && (n = (int)strlen((char *)(s)) - room) > 0)
    {
        s += n;
        *s = '<';
    }
    return s;
}
    static void add_msg_hist(s, len, attr)
    char_u *s;
    int len;
    int attr;
{
    struct msg_hist *p;
    if (msg_hist_off || msg_silent != 0)
        return;
    while (msg_hist_len > 20)
    {
        p = first_msg_hist;
        first_msg_hist = p->next;
        vim_free(p->msg);
        vim_free(p);
        --msg_hist_len;
    }
    p = (struct msg_hist *)alloc((int)sizeof(struct msg_hist));
    if (p != ((void *)0))
    {
        if (len < 0)
            len = (int)strlen((char *)(s));
        while (len > 0 && *s == '\n')
        {
            ++s;
            --len;
        }
        while (len > 0 && s[len - 1] == '\n')
            --len;
        p->msg = vim_strnsave(s, len);
        p->next = ((void *)0);
        p->attr = attr;
        if (last_msg_hist != ((void *)0))
            last_msg_hist->next = p;
        last_msg_hist = p;
        if (first_msg_hist == ((void *)0))
            first_msg_hist = last_msg_hist;
        ++msg_hist_len;
    }
}
    void ex_messages(eap)
    exarg_T *eap;
{
    struct msg_hist *p;
    char_u *s;
    msg_hist_off = 1;
    s = (char_u *)getenv((char *)((char_u *)"LANG"));
    if (s != ((void *)0) && *s != '\000')
        msg_attr((char_u *)
                ((char *)("Messages maintainer: Bram Moolenaar <Bram@vim.org>")),
                highlight_attr[(int)(HLF_T)]);
    for (p = first_msg_hist; p != ((void *)0); p = p->next)
        if (p->msg != ((void *)0))
            msg_attr(p->msg, p->attr);
    msg_hist_off = 0;
}
static void msg_end_prompt (void);
    static void msg_end_prompt()
{
    need_wait_return = 0;
    emsg_on_display = 0;
    cmdline_row = msg_row;
    msg_col = 0;
    msg_clr_eos();
}
    void wait_return(redraw)
    int redraw;
{
    int c;
    int oldState;
    int tmpState;
    int had_got_int;
    if (redraw == 1)
        must_redraw = 50;
    if (msg_silent != 0)
        return;
    if (vgetc_busy)
        return;
    if (no_wait_return)
    {
        need_wait_return = 1;
        if (!exmode_active)
            cmdline_row = msg_row;
        return;
    }
    redir_off = 1;
    oldState = State;
    if (quit_more)
    {
        c = '\015';
        quit_more = 0;
        got_int = 0;
    }
    else if (exmode_active)
    {
        msg_puts((char_u *)(" "));
        c = '\015';
        got_int = 0;
    }
    else
    {
        State = (0x200 + 0x01);
        setmouse();
        hit_return_msg();
        do
        {
            had_got_int = got_int;
            c = safe_vgetc();
            if (!global_busy)
                got_int = 0;
            if (c == 25 && clip_star.state == 2)
            {
                clip_copy_modeless_selection(1);
                c = (-((253) + ((int)(KE_IGNORE) << 8)));
            }
        } while ((had_got_int && c == 3)
                                || c == (-((253) + ((int)(KE_IGNORE) << 8)))
                                || c == (-((249) + ((int)(('X')) << 8))) || c == (-((248) + ((int)(('X')) << 8)))
                                || c == (-((253) + ((int)(KE_LEFTDRAG) << 8))) || c == (-((253) + ((int)(KE_LEFTRELEASE) << 8)))
                                || c == (-((253) + ((int)(KE_MIDDLEDRAG) << 8))) || c == (-((253) + ((int)(KE_MIDDLERELEASE) << 8)))
                                || c == (-((253) + ((int)(KE_RIGHTDRAG) << 8))) || c == (-((253) + ((int)(KE_RIGHTRELEASE) << 8)))
                                || c == (-((253) + ((int)(KE_MOUSEDOWN) << 8))) || c == (-((253) + ((int)(KE_MOUSEUP) << 8)))
                                || (!mouse_has('r')
                                    && mouse_row != Rows - 1
                                    && (c == (-((253) + ((int)(KE_LEFTMOUSE) << 8)))
                                        || c == (-((253) + ((int)(KE_MIDDLEMOUSE) << 8)))
                                        || c == (-((253) + ((int)(KE_RIGHTMOUSE) << 8)))
                                        || c == (-((253) + ((int)(KE_X1MOUSE) << 8)))
                                        || c == (-((253) + ((int)(KE_X2MOUSE) << 8)))))
                                );
        ui_breakcheck();
        if (c == (-((253) + ((int)(KE_LEFTMOUSE) << 8))) || c == (-((253) + ((int)(KE_MIDDLEMOUSE) << 8))) || c == (-((253) + ((int)(KE_RIGHTMOUSE) << 8)))
                                          || c == (-((253) + ((int)(KE_X1MOUSE) << 8))) || c == (-((253) + ((int)(KE_X2MOUSE) << 8))))
            (void)jump_to_mouse(0x08, ((void *)0), 0);
        else
            if (vim_strchr((char_u *)"\r\n ", c) == ((void *)0) && c != 3)
        {
            stuffcharReadbuff(c);
            do_redraw = 1;
        }
    }
    redir_off = 0;
    if (c == ':' || c == '?' || c == '/')
    {
        if (!exmode_active)
            cmdline_row = msg_row;
        skip_redraw = 1;
        do_redraw = 0;
    }
    tmpState = State;
    State = oldState;
    setmouse();
    msg_check();
    if (swapping_screen() && !termcap_active)
        newline_on_exit = 1;
    need_wait_return = 0;
    did_wait_return = 1;
    emsg_on_display = 0;
    lines_left = -1;
    reset_last_sourcing();
    if (keep_msg != ((void *)0) && vim_strsize(keep_msg) >=
                                  (Rows - cmdline_row - 1) * Columns + sc_col)
    {
        vim_free(keep_msg);
        keep_msg = ((void *)0);
    }
    if (tmpState == 0x400)
    {
        starttermcap();
        shell_resized();
    }
    else if (!skip_redraw
            && (redraw == 1 || (msg_scrolled != 0 && redraw != -1)))
    {
        starttermcap();
        redraw_later(10);
    }
}
    static void hit_return_msg()
{
    if (msg_didout)
        msg_putchar('\n');
    if (got_int)
        msg_puts((char_u *)(((char *)("Interrupt: "))));
    msg_puts_attr((char_u *)(((char *)("Hit ENTER or type command to continue"))), (highlight_attr[(int)(HLF_R)]));
    if (!msg_use_printf())
        msg_clr_eos();
}
    void set_keep_msg(s)
    char_u *s;
{
    vim_free(keep_msg);
    if (s != ((void *)0) && msg_silent == 0)
        keep_msg = vim_strsave(s);
    else
        keep_msg = ((void *)0);
}
    void msg_start()
{
    int did_return = 0;
    vim_free(keep_msg);
    keep_msg = ((void *)0);
    if (!msg_scroll && full_screen)
    {
        msg_row = cmdline_row;
        msg_col =
            0;
    }
    else if (msg_didout)
    {
        msg_putchar('\n');
        did_return = 1;
        if (exmode_active != 1)
            cmdline_row = msg_row;
    }
    if (!msg_didany || lines_left < 0)
        msg_starthere();
    msg_didout = 0;
    cursor_off();
    if (!did_return)
        redir_write((char_u *)"\n", -1);
}
    void msg_starthere()
{
    lines_left = cmdline_row;
    msg_didany = 0;
}
    void msg_putchar(c)
    int c;
{
    msg_putchar_attr(c, 0);
}
    void msg_putchar_attr(c, attr)
    int c;
    int attr;
{
    char_u buf[4];
    if (((c) < 0))
    {
        buf[0] = (0x80);
        buf[1] = ((c) == (0x80) ? 254 : (c) == '\000' ? 255 : ((-(c)) & 0xff));
        buf[2] = (((c) == (0x80) || (c) == '\000') ? ('X') : (((unsigned)(-(c)) >> 8) & 0xff));
        buf[3] = '\000';
    }
    else
    {
        buf[0] = c;
        buf[1] = '\000';
    }
    msg_puts_attr(buf, attr);
}
    void msg_outnum(n)
    long n;
{
    char_u buf[20];
    sprintf((char *)buf, "%ld", n);
    msg_puts(buf);
}
    void msg_home_replace(fname)
    char_u *fname;
{
    msg_home_replace_attr(fname, 0);
}
    void msg_home_replace_hl(fname)
    char_u *fname;
{
    msg_home_replace_attr(fname, highlight_attr[(int)(HLF_D)]);
}
    static void msg_home_replace_attr(fname, attr)
    char_u *fname;
    int attr;
{
    char_u *name;
    name = home_replace_save(((void *)0), fname);
    if (name != ((void *)0))
        msg_outtrans_attr(name, attr);
    vim_free(name);
}
    int msg_outtrans(str)
    char_u *str;
{
    return msg_outtrans_attr(str, 0);
}
    int msg_outtrans_attr(str, attr)
    char_u *str;
    int attr;
{
    return msg_outtrans_len_attr(str, (int)strlen((char *)(str)), attr);
}
    int msg_outtrans_len(str, len)
    char_u *str;
    int len;
{
    return msg_outtrans_len_attr(str, len, 0);
}
    char_u * msg_outtrans_one(p, attr)
    char_u *p;
    int attr;
{
    msg_puts_attr(transchar(*p), attr);
    return p + 1;
}
    int msg_outtrans_len_attr(msgstr, len, attr)
    char_u *msgstr;
    int len;
    int attr;
{
    int retval = 0;
    char_u *str = msgstr;
    char_u *plain_start = msgstr;
    char_u *s;
    if (attr & 0x1000)
    {
        add_msg_hist(str, len, attr);
        attr &= ~0x1000;
    }
    while (--len >= 0)
    {
        {
            s = transchar(*str);
            if (s[1] != '\000')
            {
                if (str > plain_start)
                    msg_puts_attr_len(plain_start, (int)(str - plain_start),
                                                                        attr);
                plain_start = str + 1;
                msg_puts_attr(s, attr == 0 ? highlight_attr[(int)(HLF_8)] : attr);
            }
            retval += ptr2cells(str);
            ++str;
        }
    }
    if (str > plain_start)
        msg_puts_attr_len(plain_start, (int)(str - plain_start), attr);
    return retval;
}
    void msg_make(arg)
    char_u *arg;
{
    int i;
    static char_u *str = (char_u *)"eeffoc", *rs = (char_u *)"Plon#dqg#vxjduB";
    arg = skipwhite(arg);
    for (i = 5; *arg && i >= 0; --i)
        if (*arg++ != str[i])
            break;
    if (i < 0)
    {
        msg_putchar('\n');
        for (i = 0; rs[i]; ++i)
            msg_putchar(rs[i] - 3);
    }
}
    int msg_outtrans_special(strstart, from)
    char_u *strstart;
    int from;
{
    char_u *str = strstart;
    int retval = 0;
    char_u *string;
    int attr;
    int len;
    attr = highlight_attr[(int)(HLF_8)];
    while (*str != '\000')
    {
        if ((str == strstart || str[1] == '\000') && *str == ' ')
        {
            string = (char_u *)"<Space>";
            ++str;
        }
        else
            string = str2special(&str, from);
        len = vim_strsize(string);
        msg_puts_attr(string, len > 1
                ? attr : 0);
        retval += len;
    }
    return retval;
}
    char_u * str2special(sp, from)
    char_u **sp;
    int from;
{
    int c;
    static char_u buf[7];
    char_u *str = *sp;
    int modifiers = 0;
    int special = 0;
    c = *str;
    if (c == (0x80) && str[1] != '\000' && str[2] != '\000')
    {
        if (str[1] == 252)
        {
            modifiers = str[2];
            str += 3;
            c = *str;
        }
        if (c == (0x80) && str[1] != '\000' && str[2] != '\000')
        {
            c = ((str[1]) == 254 ? (0x80) : (str[1]) == 255 ? (-((255) + ((int)(('X')) << 8))) : (-((str[1]) + ((int)(str[2]) << 8))));
            str += 2;
            if (c == (-((255) + ((int)(('X')) << 8))))
                c = '\000';
        }
        if (((c) < 0) || modifiers)
            special = 1;
    }
    *sp = str + 1;
    if (special || char2cells(c) > 1 || (from && c == ' '))
        return get_special_key_name(c, modifiers);
    buf[0] = c;
    buf[1] = '\000';
    return buf;
}
    void str2specialbuf(sp, buf, len)
    char_u *sp;
    char_u *buf;
    int len;
{
    char_u *s;
    *buf = '\000';
    while (*sp)
    {
        s = str2special(&sp, 0);
        if ((int)(strlen((char *)(s)) + strlen((char *)(buf))) < len)
            strcat((char *)(buf), (char *)(s));
    }
}
    void msg_prt_line(s)
    char_u *s;
{
    int c;
    int col = 0;
    int n_extra = 0;
    int c_extra = 0;
    char_u *p_extra = ((void *)0);
    int n;
    int attr= 0;
    char_u *trail = ((void *)0);
    if (curwin->w_onebuf_opt.wo_list && lcs_trail)
    {
        trail = s + strlen((char *)(s));
        while (trail > s && ((trail[-1]) == ' ' || (trail[-1]) == '\t'))
            --trail;
    }
    if (*s == '\000' && !curwin->w_onebuf_opt.wo_list)
        msg_putchar(' ');
    for (;;)
    {
        if (n_extra)
        {
            --n_extra;
            if (c_extra)
                c = c_extra;
            else
                c = *p_extra++;
        }
        else
        {
            attr = 0;
            c = *s++;
            if (c == '\011' && (!curwin->w_onebuf_opt.wo_list || lcs_tab1))
            {
                n_extra = curbuf->b_p_ts - col % curbuf->b_p_ts - 1;
                if (!curwin->w_onebuf_opt.wo_list)
                {
                    c = ' ';
                    c_extra = ' ';
                }
                else
                {
                    c = lcs_tab1;
                    c_extra = lcs_tab2;
                    attr = highlight_attr[(int)(HLF_8)];
                }
            }
            else if (c == '\000' && curwin->w_onebuf_opt.wo_list && lcs_eol)
            {
                p_extra = (char_u *)"";
                c_extra = '\000';
                n_extra = 1;
                c = lcs_eol;
                attr = highlight_attr[(int)(HLF_AT)];
                --s;
            }
            else if (c != '\000' && (n = byte2cells(c)) > 1)
            {
                n_extra = n - 1;
                p_extra = transchar(c);
                c_extra = '\000';
                c = *p_extra++;
            }
            else if (c == ' ' && trail != ((void *)0) && s > trail)
            {
                c = lcs_trail;
                attr = highlight_attr[(int)(HLF_8)];
            }
        }
        if (c == '\000')
            break;
        msg_putchar_attr(c, attr);
        col++;
    }
    msg_clr_eos();
}
    void msg_puts(s)
    char_u *s;
{
    msg_puts_attr(s, 0);
}
    void msg_puts_title(s)
    char_u *s;
{
    msg_puts_attr(s, highlight_attr[(int)(HLF_T)]);
}
    void msg_puts_long_attr(longstr, attr)
    char_u *longstr;
    int attr;
{
    msg_puts_long_len_attr(longstr, (int)strlen((char *)longstr), attr);
}
    void msg_puts_long_len_attr(longstr, len, attr)
    char_u *longstr;
    int len;
    int attr;
{
    int slen = len;
    int room;
    room = Columns - msg_col;
    if (len > room && room >= 20)
    {
        slen = (room - 3) / 2;
        msg_outtrans_len_attr(longstr, slen, attr);
        msg_puts_attr((char_u *)"...", highlight_attr[(int)(HLF_8)]);
    }
    msg_outtrans_len_attr(longstr + len - slen, slen, attr);
}
    void msg_puts_attr(s, attr)
    char_u *s;
    int attr;
{
    msg_puts_attr_len(s, -1, attr);
}
    static void msg_puts_attr_len(str, maxlen, attr)
    char_u *str;
    int maxlen;
    int attr;
{
    int oldState;
    char_u *s = str;
    char_u *p;
    char_u buf[4];
    char_u *t_s = str;
    int t_col = 0;
    int c;
    redir_write(s, maxlen);
    if (msg_silent != 0)
        return;
    if ((attr & 0x1000) && maxlen < 0)
    {
        add_msg_hist(s, -1, attr);
        attr &= ~0x1000;
    }
    if (msg_scrolled && !msg_scrolled_ign)
        need_wait_return = 1;
    msg_didany = 1;
    if (msg_use_printf())
    {
        while (*s != '\000' && (maxlen < 0 || (int)(s - str) < maxlen))
        {
            if (!silent_mode)
            {
                p = &buf[0];
                if (*s == '\n' && !info_message)
                    *p++ = '\r';
                    *p++ = *s;
                *p = '\0';
                if (info_message)
                    mch_msg((char *)buf);
                else
                    mch_errmsg((char *)buf);
            }
            {
                if (*s == '\r' || *s == '\n')
                    msg_col = 0;
                else
                    ++msg_col;
            }
            ++s;
        }
        msg_didout = 1;
        return;
    }
    did_wait_return = 0;
    while (*s != '\000' && (maxlen < 0 || (int)(s - str) < maxlen))
    {
        if (msg_row >= Rows - 1
                && (*s == '\n'
                    || (
                      (msg_col + t_col >= Columns - 1
                       || (*s == '\011' && msg_col + t_col >= ((Columns - 1) & ~7))
                      ))))
        {
            if (t_col > 0)
            {
                t_puts(t_col, t_s, s, attr);
                t_col = 0;
            }
            if (msg_no_more && lines_left == 0)
                break;
            if (gui.in_use)
                gui_undraw_cursor();
            screen_del_lines(0, 0, 1, (int)Rows, 1, ((void *)0));
            if (!can_clear((char_u *)" "))
            {
                screen_fill((int)Rows - 1, (int)Rows, 0,
                                                   (int)Columns, ' ', ' ', 0);
                if (ScreenAttrs[LineOffset[Rows - 2] + Columns - 1]
                                                               == (char_u)-1)
                    screen_fill((int)Rows - 2, (int)Rows - 1,
                                 (int)Columns - 1, (int)Columns, ' ', ' ', 0);
            }
            msg_row = Rows - 2;
            if (msg_col >= Columns)
                msg_col = Columns - 1;
            ++msg_scrolled;
            need_wait_return = 1;
            if (must_redraw < 10)
                must_redraw = 10;
            redraw_cmdline = 1;
            if (cmdline_row > 0 && !exmode_active)
                --cmdline_row;
            if (p_more && --lines_left == 0 && State != (0x200 + 0x01)
                                            && !msg_no_more && !exmode_active)
            {
                oldState = State;
                State = 0x300;
                setmouse();
                msg_moremsg(0);
                for (;;)
                {
                    c = get_keystroke();
                    if (c == (-((250) + ((int)(('X')) << 8))))
                    {
                        int idx = get_menu_index(current_menu, 0x300);
                        if (idx == -1)
                            continue;
                        c = *current_menu->strings[idx];
                        if (c != '\000' && current_menu->strings[idx][1] != '\000')
                            ins_typebuf(current_menu->strings[idx] + 1,
                                    current_menu->noremap[idx], 0, 1,
                                    current_menu->silent[idx]);
                    }
                    switch (c)
                    {
                    case '\010':
                    case 'k':
                    case (-(('k') + ((int)('u') << 8))):
                        if (!more_back_used)
                        {
                            msg_moremsg(1);
                            continue;
                        }
                        more_back = 1;
                        lines_left = 1;
                        break;
                    case '\015':
                    case '\012':
                    case 'j':
                    case (-(('k') + ((int)('d') << 8))):
                        lines_left = 1;
                        break;
                    case ':':
                        if (!confirm_msg_used)
                        {
                            typeahead_noflush(':');
                            cmdline_row = Rows - 1;
                            skip_redraw = 1;
                            need_wait_return = 0;
                        }
                    case 'q':
                    case 3:
                    case '\033':
                        if (confirm_msg_used)
                        {
                            s = confirm_msg_tail;
                            lines_left = Rows - 1;
                        }
                        else
                        {
                            got_int = 1;
                            quit_more = 1;
                        }
                        break;
                    case 'u':
                    case (-(('k') + ((int)('P') << 8))):
                        if (!more_back_used)
                        {
                            msg_moremsg(1);
                            continue;
                        }
                        more_back = Rows / 2;
                    case 'd':
                        lines_left = Rows / 2;
                        break;
                    case 'b':
                        if (!more_back_used)
                        {
                            msg_moremsg(1);
                            continue;
                        }
                        more_back = Rows - 1;
                    case ' ':
                    case (-(('k') + ((int)('N') << 8))):
                    case (-((253) + ((int)(KE_LEFTMOUSE) << 8))):
                        lines_left = Rows - 1;
                        break;
                    case 25:
                        if (clip_star.state == 2)
                            clip_copy_modeless_selection(1);
                        continue;
                    default:
                        msg_moremsg(1);
                        continue;
                    }
                    break;
                }
                screen_fill((int)Rows - 1, (int)Rows,
                                                0, (int)Columns, ' ', ' ', 0);
                State = oldState;
                setmouse();
                if (quit_more)
                {
                    msg_row = Rows - 1;
                    msg_col = 0;
                    return;
                }
            }
        }
        if (t_col > 0
                && (vim_strchr((char_u *)"\n\r\b\t", *s) != ((void *)0)
                    || *s == '\007'
                    || msg_col + t_col >= Columns
                    ))
        {
            t_puts(t_col, t_s, s, attr);
            t_col = 0;
        }
        if (*s == '\n')
        {
            msg_didout = 0;
            msg_col = 0;
            if (++msg_row >= Rows)
                msg_row = Rows - 1;
        }
        else if (*s == '\r')
        {
            msg_col = 0;
        }
        else if (*s == '\b')
        {
            if (msg_col)
                --msg_col;
        }
        else if (*s == '\011')
        {
            do
                msg_screen_putchar(' ', attr);
            while (msg_col & 7);
        }
        else if (*s == '\007')
            vim_beep();
        else
        {
            {
                if (t_col == 0)
                    t_s = s;
                ++t_col;
            }
        }
        ++s;
    }
    if (t_col > 0)
        t_puts(t_col, t_s, s, attr);
    msg_check();
}
    static void t_puts(t_col, t_s, s, attr)
    int t_col;
    char_u *t_s;
    char_u *s;
    int attr;
{
    msg_didout = 1;
    screen_puts_len(t_s, (int)(s - t_s), msg_row, msg_col, attr);
    msg_col += t_col;
    if (msg_col >= Columns)
    {
        msg_col = 0;
        ++msg_row;
    }
}
    int msg_use_printf()
{
    return (!msg_check_screen()
            || (swapping_screen() && !termcap_active)
               );
}
    void mch_errmsg(str)
    char *str;
{
    int len;
    if (
            isatty(2)
            ||
            !(gui.in_use || gui.starting)
            )
    {
        fprintf(stderr, "%s", str);
        return;
    }
    emsg_on_display = 0;
    len = (int)strlen((char *)(str)) + 1;
    if (error_ga.ga_growsize == 0)
    {
        error_ga.ga_growsize = 80;
        error_ga.ga_itemsize = 1;
    }
    if (ga_grow(&error_ga, len) == 1)
    {
        memmove((char *)((char_u *)error_ga.ga_data + error_ga.ga_len), (char *)((char_u *)str), len);
        {
            char_u *p;
            p = (char_u *)error_ga.ga_data + error_ga.ga_len;
            for (;;)
            {
                p = vim_strchr(p, '\r');
                if (p == ((void *)0))
                    break;
                *p = ' ';
            }
        }
        --len;
        error_ga.ga_len += len;
        error_ga.ga_room -= len;
    }
}
    void mch_msg(str)
    char *str;
{
    if (
            isatty(2)
            ||
            !(gui.in_use || gui.starting)
            )
    {
        printf("%s", str);
        return;
    }
    mch_errmsg(str);
}
    static void msg_screen_putchar(c, attr)
    int c;
    int attr;
{
    msg_didout = 1;
    screen_putchar(c, msg_row, msg_col, attr);
    {
        if (++msg_col >= Columns)
        {
            msg_col = 0;
            ++msg_row;
        }
    }
}
    void msg_moremsg(full)
    int full;
{
    int attr;
    attr = highlight_attr[(int)(HLF_M)];
    screen_puts((char_u *)((char *)("-- More --")), (int)Rows - 1, 0, attr);
    if (full)
        screen_puts(more_back_used
            ? (char_u *)((char *)(" (RET/BS: line, SPACE/b: page, d/u: half page, q: quit)"))
            : (char_u *)((char *)(" (RET: line, SPACE: page, d: half page, q: quit)")),
            (int)Rows - 1, 10, attr);
}
    void repeat_message()
{
    if (State == 0x300)
    {
        msg_moremsg(1);
        msg_row = Rows - 1;
    }
    else if (State == 0x800)
    {
        display_confirm_msg();
        msg_row = Rows - 1;
    }
    else if (State == 0x600)
    {
        windgoto(msg_row, msg_col);
    }
    else if (State == (0x200 + 0x01) || State == 0x400)
    {
        hit_return_msg();
        msg_row = Rows - 1;
    }
}
    static int msg_check_screen()
{
    if (!full_screen || !screen_valid(0))
        return 0;
    if (msg_row >= Rows)
        msg_row = Rows - 1;
    if (msg_col >= Columns)
        msg_col = Columns - 1;
    return 1;
}
    void msg_clr_eos()
{
    if (msg_use_printf())
    {
        if (full_screen)
        {
            if (*(term_strings[(int)(KS_CD)]))
                out_str((term_strings[(int)(KS_CD)]));
            else if (*(term_strings[(int)(KS_CE)]))
                out_str((term_strings[(int)(KS_CE)]));
        }
    }
    else
    {
        {
            screen_fill(msg_row, msg_row + 1, msg_col, (int)Columns,
                                                                 ' ', ' ', 0);
            screen_fill(msg_row + 1, (int)Rows, 0, (int)Columns, ' ', ' ', 0);
        }
    }
}
    void msg_clr_cmdline()
{
    msg_row = cmdline_row;
    msg_col = 0;
    msg_clr_eos();
}
    int msg_end()
{
    if (!exiting && need_wait_return && !(State & 0x08))
    {
        wait_return(0);
        return 0;
    }
    out_flush();
    return 1;
}
    void msg_check()
{
    if (msg_row == Rows - 1 && msg_col >= sc_col)
    {
        need_wait_return = 1;
        redraw_cmdline = 1;
    }
}
    static void redir_write(str, maxlen)
    char_u *str;
    int maxlen;
{
    char_u *s = str;
    static int cur_col = 0;
    if ((redir_fd != ((void *)0)
                          || redir_reg
                                       ) && !redir_off)
    {
        if (*s != '\n' && *s != '\r')
        {
            while (cur_col < msg_col)
            {
                if (redir_reg)
                    write_reg_contents(redir_reg, (char_u *)" ", -1, 1);
                else if (redir_fd)
                    fputs(" ", redir_fd);
                ++cur_col;
            }
        }
        if (redir_reg)
            write_reg_contents(redir_reg, s, maxlen, 1);
        while (*s != '\000' && (maxlen < 0 || (int)(s - str) < maxlen))
        {
            if (!redir_reg && redir_fd != ((void *)0))
                _IO_putc (*s, redir_fd);
            if (*s == '\r' || *s == '\n')
                cur_col = 0;
            else if (*s == '\t')
                cur_col += (8 - cur_col % 8);
            else
                ++cur_col;
            ++s;
        }
    }
}
    void give_warning(message, hl)
    char_u *message;
    int hl;
{
    if (msg_silent != 0)
        return;
    set_vim_var_string(4, message, -1);
    vim_free(keep_msg);
    keep_msg = ((void *)0);
    if (hl)
        keep_msg_attr = highlight_attr[(int)(HLF_W)];
    else
        keep_msg_attr = 0;
    if (msg_attr(message, keep_msg_attr) && msg_scrolled == 0)
        set_keep_msg(message);
    msg_didout = 0;
    msg_nowait = 1;
    msg_col = 0;
}
    void msg_advance(col)
    int col;
{
    if (msg_silent != 0)
    {
        msg_putchar(' ');
        return;
    }
    if (col >= Columns)
        col = Columns - 1;
    while (msg_col < col)
        msg_putchar(' ');
}
    int do_dialog(type, title, message, buttons, dfltbutton, textfield)
    int type;
    char_u *title;
    char_u *message;
    char_u *buttons;
    int dfltbutton;
    char_u *textfield;
{
    int oldState;
    int retval = 0;
    char_u *hotkeys;
    int c;
    if (silent_mode)
        return dfltbutton;
    if (gui.in_use && vim_strchr(p_go, 'c') == ((void *)0))
    {
        c = gui_mch_dialog(type, title, message, buttons, dfltbutton,
                                                                   textfield);
        msg_end_prompt();
        return c;
    }
    oldState = State;
    State = 0x800;
    setmouse();
    ++no_wait_return;
    hotkeys = msg_show_console_dialog(message, buttons, dfltbutton);
    if (hotkeys != ((void *)0))
    {
        for (;;)
        {
            c = get_keystroke();
            switch (c)
            {
            case '\015':
            case '\012':
                retval = dfltbutton;
                break;
            case 3:
            case '\033':
                retval = 0;
                break;
            default:
                if (c > 255)
                    continue;
                for (retval = 0; hotkeys[retval]; retval++)
                {
                    if (hotkeys[retval] == tolower(c))
                        break;
                }
                if (hotkeys[retval])
                {
                    retval++;
                    break;
                }
                continue;
            }
            break;
        }
        vim_free(hotkeys);
    }
    State = oldState;
    setmouse();
    --no_wait_return;
    msg_end_prompt();
    return retval;
}
    static char_u * msg_show_console_dialog(message, buttons, dfltbutton)
    char_u *message;
    char_u *buttons;
    int dfltbutton;
{
    int len = 0;
    int lenhotkey = 1;
    char_u *hotk;
    char_u *p;
    char_u *q;
    char_u *r;
    r = buttons;
    while (*r)
    {
        if (*r == '\n')
        {
            len++;
            lenhotkey++;
        }
        else if (*r == '&')
        {
            len++;
        }
        r++;
    }
    len += strlen((char *)(message))
            + 2
            + strlen((char *)(buttons))
            + 3;
    lenhotkey++;
    vim_free(confirm_msg);
    confirm_msg = alloc(len);
    if (confirm_msg == ((void *)0))
        return ((void *)0);
    *confirm_msg = '\000';
    hotk = alloc(lenhotkey);
    if (hotk == ((void *)0))
        return ((void *)0);
    *confirm_msg = '\n';
    strcpy((char *)(confirm_msg + 1), (char *)(message));
    p = confirm_msg + 1 + strlen((char *)(message));
    q = hotk;
    r = buttons;
    *q = (char_u)tolower(*r);
    confirm_msg_tail = p;
    *p++ = '\n';
    while (*r)
    {
        if (*r == '\n')
        {
            *p++ = ',';
            *p++ = ' ';
            *(++q) = (char_u)tolower(*(r + 1));
            if (dfltbutton)
                --dfltbutton;
        }
        else if (*r == '&')
        {
            r++;
            if (*r == '&')
                *p++ = *r;
            else
            {
                *p++ = (dfltbutton == 1) ? '[' : '(';
                *p++ = *r;
                *p++ = (dfltbutton == 1) ? ']' : ')';
                *q = (char_u)tolower(*r);
            }
        }
        else
        {
            *p++ = *r;
        }
        r++;
    }
    *p++ = ':';
    *p++ = ' ';
    *p = '\000';
    *(++q) = '\000';
    display_confirm_msg();
    return hotk;
}
    void display_confirm_msg()
{
    ++confirm_msg_used;
    if (confirm_msg != ((void *)0))
        msg_puts_attr(confirm_msg, highlight_attr[(int)(HLF_M)]);
    --confirm_msg_used;
}
    int vim_dialog_yesno(type, title, message, dflt)
    int type;
    char_u *title;
    char_u *message;
    int dflt;
{
    if (do_dialog(type,
                title == ((void *)0) ? (char_u *)((char *)("Question")) : title,
                message,
                (char_u *)((char *)("&Yes\n&No")), dflt, ((void *)0)) == 1)
        return 2;
    return 3;
}
    int vim_dialog_yesnocancel(type, title, message, dflt)
    int type;
    char_u *title;
    char_u *message;
    int dflt;
{
    switch (do_dialog(type,
                title == ((void *)0) ? (char_u *)((char *)("Question")) : title,
                message,
                (char_u *)((char *)("&Yes\n&No\n&Cancel")), dflt, ((void *)0)))
    {
        case 1: return 2;
        case 2: return 3;
    }
    return 4;
}
    int vim_dialog_yesnoallcancel(type, title, message, dflt)
    int type;
    char_u *title;
    char_u *message;
    int dflt;
{
    switch (do_dialog(type,
                title == ((void *)0) ? (char_u *)"Question" : title,
                message,
                (char_u *)((char *)("&Yes\n&No\nSave &All\n&Discard All\n&Cancel")),
                                                                  dflt, ((void *)0)))
    {
        case 1: return 2;
        case 2: return 3;
        case 3: return 5;
        case 4: return 6;
    }
    return 4;
}
    char_u * do_browse(saving, title, dflt, ext, initdir, filter, buf)
    int saving;
    char_u *title;
    char_u *dflt;
    char_u *ext;
    char_u *initdir;
    char_u *filter;
    buf_T *buf;
{
    char_u *fname;
    static char_u *last_dir = ((void *)0);
    char_u *tofree = ((void *)0);
    cmdmod.browse = 0;
    if (title == ((void *)0))
    {
        if (saving)
            title = (char_u *)((char *)("Save File dialog"));
        else
            title = (char_u *)((char *)("Open File dialog"));
    }
    if ((initdir == ((void *)0) || *initdir == '\000') && dflt != ((void *)0) && *dflt != '\000')
    {
        if (mch_isdir(dflt))
        {
            initdir = dflt;
            dflt = ((void *)0);
        }
        else if (gettail(dflt) != dflt)
        {
            tofree = vim_strsave(dflt);
            if (tofree != ((void *)0))
            {
                initdir = tofree;
                *gettail(initdir) = '\000';
                dflt = gettail(dflt);
            }
        }
    }
    if (initdir == ((void *)0) || *initdir == '\000')
    {
        if (mch_isdir(p_bsdir))
            initdir = p_bsdir;
        else if ((saving || *p_bsdir == 'b')
                && buf != ((void *)0) && buf->b_ffname != ((void *)0))
        {
            if (dflt == ((void *)0) || *dflt == '\000')
                dflt = gettail(curbuf->b_ffname);
            tofree = vim_strsave(curbuf->b_ffname);
            if (tofree != ((void *)0))
            {
                initdir = tofree;
                *gettail(initdir) = '\000';
            }
        }
        else if (*p_bsdir == 'l')
            initdir = last_dir;
    }
    if (gui.in_use)
    {
        if (filter == ((void *)0)
                && (filter = get_var_value((char_u *)"b:browsefilter")) == ((void *)0)
                && (filter = get_var_value((char_u *)"g:browsefilter")) == ((void *)0)
        )
            filter = (char_u *)"All Files (*)\t*\nC source (*.c, *.h)\t*.c;*.h\nC++ source (*.cpp, *.hpp)\t*.cpp;*.hpp\nVim files (*.vim, _vimrc, _gvimrc)\t*.vim;_vimrc;_gvimrc\n";
        fname = gui_mch_browse(saving, title, dflt, ext, initdir, filter);
        need_check_timestamps = 1;
        did_check_timestamps = 0;
    }
    else
    {
        emsg((char_u *)(((char *)("E338: Sorry, no file browser in console mode"))));
        fname = ((void *)0);
    }
    if (fname != ((void *)0))
    {
        vim_free(last_dir);
        last_dir = vim_strsave(fname);
        if (last_dir != ((void *)0))
        {
            *gettail(last_dir) = '\000';
            if (*last_dir == '\000')
            {
                vim_free(last_dir);
                last_dir = alloc(1024);
                if (last_dir != ((void *)0))
                    mch_dirname(last_dir, 1024);
            }
        }
    }
    vim_free(tofree);
    return fname;
}
