enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
extern __const unsigned short int *__ctype_b;
typedef unsigned char char_u;
char_u *FullName_save (char_u *fname, int force);
char_u *alloc (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
extern long int atol (__const char *__nptr) __attribute__ ((__pure__));
int bt_dontwrite (buf_T *buf);
void changed (void);
void check_cursor_lnum (void);
int curbufIsChanged (void);
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
int diff_check_fill (win_T *wp, linenr_T lnum);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
void expand_env (char_u *src, char_u *dst, int dstlen);
long getdigits (char_u **pp);
void getout (int exitval);
char_u *gettail (char_u *fname);
void getvcol (win_T *wp, pos_T *pos, colnr_T *start, colnr_T *cursor, colnr_T *end);
void home_replace (buf_T *buf, char_u *src, char_u *dst, int dstlen, int one);
int mch_dirname (char_u *buf, int len);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
int ml_delete (linenr_T lnum, int message);
char_u *ml_get (linenr_T lnum);
char_u *ml_get_buf (buf_T *buf, linenr_T lnum, int will_change);
int msg (char_u *s);
void msg_putchar (int c);
void msg_puts (char_u *s);
void msg_puts_attr (char_u *s, int attr);
void msg_start (void);
void out_flush (void);
void save_file_ff (buf_T *buf);
void set_keep_msg (char_u *s);
char_u *skipdigits (char_u *p);
char_u *skipwhite (char_u *p);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
typedef __u_int __mode_t;
typedef long int __off_t;
typedef long int __time_t;
__extension__ typedef unsigned long long int __u_quad_t;
typedef __u_int __gid_t;
typedef __u_int __nlink_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __u_quad_t __dev_t;
struct stat
  {
    __dev_t st_dev;
    unsigned short int __pad1;
    __ino_t st_ino;
    __mode_t st_mode;
    __nlink_t st_nlink;
    __uid_t st_uid;
    __gid_t st_gid;
    __dev_t st_rdev;
    unsigned short int __pad2;
    __off_t st_size;
    __blksize_t st_blksize;
    __blkcnt_t st_blocks;
    __time_t st_atime;
    unsigned long int __unused1;
    __time_t st_mtime;
    unsigned long int __unused2;
    __time_t st_ctime;
    unsigned long int __unused3;
    unsigned long int __unused4;
    unsigned long int __unused5;
  };
extern int stat (__const char *__restrict __file,
                 struct stat *__restrict __buf) ;
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
extern char *strncpy (char *__restrict __dest,
                      __const char *__restrict __src, size_t __n) ;
void ui_breakcheck (void);
void ui_delay (long msec, int ignoreinput);
void vim_free (void *x);
int vim_ispathsep (int c);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
extern char_u *IObuff;
extern char_u *NameBuff;
extern long Rows
                            ;
extern int State ;
extern int cmdline_row;
extern buf_T *curbuf ;
extern win_T *curwin;
extern int emsg_silent ;
extern buf_T *firstbuf ;
extern win_T *firstwin;
extern int got_int ;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
extern int highlight_attr[HLF_COUNT];
extern int keep_msg_attr ;
extern int lcs_tab1 ;
extern int msg_row;
extern int msg_scroll ;
extern int need_maketitle ;
extern int need_wait_return ;
extern char_u *p_cpo;
extern long p_report;
extern int usingNetbeans ;
int ga_grow (garray_T *gap, int n);
void ga_init2 (garray_T *gap, int itemsize, int growsize);
int lbr_chartabsize (unsigned char *s, colnr_T col);
int lbr_chartabsize_adv (char_u **s, colnr_T col);
int virtual_active (void);
int win_col_off (win_T *wp);
int win_col_off2 (win_T *wp);
int win_lbr_chartabsize (win_T *wp, char_u *s, colnr_T col, int *headp);
int call_shell (char_u *cmd, int opt);
void changed_line_abv_curs_win (win_T *wp);
void changed_lines (linenr_T lnum, colnr_T col, linenr_T lnume, long xtra);
extern int chdir (__const char *__path) ;
void check_cursor (void);
__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _blksize;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
extern int fclose (FILE *__stream) ;
void foldUpdate (win_T *wp, linenr_T top, linenr_T bot);
extern FILE *fopen (__const char *__restrict __filename,
                    __const char *__restrict __modes) ;
void mark_adjust (linenr_T line1, linenr_T line2, long amount, long amount_after);
int ml_append (linenr_T lnum, char_u *line, colnr_T len, int newfile);
extern int unlink (__const char *__name) ;
char_u *vim_strnsave (char_u *string, int len);
char_u *vim_tempname (int extra_char);
extern char_u e_prev_dir[] ;
int safe_vgetc (void);
extern int no_mapping ;
extern int allow_keys ;
extern int msg_col;
extern int must_redraw ;
enum key_extra
{
    KE_NAME = 3
    , KE_S_UP
    , KE_S_DOWN
    , KE_S_F1
    , KE_S_F2
    , KE_S_F3
    , KE_S_F4
    , KE_S_F5
    , KE_S_F6
    , KE_S_F7
    , KE_S_F8
    , KE_S_F9
    , KE_S_F10
    , KE_S_F11
    , KE_S_F12
    , KE_S_F13
    , KE_S_F14
    , KE_S_F15
    , KE_S_F16
    , KE_S_F17
    , KE_S_F18
    , KE_S_F19
    , KE_S_F20
    , KE_S_F21
    , KE_S_F22
    , KE_S_F23
    , KE_S_F24
    , KE_S_F25
    , KE_S_F26
    , KE_S_F27
    , KE_S_F28
    , KE_S_F29
    , KE_S_F30
    , KE_S_F31
    , KE_S_F32
    , KE_S_F33
    , KE_S_F34
    , KE_S_F35
    , KE_S_F36
    , KE_S_F37
    , KE_MOUSE
    , KE_LEFTMOUSE
    , KE_LEFTDRAG
    , KE_LEFTRELEASE
    , KE_MIDDLEMOUSE
    , KE_MIDDLEDRAG
    , KE_MIDDLERELEASE
    , KE_RIGHTMOUSE
    , KE_RIGHTDRAG
    , KE_RIGHTRELEASE
    , KE_IGNORE
    , KE_TAB
    , KE_S_TAB_OLD
    , KE_SNIFF
    , KE_XF1
    , KE_XF2
    , KE_XF3
    , KE_XF4
    , KE_XEND
    , KE_XHOME
    , KE_LEFTMOUSE_NM
    , KE_LEFTRELEASE_NM
    , KE_S_XF1
    , KE_S_XF2
    , KE_S_XF3
    , KE_S_XF4
    , KE_MOUSEDOWN
    , KE_MOUSEUP
    , KE_KINS
    , KE_KDEL
    , KE_CSI
    , KE_SNR
    , KE_PLUG
    , KE_CMDWIN
    , KE_C_LEFT
    , KE_C_RIGHT
    , KE_C_HOME
    , KE_C_END
    , KE_X1MOUSE
    , KE_X1DRAG
    , KE_X1RELEASE
    , KE_X2MOUSE
    , KE_X2DRAG
    , KE_X2RELEASE
    , KE_DROP
};
void change_warning (int col);
void changed_bytes (linenr_T lnum, colnr_T col);
int chartabsize (char_u *p, colnr_T col);
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef void (*GtkItemFactoryCallback) ();
void replace_push (int c);
void fixthisline (int (*get_the_indent)(void));
void ins_bytes (char_u *p);
void ins_bytes_len (char_u *p, int len);
void do_c_expr_indent (void);
int cin_islabel (int ind_maxcomment);
int cin_iscase (char_u *s);
int cin_isscopedecl (char_u *s);
extern int end_comment_pending ;
extern int did_si ;
extern int can_si_back ;
extern pos_T Insstart;
extern int orig_line_count ;
extern int vr_lines_changed ;
int copy_option_part (char_u **option, char_u *buf, int maxlen, char *sep_chars);
typedef struct oparg
{
    int op_type;
    int regname;
    int motion_type;
    int motion_force;
    int use_reg_one;
    int inclusive;
    int end_adjusted;
    pos_T start;
    pos_T end;
    long line_count;
    int empty;
    int is_VIsual;
    int block_mode;
    colnr_T start_vcol;
    colnr_T end_vcol;
} oparg_T;
pos_T *findmatch (oparg_T *oap, int initc);
int get_indent (void);
int set_indent (int size, int flags);
int get_leader_len (char_u *line, char_u **flags, int backward);
int get_lisp_indent (void);
int getviscol (void);
int in_cinkeys (int keytyped, int when, int line_is_empty);
void ins_char (int c);
extern colnr_T ai_col ;
extern int can_si ;
int linewhite (linenr_T lnum);
char_u *ml_get_curline (void);
char_u *ml_get_cursor (void);
int ml_replace (linenr_T lnum, char_u *line, int copy);
void setmouse (void);
int showmode (void);
int stuff_empty (void);
void stuffcharReadbuff (int c);
int u_save_cursor (void);
void vim_beep (void);
int vim_isIDc (int c);
int vim_isdigit (int c);
int vim_isfilec (int c);
int vim_iswordc (int c);
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
extern int did_ai ;
extern int global_busy ;
extern int intr_char ;
extern int mod_mask ;
extern int p_im;
extern int p_paste;
extern int p_sm;
extern int redraw_cmdline ;
extern int sandbox ;
typedef struct expand
{
    int xp_context;
    char_u *xp_pattern;
    char_u *xp_arg;
    int xp_backslash;
} expand_T;
char_u *ExpandOne (expand_T *xp, char_u *str, char_u *orig, int options, int mode);
void add_pathsep (char_u *p);
int check_restricted (void);
int check_secure (void);
char_u *eval_to_string (char_u *arg, char_u **nextcmd);
char_u *expand_env_save (char_u *src);
void ga_clear (garray_T *gap);
int get_c_indent (void);
void vim_setenv (char_u *name, char_u *val);
char_u *get_cmd_output (char_u *cmd, int flags);
extern int didset_vim ;
extern int didset_vimruntime ;
int get_indent_lnum (linenr_T lnum);
extern char *getenv (__const char *__name) ;
long mch_getperm (char_u *name);
int mch_isdir (char_u *name);
void msg_clr_eos (void);
int msg_end (void);
extern char *strpbrk (__const char *__s, __const char *__accept)
             __attribute__ ((__pure__));
int u_savesub (linenr_T lnum);
char_u *vim_strsave_escaped (char_u *string, char_u *esc_chars);
extern int no_wait_return ;
extern int starting ;
char_u *alloc_check (unsigned size);
void cursor_on (void);
char_u *make_filter_cmd (char_u *cmd, char_u *itmp, char_u *otmp);
int smsg_attr (int, char_u *, ...);
void deleted_lines_mark (linenr_T lnum, long count);
char_u *vim_getenv (char_u *name, int *mustfree);
int u_savedel (linenr_T lnum, long nlines);
int gen_expand_wildcards (int num_pat, char_u **pat, int *num_file, char_u ***file, int flags);
int messaging (void);
void stoptermcap (void);
void u_clearline (void);void wait_return (int redraw);
void windgoto (int row, int col);
extern int autocmd_busy ;
extern char_u e_notmp[] ;
extern char_u e_notread[] ;
extern int exiting ;
extern int exmode_active ;
extern char_u *p_hf;
extern char_u msg_buf[80];
extern int msg_silent ;
extern int skip_redraw ;
extern size_t fread (void *__restrict __ptr, size_t __size,
                     size_t __n, FILE *__restrict __stream) ;
void settmode (int tmode);
extern char_u e_notopen[] ;
extern int no_check_timestamps ;
enum SpecialKey
{
    KS_NAME = 0,
    KS_CE,
    KS_AL,
    KS_CAL,
    KS_DL,
    KS_CDL,
    KS_CS,
    KS_CL,
    KS_CD,
    KS_UT,
    KS_DA,
    KS_DB,
    KS_VI,
    KS_VE,
    KS_VS,
    KS_ME,
    KS_MR,
    KS_MD,
    KS_SE,
    KS_SO,
    KS_CZH,
    KS_CZR,
    KS_UE,
    KS_US,
    KS_MS,
    KS_CM,
    KS_SR,
    KS_CRI,
    KS_VB,
    KS_KS,
    KS_KE,
    KS_TI,
    KS_TE,
    KS_BC,
    KS_CCS,
    KS_CCO,
    KS_CSF,
    KS_CSB,
    KS_XS,
    KS_MB,
    KS_CAF,
    KS_CAB,
    KS_LE,
    KS_ND,
    KS_CIS,
    KS_CIE,
    KS_TS,
    KS_FS,
    KS_CWP,
    KS_CWS,
    KS_CRV,
    KS_CSV,
    KS_OP
};
extern char_u *(term_strings[]);
void expand_env_esc (char_u *src, char_u *dst, int dstlen, int esc);
void out_char (unsigned c);
int typebuf_typed (void);
int vim_FullName (char_u *fname, char_u *buf, int len, int force);
int match_suffix (char_u *fname);
int match_file_list (char_u *list, char_u *sfname, char_u *ffname);
extern char_u *keep_msg ;
int find_wl_entry (win_T *win, linenr_T lnum);
typedef struct foldinfo
{
    int fi_level;
    int fi_lnum;
    int fi_low_level;
} foldinfo_T;
int hasFoldingWin (win_T *win, linenr_T lnum, linenr_T *firstp, linenr_T *lastp, int cache, foldinfo_T *infop);
long foldedCount (win_T *win, linenr_T lnum, foldinfo_T *infop);
int plines_win_nofold (win_T *wp, linenr_T lnum);
void set_vim_var_nr (int idx, long val);
int fix_input_buffer (char_u *buf, int len, int script);
int check_termcode (int max_offset, char_u *buf, int buflen);
void flush_buffers (int typeahead);
int get_keystroke (void);
void ml_sync_all (int check_file, int check_char);
int ui_inchar (char_u *buf, int maxlen, long wtime);
int del_bytes (long count, int fixpos);
void out_str (char_u *s);
char_u *concat_fnames (char_u *fname1, char_u *fname2, int sep);
void screen_start (void);
void ml_open_file (buf_T *buf);
void netbeans_removed (buf_T *bufp, linenr_T linenr, colnr_T col, long len);
extern int do_redraw ;
extern int lcs_eol ;
extern int fseek (FILE *__stream, long int __off, int __whence) ;
extern long int ftell (FILE *__stream) ;
extern int setenv (__const char *__name, __const char *__value, int __replace)
            ;
struct passwd
{
  char *pw_name;
  char *pw_passwd;
  __uid_t pw_uid;
  __gid_t pw_gid;
  char *pw_gecos;
  char *pw_dir;
  char *pw_shell;
};
int mch_has_exp_wildcard (char_u *p);
void ml_close_all (int del_file);
void addfile (garray_T *gap, char_u *f, int flags);
extern struct passwd *getpwnam (__const char *__name) ;
extern char_u *p_lispwords;
extern char_u *p_su;
extern int p_vb;
extern char_u *p_wig;
int mch_expandpath (garray_T *gap, char_u *path, int flags);
int mch_expand_wildcards (int num_pat, char_u **pat, int *num_file, char_u ***file, int flags);
char_u *backslash_halve_save (char_u *p);
void truncate_spaces (char_u *line);
int eval_to_number (char_u *expr);
int lineFolded (win_T *win, linenr_T lnum);
void ml_close_notmod (void);
int ml_line_alloced (void);
void ml_setdirty (buf_T *buf, int flag);
void prepare_to_exit (void);
void changed_cline_bef_curs_win (win_T *wp);
void approximate_botline_win (win_T *wp);
void out_trash (void);
void netbeans_unmodified (buf_T *bufp);
extern int global_changedtick ;
void check_status (buf_T *buf);
int coladvance_force (colnr_T wcol);
int file_ff_differs (buf_T *buf);
pos_T *find_start_comment (int ind_maxcomment);
pos_T *findmatchlimit (oparg_T *oap, int initc, int flags, int maxtravel);
int get_expr_indent (void);
void showmatch (void);
char_u *ml_get_pos (pos_T *pos);
int plines_win (win_T *wp, linenr_T lnum, int winheight);
int plines_win_nofill (win_T *wp, linenr_T lnum, int winheight);
int win_linetabsize (win_T *wp, char_u *p, colnr_T len);
extern int p_sr;
static char_u *vim_version_dir (char_u *vimdir);
static char_u *remove_tail (char_u *p, char_u *pend, char_u *name);
static int get_indent_str (char_u *ptr, int ts);
static int copy_indent (int size, char_u *src);
    int get_indent()
{
    return get_indent_str(ml_get_curline(), (int)curbuf->b_p_ts);
}
    int get_indent_lnum(lnum)
    linenr_T lnum;
{
    return get_indent_str(ml_get(lnum), (int)curbuf->b_p_ts);
}
    int get_indent_buf(buf, lnum)
    buf_T *buf;
    linenr_T lnum;
{
    return get_indent_str(ml_get_buf(buf, lnum, 0), (int)buf->b_p_ts);
}
    static int get_indent_str(ptr, ts)
    char_u *ptr;
    int ts;
{
    int count = 0;
    for ( ; *ptr; ++ptr)
    {
        if (*ptr == '\011')
            count += ts - (count % ts);
        else if (*ptr == ' ')
            ++count;
        else
            break;
    }
    return (count);
}
    int set_indent(size, flags)
    int size;
    int flags;
{
    char_u *p;
    char_u *line;
    char_u *s;
    int todo;
    int ind_len;
    int line_len;
    int doit = 0;
    int ind_done;
    int tab_pad;
    todo = size;
    ind_len = 0;
    p = ml_get_curline();
    if (!curbuf->b_p_et)
    {
        if (!(flags & 2) && curbuf->b_p_pi)
        {
            ind_done = 0;
            while (todo > 0 && ((*p) == ' ' || (*p) == '\t'))
            {
                if (*p == '\011')
                {
                    tab_pad = (int)curbuf->b_p_ts
                                           - (ind_done % (int)curbuf->b_p_ts);
                    if (todo < tab_pad)
                        break;
                    todo -= tab_pad;
                    ++ind_len;
                    ind_done += tab_pad;
                }
                else
                {
                    --todo;
                    ++ind_len;
                    ++ind_done;
                }
                ++p;
            }
            tab_pad = (int)curbuf->b_p_ts - (ind_done % (int)curbuf->b_p_ts);
            if (todo >= tab_pad)
            {
                doit = 1;
                todo -= tab_pad;
                ++ind_len;
            }
        }
        while (todo >= (int)curbuf->b_p_ts)
        {
            if (*p != '\011')
                doit = 1;
            else
                ++p;
            todo -= (int)curbuf->b_p_ts;
            ++ind_len;
        }
    }
    while (todo > 0)
    {
        if (*p != ' ')
            doit = 1;
        else
            ++p;
        --todo;
        ++ind_len;
    }
    if (!doit && !((*p) == ' ' || (*p) == '\t') && !(flags & 2))
        return 0;
    if (flags & 2)
        p = ml_get_curline();
    else
        p = skipwhite(p);
    line_len = (int)strlen((char *)(p)) + 1;
    line = alloc(ind_len + line_len);
    if (line == ((void *)0))
        return 0;
    s = line;
    todo = size;
    if (!curbuf->b_p_et)
    {
        if (!(flags & 2) && curbuf->b_p_pi)
        {
            p = ml_get_curline();
            ind_done = 0;
            while (todo > 0 && ((*p) == ' ' || (*p) == '\t'))
            {
                if (*p == '\011')
                {
                    tab_pad = (int)curbuf->b_p_ts
                                           - (ind_done % (int)curbuf->b_p_ts);
                    if (todo < tab_pad)
                        break;
                    todo -= tab_pad;
                    ind_done += tab_pad;
                }
                else
                {
                    --todo;
                    ++ind_done;
                }
                *s++ = *p++;
            }
            tab_pad = (int)curbuf->b_p_ts - (ind_done % (int)curbuf->b_p_ts);
            if (todo >= tab_pad)
            {
                *s++ = '\011';
                todo -= tab_pad;
            }
            p = skipwhite(p);
        }
        while (todo >= (int)curbuf->b_p_ts)
        {
            *s++ = '\011';
            todo -= (int)curbuf->b_p_ts;
        }
    }
    while (todo > 0)
    {
        *s++ = ' ';
        --todo;
    }
    memmove((char *)(s), (char *)(p), (size_t)line_len);
    if (!(flags & 4) || u_savesub(curwin->w_cursor.lnum) == 1)
    {
        ml_replace(curwin->w_cursor.lnum, line, 0);
        if (flags & 1)
            changed_bytes(curwin->w_cursor.lnum, 0);
    }
    else
        vim_free(line);
    curwin->w_cursor.col = ind_len;
    return 1;
}
    static int copy_indent(size, src)
    int size;
    char_u *src;
{
    char_u *p = ((void *)0);
    char_u *line = ((void *)0);
    char_u *s;
    int todo;
    int ind_len;
    int line_len = 0;
    int tab_pad;
    int ind_done;
    int round;
    for (round = 1; round <= 2; ++round)
    {
        todo = size;
        ind_len = 0;
        ind_done = 0;
        s = src;
        while (todo > 0 && ((*s) == ' ' || (*s) == '\t'))
        {
            if (*s == '\011')
            {
                tab_pad = (int)curbuf->b_p_ts
                                           - (ind_done % (int)curbuf->b_p_ts);
                if (todo < tab_pad)
                    break;
                todo -= tab_pad;
                ind_done += tab_pad;
            }
            else
            {
                --todo;
                ++ind_done;
            }
            ++ind_len;
            if (round == 2)
                *p++ = *s;
            ++s;
        }
        tab_pad = (int)curbuf->b_p_ts - (ind_done % (int)curbuf->b_p_ts);
        if (todo >= tab_pad)
        {
            todo -= tab_pad;
            ++ind_len;
            if (round == 2)
                *p++ = '\011';
        }
        while (todo >= (int)curbuf->b_p_ts)
        {
            todo -= (int)curbuf->b_p_ts;
            ++ind_len;
            if (round == 2)
                *p++ = '\011';
        }
        while (todo > 0)
        {
            --todo;
            ++ind_len;
            if (round == 2)
                *p++ = ' ';
        }
        if (round == 1)
        {
            line_len = (int)strlen((char *)(ml_get_curline())) + 1;
            line = alloc(ind_len + line_len);
            if (line == ((void *)0))
                return 0;
            p = line;
        }
    }
    memmove((char *)(p), (char *)(ml_get_curline()), (size_t)line_len);
    ml_replace(curwin->w_cursor.lnum, line, 0);
    curwin->w_cursor.col = ind_len;
    return 1;
}
    int get_number_indent(lnum)
    linenr_T lnum;
{
    char_u *line;
    char_u *p;
    colnr_T col;
    pos_T pos;
    if (lnum > curbuf->b_ml.ml_line_count)
        return -1;
    line = ml_get(lnum);
    p = skipwhite(line);
    if (!(__ctype_b[(int) ((*p))] & (unsigned short int) _ISdigit))
        return -1;
    p = skipdigits(p);
    if (vim_strchr((char_u *)":.)]}\t ", *p) == ((void *)0))
        return -1;
    p = skipwhite(p + 1);
    if (*p == '\000')
        return -1;
    pos.lnum = lnum;
    pos.col = (colnr_T)(p - line);
    getvcol(curwin, &pos, &col, ((void *)0), ((void *)0));
    return (int)col;
}
static int cin_is_cinword (char_u *line);
    static int cin_is_cinword(line)
    char_u *line;
{
    char_u *cinw;
    char_u *cinw_buf;
    int cinw_len;
    int retval = 0;
    int len;
    cinw_len = (int)strlen((char *)(curbuf->b_p_cinw)) + 1;
    cinw_buf = alloc((unsigned)cinw_len);
    if (cinw_buf != ((void *)0))
    {
        line = skipwhite(line);
        for (cinw = curbuf->b_p_cinw; *cinw; )
        {
            len = copy_option_part(&cinw, cinw_buf, cinw_len, ",");
            if (strncmp((char *)(line), (char *)(cinw_buf), (size_t)(len)) == 0
                    && (!vim_iswordc(line[len]) || !vim_iswordc(line[len - 1])))
            {
                retval = 1;
                break;
            }
        }
        vim_free(cinw_buf);
    }
    return retval;
}
    int open_line(dir, flags, old_indent)
    int dir;
    int flags;
    int old_indent;
{
    char_u *saved_line;
    char_u *next_line = ((void *)0);
    char_u *p_extra = ((void *)0);
    pos_T old_cursor;
    int newcol = 0;
    int newindent = 0;
    int n;
    int trunc_line = 0;
    int retval = 0;
    int extra_len = 0;
    int lead_len;
    char_u *lead_flags;
    char_u *leader = ((void *)0);
    char_u *allocated = ((void *)0);
    char_u *p;
    int saved_char = '\000';
    pos_T *pos;
    int do_si = (!p_paste && curbuf->b_p_si
                                        && !curbuf->b_p_cin
                        );
    int no_si = 0;
    int first_char = '\000';
    int vreplace_mode;
    int did_append;
    int saved_pi = curbuf->b_p_pi;
    saved_line = vim_strsave(ml_get_curline());
    if (saved_line == ((void *)0))
        return 0;
    if (State & 0x80)
    {
        if (curwin->w_cursor.lnum < orig_line_count)
            next_line = vim_strsave(ml_get(curwin->w_cursor.lnum + 1));
        else
            next_line = vim_strsave((char_u *)"");
        if (next_line == ((void *)0))
            goto theend;
        replace_push('\000');
        replace_push('\000');
        p = saved_line + curwin->w_cursor.col;
        while (*p != '\000')
            replace_push(*p++);
        saved_line[curwin->w_cursor.col] = '\000';
    }
    if ((State & 0x10)
            && !(State & 0x80)
            )
    {
        p_extra = saved_line + curwin->w_cursor.col;
        if (do_si)
        {
            p = skipwhite(p_extra);
            first_char = *p;
        }
        extra_len = (int)strlen((char *)(p_extra));
        saved_char = *p_extra;
        *p_extra = '\000';
    }
    u_clearline();
    did_si = 0;
    ai_col = 0;
    if (dir == 1 && did_ai)
        trunc_line = 1;
    if (curbuf->b_p_ai
                        || do_si
                                            )
    {
        newindent = get_indent_str(saved_line, (int)curbuf->b_p_ts);
        if (newindent == 0)
            newindent = old_indent;
        if (!trunc_line && do_si && *saved_line != '\000'
                                    && (p_extra == ((void *)0) || first_char != '{'))
        {
            char_u *ptr;
            char_u last_char;
            old_cursor = curwin->w_cursor;
            ptr = saved_line;
            if (flags & 2)
                lead_len = get_leader_len(ptr, ((void *)0), 0);
            else
                lead_len = 0;
            if (dir == 1)
            {
                if (
                        lead_len == 0 &&
                        ptr[0] == '#')
                {
                    while (ptr[0] == '#' && curwin->w_cursor.lnum > 1)
                        ptr = ml_get(--curwin->w_cursor.lnum);
                    newindent = get_indent();
                }
                if (flags & 2)
                    lead_len = get_leader_len(ptr, ((void *)0), 0);
                else
                    lead_len = 0;
                if (lead_len > 0)
                {
                    p = skipwhite(ptr);
                    if (p[0] == '/' && p[1] == '*')
                        p++;
                    if (p[0] == '*')
                    {
                        for (p++; *p; p++)
                        {
                            if (p[0] == '/' && p[-1] == '*')
                            {
                                curwin->w_cursor.col = (colnr_T)(p - ptr);
                                if ((pos = findmatch(((void *)0), '\000')) != ((void *)0))
                                {
                                    curwin->w_cursor.lnum = pos->lnum;
                                    newindent = get_indent();
                                }
                            }
                        }
                    }
                }
                else
                {
                    p = ptr + strlen((char *)(ptr)) - 1;
                    while (p > ptr && ((*p) == ' ' || (*p) == '\t'))
                        --p;
                    last_char = *p;
                    if (last_char == '{' || last_char == ';')
                    {
                        if (p > ptr)
                            --p;
                        while (p > ptr && ((*p) == ' ' || (*p) == '\t'))
                            --p;
                    }
                    if (*p == ')')
                    {
                        curwin->w_cursor.col = (colnr_T)(p - ptr);
                        if ((pos = findmatch(((void *)0), '(')) != ((void *)0))
                        {
                            curwin->w_cursor.lnum = pos->lnum;
                            newindent = get_indent();
                            ptr = ml_get_curline();
                        }
                    }
                    if (last_char == '{')
                    {
                        did_si = 1;
                        no_si = 1;
                    }
                    else if (last_char != ';' && last_char != '}'
                                                       && cin_is_cinword(ptr))
                        did_si = 1;
                }
            }
            else
            {
                if (
                        lead_len == 0 &&
                        ptr[0] == '#')
                {
                    int was_backslashed = 0;
                    while ((ptr[0] == '#' || was_backslashed) &&
                         curwin->w_cursor.lnum < curbuf->b_ml.ml_line_count)
                    {
                        if (*ptr && ptr[strlen((char *)(ptr)) - 1] == '\\')
                            was_backslashed = 1;
                        else
                            was_backslashed = 0;
                        ptr = ml_get(++curwin->w_cursor.lnum);
                    }
                    if (was_backslashed)
                        newindent = 0;
                    else
                        newindent = get_indent();
                }
                p = skipwhite(ptr);
                if (*p == '}')
                    did_si = 1;
                else
                    can_si_back = 1;
            }
            curwin->w_cursor = old_cursor;
        }
        if (do_si)
            can_si = 1;
        did_ai = 1;
    }
    end_comment_pending = '\000';
    if (flags & 2)
        lead_len = get_leader_len(saved_line, &lead_flags, dir == (-1));
    else
        lead_len = 0;
    if (lead_len > 0)
    {
        char_u *lead_repl = ((void *)0);
        int lead_repl_len = 0;
        char_u lead_middle[50];
        char_u lead_end[50];
        char_u *comment_end = ((void *)0);
        int extra_space = 0;
        int current_flag;
        int require_blank = 0;
        char_u *p2;
        for (p = lead_flags; *p && *p != ':'; ++p)
        {
            if (*p == 'b')
            {
                require_blank = 1;
                continue;
            }
            if (*p == 's' || *p == 'm')
            {
                current_flag = *p;
                if (*p == 's')
                {
                    if (dir == (-1))
                    {
                        lead_len = 0;
                        break;
                    }
                    (void)copy_option_part(&p, lead_middle, 50, ",");
                    require_blank = 0;
                }
                while (*p && p[-1] != ':')
                {
                    if (*p == 'b')
                        require_blank = 1;
                    ++p;
                }
                (void)copy_option_part(&p, lead_middle, 50, ",");
                while (*p && p[-1] != ':')
                {
                    if (*p == 'x')
                        end_comment_pending = -1;
                    ++p;
                }
                n = copy_option_part(&p, lead_end, 50, ",");
                if (end_comment_pending == -1)
                    end_comment_pending = lead_end[n - 1];
                if (dir == 1)
                {
                    for (p = saved_line + lead_len; *p; ++p)
                        if (strncmp((char *)(p), (char *)(lead_end), (size_t)(n)) == 0)
                        {
                            comment_end = p;
                            lead_len = 0;
                            break;
                        }
                }
                if (lead_len > 0)
                {
                    if (current_flag == 's')
                    {
                        lead_repl = lead_middle;
                        lead_repl_len = (int)strlen((char *)(lead_middle));
                    }
                    if (!((saved_line[lead_len - 1]) == ' ' || (saved_line[lead_len - 1]) == '\t')
                            && ((p_extra != ((void *)0)
                                    && (int)curwin->w_cursor.col == lead_len)
                                || (p_extra == ((void *)0)
                                    && saved_line[lead_len] == '\000')
                                || require_blank))
                        extra_space = 1;
                }
                break;
            }
            if (*p == 'e')
            {
                if (dir == 1)
                {
                    comment_end = skipwhite(saved_line);
                    lead_len = 0;
                    break;
                }
                while (p > curbuf->b_p_com && *p != ',')
                    --p;
                for (lead_repl = p; lead_repl > curbuf->b_p_com
                                         && lead_repl[-1] != ':'; --lead_repl)
                    ;
                lead_repl_len = (int)(p - lead_repl);
                extra_space = 1;
                for (p2 = p; *p2 && *p2 != ':'; p2++)
                {
                    if (*p2 == 'x')
                        end_comment_pending = -1;
                }
                if (end_comment_pending == -1)
                {
                    while (*p2 && *p2 != ',')
                        p2++;
                    end_comment_pending = p2[-1];
                }
                break;
            }
            if (*p == 'f')
            {
                if (dir == (-1))
                    lead_len = 0;
                else
                {
                    lead_repl = (char_u *)"";
                    lead_repl_len = 0;
                }
                break;
            }
        }
        if (lead_len)
        {
            leader = alloc(lead_len + lead_repl_len + extra_space +
                                                              extra_len + 1);
            allocated = leader;
            if (leader == ((void *)0))
                lead_len = 0;
            else
            {
                strncpy((char *)(leader), (char *)(saved_line), (size_t)(lead_len));
                leader[lead_len] = '\000';
                if (lead_repl != ((void *)0))
                {
                    int c = 0;
                    int off = 0;
                    for (p = lead_flags; *p && *p != ':'; ++p)
                    {
                        if (*p == 'r' || *p == 'l')
                            c = *p;
                        else if ((__ctype_b[(int) ((*p))] & (unsigned short int) _ISdigit) || *p == '-')
                            off = getdigits(&p);
                    }
                    if (c == 'r')
                    {
                        for (p = leader + lead_len - 1; p > leader
                                                      && ((*p) == ' ' || (*p) == '\t'); --p)
                            ;
                        ++p;
                        if (p < leader + lead_repl_len)
                            p = leader;
                        else
                            p -= lead_repl_len;
                        memmove((char *)(p), (char *)(lead_repl), (size_t)lead_repl_len);
                        if (p + lead_repl_len > leader + lead_len)
                            p[lead_repl_len] = '\000';
                        while (--p >= leader)
                            if (!((*p) == ' ' || (*p) == '\t'))
                                *p = ' ';
                    }
                    else
                    {
                        p = skipwhite(leader);
                        memmove((char *)(p), (char *)(lead_repl), (size_t)lead_repl_len);
                        for (p += lead_repl_len; p < leader + lead_len; ++p)
                            if (!((*p) == ' ' || (*p) == '\t'))
                            {
                                if (p + 1 < leader + lead_len && p[1] == '\011')
                                {
                                    --lead_len;
                                    memmove((char *)(p), (char *)(p + 1), (leader + lead_len) - p);
                                }
                                else
                                    *p = ' ';
                            }
                        *p = '\000';
                    }
                    if (curbuf->b_p_ai
                                        || do_si
                                                           )
                        newindent = get_indent_str(leader, (int)curbuf->b_p_ts);
                    if (newindent + off < 0)
                    {
                        off = -newindent;
                        newindent = 0;
                    }
                    else
                        newindent += off;
                    while (off > 0 && lead_len > 0
                                               && leader[lead_len - 1] == ' ')
                    {
                        if (vim_strchr(skipwhite(leader), '\t') != ((void *)0))
                            break;
                        --lead_len;
                        --off;
                    }
                    if (lead_len > 0 && ((leader[lead_len - 1]) == ' ' || (leader[lead_len - 1]) == '\t'))
                        extra_space = 0;
                    leader[lead_len] = '\000';
                }
                if (extra_space)
                {
                    leader[lead_len++] = ' ';
                    leader[lead_len] = '\000';
                }
                newcol = lead_len;
                if (newindent
                                || did_si
                                           )
                {
                    while (lead_len && ((*leader) == ' ' || (*leader) == '\t'))
                    {
                        --lead_len;
                        --newcol;
                        ++leader;
                    }
                }
            }
            did_si = can_si = 0;
        }
        else if (comment_end != ((void *)0))
        {
            if (comment_end[0] == '*' && comment_end[1] == '/' &&
                        (curbuf->b_p_ai
                                        || do_si
                                                           ))
            {
                old_cursor = curwin->w_cursor;
                curwin->w_cursor.col = (colnr_T)(comment_end - saved_line);
                if ((pos = findmatch(((void *)0), '\000')) != ((void *)0))
                {
                    curwin->w_cursor.lnum = pos->lnum;
                    newindent = get_indent();
                }
                curwin->w_cursor = old_cursor;
            }
        }
    }
    if (p_extra != ((void *)0))
    {
        *p_extra = saved_char;
        if ((((State) & 0x40) && !((State) & 0x80)))
            replace_push('\000');
        if (curbuf->b_p_ai || (flags & 1))
        {
            while ((*p_extra == ' ' || *p_extra == '\t')
                    )
            {
                if ((((State) & 0x40) && !((State) & 0x80)))
                    replace_push(*p_extra);
                ++p_extra;
            }
        }
        if (*p_extra != '\000')
            did_ai = 0;
    }
    if (p_extra == ((void *)0))
        p_extra = (char_u *)"";
    if (lead_len)
    {
        strcat((char *)(leader), (char *)(p_extra));
        p_extra = leader;
        did_ai = 1;
    }
    else
        end_comment_pending = '\000';
    old_cursor = curwin->w_cursor;
    if (dir == (-1))
        --curwin->w_cursor.lnum;
    if (!(State & 0x80) || old_cursor.lnum >= orig_line_count)
    {
        if (ml_append(curwin->w_cursor.lnum, p_extra, (colnr_T)0, 0)
                                                                      == 0)
            goto theend;
        mark_adjust(curwin->w_cursor.lnum + 1, (linenr_T)(0x7fffffffL), 1L, 0L);
        did_append = 1;
    }
    else
    {
        curwin->w_cursor.lnum++;
        if (curwin->w_cursor.lnum >= Insstart.lnum + vr_lines_changed)
        {
            (void)u_save_cursor();
            vr_lines_changed++;
        }
        ml_replace(curwin->w_cursor.lnum, p_extra, 1);
        changed_bytes(curwin->w_cursor.lnum, 0);
        curwin->w_cursor.lnum--;
        did_append = 0;
    }
    if (newindent
                    || did_si
                                )
    {
        ++curwin->w_cursor.lnum;
        if (did_si)
        {
            if (p_sr)
                newindent -= newindent % (int)curbuf->b_p_sw;
            newindent += (int)curbuf->b_p_sw;
        }
        if (curbuf->b_p_ci && !curbuf->b_p_et)
        {
            (void)copy_indent(newindent, saved_line);
            curbuf->b_p_pi = 1;
        }
        else
            (void)set_indent(newindent, 2);
        ai_col = curwin->w_cursor.col;
        if ((((State) & 0x40) && !((State) & 0x80)))
            for (n = 0; n < (int)curwin->w_cursor.col; ++n)
                replace_push('\000');
        newcol += curwin->w_cursor.col;
        if (no_si)
            did_si = 0;
    }
    if ((((State) & 0x40) && !((State) & 0x80)))
        while (lead_len-- > 0)
            replace_push('\000');
    curwin->w_cursor = old_cursor;
    if (dir == 1)
    {
        if (trunc_line || (State & 0x10))
        {
            saved_line[curwin->w_cursor.col] = '\000';
            if (trunc_line && !(flags & 4))
                truncate_spaces(saved_line);
            ml_replace(curwin->w_cursor.lnum, saved_line, 0);
            saved_line = ((void *)0);
            if (did_append)
            {
                changed_lines(curwin->w_cursor.lnum, curwin->w_cursor.col,
                                               curwin->w_cursor.lnum + 1, 1L);
                did_append = 0;
            }
            else
                changed_bytes(curwin->w_cursor.lnum, curwin->w_cursor.col);
        }
        curwin->w_cursor.lnum = old_cursor.lnum + 1;
    }
    if (did_append)
        changed_lines(curwin->w_cursor.lnum, 0, curwin->w_cursor.lnum, 1L);
    curwin->w_cursor.col = newcol;
    curwin->w_cursor.coladd = 0;
    if (State & 0x80)
    {
        vreplace_mode = State;
        State = 0x10;
    }
    else
        vreplace_mode = 0;
    if (!p_paste
            && leader == ((void *)0)
            && curbuf->b_p_lisp
            && curbuf->b_p_ai)
    {
        fixthisline(get_lisp_indent);
        p = ml_get_curline();
        ai_col = (colnr_T)(skipwhite(p) - p);
    }
    if (!p_paste
            && (leader == ((void *)0) || !curbuf->b_p_ai)
            && (curbuf->b_p_cin
                    || *curbuf->b_p_inde != '\000'
                )
            && in_cinkeys(dir == 1
                ? 0x101
                : 0x102, ' ', linewhite(curwin->w_cursor.lnum)))
    {
        do_c_expr_indent();
        p = ml_get_curline();
        ai_col = (colnr_T)(skipwhite(p) - p);
    }
    if (vreplace_mode != 0)
        State = vreplace_mode;
    if (State & 0x80)
    {
        p_extra = vim_strsave(ml_get_curline());
        if (p_extra == ((void *)0))
            goto theend;
        ml_replace(curwin->w_cursor.lnum, next_line, 0);
        curwin->w_cursor.col = 0;
        curwin->w_cursor.coladd = 0;
        ins_bytes(p_extra);
        next_line = ((void *)0);
    }
    retval = 1;
theend:
    curbuf->b_p_pi = saved_pi;
    vim_free(saved_line);
    vim_free(next_line);
    vim_free(allocated);
    return retval;
}
    int get_leader_len(line, flags, backward)
    char_u *line;
    char_u **flags;
    int backward;
{
    int i, j;
    int got_com = 0;
    int found_one;
    char_u part_buf[50];
    char_u *string;
    char_u *list;
    i = 0;
    while (((line[i]) == ' ' || (line[i]) == '\t'))
        ++i;
    while (line[i])
    {
        found_one = 0;
        for (list = curbuf->b_p_com; *list; )
        {
            if (!got_com && flags != ((void *)0))
                *flags = list;
            (void)copy_option_part(&list, part_buf, 50, ",");
            string = vim_strchr(part_buf, ':');
            if (string == ((void *)0))
                continue;
            *string++ = '\000';
            if (got_com && vim_strchr(part_buf, 'n') == ((void *)0))
                continue;
            if (backward && vim_strchr(part_buf, 'O') != ((void *)0))
                continue;
            if (((string[0]) == ' ' || (string[0]) == '\t'))
            {
                if (i == 0 || !((line[i - 1]) == ' ' || (line[i - 1]) == '\t'))
                    continue;
                while (((string[0]) == ' ' || (string[0]) == '\t'))
                    ++string;
            }
            for (j = 0; string[j] != '\000' && string[j] == line[i + j]; ++j)
                ;
            if (string[j] != '\000')
                continue;
            if (vim_strchr(part_buf, 'b') != ((void *)0)
                           && !((line[i + j]) == ' ' || (line[i + j]) == '\t') && line[i + j] != '\000')
                continue;
            i += j;
            got_com = 1;
            found_one = 1;
            break;
        }
        if (!found_one)
            break;
        while (((line[i]) == ' ' || (line[i]) == '\t'))
            ++i;
        if (vim_strchr(part_buf, 'n') == ((void *)0))
            break;
    }
    return (got_com ? i : 0);
}
    int plines(lnum)
    linenr_T lnum;
{
    return plines_win(curwin, lnum, 1);
}
    int plines_win(wp, lnum, winheight)
    win_T *wp;
    linenr_T lnum;
    int winheight;
{
    return plines_win_nofill(wp, lnum, winheight) + diff_check_fill(wp, lnum);
}
    int plines_nofill(lnum)
    linenr_T lnum;
{
    return plines_win_nofill(curwin, lnum, 1);
}
    int plines_win_nofill(wp, lnum, winheight)
    win_T *wp;
    linenr_T lnum;
    int winheight;
{
    int lines;
    if (!wp->w_onebuf_opt.wo_wrap)
        return 1;
    if (wp->w_width == 0)
        return 1;
    if (lineFolded(wp, lnum) == 1)
        return 1;
    lines = plines_win_nofold(wp, lnum);
    if (winheight > 0 && lines > wp->w_height)
        return (int)wp->w_height;
    return lines;
}
    int plines_win_nofold(wp, lnum)
    win_T *wp;
    linenr_T lnum;
{
    char_u *s;
    long col;
    int width;
    s = ml_get_buf(wp->w_buffer, lnum, 0);
    if (*s == '\000')
        return 1;
    col = win_linetabsize(wp, s, (colnr_T)(0x7fffffffL));
    if (wp->w_onebuf_opt.wo_list && lcs_eol != '\000')
        col += 1;
    width = (wp->w_width) - win_col_off(wp);
    if (width <= 0)
        return 32000;
    if (col <= width)
        return 1;
    col -= width;
    width += win_col_off2(wp);
    return (col + (width - 1)) / width + 1;
}
    int plines_win_col(wp, lnum, column)
    win_T *wp;
    linenr_T lnum;
    long column;
{
    long col;
    char_u *s;
    int lines = 0;
    int width;
    lines = diff_check_fill(wp, lnum);
    if (!wp->w_onebuf_opt.wo_wrap)
        return lines + 1;
    if (wp->w_width == 0)
        return lines + 1;
    s = ml_get_buf(wp->w_buffer, lnum, 0);
    col = 0;
    while (*s != '\000' && --column >= 0)
    {
        col += win_lbr_chartabsize(wp, s, (colnr_T)col, ((void *)0));
            ++s;
    }
    if (*s == '\011' && (State & 0x01) && (!wp->w_onebuf_opt.wo_list || lcs_tab1))
        col += win_lbr_chartabsize(wp, s, (colnr_T)col, ((void *)0)) - 1;
    width = (wp->w_width) - win_col_off(wp);
    if (width > 0)
    {
        lines += 1;
        if (col >= width)
            lines += (col - width) / (width + win_col_off2(wp));
        if (lines <= wp->w_height)
            return lines;
    }
    return (int)(wp->w_height);
}
    int plines_m_win(wp, first, last)
    win_T *wp;
    linenr_T first, last;
{
    int count = 0;
    while (first <= last)
    {
        int x;
        x = foldedCount(wp, first, ((void *)0));
        if (x > 0)
        {
            ++count;
            first += x;
        }
        else
        {
            if (first == wp->w_topline)
                count += plines_win_nofill(wp, first, 1) + wp->w_topfill;
            else
                count += plines_win(wp, first, 1);
            ++first;
        }
    }
    return (count);
}
    void ins_bytes(p)
    char_u *p;
{
    ins_bytes_len(p, (int)strlen((char *)(p)));
}
    void ins_bytes_len(p, len)
    char_u *p;
    int len;
{
    int i;
    for (i = 0; i < len; ++i)
        ins_char(p[i]);
}
    void ins_char(c)
    int c;
{
    int newlen;
    int oldlen;
    char_u *p;
    char_u *newp;
    char_u *oldp;
    int linelen;
    colnr_T col;
    linenr_T lnum = curwin->w_cursor.lnum;
    int i;
    if (virtual_active() && curwin->w_cursor.coladd > 0)
        coladvance_force(getviscol());
    col = curwin->w_cursor.col;
    oldp = ml_get(lnum);
    linelen = (int)strlen((char *)(oldp)) + 1;
    oldlen = 0;
    newlen = 1;
    if (State & 0x40)
    {
        if (State & 0x80)
        {
            colnr_T new_vcol = 0;
            colnr_T vcol;
            int old_list;
            char_u buf[2];
            old_list = curwin->w_onebuf_opt.wo_list;
            if (old_list && vim_strchr(p_cpo, 'L') == ((void *)0))
                curwin->w_onebuf_opt.wo_list = 0;
            getvcol(curwin, &curwin->w_cursor, ((void *)0), &vcol, ((void *)0));
            buf[0] = c;
            buf[1] = '\000';
            new_vcol = vcol + chartabsize(buf, vcol);
            while (oldp[col + oldlen] != '\000' && vcol < new_vcol)
            {
                vcol += chartabsize(oldp + col + oldlen, vcol);
                if (vcol > new_vcol && oldp[col + oldlen] == '\011')
                    break;
                ++oldlen;
                if (vcol > new_vcol)
                    newlen += vcol - new_vcol;
            }
            curwin->w_onebuf_opt.wo_list = old_list;
        }
        else
            if (oldp[col] != '\000')
        {
            oldlen = 1;
        }
        replace_push('\000');
        for (i = 0; i < oldlen; ++i)
        {
            replace_push(oldp[col + i]);
        }
    }
    newp = alloc_check((unsigned)(linelen + newlen - oldlen));
    if (newp == ((void *)0))
        return;
    if (col > 0)
        memmove((char *)(newp), (char *)(oldp), (size_t)col);
    p = newp + col;
    memmove((char *)(p + newlen), (char *)(oldp + col + oldlen), (size_t)(linelen - col - oldlen));
    *p = c;
    i = 1;
    while (i < newlen)
        p[i++] = ' ';
    ml_replace(lnum, newp, 0);
    changed_bytes(lnum, col);
    if (p_sm && (State & 0x10)
            && msg_silent == 0
            && (c == ')' || c == '}' || c == ']')
            )
        showmatch();
    {
        ++curwin->w_cursor.col;
    }
}
    void ins_str(s)
    char_u *s;
{
    char_u *oldp, *newp;
    int newlen = (int)strlen((char *)(s));
    int oldlen;
    colnr_T col;
    linenr_T lnum = curwin->w_cursor.lnum;
    if (virtual_active() && curwin->w_cursor.coladd > 0)
        coladvance_force(getviscol());
    col = curwin->w_cursor.col;
    oldp = ml_get(lnum);
    oldlen = (int)strlen((char *)(oldp));
    newp = alloc_check((unsigned)(oldlen + newlen + 1));
    if (newp == ((void *)0))
        return;
    if (col > 0)
        memmove((char *)(newp), (char *)(oldp), (size_t)col);
    memmove((char *)(newp + col), (char *)(s), (size_t)newlen);
    memmove((char *)(newp + col + newlen), (char *)(oldp + col), (size_t)(oldlen - col + 1));
    ml_replace(lnum, newp, 0);
    changed_bytes(lnum, col);
    curwin->w_cursor.col += newlen;
}
    int del_char(fixpos)
    int fixpos;
{
    return del_bytes(1L, fixpos);
}
    int del_bytes(count, fixpos)
    long count;
    int fixpos;
{
    char_u *oldp, *newp;
    colnr_T oldlen;
    linenr_T lnum = curwin->w_cursor.lnum;
    colnr_T col = curwin->w_cursor.col;
    int was_alloced;
    long movelen;
    oldp = ml_get(lnum);
    oldlen = (int)strlen((char *)(oldp));
    if (col >= oldlen)
        return 0;
    movelen = (long)oldlen - (long)col - count + 1;
    if (movelen <= 1)
    {
        if (col > 0 && fixpos)
        {
            --curwin->w_cursor.col;
            curwin->w_cursor.coladd = 0;
        }
        count = oldlen - col;
        movelen = 1;
    }
    was_alloced = ml_line_alloced();
    if (was_alloced && usingNetbeans)
        netbeans_removed(curbuf, lnum, col, count);
    if (was_alloced)
        newp = oldp;
    else
    {
        newp = alloc((unsigned)(oldlen + 1 - count));
        if (newp == ((void *)0))
            return 0;
        memmove((char *)(newp), (char *)(oldp), (size_t)col);
    }
    memmove((char *)(newp + col), (char *)(oldp + col + count), (size_t)movelen);
    if (!was_alloced)
        ml_replace(lnum, newp, 0);
    changed_bytes(lnum, curwin->w_cursor.col);
    return 1;
}
    int truncate_line(fixpos)
    int fixpos;
{
    char_u *newp;
    linenr_T lnum = curwin->w_cursor.lnum;
    colnr_T col = curwin->w_cursor.col;
    if (col == 0)
        newp = vim_strsave((char_u *)"");
    else
        newp = vim_strnsave(ml_get(lnum), col);
    if (newp == ((void *)0))
        return 0;
    ml_replace(lnum, newp, 0);
    changed_bytes(lnum, curwin->w_cursor.col);
    if (fixpos && curwin->w_cursor.col > 0)
        --curwin->w_cursor.col;
    return 1;
}
    void del_lines(nlines, undo)
    long nlines;
    int undo;
{
    long n;
    if (nlines <= 0)
        return;
    if (undo && u_savedel(curwin->w_cursor.lnum, nlines) == 0)
        return;
    for (n = 0; n < nlines; )
    {
        if (curbuf->b_ml.ml_flags & 1)
            break;
        ml_delete(curwin->w_cursor.lnum, 1);
        ++n;
        if (curwin->w_cursor.lnum > curbuf->b_ml.ml_line_count)
            break;
    }
    deleted_lines_mark(curwin->w_cursor.lnum, n);
    curwin->w_cursor.col = 0;
    check_cursor_lnum();
}
    int gchar_pos(pos)
    pos_T *pos;
{
    char_u *ptr = ml_get_pos(pos);
    return (int)*ptr;
}
    int gchar_cursor()
{
    return (int)*ml_get_cursor();
}
    void pchar_cursor(c)
    int c;
{
    *(ml_get_buf(curbuf, curwin->w_cursor.lnum, 1)
                                                  + curwin->w_cursor.col) = c;
}
    int inindent(extra)
    int extra;
{
    char_u *ptr;
    colnr_T col;
    for (col = 0, ptr = ml_get_curline(); ((*ptr) == ' ' || (*ptr) == '\t'); ++col)
        ++ptr;
    if (col >= curwin->w_cursor.col + extra)
        return 1;
    else
        return 0;
}
    char_u * skip_to_option_part(p)
    char_u *p;
{
    if (*p == ',')
        ++p;
    while (*p == ' ')
        ++p;
    return p;
}
    void changed()
{
    int save_msg_scroll = msg_scroll;
    if (!curbuf->b_changed)
    {
        change_warning(0);
        if (curbuf->b_may_swap
                && !bt_dontwrite(curbuf)
                )
        {
            ml_open_file(curbuf);
            if (need_wait_return && emsg_silent == 0)
            {
                out_flush();
                ui_delay(2000L, 1);
                wait_return(1);
                msg_scroll = save_msg_scroll;
            }
        }
        curbuf->b_changed = 1;
        ml_setdirty(curbuf, 1);
        check_status(curbuf);
        need_maketitle = 1;
    }
    ++curbuf->b_changedtick;
    ++global_changedtick;
}
static void changedOneline (linenr_T lnum);
static void changed_common (linenr_T lnum, colnr_T col, linenr_T lnume, long xtra);
    void changed_bytes(lnum, col)
    linenr_T lnum;
    colnr_T col;
{
    changedOneline(lnum);
    changed_common(lnum, col, lnum + 1, 0L);
}
    static void changedOneline(lnum)
    linenr_T lnum;
{
    if (curbuf->b_mod_set)
    {
        if (lnum < curbuf->b_mod_top)
            curbuf->b_mod_top = lnum;
        else if (lnum >= curbuf->b_mod_bot)
            curbuf->b_mod_bot = lnum + 1;
    }
    else
    {
        curbuf->b_mod_set = 1;
        curbuf->b_mod_top = lnum;
        curbuf->b_mod_bot = lnum + 1;
        curbuf->b_mod_xlines = 0;
    }
}
    void appended_lines(lnum, count)
    linenr_T lnum;
    long count;
{
    changed_lines(lnum + 1, 0, lnum + 1, count);
}
    void appended_lines_mark(lnum, count)
    linenr_T lnum;
    long count;
{
    mark_adjust(lnum + 1, (linenr_T)(0x7fffffffL), count, 0L);
    changed_lines(lnum + 1, 0, lnum + 1, count);
}
    void deleted_lines(lnum, count)
    linenr_T lnum;
    long count;
{
    changed_lines(lnum, 0, lnum + count, -count);
}
    void deleted_lines_mark(lnum, count)
    linenr_T lnum;
    long count;
{
    mark_adjust(lnum, (linenr_T)(lnum + count - 1), (long)(0x7fffffffL), -count);
    changed_lines(lnum, 0, lnum + count, -count);
}
    void changed_lines(lnum, col, lnume, xtra)
    linenr_T lnum;
    colnr_T col;
    linenr_T lnume;
    long xtra;
{
    if (curbuf->b_mod_set)
    {
        if (lnum < curbuf->b_mod_top)
            curbuf->b_mod_top = lnum;
        if (lnum < curbuf->b_mod_bot)
        {
            curbuf->b_mod_bot += xtra;
            if (curbuf->b_mod_bot < lnum)
                curbuf->b_mod_bot = lnum;
        }
        if (lnume + xtra > curbuf->b_mod_bot)
            curbuf->b_mod_bot = lnume + xtra;
        curbuf->b_mod_xlines += xtra;
    }
    else
    {
        curbuf->b_mod_set = 1;
        curbuf->b_mod_top = lnum;
        curbuf->b_mod_bot = lnume + xtra;
        curbuf->b_mod_xlines = xtra;
    }
    changed_common(lnum, col, lnume, xtra);
}
    static void changed_common(lnum, col, lnume, xtra)
    linenr_T lnum;
    colnr_T col;
    linenr_T lnume;
    long xtra;
{
    win_T *wp;
    int i;
    changed();
    curbuf->b_last_change.lnum = lnum;
    curbuf->b_last_change.col = col;
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
    {
        if (wp->w_buffer == curbuf)
        {
            if (wp->w_redr_type < 10)
                wp->w_redr_type = 10;
            foldUpdate(wp, lnum, lnume + xtra - 1);
            i = hasFoldingWin(wp, lnum, &lnum, ((void *)0), 0, ((void *)0));
            if (wp->w_cursor.lnum == lnum)
                wp->w_cline_folded = i;
            i = hasFoldingWin(wp, lnume, ((void *)0), &lnume, 0, ((void *)0));
            if (wp->w_cursor.lnum == lnume)
                wp->w_cline_folded = i;
            if (wp->w_cursor.lnum <= lnum)
            {
                i = find_wl_entry(wp, lnum);
                if (i >= 0 && wp->w_cursor.lnum > wp->w_lines[i].wl_lnum)
                    changed_line_abv_curs_win(wp);
            }
            if (wp->w_cursor.lnum > lnum)
                changed_line_abv_curs_win(wp);
            else if (wp->w_cursor.lnum == lnum && wp->w_cursor.col >= col)
                changed_cline_bef_curs_win(wp);
            if (wp->w_botline >= lnum)
            {
                approximate_botline_win(wp);
            }
            for (i = 0; i < wp->w_lines_valid; ++i)
                if (wp->w_lines[i].wl_valid)
                {
                    if (wp->w_lines[i].wl_lnum >= lnum)
                    {
                        if (wp->w_lines[i].wl_lnum < lnume)
                        {
                            wp->w_lines[i].wl_valid = 0;
                        }
                        else if (xtra != 0)
                        {
                            wp->w_lines[i].wl_lnum += xtra;
                            wp->w_lines[i].wl_lastlnum += xtra;
                        }
                    }
                    else if (wp->w_lines[i].wl_lastlnum >= lnum)
                    {
                        wp->w_lines[i].wl_valid = 0;
                    }
                }
        }
    }
    if (must_redraw < 10)
        must_redraw = 10;
}
    void unchanged(buf, ff)
    buf_T *buf;
    int ff;
{
    if (buf->b_changed || (ff && file_ff_differs(buf)))
    {
        buf->b_changed = 0;
        ml_setdirty(buf, 0);
        if (ff)
            save_file_ff(buf);
        check_status(buf);
        need_maketitle = 1;
    }
    ++buf->b_changedtick;
    ++global_changedtick;
    netbeans_unmodified(buf);
}
    void check_status(buf)
    buf_T *buf;
{
    win_T *wp;
    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        if (wp->w_buffer == buf && wp->w_status_height)
        {
            wp->w_redr_status = 1;
            if (must_redraw < 10)
                must_redraw = 10;
        }
}
    void change_warning(col)
    int col;
{
    if (curbuf->b_did_warn == 0
            && curbufIsChanged() == 0
            && !autocmd_busy
            && curbuf->b_p_ro)
    {
        apply_autocmds(EVENT_FILECHANGEDRO, ((void *)0), ((void *)0), 0, curbuf);
        if (!curbuf->b_p_ro)
            return;
        msg_start();
        if (msg_row == Rows - 1)
            msg_col = col;
        msg_puts_attr((char_u *)(((char *)("W10: Warning: Changing a readonly file"))), (highlight_attr[(int)(HLF_W)] | 0x1000));
        msg_clr_eos();
        (void)msg_end();
        if (msg_silent == 0)
        {
            out_flush();
            ui_delay(1000L, 1);
        }
        curbuf->b_did_warn = 1;
        redraw_cmdline = 0;
        if (msg_row < Rows - 1)
            showmode();
    }
}
    int ask_yesno(str, direct)
    char_u *str;
    int direct;
{
    int r = ' ';
    int save_State = State;
    if (exiting)
        settmode(2);
    ++no_wait_return;
    State = 0x800;
    setmouse();
    ++no_mapping;
    ++allow_keys;
    while (r != 'y' && r != 'n')
    {
        smsg_attr(highlight_attr[(int)(HLF_R)], (char_u *)"%s (y/n)?", str);
        if (direct)
            r = get_keystroke();
        else
            r = safe_vgetc();
        if (r == 3 || r == '\033')
            r = 'n';
        msg_putchar(r);
        out_flush();
    }
    --no_wait_return;
    State = save_State;
    setmouse();
    --no_mapping;
    --allow_keys;
    return r;
}
    int get_keystroke()
{
    char_u buf[151];
    int len = 0;
    int n;
    for (;;)
    {
        cursor_on();
        out_flush();
        n = ui_inchar(buf + len, (151 - 6 - len) / 3,
                                                       len == 0 ? -1L : 100L);
        if (n > 0)
        {
            n = fix_input_buffer(buf + len, n, 0);
            len += n;
        }
        if ((n = check_termcode(1, buf, len)) < 0)
            continue;
        if (n > 0)
            len = n;
        if (len == 0)
            continue;
        n = buf[0];
        if (n == (0x80))
        {
            n = ((buf[1]) == 254 ? (0x80) : (buf[1]) == 255 ? (-((255) + ((int)(('X')) << 8))) : (-((buf[1]) + ((int)(buf[2]) << 8))));
            if (buf[1] == 252
                    || n == (-((253) + ((int)(KE_IGNORE) << 8)))
                    || n == (-((253) + ((int)(KE_LEFTMOUSE_NM) << 8)))
                    || n == (-((253) + ((int)(KE_LEFTDRAG) << 8)))
                    || n == (-((253) + ((int)(KE_LEFTRELEASE) << 8)))
                    || n == (-((253) + ((int)(KE_LEFTRELEASE_NM) << 8)))
                    || n == (-((253) + ((int)(KE_MIDDLEMOUSE) << 8)))
                    || n == (-((253) + ((int)(KE_MIDDLEDRAG) << 8)))
                    || n == (-((253) + ((int)(KE_MIDDLERELEASE) << 8)))
                    || n == (-((253) + ((int)(KE_RIGHTMOUSE) << 8)))
                    || n == (-((253) + ((int)(KE_RIGHTDRAG) << 8)))
                    || n == (-((253) + ((int)(KE_RIGHTRELEASE) << 8)))
                    || n == (-((253) + ((int)(KE_MOUSEDOWN) << 8)))
                    || n == (-((253) + ((int)(KE_MOUSEUP) << 8)))
                    || n == (-((253) + ((int)(KE_X1MOUSE) << 8)))
                    || n == (-((253) + ((int)(KE_X1DRAG) << 8)))
                    || n == (-((253) + ((int)(KE_X1RELEASE) << 8)))
                    || n == (-((253) + ((int)(KE_X2MOUSE) << 8)))
                    || n == (-((253) + ((int)(KE_X2DRAG) << 8)))
                    || n == (-((253) + ((int)(KE_X2RELEASE) << 8)))
                    || n == (-((249) + ((int)(('X')) << 8)))
                    || n == (-((248) + ((int)(('X')) << 8)))
               )
            {
                if (buf[1] == 252)
                    mod_mask = buf[2];
                len -= 3;
                if (len > 0)
                    memmove((char *)(buf), (char *)(buf + 3), (size_t)len);
                continue;
            }
        }
        if (n == intr_char)
            n = '\033';
        break;
    }
    return n;
}
    int get_number(colon)
    int colon;
{
    int n = 0;
    int c;
    if (msg_silent != 0)
        return 0;
    ++no_mapping;
    ++allow_keys;
    for (;;)
    {
        windgoto(msg_row, msg_col);
        c = safe_vgetc();
        if (vim_isdigit(c))
        {
            n = n * 10 + c - '0';
            msg_putchar(c);
        }
        else if (c == (-(('k') + ((int)('D') << 8))) || c == (-((253) + ((int)(KE_KDEL) << 8))) || c == (-(('k') + ((int)('b') << 8))) || c == 8)
        {
            n /= 10;
            msg_puts((char_u *)("\b \b"));
        }
        else if (n == 0 && c == ':' && colon)
        {
            stuffcharReadbuff(':');
            if (!exmode_active)
                cmdline_row = msg_row;
            skip_redraw = 1;
            do_redraw = 0;
            break;
        }
        else if (c == '\015' || c == '\012' || c == 3 || c == '\033')
            break;
    }
    --no_mapping;
    --allow_keys;
    return n;
}
    void msgmore(n)
    long n;
{
    long pn;
    if (global_busy
            || keep_msg != ((void *)0)
            || !messaging())
        return;
    if (n > 0)
        pn = n;
    else
        pn = -n;
    if (pn > p_report)
    {
        if (pn == 1)
        {
            if (n > 0)
                strcpy((char *)(msg_buf), (char *)(((char *)("1 more line"))));
            else
                strcpy((char *)(msg_buf), (char *)(((char *)("1 line less"))));
        }
        else
        {
            if (n > 0)
                sprintf((char *)msg_buf, ((char *)("%ld more lines")), pn);
            else
                sprintf((char *)msg_buf, ((char *)("%ld fewer lines")), pn);
        }
        if (got_int)
            strcat((char *)(msg_buf), (char *)(((char *)(" (Interrupted)"))));
        if (msg(msg_buf))
        {
            set_keep_msg(msg_buf);
            keep_msg_attr = 0;
        }
    }
}
    void beep_flush()
{
    if (emsg_silent == 0)
    {
        flush_buffers(0);
        vim_beep();
    }
}
    void vim_beep()
{
    if (emsg_silent == 0)
    {
        if (p_vb
                && !(gui.in_use && gui.starting)
                )
        {
            out_str((term_strings[(int)(KS_VB)]));
        }
        else
        {
            out_char('\007');
        }
    }
}
static char_u *homedir = ((void *)0);
    void init_homedir()
{
    char_u *var;
    var = (char_u *)getenv((char *)((char_u *)"HOME"));
    if (var != ((void *)0) && *var == '\000')
        var = ((void *)0);
    if (var != ((void *)0))
    {
        if (mch_dirname(NameBuff, 1024) == 1
                                          && chdir((char *)NameBuff) == 0)
        {
            if (!chdir((char *)var) && mch_dirname(IObuff, (1024+1)) == 1)
                var = IObuff;
            if (chdir((char *)NameBuff) != 0)
                emsg((char_u *)(((char *)(e_prev_dir))));
        }
        homedir = vim_strsave(var);
    }
}
    void expand_env(src, dst, dstlen)
    char_u *src;
    char_u *dst;
    int dstlen;
{
    expand_env_esc(src, dst, dstlen, 0);
}
extern char_u *default_vim_dir;
extern char_u *default_vimruntime_dir;
    char_u * vim_getenv(name, mustfree)
    char_u *name;
    int *mustfree;
{
    char_u *p;
    char_u *pend;
    int vimruntime;
    p = (char_u *)getenv((char *)(name));
    if (p != ((void *)0) && *p == '\000')
        p = ((void *)0);
    if (p != ((void *)0))
        return p;
    vimruntime = (strcmp((char *)(name), (char *)("VIMRUNTIME")) == 0);
    if (!vimruntime && strcmp((char *)(name), (char *)("VIM")) != 0)
        return ((void *)0);
    if (vimruntime
            && *default_vimruntime_dir == '\000'
       )
    {
        p = (char_u *)getenv((char *)((char_u *)"VIM"));
        if (p != ((void *)0) && *p == '\000')
            p = ((void *)0);
        if (p != ((void *)0))
        {
            p = vim_version_dir(p);
            if (p != ((void *)0))
                *mustfree = 1;
            else
                p = (char_u *)getenv((char *)((char_u *)"VIM"));
        }
    }
    if (p == ((void *)0))
    {
        if (p_hf != ((void *)0) && vim_strchr(p_hf, '$') == ((void *)0))
            p = p_hf;
        if (p != ((void *)0))
        {
            pend = gettail(p);
            if (p == p_hf)
                pend = remove_tail(p, pend, (char_u *)"doc");
            if (!vimruntime)
            {
                pend = remove_tail(p, pend, (char_u *)"runtime");
                pend = remove_tail(p, pend, (char_u *)"vim62");
            }
            if (pend > p && vim_ispathsep(*(pend - 1)))
                --pend;
            p = vim_strnsave(p, (int)(pend - p));
            if (p != ((void *)0) && !mch_isdir(p))
            {
                vim_free(p);
                p = ((void *)0);
            }
            else
            {
                *mustfree = 1;
            }
        }
    }
    if (p == ((void *)0))
    {
        if (vimruntime && *default_vimruntime_dir != '\000')
        {
            p = default_vimruntime_dir;
            *mustfree = 0;
        }
        else if (*default_vim_dir != '\000')
        {
            if (vimruntime && (p = vim_version_dir(default_vim_dir)) != ((void *)0))
                *mustfree = 1;
            else
            {
                p = default_vim_dir;
                *mustfree = 0;
            }
        }
    }
    if (p != ((void *)0))
    {
        if (vimruntime)
        {
            vim_setenv((char_u *)"VIMRUNTIME", p);
            didset_vimruntime = 1;
        }
        else
        {
            vim_setenv((char_u *)"VIM", p);
            didset_vim = 1;
        }
    }
    return p;
}
    void expand_env_esc(src, dst, dstlen, esc)
    char_u *src;
    char_u *dst;
    int dstlen;
    int esc;
{
    char_u *tail;
    int c;
    char_u *var;
    int copy_char;
    int mustfree;
    int at_start = 1;
    src = skipwhite(src);
    --dstlen;
    while (*src && dstlen > 0)
    {
        copy_char = 1;
        if (*src == '$'
                || (*src == '~' && at_start))
        {
            mustfree = 0;
            if (*src != '~')
            {
                tail = src + 1;
                var = dst;
                c = dstlen - 1;
                if (*tail == '{' && !vim_isIDc('{'))
                {
                    tail++;
                    while (c-- > 0 && *tail && *tail != '}')
                        *var++ = *tail++;
                }
                else
                {
                    while (c-- > 0 && *tail != '\000' && ((vim_isIDc(*tail))
                            ))
                    {
                        *var++ = *tail++;
                    }
                }
                if (src[1] == '{' && *tail != '}')
                    var = ((void *)0);
                else
                {
                    if (src[1] == '{')
                        ++tail;
                    *var = '\000';
                    var = vim_getenv(dst, &mustfree);
                }
            }
            else if ( src[1] == '\000'
                    || vim_ispathsep(src[1])
                    || vim_strchr((char_u *)" ,\t\n", src[1]) != ((void *)0))
            {
                var = homedir;
                tail = src + 1;
            }
            else
            {
                tail = src;
                var = dst;
                c = dstlen - 1;
                while ( c-- > 0
                        && *tail
                        && vim_isfilec(*tail)
                        && !vim_ispathsep(*tail))
                    *var++ = *tail++;
                *var = '\000';
                {
                    struct passwd *pw;
                    pw = getpwnam((char *)dst + 1);
                    if (pw != ((void *)0))
                        var = (char_u *)pw->pw_dir;
                    else
                        var = ((void *)0);
                }
                if (var == ((void *)0))
                {
                    expand_T xpc;
                    xpc.xp_context = 2;
                    xpc.xp_backslash = 0;
                    var = ExpandOne(&xpc, dst, ((void *)0),
                                16|64, 2);
                    mustfree = 1;
                }
            }
            if (esc && var != ((void *)0) && (char_u *)strpbrk((char *)(var), (char *)((char_u *)" \t")) != ((void *)0))
            {
                char_u *p = vim_strsave_escaped(var, (char_u *)" \t");
                if (p != ((void *)0))
                {
                    if (mustfree)
                        vim_free(var);
                    var = p;
                    mustfree = 1;
                }
            }
            if (var != ((void *)0) && *var != '\000'
                    && (strlen((char *)(var)) + strlen((char *)(tail)) + 1 < (unsigned)dstlen))
            {
                strcpy((char *)(dst), (char *)(var));
                dstlen -= (int)strlen((char *)(var));
                dst += strlen((char *)(var));
                if (*var != '\000' && vim_ispathsep(dst[-1])
                        && vim_ispathsep(*tail))
                    ++tail;
                src = tail;
                copy_char = 0;
            }
            if (mustfree)
                vim_free(var);
        }
        if (copy_char)
        {
            at_start = 0;
            if (src[0] == '\\' && src[1] != '\000')
            {
                *dst++ = *src++;
                --dstlen;
            }
            else if (src[0] == ' ' || src[0] == ',')
                at_start = 1;
            *dst++ = *src++;
            --dstlen;
        }
    }
    *dst = '\000';
}
    static char_u * vim_version_dir(vimdir)
    char_u *vimdir;
{
    char_u *p;
    if (vimdir == ((void *)0) || *vimdir == '\000')
        return ((void *)0);
    p = concat_fnames(vimdir, (char_u *)"vim62", 1);
    if (p != ((void *)0) && mch_isdir(p))
        return p;
    vim_free(p);
    p = concat_fnames(vimdir, (char_u *)"runtime", 1);
    if (p != ((void *)0) && mch_isdir(p))
        return p;
    vim_free(p);
    return ((void *)0);
}
    static char_u * remove_tail(p, pend, name)
    char_u *p;
    char_u *pend;
    char_u *name;
{
    int len = (int)strlen((char *)(name)) + 1;
    char_u *newend = pend - len;
    if (newend >= p
            && strncmp((char *)(newend), (char *)(name), (size_t)(len - 1)) == 0
            && (newend == p || vim_ispathsep(*(newend - 1))))
        return newend;
    return pend;
}
    char_u * expand_env_save(src)
    char_u *src;
{
    char_u *p;
    p = alloc(1024);
    if (p != ((void *)0))
        expand_env(src, p, 1024);
    return p;
}
    void vim_setenv(name, val)
    char_u *name;
    char_u *val;
{
    setenv((char *)name, (char *)val, 1);
}
    char_u * get_env_name(xp, idx)
    expand_T *xp;
    int idx;
{
    extern char **environ;
    static char_u name[100];
    char_u *str;
    int n;
    str = (char_u *)environ[idx];
    if (str == ((void *)0))
        return ((void *)0);
    for (n = 0; n < 99; ++n)
    {
        if (str[n] == '=' || str[n] == '\000')
            break;
        name[n] = str[n];
    }
    name[n] = '\000';
    return name;
}
    void home_replace(buf, src, dst, dstlen, one)
    buf_T *buf;
    char_u *src;
    char_u *dst;
    int dstlen;
    int one;
{
    size_t dirlen = 0, envlen = 0;
    size_t len;
    char_u *homedir_env;
    char_u *p;
    if (src == ((void *)0))
    {
        *dst = '\000';
        return;
    }
    if (buf != ((void *)0) && buf->b_help)
    {
        strcpy((char *)(dst), (char *)(gettail(src)));
        return;
    }
    if (homedir != ((void *)0))
        dirlen = strlen((char *)(homedir));
    homedir_env = (char_u *)getenv((char *)((char_u *)"HOME"));
    if (homedir_env != ((void *)0) && *homedir_env == '\000')
        homedir_env = ((void *)0);
    if (homedir_env != ((void *)0))
        envlen = strlen((char *)(homedir_env));
    if (!one)
        src = skipwhite(src);
    while (*src && dstlen > 0)
    {
        p = homedir;
        len = dirlen;
        for (;;)
        {
            if ( len
                && strncmp((char *)(src), (char *)(p), (size_t)(len)) == 0
                && (vim_ispathsep(src[len])
                    || (!one && (src[len] == ',' || src[len] == ' '))
                    || src[len] == '\000'))
            {
                src += len;
                if (--dstlen > 0)
                    *dst++ = '~';
                if (!vim_ispathsep(src[0]) && --dstlen > 0)
                    *dst++ = '/';
                break;
            }
            if (p == homedir_env)
                break;
            p = homedir_env;
            len = envlen;
        }
        while (*src && (one || (*src != ',' && *src != ' ')) && --dstlen > 0)
            *dst++ = *src++;
        while ((*src == ' ' || *src == ',') && --dstlen > 0)
            *dst++ = *src++;
    }
    *dst = '\000';
}
    char_u * home_replace_save(buf, src)
    buf_T *buf;
    char_u *src;
{
    char_u *dst;
    unsigned len;
    len = 3;
    if (src != ((void *)0))
        len += (unsigned)strlen((char *)(src));
    dst = alloc(len);
    if (dst != ((void *)0))
        home_replace(buf, src, dst, len, 1);
    return dst;
}
    int fullpathcmp(s1, s2, checkname)
    char_u *s1, *s2;
    int checkname;
{
    char_u exp1[1024];
    char_u full1[1024];
    char_u full2[1024];
    struct stat st1, st2;
    int r1, r2;
    expand_env(s1, exp1, 1024);
    r1 = stat(((char *)exp1), (&st1));
    r2 = stat(((char *)s2), (&st2));
    if (r1 != 0 && r2 != 0)
    {
        if (checkname)
        {
            if (strcmp((char *)(exp1), (char *)(s2)) == 0)
                return 7;
            r1 = vim_FullName(exp1, full1, 1024, 0);
            r2 = vim_FullName(s2, full2, 1024, 0);
            if (r1 == 1 && r2 == 1 && strcmp((char *)(full1), (char *)(full2)) == 0)
                return 7;
        }
        return 4;
    }
    if (r1 != 0 || r2 != 0)
        return 6;
    if (st1.st_dev == st2.st_dev && st1.st_ino == st2.st_ino)
        return 1;
    return 2;
}
    char_u * gettail(fname)
    char_u *fname;
{
    char_u *p1, *p2;
    if (fname == ((void *)0))
        return (char_u *)"";
    for (p1 = p2 = fname; *p2; )
    {
        if (vim_ispathsep(*p2))
            p1 = p2 + 1;
            ++p2;
    }
    return p1;
}
    char_u * getnextcomp(fname)
    char_u *fname;
{
    while (*fname && !vim_ispathsep(*fname))
        ++fname;
    if (*fname)
        ++fname;
    return fname;
}
    char_u * get_past_head(path)
    char_u *path;
{
    char_u *retval;
    retval = path;
    while (vim_ispathsep(*retval))
        ++retval;
    return retval;
}
    int vim_ispathsep(c)
    int c;
{
    return (c == '/');
}
    int vim_ispathlistsep(c)
    int c;
{
    return (c == ':');
}
    char_u * concat_fnames(fname1, fname2, sep)
    char_u *fname1;
    char_u *fname2;
    int sep;
{
    char_u *dest;
    dest = alloc((unsigned)(strlen((char *)(fname1)) + strlen((char *)(fname2)) + 3));
    if (dest != ((void *)0))
    {
        strcpy((char *)(dest), (char *)(fname1));
        if (sep)
            add_pathsep(dest);
        strcat((char *)(dest), (char *)(fname2));
    }
    return dest;
}
    void add_pathsep(p)
    char_u *p;
{
    if (*p != '\000' && !vim_ispathsep(*(p + strlen((char *)(p)) - 1)))
        strcat((char *)(p), (char *)("/"));
}
    char_u * FullName_save(fname, force)
    char_u *fname;
    int force;
{
    char_u *buf;
    char_u *new_fname = ((void *)0);
    if (fname == ((void *)0))
        return ((void *)0);
    buf = alloc((unsigned)1024);
    if (buf != ((void *)0))
    {
        if (vim_FullName(fname, buf, 1024, force) != 0)
            new_fname = vim_strsave(buf);
        else
            new_fname = vim_strsave(fname);
        vim_free(buf);
    }
    return new_fname;
}
static char_u *skip_string (char_u *p);
    pos_T * find_start_comment(ind_maxcomment)
    int ind_maxcomment;
{
    pos_T *pos;
    char_u *line;
    char_u *p;
    if ((pos = findmatchlimit(((void *)0), '*', 0x01, ind_maxcomment)) == ((void *)0))
        return ((void *)0);
    line = ml_get(pos->lnum);
    for (p = line; *p && (unsigned)(p - line) < pos->col; ++p)
        p = skip_string(p);
    if ((unsigned)(p - line) > pos->col)
        return ((void *)0);
    return pos;
}
    static char_u * skip_string(p)
    char_u *p;
{
    int i;
    for ( ; ; ++p)
    {
        if (p[0] == '\'')
        {
            if (!p[1])
                break;
            i = 2;
            if (p[1] == '\\')
            {
                ++i;
                while ((__ctype_b[(int) ((p[i - 1]))] & (unsigned short int) _ISdigit))
                    ++i;
            }
            if (p[i] == '\'')
            {
                p += i;
                continue;
            }
        }
        else if (p[0] == '"')
        {
            for (++p; p[0]; ++p)
            {
                if (p[0] == '\\' && p[1] != '\000')
                    ++p;
                else if (p[0] == '"')
                    break;
            }
            if (p[0] == '"')
                continue;
        }
        break;
    }
    if (!*p)
        --p;
    return p;
}
    void do_c_expr_indent()
{
    if (*curbuf->b_p_inde != '\000')
        fixthisline(get_expr_indent);
    else
        fixthisline(get_c_indent);
}
static char_u *cin_skipcomment (char_u *);
static int cin_nocode (char_u *);
static pos_T *find_line_comment (void);
static int cin_islabel_skip (char_u **);
static int cin_isdefault (char_u *);
static char_u *after_label (char_u *l);
static int get_indent_nolabel (linenr_T lnum);
static int skip_label (linenr_T, char_u **pp, int ind_maxcomment);
static int cin_ispreproc (char_u *);
static int cin_iscomment (char_u *);
static int cin_islinecomment (char_u *);
static int cin_isterminated (char_u *, int);
static int cin_isfuncdecl (char_u *);
static int cin_isif (char_u *);
static int cin_iselse (char_u *);
static int cin_isdo (char_u *);
static int cin_iswhileofdo (char_u *, linenr_T, int);
static int cin_ends_in (char_u *, char_u *);
static int cin_skip2pos (pos_T *trypos);
static pos_T *find_start_brace (int);
static pos_T *find_match_paren (int, int);
static int find_last_paren (char_u *l);
static int find_match (int lookfor, linenr_T ourscope, int ind_maxparen, int ind_maxcomment);
    static char_u * cin_skipcomment(s)
    char_u *s;
{
    while (*s)
    {
        s = skipwhite(s);
        if (*s != '/')
            break;
        ++s;
        if (*s == '/')
        {
            s += strlen((char *)(s));
            break;
        }
        if (*s != '*')
            break;
        for (++s; *s; ++s)
            if (s[0] == '*' && s[1] == '/')
            {
                s += 2;
                break;
            }
    }
    return s;
}
    static int cin_nocode(s)
    char_u *s;
{
    return *cin_skipcomment(s) == '\000';
}
    static pos_T * find_line_comment()
{
    static pos_T pos;
    char_u *line;
    char_u *p;
    pos = curwin->w_cursor;
    while (--pos.lnum > 0)
    {
        line = ml_get(pos.lnum);
        p = skipwhite(line);
        if (cin_islinecomment(p))
        {
            pos.col = (int)(p - line);
            return &pos;
        }
        if (*p != '\000')
            break;
    }
    return ((void *)0);
}
    static int cin_islabel_skip(s)
    char_u **s;
{
    if (!vim_isIDc(**s))
        return 0;
    while (vim_isIDc(**s))
        (*s)++;
    *s = cin_skipcomment(*s);
    return (**s == ':' && *++*s != ':');
}
    int cin_islabel(ind_maxcomment)
    int ind_maxcomment;
{
    char_u *s;
    s = cin_skipcomment(ml_get_curline());
    if (cin_isdefault(s))
        return 0;
    if (cin_isscopedecl(s))
        return 0;
    if (cin_islabel_skip(&s))
    {
        pos_T cursor_save;
        pos_T *trypos;
        char_u *line;
        cursor_save = curwin->w_cursor;
        while (curwin->w_cursor.lnum > 1)
        {
            --curwin->w_cursor.lnum;
            curwin->w_cursor.col = 0;
            if ((trypos = find_start_comment(ind_maxcomment)) != ((void *)0))
                curwin->w_cursor = *trypos;
            line = ml_get_curline();
            if (cin_ispreproc(line))
                continue;
            if (*(line = cin_skipcomment(line)) == '\000')
                continue;
            curwin->w_cursor = cursor_save;
            if (cin_isterminated(line, 1)
                    || cin_isscopedecl(line)
                    || cin_iscase(line)
                    || (cin_islabel_skip(&line) && cin_nocode(line)))
                return 1;
            return 0;
        }
        curwin->w_cursor = cursor_save;
        return 1;
    }
    return 0;
}
     int cin_iscase(s)
    char_u *s;
{
    s = cin_skipcomment(s);
    if (strncmp((char *)(s), (char *)("case"), (size_t)(4)) == 0 && !vim_isIDc(s[4]))
    {
        for (s += 4; *s; ++s)
        {
            s = cin_skipcomment(s);
            if (*s == ':')
            {
                if (s[1] == ':')
                    ++s;
                else
                    return 1;
            }
            if (*s == '\'' && s[1] && s[2] == '\'')
                s += 2;
            else if (*s == '/' && (s[1] == '*' || s[1] == '/'))
                return 0;
            else if (*s == '"')
                return 0;
        }
        return 0;
    }
    if (cin_isdefault(s))
        return 1;
    return 0;
}
    static int cin_isdefault(s)
    char_u *s;
{
    return (strncmp((char *)(s), (char *)("default"), (size_t)(7)) == 0
            && *(s = cin_skipcomment(s + 7)) == ':'
            && s[1] != ':');
}
    int cin_isscopedecl(s)
    char_u *s;
{
    int i;
    s = cin_skipcomment(s);
    if (strncmp((char *)(s), (char *)("public"), (size_t)(6)) == 0)
        i = 6;
    else if (strncmp((char *)(s), (char *)("protected"), (size_t)(9)) == 0)
        i = 9;
    else if (strncmp((char *)(s), (char *)("private"), (size_t)(7)) == 0)
        i = 7;
    else
        return 0;
    return (*(s = cin_skipcomment(s + i)) == ':' && s[1] != ':');
}
    static char_u * after_label(l)
    char_u *l;
{
    for ( ; *l; ++l)
    {
        if (*l == ':')
        {
            if (l[1] == ':')
                ++l;
            else if (!cin_iscase(l + 1))
                break;
        }
        else if (*l == '\'' && l[1] && l[2] == '\'')
            l += 2;
    }
    if (*l == '\000')
        return ((void *)0);
    l = cin_skipcomment(l + 1);
    if (*l == '\000')
        return ((void *)0);
    return l;
}
    static int get_indent_nolabel(lnum)
    linenr_T lnum;
{
    char_u *l;
    pos_T fp;
    colnr_T col;
    char_u *p;
    l = ml_get(lnum);
    p = after_label(l);
    if (p == ((void *)0))
        return 0;
    fp.col = (colnr_T)(p - l);
    fp.lnum = lnum;
    getvcol(curwin, &fp, &col, ((void *)0), ((void *)0));
    return (int)col;
}
    static int skip_label(lnum, pp, ind_maxcomment)
    linenr_T lnum;
    char_u **pp;
    int ind_maxcomment;
{
    char_u *l;
    int amount;
    pos_T cursor_save;
    cursor_save = curwin->w_cursor;
    curwin->w_cursor.lnum = lnum;
    l = ml_get_curline();
    if (cin_iscase(l) || cin_isscopedecl(l) || cin_islabel(ind_maxcomment))
    {
        amount = get_indent_nolabel(lnum);
        l = after_label(ml_get_curline());
        if (l == ((void *)0))
            l = ml_get_curline();
    }
    else
    {
        amount = get_indent();
        l = ml_get_curline();
    }
    *pp = l;
    curwin->w_cursor = cursor_save;
    return amount;
}
    static int cin_ispreproc(s)
    char_u *s;
{
    s = skipwhite(s);
    if (*s == '#')
        return 1;
    return 0;
}
    static int cin_iscomment(p)
    char_u *p;
{
    return (p[0] == '/' && (p[1] == '*' || p[1] == '/'));
}
    static int cin_islinecomment(p)
    char_u *p;
{
    return (p[0] == '/' && p[1] == '/');
}
    static int cin_isterminated(s, incl_open)
    char_u *s;
    int incl_open;
{
    s = cin_skipcomment(s);
    if (*s == '{' || (*s == '}' && !cin_iselse(s)))
        return 1;
    while (*s)
    {
        s = skip_string(cin_skipcomment(s));
        if ((*s == ';' || (incl_open && *s == '{') || *s == '}' || *s == ',')
                                                     && cin_nocode(s + 1))
            return 1;
        if (*s)
            s++;
    }
    return 0;
}
    static int cin_isfuncdecl(s)
    char_u *s;
{
    while (*s && *s != '(' && *s != ';' && *s != '\'' && *s != '"')
    {
        if (cin_iscomment(s))
            s = cin_skipcomment(s);
        else
            ++s;
    }
    if (*s != '(')
        return 0;
    while (*s && *s != ';' && *s != '\'' && *s != '"')
    {
        if (*s == ')' && cin_nocode(s + 1))
            return 1;
        if (cin_iscomment(s))
            s = cin_skipcomment(s);
        else
            ++s;
    }
    return 0;
}
    static int cin_isif(p)
    char_u *p;
{
    return (strncmp((char *)(p), (char *)("if"), (size_t)(2)) == 0 && !vim_isIDc(p[2]));
}
    static int cin_iselse(p)
    char_u *p;
{
    if (*p == '}')
        p = cin_skipcomment(p + 1);
    return (strncmp((char *)(p), (char *)("else"), (size_t)(4)) == 0 && !vim_isIDc(p[4]));
}
    static int cin_isdo(p)
    char_u *p;
{
    return (strncmp((char *)(p), (char *)("do"), (size_t)(2)) == 0 && !vim_isIDc(p[2]));
}
    static int cin_iswhileofdo(p, lnum, ind_maxparen)
    char_u *p;
    linenr_T lnum;
    int ind_maxparen;
{
    pos_T cursor_save;
    pos_T *trypos;
    int retval = 0;
    p = cin_skipcomment(p);
    if (*p == '}')
        p = cin_skipcomment(p + 1);
    if (strncmp((char *)(p), (char *)("while"), (size_t)(5)) == 0 && !vim_isIDc(p[5]))
    {
        cursor_save = curwin->w_cursor;
        curwin->w_cursor.lnum = lnum;
        curwin->w_cursor.col = 0;
        p = ml_get_curline();
        while (*p && *p != 'w')
        {
            ++p;
            ++curwin->w_cursor.col;
        }
        if ((trypos = findmatchlimit(((void *)0), 0, 0, ind_maxparen)) != ((void *)0)
                && *cin_skipcomment(ml_get_pos(trypos) + 1) == ';')
            retval = 1;
        curwin->w_cursor = cursor_save;
    }
    return retval;
}
    static int cin_ends_in(s, find)
    char_u *s;
    char_u *find;
{
    char_u *p = s;
    char_u *r;
    int len = (int)strlen((char *)(find));
    while (*p != '\000')
    {
        p = cin_skipcomment(p);
        if (strncmp((char *)(p), (char *)(find), (size_t)(len)) == 0)
        {
            r = skipwhite(p + len);
            if (*r == '\000' || cin_iscomment(r))
                return 1;
        }
        if (*p != '\000')
            ++p;
    }
    return 0;
}
    static int cin_skip2pos(trypos)
    pos_T *trypos;
{
    char_u *line;
    char_u *p;
    p = line = ml_get(trypos->lnum);
    while (*p && (colnr_T)(p - line) < trypos->col)
    {
        if (cin_iscomment(p))
            p = cin_skipcomment(p);
        else
        {
            p = skip_string(p);
            ++p;
        }
    }
    return (int)(p - line);
}
    static pos_T * find_start_brace(ind_maxcomment)
    int ind_maxcomment;
{
    pos_T cursor_save;
    pos_T *trypos;
    pos_T *pos;
    static pos_T pos_copy;
    cursor_save = curwin->w_cursor;
    while ((trypos = findmatchlimit(((void *)0), '{', 0x04, 0)) != ((void *)0))
    {
        pos_copy = *trypos;
        trypos = &pos_copy;
        curwin->w_cursor = *trypos;
        pos = ((void *)0);
        if ((colnr_T)cin_skip2pos(trypos) == trypos->col
                && (pos = find_start_comment(ind_maxcomment)) == ((void *)0))
            break;
        if (pos != ((void *)0))
            curwin->w_cursor.lnum = pos->lnum;
    }
    curwin->w_cursor = cursor_save;
    return trypos;
}
    static pos_T * find_match_paren(ind_maxparen, ind_maxcomment)
    int ind_maxparen;
    int ind_maxcomment;
{
    pos_T cursor_save;
    pos_T *trypos;
    static pos_T pos_copy;
    cursor_save = curwin->w_cursor;
    if ((trypos = findmatchlimit(((void *)0), '(', 0, ind_maxparen)) != ((void *)0))
    {
        if ((colnr_T)cin_skip2pos(trypos) > trypos->col)
            trypos = ((void *)0);
        else
        {
            pos_copy = *trypos;
            trypos = &pos_copy;
            curwin->w_cursor = *trypos;
            if (find_start_comment(ind_maxcomment) != ((void *)0))
                trypos = ((void *)0);
        }
    }
    curwin->w_cursor = cursor_save;
    return trypos;
}
    static int find_last_paren(l)
    char_u *l;
{
    int i;
    int retval = 0;
    curwin->w_cursor.col = 0;
    for (i = 0; l[i]; i++)
    {
        i = (int)(skip_string(l + i) - l);
        if (l[i] == ')')
        {
            curwin->w_cursor.col = i;
            retval = 1;
        }
    }
    return retval;
}
    int get_c_indent()
{
    int ind_level = curbuf->b_p_sw;
    int ind_open_imag = 0;
    int ind_no_brace = 0;
    int ind_first_open = 0;
    int ind_open_extra = 0;
    int ind_close_extra = 0;
    int ind_open_left_imag = 0;
    int ind_case = curbuf->b_p_sw;
    int ind_case_code = curbuf->b_p_sw;
    int ind_scopedecl = curbuf->b_p_sw;
    int ind_scopedecl_code = curbuf->b_p_sw;
    int ind_param = curbuf->b_p_sw;
    int ind_func_type = curbuf->b_p_sw;
    int ind_continuation = curbuf->b_p_sw;
    int ind_unclosed = curbuf->b_p_sw * 2;
    int ind_unclosed2 = curbuf->b_p_sw;
    int ind_unclosed_noignore = 0;
    int ind_unclosed_whiteok = 0;
    int ind_matching_paren = 0;
    int ind_comment = 0;
    int ind_in_comment = 3;
    int ind_in_comment2 = 0;
    int ind_maxparen = 20;
    int ind_maxcomment = 70;
    int ind_java = 0;
    int ind_keep_case_label = 0;
    pos_T cur_curpos;
    int amount;
    int scope_amount;
    int cur_amount;
    colnr_T col;
    char_u *theline;
    char_u *linecopy;
    pos_T *trypos;
    pos_T *tryposBrace = ((void *)0);
    pos_T our_paren_pos;
    char_u *start;
    int start_brace;
    linenr_T ourscope;
    char_u *l;
    char_u *look;
    int lookfor;
    int whilelevel;
    linenr_T lnum;
    char_u *options;
    int fraction = 0;
    int divider;
    int n;
    int iscase;
    for (options = curbuf->b_p_cino; *options; )
    {
        l = options++;
        if (*options == '-')
            ++options;
        n = getdigits(&options);
        divider = 0;
        if (*options == '.')
        {
            fraction = atol((char *)++options);
            while ((__ctype_b[(int) ((*options))] & (unsigned short int) _ISdigit))
            {
                ++options;
                if (divider)
                    divider *= 10;
                else
                    divider = 10;
            }
        }
        if (*options == 's')
        {
            if (n == 0 && fraction == 0)
                n = curbuf->b_p_sw;
            else
            {
                n *= curbuf->b_p_sw;
                if (divider)
                    n += (curbuf->b_p_sw * fraction + divider / 2) / divider;
            }
            ++options;
        }
        if (l[1] == '-')
            n = -n;
        switch (*l)
        {
            case '>': ind_level = n; break;
            case 'e': ind_open_imag = n; break;
            case 'n': ind_no_brace = n; break;
            case 'f': ind_first_open = n; break;
            case '{': ind_open_extra = n; break;
            case '}': ind_close_extra = n; break;
            case '^': ind_open_left_imag = n; break;
            case ':': ind_case = n; break;
            case '=': ind_case_code = n; break;
            case 'p': ind_param = n; break;
            case 't': ind_func_type = n; break;
            case '/': ind_comment = n; break;
            case 'c': ind_in_comment = n; break;
            case 'C': ind_in_comment2 = n; break;
            case '+': ind_continuation = n; break;
            case '(': ind_unclosed = n; break;
            case 'u': ind_unclosed2 = n; break;
            case 'U': ind_unclosed_noignore = n; break;
            case 'w': ind_unclosed_whiteok = n; break;
            case 'm': ind_matching_paren = n; break;
            case ')': ind_maxparen = n; break;
            case '*': ind_maxcomment = n; break;
            case 'g': ind_scopedecl = n; break;
            case 'h': ind_scopedecl_code = n; break;
            case 'j': ind_java = n; break;
            case 'l': ind_keep_case_label = n; break;
        }
    }
    cur_curpos = curwin->w_cursor;
    linecopy = vim_strsave(ml_get(cur_curpos.lnum));
    if (linecopy == ((void *)0))
        return 0;
    if ((State & 0x10) && linecopy[curwin->w_cursor.col] == ')')
        linecopy[curwin->w_cursor.col] = '\000';
    theline = skipwhite(linecopy);
    curwin->w_cursor.col = 0;
    if (*theline == '#' && (*linecopy == '#' || in_cinkeys('#', ' ', 1)))
    {
        amount = 0;
    }
    else if (cin_islabel(ind_maxcomment))
    {
        amount = 0;
    }
    else if (cin_islinecomment(theline)
            && (trypos = find_line_comment()) != ((void *)0))
    {
        getvcol(curwin, trypos, &col, ((void *)0), ((void *)0));
        amount = col;
    }
    else if (!cin_iscomment(theline)
            && (trypos = find_start_comment(ind_maxcomment)) != ((void *)0))
    {
        int lead_start_len = 2;
        int lead_middle_len = 1;
        char_u lead_start[50];
        char_u lead_middle[50];
        char_u lead_end[50];
        char_u *p;
        int start_align = 0;
        int start_off = 0;
        int done = 0;
        getvcol(curwin, trypos, &col, ((void *)0), ((void *)0));
        amount = col;
        p = curbuf->b_p_com;
        while (*p != '\000')
        {
            int align = 0;
            int off = 0;
            int what = 0;
            while (*p != '\000' && *p != ':')
            {
                if (*p == 's' || *p == 'e' || *p == 'm')
                    what = *p++;
                else if (*p == 'l' || *p == 'r')
                    align = *p++;
                else if ((__ctype_b[(int) ((*p))] & (unsigned short int) _ISdigit) || *p == '-')
                    off = getdigits(&p);
                else
                    ++p;
            }
            if (*p == ':')
                ++p;
            (void)copy_option_part(&p, lead_end, 50, ",");
            if (what == 's')
            {
                strcpy((char *)(lead_start), (char *)(lead_end));
                lead_start_len = (int)strlen((char *)(lead_start));
                start_off = off;
                start_align = align;
            }
            else if (what == 'm')
            {
                strcpy((char *)(lead_middle), (char *)(lead_end));
                lead_middle_len = (int)strlen((char *)(lead_middle));
            }
            else if (what == 'e')
            {
                if (strncmp((char *)(theline), (char *)(lead_middle), (size_t)(lead_middle_len)) == 0
                        && strncmp((char *)(theline), (char *)(lead_end), (size_t)(strlen((char *)(lead_end)))) != 0)
                {
                    done = 1;
                    if (curwin->w_cursor.lnum > 1)
                    {
                        look = skipwhite(ml_get(curwin->w_cursor.lnum - 1));
                        if (strncmp((char *)(look), (char *)(lead_start), (size_t)(lead_start_len)) == 0)
                            amount = get_indent_lnum(curwin->w_cursor.lnum - 1);
                        else if (strncmp((char *)(look), (char *)(lead_middle), (size_t)(lead_middle_len)) == 0)
                        {
                            amount = get_indent_lnum(curwin->w_cursor.lnum - 1);
                            break;
                        }
                        else if (strncmp((char *)(ml_get(trypos->lnum) + trypos->col), (char *)(lead_start), (size_t)(lead_start_len)) != 0)
                            continue;
                    }
                    if (start_off != 0)
                        amount += start_off;
                    else if (start_align == 'r')
                        amount += lead_start_len - lead_middle_len;
                    break;
                }
                if (strncmp((char *)(theline), (char *)(lead_middle), (size_t)(lead_middle_len)) != 0
                        && strncmp((char *)(theline), (char *)(lead_end), (size_t)(strlen((char *)(lead_end)))) == 0)
                {
                    amount = get_indent_lnum(curwin->w_cursor.lnum - 1);
                    if (off != 0)
                        amount += off;
                    else if (align == 'r')
                        amount += lead_start_len - lead_middle_len;
                    done = 1;
                    break;
                }
            }
        }
        if (done)
            ;
        else if (theline[0] == '*')
            amount += 1;
        else
        {
            amount = -1;
            for (lnum = cur_curpos.lnum - 1; lnum > trypos->lnum; --lnum)
            {
                if (linewhite(lnum))
                    continue;
                amount = get_indent_lnum(lnum);
                break;
            }
            if (amount == -1)
            {
                if (!ind_in_comment2)
                {
                    start = ml_get(trypos->lnum);
                    look = start + trypos->col + 2;
                    if (*look != '\000')
                        trypos->col = (colnr_T)(skipwhite(look) - start);
                }
                getvcol(curwin, trypos, &col, ((void *)0), ((void *)0));
                amount = col;
                if (ind_in_comment2 || *look == '\000')
                    amount += ind_in_comment;
            }
        }
    }
    else if (((trypos = find_match_paren(ind_maxparen, ind_maxcomment)) != ((void *)0)
                && ind_java == 0)
            || (tryposBrace = find_start_brace(ind_maxcomment)) != ((void *)0)
            || trypos != ((void *)0))
    {
      if (trypos != ((void *)0) && tryposBrace != ((void *)0))
      {
          if (trypos->lnum != tryposBrace->lnum
                  ? trypos->lnum < tryposBrace->lnum
                  : trypos->col < tryposBrace->col)
              trypos = ((void *)0);
          else
              tryposBrace = ((void *)0);
      }
      if (trypos != ((void *)0))
      {
        amount = -1;
        our_paren_pos = *trypos;
        if (theline[0] != ')')
        {
            for (lnum = cur_curpos.lnum - 1; lnum > our_paren_pos.lnum; --lnum)
            {
                l = skipwhite(ml_get(lnum));
                if (cin_nocode(l))
                    continue;
                if (cin_ispreproc(l))
                    continue;
                curwin->w_cursor.lnum = lnum;
                if ((trypos = find_start_comment(ind_maxcomment)) != ((void *)0))
                {
                    lnum = trypos->lnum + 1;
                    continue;
                }
                if ((trypos = find_match_paren(ind_maxparen,
                                                   ind_maxcomment)) != ((void *)0) &&
                                         trypos->lnum == our_paren_pos.lnum &&
                                             trypos->col == our_paren_pos.col)
                {
                    amount = get_indent_lnum(lnum);
                    break;
                }
            }
        }
        if (amount == -1)
        {
            amount = skip_label(our_paren_pos.lnum, &look, ind_maxcomment);
            cur_amount = (0x7fffffffL);
            if (theline[0] == ')' || ind_unclosed == 0
                       || (!ind_unclosed_noignore && *skipwhite(look) == '('))
            {
                if (theline[0] != ')')
                {
                    if (ind_unclosed_whiteok)
                        our_paren_pos.col++;
                    else
                    {
                        col = our_paren_pos.col + 1;
                        l = ml_get(our_paren_pos.lnum);
                        while (((l[col]) == ' ' || (l[col]) == '\t'))
                            col++;
                        if (l[col] != '\000')
                            our_paren_pos.col = col;
                        else
                            our_paren_pos.col++;
                    }
                }
                getvcol(curwin, &our_paren_pos, &col, ((void *)0), ((void *)0));
                cur_amount = col;
            }
            if (theline[0] == ')' && ind_matching_paren)
            {
            }
            else if (ind_unclosed == 0 || (!ind_unclosed_noignore
                                                  && *skipwhite(look) == '('))
                amount = cur_amount;
            else
            {
                col = our_paren_pos.col;
                while (our_paren_pos.col > 0)
                {
                    --our_paren_pos.col;
                    switch (*ml_get_pos(&our_paren_pos))
                    {
                        case '(': amount += ind_unclosed2;
                                  col = our_paren_pos.col;
                                  break;
                        case ')': amount -= ind_unclosed2;
                                  col = (0x7fffffffL);
                                  break;
                    }
                }
                if (col == (0x7fffffffL))
                    amount += ind_unclosed;
                else
                {
                    curwin->w_cursor.lnum = our_paren_pos.lnum;
                    curwin->w_cursor.col = col;
                    if ((trypos = find_match_paren(ind_maxparen,
                                                     ind_maxcomment)) != ((void *)0))
                        amount += ind_unclosed2;
                    else
                        amount += ind_unclosed;
                }
                if (cur_amount < amount)
                    amount = cur_amount;
            }
        }
        if (cin_iscomment(theline))
            amount += ind_comment;
      }
      else
      {
        trypos = tryposBrace;
        ourscope = trypos->lnum;
        start = ml_get(ourscope);
        look = skipwhite(start);
        if (*look == '{')
        {
            getvcol(curwin, trypos, &col, ((void *)0), ((void *)0));
            amount = col;
            if (*start == '{')
                start_brace = 1;
            else
                start_brace = 2;
        }
        else
        {
            curwin->w_cursor.lnum = ourscope;
            lnum = ourscope;
            if (find_last_paren(start) &&
                    (trypos = find_match_paren(ind_maxparen,
                                                     ind_maxcomment)) != ((void *)0))
                lnum = trypos->lnum;
            if (ind_keep_case_label && cin_iscase(skipwhite(ml_get_curline())))
                amount = get_indent();
            else
                amount = skip_label(lnum, &l, ind_maxcomment);
            start_brace = 3;
        }
        if (theline[0] == '}')
        {
            amount += ind_close_extra;
        }
        else
        {
            lookfor = 0;
            if (cin_iselse(theline))
                lookfor = 1;
            else if (cin_iswhileofdo(theline, cur_curpos.lnum, ind_maxparen))
                lookfor = 2;
            if (lookfor)
            {
                curwin->w_cursor.lnum = cur_curpos.lnum;
                if (find_match(lookfor, ourscope, ind_maxparen,
                                                        ind_maxcomment) == 1)
                {
                    amount = get_indent();
                    goto theend;
                }
            }
            if (start_brace == 1)
            {
                amount = ind_open_left_imag;
            }
            else
            {
                if (start_brace == 3)
                    amount += ind_open_imag;
                else
                {
                    amount -= ind_open_extra;
                    if (amount < 0)
                        amount = 0;
                }
            }
            if (cin_iscase(theline))
            {
                lookfor = 3;
                amount += ind_case;
            }
            else if (cin_isscopedecl(theline))
            {
                lookfor = 7;
                amount += ind_scopedecl;
            }
            else
            {
                lookfor = 4;
                amount += ind_level;
            }
            scope_amount = amount;
            whilelevel = 0;
            curwin->w_cursor = cur_curpos;
            for (;;)
            {
                curwin->w_cursor.lnum--;
                curwin->w_cursor.col = 0;
                if (curwin->w_cursor.lnum <= ourscope)
                {
                    if (lookfor == 6)
                        amount += ind_continuation;
                    else if (lookfor != 5)
                    {
                        amount = scope_amount;
                        if (theline[0] == '{')
                            amount += ind_open_extra;
                    }
                    break;
                }
                if ((trypos = find_start_comment(ind_maxcomment)) != ((void *)0))
                {
                    curwin->w_cursor.lnum = trypos->lnum + 1;
                    continue;
                }
                l = ml_get_curline();
                iscase = cin_iscase(l);
                if (iscase || cin_isscopedecl(l))
                {
                    if (whilelevel > 0)
                        continue;
                    if (lookfor == 6)
                    {
                        amount += ind_continuation;
                        break;
                    }
                    if ( (iscase && lookfor == 3)
                            || (!iscase && lookfor == 7))
                    {
                        if ((trypos = find_start_brace(ind_maxcomment)) ==
                                             ((void *)0) || trypos->lnum == ourscope)
                        {
                            amount = get_indent();
                            break;
                        }
                        continue;
                    }
                    n = get_indent_nolabel(curwin->w_cursor.lnum);
                    if (lookfor == 5)
                    {
                        if (n)
                            amount = n;
                        break;
                    }
                    if (n)
                    {
                        amount = n;
                        l = after_label(ml_get_curline());
                        if (l != ((void *)0) && cin_is_cinword(l))
                            amount += ind_level + ind_no_brace;
                        break;
                    }
                    scope_amount = get_indent() + (iscase
                                        ? ind_case_code : ind_scopedecl_code);
                    lookfor = 4;
                    continue;
                }
                if (lookfor == 3 || lookfor == 7)
                    continue;
                if (cin_islabel(ind_maxcomment))
                {
                    l = after_label(ml_get_curline());
                    if (l == ((void *)0) || cin_nocode(l))
                        continue;
                }
                l = ml_get_curline();
                if (cin_ispreproc(l) || cin_nocode(l))
                    continue;
                if (!cin_isterminated(l, 0))
                {
                    (void)find_last_paren(l);
                    if ((trypos = find_match_paren(ind_maxparen,
                                                     ind_maxcomment)) != ((void *)0))
                    {
                        curwin->w_cursor.lnum = trypos->lnum;
                        l = ml_get_curline();
                        if (cin_iscase(l) || cin_isscopedecl(l))
                        {
                            ++curwin->w_cursor.lnum;
                            continue;
                        }
                    }
                    cur_amount = skip_label(curwin->w_cursor.lnum,
                                                          &l, ind_maxcomment);
                    if (lookfor != 5 && theline[0] == '{')
                    {
                        amount = cur_amount;
                        if (*skipwhite(l) != '{')
                            amount += ind_open_extra;
                        break;
                    }
                    if (cin_is_cinword(l) || cin_iselse(skipwhite(l)))
                    {
                        if (lookfor == 6)
                        {
                            amount += ind_continuation;
                            break;
                        }
                        amount = cur_amount;
                        if (theline[0] == '{')
                            amount += ind_open_extra;
                        if (lookfor != 5)
                        {
                            amount += ind_level + ind_no_brace;
                            break;
                        }
                        l = skipwhite(ml_get_curline());
                        if (cin_isdo(l))
                        {
                            if (whilelevel == 0)
                                break;
                            --whilelevel;
                        }
                        if (cin_iselse(l)
                                && whilelevel == 0
                                && ((trypos = find_start_brace(ind_maxcomment))
                                                                    == ((void *)0)
                                    || find_match(1, trypos->lnum,
                                        ind_maxparen, ind_maxcomment) == 0))
                            break;
                    }
                    else
                    {
                        if (lookfor == 6)
                            break;
                        amount = cur_amount;
                        if (lookfor != 5)
                            lookfor = 6;
                    }
                }
                else if (cin_iswhileofdo(l,
                                         curwin->w_cursor.lnum, ind_maxparen))
                {
                    if (lookfor == 6)
                    {
                        amount += ind_continuation;
                        break;
                    }
                    if (whilelevel == 0)
                    {
                        lookfor = 5;
                        amount = get_indent();
                        if (theline[0] == '{')
                            amount += ind_open_extra;
                    }
                    ++whilelevel;
                }
                else
                {
                    if (whilelevel > 0)
                    {
                        l = cin_skipcomment(ml_get_curline());
                        if (cin_isdo(l))
                        {
                            amount = get_indent();
                            --whilelevel;
                            continue;
                        }
                    }
                    if (lookfor == 6)
                    {
                        amount += ind_continuation;
                        break;
                    }
                    if (lookfor == 5)
                    {
                        if (whilelevel == 0)
                            break;
                    }
                    else
                    {
term_again:
                        l = ml_get_curline();
                        if (find_last_paren(l) &&
                                (trypos = find_match_paren(ind_maxparen,
                                                     ind_maxcomment)) != ((void *)0))
                        {
                            curwin->w_cursor.lnum = trypos->lnum;
                            l = ml_get_curline();
                            if (cin_iscase(l) || cin_isscopedecl(l))
                            {
                                ++curwin->w_cursor.lnum;
                                continue;
                            }
                        }
                        iscase = (ind_keep_case_label && cin_iscase(l));
                        amount = skip_label(curwin->w_cursor.lnum,
                                                          &l, ind_maxcomment);
                        if (theline[0] == '{')
                            amount += ind_open_extra;
                        if (*skipwhite(l) == '{')
                            amount -= ind_open_extra;
                        lookfor = iscase ? 4 : 5;
                        curwin->w_cursor.col = 0;
                        if (*cin_skipcomment(l) == '}'
                                && (trypos = find_start_brace(ind_maxcomment))
                                                            != ((void *)0))
                        {
                            curwin->w_cursor.lnum = trypos->lnum;
                            l = cin_skipcomment(ml_get_curline());
                            if (*l == '}' || !cin_iselse(l))
                                goto term_again;
                            ++curwin->w_cursor.lnum;
                        }
                    }
                }
            }
        }
      }
      if (cin_iscomment(theline))
          amount += ind_comment;
    }
    else
    {
        if (theline[0] == '{')
        {
            amount = ind_first_open;
        }
        else if (cur_curpos.lnum < curbuf->b_ml.ml_line_count
                && !cin_nocode(theline)
                && cin_isfuncdecl(ml_get(cur_curpos.lnum + 1))
                && !cin_isterminated(theline, 0))
        {
            amount = ind_func_type;
        }
        else
        {
            amount = 0;
            curwin->w_cursor = cur_curpos;
            while (curwin->w_cursor.lnum > 1)
            {
                curwin->w_cursor.lnum--;
                curwin->w_cursor.col = 0;
                l = ml_get_curline();
                if ((trypos = find_start_comment(ind_maxcomment)) != ((void *)0))
                {
                    curwin->w_cursor.lnum = trypos->lnum + 1;
                    continue;
                }
                if (cin_isfuncdecl(theline))
                    break;
                if (*skipwhite(l) == '}')
                    break;
                if (cin_ends_in(l, (char_u *)"};"))
                    break;
                if (cin_ispreproc(l))
                    continue;
                if (cin_nocode(l))
                    continue;
                if (cin_isfuncdecl(l))
                {
                    amount = ind_param;
                    break;
                }
                if (cin_ends_in(l, (char_u*)";"))
                {
                    l = ml_get(curwin->w_cursor.lnum - 1);
                    if (cin_ends_in(l, (char_u *)",")
                            || (*l != '\000' && l[strlen((char *)(l)) - 1] == '\\'))
                        break;
                    l = ml_get_curline();
                }
                if (cin_ends_in(l, (char_u *)",")
                        || (*l != '\000' && l[strlen((char *)(l)) - 1] == '\\'))
                {
                    amount = get_indent();
                    if (amount == 0)
                        amount = ind_param;
                    break;
                }
                find_last_paren(l);
                if ((trypos = find_match_paren(ind_maxparen,
                                                     ind_maxcomment)) != ((void *)0))
                    curwin->w_cursor.lnum = trypos->lnum;
                amount = get_indent();
                break;
            }
            if (cin_iscomment(theline))
                amount += ind_comment;
        }
    }
theend:
    curwin->w_cursor = cur_curpos;
    vim_free(linecopy);
    if (amount < 0)
        return 0;
    return amount;
}
    static int find_match(lookfor, ourscope, ind_maxparen, ind_maxcomment)
    int lookfor;
    linenr_T ourscope;
    int ind_maxparen;
    int ind_maxcomment;
{
    char_u *look;
    pos_T *theirscope;
    char_u *mightbeif;
    int elselevel;
    int whilelevel;
    if (lookfor == 1)
    {
        elselevel = 1;
        whilelevel = 0;
    }
    else
    {
        elselevel = 0;
        whilelevel = 1;
    }
    curwin->w_cursor.col = 0;
    while (curwin->w_cursor.lnum > ourscope + 1)
    {
        curwin->w_cursor.lnum--;
        curwin->w_cursor.col = 0;
        look = cin_skipcomment(ml_get_curline());
        if (cin_iselse(look)
                || cin_isif(look)
                || cin_isdo(look)
                || cin_iswhileofdo(look, curwin->w_cursor.lnum, ind_maxparen))
        {
            theirscope = find_start_brace(ind_maxcomment);
            if (theirscope == ((void *)0))
                break;
            if (theirscope->lnum < ourscope)
                break;
            if (theirscope->lnum > ourscope)
                continue;
            look = cin_skipcomment(ml_get_curline());
            if (cin_iselse(look))
            {
                mightbeif = cin_skipcomment(look + 4);
                if (!cin_isif(mightbeif))
                    ++elselevel;
                continue;
            }
            if (cin_iswhileofdo(look, curwin->w_cursor.lnum, ind_maxparen))
            {
                ++whilelevel;
                continue;
            }
            look = cin_skipcomment(ml_get_curline());
            if (cin_isif(look))
            {
                elselevel--;
                if (elselevel == 0 && lookfor == 1)
                    whilelevel = 0;
            }
            if (cin_isdo(look))
                whilelevel--;
            if (elselevel <= 0 && whilelevel <= 0)
            {
                return 1;
            }
        }
    }
    return 0;
}
    int get_expr_indent()
{
    int indent;
    pos_T pos;
    pos = curwin->w_cursor;
    set_vim_var_nr(9, curwin->w_cursor.lnum);
    ++sandbox;
    indent = eval_to_number(curbuf->b_p_inde);
    --sandbox;
    curwin->w_cursor = pos;
    check_cursor();
    if (indent < 0)
        indent = get_indent();
    return indent;
}
static int lisp_match (char_u *p);
    static int lisp_match(p)
    char_u *p;
{
    char_u buf[512];
    int len;
    char_u *word = p_lispwords;
    while (*word != '\000')
    {
        (void)copy_option_part(&word, buf, 512, ",");
        len = (int)strlen((char *)(buf));
        if (strncmp((char *)(buf), (char *)(p), (size_t)(len)) == 0 && p[len] == ' ')
            return 1;
    }
    return 0;
}
    int get_lisp_indent()
{
    pos_T *pos, realpos;
    int amount;
    char_u *that;
    colnr_T col;
    colnr_T firsttry;
    int parencount, quotecount;
    int vi_lisp;
    vi_lisp = (vim_strchr(p_cpo, 'p') != ((void *)0));
    realpos = curwin->w_cursor;
    curwin->w_cursor.col = 0;
    if ((pos = findmatch(((void *)0), '(')) != ((void *)0))
    {
        amount = -1;
        parencount = 0;
        while (--curwin->w_cursor.lnum >= pos->lnum)
        {
            if (linewhite(curwin->w_cursor.lnum))
                continue;
            for (that = ml_get_curline(); *that != '\000'; ++that)
            {
                if (*that == ';')
                {
                    while (*(that + 1) != '\000')
                        ++that;
                    continue;
                }
                if (*that == '\\')
                {
                    if (*(that + 1) != '\000')
                        ++that;
                    continue;
                }
                if (*that == '"' && *(that + 1) != '\000')
                {
                    that++;
                    while (*that && (*that != '"' || *(that - 1) == '\\'))
                        ++that;
                }
                if (*that == '(')
                    ++parencount;
                else if (*that == ')')
                    --parencount;
            }
            if (parencount == 0)
            {
                amount = get_indent();
                break;
            }
        }
        if (amount == -1)
        {
            curwin->w_cursor.lnum = pos->lnum;
            curwin->w_cursor.col = pos->col;
            col = pos->col;
            that = ml_get_curline();
            if (vi_lisp && get_indent() == 0)
                amount = 2;
            else
            {
                amount = 0;
                while (*that && col)
                {
                    amount += lbr_chartabsize_adv(&that, (colnr_T)amount);
                    col--;
                }
                if (!vi_lisp && *that == '(' && lisp_match(that + 1))
                    amount += 2;
                else
                {
                    that++;
                    amount++;
                    firsttry = amount;
                    while (((*that) == ' ' || (*that) == '\t'))
                    {
                        amount += lbr_chartabsize(that, (colnr_T)amount);
                        ++that;
                    }
                    if (*that && *that != ';')
                    {
                        if (!vi_lisp && *that != '(')
                            firsttry++;
                        parencount = 0;
                        quotecount = 0;
                        if (vi_lisp
                                || (*that != '"'
                                    && *that != '\''
                                    && *that != '#'
                                    && (*that < '0' || *that > '9')))
                        {
                            while (*that
                                    && (!((*that) == ' ' || (*that) == '\t')
                                        || quotecount
                                        || parencount)
                                    && (!(*that == '('
                                            && !quotecount
                                            && !parencount
                                            && vi_lisp)))
                            {
                                if (*that == '"')
                                    quotecount = !quotecount;
                                if (*that == '(' && !quotecount)
                                    ++parencount;
                                if (*that == ')' && !quotecount)
                                    --parencount;
                                if (*that == '\\' && *(that+1) != '\000')
                                    amount += lbr_chartabsize_adv(&that,
                                                             (colnr_T)amount);
                                amount += lbr_chartabsize_adv(&that,
                                                             (colnr_T)amount);
                            }
                        }
                        while (((*that) == ' ' || (*that) == '\t'))
                        {
                            amount += lbr_chartabsize(that, (colnr_T)amount);
                            that++;
                        }
                        if (!*that || *that == ';')
                            amount = firsttry;
                    }
                }
            }
        }
    }
    else
        amount = 0;
    curwin->w_cursor = realpos;
    return amount;
}
    void prepare_to_exit()
{
    if (gui.in_use)
    {
        gui.dying = 1;
        out_trash();
    }
    else
    {
        windgoto((int)Rows - 1, 0);
        settmode(0);
            stoptermcap();
        out_flush();
    }
}
    void preserve_exit()
{
    buf_T *buf;
    prepare_to_exit();
    out_str(IObuff);
    screen_start();
    out_flush();
    ml_close_notmod();
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
    {
        if (buf->b_ml.ml_mfp != ((void *)0) && buf->b_ml.ml_mfp->mf_fname != ((void *)0))
        {
            out_str((char_u *)(((char *)("Vim: preserving files...\n"))));
            screen_start();
            out_flush();
            ml_sync_all(0, 0);
            break;
        }
    }
    ml_close_all(0);
    out_str((char_u *)(((char *)("Vim: Finished.\n"))));
    getout(1);
}
    int vim_fexists(fname)
    char_u *fname;
{
    struct stat st;
    if (stat(((char *)fname), (&st)))
        return 0;
    return 1;
}
static int breakcheck_count = 0;
    void line_breakcheck()
{
    if (++breakcheck_count >= 200)
    {
        breakcheck_count = 0;
        ui_breakcheck();
    }
}
    void fast_breakcheck()
{
    if (++breakcheck_count >= 200 * 10)
    {
        breakcheck_count = 0;
        ui_breakcheck();
    }
}
    int expand_wildcards(num_pat, pat, num_file, file, flags)
    int num_pat;
    char_u **pat;
    int *num_file;
    char_u ***file;
    int flags;
{
    int retval;
    int i, j;
    char_u *p;
    int non_suf_match;
    retval = gen_expand_wildcards(num_pat, pat, num_file, file, flags);
    if (flags & 16)
        return retval;
    if (*p_wig)
    {
        char_u *ffname;
        for (i = 0; i < *num_file; ++i)
        {
            ffname = FullName_save((*file)[i], 0);
            if (ffname == ((void *)0))
                break;
            if (match_file_list(p_wig, (*file)[i], ffname))
            {
                vim_free((*file)[i]);
                for (j = i; j + 1 < *num_file; ++j)
                    (*file)[j] = (*file)[j + 1];
                --*num_file;
                --i;
            }
            vim_free(ffname);
        }
    }
    if (*num_file > 1)
    {
        non_suf_match = 0;
        for (i = 0; i < *num_file; ++i)
        {
            if (!match_suffix((*file)[i]))
            {
                p = (*file)[i];
                for (j = i; j > non_suf_match; --j)
                    (*file)[j] = (*file)[j - 1];
                (*file)[non_suf_match++] = p;
            }
        }
    }
    return retval;
}
    int match_suffix(fname)
    char_u *fname;
{
    int fnamelen, setsuflen;
    char_u *setsuf;
    char_u suf_buf[30];
    fnamelen = (int)strlen((char *)(fname));
    setsuflen = 0;
    for (setsuf = p_su; *setsuf; )
    {
        setsuflen = copy_option_part(&setsuf, suf_buf, 30, ".,");
        if (fnamelen >= setsuflen
                && strncmp((char *)(suf_buf), (char *)(fname + fnamelen - setsuflen), (size_t)((size_t)setsuflen)) == 0)
            break;
        setsuflen = 0;
    }
    return (setsuflen != 0);
}
static int vim_backtick (char_u *p);
static int expand_backtick (garray_T *gap, char_u *pat, int flags);
    int gen_expand_wildcards(num_pat, pat, num_file, file, flags)
    int num_pat;
    char_u **pat;
    int *num_file;
    char_u ***file;
    int flags;
{
    int i;
    garray_T ga;
    char_u *p;
    static int recursive = 0;
    int add_pat;
    if (recursive)
        return mch_expand_wildcards(num_pat, pat, num_file, file, flags);
    for (i = 0; i < num_pat; i++)
    {
        if ((char_u *)strpbrk((char *)(pat[i]), (char *)((char_u *)"`'{")) != ((void *)0)
                && !(vim_backtick(pat[i]) && pat[i][1] == '=')
           )
            return mch_expand_wildcards(num_pat, pat, num_file, file, flags);
    }
    recursive = 1;
    ga_init2(&ga, (int)sizeof(char_u *), 30);
    for (i = 0; i < num_pat; ++i)
    {
        add_pat = -1;
        p = pat[i];
        if (vim_backtick(p))
            add_pat = expand_backtick(&ga, p, flags);
        else
        {
            if ((char_u *)strpbrk((char *)(p), (char *)((char_u *)"$~")) != ((void *)0))
            {
                p = expand_env_save(p);
                if (p == ((void *)0))
                    p = pat[i];
                else if ((char_u *)strpbrk((char *)(p), (char *)((char_u *)"$~")) != ((void *)0))
                {
                    vim_free(p);
                    ga_clear(&ga);
                    i = mch_expand_wildcards(num_pat, pat, num_file, file,
                                                                       flags);
                    recursive = 0;
                    return i;
                }
            }
            if (mch_has_exp_wildcard(p))
                add_pat = mch_expandpath(&ga, p, flags);
        }
        if (add_pat == -1 || (add_pat == 0 && (flags & 4)))
        {
            char_u *t = backslash_halve_save(p);
            if (flags & 4)
                addfile(&ga, t, flags | 1 | 2);
            else if (mch_getperm(t) >= 0)
                addfile(&ga, t, flags);
            vim_free(t);
        }
        if (p != pat[i])
            vim_free(p);
    }
    *num_file = ga.ga_len;
    *file = (ga.ga_data != ((void *)0)) ? (char_u **)ga.ga_data : (char_u **)"";
    recursive = 0;
    return (ga.ga_data != ((void *)0)) ? 1 : 0;
}
    static int vim_backtick(p)
    char_u *p;
{
    return (*p == '`' && *(p + 1) != '\000' && *(p + strlen((char *)(p)) - 1) == '`');
}
    static int expand_backtick(gap, pat, flags)
    garray_T *gap;
    char_u *pat;
    int flags;
{
    char_u *p;
    char_u *cmd;
    char_u *buffer;
    int cnt = 0;
    int i;
    cmd = vim_strnsave(pat + 1, (int)strlen((char *)(pat)) - 2);
    if (cmd == ((void *)0))
        return 0;
    if (*cmd == '=')
        buffer = eval_to_string(cmd + 1, &p);
    else
        buffer = get_cmd_output(cmd, (flags & 32) ? 16 : 0);
    vim_free(cmd);
    if (buffer == ((void *)0))
        return 0;
    cmd = buffer;
    while (*cmd != '\000')
    {
        cmd = skipwhite(cmd);
        p = cmd;
        while (*p != '\000' && *p != '\r' && *p != '\n')
            ++p;
        if (p > cmd)
        {
            i = *p;
            *p = '\000';
            addfile(gap, cmd, flags);
            *p = i;
            ++cnt;
        }
        cmd = p;
        while (*cmd != '\000' && (*cmd == '\r' || *cmd == '\n'))
            ++cmd;
    }
    vim_free(buffer);
    return cnt;
}
    void addfile(gap, f, flags)
    garray_T *gap;
    char_u *f;
    int flags;
{
    char_u *p;
    int isdir;
    if (!(flags & 4) && mch_getperm(f) < 0)
        return;
    isdir = mch_isdir(f);
    if ((isdir && !(flags & 1)) || (!isdir && !(flags & 2)))
        return;
    if (ga_grow(gap, 1) == 0)
        return;
    p = alloc((unsigned)(strlen((char *)(f)) + 1 + isdir));
    if (p == ((void *)0))
        return;
    strcpy((char *)(p), (char *)(f));
    if (isdir && (flags & 8))
        add_pathsep(p);
    ((char_u **)gap->ga_data)[gap->ga_len++] = p;
    --gap->ga_room;
}
    char_u * get_cmd_output(cmd, flags)
    char_u *cmd;
    int flags;
{
    char_u *tempname;
    char_u *command;
    char_u *buffer = ((void *)0);
    int len;
    int i = 0;
    FILE *fd;
    if (check_restricted() || check_secure())
        return ((void *)0);
    if ((tempname = vim_tempname('o')) == ((void *)0))
    {
        emsg((char_u *)(((char *)(e_notmp))));
        return ((void *)0);
    }
    command = make_filter_cmd(cmd, ((void *)0), tempname);
    if (command == ((void *)0))
        goto done;
    ++no_check_timestamps;
    call_shell(command, 8 | 2 | flags);
    --no_check_timestamps;
    vim_free(command);
    fd = fopen(((char *)tempname), ("r"));
    if (fd == ((void *)0))
    {
        emsg2((char_u *)(((char *)(e_notopen))), (char_u *)(tempname));
        goto done;
    }
    fseek(fd, 0L, 2);
    len = ftell(fd);
    fseek(fd, 0L, 0);
    buffer = alloc(len + 1);
    if (buffer != ((void *)0))
        i = (int)fread((char *)buffer, (size_t)1, (size_t)len, fd);
    fclose(fd);
    unlink((char *)(tempname));
    if (buffer == ((void *)0))
        goto done;
    if (i != len)
    {
        emsg2((char_u *)(((char *)(e_notread))), (char_u *)(tempname));
        vim_free(buffer);
        buffer = ((void *)0);
    }
    else
        buffer[len] = '\0';
done:
    vim_free(tempname);
    return buffer;
}
    void FreeWild(count, files)
    int count;
    char_u **files;
{
    if (files == ((void *)0) || count <= 0)
        return;
    while (count--)
        vim_free(files[count]);
    vim_free(files);
}
    int goto_im()
{
    return (p_im && stuff_empty() && typebuf_typed());
}
