#!/bin/tcsh
foreach i ( *.c )
  echo gcc -c $i
  if (! -e $i:r.o ) then
    gcc -g -O2 -c $i
  endif
end
if (! -e vim.dynamic) then
  echo gcc -o vim.dynamic *.o -L/usr/X11R6/lib  -L/usr/local/lib -L/usr/lib -L/usr/X11R6/lib -lgtk -lgdk -rdynamic -lgmodule -lglib -ldl -lXi -lXext -lm -lXt -lncurses -ldl
  gcc -o vim.dynamic *.o -L/usr/X11R6/lib  -L/usr/local/lib -L/usr/lib -L/usr/X11R6/lib -lgtk -lgdk -rdynamic -lgmodule -lglib -ldl -lXi -lXext -lm -lXt -lncurses -ldl
endif
if (! -e vim.static) then
  echo gcc -Wl,-Map,vim.map -static -o vim *.o /usr/lib/libgtk.a /usr/lib/libgdk.a /usr/lib/libgmodule.a /usr/lib/libglib.a /usr/X11R6/lib/libXext.a /usr/X11R6/lib/libXt.a /usr/X11R6/lib/libSM.a /usr/X11R6/lib/libICE.a /usr/X11R6/lib/libXi.a /usr/X11R6/lib/libX11.a /usr/lib/libncurses.a /usr/lib/libdl.a /usr/lib/libm.a 
  gcc -Wl,-Map,vim.map -static -o vim.static *.o /usr/lib/libgtk.a /usr/lib/libgdk.a /usr/lib/libgmodule.a /usr/lib/libglib.a /usr/X11R6/lib/libXext.a /usr/X11R6/lib/libXt.a /usr/X11R6/lib/libSM.a /usr/X11R6/lib/libICE.a /usr/X11R6/lib/libXi.a /usr/X11R6/lib/libX11.a /usr/lib/libncurses.a /usr/lib/libdl.a /usr/lib/libm.a 
endif

